SystemOrganization addCategory: #'Polymorph-Widgets'!
SystemOrganization addCategory: #'Polymorph-Widgets-Themes'!
SystemOrganization addCategory: #'Polymorph-Widgets-Windows'!

Trait named: #TEasilyThemed
	uses: {}
	category: 'Polymorph-Widgets'!

!TEasilyThemed commentStamp: 'gvc 5/18/2007 11:55' prior: 0!
Trait providing useful theme-related methods.!

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/18/2007 14:55'!
abort: aStringOrText
	"Open an error dialog."

	^self abort: aStringOrText title: 'Error' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/18/2007 14:55'!
abort: aStringOrText title: aString
	"Open an error dialog."

	^self theme
		abortIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/30/2006 09:37'!
alert: aStringOrText
	"Open an alert dialog."

	^self alert: aStringOrText title: 'Alert' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/12/2009 18:15'!
alert: aStringOrText title: aString
	"Open an alert dialog."

	^self
		alert: aStringOrText
		title: aString
		configure: [:d | ]! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/12/2009 18:15'!
alert: aStringOrText title: aString configure: aBlock
	"Open an alert dialog.
	Configure the dialog with the 1 argument block
	before opening modally."

	^self theme
		alertIn: self
		text: aStringOrText
		title: aString
		configure: aBlock! !

!TEasilyThemed methodsFor: 'services' stamp: 'BenjaminVanRyseghem 5/13/2011 14:21'!
centeredAlert: aStringOrText title: aString configure: aBlock
	"Open an alert dialog.
	Configure the dialog with the 1 argument block
	before opening modally."

	^self theme
		centeredAlertIn: self
		text: aStringOrText
		title: aString
		configure: aBlock! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/3/2007 14:19'!
chooseColor
	"Answer the result of a color selector dialog ."

	^self chooseColor: Color black! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/3/2007 13:38'!
chooseColor: aColor 
	"Answer the result of a color selector dialog with the given color."

	^self theme
		chooseColorIn: self
		title: 'Colour Selector' translated
		color: aColor! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/22/2006 11:04'!
chooseColor: aColor title: title
	"Answer the result of a color selector dialog with the given title and initial colour."

	^self theme
		chooseColorIn: self
		title: title
		color: aColor! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 4/2/2007 15:34'!
chooseDirectory: title 
	"Answer the result of a file dialog with the given title, answer a directory."

	^self
		chooseDirectory: title
		path: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/15/2007 14:45'!
chooseDirectory: title path: path
	"Answer the result of a file dialog with the given title, answer a directory."

	^self theme
		chooseDirectoryIn: self
		title: title
		path: path! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/12/2007 14:24'!
chooseDropList: aStringOrText list: aList
	"Open a drop list chooser dialog."

	^self
		chooseDropList: aStringOrText
		title: 'Choose' translated
		list: aList! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/12/2007 14:23'!
chooseDropList: aStringOrText title: aString list: aList
	"Open a drop list chooser dialog."

	^self theme
		chooseDropListIn: self
		text: aStringOrText
		title: aString
		list: aList! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 4/4/2007 16:08'!
chooseFileName: title extensions: exts path: path preview: preview
	"Answer the result of a file name chooser dialog with the given title, extensions
	to show, path and preview type."

	^self theme
		chooseFileNameIn: self
		title: title
		extensions: exts
		path: path
		preview: preview! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/3/2007 13:38'!
chooseFont
	"Answer the result of a font selector dialog."

	^self chooseFont: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 5/3/2007 13:38'!
chooseFont: aFont 
	"Answer the result of a font selector dialog with the given initial font."

	^self theme
		chooseFontIn: self
		title: 'Font Selector' translated
		font: aFont! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 11:13'!
deny: aStringOrText
	"Open a denial dialog."

	^self deny: aStringOrText title: 'Access Denied' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 11:13'!
deny: aStringOrText title: aString
	"Open a denial dialog."

	^self theme
		denyIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/31/2006 15:32'!
fileOpen: title
	"Answer the result of a file open dialog with the given title."

	^self
		fileOpen: title
		extensions: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 10:33'!
fileOpen: title extensions: exts
	"Answer the result of a file open dialog with the given title and extensions to show."

	^self
		fileOpen: title
		extensions: exts
		path: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 12/18/2006 11:21'!
fileOpen: title extensions: exts path: path
	"Answer the result of a file open dialog with the given title, extensions to show and path."

	^self 
		fileOpen: title
		extensions: exts
		path: path
		preview: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 13:38'!
fileOpen: title extensions: exts path: path preview: preview
	"Answer the result of a file open dialog with the given title, extensions to show, path and preview type."

	^self theme
		fileOpenIn: self
		title: title
		extensions: exts
		path: path
		preview: preview! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 10:33'!
fileSave: title
	"Answer the result of a file save dialog with the given title."

	^self
		fileSave: title
		extensions: nil
		path: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 10:33'!
fileSave: title extensions: exts
	"Answer the result of a file save dialog with the given title."

	^self
		fileSave: title
		extensions: exts
		path: nil! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 9/27/2006 10:33'!
fileSave: title extensions: exts path: path
	"Answer the result of a file save dialog with the given title, extensions to show and path."

	^self theme
		fileSaveIn: self
		title: title
		extensions: exts
		path: path! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/31/2006 15:32'!
fileSave: title path: path
	"Answer the result of a file save open dialog with the given title."

	^self
		fileSave: title
		extensions: nil
		path: path! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 4/15/2008 22:58'!
longMessage: aStringOrText title: aString
	"Open a (long) message dialog."

	^self theme
		longMessageIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/29/2006 16:51'!
message: aStringOrText
	"Open a message dialog."

	^self message: aStringOrText title: 'Information' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/27/2006 10:24'!
message: aStringOrText title: aString
	"Open a message dialog."

	^self theme
		messageIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 15:13'!
newAlphaImage: aForm help: helpText
	"Answer an alpha image morph."

	^self theme
		newAlphaImageIn: self
		image: aForm
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/26/2006 11:39'!
newAlphaSelector: aModel getAlpha: getSel setAlpha: setSel help: helpText
	"Answer an alpha channel selector with the given selectors."

	^self theme
		newAlphaSelectorIn: self
		for: aModel
		getAlpha: getSel
		setAlpha: setSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/5/2006 14:44'!
newAutoAcceptTextEditorFor: aModel getText: getSel setText: setSel getEnabled: enabledSel
	"Answer a text editor for the given model."

	^self theme
		newAutoAcceptTextEditorIn: self
		for: aModel
		getText: getSel
		setText: setSel
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/3/2009 13:23'!
newAutoAcceptTextEntryFor: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel font: aFont help: helpText
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: aClass
		getEnabled: enabledSel
		font: aFont
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'AlainPlantec 11/26/2010 10:29'!
newAutoAcceptTextEntryFor: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel font: aFont help: helpText entryCompletion: anEntryCompletion
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: aClass
		getEnabled: enabledSel
		font: aFont
		help: helpText
		entryCompletion: anEntryCompletion! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/18/2006 12:51'!
newAutoAcceptTextEntryFor: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: aClass
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'AlainPlantec 11/26/2010 10:30'!
newAutoAcceptTextEntryFor: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText entryCompletion: anEntryCompletion
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: aClass
		getEnabled: enabledSel
		help: helpText
		entryCompletion: anEntryCompletion! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/27/2009 12:03'!
newAutoAcceptTextEntryFor: aModel getText: getSel setText: setSel getEnabled: enabledSel font: aFont help: helpText
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: enabledSel
		font: aFont
		help: helpText
! !

!TEasilyThemed methodsFor: 'controls' stamp: 'AlainPlantec 11/26/2010 10:30'!
newAutoAcceptTextEntryFor: aModel getText: getSel setText: setSel getEnabled: enabledSel font: aFont help: helpText entryCompletion: anEntryCompletion
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: enabledSel
		font: aFont
		help: helpText
		entryCompletion: anEntryCompletion
! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/18/2006 13:00'!
newAutoAcceptTextEntryFor: aModel getText: getSel setText: setSel getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'AlainPlantec 11/26/2010 10:30'!
newAutoAcceptTextEntryFor: aModel getText: getSel setText: setSel getEnabled: enabledSel help: helpText entryCompletion: anEntryCompletion
	"Answer a text entry for the given model."

	^self theme
		newAutoAcceptTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: enabledSel
		help: helpText
		entryCompletion: anEntryCompletion! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/30/2009 14:07'!
newBalloonHelp: aTextStringOrMorph for: aMorph
	"Answer a new balloon help with the given contents for aMorph
	at a given corner."

	^self theme
		newBalloonHelpIn: self
		contents: aTextStringOrMorph
		for: aMorph
		corner: #bottomLeft! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/30/2009 14:07'!
newBalloonHelp: aTextStringOrMorph for: aMorph corner: cornerSymbol
	"Answer a new balloon help with the given contents for aMorph
	at a given corner."

	^self theme
		newBalloonHelpIn: self
		contents: aTextStringOrMorph
		for: aMorph
		corner: cornerSymbol! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/8/2009 13:09'!
newBracketSliderFor: aModel getValue: getSel setValue: setSel min: minValue max: maxValue quantum: quantum getEnabled: enabledSel help: helpText
	"Answer a bracket slider with the given selectors."

	^self theme
		newBracketSliderIn: self
		for: aModel
		getValue: getSel
		setValue: setSel
		min: minValue
		max: maxValue
		quantum: quantum
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/8/2009 13:10'!
newBracketSliderFor: aModel getValue: getSel setValue: setSel min: minValue max: maxValue quantum: quantum help: helpText
	"Answer a bracket slider with the given selectors."

	^self
		newBracketSliderFor: aModel
		getValue: getSel
		setValue: setSel
		min: minValue
		max: maxValue
		quantum: quantum 
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/17/2008 13:24'!
newButtonFor: aModel action: actionSel getEnabled: enabledSel label: stringOrText help: helpText
	"Answer a new button."

	^self
		newButtonFor: aModel
		getState: nil
		action: actionSel
		arguments: nil
		getEnabled: enabledSel 
		label: stringOrText
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/17/2008 13:24'!
newButtonFor: aModel action: actionSel label: stringOrText help: helpText
	"Answer a new button."

	^self
		newButtonFor: aModel
		getState: nil
		action: actionSel
		arguments: nil
		getEnabled: nil 
		label: stringOrText
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/17/2007 15:22'!
newButtonFor: aModel getState: stateSel action: actionSel arguments: args getEnabled: enabledSel getLabel: labelSel help: helpText
	"Answer a new button."

	^self theme
		newButtonIn: self for: aModel
		getState: stateSel
		action: actionSel
		arguments: args
		getEnabled: enabledSel 
		getLabel: labelSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/17/2008 13:24'!
newButtonFor: aModel getState: stateSel action: actionSel arguments: args getEnabled: enabledSel label: stringOrText help: helpText
	"Answer a new button."

	^self theme
		newButtonIn: self for: aModel
		getState: stateSel
		action: actionSel
		arguments: args
		getEnabled: enabledSel 
		label: stringOrText
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/14/2009 15:38'!
newButtonFor: aModel getState: stateSel action: actionSel arguments: args getEnabled: enabledSel labelForm: aForm help: helpText
	"Answer a new button."

	^self theme
		newButtonIn: self for: aModel
		getState: stateSel
		action: actionSel
		arguments: args
		getEnabled: enabledSel 
		label: (AlphaImageMorph new image: aForm)
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 8/10/2010 16:02'!
newButtonLabel: aString
	"Answer a new button text label."

	^self
		newButtonLabelFor: nil
		label: aString
		getEnabled: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 8/10/2010 16:02'!
newButtonLabelFor: aModel label: aString getEnabled: enabledSel
	"Answer a new button text label."

	^self theme
		newButtonLabelIn: self
		for: aModel
		label: aString
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:20'!
newCancelButton
	"Answer a new cancel button."

	^self newCancelButtonFor: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:33'!
newCancelButtonFor: aModel
	"Answer a new cancel button."

	^self theme
		newCancelButtonIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/17/2008 13:24'!
newCheckboxFor: aModel getSelected: getSel setSelected: setSel getEnabled: enabledSel label: stringOrText help: helpText
	"Answer a checkbox with the given label."

	^self theme
		newCheckboxIn: self
		for: aModel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		label: stringOrText
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/17/2008 13:24'!
newCheckboxFor: aModel getSelected: getSel setSelected: setSel label: stringOrText help: helpText
	"Answer a checkbox with the given label."

	^self theme
		newCheckboxIn: self
		for: aModel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		label: stringOrText
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:20'!
newCloseButton
	"Answer a new close button."

	^self newCloseButtonFor: self ! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:20'!
newCloseButtonFor: aModel
	"Answer a new close button."

	^self theme
		newCloseButtonIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 8/10/2010 16:35'!
newCloseControlFor: aModel action: aValuable help: helpText
	"Answer a new cancel button."

	^self theme
		newCloseControlIn: self
		for: aModel
		action: aValuable
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/22/2006 09:24'!
newColorChooserFor: aModel getColor: getSel setColor: setSel getEnabled: enabledSel help: helpText
	"Answer a color chooser with the given selectors."

	^self theme
		newColorChooserIn: self
		for: aModel
		getColor: getSel
		setColor: setSel
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:34'!
newColorChooserFor: aModel getColor: getSel setColor: setSel help: helpText
	"Answer a color chooser with the given selectors."

	^self theme
		newColorChooserIn: self
		for: aModel
		getColor: getSel
		setColor: setSel
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/22/2006 09:44'!
newColorPresenterFor: aModel getColor: getSel help: helpText
	"Answer a color presenter with the given selectors."

	^self theme
		newColorPresenterIn: self
		for: aModel
		getColor: getSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:21'!
newColumn: controls
	"Answer a morph laid out with a column of controls."

	^self theme
		newColumnIn: self
		for: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 5/15/2007 17:39'!
newDialogPanel
	"Answer a new main dialog panel."

	^self theme
		newDialogPanelIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:03'!
newDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a drop list for the given model."

	^self theme
		newDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:03'!
newDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a drop list for the given model."

	^self theme
		newDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:03'!
newDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel help: helpText
	"Answer a drop list for the given model."

	^self
		newDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 8/17/2010 15:57'!
newEditableDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel addToList: addSel class: aClass default: defaultValue ghostText: ghostText getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer an editable drop list for the given model."

	^self theme
		newEditableDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		addToList: addSel
		class: aClass
		default: defaultValue
		ghostText: ghostText
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 8/17/2010 16:02'!
newEditableDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel addToList: addSel ghostText: ghostText getEnabled: enabledSel help: helpText
	"Answer an editable drop list for the given model."

	^self theme
		newEditableDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		addToList: addSel
		class: String
		default: ''
		ghostText: ghostText
		getEnabled: enabledSel
		useIndex: false
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/16/2007 14:14'!
newEmbeddedMenu
	"Answer a new menu."

	^self theme
		newEmbeddedMenuIn: self
		for: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 16:21'!
newExpander: aString
	"Answer an expander with the given label."

	^self theme
		newExpanderIn: self
		label: aString
		forAll: #()! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 16:20'!
newExpander: aString for: aControl
	"Answer an expander with the given label and control."

	^self theme
		newExpanderIn: self
		label: aString
		forAll: {aControl}! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 16:21'!
newExpander: aString forAll: controls
	"Answer an expander with the given label and controls."

	^self theme
		newExpanderIn: self
		label: aString
		forAll: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:00'!
newFuzzyLabel: aString
	"Answer a new fuzzy label."

	^self theme
		newFuzzyLabelIn: self
		for: nil
		label: aString
		offset: 1
		alpha: 0.5
		getEnabled: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:00'!
newFuzzyLabelFor: aModel label: aString getEnabled: enabledSel
	"Answer a new fuzzy label."

	^self theme
		newFuzzyLabelIn: self
		for: aModel
		label: aString
		offset: 1
		alpha: 0.5
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:00'!
newFuzzyLabelFor: aModel label: aString offset: offset alpha: alpha getEnabled: enabledSel
	"Answer a new fuzzy label."

	^self theme
		newFuzzyLabelIn: self
		for: aModel
		label: aString
		offset: offset
		alpha: alpha
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 15:56'!
newGroupbox
	"Answer a plain groupbox."

	^self theme
		newGroupboxIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:21'!
newGroupbox: aString
	"Answer a groupbox with the given label."

	^self theme
		newGroupboxIn: self
		label: aString! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:22'!
newGroupbox: aString for: control
	"Answer a groupbox with the given label and control."

	^self theme
		newGroupboxIn: self
		label: aString
		for: control! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:22'!
newGroupbox: aString forAll: controls
	"Answer a groupbox with the given label and controls."

	^self theme
		newGroupboxIn: self
		label: aString
		forAll: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 15:57'!
newGroupboxFor: control
	"Answer a plain groupbox with the given control."

	^self theme
		newGroupboxIn: self
		for: control! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 10:33'!
newGroupboxForAll: controls
	"Answer a plain groupbox with the given controls."

	^self theme
		newGroupboxIn: self
		forAll: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 14:59'!
newHSVASelector: aColor help: helpText
	"Answer a hue-saturation-volume selector with the given color."

	^self theme
		newHSVASelectorIn: self
		color: aColor
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 14:46'!
newHSVSelector: aColor help: helpText
	"Answer a hue-saturation-volume selector with the given color."

	^self theme
		newHSVSelectorIn: self
		color: aColor
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 16:28'!
newHueSelector: aModel getHue: getSel setHue: setSel help: helpText
	"Answer a hue selector with the given selectors."

	^self theme
		newHueSelectorIn: self
		for: aModel
		getHue: getSel
		setHue: setSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/25/2006 15:36'!
newImage: aForm
	"Answer a new image."

	^self theme
		newImageIn: self
		form: aForm! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/11/2006 13:13'!
newImage: aForm size: aPoint
	"Answer a new image."

	^self theme
		newImageIn: self
		form: aForm
		size: aPoint! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 8/30/2011 15:28'!
newImageFor: aModel get: getSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newImageIn: self
		for: aModel
		get: getSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/2/2009 15:00'!
newIncrementalSliderFor: aModel getValue: getSel setValue: setSel min: min max: max quantum: quantum getEnabled: enabledSel help: helpText
	"Answer an inremental slider with the given selectors."

	^self theme
		newIncrementalSliderIn: self
		for: aModel
		getValue: getSel
		setValue: setSel
		min: min
		max: max
		quantum: quantum
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/16/2007 15:51'!
newLabel: aString
	"Answer a new text label."

	^self
		newLabelFor: nil
		label: aString
		getEnabled: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'StephaneDucasse 8/17/2010 19:34'!
newLabelFor: aModel getLabel: labelSel getEnabled: enabledSel
	"Answer a new text label."

	^self theme
		newLabelIn: self
		for: aModel
		getLabel: labelSel
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/16/2007 15:50'!
newLabelFor: aModel label: aString getEnabled: enabledSel
	"Answer a new text label."

	^self theme
		newLabelIn: self
		for: aModel
		label: aString
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 1/20/2011 12:20'!
newLabelGroup: labelsAndControls
	"Answer a morph laid out with a column of labels and a column of associated controls.
	Controls having a vResizing value of #spaceFill will
	cause their row to use #spaceFill also, otherwise #shrinkWrap."

	^self theme
		newLabelGroupIn: self
		for: labelsAndControls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 1/20/2011 12:20'!
newLabelGroup: labelsAndControls font: aFont labelColor: aColor
	"Answer a morph laid out with a column of labels and a column of associated controls.
	Controls having a vResizing value of #spaceFill will
	cause their row to use #spaceFill also, otherwise #shrinkWrap."

	^self theme
		newLabelGroupIn: self
		for: labelsAndControls
		font: aFont
		labelColor: aColor
! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 11:45'!
newListFor: aModel list: listSelector selected: getSelector changeSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a list for the given model."

	^self theme
		newListIn: self
		for: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 11:48'!
newListFor: aModel list: listSelector selected: getSelector changeSelected: setSelector help: helpText
	"Answer a list for the given model."

	^self
		newListFor: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 7/15/2011 10:18'!
newListFor: aModel list: listSelector selected: getSelector changeSelected: setSelector icon: iconSelector getEnabled: enabledSel help: helpText
	"Answer a list for the given model."

	^self theme
		newListIn: self
		for: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		icon: iconSelector
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/12/2006 16:09'!
newMenu
	"Answer a new menu."

	^self theme
		newMenuIn: self
		for: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/12/2006 16:09'!
newMenuFor: aModel
	"Answer a new menu."

	^self theme
		newMenuIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:32'!
newMorphDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a morph drop list for the given model."

	^self 
		newMorphDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 16:58'!
newMorphDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a morph drop list for the given model."

	^self theme
		newMorphDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:32'!
newMorphDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel help: helpText
	"Answer a morph drop list for the given model."

	^self 
		newMorphDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:27'!
newMorphListFor: aModel list: listSelector getSelected: getSelector setSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a morph list for the given model."

	^self theme
		newMorphListIn: self
		for: aModel
		list: listSelector
		getSelected: getSelector
		setSelected: setSelector
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:28'!
newMorphListFor: aModel list: listSelector getSelected: getSelector setSelected: setSelector help: helpText
	"Answer a morph list for the given model."

	^self
		newMorphListFor: aModel
		list: listSelector
		getSelected: getSelector
		setSelected: setSelector
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 10/5/2010 13:40'!
newMultistateButton
	"Answer a new multistate button morph.
	To be usable it needs to have fill styles assigned to various states along
	with mouse-up/down actions."
	
	^self theme
		newMultistateButtonIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 14:25'!
newNoButton
	"Answer a new No button."

	^self newNoButtonFor: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 14:26'!
newNoButtonFor: aModel
	"Answer a new No button."

	^self theme
		newNoButtonIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:23'!
newOKButton
	"Answer a new OK button."

	^self newOKButtonFor: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 3/23/2007 15:58'!
newOKButtonFor: aModel
	"Answer a new OK button."

	^self
		newOKButtonFor: aModel
		getEnabled: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 3/23/2007 15:56'!
newOKButtonFor: aModel getEnabled: enabledSel
	"Answer a new OK button."

	^self theme
		newOKButtonIn: self
		for: aModel
		getEnabled: enabledSel! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 10/5/2010 13:49'!
newOverflowRowForAll: aCollectionOfMorphs
	"Answer a new overflow row morph that provides a drop down for
	the given contents that are unable to fit the bounds."
	
	^self theme
		newOverflowRowIn: self
		forAll: aCollectionOfMorphs! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 5/15/2007 17:40'!
newPanel
	"Answer a new panel."

	^self theme
		newPanelIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/2/2007 10:39'!
newPluggableDialogWindow
	"Answer a new pluggable dialog."

	^self
		newPluggableDialogWindow: 'Dialog'! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/2/2007 10:38'!
newPluggableDialogWindow: title
	"Answer a new pluggable dialog with the given content."

	^self
		newPluggableDialogWindow: title
		for: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/2/2007 10:38'!
newPluggableDialogWindow: title for: contentMorph
	"Answer a new pluggable dialog with the given content."

	^self theme
		newPluggableDialogWindowIn: self
		title: title
		for: contentMorph! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/17/2008 13:25'!
newRadioButtonFor: aModel getSelected: getSel setSelected: setSel getEnabled: enabledSel label: stringOrText help: helpText
	"Answer a checkbox (radio button appearance) with the given label."

	^self theme
		newRadioButtonIn: self
		for: aModel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		label: stringOrText
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/17/2008 13:25'!
newRadioButtonFor: aModel getSelected: getSel setSelected: setSel label: stringOrText help: helpText
	"Answer a checkbox (radio button appearance) with the given label."

	^self
		newRadioButtonFor: aModel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		label: stringOrText
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/15/2007 17:48'!
newRow
	"Answer a morph laid out as a row."

	^self theme
		newRowIn: self
		for: #()! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:27'!
newRow: controls
	"Answer a morph laid out with a row of controls."

	^self theme
		newRowIn: self
		for: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/8/2007 14:38'!
newSVSelector: aColor help: helpText
	"Answer a saturation-volume selector with the given color."

	^self theme
		newSVSelectorIn: self
		color: aColor
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 10/5/2010 13:29'!
newScrollPaneFor: aMorph
	"Answer a new scroll pane morph to scroll the given morph."
	
	^self theme
		newScrollPaneIn: self
		for: aMorph! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/15/2007 15:41'!
newSeparator
	"Answer an horizontal separator."

	^self theme
		newSeparatorIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:30'!
newSliderFor: aModel getValue: getSel setValue: setSel getEnabled: enabledSel help: helpText
	"Answer a slider with the given selectors."

	^self theme
		newSliderIn: self
		for: aModel
		getValue: getSel
		setValue: setSel
		min: 0
		max: 1
		quantum: nil
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 13:13'!
newSliderFor: aModel getValue: getSel setValue: setSel help: helpText
	"Answer a slider with the given selectors."

	^self theme
		newSliderIn: self
		for: aModel
		getValue: getSel
		setValue: setSel
		min: 0
		max: 1
		quantum: nil
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:28'!
newSliderFor: aModel getValue: getSel setValue: setSel min: min max: max quantum: quantum getEnabled: enabledSel help: helpText
	"Answer a slider with the given selectors."

	^self theme
		newSliderIn: self
		for: aModel
		getValue: getSel
		setValue: setSel
		min: min
		max: max
		quantum: quantum
		getEnabled: enabledSel
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/21/2009 14:44'!
newStack
	"Answer a morph laid out as a stack."

	^self theme
		newStackIn: self
		for: #()! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 10/21/2009 14:44'!
newStack: controls
	"Answer a morph laid out with a stack of controls."

	^self theme
		newStackIn: self
		for: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:42'!
newString: aStringOrText
	"Answer a new embossed string."

	^self theme
		newStringIn: self
		label: aStringOrText
		font: self theme labelFont
		style: #plain! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:42'!
newString: aStringOrText font: aFont style: aStyle
	"Answer a new embossed string."

	^self theme
		newStringIn: self
		label: aStringOrText
		font: aFont
		style: aStyle! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/9/2007 11:43'!
newString: aStringOrText style: aStyle
	"Answer a new embossed string."

	^self theme
		newStringIn: self
		label: aStringOrText
		font: self theme labelFont
		style: aStyle! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/16/2006 08:41'!
newTabGroup: labelsAndPages
	"Answer a tab group with the given tab labels associated with pages."

	^self theme
		newTabGroupIn: self
		for: labelsAndPages! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 4/11/2007 16:25'!
newText: aStringOrText
	"Answer a new text."

	^self theme
		newTextIn: self
		text: aStringOrText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 12:50'!
newTextEditorFor: aModel getText: getSel setText: setSel
	"Answer a text editor for the given model."

	^self
		newTextEditorFor: aModel
		getText: getSel
		setText: setSel
		getEnabled: nil! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/5/2006 14:51'!
newTextEditorFor: aModel getText: getSel setText: setSel getEnabled: enabledSel 
	"Answer a text editor for the given model."

	^self theme
		newTextEditorIn: self
		for: aModel
		getText: getSel
		setText: setSel
		getEnabled: enabledSel ! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/18/2006 12:56'!
newTextEntryFor: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: aClass
		getEnabled: enabledSel 
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/18/2006 13:00'!
newTextEntryFor: aModel getText: getSel setText: setSel getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: enabledSel 
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'AlainPlantec 11/25/2010 17:48'!
newTextEntryFor: aModel getText: getSel setText: setSel getEnabled: enabledSel help: helpText entryCompletion: anEntryCompletion

	"Answer a text entry for the given model."

	^self theme
		newTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: enabledSel 
		help: helpText
		entryCompletion: anEntryCompletion! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 12:50'!
newTextEntryFor: aModel getText: getSel setText: setSel help: helpText
	"Answer a text entry for the given model."

	^self
		newTextEntryFor: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: nil 
		help: helpText! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:28'!
newTitle: aString for: control
	"Answer a morph laid out with a column with a title."

	^self theme
		newTitleIn: self
		label: aString
		for: control! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 6/20/2007 09:38'!
newToolDockingBar
	"Answer a tool docking bar."

	^self theme
		newToolDockingBarIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/19/2006 10:07'!
newToolSpacer
	"Answer a tool spacer."

	^self theme
		newToolSpacerIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/19/2006 10:06'!
newToolbar
	"Answer a toolbar."

	^self theme
		newToolbarIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/19/2006 10:07'!
newToolbar: controls
	"Answer a toolbar with the given controls."

	^self theme
		newToolbarIn: self
		for: controls! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 9/19/2006 10:08'!
newToolbarHandle
	"Answer a toolbar handle."

	^self theme
		newToolbarHandleIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/25/2006 10:28'!
newTreeFor: aModel list: listSelector selected: getSelector changeSelected: setSelector
	"Answer a new tree morph."
	
	^self theme
		newTreeIn: self
		for: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 8/7/2007 11:55'!
newVerticalSeparator
	"Answer a vertical separator."

	^self theme
		newVerticalSeparatorIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 10/5/2010 13:23'!
newWindowFor: aModel title: titleString
	"Answer a new window morph."
	
	^self theme
		newWindowIn: self
		for: aModel
		title: titleString! !

!TEasilyThemed methodsFor: 'controls' stamp: 'GaryChambers 10/5/2010 14:06'!
newWorkArea
	"Answer a new work area morph."
	
	^self theme
		newWorkAreaIn: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 14:25'!
newYesButton
	"Answer a new Yes button."

	^self newYesButtonFor: self! !

!TEasilyThemed methodsFor: 'controls' stamp: 'gvc 1/10/2007 14:23'!
newYesButtonFor: aModel
	"Answer a new yes button."

	^self theme
		newYesButtonIn: self
		for: aModel! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 14:28'!
proceed: aStringOrText
	"Open a proceed dialog."

	^self proceed: aStringOrText title: 'Proceed' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 8/25/2006 16:20'!
proceed: aStringOrText title: aString
	"Open a proceed dialog and answer true if not cancelled, false otherwise."

	^self theme
		proceedIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 14:28'!
question: aStringOrText
	"Open a question dialog."

	^self question: aStringOrText title: 'Question' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 2/28/2007 12:35'!
question: aStringOrText title: aString
	"Open a question dialog and answer true if yes,
	false if no and nil if cancelled."

	^self theme
		questionIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 14:46'!
questionWithoutCancel: aStringOrText
	"Open a question dialog."

	^self questionWithoutCancel: aStringOrText title: 'Question' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 2/28/2007 12:35'!
questionWithoutCancel: aStringOrText title: aString
	"Open a question dialog and answer true if yes,
	false if no and nil if cancelled."

	^self theme
		questionWithoutCancelIn: self
		text: aStringOrText
		title: aString! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 10:44'!
textEntry: aStringOrText
	"Open a text entry dialog."

	^self textEntry: aStringOrText title: 'Entry' translated! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 10:45'!
textEntry: aStringOrText title: aString
	"Open a text entry dialog."

	^self
		textEntry: aStringOrText
		title: aString
		entryText: ''! !

!TEasilyThemed methodsFor: 'services' stamp: 'gvc 1/10/2007 10:43'!
textEntry: aStringOrText title: aString entryText: defaultEntryText
	"Open a text entry dialog."

	^self theme
		textEntryIn: self
		text: aStringOrText
		title: aString
		entryText: defaultEntryText! !

!TEasilyThemed methodsFor: 'theme' stamp: 'gvc 8/24/2006 18:44'!
theme
	"Answer the ui theme that provides controls."

	^UITheme current! !

Trait named: #TEnableOnHaloMenu
	uses: {}
	category: 'Polymorph-Widgets'!

!TEnableOnHaloMenu commentStamp: 'gvc 5/18/2007 11:56' prior: 0!
Trait providing an "enabled" option on the halo menu.!

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:22'!
addToggleItemsToHaloMenu: aCustomMenu 
	"Add toggle-items to the halo menu"
	
	super addToggleItemsToHaloMenu: aCustomMenu.
	aCustomMenu
		addUpdating: #enabledString
		target: self
		action: #toggleEnabled! !

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:24'!
enabled
	"Answer the enabled state of the receiver."

	self requirement! !

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:24'!
enabled: aBoolean
	"Set the enabled state of the receiver."

	self requirement! !

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:22'!
enabledString
	"Answer the string to be shown in a menu to represent the 
	'enabled' status"
	
	^ (self enabled
		ifTrue: ['<on>']
		ifFalse: ['<off>']), 'enabled' translated! !

!TEnableOnHaloMenu methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 15:23'!
toggleEnabled
	"Toggle the enabled state."

	self enabled: self enabled not! !

RectangleMorph subclass: #IconicListItem
	instanceVariableNames: 'originalObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!IconicListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/7/2011 15:19'!
originalObject

	^ originalObject! !

!IconicListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/7/2011 15:19'!
originalObject: anObject
	
	originalObject := anObject! !

!TopLeftGripMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/12/2007 10:53'!
containsPoint: aPoint
	"Answer true only if on edges."
	
	|w|
	^(super containsPoint: aPoint) and: [
		w := SystemWindow borderWidth.
		((self bounds translateBy: w@w)
			containsPoint: aPoint) not]! !

!TopLeftGripMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 5/13/2008 10:21'!
drawOn: aCanvas
	"Draw the grip on the given canvas."

	| dotBounds alphaCanvas windowBorderWidth dotBounds2 |
	
	self shouldDraw ifFalse: [^self].

	windowBorderWidth := SystemWindow borderWidth.
	alphaCanvas := aCanvas asAlphaBlendingCanvas: 0.7.	
	"alphaCanvas
		frameRectangle: bounds color: Color blue."

	dotBounds := self bounds.
	dotBounds2 := dotBounds right: (dotBounds left + windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.
	
	dotBounds2 := dotBounds left: (dotBounds left + windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 left: (dotBounds2 left + 7).
	dotBounds2 := dotBounds2 right: (dotBounds2 right - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor.

	dotBounds2 := dotBounds right: (dotBounds left + windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 top: (dotBounds2 top + 7).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor! !

!AlphaBlendingCanvas methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 9/1/2008 16:31'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule
	"Draw the given form. For the 'paint' combination rule use stenciling otherwise simply fill the source rectangle.
	Do a blendAlpha if the rule is blend to cope with translucent images being drawn (via translucentImage:...)."
	
	rule = Form paint ifTrue:[
		^myCanvas
			image: aForm
			at: aPoint
			sourceRect: sourceRect
			rule: Form paintAlpha
			alpha: alpha.
	].
	rule = Form over ifTrue:[
		^myCanvas
			image: aForm
			at: aPoint
			sourceRect: sourceRect
			rule: Form blendAlpha
			alpha: alpha.
	].
	rule = Form blend ifTrue:[
		^myCanvas
			image: aForm
			at: aPoint
			sourceRect: sourceRect
			rule: Form blendAlpha
			alpha: alpha.
	].! !

!InfiniteForm methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/21/2008 16:37'!
fillRectangle: aRectangle on: aCanvas
	"Fill the given rectangle on the given canvas with the receiver."
	
	aCanvas fillRectangle: aRectangle basicFillStyle: self! !

MorphTreeNodeMorph subclass: #TickSelectionListNodeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TickSelectionListNodeMorph commentStamp: '<historical>' prior: 0!
A TickSelectionListNodeMorph is the morph used to render the tree used to render te tick list!

!TickSelectionListNodeMorph methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 9/17/2011 03:25'!
drawMouseDownHighlightOn: aCanvas
	"Draw with a dotted border."

	self highlightedForMouseDown 
		ifTrue: [
			container ifNil: [^super drawMouseDownHighlightOn: aCanvas].
			self storeValue ifNil: [ self storeValue: self complexContents selected not ].
			self complexContents selected: self storeValue.
			aCanvas 
				frameRectangle: self selectionFrame
				width: 1
				colors: {container mouseDownHighlightColor. Color transparent}
				dashes: #(1 1)]! !

!TickSelectionListNodeMorph methodsFor: 'event' stamp: 'BenjaminVanRyseghem 9/17/2011 05:09'!
pressed: anIndex 

	self complexContents pressed: anIndex! !

!TickSelectionListNodeMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 03:24'!
storeValue

	^ self owner owner storeValue! !

!TickSelectionListNodeMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 03:24'!
storeValue: aValue

	^ self owner owner storeValue: aValue! !

PluggableTextMorph subclass: #PluggableTextEditorMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PluggableTextEditorMorph commentStamp: 'AlainPlantec 2/22/2011 08:51' prior: 0!
Multi-line text editor with support for accepting on both each change and/or when keyboard focus changes. Also supports custom selection colour and clickable highlights.

to see later 
uses: TEnableOnHaloMenu

DEPRECATED in 1.3

!

PluggableTextEditorMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

PluggableTextMorph subclass: #PluggableTextFieldMorph
	instanceVariableNames: 'converter ghostText default entryCompletion endRow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PluggableTextFieldMorph commentStamp: 'gvc 5/18/2007 12:39' prior: 0!
Single-line text field editor with DialogWindow key integration (return for default, escape for cancel) and keyboard focus navigation (tab/shift-tab). Additionally supports pluggable converters to translate between an object and its string form and vice-versa.!

!PluggableTextFieldMorph methodsFor: 'Polymorph-Widgets-override' stamp: 'GaryChambers 3/8/2011 11:45'!
acceptTextInModel
	"Inform the model that the receiver's textMorph's
	text should be accepted.
	Answer true if the model accepted ok, false
	otherwise"
	| objectToAccept text |
	self hasValidText ifFalse: [^false].
	text := self text.
	objectToAccept := self converter
				ifNil: [text]
				ifNotNil: [self default
						ifNil: [self converter stringAsObject: text asString]
						ifNotNil: [text
								ifEmpty: [self default]
								ifNotEmpty: [self converter stringAsObject: text asString]]].
	^ setTextSelector isNil
		or: [setTextSelector numArgs = 2
				ifTrue: [model
						perform: setTextSelector
						with: objectToAccept
						with: self]
				ifFalse: [model perform: setTextSelector with: objectToAccept]]! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 5/23/2007 13:08'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme textFieldNormalBorderStyleFor: self]
		ifFalse: [self theme textFieldDisabledBorderStyleFor: self]! !

!PluggableTextFieldMorph methodsFor: 'testing' stamp: 'AlainPlantec 11/25/2010 21:07'!
chooserHasFocus
	^ entryCompletion notNil and: [entryCompletion chooser notNil and: [entryCompletion chooser hasFocus]]
! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2010 22:18'!
closeChooser	
	entryCompletion
		ifNotNil: [entryCompletion closeChooser]! !

!PluggableTextFieldMorph methodsFor: 'model access' stamp: 'gvc 9/18/2006 12:22'!
convertTo: aClass
	"Set the converter object class."

	self converter isNil
		ifTrue: [self converter: (ObjectStringConverter forClass: aClass)]
		ifFalse: [self converter objectClass: aClass]! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 12:21'!
converter
	"Answer the value of converter"

	^ converter! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 12:21'!
converter: anObject
	"Set the value of converter"

	converter := anObject! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/14/2009 11:29'!
default
	^ default! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/14/2009 11:29'!
default: anObject
	default := anObject! !

!PluggableTextFieldMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 4/12/2011 10:12'!
drawOn: aCanvas 
	"Eventually draw the helpText"
	super drawOn: aCanvas.
	self ghostText
		ifNotEmpty: [
			self text isEmpty
				ifTrue: [| ghostBounds |
					ghostBounds := ((self scroller submorphBounds topLeft corner: self innerBounds bottomRight)
						translateBy: 0 @ (self scroller height - self theme textFont height / 2) rounded)
						insetBy: self textMarginsWidth @ 0.
					aCanvas 
						drawString: self ghostText
						in: ghostBounds
						font: self theme  textFont
						color: Color lightGray]].
	entryCompletion 
		ifNotNil: [entryCompletion closeIfNotOver: self].
! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/28/2010 09:09'!
entryCompletion: anEntryCompletion
	entryCompletion := anEntryCompletion.
	entryCompletion 
		ifNotNil: [ entryCompletion chooseBlock isNil
			ifTrue: [entryCompletion chooseBlock: [:v | self setText: v. self acceptTextInModel ]]
			ifFalse: [ | blk | 
				blk := entryCompletion chooseBlock.
				entryCompletion chooseBlock: [:v | self setText: v. self acceptTextInModel. blk value: v]]].
! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 5/23/2007 13:04'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme textFieldNormalFillStyleFor: self]
		ifFalse: [self theme textFieldDisabledFillStyleFor: self]! !

!PluggableTextFieldMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/25/2010 22:12'!
focusChanged
	| outerMorph |
	(self hasFocus or: [self chooserHasFocus])
		ifFalse: [self closeChooser].
	super focusChanged
! !

!PluggableTextFieldMorph methodsFor: 'model access' stamp: 'gvc 9/18/2006 14:06'!
getSelection
	"Answer the model's selection interval.
	If not available keep the current selection."

	getSelectionSelector isNil ifFalse: [^super getSelection].
	^selectionInterval ifNil: [super getSelection]! !

!PluggableTextFieldMorph methodsFor: 'model access' stamp: 'gvc 9/18/2006 12:55'!
getText
	"Retrieve the current model text. Set the converter to
	convert between the class of the returned object and string form."

	| newObj |
	getTextSelector isNil ifTrue: [^super getText].
	newObj := model perform: getTextSelector.
	newObj ifNil: [^Text new].
	self converter isNil
		ifTrue: [self convertTo: newObj class].
	^(self converter objectAsString: newObj) shallowCopy! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/14/2009 11:29'!
ghostText
	"Answer the value of helpText"

	^ ghostText ifNil: [ghostText := '']! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/14/2009 11:29'!
ghostText: aText
	"Set the value of helpText"
	ghostText := aText ifNotNil: [aText asString]
! !

!PluggableTextFieldMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/29/2008 16:59'!
handlesMouseWheel: evt
	"Do I want to receive mouseWheel events?." 

	^false! !

!PluggableTextFieldMorph methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 3/8/2011 12:26'!
hasValidText
	"Return true if the text is valid with respect to the converter."

	|string|
	self converter ifNil: [^super hasValidText].
	string := self text asString.
	^(string isEmpty and: [self default notNil]) or: [
		self converter isStringValid: self text asString]! !

!PluggableTextFieldMorph methodsFor: 'geometry' stamp: 'AlainPlantec 11/27/2010 23:29'!
innerBounds
	| inb |
	inb := super innerBounds.
	endRow 
		ifNotNil: [inb := inb withRight: (inb right - endRow fullBounds width)].
	^ inb! !

!PluggableTextFieldMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/28/2010 09:44'!
keyboardFocusChange: aBoolean
	self closeChooser.
	super keyboardFocusChange: aBoolean.
! !

!PluggableTextFieldMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/28/2010 10:07'!
keystrokeFromTextMorph: anEvent
	anEvent keyCharacter = Character cr
		ifTrue: [self closeChooser].
	^ (super keystrokeFromTextMorph: anEvent)
		or: [entryCompletion notNil and: [entryCompletion keystroke: anEvent from: self]]
			
	! !

!PluggableTextFieldMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/27/2010 22:31'!
layoutChanged
	super layoutChanged.
	endRow 
		ifNotNil: [ | deltaY |
			deltaY := (self height - endRow fullBounds height) // 2.
			endRow position: self boundsInWorld topRight - (endRow fullBounds width @ deltaY negated)].
! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:00'!
maxLength
	"Answer the maximum number of characters that may be typed."

	^self textMorph maxLength! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 14:59'!
maxLength: anInteger
	"Set the maximum number of characters that may be typed."

	self textMorph maxLength: anInteger! !

!PluggableTextFieldMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/24/2010 20:46'!
mouseDownFromTextMorph: anEvent
	super mouseDownFromTextMorph: anEvent.
	entryCompletion ifNotNil: [entryCompletion mouseDownFromTextMorph: anEvent]! !

!PluggableTextFieldMorph methodsFor: 'styling' stamp: 'AlainPlantec 8/27/2011 16:03'!
okToStyle
	^ false! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2010 19:01'!
openChooser	
	entryCompletion
		ifNotNil: [entryCompletion openChooserWith: textMorph text string from: self]! !

!PluggableTextFieldMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/26/2010 18:09'!
outOfWorld: aWorld
	self closeChooser.
	super outOfWorld: aWorld! !

!PluggableTextFieldMorph methodsFor: 'event handling' stamp: 'gvc 1/4/2007 15:36'!
scrollByKeyboard: event 
	"If event is ctrl+up/down then scroll and answer true.
	Just don't, really!!"
	
	^false! !

!PluggableTextFieldMorph methodsFor: 'editor access' stamp: 'gvc 1/4/2007 15:15'!
scrollSelectionIntoView: event 
	"Scroll my text into view if necessary and return true, else return false.
	Redone here to deal with horizontal scrolling!!"
	
	| selRects delta selRect rectToTest transform cpHere |
	selectionInterval := textMorph editor selectionInterval.
	selRects := textMorph paragraph selectionRects.
	selRects isEmpty ifTrue: [^ false].
	rectToTest := selRects first merge: selRects last.
	transform := scroller transformFrom: self.
	(event notNil and: [event anyButtonPressed]) ifTrue:  "Check for autoscroll"
		[cpHere := transform localPointToGlobal: event cursorPoint.
		cpHere y <= self top
			ifTrue: [rectToTest := selRects first topLeft extent: 2@2]
			ifFalse: [cpHere y >= self bottom
					ifTrue: [rectToTest := selRects last bottomRight extent: 2@2]
					ifFalse: [^ false]]].
	selRect := transform localBoundsToGlobal: rectToTest.
	selRect height > bounds height
		ifTrue: [^ false].  "Would not fit, even if we tried to scroll"
	(delta := selRect amountToTranslateWithin: self innerBounds) ~= (0@0) ifTrue:
		["Scroll end of selection into view if necessary"
		self scrollBy: delta truncated.
		^ true].
	^ false! !

!PluggableTextFieldMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/25/2010 18:34'!
textChanged
	super textChanged.
	self openChooser! !

!PluggableTextFieldMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/14/2009 11:30'!
textMarginsWidth
	| tm |
	"hack to get the margins width 
	because textMorph margins can 
	be an integer, a point or a rectangle"
	tm := self textMorph margins.
	^ tm isRectangle
		ifTrue: [tm left]
		ifFalse: [tm isPoint
				ifTrue: [tm x]
				ifFalse: [tm]]! !

!PluggableTextFieldMorph methodsFor: 'private' stamp: 'gvc 9/9/2006 14:07'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^TextMorphForFieldView! !

!PluggableTextFieldMorph methodsFor: 'updating' stamp: 'gvc 6/21/2007 10:51'!
update: aSymbol
	"Update the receiver based on the given aspect.
	Override to not accept an #appendText for a text field
	since if broadcast by a model it will append to ALL
	text fields/editors."
	
	aSymbol == #appendEntry
		ifTrue: [^self].
	^super update: aSymbol! !

!PluggableTextFieldMorph methodsFor: 'initialization' stamp: 'AlainPlantec 11/28/2010 09:08'!
withDropListButton
	| downArrow downArrowBtn |
	endRow := AlignmentMorph newRow.
	downArrow := (self theme 
		basicCreateArrowOfDirection: #bottom 
		size: (textMorph textStyle defaultFont height)
		color: Color veryLightGray).
	downArrowBtn := IconicButton new labelGraphic: downArrow.
	downArrowBtn height: self innerBounds height.
	downArrowBtn borderWidth: 0.
	downArrowBtn color: Color transparent.
	downArrowBtn actionSelector:  #openChooserWithAllOrCloseFrom:.
	downArrowBtn target: entryCompletion.
	downArrowBtn arguments: (Array with: self).
	endRow addMorph: downArrowBtn.
	self addMorph: endRow.! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 2/21/2011 18:21'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self borderStyle baseColor: (self enabled ifTrue: [paneColor twiceDarker] ifFalse: [paneColor darker]).
	self fillStyle: self fillStyleToUse.
	self borderWidth > 0 
		ifTrue: [self borderStyle: self borderStyleToUse]! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
appendText: aTextOrString
	"Append the given text to the receiver."

	self handleEdit: [
		self 
			selectInvisiblyFrom: textMorph asText size + 1 to: textMorph asText size;
			replaceSelectionWith: aTextOrString;
			selectFrom: textMorph asText size + 1 to: textMorph asText size;
			hasUnacceptedEdits: false;
			scrollSelectionIntoView;
			changed]! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since the drawOn: method is so horrible."

	super drawSubmorphsOn: aCanvas.
	self textMorph ifNotNil: [:tm | self hasKeyboardFocus 
			ifTrue: [self drawKeyboardFocusOn: aCanvas]]! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
focusBounds
	"Answer the bounds for drawing the focus indication
	(when externalFocusForPluggableText is enabled)."

	^self theme textFocusBoundsFor: self! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
hasKeyboardFocus
	"Answer whether the receiver has keyboard focus."

	^super hasKeyboardFocus or: [(self textMorph ifNil: [^false]) hasKeyboardFocus]! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 3/8/2011 12:00'!
hasValidText
	"Return true if the text is valid for acceptance."

	^true! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
keyboardFocusChange: aBoolean
	"Pass on to text morph."
	
	aBoolean ifTrue: [self textMorph takeKeyboardFocus]! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Note: written so that #layoutBounds can be changed without touching this method"
	
	super layoutBounds: aRectangle.
	textMorph ifNotNil:
		[textMorph extent: (self innerBounds width-6)@self height].
	self setScrollDeltas
! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
minHeight
	"Implemented here since extent: overriden."

	^super minHeight max: 16! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
minWidth
	"Implemented here since extent: overriden."

	^super minWidth max: 36! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
navigationKey: event
	"Check for tab key activity and change focus as appropriate.
	Must override here rather than in #tabKey: otherwise
	the tab will get passed to the window and change the focus."

	(event keyCharacter = Character tab and: [
		(event anyModifierKeyPressed or: [event shiftPressed]) not]) ifTrue: [^false].
	^super navigationKey: event! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!PluggableTextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/8/2010 22:10'!
wantsKeyboardFocus
	"Answer whether the receiver would like keyboard focus
	in the general case (mouse action normally). Even if disabled
	we allow for text morphs since can potentially copy text."

	^self takesKeyboardFocus and: [
		self visible and: [
			self enabled or: [self valueOfProperty: #wantsKeyboardFocusWhenDisabled ifAbsent: [true]]]]
! !

ImageMorph subclass: #AlphaImageMorph
	instanceVariableNames: 'alpha cachedForm layout scale enabled autoSize getImageSelector model'
	classVariableNames: 'DefaultImage'
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!AlphaImageMorph commentStamp: 'gvc 5/18/2007 13:52' prior: 0!
Displays an image with the specified alpha value (translucency) and optional scale and layout (scaled, top-right etc.).!

!AlphaImageMorph class methodsFor: 'as yet unclassified' stamp: 'GaryChambers 9/8/2011 10:35'!
defaultImage: aForm
	"Set the default image used for new instances of the receiver."

	DefaultImage := aForm! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 9/26/2006 09:40'!
alpha
	"Answer the value of alpha"

	^ alpha! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 15:34'!
alpha: anObject
	"Set the value of alpha"

	alpha := anObject.
	self
		cachedForm: nil;
		changed;
		changed: #alpha! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 2/3/2010 17:46'!
autoSize
	"Answer the value of autoSize"

	^ autoSize! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 2/3/2010 17:46'!
autoSize: anObject
	"Set the value of autoSize"

	autoSize := anObject! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/4/2011 12:59'!
cachedForm
	"Answer the value of cachedForm"
	
	|form i effectiveAlpha|
	cachedForm ifNil: [
		i := self scaledImage.
		effectiveAlpha := self enabled
			ifTrue: [self alpha]
			ifFalse: [self alpha / 2].
		effectiveAlpha = 1.0
			ifTrue: [self cachedForm: i]
			ifFalse: [form := Form extent: i extent depth: 32.
					form fillColor: (Color white alpha: 0.003922).
					(form getCanvas asAlphaBlendingCanvas: effectiveAlpha)
						drawImage: i
					at: 0@0.
					self cachedForm: form]].
	^cachedForm! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 9/27/2006 15:02'!
cachedForm: anObject
	"Set the value of cachedForm"

	cachedForm := anObject! !

!AlphaImageMorph methodsFor: 'initialization' stamp: 'gvc 9/26/2006 12:40'!
defaultColor
	"Answer the default color for the receiver."

	^Color transparent! !

!AlphaImageMorph methodsFor: 'initialization' stamp: 'gvc 12/3/2007 11:37'!
defaultImage
	"Answer the default image for the receiver."

	^DefaultImage ifNil: [DefaultImage := DefaultForm asFormOfDepth: 32]! !

!AlphaImageMorph methodsFor: 'drawing' stamp: 'gvc 8/8/2007 16:25'!
drawOn: aCanvas
	"Draw with the current alpha
	Can't do simple way since BitBlt rules are dodgy!!."
	
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
	(self cachedForm width = 0 or: [self cachedForm height = 0]) ifTrue: [^self].
	self layout == #tiled
		ifTrue: [aCanvas fillRectangle: self innerBounds fillStyle: (AlphaInfiniteForm with: self cachedForm)]
		ifFalse: [aCanvas clipBy: self innerBounds during: [:c |
					c translucentImage: self cachedForm at: self layoutPosition]]! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 1/13/2009 17:56'!
enabled
	"Answer the value of enabled"

	^enabled! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 1/13/2009 17:57'!
enabled: anObject
	"Set the value of enabled"

	enabled := anObject.
	self
		cachedForm: nil;
		changed! !

!AlphaImageMorph methodsFor: 'geometry' stamp: 'GaryChambers 8/4/2011 13:06'!
extent: aPoint
	"Allow as normal."
	
	self perform: #extent: withArguments: {aPoint} inSuperclass: Morph.
	(self layout = #scaled or: [self layout = #scaledAspect]) ifTrue: [self cachedForm: nil]
! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/30/2011 15:22'!
getImageSelector

	^ getImageSelector! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/30/2011 15:22'!
getImageSelector: anObject

	getImageSelector := anObject! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 9/28/2006 14:15'!
image: anImage 
	"Clear the cached form."
	
	^self image: anImage size: anImage extent! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 2/3/2010 17:48'!
image: aForm size: aPoint
	"Set the image to be the form scaled to the given size and padded if neccesary."

	|f f2|
	f := aForm scaledToSize: aPoint.
	(f depth < 32 and: [f depth > 4])
		ifTrue: [f2 := Form extent: aPoint depth: 32.
				f2 fillColor: (Color white alpha: 0.003922).
				f2 getCanvas translucentImage: f at: 0@0.
				f2 fixAlpha]
		ifFalse: [f2 := f].
	self autoSize
		ifTrue: [super image: f2]
		ifFalse: [image := f2.
				self changed].
	self cachedForm: nil.
	self changed: #imageExtent! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 6/30/2009 16:02'!
imageExtent
	"Answer the extent of the original form."

	^self image extent! !

!AlphaImageMorph methodsFor: 'initialization' stamp: 'gvc 2/3/2010 17:55'!
initialize
	"Initialize the receiver.
	Use the 32 bit depth default image to avoid
	unnecessary conversions."

	enabled := true.
	autoSize := true.
	scale := 1.0.
	layout := #topLeft.
	alpha := 1.0.
	super initialize! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 10/11/2006 12:00'!
layout
	"Answer the value of layout"

	^ layout! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/4/2011 13:04'!
layout: aSymbol
	"Set the value of layout"

	|old|
	(old := layout) = aSymbol ifTrue: [^self].
	layout := aSymbol.
	((old = #scaled or: [old = #scaledAspect]) or: [aSymbol = #scaled or: [aSymbol = #scaledAspect]])
		ifTrue: [self cachedForm: nil].
	self changed! !

!AlphaImageMorph methodsFor: 'geometry' stamp: 'GaryChambers 8/4/2011 13:07'!
layoutPosition
	"Answer the position that the cached form should be drawn
	based on the layout"
	
	self layout == #topCenter ifTrue: [^self innerBounds topCenter - (self cachedForm width // 2 @ 0)].
	self layout == #topRight ifTrue: [^self innerBounds topRight - (self cachedForm width @ 0)].
	self layout == #rightCenter ifTrue: [^self innerBounds rightCenter - (self cachedForm width @ (self cachedForm height // 2))].
	self layout == #bottomRight ifTrue: [^self innerBounds bottomRight - self cachedForm extent].
	self layout == #bottomCenter ifTrue: [^self innerBounds bottomCenter - (self cachedForm width // 2 @ self cachedForm height)].
	self layout == #bottomLeft ifTrue: [^self innerBounds bottomLeft - (0 @ self cachedForm height)].
	self layout == #leftCenter ifTrue: [^self innerBounds leftCenter - (0 @ (self cachedForm height // 2))].
	(self layout == #center or: [self layout == #scaledAspect]) ifTrue: [^self innerBounds center - (self cachedForm extent // 2)].
	^self innerBounds topLeft! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/4/2011 13:04'!
layoutSymbols
	"Answer the available layout options."

	^#(#center #tiled #scaled #scaledAspect
		#topLeft #topCenter #topRight #rightCenter
		#bottomRight #bottomCenter #bottomLeft #leftCenter)! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/30/2011 15:32'!
model

	^ model! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/30/2011 15:33'!
model: anObject
	"Set my model and make me me a dependent of the given object."

	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject
! !

!AlphaImageMorph methodsFor: 'geometry' stamp: 'gvc 10/22/2007 11:51'!
optimalExtent
	"Answer the optimal extent for the receiver."
	
	^self image extent * self scale + (self borderWidth * 2)! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 10/11/2006 12:43'!
scale
	"Answer the value of scale"

	^ scale! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 15:34'!
scale: aNumber
	"Set the value of scale"

	scale = aNumber ifTrue: [^self].
	scale := aNumber.
	self
		cachedForm: nil;
		changed;
		changed: #scale! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/4/2011 13:04'!
scaledImage
	"Answer the image scaled as required."
	
	|i|
	i := self image.
	(self layout == #scaled and: [self extent ~= i extent]) ifTrue: [
		^i magnify: i boundingBox by: (self extent / i extent) smoothing: 2].
	(self layout == #scaledAspect and: [self extent ~= i extent]) ifTrue: [
		^self width / i width > (self height / i height)
			ifTrue: [i magnify: i boundingBox by: (self height / i height) smoothing: 2]
			ifFalse: [i magnify: i boundingBox by: (self width / i width) smoothing: 2]].
	self scale ~= 1 ifTrue: [
		^i magnify: i boundingBox by: self scale smoothing: 2].
	^i! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/30/2011 15:23'!
update: aSymbol
	"Update the image if changed."
	
	super update: aSymbol.
	aSymbol = self getImageSelector ifTrue: [
		self updateImage]! !

!AlphaImageMorph methodsFor: 'accessing' stamp: 'GaryChambers 8/30/2011 15:35'!
updateImage
	"Get the image from the model."
	
	(self model notNil and: [self getImageSelector notNil]) ifTrue: [
		(self model perform: self getImageSelector) ifNotNil: [:i | self image: i]]! !

!ImageMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/25/2006 15:45'!
adoptPaneColor: paneColor
	"Change our border color too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self borderStyle baseColor: paneColor twiceDarker! !

!ImageMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/27/2009 11:56'!
borderStyle: newStyle
	"Set the extent to include border width."
	
	| newExtent |
	self borderStyle = newStyle ifTrue: [^self].
	newExtent := 2 * newStyle width + image extent.
	bounds extent = newExtent ifFalse: [super extent: newExtent].
	super borderStyle: newStyle! !

!ImageMorph methodsFor: '*Polymorph-Widgets' stamp: 'StephaneDucasse 5/28/2011 13:40'!
color: aColor
	"Set the color.
	Change to a ColorForm here if depth 1."
	
        super color: aColor.
        (image depth = 1 and: [aColor isColor]) ifTrue: [
		image isColorForm ifFalse: [
			image := ColorForm mappingWhiteToTransparentFrom: image].
                image colors: {Color transparent. aColor}.
                self changed]! !

!ImageMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/18/2007 11:52'!
drawOn: aCanvas
	"Draw the border after the image."
	
	| style |
	self isOpaque
		ifTrue:[aCanvas drawImage: image at: self innerBounds origin]
		ifFalse:[aCanvas translucentImage: image at: self innerBounds origin].
	(style := self borderStyle) ifNotNil:[
		style frameRectangle: bounds on: aCanvas]! !

!ImageMorph methodsFor: '*Polymorph-Widgets' stamp: 'StephaneDucasse 10/12/2010 13:02'!
image: anImage 
	"Fixed to take account of border width.
	Use raw image, only change depth 1 forms to
	ColorForm with transparency if #color: is sent."
	
	image := anImage. 
	super extent: (2 * self borderWidth) asPoint + image extent.
	self changed! !

!LazyListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/12/2006 11:21'!
mouseDownRow
	"Answer the row that should have mouse down highlighting if any."

	^self valueOfProperty: #mouseDownRow! !

!LazyListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 13:06'!
mouseDownRow: anInteger
	"Set the row that should have mouse down highlighting or nil if none."

	anInteger = self mouseDownRow ifTrue: [^self].
	self mouseDownRowFrameChanged.
	self setProperty: #mouseDownRow toValue: anInteger.
	self mouseDownRowFrameChanged! !

!LazyListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 14:04'!
mouseDownRowFrameChanged
	"Invalidate frame of the current mouse down row if any."
	
	|frame row|
	row := self mouseDownRow ifNil: [ ^self ].
	frame := self selectionFrameForRow: row.
	self invalidRect: frame! !

!LazyListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 11:44'!
selectionFrameChanged
	"Invalidate frame of the current selection if any."
	
	| frame |
	selectedRow ifNil: [ ^self ].
	selectedRow = 0 ifTrue: [ ^self ].
	frame := self selectionFrameForRow: selectedRow.
	self invalidRect: frame! !

!LazyListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/12/2006 15:33'!
selectionFrameForRow: row
	"Answer the selection frame rectangle."

	|frame|
	frame := self drawBoundsForRow: row.
	frame := frame intersect: self bounds.
	frame := self bounds: frame in: listSource.
	frame := self
		bounds: ((frame left: listSource innerBounds left) right: listSource innerBounds right)
		from: listSource.
	^frame! !

LazyListMorph subclass: #LazyMorphListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!LazyMorphListMorph commentStamp: 'gvc 5/18/2007 12:47' prior: 0!
Support for morph lists in PluggableMorphListMorph.!

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 13:38'!
adjustHeight
	"private.  Adjust our height to match the length of the underlying list.
	Automatic with table layout."
! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/13/2006 11:12'!
adjustWidth
	"private.  Adjust our height to match the length of the underlying list"
	
	self width: (listSource innerBounds width max: self hUnadjustedScrollRange). ! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 15:14'!
display: item  atRow: row on: aCanvas
	"Display the given item at the given row on the given canvas."
	
	|c frame|
	row = self mouseDownRow ifFalse: [^self].
	frame := self selectionFrameForRow: row.
	c := self colorForRow: row.
	aCanvas 
		frameRectangle: frame
		width: 1
		colors: {c. Color transparent}
		 dashes: #(1 1)! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 16:08'!
drawBoundsForRow: row
	"Calculate the bounds that row should be drawn at.  This might be outside our bounds!!"
	
	(row between: 1 and: listItems size)
		ifFalse: [^0@0 corner: 0@0].
	^(listItems at: row) bounds! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front"

	| drawBlock|
	submorphs isEmpty ifTrue: [^self].
	drawBlock := [:canvas | | i |
		(self topVisibleRowForCanvas: aCanvas) to: (self bottomVisibleRowForCanvas: aCanvas) do: [ :row |
			i := self item: row.
			canvas fullDrawMorph: i]].
	self clipSubmorphs 
		ifTrue: [aCanvas clipBy: (aCanvas clipRect intersect: self clippingBounds) during: drawBlock]
		ifFalse: [drawBlock value: aCanvas]! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/19/2009 12:25'!
hUnadjustedScrollRange
	"Answer the width of the widest item."

	maxWidth ifNotNil:[^maxWidth].
	listItems isEmpty ifTrue: [^0].
	maxWidth := 0.
	listItems do: [:each |
		each ifNotNil: [maxWidth := maxWidth max: (self widthToDisplayItem: each)]].
	^maxWidth
! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/13/2006 10:44'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		changeTableLayout;
		cellPositioning: #topLeft;
		cellInset: 2;
		vResizing: #shrinkWrap;
		hResizing: #rigid! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/20/2009 16:56'!
listChanged
	"set newList to be the list of strings to display"
	listItems := (1 to: self getListSize) collect: [:i |
		self getListItem: i].
	self removeAllMorphs.
	self extent: 0@0.
	listItems do: [:i | self addMorphBack: i].
	selectedRow := nil.
	selectedRows := PluggableSet integerSet.
	maxWidth := nil. "recompute"
	self
		adjustHeight;
		adjustWidth.
	listItems do: [:i | i layoutChanged].
	self changed.
! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 13:36'!
rowAtLocation: aPoint
	"return the number of the row at aPoint"

	| y |
	y := aPoint y.
	y < self top ifTrue: [ ^ 1 ].
	listItems with: (1 to: listItems size) do: [:i :row |
		(y < i bottom) ifTrue: [^row]].
	^listItems size! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 12:24'!
selectRow: index
	"select the index-th row"
	selectedRows add: index.
	self invalidRect: (self drawBoundsForRow: index)! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 15:33'!
selectionFrameForRow: row
	"Answer the selection frame rectangle."

	|frame|
	frame := self drawBoundsForRow: row.
	frame := frame expandBy: (self cellInset // 2).
	self cellInset odd ifTrue: [frame := frame bottom: frame bottom + 1].
	frame := frame intersect: self bounds.
	frame := self bounds: frame in: listSource.
	frame := self
		bounds: ((frame left: listSource innerBounds left) right: listSource innerBounds right)
		from: listSource.
	^frame! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
userString
	"Do I have a text string to be searched on?"

	
	^ String streamContents: [:strm | | usm |
		1 to: self getListSize do: [:i |
			usm := (self getListItem: i) submorphs detect: [:m | m userString notNil] ifNone: [].
			strm nextPutAll: (usm ifNil: [''] ifNotNil: [usm userString]); cr]]! !

!LazyMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 11:09'!
widthToDisplayItem: item

	^item minExtent x
	! !

MorphTreeModel subclass: #CheckList
	instanceVariableNames: 'rootItems headerLabel rootNodes multiSelection autoMultiSelection itemLabelSelector wrapBlockOrSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!CheckList class methodsFor: 'example' stamp: 'AlainPlantec 9/28/2011 11:42'!
example
	"self example"

	(((self new) 
		rootItems: (Object subclasses sort: [:a :b | a name <= b name]);
		headerLabel: 'Object sub-classes';
		multiSelection: true;
		buildContents)
			embeddedInMorphicWindowLabeled: 'Object sub-classes ready to be checked') 
				openInWorld
! !

!CheckList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/28/2011 16:35'!
itemsList: itemsList

	^ self new
		rootItems: itemsList;
		yourself! !

!CheckList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/28/2011 16:35'!
itemsList: itemsList itemsHeaderName: aName

	^ self new
		rootItems: itemsList;
		headerLabel: aName;
		yourself! !

!CheckList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/28/2011 16:36'!
itemsList: itemsList itemsHeaderName: aName wrapBlockOrSelector: wrapBlockOrSelector

	^ self basicNew
		wrapBlockOrSelector: wrapBlockOrSelector;
		initialize;
		rootItems: itemsList;
		headerLabel: aName;
		yourself! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/27/2011 11:28'!
autoMultiSelection
	^ autoMultiSelection ifNil: [autoMultiSelection := true]! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/27/2011 11:28'!
autoMultiSelection: aBoolean
	autoMultiSelection := aBoolean! !

!CheckList methodsFor: 'tree build' stamp: 'AlainPlantec 9/27/2011 11:29'!
buildContents
	^ self treeMorph buildContents; yourself ! !

!CheckList methodsFor: 'selecting' stamp: 'AlainPlantec 9/27/2011 23:38'!
deselectAll
	self rootNodes do: [:each | each selected: false ].
	self selection empty.
	self selectItems: self selection selectedItems.
	self selectionChanged.


	
	! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/26/2011 22:46'!
headerLabel

	^ headerLabel! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/26/2011 22:46'!
headerLabel: aString
	
	headerLabel := aString! !

!CheckList methodsFor: 'wrapping' stamp: 'AlainPlantec 9/27/2011 12:17'!
itemLabelSelector
	^ itemLabelSelector ifNil: [itemLabelSelector := #asString]! !

!CheckList methodsFor: 'wrapping' stamp: 'AlainPlantec 9/27/2011 12:17'!
itemLabelSelector: aSelector
	itemLabelSelector := aSelector! !

!CheckList methodsFor: 'event' stamp: 'AlainPlantec 9/26/2011 23:06'!
keyStroke: anEvent

	anEvent keyString =  '<Cmd-a>'
		ifTrue: [ self selectAll ].
		
	anEvent keyString =  '<Cmd-A>'
		ifTrue: [ self deselectAll ]! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/27/2011 11:16'!
multiSelection
	^ multiSelection ifNil: [multiSelection := true]! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/27/2011 11:15'!
multiSelection: aBoolean
	multiSelection := aBoolean! !

!CheckList methodsFor: 'private' stamp: 'AlainPlantec 9/27/2011 22:22'!
newSelectionHandler
	^ self multiSelection
		ifTrue: [MorphTreeMorphMultipleSelection new]
		ifFalse: [MorphTreeMorphSingleSelection new]! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/26/2011 22:44'!
rootItems

	^ rootItems ifNil: [ rootItems := {} ]! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/27/2011 23:39'!
rootItems: aCollection
	rootItems := aCollection.
	rootNodes := nil.! !

!CheckList methodsFor: 'tree build' stamp: 'AlainPlantec 9/27/2011 15:22'!
rootNodeClassFromItem: anItem

	^ CheckListNode! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/26/2011 23:25'!
rootNodes

	^ rootNodes ifNil: [ rootNodes := super rootNodes ]! !

!CheckList methodsFor: 'selecting' stamp: 'AlainPlantec 9/27/2011 23:38'!
selectAll
	self selection empty.
	self rootNodes do: [:each | 
		each selected: true. 
		self selection addNode: each].
	self selectItems: self selection selectedItems.
	self selectionChanged.

	! !

!CheckList methodsFor: 'selecting' stamp: 'AlainPlantec 9/28/2011 09:37'!
selectedFromNode: aNode
	aNode selected 
		ifTrue: [self selection addNode: aNode]
		ifFalse: [ self selection removeNode: aNode].
	self selectItems: self selection selectedItems.
	"self selectionChanged."
! !

!CheckList methodsFor: 'accessing' stamp: 'AlainPlantec 9/27/2011 22:33'!
selection
	^ selection ifNil: [selection := self newSelectionHandler]! !

!CheckList methodsFor: 'selecting' stamp: 'AlainPlantec 9/27/2011 23:25'!
selectionChanged
	self rootNodes
		do: [:nd | nd selected: false].
	self selection selectedNodes
		ifNotNil: [:nodes | nodes do: [:nd | nd selected: true]].

	! !

!CheckList methodsFor: 'tree build' stamp: 'AlainPlantec 9/28/2011 11:44'!
treeMorph
	| treeMorph col1 col2 |
	col1 := MorphTreeColumn new 
				startWidth: 5;
				rowMorphGetSelector: #checkButton.
	col2 := MorphTreeColumn new 
				rowMorphGetSelector: #rowLabel.
	self headerLabel
		ifNotNil: [
			col1 headerButtonLabel: '' font: nil. 
			col2 headerButtonLabel: self headerLabel font: nil].
	treeMorph := (MorphTreeMorph on: self) 
			columns:  (Array with: col1 with: col2);
			resizerWidth: 0;
			columnInset: 3; 
			rowInset: 1; 
			keystrokeActionSelector: #keyStroke:;
			makeLastColumnUnbounded;
			preferedPaneColor: Color white;
			withSelectionColorFeedback: false;
			multiSelection: self multiSelection;
			autoMultiSelection: self autoMultiSelection;
			rowColorForEven: Color veryLightGray muchLighter odd: Color white.
	^ treeMorph! !

!CheckList methodsFor: 'wrapping' stamp: 'BenjaminVanRyseghem 9/28/2011 16:41'!
wrapBlockOrSelector

	^ wrapBlockOrSelector! !

!CheckList methodsFor: 'wrapping' stamp: 'BenjaminVanRyseghem 9/28/2011 16:41'!
wrapBlockOrSelector: aBlockOrSelector

	wrapBlockOrSelector := aBlockOrSelector! !

!CheckList methodsFor: 'wrapping' stamp: 'BenjaminVanRyseghem 9/28/2011 17:03'!
wrapItem: anItem
	"Here I return the display of my item, wrapped or not, using a block or a selector which will be performed directly on the item"
	
	| anIndex |
	anIndex := self rootItems identityIndexOf: anItem ifAbsent: [ ^ anItem ].
	
	^ wrapBlockOrSelector 
		ifNil: [ anItem ]
		ifNotNil: [ 
			wrapBlockOrSelector isBlock
				ifTrue: [ wrapBlockOrSelector cull: anItem ]
				ifFalse: [ wrapBlockOrSelector isSymbol
							ifTrue: [| numArgs |
								numArgs := wrapBlockOrSelector numArgs.
								numArgs isZero 
									ifTrue: [ anItem perform: wrapBlockOrSelector ]
									ifFalse: [ 
										numArgs = 1
											ifTrue: [ anItem perform: wrapBlockOrSelector with: anIndex ]
											ifFalse: [ self error: 'Wrong number of arguments' ]]]
							ifFalse: [ anItem ]]]! !

MorphTreeModel subclass: #TickSelectionList
	instanceVariableNames: 'defaultValue itemsHeaderName itemsList lastSelectionIndex onSelectionChangedBlockOrAssociation wrapBlockOrSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TickSelectionList commentStamp: '<historical>' prior: 0!
I am a list of items where each item is linked to a checkbox.
I am based on MorphTreeMorph for rendering

self example!

!TickSelectionList class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 9/19/2011 17:00'!
example
	"self example"

	(self itemsList: Morph instVarNames itemsHeaderName: 'Inst Var Name') open! !

!TickSelectionList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 02:51'!
itemsList: itemsList

	^ self new
		itemsList: itemsList;
		yourself! !

!TickSelectionList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 05:33'!
itemsList: itemsList itemsHeaderName: aName

	^ self new
		itemsList: itemsList;
		itemsHeaderName: aName;
		yourself! !

!TickSelectionList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 06:21'!
itemsList: itemsList itemsHeaderName: aName wrapBlockOrSelector: wrapBlockOrSelector

	^ self basicNew
		wrapBlockOrSelector: wrapBlockOrSelector;
		initialize;
		itemsList: itemsList;
		itemsHeaderName: aName;
		yourself! !

!TickSelectionList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 15:37'!
itemsList: itemsList itemsHeaderName: aName wrapBlockOrSelector: wrapBlockOrSelector defaultValue: defaultValue

	^ self basicNew
		wrapBlockOrSelector: wrapBlockOrSelector;
		defaultValue: defaultValue
		initialize;
		itemsList: itemsList;
		itemsHeaderName: aName;
		yourself! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:40'!
buildContents

	^ self treeMorph buildContents! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 15:38'!
defaultValue

	^ defaultValue ifNil: [ defaultValue := false ]! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 15:38'!
defaultValue: aBoolean

	defaultValue := aBoolean! !

!TickSelectionList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/17/2011 19:18'!
deselectAll
	
	self rootItems do: [:each | each selected: false ].
	self noticeSelectionChanged! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 15:46'!
initialize

	lastSelectionIndex := 1.
	itemsHeaderName := ''.! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 02:52'!
itemsHeaderName

	^ itemsHeaderName! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 02:52'!
itemsHeaderName: anObject
	
	itemsHeaderName := anObject! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 02:51'!
itemsList

	^ itemsList ifNil: [ itemsList := {} ]! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 16:58'!
itemsList: aCollection
	" Here I assume the collection provided is not wrapped "
	
	itemsList := aCollection collect: [:each | TickSelectionValueHolder item: each selected: self defaultValue wrapBlockOrSelector: wrapBlockOrSelector]! !

!TickSelectionList methodsFor: 'event' stamp: 'BenjaminVanRyseghem 9/17/2011 15:43'!
keyStroke: anEvent

	anEvent keyString =  '<Cmd-a>'
		ifTrue: [ self selectAll ].
		
	anEvent keyString =  '<Cmd-A>'
		ifTrue: [ self deselectAll ]! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 02:52'!
lastSelectionIndex

	^ lastSelectionIndex! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:07'!
lastSelectionIndex: anObject
	
	lastSelectionIndex := anObject! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 16:59'!
noticeSelectionChanged
	"Here I propagate the information that the selection has changed"
	"I can handler either a block or an association receiver-> selector"


	self onSelectionChangedBlockOrAssociation 
		ifNotNil: [:blockOrAssociation |
			blockOrAssociation isBlock
				ifTrue: [ blockOrAssociation cull: self selectedItems ]
				ifFalse: [| receiver selector |
					receiver := blockOrAssociation key.
					selector := blockOrAssociation value.
					receiver ifNil: [ ^self ].
					selector isSymbol
						ifTrue: [ | numArgs |
							numArgs := selector numArgs.
							numArgs = 0 ifTrue: [^ receiver perform: selector ].
							numArgs = 1 ifTrue: [ ^ receiver perform: selector with: self selectedItems ].
							self error: 'Invalid number of argument']]]! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 16:59'!
onSelectionChangedBlockOrAssociation
" return a block or an association (receiver->selector)"

	^ onSelectionChangedBlockOrAssociation! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 19:14'!
onSelectionChangedBlockOrAssociation: anObject
	
	onSelectionChangedBlockOrAssociation := anObject! !

!TickSelectionList methodsFor: 'example' stamp: 'BenjaminVanRyseghem 9/21/2011 16:59'!
open
	" self new open"

	(self buildContents
		embeddedInMorphicWindowLabeled: 'Tick Selection List example') openInWorld! !

!TickSelectionList methodsFor: 'event' stamp: 'BenjaminVanRyseghem 9/17/2011 19:18'!
pressed: anIndex

	ActiveHand shiftPressed
		ifTrue: [ | list value |
			list := self rootItems.
			value := (list at: self lastSelectionIndex) selected.
			anIndex < self lastSelectionIndex
				ifTrue: [ list from: anIndex+1 to: self lastSelectionIndex do: [:each | each selected: value ]]
				ifFalse: [ list from:self lastSelectionIndex to: anIndex-1 do: [:each | each selected: value ]]].
	self noticeSelectionChanged.
	self lastSelectionIndex: anIndex! !

!TickSelectionList methodsFor: 'tree build' stamp: 'BenjaminVanRyseghem 9/17/2011 02:50'!
rootItems

	^ self itemsList! !

!TickSelectionList methodsFor: 'tree build' stamp: 'BenjaminVanRyseghem 9/16/2011 18:13'!
rootNodeClassFromItem: anItem

	^ TickSelectionListNode! !

!TickSelectionList methodsFor: 'tree build' stamp: 'BenjaminVanRyseghem 9/17/2011 03:38'!
rootNodeFromItem: anItem

	anItem addDependent: self.
	^ super rootNodeFromItem: anItem! !

!TickSelectionList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/17/2011 19:18'!
selectAll
	
	self rootItems do: [:each | each selected: true ].
	self noticeSelectionChanged! !

!TickSelectionList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 9/17/2011 06:11'!
selectedItems

	^ self rootItems select: [:each | each selected ] thenCollect: #item! !

!TickSelectionList methodsFor: 'tree build' stamp: 'BenjaminVanRyseghem 9/19/2011 16:43'!
selection: aNodePath
	| selectedItem value list newIndex multiSelectionNodePath |

	list := self rootItems.
	
	aNodePath selectedNodePath
		ifNotNil: [:path |
			selectedItem := path first.
			value := selectedItem item selected.
			newIndex := (list indexOf: selectedItem item).
			ActiveHand shiftPressed
				ifFalse: [ self lastSelectionIndex: newIndex ].
			list from: ( self lastSelectionIndex min: (newIndex)) to: (newIndex max: self lastSelectionIndex) do: [:each | 
				each selected: value ].
			self lastSelectionIndex: newIndex].
	
	super selection: aNodePath.
	self noticeSelectionChanged.! !

!TickSelectionList methodsFor: 'tree build' stamp: 'BenjaminVanRyseghem 9/17/2011 14:27'!
treeMorph
	
	| treeMorph |
	
	treeMorph := (TickSelectionListMorph on: self)
		columns: {MorphTreeColumn new startWidth: 5;
						rowMorphGetSelector: #selectedMorph;
						headerButtonLabel: '' font:  nil.
					MorphTreeColumn new
						rowMorphGetSelector: #nameMorph;
						headerButtonLabel: self itemsHeaderName font:  nil};
						
		withHLines: true;
		resizerWidth: 0;
		columnInset: 3;
		keystrokeActionSelector: #keyStroke:;
		makeLastColumnUnbounded;
		preferedPaneColor: Color white;
		rowColorForEven:  Color veryLightGray muchLighter odd: Color white .
	^ treeMorph ! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:16'!
wrapBlockOrSelector

	^ wrapBlockOrSelector! !

!TickSelectionList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:16'!
wrapBlockOrSelector: anObject
	
	wrapBlockOrSelector := anObject! !

MorphTreeModel subclass: #TickSelectionValueHolder
	instanceVariableNames: 'item selected wrapBlockOrSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TickSelectionValueHolder commentStamp: '<historical>' prior: 0!
A TickSelectionValueHolder is a dummy class which is used to wrap the items used in the tick list to keep the status of the selection!

!TickSelectionValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 06:11'!
item: itemName

	^ self new
		item: itemName;
		yourself! !

!TickSelectionValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 15:39'!
item: item selected: selected wrapBlockOrSelector: wrapBlockOrSelector

	^ self basicNew
		wrapBlockOrSelector: wrapBlockOrSelector;
		initialize;
		item: item;
		selected: selected;
		yourself! !

!TickSelectionValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 06:22'!
item: item wrapBlockOrSelector: wrapBlockOrSelector

	^ self basicNew
		wrapBlockOrSelector: wrapBlockOrSelector;
		initialize;
		item: item;
		yourself! !

!TickSelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:12'!
item

	^ item! !

!TickSelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:10'!
item: anObject
	
	item := anObject! !

!TickSelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 17:01'!
itemName
	"Here I return the display of my item, wrapped or not, using a block or a selector which will be performed directly on the item"
	
	^ wrapBlockOrSelector 
		ifNil: [ self item ]
		ifNotNil: [ 
			wrapBlockOrSelector isBlock
				ifTrue: [ wrapBlockOrSelector cull: self item ]
				ifFalse: [ wrapBlockOrSelector isSymbol
							ifTrue: [| numArgs |
								numArgs := wrapBlockOrSelector numArgs.
								numArgs isZero 
									ifTrue: [ self item perform: wrapBlockOrSelector ]
									ifFalse: [ self error: 'Wrong number of arguments']]
							ifFalse: [ self item ]]]! !

!TickSelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 02:09'!
selected

	^ selected ifNil: [ selected := false ]! !

!TickSelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 02:10'!
selected: anObject
	
	selected := anObject.
	self changed: #selected! !

!TickSelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:10'!
wrapBlockOrSelector

	^ wrapBlockOrSelector! !

!TickSelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:10'!
wrapBlockOrSelector: anObject
	
	wrapBlockOrSelector := anObject! !

Model subclass: #AnimationSettings
	instanceVariableNames: 'useAnimation animateClosing delay numberOfSteps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!AnimationSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:21'!
animateClosing
	^ animateClosing ifNil: [animateClosing := false]! !

!AnimationSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:21'!
animateClosing: aBoolean
	animateClosing := aBoolean! !

!AnimationSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:24'!
delay
	^ delay ifNil: [delay := 8]! !

!AnimationSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:22'!
delay: anInteger
	delay := anInteger! !

!AnimationSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:23'!
numberOfSteps
	^ numberOfSteps ifNil: [numberOfSteps := 20]! !

!AnimationSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:23'!
numberOfSteps: anInteger
	numberOfSteps := anInteger! !

!AnimationSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:20'!
useAnimation
	^ useAnimation ifNil: [useAnimation := false]! !

!AnimationSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:21'!
useAnimation: aBoolean
	useAnimation := aBoolean! !

!Model methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 4/14/2011 11:30'!
theme
	^ UITheme current ! !

Model subclass: #ThemeSettings
	instanceVariableNames: 'windowColor selectionColor autoSelectionColor buttonColor scrollbarColor standardColorsOnly progressBarColor progressBarProgressColor menuColor menuTitleColor preferGradientFill menuWithIcons preferRoundCorner autoMenuColor flatMenu fadedBackgroundWindows fastDragging animationSettings alternativeButtonsInScrollBars scrollBarThickness balloonHelpEnabled tabAmongFields balloonHelpDelayTime maxBalloonHelpLineLength dragNDropWithAnimation desktopImageLayout menuSelectionColor secondarySelectionColor findReplaceSelectionColor selectionBarColor unfocusedSelectionColor menuSelectionTextColor selectionTextColor secondarySelectionTextColor findReplaceSelectionTextColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!ThemeSettings commentStamp: 'gvc 5/18/2007 10:23' prior: 0!
Configurable basic settings for themes.!

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:25'!
animationSettings
	^ animationSettings ifNil: [animationSettings := AnimationSettings new]! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 10/18/2006 12:11'!
applySettingsFrom: aThemeSettings
	"Change the settings to be those of aThemeSettings."
	
	self
		windowColor: aThemeSettings windowColor;
		selectionColor: aThemeSettings selectionColor;
		autoSelectionColor: aThemeSettings autoSelectionColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 22:48'!
autoMenuColor
	"Answer the value of autoMenuColor"

	^autoMenuColor ifNil: [^false]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 18:11'!
autoMenuColor: aBoolean
	"Answer the value of autoMenuColor"

	autoMenuColor := aBoolean! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/18/2007 11:45'!
autoSelectionColor
	"Answer the value of autoSelectionColor"

	^autoSelectionColor ifNil: [^true]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 10/12/2006 14:04'!
autoSelectionColor: anObject
	"Set the value of autoSelectionColor"

	autoSelectionColor := anObject.
	self
		changed: #autoSelectionColor;
		changed: #manualSelectionColor;
		changed: #selectionColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/19/2009 23:29'!
balloonHelpDelayTime
	^ balloonHelpDelayTime ifNil: [balloonHelpDelayTime := 800]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/19/2009 23:30'!
balloonHelpDelayTime: anInteger
	balloonHelpDelayTime := anInteger! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/19/2009 23:15'!
balloonHelpEnabled
	^ balloonHelpEnabled ifNil: [balloonHelpEnabled := true]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/19/2009 23:15'!
balloonHelpEnabled: aBoolean
	balloonHelpEnabled := aBoolean! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 9/17/2007 14:14'!
basicSelectionColor
	"Answer the recorded selection color rather than derived."

	^selectionColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/16/2007 13:39'!
buttonColor
	"Answer the value of buttonColor"

	^buttonColor ifNil: [self windowColor]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/13/2007 17:05'!
buttonColor: anObject
	"Set the value of buttonColor"

	buttonColor := anObject! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 17:06'!
defaultButtonColor
	"Answer the default button colour."

	^Color gray! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 13:01'!
defaultScrollbarColor
	"Answer the default scrollbar colour."

	^Color gray! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 17:48'!
defaultSelectionColor
	"Answer the default selection colour."

	^self defaultWindowColor! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/20/2010 19:47'!
defaultWindowColor
	"Answer the default window colour."

	^ Color lightGray! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 4/27/2010 11:56'!
derivedMenuColor
	"Answer a selection colour based on the window color."

	| autoColor worldColor |
	autoColor := self autoMenuColor 
				and: [Display depth > 4
						and: [(worldColor := self currentWorld color) isColor]].

	^ autoColor
				ifTrue: [worldColor luminance > 0.7
						ifTrue: [worldColor mixed: 0.85 with: Color black]
						ifFalse: [worldColor mixed: 0.4 with: Color white]]
				ifFalse: [self menuColor].
! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 14:39'!
derivedSelectionColor
	"Answer a selection colour based on the window color."

	^self windowColor whiter lighter! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 3/9/2010 15:14'!
desktopImageLayout
	"Answer the layout symbol for any desktop image.
	See AlphaImageMorph>>layoutSymbols."

	^desktopImageLayout ifNil: [desktopImageLayout := #scaled]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 3/9/2010 15:14'!
desktopImageLayout: aSymbol
	"Set the layout symbol for any desktop image.
	See AlphaImageMorph>>layoutSymbols."

	desktopImageLayout := aSymbol! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/20/2009 00:02'!
dragNDropWithAnimation
	^ dragNDropWithAnimation ifNil: [dragNDropWithAnimation := false]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/20/2009 00:02'!
dragNDropWithAnimation: aBoolean
	dragNDropWithAnimation := aBoolean! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 14:27'!
fadedBackgroundWindows
	^ fadedBackgroundWindows ifNil: [fadedBackgroundWindows := true]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 14:27'!
fadedBackgroundWindows: aBoolean
	fadedBackgroundWindows := aBoolean! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 18:29'!
fallbackMenuColor
	"Answer the value of menuColor"

	^ self preferGradientFill ifTrue: [Color lightGray] ifFalse: [Color lightGray muchLighter]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 21:34'!
fastDragging 
		^ fastDragging ifNil: [fastDragging := false] ! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 21:35'!
fastDragging: aBoolean
		fastDragging := aBoolean! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2010 16:33'!
findReplaceSelectionColor
	"Answer the value of the selectionColor for find/replace"

	^ findReplaceSelectionColor ifNil: [findReplaceSelectionColor := Color orange alpha: 0.4]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 11/12/2010 22:28'!
findReplaceSelectionColor: anColor
	findReplaceSelectionColor := anColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 22:15'!
findReplaceSelectionTextColor
	"Answer the value of the selectionTextColor for find/replace"

	^ findReplaceSelectionTextColor 
		ifNil: [ self findReplaceSelectionColor contrastingColor ]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 21:36'!
findReplaceSelectionTextColor: aColor
	"Answer the value of the selectionTextColor for find/replace"

	findReplaceSelectionTextColor := aColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 19:18'!
flatMenu 
		^ flatMenu ifNil: [flatMenu := false]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 19:19'!
flatMenu: aBoolean
		flatMenu := aBoolean! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:43'!
fromConfiguration: tree
	"Update the settings from the given tree."
	
	(tree at: #windowColor ifAbsent: []) ifNotNil: [:v | self windowColor: v].
	(tree at: #autoSelectionColor ifAbsent: []) ifNotNil: [:v | self autoSelectionColor: v].
	(tree at: #selectionColor ifAbsent: []) ifNotNil: [:v | self selectionColor: v]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 21:50'!
haveFindReplaceSelectionTextColor

	^ findReplaceSelectionTextColor notNil! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 21:49'!
haveSecondarySelectionTextColor
	"Answer the value of selectionTextColor"

	^ secondarySelectionTextColor notNil! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 21:49'!
haveSelectionTextColor
	
	^ selectionTextColor notNil! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/20/2009 21:54'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		autoSelectionColor: true;
		windowColor: self defaultWindowColor;
		selectionColor: self defaultSelectionColor;
		buttonColor: self defaultButtonColor;
		scrollbarColor: self defaultScrollbarColor;
		standardColorsOnly: false! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:41'!
manualSelectionColor
	"Answer the inverse of autoSelectionColor."

	^self autoSelectionColor not! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/19/2009 23:31'!
maxBalloonHelpLineLength
	^ maxBalloonHelpLineLength ifNil: [maxBalloonHelpLineLength := 40]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/19/2009 23:31'!
maxBalloonHelpLineLength: anInteger
	maxBalloonHelpLineLength := anInteger! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 10:50'!
menuBorderColor
	"Answer the value of menuColor"

	^ self flatMenu  
		ifFalse: [#raised]
		ifTrue: [self derivedMenuColor twiceDarker]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 17:53'!
menuBorderWidth
	"Answer the value of menuColor"

	^ 2! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 17:23'!
menuColor
	"Answer the value of menuColor"

	^ menuColor ifNil: [self fallbackMenuColor]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 10/16/2008 16:12'!
menuColor: anObject
	"Set the value of menuColor"

	menuColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/19/2009 23:22'!
menuKeyboardControl
	^ true! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 1/4/2010 08:48'!
menuKeyboardFocusColor
	^ (Color r: 0.6 g: 1.0 b: 1.0)! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 3/24/2010 11:03'!
menuSelectionColor
	"Answer the value of menuSelectionColor"

	^menuSelectionColor ifNil: [self derivedMenuColor darker]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'MarcusDenker 9/27/2010 15:31'!
menuSelectionColor: aColor
	"Set the base value of menuSelectionColor.
	If nil, actual color used will be based on derived menu color."

	menuSelectionColor := aColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 21:03'!
menuSelectionTextColor
	"Answer the value of menuSelectionTextColor"

	^menuSelectionTextColor ifNil: [menuSelectionTextColor := Color black]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 21:10'!
menuSelectionTextColor: aColor
	"Answer the value of menuSelectionTextColor"

	menuSelectionTextColor := aColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 11:05'!
menuShadowColor
	^ TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.666! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 19:52'!
menuTitleBorderColor
	^ self flatMenu
		ifFalse: [#inset]
		ifTrue: [self derivedMenuColor muchDarker]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/21/2009 11:39'!
menuTitleColor
	"Answer the value of menuTitleColor"

	Display depth = 1 ifTrue: [^ Color white].
	Display depth = 2 ifTrue: [^ Color gray].
	^menuTitleColor 
		ifNil: [self menuColor 
				ifNil: [Color gray] 
				ifNotNil: [:mc | self preferGradientFill 
					ifTrue: [mc]
					ifFalse: [mc twiceDarker]]]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 10/16/2008 16:12'!
menuTitleColor: anObject
	"Set the value of menuTitleColor"

	menuTitleColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 15:24'!
menuWithIcons
	^ menuWithIcons ifNil: [menuWithIcons := true]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 15:24'!
menuWithIcons: aBoolean
	menuWithIcons := aBoolean! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 11:34'!
preferGradientFill 
	"Answer the value of preferGradientFill "

	^preferGradientFill  ifNil: [preferGradientFill := self preferGradientFillByDefault]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 11:28'!
preferGradientFill: aBoolean
	"Set the value of preferGradientFill "

	preferGradientFill  := aBoolean! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 11:34'!
preferGradientFillByDefault
	^ true! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 17:19'!
preferRoundCorner
	"Answer the value of preferRoundCorner"

	^preferRoundCorner  ifNil: [preferRoundCorner := self preferRoundCornerByDefault]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 15:41'!
preferRoundCorner: aBoolean
	"Set the value of preferRoundCorner"

	preferRoundCorner := aBoolean! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 15:38'!
preferRoundCornerByDefault
	^ true! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 18:01'!
progressBarColor
	"Answer the value of progressBarColor"

	^progressBarColor ifNil: [progressBarColor := self derivedMenuColor muchLighter]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/23/2007 17:20'!
progressBarColor: anObject
	"Set the value of progressBarColor"

	progressBarColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/20/2009 00:25'!
progressBarProgressColor
	"Answer the value of progressBarProgressColor"

	^progressBarProgressColor ifNil: [self menuTitleColor]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/24/2007 11:45'!
progressBarProgressColor: anObject
	"Set the value of progressBarProgressColor"

	progressBarProgressColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/17/2009 14:36'!
scrollBarThickness
	^ scrollBarThickness ifNil: [scrollBarThickness := 14]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/17/2009 14:38'!
scrollBarsOnRight
	^ true! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/16/2007 13:40'!
scrollbarColor
	"Answer the value of scrollbarColor"

	^scrollbarColor ifNil: [self windowColor]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/16/2007 13:00'!
scrollbarColor: anObject
	"Set the value of scrollbarColor"

	scrollbarColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2010 16:32'!
secondarySelectionColor
	"Answer the value of selectionColor"

	^ secondarySelectionColor ifNil: [secondarySelectionColor :=   (TranslucentColor r: 0.351 g: 0.939 b: 0.46 alpha: 0.35)]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 11/8/2010 14:50'!
secondarySelectionColor: anColor
	secondarySelectionColor := anColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 22:14'!
secondarySelectionTextColor
	"Answer the value of selectionTextColor"

	^ secondarySelectionTextColor 
		ifNil: [ self secondarySelectionColor contrastingColor ]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 21:35'!
secondarySelectionTextColor: aColor
	"set the value of selectionTextColor"

	secondarySelectionTextColor := aColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2010 16:36'!
selectionBarColor
	^ selectionBarColor ifNil: [selectionBarColor := self selectionColor alpha: 0.06]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2010 14:54'!
selectionBarColor: aColor
	selectionBarColor := aColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2010 19:28'!
selectionColor
	"Answer the value of selectionColor"
	
	Display depth = 1 ifTrue: [^ Color veryLightGray].
	Display depth = 2 ifTrue: [^ Color gray].
	^self autoSelectionColor
		ifTrue: [self derivedSelectionColor]
		ifFalse: [selectionColor ifNil: [selectionColor := TranslucentColor r: 0.0 g: 0.0 b: 0.8 alpha: 0.25]]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/20/2009 21:53'!
selectionColor: anObject
	"Set the value of selectionColor"
	selectionColor := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 9/11/2011 05:31'!
selectionTextColor
	"Answer the value of selectionTextColor"
	
	^selectionTextColor ifNil: [Color black ]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 21:14'!
selectionTextColor: aColor
	selectionTextColor := aColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 20:23'!
standardColorsOnly
	"Answer the value of standardColorsOnly"
 
	^standardColorsOnly ifNil: [^false]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 4/13/2007 17:01'!
standardColorsOnly: anObject
	"Set the value of standardColorsOnly"

	standardColorsOnly := anObject! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/19/2009 23:24'!
tabAmongFields
	^ tabAmongFields ifNil: [tabAmongFields := true]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 12/19/2009 23:25'!
tabAmongFields: aBoolean
	tabAmongFields := aBoolean! !

!ThemeSettings methodsFor: 'as yet unclassified' stamp: 'gvc 9/17/2007 14:14'!
toConfiguration: tree
	"Update the tree from the receiver."
	
	tree at: #windowColor put: self windowColor.
	tree at: #autoSelectionColor put: self autoSelectionColor.
	tree at: #selectionColor put: self basicSelectionColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/9/2011 08:34'!
unfocusedSelectionColor
	"Answer the value of selectionColor when the window have not the focus"

	^ unfocusedSelectionColor ifNil: [unfocusedSelectionColor := self selectionColor alphaMixed: 0.7 with: Color veryLightGray lighter]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 11/17/2010 19:34'!
unfocusedSelectionColor: aColor
	"Answer the value of selectionColor when the window have not the focus"

	unfocusedSelectionColor := aColor! !

!ThemeSettings methodsFor: 'accessing' stamp: 'AlainPlantec 2/11/2011 18:19'!
windowColor
	"Answer the value of windowColor"

	^ windowColor ifNil: [Color lightGray]! !

!ThemeSettings methodsFor: 'accessing' stamp: 'gvc 10/12/2006 14:06'!
windowColor: anObject
	"Set the value of windowColor"

	windowColor := anObject.
	self changed: #windowColor.
	self autoSelectionColor ifTrue: [self changed: #selectionColor]! !

ScrollBar subclass: #GeneralScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!GeneralScrollBar commentStamp: 'gvc 5/18/2007 13:01' prior: 0!
Support for GeneralScrollPane.!

!GeneralScrollBar methodsFor: 'model access' stamp: 'gvc 9/7/2006 13:45'!
setValue: newValue
	"Bypass screwed up scrollbar!!"
	
	^self perform: #setValue: withArguments: {newValue} inSuperclass: Slider! !

!ScrollBar class methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 10:14'!
imageColorFor: aScrollbar
	"Return the (button) image colour for the given scrollbar."
	
	^self theme scrollbarImageColorFor: aScrollbar! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'pmm 3/13/2010 11:33'!
adoptGradientColor: aColor
	"Adopt the given pane color."

	|c fs bfs bs bbs|
	aColor ifNil:[^self].
	c := aColor.
	fs := self normalThumbFillStyle.
	bfs := self normalButtonFillStyle.
	bs := self normalThumbBorderStyle.
	bbs := self normalButtonBorderStyle.
	sliderColor := c.
	downButton
		fillStyle: bfs;
		borderStyle: bbs.
	upButton
		fillStyle: bfs shallowCopy;
		borderStyle: bbs.
	slider
		fillStyle: fs;
		borderStyle: bs.
	self updateUpButtonImage.
	self updateDownButtonImage! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/23/2007 15:20'!
mouseEnterDownButton: event
	"The mouse has entered the down button."
	
	downButton
		fillStyle: self mouseOverButtonFillStyle;
		borderStyle: self mouseOverButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/12/2009 14:03'!
mouseEnterPagingArea: event
	"The mouse has entered the paging area."
	
	pagingArea
		fillStyle: self mouseOverFillStyle;
		borderStyle: self mouseOverBorderStyle;
		changed.
	slider
		fillStyle: self mouseOverPagingAreaThumbFillStyle;
		borderStyle: self mouseOverPagingAreaThumbBorderStyle;
		changed.
	upButton
		fillStyle: self mouseOverPagingAreaButtonFillStyle;
		borderStyle: self mouseOverPagingAreaButtonBorderStyle;
		changed.
	downButton
		fillStyle: self mouseOverPagingAreaButtonFillStyle;
		borderStyle: self mouseOverPagingAreaButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/12/2009 13:54'!
mouseEnterThumb: event
	"The mouse has entered the thumb."
	
	slider
		fillStyle: self mouseOverThumbFillStyle;
		borderStyle: self mouseOverThumbBorderStyle;
		changed.
	upButton
		fillStyle: self mouseOverThumbButtonFillStyle;
		borderStyle: self mouseOverThumbButtonBorderStyle;
		changed.
	downButton
		fillStyle: self mouseOverThumbButtonFillStyle;
		borderStyle: self mouseOverThumbButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/23/2007 15:20'!
mouseEnterUpButton: event
	"The mouse has entered the up button."
	
	upButton
		fillStyle: self mouseOverButtonFillStyle;
		borderStyle: self mouseOverButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/23/2007 15:23'!
mouseLeaveDownButton: event
	"The mouse has left the down button."
	
	downButton
		fillStyle: self normalButtonFillStyle;
		borderStyle: self normalButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/12/2009 14:04'!
mouseLeavePagingArea: event
	"The mouse has left the paging area."
	
	pagingArea
		fillStyle: self normalFillStyle;
		borderStyle: self normalBorderStyle;
		changed.
	slider
		fillStyle: self normalThumbFillStyle;
		borderStyle: self normalThumbBorderStyle;
		changed.
	upButton
		fillStyle: self normalButtonFillStyle;
		borderStyle: self normalButtonBorderStyle;
		changed.
	downButton
		fillStyle: self normalButtonFillStyle;
		borderStyle: self normalButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/12/2009 14:05'!
mouseLeaveThumb: event
	"The mouse has left the thumb."	
	slider
		fillStyle: self normalThumbFillStyle;
		borderStyle: self normalThumbBorderStyle;
		changed.
	(self containsPoint: event position)
		ifTrue: [upButton
				fillStyle: self mouseOverPagingAreaButtonFillStyle;
				borderStyle: self mouseOverPagingAreaButtonBorderStyle]
		ifFalse: [upButton
				fillStyle: self normalButtonFillStyle;
				borderStyle: self normalButtonBorderStyle].
	(self containsPoint: event position)
		ifTrue: [downButton
				fillStyle: self mouseOverPagingAreaButtonFillStyle;
				borderStyle: self mouseOverPagingAreaButtonBorderStyle]
		ifFalse: [downButton
				fillStyle: self normalButtonFillStyle;
				borderStyle: self normalButtonBorderStyle]! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/23/2007 15:24'!
mouseLeaveUpButton: event
	"The mouse has left the up button."
	
	upButton
		fillStyle: self normalButtonFillStyle;
		borderStyle: self normalButtonBorderStyle;
		changed! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverBorderStyle
	"Return the mouse over borderStyle for the receiver."
	
	^self theme scrollbarMouseOverBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverButtonBorderStyle
	"Return the mouse over button borderStyle for the receiver."
	
	^self theme scrollbarMouseOverButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverButtonFillStyle
	"Return the mouse over button fillStyle for the receiver."
	
	^self theme scrollbarMouseOverButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverFillStyle
	"Return the mouse over fillStyle for the receiver."
	
	^self theme scrollbarMouseOverFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverPagingAreaButtonBorderStyle
	"Return the button borderStyle for the receiver when the mouse
	is over the paging area."
	
	^self theme scrollbarMouseOverBarButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverPagingAreaButtonFillStyle
	"Return the button fillStyle for the receiver when the mouse
	is over the paging area."
	
	^self theme scrollbarMouseOverBarButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverPagingAreaThumbBorderStyle
	"Return the thumb borderStyle for the receiver when the mouse
	is over the paging area."
	
	^self theme scrollbarMouseOverBarThumbBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverPagingAreaThumbFillStyle
	"Return the thumb fillStyle for the receiver when the mouse
	is over the paging area."
	
	^self theme scrollbarMouseOverBarThumbFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverThumbBorderStyle
	"Return the mouse over thumb borderStyle for the receiver."
	
	^self theme scrollbarMouseOverThumbBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverThumbButtonBorderStyle
	"Return the button borderStyle for the receiver when the mouse
	is over the thumb."
	
	^self theme scrollbarMouseOverThumbButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverThumbButtonFillStyle
	"Return the mouse over thumb fillStyle for the receiver."
	
	^self theme scrollbarMouseOverThumbButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
mouseOverThumbFillStyle
	"Return the mouse over thumb fillStyle for the receiver."
	
	^self theme scrollbarMouseOverThumbFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/17/2009 14:09'!
mouseUpInSlider: event
	"The mouse button has been released."
	
	sliderShadow hide.
	(slider containsPoint: event position)
		ifTrue: [slider
					fillStyle: self mouseOverThumbFillStyle;
					borderStyle: self mouseOverThumbBorderStyle]
		ifFalse: [self mouseLeaveThumb: event].
	slider changed! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalBorderStyle
	"Return the normal borderStyle for the receiver."
	
	^self theme scrollbarNormalBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalButtonBorderStyle
	"Return the normal button borderStyle for the receiver."
	
	^self theme scrollbarNormalButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalButtonFillStyle
	"Return the normal button fillStyle for the receiver."
	
	^self theme scrollbarNormalButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalFillStyle
	"Return the normal fillStyle for the receiver."
	
	^self theme scrollbarNormalFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalThumbBorderStyle
	"Return the normal thumb borderStyle for the receiver."
	
	^self theme scrollbarNormalThumbBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
normalThumbFillStyle
	"Return the normal thumb fillStyle for the receiver."
	
	^self theme scrollbarNormalThumbFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedBorderStyle
	"Return the pressed borderStyle for the receiver."
	
	^self theme scrollbarPressedBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedButtonBorderStyle
	"Return the pressed button borderStyle for the receiver."
	
	^self theme scrollbarPressedButtonBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedButtonFillStyle
	"Return the pressed button fillStyle for the receiver."
	
	^self theme scrollbarPressedButtonFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedFillStyle
	"Return the pressed fillStyle for the receiver."
	
	^self theme scrollbarPressedFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedThumbBorderStyle
	"Return the pressed thumb borderStyle for the receiver."
	
	^self theme scrollbarPressedThumbBorderStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:56'!
pressedThumbFillStyle
	"Return the pressed thumb fillStyle for the receiver."
	
	^self theme scrollbarPressedThumbFillStyleFor: self! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/17/2009 14:09'!
scrollAbsolute: event
	"Just don't if it is not the red button and we are drawing gradients."
	
	event redButtonPressed ifFalse: [^self].
	^super scrollAbsolute: event! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 14:14'!
setValueSelector: aSymbol
	"Directly set the selector to make more flexible."
	
	setValueSelector := aSymbol! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/26/2008 18:15'!
slider
	"Answer the slider."

	^slider! !

!ScrollBar methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/24/2007 15:18'!
themeChanged
	"Update the rounding of buttons, slider and paging area."

	pagingArea cornerStyle: (self theme scrollbarPagingAreaCornerStyleIn: self window).
	slider cornerStyle: (self theme scrollbarThumbCornerStyleIn: self window).
	upButton cornerStyle: (self theme scrollbarButtonCornerStyleIn: self window).
	downButton cornerStyle: (self theme scrollbarButtonCornerStyleIn: self window).
	super themeChanged! !

!Debugger methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 1/23/2011 09:15'!
addOptionalButtonsTo: window at: fractions plus: verticalOffset 
	"Add button panes to the window. A row of custom
	debugger-specific buttons (Proceed, Restart, etc.) is always
	added, and if optionalButtons is in force, then the standard
	code-tool buttons are also added. Answer the verticalOffset
	plus the height added."
	| delta buttons anOffset |
	anOffset := (CodeHolder optionalButtons and: [ self class extraDebuggerButtons])
				ifTrue: [super
						addOptionalButtonsTo: window
						at: fractions
						plus: verticalOffset]
				ifFalse: [verticalOffset].
	buttons := self customButtonRow.
	buttons := OverflowRowMorph new
		baseMorph: buttons;
		height: buttons minExtent y;
		setNameTo: buttons assureExtension externalName.
	delta := buttons minExtent y + 2.
	buttons color: Color white; borderWidth: 0.
	window
		addMorph: buttons
		fullFrame: (LayoutFrame
				fractions: fractions
				offsets: (0 @ anOffset corner: 0 @ (anOffset + delta - 1))).
	^ anOffset + delta! !

!Debugger methodsFor: '*Polymorph-Widgets' stamp: 'JuanVuletich 10/22/2010 14:08'!
buildMorphicNotifierLabelled: label message: messageString

	^UIManager default buildMorphicNotifierFor: self labelled: label message: messageString
! !

!Debugger methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 09:44'!
buttonRowForPreDebugWindow: aDebugWindow
	"Answer a row of button for a pre-debug notifier."
	
	| buttons quads |
	buttons := OrderedCollection with: (AlignmentMorph newVariableTransparentSpacer).
	quads := OrderedCollection withAll: self preDebugButtonQuads.
	(self interruptedContext selector == #doesNotUnderstand:) ifTrue: [
		quads add: { 'Create'. #createMethod. #magenta. 'create the missing method' }].
	quads do: [:quad |
		buttons add: ((PluggableButtonMorph
			on: aDebugWindow
			getState: nil
			action: quad second)
		label: quad first;
		setBalloonText: quad fourth;
		useSquareCorners;
		hResizing: #shrinkWrap;
		vResizing: #spaceFill).
		buttons add: AlignmentMorph newVariableTransparentSpacer].
	^(self theme builder newRow:  buttons)
		cellInset: 2! !

!Debugger methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 09:44'!
customButtonRow
	"Answer a button pane affording the user one-touch access to certain functions; the pane is given the formal name 'customButtonPane' by which it can be retrieved by code wishing to send messages to widgets residing on the pane"

	| buttons buttonsSpec |
	buttons := OrderedCollection new.
	buttonsSpec := OrderedCollection withAll: self customButtonSpecs.

	buttonsSpec add: { 'Create'. #createMethod. 'create the missing method'. #isInterruptedContextDoesNotUnderstand}.
	
	buttonsSpec do: [:buttonSpec | | button |
		button := (PluggableButtonMorph
			on: self
			getState: nil
			action: buttonSpec second)
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			askBeforeChanging: (#(proceed restart send doStep stepIntoBlock fullStack where) includes: buttonSpec second);
			label: buttonSpec first asString;
			setBalloonText: (buttonSpec size > 2 ifTrue: [buttonSpec third]);
			yourself.
		buttonSpec size > 3 ifTrue: [ button getEnabledSelector: buttonSpec fourth].
			
		buttons add: button ].
	
	^(self theme builder newRow:  buttons)
		layoutInset: (0@0 corner: 0@1);
		cellInset: 2! !

!Debugger methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 09:44'!
optionalButtonRow
	"Answer a button pane affording the user one-touch access to certain functions; the pane is given the formal name 'buttonPane' by which it can be retrieved by code wishing to send messages to widgets residing on the pane"

	| buttons |
	buttons := OrderedCollection new.
	self optionalButtonPairs do: [:tuple |
		buttons add: ((PluggableButtonMorph
			on: self
			getState: nil
			action: tuple second)
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			askBeforeChanging: (#(proceed restart send doStep stepIntoBlock fullStack where) includes: tuple second);
			label: tuple first asString;
			setBalloonText: (tuple size > 2 ifTrue: [tuple third]))].
	^(self theme builder newRow:  buttons)
		cellInset: 2! !

!EditorFindReplaceDialogWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/3/2010 09:46'!
aboutText
	^ 'This dialog can be opened with <cmd-f> in an editable text area or from the text area contextual menu. 
Previous find and replace tokens are kept so that you can directly retrieve them from the find and the replace input fields.
While you enter a find token in the find field, in the currently edited text, all matching text portions are dynamically enlighted with the find selection color (orange color by default).
The find token is shared by all text editing areas. You can also set it with the keyboard by using the <cmd-h> shortcut after having selected the portion of text you want to find. Then, you can find the next matching portion of text by using the <cmd-g> shortcut. 
In order to get rid of the current find token, just enter <cmd-h> with nothing selected or just cancel this dialog.
The colorization is manageable with the settings browser from where you can completely disallow it or change the selection color'! !

!EditorFindReplaceDialogWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/3/2010 09:05'!
aboutTitle
	^ 'Find & replace dialog'! !

!EditorFindReplaceDialogWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 8/23/2011 13:26'!
initialize
	"Set the initial position based on usable screen area."

	super initialize.
	self position: RealEstateAgent maximumUsableArea topLeft! !

!EditorFindReplaceDialogWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/3/2010 09:02'!
removeBoxes
	"Remove all label area boxes."

	expandBox ifNotNil: [expandBox delete. expandBox := nil].
	collapseBox ifNotNil: [collapseBox delete. collapseBox := nil]! !

!EditorFindReplaceDialogWindow methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 09:45'!
taskbarIcon
	^self theme smallFindIcon! !

!FormCanvas methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 3/16/2009 13:36'!
balloonFillRectangle: aRectangle fillStyle: aFillStyle

	self asBalloonCanvas fillRectangle: aRectangle basicFillStyle: aFillStyle! !

!FormCanvas methodsFor: '*Polymorph-Widgets' stamp: 'IgorStasenko 7/18/2011 18:14'!
fillRectangle: aRectangle basicFillStyle: aFillStyle
	"Fill the given rectangle with the given, non-composite, fill style."
	
	| pattern |

	(aFillStyle isKindOf: InfiniteForm) ifTrue: [
		^self infiniteFillRectangle: aRectangle fillStyle: aFillStyle
	].

	(aFillStyle isSolidFill) 
		ifTrue:[^self fillRectangle: aRectangle color: aFillStyle asColor].
	"We have a very special case for filling with infinite forms"
	(aFillStyle isBitmapFill and:[aFillStyle origin = (0@0)]) ifTrue:[
		pattern := aFillStyle form.
		(aFillStyle direction = (pattern width @ 0) 
			and:[aFillStyle normal = (0@pattern height)]) ifTrue:[
				"Can use an InfiniteForm"
				^self fillRectangle: aRectangle color: (InfiniteForm with: pattern)].
	].
	"Use a BalloonCanvas instead"
	self balloonFillRectangle: aRectangle fillStyle: aFillStyle.! !

!FormCanvas methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 10/7/2008 14:02'!
infiniteFillRectangle: aRectangle fillStyle: aFillStyle

	| additionalOffset rInPortTerms clippedPort targetTopLeft clipOffset ex |

	"this is a bit of a kludge to get the form to be aligned where I *think* it should be.
	something better is needed, but not now"

	additionalOffset := 0@0.
	ex := aFillStyle form extent.
	rInPortTerms := (aRectangle intersect: aFillStyle boundingBox) translateBy: origin.
	clippedPort := port clippedBy: rInPortTerms.
	targetTopLeft := clippedPort clipRect topLeft truncateTo: ex.
	clipOffset := rInPortTerms topLeft - targetTopLeft.
	additionalOffset := (clipOffset \\ ex) - ex.
	^aFillStyle
		displayOnPort: clippedPort
		offsetBy: additionalOffset
! !

ComplexBorder subclass: #W2KComplexTabBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!W2KComplexTabBorder methodsFor: 'drawing' stamp: 'SW 5/22/2009 20:52'!
drawLineFrom: startPoint to: stopPoint on: aCanvas ! !

!W2KComplexTabBorder methodsFor: 'drawing' stamp: 'SW 5/22/2009 20:51'!
drawPolyPatchFrom: startPoint to: stopPoint on: aCanvas usingEnds: endsArray! !

!W2KComplexTabBorder methodsFor: 'drawing' stamp: 'SW 5/22/2009 20:51'!
framePolygon2: vertices on: aCanvas! !

!W2KComplexTabBorder methodsFor: 'drawing' stamp: 'SW 5/22/2009 20:50'!
framePolygon: vertices on: aCanvas! !

!W2KComplexTabBorder methodsFor: 'drawing' stamp: 'SW 5/23/2009 14:33'!
frameRectangle: aRectangle on: aCanvas
	"Note: This uses BitBlt since it's roughly a factor of two faster for rectangles"
	| w h r |
	self colors ifNil:[^super frameRectangle: aRectangle on: aCanvas].
	w := self width.
	w isPoint ifTrue:[h := w y. w := w x] ifFalse:[h := w].
	1 to: h do:[:i| "top/bottom"
		r := (aRectangle topLeft + (i-1)) extent: (aRectangle width - (i-1*2))@1. "top"
		aCanvas fillRectangle: r color: (colors at: i).
		"r := (aRectangle bottomLeft + (i @ (0-i))) extent: (aRectangle width - (i-1*2) - 1)@0. 
		aCanvas fillRectangle: r color: (colors at: colors size - i + 1)."
	].
	1 to: w do:[:i| "left/right"
		r := (aRectangle topLeft + (i-1)) extent: 1@(aRectangle height - (i-1*2)). "left"
		aCanvas fillRectangle: r color: (colors at: i).
		r := aRectangle topRight + ((0-i)@i) extent: 1@(aRectangle height - (i-1*2) ). "right"
		aCanvas fillRectangle: r color: (colors at: colors size - i + 1).
	].! !

!W2KComplexTabBorder methodsFor: 'initialize' stamp: 'SW 5/22/2009 21:02'!
initialize
	super initialize.
	self style: #complexRaised! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 2/11/2011 16:50'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self selectionColor: self selectionColor.
	self fillStyle: self fillStyleToUse.
	self borderWidth > 0 ifTrue: [
		self borderStyle: self borderStyleToUse]! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/7/2007 12:42'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme listNormalBorderStyleFor: self]
		ifFalse: [self theme listDisabledBorderStyleFor: self]! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/2/2007 13:34'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/17/2007 15:22'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/2/2007 13:34'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/2/2007 13:34'!
enabled
	"Answer the enablement state of the receiver."

	^self valueOfProperty: #enabled ifAbsent: [true]! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/2/2007 13:34'!
enabled: aBoolean
	"Set the enablement state of the receiver."

	aBoolean = self enabled
		ifFalse: [self setProperty: #enabled toValue: aBoolean.
				self
					adoptPaneColor: self paneColor;
					changed]! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/7/2007 12:39'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme listNormalFillStyleFor: self]
		ifFalse: [self theme listDisabledFillStyleFor: self]! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/1/2009 15:18'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^self theme listFocusBoundsFor: self! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/7/2007 11:47'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^self valueOfProperty: #getEnabledSelector! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/7/2007 11:46'!
getEnabledSelector: aSymbol
	"Set the value of getEnabledSelector"

	self setProperty: #getEnabledSelector toValue: aSymbol.
	self updateEnabled! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/12/2006 14:52'!
handleFocusEvent: anEvent
	"Handle the given event. This message is sent if the receiver currently has the focus and is therefore receiving events directly from some hand."
	
	self processEvent: anEvent. "give submorphs a chance"
	(anEvent isMouse and: [anEvent isMouseDown and: [(self fullContainsPoint: anEvent position) not]])
		ifFalse: [^super handleFocusEvent: anEvent].
	"click outside - pass to event handler"
	self eventHandler
		ifNotNil: [self eventHandler mouseDown: anEvent fromMorph: self]! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/20/2006 10:24'!
mouseDownRow
	"Answer the mouse down row or nil if none."

	^self listMorph mouseDownRow! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/20/2006 10:24'!
mouseDownRow: anIntegerOrNil
	"Set the mouse down row or nil if none."

	self listMorph mouseDownRow: anIntegerOrNil! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/3/2008 13:05'!
optimalExtent
	"Answer the extent of the list morph."

	^self listMorph extent + (self borderWidth * 2) + self scrollBarThickness! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 2/11/2011 10:29'!
selectionColor
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColor ifAbsent: [self theme selectionColor] ! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 2/11/2011 16:38'!
selectionColor: aColor 
	"Set the colour for selected items."
	| w |
	aColor
		ifNil: [self removeProperty: #selectionColor]
		ifNotNil: [self setProperty: #selectionColor toValue: aColor].
	w := self ownerThatIsA: SystemWindow.
	self
		selectionColorToUse: ((self theme settings fadedBackgroundWindows not or: [w isNil or: [w isActive]])
				ifTrue: [aColor]
				ifFalse: [self theme unfocusedSelectionColor])! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 2/11/2011 16:35'!
selectionColorToUse
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColorToUse ifAbsent: [self theme settings selectionColor] ! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 11:44'!
selectionColorToUse: aColor
	"Set the colour for selected items."

	aColor = self selectionColorToUse ifTrue: [^self].
	aColor
		ifNil: [self removeProperty: #selectionColorToUse]
		ifNotNil: [self setProperty: #selectionColorToUse toValue: aColor].
	self listMorph selectionFrameChanged! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'BenjaminVanRyseghem 6/4/2011 15:40'!
specialKeyPressed: asciiValue
	"A special key with the given ascii-value was pressed; dispatch it"

	| oldSelection nextSelection max howManyItemsShowing |
	asciiValue = 27 ifTrue: 
		[" escape key"
		^ ActiveEvent shiftPressed
			ifTrue:
				[ActiveWorld invokeWorldMenuFromEscapeKey]
			ifFalse:
				[self yellowButtonActivity: false]].

	max := self maximumSelection.
	max > 0 ifFalse: [^ self].
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	asciiValue = 31 ifTrue: 
		[" down arrow"
		self resetListSelectionSilently.
		nextSelection := oldSelection + 1.
		nextSelection > max ifTrue: [nextSelection := max]].
	
	asciiValue = 13 ifTrue: [ 
		"enter pressed" 
		self selectSearchedElement ].
	
	asciiValue = 30 ifTrue: 
		[" up arrow"
		self resetListSelectionSilently.
		nextSelection := oldSelection - 1.
		nextSelection < 1 ifTrue: [nextSelection := 1]].
	asciiValue = 1 ifTrue:
		[" home"
		self resetListSelectionSilently.
		nextSelection := 1].
	asciiValue = 4 ifTrue:
		[" end"
		self resetListSelectionSilently.
		nextSelection := max].
	howManyItemsShowing := self numSelectionsInView.
	asciiValue = 11 ifTrue:
		[" page up"
		self resetListSelectionSilently.
		nextSelection := 1 max: oldSelection - howManyItemsShowing].
	asciiValue = 12 ifTrue:
		[" page down"
		self resetListSelectionSilently.
		nextSelection := oldSelection + howManyItemsShowing min: max].
	(self enabled and: [model okToChange]) ifFalse: [^ self].
	"No change if model is locked"
	oldSelection = nextSelection ifTrue: [^ self].
	^ self changeModelSelection: nextSelection! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/22/2007 14:48'!
themeChanged
	"Update the selection colour."

	self selectionColor ifNotNil: [
		self selectionColor: self theme selectionColor].
	super themeChanged! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/8/2009 13:25'!
updateEnabled
	"Update the enablement state."

	self model ifNotNil: [
		self getEnabledSelector ifNotNil: [
			self enabled: (self model perform: self getEnabledSelector)]]! !

!PluggableListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/19/2006 15:24'!
vExtraScrollRange
	"Return the amount of extra blank space to include below the bottom of the scroll content."

	^8
! !

PluggableListMorph subclass: #PluggableMorphListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PluggableMorphListMorph commentStamp: 'gvc 5/18/2007 12:30' prior: 0!
A type of PluggableListMorph that supports morphs for items. Useful for lists with icons etc.!

PluggableMorphListMorph subclass: #PluggableIconListMorph
	instanceVariableNames: 'getIconSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PluggableIconListMorph commentStamp: 'gvc 5/18/2007 12:31' prior: 0!
A type of PluggableListMorph that supports a single icon (Form) for items. Useful for lists with icons.!

!PluggableIconListMorph methodsFor: 'event' stamp: 'BenjaminVanRyseghem 8/23/2011 14:23'!
basicKeyPressed: aChar 
	
	aChar == Character space
		ifTrue: [ self interactWithSelectedItem ]
		ifFalse: [ super basicKeyPressed: aChar ]! !

!PluggableIconListMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:56'!
getIconSelector
	"Answer the value of getIconSelector"

	^ getIconSelector! !

!PluggableIconListMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:56'!
getIconSelector: anObject
	"Set the value of getIconSelector"

	getIconSelector := anObject! !

!PluggableIconListMorph methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 3/30/2011 10:40'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"

	getListSelector isNil ifTrue: [^#()].
	list := model perform: getListSelector.
	list isNil ifTrue: [^ #()].
	list := list collect: [ :item | self itemMorphFor: item].
	^list! !

!PluggableIconListMorph methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 3/30/2011 10:44'!
getListItem: index
	"get the index-th item in the displayed list"

	getListElementSelector ifNotNil: [
		^self itemMorphFor: (model perform: getListElementSelector with: index)].
	(list notNil and: [list size >= index]) ifTrue: [ ^list at: index ].
	^ self wrapItem: (self getList at: index)! !

!PluggableIconListMorph methodsFor: 'action' stamp: 'BenjaminVanRyseghem 8/23/2011 14:38'!
interactWithSelectedItem

	self selection
		ifNotNil: [: sel | sel submorphs do: [:each | each update: #interact ]]! !

!PluggableIconListMorph methodsFor: 'display' stamp: 'BenjaminVanRyseghem 9/7/2011 15:20'!
itemMorphFor: anObject
	"Answer a morph for the object with the appropriate icon."

	|item icon|
	item := IconicListItem new
		changeTableLayout;
		listDirection: #leftToRight;
		cellPositioning: #center;
		cellInset: 2;
		borderWidth: 0;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		originalObject: anObject;
		extent: 20@16.
	icon := self getIconSelector ifNotNil: [self model perform: self getIconSelector withEnoughArguments: {anObject}].
	icon ifNotNil: [
		item addMorphBack: icon asMorph].
	item addMorphBack: (StringMorph contents: (self wrapItem: anObject)).
	^item! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/1/2011 13:16'!
basicKeyPressed: aChar

	| oldSelection nextSelection max milliSeconds nextSelectionList nextSelectionText s|
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	
	self searchedElement: nil.
	
	max := self maximumSelection.
	milliSeconds := Time millisecondClockValue.
	milliSeconds - lastKeystrokeTime > 500 ifTrue: ["just use the one current character for selecting"
		lastKeystrokes := ''].
	lastKeystrokes := lastKeystrokes , aChar asLowercase asString.
	lastKeystrokeTime := milliSeconds.
	nextSelectionList := OrderedCollection newFrom: (list copyFrom: oldSelection + 1 to: max).
	nextSelectionList addAll: (list copyFrom: 1 to: oldSelection).
	"Get rid of blanks and style used in some lists"
	nextSelectionText := nextSelectionList detect: [:a |
		s := a userString ifNil: [(a submorphs collect: [:m | m userString]) detect: [:us | us notNil] ifNone: ['']].
		s withBlanksTrimmed asLowercase beginsWith: lastKeystrokes]
				ifNone: [^ self flash"match not found"].
	model okToChange ifFalse: [^ self].
	nextSelection := list findFirst: [:a |
		s := a userString ifNil: [(a submorphs collect: [:m | m userString]) detect: [:us | us notNil] ifNone: ['']].
		a == nextSelectionText].
	"No change if model is locked"
	oldSelection == nextSelection ifTrue: [^ self flash].
	
	self searchedElement: nextSelection.! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 14:23'!
extent: newExtent
	"Change listMorph's bounds to the new width. It is either the size
	of the widest list item, or the size of self, whatever is bigger"

	super extent: newExtent.
	self listMorph width: (self innerBounds width max: listMorph hUnadjustedScrollRange). 
! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/17/2008 12:38'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"

	getListSelector isNil ifTrue: [^#()].
	list := model perform: getListSelector.
	list isNil ifTrue: [^ #()].
	^list! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 14:26'!
getListItem: index
	"get the index-th item in the displayed list"

	getListElementSelector ifNotNil: [
		^model perform: getListElementSelector with: index].
	(list notNil and: [list size >= index]) ifTrue: [ ^list at: index ].
	^self getList at: index! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 14:24'!
hExtraScrollRange
	"Return the amount of extra blank space to include to the right of the scroll content."

	^12! !

!PluggableMorphListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2006 09:50'!
listMorphClass
	"Answer the class to use for the list morph."

	^LazyMorphListMorph! !

Slider subclass: #PluggableSliderMorph
	instanceVariableNames: 'getValueSelector getEnabledSelector enabled min max quantum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PluggableSliderMorph commentStamp: 'gvc 7/16/2007 13:57' prior: 0!
A pluggable slider (rather than one that auto-generates access selectors). Needs to be themed...!

PluggableSliderMorph subclass: #BracketSliderMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!BracketSliderMorph commentStamp: 'gvc 5/18/2007 13:39' prior: 0!
Abstract superclass for morphs that are used to select a component (R, G, B or A) of a colour.!

BracketSliderMorph subclass: #AColorSelectorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!AColorSelectorMorph commentStamp: 'gvc 5/18/2007 13:52' prior: 0!
ColorComponentSelector showing an alpha gradient over a hatched background.!

!AColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/3/2009 13:43'!
color: aColor
	"Set the gradient colors."
	
	super color: aColor asNontranslucentColor.
	self fillStyle: self defaultFillStyle! !

!AColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/3/2009 13:43'!
defaultFillStyle
	"Answer the hue gradient."

	^(GradientFillStyle colors: {self color alpha: 0. self color})
		origin: self topLeft;
		direction: (self bounds isWide
					ifTrue: [self width@0]
					ifFalse: [0@self height])! !

!AColorSelectorMorph methodsFor: 'drawing' stamp: 'gvc 9/19/2006 14:28'!
drawOn: aCanvas
	"Draw a hatch pattern first."

	aCanvas
		fillRectangle: self innerBounds
		fillStyle: (InfiniteForm with: self hatchForm).
	super drawOn: aCanvas
! !

!AColorSelectorMorph methodsFor: 'visual properties' stamp: 'gvc 9/19/2006 15:46'!
fillStyle: fillStyle
	"If it is a color then override with gradient."
	
	fillStyle isColor
		ifTrue: [self color: fillStyle]
		ifFalse: [super fillStyle: fillStyle]! !

!AColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:17'!
hatchForm
	"Answer a form showing a grid hatch pattern."

	^ColorPresenterMorph hatchForm! !

!AColorSelectorMorph methodsFor: 'initialization' stamp: 'gvc 9/26/2006 11:54'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		value: 1.0;
		color: Color black! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/3/2009 13:40'!
defaultFillStyle
	"Answer the defauolt fill style."

	^Color gray! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/3/2009 13:40'!
extent: aPoint
	"Update the gradient directions."

	super extent: aPoint.
	self updateFillStyle! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 16:05'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self fillStyle! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 14:06'!
gradient
	"Answer the gradient."

	self subclassResponsibility! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/3/2009 13:39'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		fillStyle: self defaultFillStyle;
		borderStyle: (BorderStyle inset baseColor: self paneColor; width: 1);
		sliderColor: Color black;
		clipSubmorphs: true! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 15:53'!
initializeSlider
	"Make the slider raised."
	
	slider :=( BracketMorph newBounds: self totalSliderArea)
		horizontal: self bounds isWide;
		color: self thumbColor;
		borderStyle: (BorderStyle raised baseColor: Color white; width: 1).
	sliderShadow := (BracketMorph newBounds: self totalSliderArea)
		horizontal: self bounds isWide;
		color: self pagingArea color;
		borderStyle: (BorderStyle inset baseColor: (Color white alpha: 0.6); width: 1).
	slider on: #mouseMove send: #scrollAbsolute: to: self.
	slider on: #mouseDown send: #mouseDownInSlider: to: self.
	slider on: #mouseUp send: #mouseUpInSlider: to: self.
	"(the shadow must have the pagingArea as its owner to highlight properly)"
	self pagingArea addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider.
	self computeSlider.
! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/3/2009 13:41'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Note: written so that #layoutBounds can be changed without touching this method"
	
	super layoutBounds: aRectangle.
	self updateFillStyle.
	slider horizontal: self bounds isWide.
	sliderShadow horizontal: self bounds isWide! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 11:34'!
roomToMove
	"Allow to run off the edges a bit."
	
	^self bounds isWide
		ifTrue: [self totalSliderArea insetBy: ((self sliderThickness // 2@0) negated corner: (self sliderThickness // 2 + 1)@0)]
		ifFalse: [self totalSliderArea insetBy: (0@(self sliderThickness // 2) negated corner: 0@(self sliderThickness // 2 - (self sliderThickness \\ 2) + 1))]! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:29'!
sliderColor: newColor
	"Set the slider colour."
	
	super sliderColor: (self enabled ifTrue: [Color black] ifFalse: [self sliderShadowColor]).
	slider ifNotNil: [slider borderStyle baseColor: Color white]! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 15:43'!
sliderShadowColor
	"Answer the color for the slider shadow."
	
	^Color black alpha: 0.6! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 12:02'!
sliderThickness
	"Answer the thickness of the slider."
	
	^((self bounds isWide
		ifTrue: [self height]
		ifFalse: [self width]) // 2 max: 8) // 2 * 2 + 1! !

!BracketSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/3/2009 13:41'!
updateFillStyle
	"Update the fill style directions."

	|b fs|
	fs := self fillStyle.
	fs isOrientedFill ifTrue: [
		b := self innerBounds.
		fs origin: b topLeft.
		fs direction: (b isWide
			ifTrue: [b width@0]
			ifFalse: [0@b height])]! !

BracketSliderMorph subclass: #HColorSelectorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!HColorSelectorMorph commentStamp: 'gvc 5/18/2007 12:58' prior: 0!
ColorComponentSelector showing a hue rainbow palette.!

!HColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 14:13'!
color: aColor
	"Ignore to preserve fill style."
	! !

!HColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/3/2009 13:44'!
defaultFillStyle
	"Answer the hue gradient."

	^(GradientFillStyle colors: ((0.0 to: 359.9 by: 0.1) collect: [:a | Color h: a s: 1.0 v: 1.0]))
		origin: self topLeft;
		direction: (self bounds isWide
					ifTrue: [self width@0]
					ifFalse: [0@self height])! !

!PluggableSliderMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:28'!
on: anObject getValue: getSel setValue: setSel
	"Answer a new instance of the receiver with
	the given selectors as the interface."

	^self new
		on: anObject
		getValue: getSel
		setValue: setSel! !

!PluggableSliderMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:27'!
on: anObject getValue: getSel setValue: setSel min: min max: max quantum: quantum
	"Answer a new instance of the receiver with
	the given selectors as the interface."

	^self new
		min: min;
		max: max;
		quantum: quantum;
		on: anObject
		getValue: getSel
		setValue: setSel! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:58'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self
		fillStyle: self fillStyleToUse;
		borderStyle: self borderStyleToUse;
		sliderColor: (self enabled
			ifTrue: [paneColor twiceDarker]
			ifFalse: [self paneColor twiceDarker paler])! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:25'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme sliderNormalBorderStyleFor: self]
		ifFalse: [self theme sliderDisabledBorderStyleFor: self]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 15:02'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^Color white! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:19'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:19'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/3/2007 15:19'!
enabled
	"Answer the value of enabled"

	^ enabled! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/3/2007 15:21'!
enabled: anObject
	"Set the value of enabled"

	enabled = anObject ifTrue: [^self].
	enabled := anObject.
	self changed: #enabled.
	self
		adoptPaneColor: self paneColor;
		changed! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:24'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme sliderNormalFillStyleFor: self]
		ifFalse: [self theme sliderDisabledFillStyleFor: self]! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2009 13:03'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/10/2009 13:32'!
getEnabledSelector: aSymbol
	"Set the value of getEnabledSelector"

	getEnabledSelector := aSymbol.
	self updateEnabled! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:31'!
getValueSelector
	"Answer the value of getValueSelector"

	^ getValueSelector! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:31'!
getValueSelector: anObject
	"Set the value of getValueSelector"

	getValueSelector := anObject! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:27'!
handlesMouseDown: evt
	"Answer true." 

	^true! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 13:14'!
initialize
	"Initialize the receiver."

	min := 0.
	max := 1.
	super initialize.
	self enabled: true! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 15:00'!
initializeSlider
	"Make the slider raised."
	
	super initializeSlider.
	slider borderStyle: (BorderStyle raised baseColor: slider color; width: 1)! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/3/2007 15:14'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Note: written so that #layoutBounds can be changed without touching this method"
	
	super layoutBounds: aRectangle.
	self computeSlider! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 10:43'!
max
	"Answer the value of max"

	^ max! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:21'!
max: anObject
	"Set the value of max"

	max := anObject.
	self setValue: self value! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 10:43'!
min
	"Answer the value of min"

	^ min! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:21'!
min: anObject
	"Set the value of min"

	min := anObject.
	self setValue: self value! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:32'!
minHeight
	"Answer the receiver's minimum height.
	Give it a bit of a chance..."
	
	^8 max: super minHeight! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 10:35'!
mouseDown: anEvent
	"Set the value directly."
	
	self enabled ifTrue: [
		self
			scrollPoint: anEvent;
			computeSlider].
	super mouseDown: anEvent.
	self enabled ifFalse: [^self].
	anEvent hand newMouseFocus: slider event: anEvent.
	slider
		mouseEnter: anEvent copy;
		mouseDown: anEvent copy
! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 10:36'!
mouseDownInSlider: event
	"Ignore if disabled."
	
	self enabled ifFalse: [^self].
	^super mouseDownInSlider: event! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:29'!
on: anObject getValue: getSel setValue: setSel
	"Use the given selectors as the interface."

	self
		model: anObject;
		getValueSelector: getSel;
		setValueSelector: setSel;
		updateValue! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:14'!
quantum
	"Answer the value of quantum"

	^ quantum! !

!PluggableSliderMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:20'!
quantum: anObject
	"Set the value of quantum"

	quantum := anObject.
	self setValue: self value! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:41'!
scaledValue
	"Answer the scaled value."

	|val|
	val := self value * (self max - self min) + self min.
	self quantum ifNotNil: [:q |
		val := val roundTo: q].
	^(val max: self min) min: self max! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:41'!
scaledValue: newValue
	"Set the scaled value."

	|val|
	val := newValue.
	self quantum ifNotNil: [:q |
		val := val roundTo: q].
	self value: newValue - self min / (self max - self min)! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 10:37'!
scrollAbsolute: event
	"Ignore if disabled."
	
	self enabled ifFalse: [^self].
	^super scrollAbsolute: event! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:28'!
scrollPoint: event
	"Scroll to the event position."
	
	| r p |
	r := self roomToMove.
	bounds isWide
		ifTrue: [r width = 0 ifTrue: [^ self]]
		ifFalse: [r height = 0 ifTrue: [^ self]].
	p := event position - (self sliderThickness // 2) adhereTo: r.
	self descending
		ifFalse:
			[self setValue: (bounds isWide 
				ifTrue: [(p x - r left) asFloat / r width]
				ifFalse: [(p y - r top) asFloat / r height])]
		ifTrue:
			[self setValue: (bounds isWide
				ifTrue: [(r right - p x) asFloat / r width]
				ifFalse:	[(r bottom - p y) asFloat / r height])]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:41'!
setValue: newValue
	"Called internally for propagation to model."

	|scaled|
	value := newValue.
	self scaledValue: (scaled := self scaledValue).
	self model ifNotNil: [
		self setValueSelector ifNotNil: [:sel |
			self model perform: sel with: scaled]]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:18'!
setValueSelector
	"Answer the set selector."
	
	^setValueSelector! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:31'!
setValueSelector: aSymbol
	"Directly set the selector to make more flexible."
	
	setValueSelector := aSymbol! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/20/2007 14:57'!
sliderColor: newColor
	"Set the slider colour."
	
	super sliderColor: newColor.
	slider ifNotNil: [slider borderStyle baseColor: newColor]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:05'!
update: aSymbol
	"Update the value."
	
	super update: aSymbol.
	aSymbol == self getEnabledSelector ifTrue: [
		^self updateEnabled].
	aSymbol = self getValueSelector ifTrue: [
		^self updateValue]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:06'!
updateEnabled
	"Update the enablement state."

	self model ifNotNil: [
		self getEnabledSelector ifNotNil: [
			self enabled: (self model perform: self getEnabledSelector)]]! !

!PluggableSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:00'!
updateValue
	"Update the value."
	
	self model ifNotNil: [
		self getValueSelector ifNotNil: [
			self scaledValue: (self model perform: self getValueSelector)]]! !

!CodeHolder methodsFor: '*Polymorph-Widgets' stamp: 'IgorStasenko 1/14/2011 12:25'!
addOptionalButtonsTo: window at: fractions plus: verticalOffset 
	"If the receiver wishes it, add a button pane to the window, and
	answer the verticalOffset plus the height added"
	| delta buttons divider |
	self wantsOptionalButtons
		ifFalse: [^ verticalOffset].
	buttons := self optionalButtonRow color: Color white.
	buttons  layoutInset: (0@0 corner: 0@4).
	buttons := OverflowRowMorph new
		baseMorph: buttons;
		height: buttons minExtent y;
		setNameTo: buttons assureExtension externalName.
	delta := buttons minExtent y + 2.
	divider := BorderedSubpaneDividerMorph forBottomEdge.
	divider extent: 4 @ 4;
				color: Color gray;
				borderColor: #simple;
				borderWidth: 0.
	window
		addMorph: buttons
		fullFrame: (LayoutFrame
				fractions: fractions
				offsets: (0 @ verticalOffset corner: 0 @ (verticalOffset + delta - 1))).
	window
		addMorph: divider
		fullFrame: (LayoutFrame
				fractions: fractions
				offsets: (0 @ (verticalOffset + delta - 1) corner: 0 @ (verticalOffset + delta))).
	^ verticalOffset + delta! !

!CodeHolder methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 09:43'!
codePaneProvenanceButton
	"Answer a button that reports on, and allow the user to modify,
	the code-pane-provenance setting"
	
	^(self theme  builder
		newDropListFor: self
		list: #codePaneProvenanceList
		getSelected: #codePaneProvenanceIndex
		setSelected: #codePaneProvenanceIndex:
		help: 'Select what is shown in the code pane' translated)
			cornerStyle: (self theme buttonCornerStyleIn: nil);
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			minWidth: 88! !

!CodeHolder methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 10:10'!
optionalButtonRow
	"Answer a row of control buttons"
	
	| buttons |
	buttons := OrderedCollection new.
	self optionalButtonPairs
		do: [:tuple |
			buttons add: ((PluggableButtonMorph
					on: self
					getState: nil
					action: tuple second)
				onColor: self class patchworkUIThemeColor  offColor: self class patchworkUIThemeColor darker darker;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				label: tuple first asString;
				setBalloonText: (tuple size > 2 ifTrue: [tuple third]);
				triggerOnMouseDown: (tuple size > 3
					ifTrue: [tuple fourth]
					ifFalse: [false]))].
	buttons add: self codePaneProvenanceButton.
	^(self theme builder newRow:  buttons)
		setNameTo: 'buttonPane';
		cellInset: 2! !

!GradientFillStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 12:22'!
= anGradientFillStyle
	"Answer whether equal."

	^super = anGradientFillStyle
		and: [self pixelRamp == anGradientFillStyle pixelRamp] "LRU should make identity equal"! !

!GradientFillStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 12:22'!
hash
	"Hash is implemented because #= is implemented."
	
	^super hash bitXor: self pixelRamp hash! !

StringMorph subclass: #EmbossedStringMorph
	instanceVariableNames: 'style trackPaneColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!EmbossedStringMorph commentStamp: 'gvc 5/18/2007 13:15' prior: 0!
A label that underdraws to the top-left and/or bottom-right with a lighter and/or darker colour to the receiver.!

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:53'!
adoptPaneColor: paneColor
	"Set the color."
	
	(paneColor notNil and: [self trackPaneColor])
		ifTrue: [self color: paneColor].
	super adoptPaneColor: paneColor! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 17:03'!
drawOn: aCanvas
	"Draw the hi/lowlights too."

	|box|
	self style == #plain
		ifTrue: [^super drawOn: aCanvas].
	box := self bounds.
	(self style == #inset or: [self style == #insetNoHighlight])
		ifTrue: [self style == #insetNoHighlight
					ifFalse: [aCanvas drawString: self contents in: (box translateBy: 1)
								font: self fontToUse color: self color veryMuchLighter].
				aCanvas
					drawString: self contents in: (box translateBy: -1)
					font: self fontToUse color: self color muchDarker;
					drawString: self contents in: box
					font: self fontToUse color: self color]
		ifFalse: [self style == #raisedNoHighlight
					ifFalse: [aCanvas drawString: self contents in: (box translateBy: -1)
								font: self fontToUse color: self color veryMuchLighter].
				aCanvas
					drawString: self contents in: (box translateBy: 1)
					font: self fontToUse color: self color muchDarker;
					drawString: self contents in: box
					font: self fontToUse color: self color]! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:55'!
initWithContents: aString font: aFont emphasis: emphasisCode
	"Grrr, why do they do basicNew?"
	
	super initWithContents: aString font: aFont emphasis: emphasisCode.
	self
		style: #inset;
		trackPaneColor: true.! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:52'!
initialize
	"Initialize the receiver."
	
	super initialize.
	self
		style: #inset;
		trackPaneColor: true! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 13:16'!
measureContents
	"Measure the contents for fitting. Add 2@2 for hi/lowlights."

	^super measureContents + 2! !

!EmbossedStringMorph methodsFor: 'accessing' stamp: 'gvc 4/27/2006 12:09'!
style
	"Answer the value of style"

	^ style! !

!EmbossedStringMorph methodsFor: 'accessing' stamp: 'gvc 5/10/2006 15:26'!
style: anObject
	"Set the value of style"

	style := anObject.
	self changed! !

!EmbossedStringMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 11:35'!
styleSymbols
	"Answer the valid styles."

	^#(plain inset insetNoHighlight raised raisedNoHighlight)! !

!EmbossedStringMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:52'!
trackPaneColor
	"Answer the value of trackPaneColor"

	^ trackPaneColor! !

!EmbossedStringMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 11:52'!
trackPaneColor: anObject
	"Set the value of trackPaneColor"

	trackPaneColor := anObject! !

StringMorph subclass: #LabelMorph
	instanceVariableNames: 'getEnabledSelector getTextSelector enabled model disabledStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!LabelMorph commentStamp: 'gvc 5/18/2007 12:48' prior: 0!
String morph with enablement support. When disabled the text will appear inset.!

LabelMorph subclass: #FuzzyLabelMorph
	instanceVariableNames: 'offset alpha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!FuzzyLabelMorph commentStamp: 'gvc 5/18/2007 13:16' prior: 0!
A label that underdraws to the top-left, top-right, bottom-right and bottom left by a specifed offset in a contrasting colour to the receiver's with a specified alpha value.!

!FuzzyLabelMorph methodsFor: 'accessing' stamp: 'gvc 3/26/2007 16:57'!
alpha
	"Answer the value of alpha"

	^ alpha! !

!FuzzyLabelMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 12:51'!
alpha: anObject
	"Set the value of alpha"

	alpha := anObject.
	self changed! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 3/24/2010 17:12'!
drawOn: aCanvas
	"Draw based on enablement."
	
	|pc fuzzColor labelColor|
	pc := self paneColor.
	labelColor := self enabled
		ifTrue: [self color]
		ifFalse: [pc twiceDarker].
	fuzzColor := self enabled
		ifTrue: [labelColor twiceDarker darker contrastingColor alpha: self 
alpha]
		ifFalse: [Color transparent].
	aCanvas depth < 8 ifTrue: [fuzzColor := Color transparent alpha: 0.001].
	fuzzColor isTransparent ifFalse: [
		aCanvas
			drawString: self contents
			in: (self bounds translateBy: 0 @ -1)
			font: self fontToUse
			color: fuzzColor;
			drawString: self contents
			in: (self bounds translateBy: (self offset * 2) @ -1)
			font: self fontToUse
			color: fuzzColor;
			drawString: self contents
			in: (self bounds translateBy: (self offset * 2) @ (self offset 
* 2 - 1))
			font: self fontToUse
			color: fuzzColor;
			drawString: self contents
			in: (self bounds translateBy: 0 @ (self offset * 2 - 1))
			font: self fontToUse
			color: fuzzColor].
	aCanvas
		drawString: self contents
		in: (self bounds translateBy: self offset @ (self offset - 1))
		font: self fontToUse
		color: labelColor! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 12:52'!
initWithContents: aString font: aFont emphasis: emphasisCode
	"Grrr, why do they do basicNew?"
	
	offset := 1.
	alpha := 0.5.
	super initWithContents: aString font: aFont emphasis: emphasisCode! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 12:52'!
initialize
	"Initialize the receiver."

	offset := 1.
	alpha := 0.5.
	super initialize! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/29/2007 17:02'!
measureContents
	"Add 2 times offset."
	
	^super measureContents ceiling + (self offset * 2) asPoint! !

!FuzzyLabelMorph methodsFor: 'accessing' stamp: 'gvc 3/16/2007 10:45'!
offset
	"Answer the value of offset"

	^ offset! !

!FuzzyLabelMorph methodsFor: 'accessing' stamp: 'gvc 8/9/2007 13:06'!
offset: anObject
	"Set the value of offset"

	offset := anObject.
	self fitContents! !

!FuzzyLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/29/2007 17:22'!
setWidth: width
	"Set the width/extent."
	
	self extent: width @ (self fontToUse height ceiling + (2 * self offset))! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:35'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:43'!
disabledStyle
	"Answer the value of disabledStyle"

	^ disabledStyle! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:53'!
disabledStyle: anObject
	"Set the value of disabledStyle"

	disabledStyle := anObject.
	self
		changed: #disabledStyle;
		changed! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/2/2009 13:59'!
drawOn: aCanvas
	"Draw based on enablement."
	
	|pc|
	pc := self owner
		ifNil: [self paneColor]
		ifNotNil: [self owner color isTransparent
					ifTrue: [self owner paneColor]
					ifFalse: [self owner color]].
	self enabled
		ifTrue: [aCanvas
					drawString: self contents
					in: self bounds
					font: self fontToUse
					color: self color]
		ifFalse: [self disabledStyle == #inset ifTrue: [
					aCanvas
						drawString: self contents
						in: (self bounds translateBy: 1)
						font: self fontToUse
						color: pc lighter;
						drawString: self contents
						in: self bounds
						font: self fontToUse
						color: pc muchDarker].
				self disabledStyle == #plain ifTrue: [	
					aCanvas
						drawString: self contents
						in: self bounds
						font: self fontToUse
						color: pc muchDarker]]! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:35'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 1/16/2007 15:28'!
enabled
	"Answer the value of enabled"

	^enabled! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 3/2/2010 17:23'!
enabled: aBoolean
	"Set the value of enabled"

	enabled == aBoolean ifFalse: [
		enabled := aBoolean.
		self
			changed: #enabled;
			changed]! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 15:28'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 15:27'!
getEnabledSelector: anObject
	"Set the value of getEnabledSelector"

	getEnabledSelector := anObject.
	self updateEnabled! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 7/30/2010 13:25'!
getTextSelector

	^ getTextSelector! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 7/30/2010 13:37'!
getTextSelector: aSymbol

	getTextSelector := aSymbol.
	self updateText! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:51'!
initWithContents: aString font: aFont emphasis: emphasisCode
	"Grrr, why do they do basicNew?"
	
	super initWithContents: aString font: aFont emphasis: emphasisCode.
	self
		disabledStyle: #plain;
		enabled: true! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:44'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		disabledStyle: #plain;
		enabled: true! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:16'!
interactionState: aSymbol
	"Backstop here to prevent 'legacy' color handling being applied from
	pluggable buttons."! !

!LabelMorph methodsFor: 'layout' stamp: 'gvc 6/15/2007 13:17'!
minHeight
	"Answer the receiver's minimum height.
	based on font height."
	
	^self fontToUse height rounded max: super minHeight! !

!LabelMorph methodsFor: 'layout' stamp: 'gvc 10/26/2007 21:15'!
minWidth
	"Answer the minmum width of the receiver.
	Based on font and contents."

	^self valueOfProperty: #minWidth ifAbsent: [self measureContents x] "allow override"! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 1/16/2007 15:52'!
model
	"Answer the value of model"

	^model! !

!LabelMorph methodsFor: 'accessing' stamp: 'gvc 1/16/2007 15:54'!
model: anObject
	"Set my model and make me me a dependent of the given object."

	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2010 13:25'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == self getEnabledSelector ifTrue:
		[self updateEnabled.
		^ self].
	aSymbol == self getTextSelector ifTrue:
		[self updateText.
		^ self]! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:25'!
updateEnabled
	"Update the enablement state."

	self model ifNotNil: [
		self getEnabledSelector ifNotNil: [
			self enabled: (self model perform: self getEnabledSelector)]]! !

!LabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2010 13:26'!
updateText
	"Update the text contents."

	self model ifNotNil: [
		self getTextSelector ifNotNil: [
			self contents: (self model perform: self getTextSelector)]]! !

LabelMorph subclass: #MultistateLabelMorph
	instanceVariableNames: 'colorMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!MultistateLabelMorph methodsFor: 'accessing' stamp: 'gvc 3/4/2010 15:19'!
colorMap
	"Answer the value of colorMap"

	^ colorMap! !

!MultistateLabelMorph methodsFor: 'accessing' stamp: 'gvc 3/4/2010 15:19'!
colorMap: anObject
	"Set the value of colorMap"

	colorMap := anObject! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:35'!
defaultColorMap
	"Answer the default colour map."

	|black grey|
	black := Color black.
	grey := Color gray.
	^Dictionary new
		at: #normal put: black;
		at: #mouseOver put: black;
		at: #pressed put: black;
		at: #disabled put: grey;
		at: #selected put: black;
		at: #selectedPressed put: black;
		at: #selectedMouseOver put: black;
		at: #selectedDisabled put: grey;
		yourself
		! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:40'!
disabledColor
	"Answer the disabled colour."

	^self colorMap at: #disabled! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:40'!
disabledColor: aColor
	"Set the disabled colour."

	self colorMap at: #disabled put: aColor! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:40'!
drawOn: aCanvas
	"Draw based on state."

	self enabled
		ifTrue: [aCanvas
					drawString: self contents
					in: self bounds
					font: self fontToUse
					color: self color]
		ifFalse: [self disabledStyle == #inset
					ifTrue: [aCanvas
							drawString: self contents
							in: (self bounds translateBy: 1)
							font: self fontToUse
							color: self disabledColor muchLighter;
							drawString: self contents
							in: self bounds
							font: self fontToUse
							color: self disabledColor]
					ifFalse: [aCanvas
								drawString: self contents
								in: self bounds
								font: self fontToUse
								color: self disabledColor]]! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:34'!
initWithContents: aString font: aFont emphasis: emphasisCode
	"Grrr, why do they do basicNew?"
	
	colorMap := self defaultColorMap.
	super initWithContents: aString font: aFont emphasis: emphasisCode! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:20'!
initialize
	"Set up a default colour map."

	colorMap := self defaultColorMap.
	super initialize! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:24'!
interactionState: aSymbol
	"Set the appropriate text colour."
	
	self color: (self colorMap at: aSymbol)! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:36'!
mouseOverColor: aColor
	"Set the mouseOver colour."

	self colorMap at: #mouseOver put: aColor! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:36'!
normalColor: aColor
	"Set the normal colour."

	self colorMap at: #normal put: aColor! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:37'!
pressedColor: aColor
	"Set the pressed colour."

	self colorMap at: #pressed put: aColor! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:37'!
selectedColor: aColor
	"Set the selected colour."

	self colorMap at: #selected put: aColor! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:38'!
selectedDisabledColor: aColor
	"Set the selectedDisabled colour."

	self colorMap at: #selectedDisabled put: aColor! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:37'!
selectedMouseOverColor: aColor
	"Set the selectedMouseOver colour."

	self colorMap at: #selectedMouseOver put: aColor! !

!MultistateLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 15:37'!
selectedPressedColor: aColor
	"Set the selectedPressed colour."

	self colorMap at: #selectedPressed put: aColor! !

LabelMorph subclass: #ShadowLabelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!ShadowLabelMorph methodsFor: 'drawing' stamp: 'StephaneDucasse 10/12/2010 12:58'!
drawOn: aCanvas
	"Draw based on enablement."
	
	|pc|
	pc := self owner
		ifNil: [self paneColor]
		ifNotNil: [self owner color isTransparent
					ifTrue: [self owner paneColor]
					ifFalse: [self owner color]].
	aCanvas
		drawString: self contents
		in: (self bounds translateBy: 1)
		font: self fontToUse
		color: pc lighter;
		drawString: self contents
		in: self bounds
		font: self fontToUse
		color: self color.! !

!StringMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 1/7/2010 22:42'!
handlesMouseDown: evt
	"If the shift key is pressed then yes.
	As normal if StringMorph class>> editableStringMorph  returns false."
	
	^ (self isEditable: evt)
		ifTrue: [true]
		ifFalse: [super handlesMouseDown: evt]! !

!StringMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 1/7/2010 22:43'!
isEditable: evt
	"If the shift key is pressed then yes.
	As normal if StringMorph class>> editableStringMorph  returns false."
	
	^(self class editableStringMorph and: [evt shiftPressed and: [self wantsKeyboardFocusOnShiftClick]])
! !

!StringMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/4/2007 12:24'!
measureContents
	"Round up in case fractional."
	
	| f |
	f := self fontToUse.
	^(((f widthOfString: contents) max: self minimumWidth)  @ f height) ceiling! !

!StringMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/15/2007 13:18'!
minHeight
	"Answer the minimum height of the receiver."
	
	^self fontToUse height max: super minHeight! !

!StringMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 1/7/2010 22:43'!
mouseDown: evt
	"If the shift key is pressed, make this string the keyboard input focus.
	Process as normal if StringMorph class>> editableStringMorph  returns false."

	(self isEditable: evt)
		ifTrue: [self launchMiniEditor: evt]
		ifFalse: [super mouseDown: evt].
! !

!StringMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/9/2007 12:29'!
paneColor
	"Answer the window's pane color or our owner's color otherwise."

	^self paneColorOrNil ifNil: [self owner ifNil: [Color transparent] ifNotNil: [self owner color]]! !

!StringMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/4/2007 12:24'!
setWidth: width
	"Round up in case fractional."
	
	self extent: (width @ (font ifNil: [TextStyle defaultFont]) height) ceiling! !

!MCTool methodsFor: '*Polymorph-Widgets-override' stamp: 'sd 6/5/2011 19:07'!
show
	"Open the tool returning the window."

	modal := false.
	^ (self window)
		openInWorldExtent: self defaultExtent;
		yourself! !

!MCTool methodsFor: '*Polymorph-Widgets-override' stamp: 'sd 6/5/2011 19:11'!
showLabelled: labelString
	
	modal := false.
	self label: labelString.
	^ (self window)
		openInWorldExtent: self defaultExtent;
		yourself! !

!MCTool methodsFor: '*Polymorph-Widgets-override' stamp: 'sd 6/5/2011 19:11'!
showModally
	| tb |
	modal := true.
	self window openInWorldExtent: 400 @ 400.
	[ self window world notNil ] whileTrue: [ self window outermostWorldMorph doOneCycle ].
	morph := nil.
	^ modalValue! !

!IconicButton methodsFor: '*Polymorph-Widgets-override' stamp: 'BenjaminVanRyseghem 4/12/2011 17:08'!
extraBorder

	^ 6! !

!IconicButton methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/29/2007 10:55'!
handlesMouseOver: anEvent
	"Answer true, otherwise what is all that
	#mouseEnter:/#mouseLeave: stuff about?"

	^true! !

!IconicButton methodsFor: '*Polymorph-Widgets-override' stamp: 'BenjaminVanRyseghem 4/12/2011 17:08'!
labelGraphic: aForm
	"Changed to look for any image morph rather than just a sketch."
	
	| oldLabel |
	graphicalMorph ifNotNil: [graphicalMorph delete].
	graphicalMorph := ImageMorph new image: aForm.
	self extent: graphicalMorph extent + (self borderWidth + self extraBorder).
	graphicalMorph position: self center - (graphicalMorph extent // 2).
	self addMorph: graphicalMorph.
	graphicalMorph lock! !

!IconicButton methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/21/2008 13:03'!
mouseDown: evt
	"Partial workaraound for broken MouseOverHandler.
	Remove the border on mouse down if mouse focus has changed."
	
	super mouseDown: evt.
	(actWhen == #buttonDown and: [(evt hand mouseFocus = self) not])
		ifTrue: [self mouseLeave: evt]! !

!IconicButton methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/23/2008 17:20'!
mouseEnter: evt
	"Remember the old border style."
	
	(self hasProperty: #oldBorder) ifFalse: [
		self setProperty: #oldBorder toValue: self borderStyle].
	self borderStyle: self mouseOverBorderStyle! !

!IconicButton methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 09:58'!
mouseLeave: evt
	"Reinstate the old border style."

	(self valueOfProperty: #oldBorder)
		ifNotNil: [:b |
			self borderStyle: b.
			self removeProperty: #oldBorder]
		ifNil: [self borderNormal]! !

!IconicButton methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/23/2008 17:19'!
mouseOverBorderStyle
	"Answer the border style to use whilst the mouse
	is over the receiver."

	^self valueOfProperty: #mouseOverBorderStyle ifAbsent: [BorderStyle thinGray]! !

!IconicButton methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/23/2008 17:19'!
mouseOverBorderStyle: aBorderStyle
	"Set the border style to use whilst the mouse
	is over the receiver."

	self setProperty: #mouseOverBorderStyle toValue: aBorderStyle! !

!HandMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 2/24/2009 10:36'!
fullDrawOn: aCanvas 
	"A HandMorph has unusual drawing requirements:
		1. the hand itself (i.e., the cursor) appears in front of its submorphs
		2. morphs being held by the hand cast a shadow on the world/morphs below
	The illusion is that the hand plucks up morphs and carries them above the world."

	"Note: This version caches an image of the morphs being held by the hand for
	 better performance. This cache is invalidated if one of those morphs changes."

	| disableCaching subBnds roundCorners rounded |
	self visible ifFalse: [^self].
	(aCanvas isVisible: self fullBounds) ifFalse: [^self].
	disableCaching := false.
	disableCaching 
		ifTrue: 
			[self nonCachingFullDrawOn: aCanvas.
			^self].
	submorphs isEmpty 
		ifTrue: 
			[cacheCanvas := nil.
			^self drawOn: aCanvas].	"just draw the hand itself"
	subBnds := Rectangle merging: (submorphs collect: [:m | m fullBounds]).
	self updateCacheCanvas: aCanvas.
	(cacheCanvas isNil 
		or: [cachedCanvasHasHoles and: [cacheCanvas depth = 1]]) 
			ifTrue: 
				["could not use caching due to translucency; do full draw"

				self nonCachingFullDrawOn: aCanvas.
				^self].

	"--> begin rounded corners hack <---"
	roundCorners := cachedCanvasHasHoles == false 
				and: [submorphs size = 1 and: [submorphs first wantsRoundedCorners]].
	roundCorners 
		ifTrue: 
			[rounded := submorphs first.
			aCanvas asShadowDrawingCanvas translateBy: self shadowOffset
				during: 
					[:shadowCanvas | 
					shadowCanvas roundCornersOf: rounded
						during: 
							[(subBnds areasOutside: (rounded boundsWithinCorners 
										translateBy: self shadowOffset negated)) 
								do: [:r | shadowCanvas fillRectangle: r color: Color black]]].
			aCanvas roundCornersOf: rounded
				during: 
					[aCanvas 
						drawImage: cacheCanvas form
						at: subBnds origin
						sourceRect: cacheCanvas form boundingBox].
			^self drawOn: aCanvas	"draw the hand itself in front of morphs"].
	"--> end rounded corners hack <---"

	"draw the shadow"
	(submorphs anySatisfy: [:m | m handlesDropShadowInHand not]) ifTrue: [
		aCanvas asShadowDrawingCanvas translateBy: self shadowOffset
		during: 
			[:shadowCanvas | 
			cachedCanvasHasHoles 
				ifTrue: 
					["Have to draw the real shadow of the form"

					shadowCanvas paintImage: cacheCanvas form at: subBnds origin]
				ifFalse: 
					["Much faster if only have to shade the edge of a solid rectangle"

					(subBnds areasOutside: (subBnds translateBy: self shadowOffset negated)) 
						do: [:r | shadowCanvas fillRectangle: r color: Color black]]]].

	"draw morphs in front of the shadow using the cached Form"
	aCanvas translucentImage: cacheCanvas form at: subBnds origin.
	self drawOn: aCanvas	"draw the hand itself in front of morphs"! !

AlignmentMorph subclass: #PluggablePanelMorph
	instanceVariableNames: 'model getChildrenSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PluggablePanelMorph commentStamp: 'ar 2/11/2005 20:13' prior: 0!
A pluggable panel morph which deals with changing children.!

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:47'!
getChildrenSelector
	^getChildrenSelector! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:47'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol.! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:48'!
model
	^model! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:48'!
model: aModel
	model ifNotNil:[model removeDependent: self].
	model := aModel.
	model ifNotNil:[model addDependent: self].! !

!PluggablePanelMorph methodsFor: 'update' stamp: 'marcus.denker 9/14/2008 18:59'!
update: what
	what ifNil: [^self].
	what == getChildrenSelector ifTrue:[
		self removeAllMorphs.
		self addAllMorphs: (model perform: getChildrenSelector).
		self submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].! !

!TextMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'MarcusDenker 4/12/2011 17:43'!
drawNullTextOn: aCanvas
	"Make null text frame visible.
	Nicer if not shaded!!"

	aCanvas fillRectangle: bounds color: (self backgroundColor ifNil: [Color transparent])! !

!TextMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'AlainPlantec 10/25/2010 17:09'!
drawOn: aCanvas
	"Draw the receiver on a canvas.
	Draw keyboard focus if appropriate."

	| fauxBounds |
	self setDefaultContentsIfNil.
	super drawOn: aCanvas.  "Border and background if any"
	false ifTrue: [self debugDrawLineRectsOn: aCanvas].  "show line rects for debugging"
	(self startingIndex > text size)
		ifTrue: [self drawNullTextOn: aCanvas].
	"Hack here:  The canvas expects bounds to carry the location of the text, but we also need to communicate clipping."
	fauxBounds := self bounds topLeft corner: self innerBounds bottomRight.
	aCanvas paragraph: self paragraph bounds: fauxBounds color: color.! !

!TextMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'AlainPlantec 12/27/2010 21:22'!
keyboardFocusChange: aBoolean 	
	| w ptm |	
	paragraph isNil ifFalse:[paragraph focused: aBoolean].	
	aBoolean 
		ifTrue:["A hand is wanting to send us characters..."
			self hasFocus ifFalse: [self editor	"Forces install"].
			Editor blinkingCursor 
				ifTrue: [self startBlinking].
			self showOverEditableTextCursor] 
		ifFalse:["A hand has clicked elsewhere..."		
			(w := self world) 
				ifNotNil:[w handsDo: [:h | h keyboardFocus == self ifTrue: [^self]].
					"Release control unless some hand is still holding on"			
					self releaseEditor].
			self hideOverEditableTextCursor.
			self stopBlinking].
	self focusChanged! !

!TextMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 9/15/2011 17:27'!
optimalExtent
	"Create a new paragraph and answer its extent."
	
	^(Paragraph new
		compose: text
		style: textStyle copy
		from: 1
		in: (0@0 extent: 9999999@9999999);
		adjustRightX;
		extent) + (self borderWidth * 2) + (2@0) "FreeType kerning allowance"! !

!TextMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/23/2006 14:48'!
overrideExtent: newExtent
	"If autoFit is on then override to false for the duration of the extent call."
	
	self isAutoFit
		ifTrue: [self
				setProperty: #autoFitContents toValue: false;
				extent: newExtent;
				setProperty: #autoFitContents toValue: true]! !

!TextMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/5/2007 16:12'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!TextMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/5/2007 16:14'!
wantsKeyboardFocusNavigation
	"Answer whether the receiver wants to be navigated to.
	Answer false here (use PluggableTextMorph instead)."

	^false! !

!TextMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 7/30/2007 14:55'!
yellowButtonActivity: shiftKeyState 
	"Invoke the text-editing menu.
	Check if required first!!"
	
	| menu |
	self wantsYellowButtonMenu
		ifFalse: [^self].
	(menu := self getMenu: shiftKeyState)
		ifNotNil: [""
			menu setInvokingView: self editor.
			menu invokeModal. self changed]! !

MorphicModel subclass: #CheckboxMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: 'buttonMorph labelMorph setStateSelector getStateSelector enabled getEnabledSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!CheckboxMorph commentStamp: 'gvc 5/18/2007 13:47' prior: 0!
Checkbox with box button and label with enablement support.!

CheckboxMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

!CheckboxMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 16:50'!
on: anObject selected: getSelectionSel changeSelected: setSelectionSel
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."

	^self new
		on: anObject 
		selected: getSelectionSel
		changeSelected: setSelectionSel! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:38'!
beCheckbox
	"Change the button to be a checkbox."
	
	self buttonMorph beCheckbox! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:38'!
beRadioButton
	"Change the button to be a radio button."
	
	self buttonMorph beRadioButton! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 14:49'!
buttonMorph
	"Answer the value of buttonMorph"

	^ buttonMorph! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:11'!
buttonMorph: aMorph
	"Set the value of buttonMorph"

	buttonMorph ifNotNil: [
		self removeDependent: buttonMorph.
		buttonMorph delete].
	buttonMorph := aMorph.
	self
		addDependent: aMorph;
		addMorphFront: aMorph! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 11:38'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!CheckboxMorph methodsFor: 'drawing' stamp: 'gvc 5/22/2007 16:04'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 11:38'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 14:49'!
enabled
	"Answer the value of enabled"

	^ enabled! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'MarcusDenker 12/11/2009 07:42'!
enabled: aBoolean
	"Set the value of enabled"

	enabled := aBoolean.
	self labelMorph ifNotNil: [:m |
		(m respondsTo: #enabled:) ifTrue: [
			m enabled: aBoolean]].
	self buttonMorph ifNotNil: [:m | m enabled: aBoolean].
	self changed: #enabled! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:58'!
font
	"Answer the label font"

	^self labelMorph font! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:58'!
font: aFont
	"Set the label font"

	self labelMorph font: aFont! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:05'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 18:01'!
getEnabledSelector: anObject
	"Set the value of getEnabledSelector"

	getEnabledSelector := anObject.
	self updateEnabled! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 14:49'!
getStateSelector
	"Answer the value of getStateSelector"

	^ getStateSelector! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 18:02'!
getStateSelector: anObject
	"Set the value of getStateSelector"

	getStateSelector := anObject.
	self updateSelection! !

!CheckboxMorph methodsFor: 'event handling' stamp: 'gvc 1/16/2007 15:20'!
handlesKeyboard: evt
	"Yes, we do it here."
	
	^true! !

!CheckboxMorph methodsFor: 'initialization' stamp: 'gvc 8/2/2007 16:11'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 2; "space for focus"
		borderColor: Color transparent;
		enabled: true;
		changeTableLayout;
		listDirection: #leftToRight;
		wrapCentering: #center;
		cellInset: 8;
		buttonMorph: self newButtonMorph;
		labelMorph: self newLabelMorph;
		on: #mouseDown send: #updateButton: to: self;
		on: #mouseMove send: #updateButton: to: self;
		on: #mouseUp send: #updateButton: to: self! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 15:14'!
isSelected
	"Answer whether the receiver is selected."

	self model ifNil: [^false].
	^self model perform: (self getStateSelector ifNil: [^false])! !

!CheckboxMorph methodsFor: 'event handling' stamp: 'gvc 5/22/2007 16:11'!
keyStroke: event 
	"Process keys navigation and space to toggle."
	
	(self navigationKey: event) ifTrue: [^self].
	event keyCharacter = Character space
		ifTrue: [self toggleSelected]! !

!CheckboxMorph methodsFor: 'event handling' stamp: 'gvc 9/6/2007 14:37'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self focusChanged! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:14'!
label
	"Answer the contents of the label morph."

	^(self labelMorph ifNil: [^'']) contents! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:13'!
label: aString
	"Set the contents of the label morph."

	self labelMorph contents: aString.
	self labelMorph: self newLabel! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 14:49'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/2/2007 16:09'!
labelMorph: aMorph
	"Set the value of labelMorph"

	labelMorph ifNotNil: [labelMorph delete].
	labelMorph := aMorph.
	self addMorphBack: aMorph! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/17/2006 18:03'!
newButtonMorph
	"Answer a new button morph"

	^CheckboxButtonMorph new
		target: self;
		actionSelector: #toggleSelected;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:13'!
newLabel
	"Answer a new label morph"

	^self theme checkboxLabelFor: self! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 16:14'!
newLabelMorph
	"Answer a new label morph"

	^self theme checkboxLabelFor: self! !

!CheckboxMorph methodsFor: 'initialization' stamp: 'gvc 8/17/2006 18:01'!
on: anObject selected: getSelectionSel changeSelected: setSelectionSel
	"Set the receiver to the given model parameterized by the given message selectors."

	self
		model: anObject;
		getStateSelector: getSelectionSel;
		setStateSelector: setSelectionSel;
		updateSelection! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:00'!
setStateSelector
	"Answer the value of setStateSelector"

	^ setStateSelector! !

!CheckboxMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:00'!
setStateSelector: anObject
	"Set the value of setStateSelector"

	setStateSelector := anObject! !

!CheckboxMorph methodsFor: 'focus handling' stamp: 'gvc 1/11/2007 12:28'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!CheckboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/25/2006 14:35'!
toggleSelected
	"Toggle the selection state."

	self enabled ifFalse: [^self].
	self model ifNil: [^self].
	(self setStateSelector ifNil: [^self]) numArgs = 0
		ifTrue: [self model perform: self setStateSelector].
	self setStateSelector numArgs = 1
		ifTrue: [	self model perform: self setStateSelector with: self isSelected not].
	self updateSelection
	! !

!CheckboxMorph methodsFor: 'updating' stamp: 'gvc 8/17/2006 17:58'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == self getStateSelector ifTrue: 
		[self updateSelection.
		^ self].
	aSymbol == self getEnabledSelector ifTrue:
		[self updateEnabled.
		^ self]! !

!CheckboxMorph methodsFor: 'updating' stamp: 'gvc 8/17/2006 18:06'!
updateButton: evt
	"Update the button due to mouse activity in the receiver."

	self enabled ifFalse: [^self].
	evt isMouseDown ifTrue: [
		self buttonMorph state == #on ifTrue: [^self buttonMorph state: #repressed].
		self buttonMorph state == #off ifTrue: [^self buttonMorph state: #pressed]].
	evt isMouseUp ifTrue: [
		self buttonMorph state == #repressed ifTrue: [
			^self buttonMorph state: #off; doButtonAction].
		self buttonMorph state == #pressed ifTrue: [
			^self buttonMorph state: #on; doButtonAction]].
	evt isMove ifTrue: [
		(self containsPoint: evt cursorPoint)
			ifTrue: [self buttonMorph state == #on ifTrue: [^self buttonMorph state: #repressed].
					self buttonMorph state == #off ifTrue: [^self buttonMorph state: #pressed]]
			ifFalse: [self buttonMorph state == #repressed ifTrue: [^self buttonMorph state: #on].
					self buttonMorph state == #pressed ifTrue: [^self buttonMorph state: #off]]]! !

!CheckboxMorph methodsFor: 'updating' stamp: 'gvc 9/8/2009 13:25'!
updateEnabled
	"Update the enablement state."

	self model ifNotNil: [
		self getEnabledSelector ifNotNil: [
			self enabled: (self model perform: self getEnabledSelector)]]! !

!CheckboxMorph methodsFor: 'updating' stamp: 'MarcusDenker 12/11/2009 07:38'!
updateSelection
	"Update the selection state."

	self buttonMorph ifNotNil: [:m | m selected: self isSelected].
	self changed: #isSelected! !

CheckboxMorph subclass: #TickSelectionCheckboxMorph
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TickSelectionCheckboxMorph commentStamp: '<historical>' prior: 0!
A TickSelectionCheckboxMorph is a checkbox which propagate a bit more the events!

!TickSelectionCheckboxMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:30'!
index: anIndex

	index := anIndex! !

!TickSelectionCheckboxMorph methodsFor: 'morph' stamp: 'BenjaminVanRyseghem 9/17/2011 05:10'!
newButtonMorph
	"Answer a new button morph"

	| instance |
	instance := TickSelectionCheckboxButtonMorph new
		target: self;
		actionSelector: #toggleSelected;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap.
		
	instance index: index.
	^ instance! !

!TickSelectionCheckboxMorph methodsFor: 'event' stamp: 'BenjaminVanRyseghem 9/17/2011 05:08'!
pressed: anIndex

	self owner owner pressed: anIndex! !

MorphicModel subclass: #ColorPresenterMorph
	instanceVariableNames: 'contentMorph labelMorph solidLabelMorph getColorSelector'
	classVariableNames: 'HatchForm'
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ColorPresenterMorph commentStamp: 'gvc 5/18/2007 13:38' prior: 0!
Displays a colour with alpha against a white, hatched and black background.!

ColorPresenterMorph subclass: #ColorChooserMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: 'setColorSelector enabled getEnabledSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ColorChooserMorph commentStamp: 'gvc 5/18/2007 13:45' prior: 0!
ColorPresenter that opens a colour selector when clicked.!

ColorChooserMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

!ColorChooserMorph class methodsFor: 'instance creation' stamp: 'StephaneDucasse 3/3/2010 16:14'!
on: anObject color: getSel changeColor: setSel
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."
	"(ColorChooserMorph on: (BorderedMorph new) color: #color changeColor: #color:) openInWorld"
	^self new
		on: anObject 
		color: getSel
		changeColor: setSel! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:03'!
chooseColor
	"Popup the color picker for now."

	|newColor|
	newColor := self theme
		chooseColorIn: ((self ownerThatIsA: SystemWindow) ifNil: [self])
		title: 'Choose Color'
		color: self labelMorph color.
	newColor ifNil: [^self].
	self labelMorph color: newColor.
	self solidLabelMorph color: newColor asNontranslucentColor.
	self setColorSelector ifNotNil: [self model perform: self setColorSelector with: newColor]! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:46'!
enabled
	"Answer the enabled state of the receiver."
	
	^enabled! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:38'!
enabled: aBoolean
	"Set the enabled state of the receiver."

	enabled := aBoolean.
	self contentMorph ifNotNil: [:m | m enabled: aBoolean].
	self changed: #enabled! !

!ColorChooserMorph methodsFor: 'accessing' stamp: 'gvc 10/12/2006 13:47'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!ColorChooserMorph methodsFor: 'accessing' stamp: 'gvc 10/12/2006 13:51'!
getEnabledSelector: anObject
	"Set the value of getEnabledSelector"

	getEnabledSelector := anObject.
	self updateEnabled! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:44'!
initialize
	"Initialize the receiver."

	enabled := true.
	super initialize! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 12/8/2008 19:40'!
newContentMorph
	"Answer a new button morph"

	|b|
	b := (self theme
		newButtonIn: self
		for: self
		getState: nil
		action: #chooseColor
		arguments: #()
		getEnabled: #enabled
		label: (self newHatchMorph layoutInset: 2)
		help: nil)
		hResizing: #spaceFill.
	b contentHolder hResizing: #spaceFill.
	^b! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:46'!
on: anObject color: getColSel changeColor: setColSel
	"Set the receiver to the given model parameterized by the given message selectors."

	self
		on: anObject color: getColSel;
		setColorSelector: setColSel! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/14/2009 18:41'!
setColorSelector
	"Answer the value of setColorSelector"

	^ setColorSelector! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/14/2009 18:41'!
setColorSelector: anObject
	"Set the value of setColorSelector"

	setColorSelector := anObject! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:51'!
update: aSymbol 
	"Refer to the comment in View|update:."

	super update: aSymbol.
	aSymbol == self getEnabledSelector ifTrue: 
		[self updateEnabled.
		^ self]! !

!ColorChooserMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:25'!
updateEnabled
	"Update the enablement state."

	self model ifNotNil: [
		self getEnabledSelector ifNotNil: [
			self enabled: (self model perform: self getEnabledSelector)]]! !

!ColorPresenterMorph class methodsFor: 'graphics constants' stamp: 'gvc 9/18/2006 16:05'!
hatchForm
	"Answer a form showing a grid hatch pattern."

	^HatchForm ifNil: [HatchForm := self newHatchForm]! !

!ColorPresenterMorph class methodsFor: 'graphics constants' stamp: 'gvc 9/18/2006 16:24'!
newHatchForm
	"Answer a new hatch form."
	
	^(Form
	extent: 8@8
	depth: 1
	fromArray: #( 4026531840 4026531840 4026531840 4026531840 251658240 251658240 251658240 251658240)
	offset: 0@0)! !

!ColorPresenterMorph class methodsFor: 'instance creation' stamp: 'StephaneDucasse 3/3/2010 16:12'!
on: anObject color: getSel
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."
	
	"(ColorPresenterMorph on: (BorderedMorph new) color: #color) openInWorld"
	
	^self new
		on: anObject 
		color: getSel! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/22/2006 09:25'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/22/2006 09:25'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
getColorSelector
	"Answer the value of getColorSelector"

	^ getColorSelector! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
getColorSelector: anObject
	"Set the value of getColorSelector"

	getColorSelector := anObject! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 16:04'!
hatchForm
	"Answer a form showing a grid hatch pattern."

	^self class hatchForm! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:34'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 0;
		changeTableLayout;
		labelMorph: self newLabelMorph;
		solidLabelMorph: self newLabelMorph;
		contentMorph: self newContentMorph;
		addMorphBack: self contentMorph! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 15:48'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:23'!
newContentMorph
	"Answer a new content morph"

	^Morph new
		color: Color transparent;
		changeTableLayout;
		borderStyle: (BorderStyle inset width: 1);
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		addMorph: self newHatchMorph;
		yourself! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 12/8/2008 19:40'!
newHatchMorph
	"Answer a new morph showing a grid hatch pattern."

	^Morph new
		color: Color transparent;
		changeProportionalLayout;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		minWidth: 48;
		minHeight: 12;
		addMorph: (Morph new color: Color white)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 0.3@1));
		addMorph: (Morph new fillStyle: (InfiniteForm with: self hatchForm))
		fullFrame: (LayoutFrame fractions: (0.3@0 corner: 0.7@1));
		addMorph: self solidLabelMorph
		fullFrame: (LayoutFrame fractions: (0.7@0 corner: 1@1));
		addMorph: self labelMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1))! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 16:20'!
newLabelMorph
	"Answer a new label morph"

	^Morph new! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:45'!
on: anObject color: getColSel
	"Set the receiver to the given model parameterized by the given message selectors."

	self
		model: anObject;
		getColorSelector: getColSel;
		updateColor! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/3/2009 18:14'!
setColor: aColor
	"Update the colour of the labels."

	self labelMorph color: aColor.
	self solidLabelMorph color: aColor asNontranslucentColor! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 16:17'!
solidLabelMorph
	"Answer the value of solidLabelMorph"

	^ solidLabelMorph! !

!ColorPresenterMorph methodsFor: 'accessing' stamp: 'gvc 9/18/2006 16:17'!
solidLabelMorph: anObject
	"Set the value of solidLabelMorph"

	solidLabelMorph := anObject! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:34'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == self getColorSelector ifTrue: 
		[self updateColor.
		^ self]! !

!ColorPresenterMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 18:36'!
updateColor
	"Update the color state."

	|col|
	self getColorSelector ifNotNil: [
		col := (self model perform: self getColorSelector) ifNil: [Color transparent].
		self setColor: col]! !

MorphicModel subclass: #ComposableMorph
	uses: TEasilyThemed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ComposableMorph commentStamp: 'gvc 5/18/2007 13:32' prior: 0!
Morph with an inset border by default and theme access.!

ComposableMorph class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

!ComposableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 09:39'!
defaultBorderColor
	"Answer the default border color/fill style for the receiver"
	
	^#inset! !

!ComposableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 09:39'!
defaultBorderWidth
	"Answer the default border width for the receiver."
	
	^ 1! !

!ComposableMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/29/2006 18:25'!
defaultTitle
	"Answer the default title label for the receiver."

	^'Composite' translated! !

!ComposableMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/7/2010 21:12'!
newWindow
	"Answer a new window with the receiver as model,
	except when the receiver is a morph."

	|w|
	w := StandardWindow new
		model: (self isMorph ifFalse: [self]);
		title: self defaultTitle;
		addMorph: self
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1));
		yourself.
	self
		borderWidth: 0.
	^w! !

MorphicModel subclass: #DropListMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: 'contentMorph listMorph buttonMorph list listSelectionIndex getListSelector getIndexSelector setIndexSelector getEnabledSelector enabled useSelectionIndex selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!DropListMorph commentStamp: 'gvc 5/23/2007 14:12' prior: 0!
Displays a selected item and a drop button. When pressed will popup a list to enable changing of the selection. Supports enablement.!

DropListMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

!DropListMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 7/17/2006 12:25'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."

	^self new
		on: anObject 
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel! !

!DropListMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 16:05'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel useIndex: useIndex
	"Answer a new instance of the receiver on the given model using
	the given selectors as the interface."

	^self new
		useSelectionIndex: useIndex;
		on: anObject 
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/22/2009 15:35'!
adoptPaneColor: paneColor
	"Pass on to the list morph and border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self borderWidth > 0 ifTrue: [
		self borderStyle: self borderStyleToUse].
	self buttonMorph cornerStyle: self cornerStyle.
	self updateContentColor: paneColor.
	self listPaneColor: paneColor.
	self changed: #buttonLabel! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:04'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme dropListNormalBorderStyleFor: self]
		ifFalse: [self theme dropListDisabledBorderStyleFor: self]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/23/2009 13:12'!
buttonExtent
	"Answer based on theme and preferences."
	
	^self buttonWidth @ self buttonHeight! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/23/2009 13:12'!
buttonHeight
	"Answer based on theme."
	
	^self theme buttonMinHeight! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/1/2009 11:40'!
buttonLabel
	"Answer the label for the button."

	^self theme dropListButtonLabelFor: self! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/22/2006 13:25'!
buttonMorph
	"Answer the value of buttonMorph"

	^ buttonMorph! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/22/2006 13:25'!
buttonMorph: anObject
	"Set the value of buttonMorph"

	buttonMorph := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/17/2009 14:34'!
buttonWidth
	"Answer based on scrollbar size."
	
	^ (self theme scrollbarThickness + 3)
		max: self theme dropListControlButtonWidth! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 6/17/2006 11:45'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 6/17/2006 11:45'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/18/2010 17:34'!
cornerStyle: aSymbol
	"Update the layout inset too."

	super cornerStyle: aSymbol.
	self layoutInset: self layoutInsetToUse.
	self buttonMorph cornerStyle: self cornerStyle.
	self fillStyle: self fillStyleToUse! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:17'!
defaultColor
	"Answer the default color of the receiver."

	^Color white! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 12:18'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 15:16'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [
		self drawKeyboardFocusOn: aCanvas]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 12:18'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/14/2006 13:18'!
enabled
	"Answer the value of enabled"

	^ enabled! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 9/1/2006 15:57'!
enabled: anObject
	"Set the value of enabled"

	enabled = anObject ifTrue: [^self].
	enabled := anObject.
	anObject ifFalse: [self hideList].
	self changed: #enabled.
	self
		adoptPaneColor: self paneColor;
		changed! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:04'!
extent: newExtent
	"Update the gradient."
	
	super extent: newExtent.
	(self fillStyle notNil and: [self fillStyle isSolidFill not])
		ifTrue: [self fillStyle: self fillStyleToUse]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:03'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme dropListNormalFillStyleFor: self]
		ifFalse: [self theme dropListDisabledFillStyleFor: self]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/20/2009 16:38'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^self theme dropListFocusBoundsFor: self! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/20/2009 16:40'!
focusIndicatorCornerRadius
	"Answer the corner radius preferred for the focus indicator
	for the receiver for themes that support this."

	^self theme dropListFocusIndicatorCornerRadiusFor: self ! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 15:07'!
font
	"Answer the list font"

	^self listMorph font! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 12:34'!
font: aFont
	"Set the list and content font"

	self listMorph font: aFont.
	self contentMorph beAllFont: aFont! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/3/2011 16:40'!
getCurrentSelection
	"Answer the current selection from the model."

	|mySelection|
	mySelection := self model perform: self getIndexSelector.
	^(self list includes: mySelection)
		ifTrue: [mySelection]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/17/2006 12:30'!
getCurrentSelectionIndex
	"Answer the index of the current selection."

	self getIndexSelector ifNil: [^0].
	^self model perform: self getIndexSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/14/2006 13:16'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/14/2006 13:30'!
getEnabledSelector: anObject
	"Set the value of getEnabledSelector"

	getEnabledSelector := anObject.
	self updateEnabled! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
getIndexSelector
	"Answer the value of getIndexSelector"

	^ getIndexSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
getIndexSelector: anObject
	"Set the value of getIndexSelector"

	getIndexSelector := anObject! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
getListSelector
	"Answer the value of getListSelector"

	^ getListSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
getListSelector: anObject
	"Set the value of getListSelector"

	getListSelector := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 11:30'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event."
	
	^true! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 11/25/2010 16:00'!
hideList
	"Hide the list."

	self listMorph ifNil: [^self].
	self listVisible ifFalse: [^self].
	self listMorph delete.
	self listMorph selectionIndex = self listSelectionIndex
		ifFalse: [self listMorph changeModelSelection: self listMorph selectionIndex].
	self roundedCorners: #(1 2 3 4).
	(self buttonMorph ifNil: [^self]) roundedCorners: (self roundedCorners copyWithoutAll: #(1 2)).
	self fillStyle: self fillStyleToUse.
	self wantsKeyboardFocus
		ifTrue: [self takeKeyboardFocus]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/18/2010 18:17'!
initialize
	"Initialize the receiver."

	super initialize.
	listSelectionIndex := 0.
	enabled := true.
	list := #().
	self
		useSelectionIndex: true;
		clipSubmorphs: true;
		layoutPolicy: RowLayout new;
		layoutInset: self layoutInsetToUse;
		cellPositioning: #center;
		listMorph: self newListMorph;
		contentMorph: self newContentMorph;
		buttonMorph: self newButtonMorph;
		fillStyle: self fillStyleToUse;
		borderStyle: self borderStyleToUse;
		addMorphBack: self contentMorph;
		addMorphBack: (self addDependent: self buttonMorph);
		on: #mouseDown send: #popList to: self.
	self listMorph fillStyle: (self theme dropListNormalListFillStyleFor: self)! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 06:51'!
keyStroke: event
	"Pass on to the list."
	
	(self navigationKey: event) ifTrue: [^self].
	self listMorph keyStroke: event ! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2007 14:37'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self focusChanged! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/18/2010 17:33'!
layoutInsetToUse
	"Answer the layout inset that should be used."

	^self theme dropListInsetFor: self! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/4/2011 12:27'!
list
	"Answer the list contents."
	^list! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/4/2011 12:28'!
list: aCollection
	"Set the list contents."

	list := aCollection.
	self changed: #list! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/29/2006 12:16'!
listHeight
	"Answer the height for the list."

	^(self listMorph listMorph height + 6 max: 38) min: 200! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 6/17/2006 11:07'!
listMorph
	"Answer the value of listMorph"

	^ listMorph! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 6/17/2006 11:07'!
listMorph: anObject
	"Set the value of listMorph"

	listMorph := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:42'!
listMorphClass
	"Answer the class for a new list morph"

	^PluggableListMorph! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/22/2006 15:44'!
listMouseDown: evt
	"Click outside the list."

	(self listMorph fullContainsPoint: evt position)
		ifTrue: [self listMorph selectionIndex: (self listMorph rowAtLocation: evt position)]
		ifFalse: [self hideList]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/13/2009 14:01'!
listPaneColor: paneColor
	"Set the pane color for the list."
	
	self listMorph ifNil: [^self].
	self listMorph
		adoptPaneColor: paneColor;
		fillStyle: (self theme dropListNormalListFillStyleFor: self);
		borderStyle: (self theme dropListNormalListBorderStyleFor: self)! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:28'!
listSelectionIndex
	"Answer the list selection."

	^listSelectionIndex! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/3/2011 17:30'!
listSelectionIndex: anInteger
	"Set the list selection."

	self hideList.
	anInteger = 0 ifTrue: [^self].
	listSelectionIndex := anInteger.
	self
		changed: #listSelectionIndex;
		updateContents;
		triggerEvent: #selectionIndex with: anInteger.
	self model ifNotNil: [:m | 
		self setIndexSelector ifNotNil: [:s |
			self useSelectionIndex
				ifTrue: [m perform: s with: anInteger]
				ifFalse: [m perform: s with: self selectedItem]]]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 12:26'!
listVisible
	"Answer whether the list is visible."

	^self listMorph owner notNil! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 12:27'!
morphicLayerNumber
	"Answer the layer number."

	^self listVisible ifTrue: [10] ifFalse: [super morphicLayerNumber]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/23/2009 13:12'!
newButtonMorph
	"Answer a new button morph"

	^(ControlButtonMorph
		on: self
		getState: nil
		action: #popList
		label: #buttonLabel)
			roundedCorners: #(3 4);
			getEnabledSelector: #enabled;
			label: self buttonLabel; 
			vResizing: #spaceFill;
			hResizing: #rigid;
			extent: self buttonExtent;
			setProperty: #wantsKeyboardFocusNavigation toValue: false;
			cornerStyle: self cornerStyle! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/17/2010 16:43'!
newContentMorph
	"Answer a new content morph"

	^TextMorphForFieldView new
		contents: ' ';
		margins: (2@0 corner: 2@1);
		borderStyle: (BorderStyle simple width: 0);
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		autoFit: false;
		lock! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/13/2009 14:01'!
newListMorph
	"Answer a new list morph"

	|m|
	m := (self listMorphClass
		on: self
		list: #list
		selected: #listSelectionIndex
		changeSelected: #listSelectionIndex:
		menu: nil
		keystroke: nil)
			roundedCorners: #(2 3);
			setProperty: #morphicLayerNumber toValue: 5;
			color: self color;
			borderStyle: (self theme dropListNormalListBorderStyleFor: self);
			on: #mouseDown send: #listMouseDown: to: self.
	^m! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:58'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel
	"Set the receiver to the given model parameterized by the given message selectors."

	getListSel isSymbol
		ifTrue: [self  getListSelector: getListSel]
		ifFalse: [self list: getListSel]. "allow direct list"
	self
		model: anObject;
		getIndexSelector: getSelectionSel;
		setIndexSelector: setSelectionSel;
		updateList;
		updateListSelectionIndex;
		updateContents! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/8/2006 10:13'!
outOfWorld: aWorld
	"Get rid of the list if visible."

	self hideList.
	^super outOfWorld: aWorld! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/22/2006 15:00'!
popList
	"Hide / show the list."

	self enabled ifFalse: [^self].
	self listMorph owner isNil
		ifTrue: [self showList]
		ifFalse: [self hideList]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 11/25/2010 15:55'!
positionList
	"Position the list morph to fit on the display."

	self boundsInWorld bottomLeft y + self listHeight > self world bottom
		ifTrue: [self buttonMorph roundedCorners: (self roundedCorners copyWithoutAll: #(1 4)).
				self roundedCorners: (self roundedCorners copyWithoutAll: #(1 4)).
				self listMorph
					bounds: (self boundsInWorld topLeft - (0 @ self listHeight) extent: self width @ self listHeight)]
		ifFalse: [self buttonMorph roundedCorners: (self roundedCorners copyWithoutAll: #(1 2 3)).
				self roundedCorners: (self roundedCorners copyWithoutAll: #(2 3)).
				self listMorph
					bounds: (self boundsInWorld bottomLeft extent: self width @ self listHeight)]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:38'!
roundedCorners: anArray
	"Set the corners to round."

	super roundedCorners: anArray.
	self buttonMorph ifNotNil: [:b |
		b roundedCorners: (anArray copyWithoutAll: #(1 2))]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:12'!
selectedItem
	"Answer the selected list item."

	^(self listSelectionIndex between: 1 and: self list size) ifTrue: [
		self list at: self listSelectionIndex]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:58'!
selectionColor
	"Answer the selection color for the receiver."

	^self listMorph selectionColor! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/12/2006 13:58'!
selectionColor: aColor
	"Set the selection color for the receiver."

	self listMorph selectionColor: aColor! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
setIndexSelector
	"Answer the value of setIndexSelector"

	^ setIndexSelector! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 7/17/2006 12:26'!
setIndexSelector: anObject
	"Set the value of setIndexSelector"

	setIndexSelector := anObject! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 11/25/2010 16:00'!
showList
	"Show the list."

	self listMorph owner isNil
		ifTrue: [self positionList.
				self
					fillStyle: self fillStyleToUse;
					listPaneColor: self paneColor.
				self world addMorphInLayer: self listMorph.
				self listMorph wantsKeyboardFocus ifTrue: [
					self listMorph takeKeyboardFocus].
				self activeHand
					newMouseFocus: self listMorph]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2007 14:37'!
step
	"Reset mouse focus to the list if it is showing."

	self listVisible ifTrue: [
		self activeHand mouseFocus ifNil: [
			 self listMorph wantsKeyboardFocus ifTrue: [
				self listMorph takeKeyboardFocus].
			self activeHand newMouseFocus: self listMorph]]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2006 12:48'!
stepTime
	"Answer the desired time between steps in milliseconds."

	^100! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 12:30'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/18/2010 17:34'!
themeChanged
	"Update the selection colour."

	self selectionColor ifNotNil: [
		self selectionColor: self theme selectionColor].
	self layoutInset: self layoutInsetToUse.
	self buttonMorph extent: self buttonExtent.
	super themeChanged.
	self buttonMorph cornerStyle: self cornerStyle.! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/14/2006 13:18'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == getListSelector ifTrue: 
		[self updateList.
		^ self].
	aSymbol == getIndexSelector ifTrue:
		[self updateListSelectionIndex.
		^ self].
	aSymbol == getEnabledSelector ifTrue:
		[self updateEnabled.
		^ self].
! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/17/2010 15:24'!
updateContentColor: paneColor
	"Change the content text color."
	
	self enabled
		ifTrue: [self contentMorph textColor: Color black]
		ifFalse: [self contentMorph textColor: Color lightGray]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 15:35'!
updateContents
	"Update the contents."

	|sel|
	self contentMorph
		contents: (self listSelectionIndex > 0
			ifTrue: [sel := self list at: self listSelectionIndex.
					sel isText
						ifTrue: [sel]
						ifFalse: [sel asString]]
			ifFalse: [' ']) "needs something to keep font"! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:25'!
updateEnabled
	"Update the enablement state."

	self model ifNotNil: [
		self getEnabledSelector ifNotNil: [
			self enabled: (self model perform: self getEnabledSelector)]]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:57'!
updateList
	"Refresh the list."

	self getListSelector isSymbol ifTrue: [
		self list: (self model perform: self getListSelector).
		listSelectionIndex := 0]! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'nice 4/19/2011 00:36'!
updateListSelectionIndex
	"Update the list selection."

	|i|
	self useSelectionIndex
		ifTrue: [i := self getCurrentSelectionIndex.
				listSelectionIndex = i ifTrue: [^self].
				listSelectionIndex := i]
		ifFalse: [i := self getCurrentSelection.
				listSelectionIndex := i isNil
					ifTrue: [0]
					ifFalse: [self list indexOf: i]].
	self
		changed: #listSelectionIndex;
		updateContents;
		triggerEvent: #selectionIndex with: i! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:53'!
useIndex
	"Use the model as returning the selected index rather than item."

	self useSelectionIndex: true! !

!DropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 15:53'!
useSelection
	"Use the model as returning the selected item rather than index."

	self useSelectionIndex: false! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 15:53'!
useSelectionIndex
	"Answer the value of useSelectionIndex"

	^ useSelectionIndex! !

!DropListMorph methodsFor: 'accessing' stamp: 'gvc 8/8/2007 15:53'!
useSelectionIndex: anObject
	"Set the value of useSelectionIndex"

	useSelectionIndex := anObject! !

DropListMorph subclass: #EditableDropListMorph
	instanceVariableNames: 'addToListSel content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!EditableDropListMorph commentStamp: 'LaurentLaffont 3/31/2011 21:04' prior: 0!
I'm a DropListMorph which content can be modified.

Try:

(EditableDropListMorph
        on: [#(one two three)]
        list: #value
        selected: nil
        changeSelected: nil) openInWindow extent: 400@20.!

!EditableDropListMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 4/9/2009 09:56'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel useIndex: useIndex addToList: addToListSel class: aClass getEnabled: getEnabledSel 
	^ self
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		useIndex: useIndex
		addToList: addToListSel
		class: aClass
		getEnabled: getEnabledSel
		default: '' ! !

!EditableDropListMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 10/20/2009 12:41'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel useIndex: useIndex addToList: addToListSel class: aClass getEnabled: getEnabledSel default: aDefaultValue
	^ (super
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		useIndex: useIndex) convertTo: aClass;
		 getEnabledSelector: getEnabledSel;
		 addToListSel: addToListSel;
		 default: aDefaultValue;
		 yourself! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 10/20/2009 12:41'!
addToListSel: aSelector
	addToListSel := aSelector! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/17/2010 16:57'!
adoptPaneColor: paneColor
	"Clear the fill style of the text."
	
	super adoptPaneColor: paneColor.
	self contentMorph fillStyle: Color transparent ! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 15:26'!
content
	^ content
! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/3/2011 19:06'!
content: anObject 
	content := anObject.
	self model perform: addToListSel with: content.
	self listSelectionIndex: (self list indexOf: content).
	self updateList! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 16:30'!
convertTo: aClass 
	self contentMorph convertTo: aClass ! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 4/9/2009 10:11'!
converter
	^ self contentMorph converter! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 4/9/2009 11:03'!
default: anObject 
	self contentMorph default: anObject! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/17/2010 17:08'!
enabled: aBoolean
	"Set the value of enabled"
	
	super enabled: aBoolean.
	self
		contentMorph enabled: aBoolean;
		fillStyle: Color transparent ! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/3/2009 06:33'!
font: aFont
	"Set the list and content font"

	self listMorph font: aFont.
	self contentMorph font: aFont! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 4/8/2009 10:41'!
ghostText: aText
	self contentMorph ghostText: aText
! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/17/2010 17:02'!
initialize

	super initialize.
	self vResizing: #shrinkWrap! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 03:54'!
layoutInsetToUse
	"Answer the layout inset that should be used."

	"^self theme editableDropListInsetFor: self"
	^ 0 @ 0 corner: 0 @ 0! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 18:21'!
listHeight
	"Answer the height for the list."
	^(self listMorph listMorph height + 12) min: 200! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/12/2011 09:45'!
minHeight
	"Answer the minimum height for the drop list."
	
	^self theme textFont height + 7! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/3/2011 18:05'!
newContentMorph
	"Answer a new content morph"
	
	| pt |
	pt := PluggableTextFieldMorph new
		convertTo: String;
		alwaysAccept: true;
		on: self
		text: #content
		accept: #content:
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: nil;
		font: self theme textFont;
		cornerStyle: (self theme textEntryCornerStyleIn: self);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle simple width: 0);
		color: Color white;
		hideScrollBarsIndefinitely;
		setBalloonText: nil.
		
	pt textMorph autoFit: true;
		wrapFlag: false;
		margins: self theme editableDropListMargins.
		
	^ pt! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 4/9/2009 10:12'!
objectAsString: anObject
	^ self converter objectAsString: anObject! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 4/8/2009 09:11'!
updateContents
	"Update the contents."

	|sel|
	self contentMorph
		setText: (self listSelectionIndex > 0
			ifTrue: [sel := self list at: self listSelectionIndex.
					sel isText
						ifTrue: [sel]
						ifFalse: [sel asString]]
			ifFalse: ['']) "needs something to keep font"! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/3/2009 09:10'!
wantsFrameAdornments: aBoolean
	self contentMorph wantsFrameAdornments: aBoolean! !

EditableDropListMorph subclass: #SearchMorph
	instanceVariableNames: 'maxSize currentCompletionIndex updateSelector keystrokeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!SearchMorph commentStamp: 'CamilloBruni 8/4/2011 14:39' prior: 0!
I am a searchfield with a dropdown for the history. It is a minor extension to the EditableDropListMorph managing the search history directly in the morph. 

Typical use-case:

	^ SearchMorph new
		model: self;
		setIndexSelector: #classSearchAccept:; "sends the search result to the model"
		searchList: self class classSearchList; "sent on creation to get the initial search list"
		yourself
	
	!

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 04:50'!
acceptSelector
	^ self setIndexSelector! !

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 04:41'!
acceptSelector: aSymbol
	self setIndexSelector: aSymbol! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/4/2011 12:27'!
addToList: aString
	aString isEmpty ifTrue: [ ^ self ].
	list ifNil: [
		list := self searchList].
	list remove: aString ifAbsent: [].
	list size = self maxSize
		ifTrue: [ self searchList removeLast].
	list addFirst: aString.
	self changed: #list.! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 08:00'!
content
	^ content! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 06:56'!
content: anObject 
	content := anObject trimBoth.
	self addToList: content.
	self listSelectionIndex: (self list indexOf: content).
	self updateList! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 08:01'!
contentChanged: aString
	content := aString.
	self updateSelector ifNotNil: [ :selector|
		self model perform: selector with: aString ]! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 04:08'!
currentTabCompletion
	self searchList ifEmpty: [ ^ ''].
	
	currentCompletionIndex > self searchList
		ifTrue: [ currentCompletionIndex := 1].
	
	^ self searchList at: currentCompletionIndex! !

!SearchMorph methodsFor: 'initialization' stamp: 'CamilloBruni 8/4/2011 14:22'!
initialize
	super initialize.
	self convertTo: String.
	list := OrderedCollection new.
	self useSelectionIndex: false.
	self ghostText: 'Hit return to accept' translated! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 07:57'!
keyStroke: event

	keystrokeSelector ifNotNil: [ 
		(self keystrokeAction: event) ifTrue: [ ^ self ] ].
	
	^ super keyStroke: event! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/2/2011 13:13'!
keyStroke: event fromMorph: morph

	keystrokeSelector ifNotNil: [ 
		^ self keystrokeAction: event ].
	
	^ false! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/2/2011 13:06'!
keystrokeAction: event 
	| args returnValue |
	keystrokeSelector ifNil: [ ^ nil ].
	args := keystrokeSelector numArgs.
	args = 1 ifTrue: [returnValue := model perform: keystrokeSelector with: event].
	args = 2 
		ifTrue: 
			[returnValue := model 
				perform: keystrokeSelector
				with: event
				with: self].
	returnValue ifNotNil: [
			^ returnValue = true ].
	
	self error: 'keystrokeSelector must be a 1- or 2-keyword symbol'.
	^ false! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/2/2011 13:05'!
keystrokeSelector
	^ keystrokeSelector! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 07:07'!
keystrokeSelector: aSymbol
	keystrokeSelector := aSymbol.
! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/3/2011 19:17'!
listSelectionIndex: anInteger
	"Set the list selection."

	self hideList.
	anInteger = 0 
		ifTrue: [
			self model ifNotNil: [:m | 
				self setIndexSelector ifNotNil: [:s |
					self useSelectionIndex 
						ifFalse: [m perform: s with: nil]]]]
		ifFalse: [ ^ super listSelectionIndex: anInteger ].! !

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2011 16:44'!
maxSize
	^ maxSize! !

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2011 16:44'!
maxSize: aNumber
	maxSize := aNumber! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 9/13/2011 17:07'!
newContentMorph
	|pluggableTextMorph|
	pluggableTextMorph := super newContentMorph.
	pluggableTextMorph 
		autoAccept: false;
		askBeforeDiscardingEdits: false;
		setProperty: #wantsFrameAdornments toValue: false;
		changedAction: [:aString| self contentChanged: aString asString];
		eventHandler: (PluggableEventHandler model: self).
	^ pluggableTextMorph! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 04:06'!
nextCompletion
	currentCompletionIndex := (currentCompletionIndex + 1 \\ self searchList size) + 1.
	^ self currentTabCompletion! !

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2011 17:24'!
searchList
	^ list ifNil: [ list := OrderedCollection new].! !

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/4/2011 12:27'!
searchList: aCollection
	self list: aCollection! !

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2011 17:17'!
searchString
	^ content! !

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 07:52'!
selectionInterval
	^ contentMorph selectionInterval! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/4/2011 12:31'!
showList
	"trigger a list update so that shared search results are updated properly"
	self changed: #list.
	super showList.! !

!SearchMorph methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 06:13'!
takeKeyboardFocus
	contentMorph takeKeyboardFocus.! !

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 04:57'!
updateSelector
	^ updateSelector! !

!SearchMorph methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 04:57'!
updateSelector: aSymbol 
	updateSelector := aSymbol! !

DropListMorph subclass: #MorphDropListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!MorphDropListMorph commentStamp: 'gvc 5/18/2007 12:43' prior: 0!
Drop list supporting morphs in list.!

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 15:07'!
font: aFont
	"Set the list font"

	self listMorph font: aFont! !

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 11:43'!
listMorphClass
	"Answer the class for a new list morph"

	^PluggableMorphListMorph! !

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/17/2006 12:11'!
newContentMorph
	"Answer a new content morph"

	^Morph new
		changeTableLayout;
		listDirection: #leftToRight;
		wrapCentering: #center;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		layoutInset: 2;
		color: Color transparent;
		borderWidth: 0;
		clipSubmorphs: true;
		lock! !

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/29/2006 11:58'!
updateContentColor: paneColor
	"Change the content text color."
	! !

!MorphDropListMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/17/2006 13:35'!
updateContents
	"Update the contents."

	|item|
	self contentMorph removeAllMorphs.
	self listSelectionIndex > 0
		ifTrue: [item := (self list at: self listSelectionIndex) copy
					hResizing: #spaceFill;
					vResizing: #rigid.
				self contentMorph
					addMorph: item]! !

MorphicModel subclass: #ExampleBuilderMorph
	uses: TEasilyThemed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ExampleBuilderMorph commentStamp: 'gvc 7/19/2007 16:49' prior: 0!
Morph with an inset border by default and theme access. Overrides openModal: to allow multiple free example dialogs to be presented.!

ExampleBuilderMorph class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

!ExampleBuilderMorph methodsFor: 'services' stamp: 'FernandoOlivero 3/2/2011 09:35'!
chooseColor: aColor title: label
	"Answer the user choice of a colour."
	
	^ self theme 
		chooseColorIn: self modalMorph
		title: (label ifNil: ['Choose Color' translated])
		color: aColor! !

!ExampleBuilderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/6/2010 17:08'!
openModal: aSystemWindow
	"Open the given window an available position without modality.
	Answer the system window."
	
	|baseArea areas searching foundRect|
	aSystemWindow extent: aSystemWindow initialExtent.
	areas := World submorphs
		select: [:m | m isKindOf: DialogWindow]
		thenCollect: [:m | m bounds expandBy: 8].
	baseArea := RealEstateAgent maximumUsableArea insetBy: 8.
	searching := true.
	baseArea allAreasOutsideList: areas do: [:rect |
		searching ifTrue: [
			aSystemWindow extent <= (rect insetBy: 8) extent
				ifTrue: [foundRect := rect.
						searching := false]]].
	searching ifTrue: [foundRect := baseArea].
	aSystemWindow setWindowColor: self theme windowColor.
	aSystemWindow position: foundRect topLeft + 8.
	aSystemWindow openAsIs.
	^aSystemWindow! !

MorphicModel subclass: #GroupboxMorph
	instanceVariableNames: 'contentMorph labelMorph getContentSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!GroupboxMorph commentStamp: 'gvc 5/18/2007 12:36' prior: 0!
Groupbox with title with a vertical layout. Appears in a lighter colour than the owner's pane colour.!

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/20/2006 11:24'!
addContentMorph: aMorph
	"Add a morph to the content."

	^self contentMorph addMorphBack: aMorph! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/25/2008 14:55'!
adoptPaneColor: paneColor
	"Pass on to the content morph."
	
	|c|
	paneColor ifNil: [^super adoptPaneColor: paneColor].
	c := self theme subgroupColorFrom: paneColor.
	super adoptPaneColor: c.
	self contentMorph borderStyle: (self theme groupPanelBorderStyleFor: self).
	self labelMorph
		color: paneColor blacker muchDarker;
		backgroundColor: c;
		borderStyle: (self theme groupLabelBorderStyleFor: self)! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:05'!
containsPoint: aPoint
	"Override here to check the label and content instead."
	
	^(super containsPoint: aPoint) and: [
		(self labelMorph containsPoint: aPoint) or: [
		self contentMorph containsPoint: aPoint]]! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/26/2011 10:13'!
contentFromModel
	"Answer content from the model."
	
	^self getContentSelector ifNotNil: [:s |
		self model ifNotNil: [:m | m perform: s]]! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 8/19/2006 16:31'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 8/19/2006 16:31'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/20/2006 11:47'!
cornerStyle: aSymbol
	"Pass on to list too."

	super cornerStyle: aSymbol.
	self labelMorph cornerStyle: aSymbol.
	self contentMorph cornerStyle: aSymbol! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:55'!
font
	"Answer the label font"

	^self labelMorph font! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:55'!
font: aFont
	"Set the label font"

	self labelMorph font: aFont! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'GaryChambers 7/26/2011 10:11'!
getContentSelector

	^ getContentSelector! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'GaryChambers 7/26/2011 10:11'!
getContentSelector: anObject

	getContentSelector := anObject! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/12/2007 10:49'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."

	^Color transparent! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/19/2010 16:21'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		roundedCorners: #(2 3 4);
		borderWidth: 0;
		changeTableLayout;
		cellPositioning: #topLeft;
		cellInset: 0 @ -1;
		reverseTableCells: true;
		labelMorph: self newLabelMorph;
		contentMorph: self newContentMorph;
		addMorphBack: self contentMorph;
		addMorphBack: self labelMorph! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/20/2006 11:26'!
label
	"Answer the contents of the label morph."

	^self labelMorph contents! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/25/2008 14:31'!
label: aString
	"Set the contents of the label morph."

	aString ifNil: [
		self roundedCorners: #(1 2 3 4).
		self labelMorph delete. ^self].
	self roundedCorners: #(2 3 4).
	self labelMorph owner ifNil: [
		self addMorph: self labelMorph].
	self labelMorph contents: aString! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 8/19/2006 16:31'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!GroupboxMorph methodsFor: 'accessing' stamp: 'gvc 8/19/2006 16:31'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 15:34'!
minExtent
	"Answer the minmum extent of the receiver.
	Based on label and rounding."

	^super minExtent max: self labelMorph minExtent + (8@0)! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/25/2008 14:33'!
newContentMorph
	"Answer a new content morph"

	|p|
	p := PanelMorph new
		roundedCorners: self roundedCorners;
		changeTableLayout; 
		layoutInset: (4@4 corner: 4@4);
		cellInset: 8;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	p borderStyle: (self theme groupPanelBorderStyleFor: p).
	^p! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/19/2010 16:21'!
newLabelMorph
	"Answer a new label morph"

	^TextMorph new
		roundedCorners: #(1 4);
		margins: (2@1 corner: 2 @ -1);
		contents: 'groupbox';
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		lock! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:39'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^super paneColorOrNil ifNotNil: [:c | self theme subgroupColorFrom: c]! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/26/2011 10:18'!
replaceContentMorph: aMorph
	"Replace the content."

	self contentMorph
		removeAllMorphs;
		addMorphBack: aMorph.
	self adoptPaneColor.
	^aMorph
		! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:39'!
roundedCorners: anArray
	"Set the corners to round."

	super roundedCorners: anArray.
	self contentMorph ifNotNil: [:cm | cm roundedCorners: self roundedCorners]! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/25/2008 14:39'!
selectedTab
	"Answer the label morph for compatibility with TabPanelBorder."
	
	^self labelMorph owner
		ifNotNil: [self labelMorph]! !

!GroupboxMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/26/2011 10:14'!
update: aSymbol
	"Replace the content if appropriate."
	
	super update: aSymbol.
	aSymbol = self getContentSelector ifTrue: [
		self contentFromModel ifNotNil: [:c | self replaceContentMorph: c]]
		! !

GroupboxMorph subclass: #W2KGroupboxMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!W2KGroupboxMorph methodsFor: 'drawing' stamp: 'SS 1/1/2009 01:47'!
drawOn: aCanvas

	| aSmallerRect |
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle.
	aSmallerRect := self bounds copy.
	aSmallerRect := aSmallerRect top: (aSmallerRect top + (self labelMorph bounds height / 1.5) asInteger).
	self borderStyle frameRectangle: aSmallerRect on: aCanvas.
	! !

MorphicModel subclass: #IncrementalSliderMorph
	instanceVariableNames: 'sliderMorph getValueSelector setValueSelector getEnabledSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!IncrementalSliderMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 14:02'!
on: anObject getValue: getSel setValue: setSel
	"Answer a new instance of the receiver with
	the given selectors as the interface."

	^self new
		on: anObject
		getValue: getSel
		setValue: setSel! !

!IncrementalSliderMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 14:01'!
on: anObject getValue: getSel setValue: setSel min: min max: max quantum: quantum
	"Answer a new instance of the receiver with
	the given selectors as the interface."

	^self new
		min: min;
		max: max;
		quantum: quantum;
		on: anObject
		getValue: getSel
		setValue: setSel! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 14:45'!
buttons
	"Answer the buttons."

	^{self firstSubmorph. self lastSubmorph}! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 14:56'!
decrement
	"Decrement the value."

	self value: self value - self quantum! !

!IncrementalSliderMorph methodsFor: 'initialize-release' stamp: 'gvc 9/3/2009 13:54'!
defaultSliderFillStyle
	"Answer the hue gradient."

	^(GradientFillStyle colors: {Color white. Color black})
		origin: self topLeft;
		direction: (self bounds isWide
					ifTrue: [self width@0]
					ifFalse: [0@self height])! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'MarcusDenker 12/11/2009 09:34'!
enabled
	"Answer whether the receiver is enabled for user input."

	^self sliderMorph
		ifNil: [super enabled]
		ifNotNil: [:sm | sm enabled]! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'MarcusDenker 12/11/2009 07:39'!
enabled: aBoolean
	"Set whether the receiver is enabled for user input."

	self sliderMorph ifNotNil: [:sm | sm enabled: aBoolean].
	self
		changed: #enabled;
		changed: #minEnabled;
		changed: #maxEnabled! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 15:17'!
extent: aPoint
	"Set the button width to match the height."

	self extent = aPoint ifTrue: [^self].
	super extent: aPoint.
	self updateOrientation: aPoint! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/10/2009 13:37'!
getEnabledSelector
	"Answer the value of getEnabledSelector"

	^ getEnabledSelector! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/10/2009 13:37'!
getEnabledSelector: aSymbol
	"Set the value of getEnabledSelector"

	getEnabledSelector := aSymbol.
	self updateEnabled! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 13:57'!
getValueSelector
	"Answer the value of getValueSelector"

	^ getValueSelector! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 13:57'!
getValueSelector: anObject
	"Set the value of getValueSelector"

	getValueSelector := anObject! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 14:56'!
increment
	"Increment the value."

	self value: self value + self quantum! !

!IncrementalSliderMorph methodsFor: 'initialize-release' stamp: 'gvc 9/2/2009 14:22'!
initialize
	"Initialize the receiver."

	super initialize.
	self sliderMorph: self newSliderMorph.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 0;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderColor: Color transparent;
		addMorphBack: self newDecrementButton;
		addMorphBack: self sliderMorph;
		addMorphBack: self newIncrementButton! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 14:31'!
max
	"Answer the max value."

	^(self sliderMorph ifNil: [^0]) max! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 14:55'!
max: aNumber
	"Set the max value."

	(self sliderMorph ifNil: [^self]) max: aNumber! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:13'!
maxEnabled
	"Answer whether the maximum button should be enabled."

	^self enabled and: [self notAtMax]! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 14:31'!
min
	"Answer the min value."

	^(self sliderMorph ifNil: [^0]) min! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 14:55'!
min: aNumber
	"Set the min value."

	(self sliderMorph ifNil: [^self]) min: aNumber! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:13'!
minEnabled
	"Answer whether the minimum button should be enabled."

	^self enabled and: [self notAtMin]! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/25/2011 10:07'!
minExtent
	"Must answer a fixed small size here to
	allow auto orientation to work."
	
	^(24 max: self minWidth) @ (24 max: self minHeight)! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 14:50'!
newButtonLabel: direction ofSize: size
	"Answer a new label for an inc/dec button."

	^AlphaImageMorph new
		image: (ScrollBar
				arrowOfDirection: direction
				size: size
				color: self paneColor darker)! !

!IncrementalSliderMorph methodsFor: 'initialize-release' stamp: 'FernandoOlivero 4/12/2011 09:47'!
newDecrementButton
	"Answer a new decrement button."

	^(self theme builder
		newButtonFor: self
		action: #decrement
		getEnabled: #minEnabled
		label: (self newButtonLabel: #left ofSize: 24)
		help: nil)
		vResizing: #spaceFill;
		width: 64;
		roundedCorners: #(1 2);
		setProperty: #wantsKeyboardFocusNavigation toValue: false;
		on: #mouseStillDown send: #decrement to: self! !

!IncrementalSliderMorph methodsFor: 'initialize-release' stamp: 'FernandoOlivero 4/12/2011 09:47'!
newIncrementButton
	"Answer a new increment button."

	^(self theme builder
		newButtonFor: self
		action: #increment
		getEnabled: #maxEnabled
		label: (self newButtonLabel: #right ofSize: 24)
		help: nil)
		vResizing: #spaceFill;
		width: 64;
		roundedCorners: #(3 4);
		setProperty: #wantsKeyboardFocusNavigation toValue: false;
		on: #mouseStillDown send: #increment to: self! !

!IncrementalSliderMorph methodsFor: 'initialize-release' stamp: 'FernandoOlivero 4/12/2011 09:47'!
newSliderMorph
	"Answer a new morph for the slider."

	|slider|
	slider := self theme builder
		newBracketSliderFor: self
		getValue: #value
		setValue: #value:
		min: 0
		max: 100
		quantum: 1
		getEnabled: #enabled
		help: nil.
	slider fillStyle: self defaultSliderFillStyle.
	^slider! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 14:35'!
notAtMax
	"Answer whether the value is not at the maximum,"

	^self value < self max! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 14:35'!
notAtMin
	"Answer whether the value is not at the minimum,"

	^self value > self min! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 14:02'!
on: anObject getValue: getSel setValue: setSel
	"Use the given selectors as the interface."

	self
		model: anObject;
		getValueSelector: getSel;
		setValueSelector: setSel;
		updateValue! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 14:31'!
quantum
	"Answer the quantum value."

	^(self sliderMorph ifNil: [^0]) quantum! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 14:55'!
quantum: aNumber
	"Set the quantum value."

	(self sliderMorph ifNil: [^self]) quantum: aNumber! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 13:57'!
setValueSelector
	"Answer the value of setValueSelector"

	^ setValueSelector! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 13:57'!
setValueSelector: anObject
	"Set the value of setValueSelector"

	setValueSelector := anObject! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 14:18'!
sliderMorph
	"Answer the value of sliderMorph"

	^ sliderMorph! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/2/2009 14:18'!
sliderMorph: anObject
	"Set the value of sliderMorph"

	sliderMorph := anObject! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:24'!
update: aSymbol
	"Update the value."
	
	super update: aSymbol.
	aSymbol = self getValueSelector
		ifTrue: [^self updateValue].
	aSymbol = self getEnabledSelector
		ifTrue: [^self updateEnabled]! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2009 13:26'!
updateEnabled
	"Update the enablement state."

	self model ifNotNil: [
		self getEnabledSelector ifNotNil: [
			self enabled: (self model perform: self getEnabledSelector)]]! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/2/2009 15:19'!
updateOrientation: aPoint
	"Set the layout for the new extent."

	|butts|
	butts := self buttons.
	aPoint x >= aPoint y
		ifTrue: [self listDirection: #leftToRight.
				butts first
					roundedCorners: #(1 2);
					hResizing: #rigid;
					vResizing: #spaceFill;
					width: aPoint y;
					label: (self newButtonLabel: #left ofSize: aPoint y // 2).
				butts last
					roundedCorners: #(3 4);
					hResizing: #rigid;
					vResizing: #spaceFill;
					width: aPoint y;
					label: (self newButtonLabel: #right ofSize: aPoint y // 2)]
		ifFalse: [self listDirection: #topToBottom.
				butts first
					roundedCorners: #(1 4);
					hResizing: #spaceFill;
					vResizing: #rigid;
					height: aPoint x;
					label: (self newButtonLabel: #top ofSize: aPoint x // 2).
				butts last
					roundedCorners: #(2 3);
					hResizing: #spaceFill;
					vResizing: #rigid;
					height: aPoint x;
					label: (self newButtonLabel: #bottom ofSize: aPoint x // 2)]! !

!IncrementalSliderMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:39'!
updateValue
	"Update the value."
	
	self model ifNotNil: [
		self getValueSelector ifNotNil: [
			self sliderMorph ifNotNil: [:sm |
				sm scaledValue: self value.
			self changed: #minEnabled; changed: #maxEnabled]]]! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/4/2009 16:15'!
value
	"Answer the slider value."

	^self getValueSelector
		ifNil: [(self sliderMorph ifNil: [^0]) scaledValue]
		ifNotNil: [self model
					ifNil: [(self sliderMorph ifNil: [^0]) scaledValue]
					ifNotNil: [self model perform: self getValueSelector]]! !

!IncrementalSliderMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2009 13:17'!
value: aNumber
	"Set the slider value."

	(self sliderMorph ifNil: [^self]) scaledValue: aNumber.
	self model ifNotNil: [
		self setValueSelector ifNotNil: [
			self model perform: self setValueSelector with: self sliderMorph scaledValue]].
	self changed: #minEnabled; changed: #maxEnabled! !

MorphicModel subclass: #TabGroupMorph
	instanceVariableNames: 'tabSelectorMorph contentMorph pageMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TabGroupMorph commentStamp: 'gvc 5/18/2007 11:54' prior: 0!
Organises a set of pages sharing the same space and selected through the use of tabs along the top.!

!TabGroupMorph class methodsFor: 'example' stamp: 'FernandoOlivero 4/12/2011 10:34'!
example

	| builder window page1 page2 label1 label2 tabs content okButton cancelButton |
	builder := self theme  builder.
	okButton := builder newOKButton.
	cancelButton := builder newCancelButton.
	page1 := ( builder newStack: {
		( builder
			newAlphaImage: self theme warningIcon
			help: nil)
			alpha: 0.5.
		CircleMorph new
			hResizing: #spaceFill;
			vResizing: #spaceFill})
		fillStyle: Color red;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	page2 :=  builder newPanel
		fillStyle: Color green;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	label1 :=  builder newRow: {
		 builder newButtonLabel: 'First page'.
		 builder
			newCloseControlFor: nil
			action: [tabs removePage: page1]
			help: 'Close this tab'}.
	label2 :=  builder newRow: {
		 builder newButtonLabel: 'Second page'.
		 builder
			newCloseControlFor: nil
			action: [tabs removePage: page2]
			help: 'Close this tab'}.
	label1 cellInset: 0.
	label2 cellInset: 0.
	tabs :=  builder newTabGroup: {
		label1 -> page1.
		label2-> page2}.
	content :=  builder 
			newColumn: {
				tabs.
				( builder newRow: {okButton. cancelButton})
					listCentering: #bottomRight}.
	window := content
		extent: 250@300;
		openInWindow.
	okButton model: window; action: #delete.
	cancelButton model: window; action: #delete! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 14:13'!
addPage: aMorph label: aStringOrMorph
	"Add a page and its tab."

	aMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	self pages add: aMorph.
	self tabSelectorMorph addTab: aStringOrMorph! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2008 13:37'!
adoptPaneColor: paneColor
	"Pass on to the content morph a little lighter."
	
	paneColor ifNil: [^super adoptPaneColor: paneColor].
	super adoptPaneColor: (self theme subgroupColorFrom: paneColor).
	self contentMorph borderStyle: (self theme tabPanelBorderStyleFor: self)! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 13:28'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 13:28'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:44'!
cornerStyle: aSymbol
	"Pass on to selector and content too."

	super cornerStyle: aSymbol.
	self tabSelectorMorph cornerStyle: aSymbol.
	self contentMorph cornerStyle: aSymbol! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/16/2006 08:47'!
font
	"Answer the label font"

	^self tabSelectorMorph font! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/16/2006 08:46'!
font: aFont
	"Set the label font"

	self tabSelectorMorph font: aFont! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/2/2009 10:59'!
fullDrawOn: aCanvas
	"Patch up the selected tab visuals if required."
	
	super fullDrawOn: aCanvas.
	self theme drawTabGroupFinishingFor: self on: aCanvas! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/19/2010 16:21'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 0;
		changeTableLayout;
		cellPositioning: #topLeft;
		cellInset: 0 @ -1;
		reverseTableCells: true;
		pageMorphs: OrderedCollection new;
		tabSelectorMorph: self newTabSelectorMorph;
		contentMorph: self newContentMorph;
		addMorph: self tabSelectorMorph;
		addMorph: self contentMorph.
	self tabSelectorMorph addDependent: self! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/16/2006 08:44'!
labelsAndPages: assocs
	"Replace the tabs and the associated pages."

	self contentMorph removeAllMorphs.
	self tabSelectorMorph removeAllMorphs.
	assocs do: [:a | self addPage: a value label: a key]! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 14:46'!
minExtent
	"Calculate the min extent of the receiver based on all pages."

	|extra|
	self page ifNil: [^super minExtent max: self tabSelectorMorph minExtent].
	extra := 0@(self tabSelectorMorph minExtent y) + (self contentMorph borderWidth * 2).
	extra := extra + self contentMorph layoutInset topLeft.
	extra := extra + self contentMorph layoutInset bottomRight.
	^super minExtent max: (((self pages inject: 0 @ 0 into: [:mw :pm | mw max: pm minExtent]) + extra)
		max: self tabSelectorMorph minExtent)! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/7/2008 14:47'!
newContentMorph
	"Answer a new content morph"

	|p|
	p := PanelMorph new
		roundedCorners: #(2 3 4);
		changeTableLayout; 
		layoutInset: (4@4 corner: 4@4);
		cellInset: 8;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	p borderStyle: (self theme tabPanelBorderStyleFor: self).
	^p! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:30'!
newTabSelectorMorph
	"Answer a new tab selector morph"

	^TabSelectorMorph new
		vResizing: #shrinkWrap;
		hResizing: #spaceFill! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 14:00'!
page
	"Answer the current page morph if any."

	^self pageMorph! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 13:37'!
page: aMorph
	"Select the give page."

	self selectedPageIndex: (self pages indexOf: aMorph)! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:58'!
pageMorph
	"Answer the current page morph if any."

	^self contentMorph hasSubmorphs
		ifTrue: [self contentMorph submorphs first]! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 13:53'!
pageMorphs
	"Answer the value of pageMorphs"

	^ pageMorphs! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 13:53'!
pageMorphs: anObject
	"Set the value of pageMorphs"

	pageMorphs := anObject! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 14:00'!
pages
	"Answer the pages."

	^self pageMorphs! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:42'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^super paneColorOrNil ifNotNil: [:c | self theme subgroupColorFrom: c]! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 13:26'!
relabelPage: aMorph with: aStringOrMorph
	"Relabel the tab associated with the given page and
	update tabs."

	self tabSelectorMorph
		relabelTab: (self tabOfPage: aMorph) with: aStringOrMorph! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/10/2010 14:38'!
removePage: aMorph
	"Remove the given page and its tab."

	|index|
	index := self pages indexOf: aMorph.
	self pages remove: aMorph.
	self tabSelectorMorph removeTabIndex: index! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/10/2010 14:23'!
removePageIndex: anInteger
	"Remove the page at index anInteger page and its tab."

	self pages removeAt: anInteger.
	self tabSelectorMorph removeTabIndex: anInteger! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 11:51'!
selectedPageIndex
	"Answer the selected page index."

	^self tabSelectorMorph selectedIndex! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:55'!
selectedPageIndex: index
	"Set the selected page index."

	self tabSelectorMorph selectedIndex: index! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 12:31'!
selectedTab
	"Answer the tab of the selected page."
	
 	^self tabSelectorMorph selectedTab! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 13:22'!
tabOfPage: aMorph
	"Answer the tab associated with the given page."

	^self tabSelectorMorph tabs at: (self pages indexOf: aMorph)! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 11:51'!
tabSelectorMorph
	"Answer the value of tabSelectorMorph"

	^ tabSelectorMorph! !

!TabGroupMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 11:51'!
tabSelectorMorph: anObject
	"Set the value of tabSelectorMorph"

	tabSelectorMorph := anObject! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2008 11:36'!
themeChanged
	"Update the corner style."

	self cornerStyle: (self theme tabGroupCornerStyleIn: self window).
	super themeChanged! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:59'!
update: aSymbol
	"Handle tab changes."

	super update: aSymbol.
	aSymbol == #selectedIndex
		ifTrue: [self updatePageIndex: self selectedPageIndex]! !

!TabGroupMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 10:57'!
updatePageIndex: index
	"Change to the given page index."

	self pageMorph ifNotNil: [:p | self contentMorph removeMorph: p].
	index > 0 ifTrue: [self contentMorph addMorph: (self pages at: index)].
	self pageMorph ifNotNil: [:pm | pm layoutChanged].
	self adoptPaneColor: self paneColor! !

MorphicModel subclass: #TabSelectorMorph
	instanceVariableNames: 'selectedIndex visibleTabRange font tabs controls wrapScrolling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TabSelectorMorph commentStamp: 'gvc 5/18/2007 11:54' prior: 0!
Row of tabs for a TabGroupMorph.!

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 11:16'!
activate
	"Update the non visible tabs too."

	super activate.
	self nonVisibleTabs do: [:t | t activate]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 17:48'!
addTab: aStringOrMorph
	"Add a new tab with the given text."
	
	self tabs add: (self newLabelMorph: aStringOrMorph).
	self updateTabs! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 17:18'!
basicMinExtent
	"Answer the unadjusted min extent."

	|minTabExtent controlExtent controlsExtent|
	controlsExtent := 0@0.
	self controls do: [:control |
		controlExtent := control minExtent.
		controlsExtent := controlsExtent x + controlExtent x @ (controlsExtent y max: controlExtent y)].
	self tabs ifEmpty: [^controlsExtent].
	minTabExtent := 0@0.
	self tabs do: [:tab | minTabExtent := minTabExtent max: tab minExtent].
	^minTabExtent x + controlsExtent x @ (minTabExtent y max: controlsExtent y)! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 11:55'!
calculateVisibleTabs
	"Answer the tabs that should be visible given the space."

	|widths answer availableWidth accumulatedWidth tabStr widthStr width|
	widths := self tabs collect: [:t | t minExtent x].
	availableWidth := self layoutBounds width.
	self cornerStyle = #rounded
		ifTrue: [availableWidth := availableWidth - 6].
	widths sum <= availableWidth ifTrue: [^self tabs].
	availableWidth := availableWidth - self controlsExtent x.
	answer := OrderedCollection new.
	accumulatedWidth := 0.
	self visibleTabRange last = 0
		ifTrue: [tabStr := (self tabs copyFrom: self visibleTabRange first to: self tabs size) readStream.
				widthStr := (widths copyFrom: self visibleTabRange first to: widths size) readStream.
				[accumulatedWidth <= availableWidth and: [tabStr atEnd not]] whileTrue: [
					answer add: tabStr next.
					accumulatedWidth := accumulatedWidth + widthStr next].
				accumulatedWidth > availableWidth ifTrue: [
					answer removeLast].
				^answer]
		ifFalse: [tabStr := (self tabs copyFrom: 1 to: self visibleTabRange last) reversed readStream.
				widthStr := (widths copyFrom: 1 to: self visibleTabRange last) reversed readStream.
				[accumulatedWidth <= availableWidth and: [tabStr atEnd not]] whileTrue: [
					answer addFirst: tabStr next.
					accumulatedWidth := accumulatedWidth + (width := widthStr next)].
				accumulatedWidth > availableWidth ifTrue: [
					answer removeFirst.
					accumulatedWidth := accumulatedWidth - width].
				tabStr := (self tabs copyFrom: self visibleTabRange last + 1 to: self tabs size) readStream.
				widthStr := (widths copyFrom: self visibleTabRange last + 1 to: widths size) readStream.
				[accumulatedWidth <= availableWidth and: [tabStr atEnd not]] whileTrue: [
					answer add: tabStr next.
					accumulatedWidth := accumulatedWidth + widthStr next].
				accumulatedWidth > availableWidth
					ifTrue: [answer removeLast].
				^answer]
	
		
	! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 13:45'!
controlButtonWidth
	"Answer the width for a scroll button."

	^self theme scrollbarThickness + 3! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/7/2011 13:42'!
controls

	^ controls! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/7/2011 13:42'!
controls: anObject

	controls := anObject! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 13:53'!
controlsExtent
	"Answer the min extent of the controls."

	^self controls first minExtent + (self controls last minExtent x @ 0)! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2008 11:35'!
cornerStyle: aSymbol
	"Pass to tabs also."

	super cornerStyle: aSymbol.
	self tabs do: [:t | t cornerStyle: aSymbol]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 11:44'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	|tab|
	super drawSubmorphsOn: aCanvas.
	(self hasKeyboardFocus and: [(tab := self selectedTab) notNil
			and: [tab owner notNil]])
		ifTrue: [self clipSubmorphs 
				ifTrue: [aCanvas
							clipBy: (aCanvas clipRect intersect: self clippingBounds)
							during: [:c | tab drawKeyboardFocusOn: c]]
				ifFalse: [tab drawKeyboardFocusOn: aCanvas]]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 12:00'!
ensureSelectedTabIsVisible
	"Update the tabs if the seleted tab is not in the visible range."

	(self selectedIndex > 0 and: [(self visibleTabRange includes: self selectedIndex) not])
		ifTrue: [self visibleTabRange: (self selectedIndex to: 0).
				self updateTabs]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 11:59'!
extent: aPoint
	"Set the extent of the receiver.
	Update the tabs."

	self extent = aPoint ifTrue: [^self].
	super extent: aPoint.
	self
		updateTabs;
		ensureSelectedTabIsVisible! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 09:35'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^self selectedTab
		ifNil: [super focusBounds]
		ifNotNil: [:tab | tab focusBounds]! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/16/2006 08:54'!
font
	"Answer the label font"

	^font! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'gvc 7/30/2009 13:47'!
font: aFont
	"Set the label font"

	font == aFont ifTrue: [^self].
	font := aFont.
	self updateFont! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:09'!
handlesKeyboard: evt
	"Yes, we do it here."
	
	^true! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 14:49'!
initialize
	"Initialize the receiver."

	super initialize.
	selectedIndex := 0.
	self
		tabs: OrderedCollection new;
		wrapScrolling: false;
		visibleTabRange: (1 to: 0);
		controls: self newControls;
		roundedCorners: #(1 4);
		borderWidth: 0;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: (self theme tabSelectorCellInsetFor: self)! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:12'!
keyStroke: event 
	"Process keys navigation and space to toggle."
	
	(self navigationKey: event) ifTrue: [^self].
	event keyCharacter = Character arrowLeft
		ifTrue: [self selectPreviousTab].
	event keyCharacter = Character arrowRight
		ifTrue: [self selectNextTab]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/6/2007 14:37'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self focusChanged! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 13:19'!
leftButtonEnabled
	"Answer whether the button for scrolling left should be enabled."

	^self wrapScrolling or: [self visibleTabRange first > 1]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 13:46'!
leftButtonLabel
	"Answer the label for a button for scrolling left."

	^AlphaImageMorph new image: (
		ScrollBar
			arrowOfDirection: #left
			size: self controlButtonWidth - 3
			color: self paneColor darker)! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/2/2009 11:10'!
minExtent
	"Add a bit for the round corner of the group."

	^self theme tabSelectorMorphMinExtentFor: self! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 13:44'!
newControls
	"Answer the scrolling controls."
	
	^{self newLeftButton. self newRightButton}! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 14:27'!
newEndSpacer
	"Answer a spacer to pad when rounded."

	^Morph new
		borderWidth: 0;
		color: Color transparent;
		extent: 6@0! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 13:47'!
newLabelMorph: aStringOrMorph
	"Answer a new label morph with the given label text."

	^TabLabelMorph new
		roundedCorners: #(1 4);
		cornerStyle: self cornerStyle;
		changeTableLayout;
		listCentering: #center;
		layoutInset: (self theme tabLabelInsetFor: self);
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		label: aStringOrMorph;
		font: self font;
		on: #mouseDown send: #tabClicked:with: to: self;
		tabSelector: self! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 13:13'!
newLeftButton
	"Answer a new button for scrolling left."

	^(ControlButtonMorph
			on: self
			getState: nil
			action: #scrollTabsLeft
			label: #leftButtonLabel)
		getEnabledSelector: #leftButtonEnabled;
		hResizing: #rigid;
		vResizing: #spaceFill;
		cornerStyle: #square;
		extent: self controlButtonWidth asPoint! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 13:13'!
newRightButton
	"Answer a new button for scrolling right."

	^(ControlButtonMorph
			on: self
			getState: nil
			action: #scrollTabsRight
			label: #rightButtonLabel)
		getEnabledSelector: #rightButtonEnabled;
		hResizing: #rigid;
		vResizing: #spaceFill;
		cornerStyle: #square;
		extent: self controlButtonWidth asPoint! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 12:34'!
newSpacer
	"Answer a spacer to place the controls to the right."

	^Morph new
		borderWidth: 0;
		color: Color transparent;
		extent: 0@0;
		minWidth: 0;
		hResizing: #spaceFill! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 11:17'!
nonVisibleTabs
	"Answer the tabs that are not currently visible."

	^self tabs select: [:t | t owner isNil]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 11:17'!
passivate
	"Update the non visible tabs too."

	super passivate.
	self nonVisibleTabs do: [:t | t passivate]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 13:51'!
relabelTab: aTab with: aStringOrMorph
	"Relabel the tab update tab layout."

	aTab label: aStringOrMorph.
	aTab owner ifNotNil: [
		self updateTabs.
		(aTab isSelected and: [aTab isVisible not])
			ifTrue: [self ensureSelectedTabIsVisible]]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 15:32'!
removeTabIndex: anInteger
	"Remove the tab at the given index and
	adjust any selected (next or first if was last)."
	
	self tabs removeAt: anInteger.
	self selectedIndex: 0.
	self tabs ifNotEmpty: [
		self selectedIndex: self selectedIndex - 1 \\ self tabs size + 1]
		! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 13:19'!
rightButtonEnabled
	"Answer whether the button for scrolling right should be enabled."

	^self wrapScrolling or: [self visibleTabRange last < self tabs size]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 13:47'!
rightButtonLabel
	"Answer the label for a button for scrolling right."

	^AlphaImageMorph new image: (
		ScrollBar
			arrowOfDirection: #right
			size: self controlButtonWidth - 3
			color: self paneColor darker)! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 11:41'!
scrollTabsLeft
	"Scroll left through the tabs."
	
	self visibleTabRange: (self visibleTabRange first < 2
		ifTrue: [0 to: self tabs size]
		ifFalse: [0 to: self visibleTabRange first - 1]).
	self updateTabs! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 11:15'!
scrollTabsRight
	"Scroll right through the tabs."
	
	self visibleTabRange: (self visibleTabRange last \\ self tabs size + 1 to: 0).
	self updateTabs! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:14'!
selectNextTab
	"Select the next tab, or the first if none selected."
	
	self selectedIndex: self selectedIndex \\ self tabs size + 1! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:18'!
selectPreviousTab
	"Select the previous tab, or the last if none selected."
	
	self selectedIndex: (self selectedIndex < 2
		ifTrue: [self tabs size]
		ifFalse: [self selectedIndex - 1])! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/15/2006 11:37'!
selectedIndex
	"Answer the value of selectedIndex"

	^ selectedIndex! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/10/2011 15:14'!
selectedIndex: index
	"Set the value of selectedIndex"

	|oldIndex|
	selectedIndex == index ifTrue: [^self].
	oldIndex := selectedIndex.
	selectedIndex := (index min: self tabs size).
	self visibleTabRange first > index
		ifTrue: [self visibleTabRange: ((index max: 1) to: 0)]
		ifFalse: [self visibleTabRange last < index
				ifTrue: [self visibleTabRange: (0 to: index)]].
	self updateTabs.
	self changed: #selectedIndex with: oldIndex! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/10/2010 14:16'!
selectedTab
	"Answer the selected tab."
	
	^self selectedIndex = 0
		ifFalse: [self tabs at: self selectedIndex ifAbsent: [nil]]! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 13:46'!
tabClicked: evt with: aMorph 
	"A tab has been clicked."
	
	self selectedIndex: (self tabs indexOf: aMorph)! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/7/2011 13:00'!
tabs

	^ tabs! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/7/2011 12:58'!
tabs: anObject

	tabs := anObject! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 11:14'!
tabsAndControls
	"Answer the tabs and scrolling controls that should be visible given the space."

	|visibleTabs firstIndex|
	self tabs ifEmpty: [
		self visibleTabRange: (1 to: 0).
		^#()].
	visibleTabs := self calculateVisibleTabs.
	visibleTabs ifEmpty: [
		self visibleTabRange: (1 to: 0).
		^#()].
	firstIndex := self tabs indexOf: visibleTabs first.
	self visibleTabRange: (firstIndex to: firstIndex + visibleTabs size - 1).
	visibleTabs size = self tabs size ifFalse: [
		visibleTabs
			add: self newSpacer;
			addAll: self controls.
		self cornerStyle = #rounded
			ifTrue: [visibleTabs add: self newEndSpacer]].
	^visibleTabs! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:00'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 17:08'!
updateFont
	"Update the label font."

	self tabs do: [:t | t font: self font].
	self updateTabs! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 11:04'!
updateTabs
	"Update the submorphs based on visible tabs."

	|tabsAndControls|
	tabsAndControls := self tabsAndControls.
	self removeAllMorphs.
	tabsAndControls ifEmpty: [^self].
	self
		addAllMorphs: self tabsAndControls;
		adoptPaneColor! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/8/2011 11:02'!
visibleTabRange

	^ visibleTabRange! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/8/2011 13:16'!
visibleTabRange: anInterval
	"Record the range of tabs that are visible.
	Also used when scrolling to determine starting index."
	
	visibleTabRange := anInterval.
	self
		changed: #leftButtonEnabled;
		changed: #rightButtonEnabled! !

!TabSelectorMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 11:19'!
visibleTabs
	"Answer the tabs that are currently visible."

	^self tabs select: [:t | t owner notNil]! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/8/2011 13:17'!
wrapScrolling

	^ wrapScrolling! !

!TabSelectorMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/8/2011 13:18'!
wrapScrolling: aBoolean
	"Set whether tab scrolling wraps around at each end."

	wrapScrolling := aBoolean.
	self
		changed: #leftButtonEnabled;
		changed: #rightButtonEnabled! !

!SmalltalkImage methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 10:30'!
theme
	^ UITheme current ! !

ThreePhaseButtonMorph subclass: #CheckboxButtonMorph
	uses: TEnableOnHaloMenu
	instanceVariableNames: 'repressedImage enabled isRadioButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!CheckboxButtonMorph commentStamp: 'gvc 5/23/2007 12:19' prior: 0!
Checkbox/radio - button only.!

CheckboxButtonMorph class
	uses: TEnableOnHaloMenu classTrait
	instanceVariableNames: ''!

!CheckboxButtonMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:21'!
checkBox
	"Answer a button pre-initialized with checkbox images."
	
	^self new
		beCheckbox! !

!CheckboxButtonMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 15:21'!
radioButton
	"Answer a button pre-initialized with radio button images."
	
	^self new
		beRadioButton! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 12/8/2008 19:17'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse.
	self cornerStyle: (self isRadioButton
		ifTrue: [self theme radioButtonCornerStyleFor: self]
		ifFalse: [self theme checkboxCornerStyleFor: self])! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 12/8/2008 19:16'!
beCheckbox
	"Change the images and square the border
	to be a checkbox."

	self
		isRadioButton: false;
		onImage: self theme checkboxMarkerForm;
		cornerStyle: (self theme checkboxCornerStyleFor: self);
		borderStyle: self borderStyleToUse! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 12/8/2008 19:16'!
beRadioButton
	"Change the images and round the border
	to be a radio button."

	self
		isRadioButton: true;
		onImage: self theme radioButtonMarkerForm;
		cornerStyle: (self theme radioButtonCornerStyleFor: self);
		borderStyle: self borderStyleToUse! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/27/2009 11:54'!
borderStyle: newStyle
	"Use narrowest image dimension."
	
	| newExtent |
	self borderStyle = newStyle ifTrue: [^self].
	super borderStyle: newStyle.
	newExtent := 2 * newStyle width + image extent min asPoint.
	bounds extent = newExtent ifFalse: [self extent: newExtent]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/29/2008 22:05'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self isRadioButton
		ifTrue: [self radioBorderStyleToUse]
		ifFalse: [self checkboxBorderStyleToUse]! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 11/5/2007 15:34'!
borderWidth: bw
	"Use narrowest image dimension."
	
	| newExtent |
	super borderWidth: bw.
	newExtent := 2 * bw + image extent min asPoint.
	bounds extent = newExtent ifFalse: [super extent: newExtent]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/29/2008 22:05'!
checkboxBorderStyleToUse
	"Answer the borderStyle that should be used for the receiver when it is a checkbox."
	
	^self selected
		ifTrue: [self enabled
			ifTrue: [self theme checkboxButtonSelectedBorderStyleFor: self]
			ifFalse: [self theme checkboxButtonSelectedDisabledBorderStyleFor: self]]
		ifFalse: [self enabled
			ifTrue: [self theme checkboxButtonNormalBorderStyleFor: self]
			ifFalse: [self theme checkboxButtonDisabledBorderStyleFor: self]]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/29/2008 22:04'!
checkboxFillStyleToUse
	"Answer the fillStyle that should be used for the receiver when it is a checkbox."
	
	^self selected
		ifTrue: [self enabled
			ifTrue: [self theme checkboxButtonSelectedFillStyleFor: self]
			ifFalse: [self theme checkboxButtonSelectedDisabledFillStyleFor: self]]
		ifFalse: [self enabled
			ifTrue: [self theme checkboxButtonNormalFillStyleFor: self]
			ifFalse: [self theme checkboxButtonDisabledFillStyleFor: self]]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:38'!
colorToUse
	"Answer the color we should use."

	^self paneColor! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 14:16'!
disable
	"Disable the receiver."
	
	self enabled: false! !

!CheckboxButtonMorph methodsFor: 'drawing' stamp: 'gvc 5/23/2007 11:48'!
drawOn: aCanvas
	"Draw the image for the current state."
	
	|img|
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
	img := self imageToUse.
	img ifNotNil: [
		aCanvas
			translucentImage: img
			at: self innerBounds center - (img extent // 2)].
	(self state == #pressed or: [self state == #repressed]) ifTrue: [
		aCanvas fillRectangle: self innerBounds fillStyle: (self paneColor alpha: 0.3)].
	self enabled ifFalse: [aCanvas fillRectangle: self innerBounds fillStyle: (self paneColor alpha: 0.4)]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/2/2007 14:16'!
enable
	"Enable the receiver."
	
	self enabled: true! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 16:04'!
enabled
	"Answer the value of enabled"

	^ enabled! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 7/30/2009 14:11'!
enabled: anObject
	"Set the value of enabled"

	enabled = anObject ifTrue: [^self].
	enabled := anObject.
	self changed: #enabled.
	self
		adoptPaneColor: self paneColor;
		changed! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/29/2008 21:56'!
fillStyleToUse
	"Answer the fillStyle that should be used for the receiver."
	
	^self isRadioButton
		ifTrue: [self radioFillStyleToUse]
		ifFalse: [self checkboxFillStyleToUse]! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 11/5/2007 15:28'!
image: anImage 
	"Fixed to take account of border width. Use narrowest
	dimanesion of image to allow a little flexibility."
	
	image := anImage depth = 1 
				ifTrue: [ColorForm mappingWhiteToTransparentFrom: anImage]
				ifFalse: [anImage]. 
	self extent: 2 * self borderWidth + image extent min asPoint.
	self changed! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:46'!
imageToUse
	"Answer the image we should use."

	^state caseOf: {
		[#off] -> [self offImage].
		[#pressed] -> [self pressedImage].
		[#on] -> [self onImage].
		[#repressed] -> [self repressedImage ifNil: [self onImage]]}
		otherwise: []! !

!CheckboxButtonMorph methodsFor: 'initialization' stamp: 'gvc 10/25/2007 17:36'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		isRadioButton: false;
		enabled: true;
		onImage: self theme checkboxMarkerForm;
		fillStyle: self fillStyleToUse;
		borderStyle: self borderStyleToUse! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/25/2007 17:34'!
isRadioButton
	"Answer the value of isRadioButton"

	^ isRadioButton! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/25/2007 17:34'!
isRadioButton: anObject
	"Set the value of isRadioButton"

	isRadioButton := anObject! !

!CheckboxButtonMorph methodsFor: 'event handling' stamp: 'gvc 9/18/2006 13:40'!
mouseDown: evt
	"Handle the transitions."
	
	self enabled ifFalse: [^self perform: #mouseDown: withArguments: {evt} inSuperclass: Morph].
	self isOn
		ifTrue: [self state: #repressed]
		ifFalse: [self state: #pressed].
	actWhen == #buttonDown
		ifTrue:
			[self doButtonAction].
	self mouseStillDown: evt.! !

!CheckboxButtonMorph methodsFor: 'event handling' stamp: 'gvc 8/17/2006 16:34'!
mouseMove: evt
	"Check for straying."
	
	self enabled ifFalse: [^self perform: #mouseMove: withArguments: {evt} inSuperclass: Morph].
	(self containsPoint: evt cursorPoint)
		ifTrue: [state == #on
					ifTrue: [self state: #repressed].
				state == #off
					ifTrue: [self state: #pressed].
				self perform: #mouseMove: withArguments: {evt} inSuperclass: Morph]
				"Allow on:send:to: to set the response to events other than actWhen"
		ifFalse: [state == #repressed
					ifTrue: [self state: #on].
				state == #pressed
					ifTrue: [self state: #off]].
! !

!CheckboxButtonMorph methodsFor: 'event handling' stamp: 'gvc 8/17/2006 16:35'!
mouseUp: evt
	"Allow on:send:to: to set the response to events other than actWhen"
	
	self enabled ifFalse: [^self perform: #mouseUp: withArguments: {evt} inSuperclass: Morph].
	actWhen == #buttonUp
		ifFalse: [^self perform: #mouseUp: withArguments: {evt} inSuperclass: Morph].
	(self containsPoint: evt cursorPoint)
		ifTrue: [state == #repressed
					ifTrue: [self state: #off]
					ifFalse: [self state: #on].
				self doButtonAction: evt]
		ifFalse: [target ifNotNil: [target mouseUpBalk: evt]].
	^self perform: #mouseDown: withArguments: {evt} inSuperclass: Morph! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/29/2008 22:04'!
radioBorderStyleToUse
	"Answer the borderStyle that should be used for the receiver when it is a radio button."
	
	^self selected
		ifTrue: [self enabled
			ifTrue: [self theme radioButtonSelectedBorderStyleFor: self]
			ifFalse: [self theme radioButtonSelectedDisabledBorderStyleFor: self]]
		ifFalse: [self enabled
			ifTrue: [self theme radioButtonNormalBorderStyleFor: self]
			ifFalse: [self theme radioButtonDisabledBorderStyleFor: self]]! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 2/29/2008 21:58'!
radioFillStyleToUse
	"Answer the fillStyle that should be used for the receiver when it is a radio button."
	
	^self selected
		ifTrue: [self enabled
			ifTrue: [self theme radioButtonSelectedFillStyleFor: self]
			ifFalse: [self theme radioButtonSelectedDisabledFillStyleFor: self]]
		ifFalse: [self enabled
			ifTrue: [self theme radioButtonNormalFillStyleFor: self]
			ifFalse: [self theme radioButtonDisabledFillStyleFor: self]]! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:17'!
repressedImage
	"Answer the value of repressedImage"

	^ repressedImage! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 15:18'!
repressedImage: anObject
	"Set the value of repressedImage. This is shown when
	pressed after being off."

	repressedImage := anObject.
	self invalidRect: self bounds! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/25/2006 17:46'!
selected
	"Answer the state taking account of the intermediate states."

	^self state == #repressed or: [self state == #on]! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 18:00'!
selected: aBoolean
	"Set the state taking account of the intermediate states."

	(self state == #pressed or: [self state == #repressed])
		ifTrue: [self state: (aBoolean ifTrue: [#repressed] ifFalse: [#pressed])]
		ifFalse: [self state: (aBoolean ifTrue: [#on] ifFalse: [#off])]! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 8/17/2006 16:41'!
state
	"Answer the state."

	^state! !

!CheckboxButtonMorph methodsFor: 'accessing' stamp: 'gvc 2/29/2008 21:53'!
state: newState
	"Change the image and invalidate the rect."

	newState == state ifTrue: [^ self].
	state := newState.
	self
		adoptPaneColor: self paneColor;
		changed! !

!CheckboxButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 12/8/2008 19:17'!
themeChanged
	"Update the on image."

	self onImage: (self isRadioButton
		ifTrue: [self theme radioButtonMarkerForm]
		ifFalse: [self theme checkboxMarkerForm]).
	self adoptPaneColor: self paneColor.
	super themeChanged! !

CheckboxButtonMorph subclass: #TickSelectionCheckboxButtonMorph
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TickSelectionCheckboxButtonMorph commentStamp: '<historical>' prior: 0!
A TickSelectionCheckboxButtonMorph is the button hidden into the TickSelectionCheckboxMorph!

!TickSelectionCheckboxButtonMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:30'!
index: anIndex

	index := anIndex! !

!TickSelectionCheckboxButtonMorph methodsFor: 'event' stamp: 'BenjaminVanRyseghem 9/19/2011 16:56'!
mouseUp: evt
	"Handle the transitions."
	| result |
	result := super mouseUp: evt.
	self pressed: index.
	^ result ! !

!TickSelectionCheckboxButtonMorph methodsFor: 'event' stamp: 'BenjaminVanRyseghem 9/17/2011 05:05'!
pressed: anIndex

	self owner pressed: anIndex! !

MorphTreeMorph subclass: #TickSelectionListMorph
	instanceVariableNames: 'storeValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TickSelectionListMorph commentStamp: '<historical>' prior: 0!
A TickSelectionListMorph is used to render the tick list

storeValue
	- xxxxx
!

!TickSelectionListMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 03:08'!
indentingItemClass
	
	^ TickSelectionListNodeMorph! !

!TickSelectionListMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 03:25'!
mouseUp: event 

	self storeValue: nil.
	super mouseUp: event ! !

!TickSelectionListMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 03:25'!
storeValue

	^ storeValue! !

!TickSelectionListMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 03:25'!
storeValue: anObject
	
	storeValue := anObject! !

Morph subclass: #BracketMorph
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!BracketMorph commentStamp: 'gvc 5/18/2007 13:48' prior: 0!
Morph displaying opposing arrows.!

!BracketMorph methodsFor: 'drawing' stamp: 'gvc 9/21/2006 16:16'!
drawOn: aCanvas
	"Draw triangles at the edges."
	
	|r|
	r := self horizontal
		ifTrue: [self bounds insetBy: (2@1 corner: 2@1)]
		ifFalse: [self bounds insetBy: (1@2 corner: 1@2)].
	aCanvas
		drawPolygon: (self leftOrTopVertices: self bounds)
		fillStyle: self borderColor;
		drawPolygon: (self leftOrTopVertices: r)
		fillStyle: self fillStyle;
		drawPolygon: (self rightOrBottomVertices: self bounds)
		fillStyle: self borderColor;
		drawPolygon: (self rightOrBottomVertices: r)
		fillStyle: self fillStyle! !

!BracketMorph methodsFor: 'accessing' stamp: 'gvc 9/21/2006 15:48'!
horizontal
	"Answer whether horizontal or vertical."
	
	^self orientation == #horizontal! !

!BracketMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 15:54'!
horizontal: aBoolean
	"Set whether horizontal or vertical."
	
	^self orientation: (aBoolean ifTrue: [#horizontal] ifFalse: [#vertical])! !

!BracketMorph methodsFor: 'initialization' stamp: 'gvc 9/19/2006 15:52'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		orientation: #horizontal! !

!BracketMorph methodsFor: 'geometry' stamp: 'gvc 9/21/2006 15:45'!
leftOrTopVertices: r
	"Answer the vertices for a left or top bracket in the given rectangle."
	
	^self orientation == #vertical
		ifTrue: [{r topLeft - (0@1). r left + (r height // 2 + (r height \\ 2))@(r center y - (r height + 1 \\ 2)).
				r left + (r height // 2 + (r height \\ 2))@(r center y). r bottomLeft}]
		ifFalse: [{r topLeft. (r center x - (r width + 1 \\ 2))@(r top + (r width // 2 + (r width \\ 2))).
				r center x@(r top + (r width // 2 + (r width \\ 2))). r topRight}]! !

!BracketMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 15:51'!
orientation
	"Answer the value of orientation"

	^ orientation! !

!BracketMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 15:52'!
orientation: anObject
	"Set the value of orientation"

	orientation := anObject.
	self changed! !

!BracketMorph methodsFor: 'geometry' stamp: 'gvc 9/21/2006 16:18'!
rightOrBottomVertices: r
	"Answer the vertices for a right or bottom bracket in the given rectangle."
	
	^self orientation == #vertical
		ifTrue: [{r topRight - (0@1). r right - (r height // 2 + (r height \\ 2))@(r center y - (r height + 1 \\ 2)).
				r right - (r height // 2 + (r height \\ 2))@(r center y). r bottomRight}]
		ifFalse: [{(r center x)@(r bottom - 1 - (r width // 2 + (r width \\ 2))).
				r center x @(r bottom - 1 - (r width // 2 + (r width \\ 2))). r bottomRight. r bottomLeft - (1@0)}]! !

Morph subclass: #FullscreenMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!FullscreenMorph commentStamp: 'gvc 5/18/2007 13:04' prior: 0!
Provides for another morph to occupy the full screen area (less docking bars).!

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/30/2006 10:44'!
contentMorph
	"Answer the current content."
	
	^self submorphs first! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 12/3/2007 12:39'!
defaultColor
	"Return the receiver's default color."
	
	^Color white! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:21'!
edgeToAdhereTo
	"Must implement. Answer #none."
	
	^#none! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 12:57'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		changeProportionalLayout;
		bounds: World clearArea;
		beSticky! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:15'!
isAdheringToBottom
	"Must implement. Answer false."
	
	^false! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:15'!
isAdheringToLeft
	"Must implement. Answer false."
	
	^false! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:15'!
isAdheringToRight
	"Must implement. Answer false."
	
	^false! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:15'!
isAdheringToTop
	"Must implement. Answer false."
	
	^false! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:11'!
isDockingBar
	"Answer yes so we get updated when the Display is resized."

	^true! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:39'!
layoutChanged
	"Don't pass to owner, since the receiver doesn't care!! Improves frame rate."
	
	fullBounds := nil.
	self layoutPolicy ifNotNil:[:l | l flushLayoutCache].! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/30/2006 14:06'!
openAsIs
	"Open in the current world with the current position and extent."
	
	^self openAsIsIn: self currentWorld
! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 10:03'!
openAsIsIn: aWorld
	"Start stepping."
	
	aWorld addMorph: self.
	(self submorphs notEmpty and: [self submorphs first isSystemWindow])
		ifTrue: [self submorphs first openedFullscreen].
	aWorld startSteppingSubmorphsOf: self! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 09:04'!
openInWorld: aWorld
	"Open as is."
	
	^self openAsIsIn: aWorld! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 09:08'!
setContentMorph: aMorph
	"Replace the submorphs with aMorph."
	
	self removeAllMorphs.
	self
		addMorph: aMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1))! !

!FullscreenMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 19:27'!
updateBounds
	"Update the receiver's bounds to fill the world."

	self bounds: self owner clearArea
	! !

Morph subclass: #GeneralScrollPane
	instanceVariableNames: 'scroller hScrollbar vScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!GeneralScrollPane commentStamp: 'gvc 5/18/2007 13:01' prior: 0!
A scroll pane that handles its contents accurately.!

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/20/2011 13:19'!
adoptPaneColor: paneColor
	"Adopt the given pane color."
	
	super adoptPaneColor: paneColor.
	self hScrollbar adoptPaneColor: paneColor.
	self vScrollbar adoptPaneColor: paneColor! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/11/2011 13:15'!
changeScrollerTableLayout
	"Change the scroller's layout policy to a table layout."

	self scroller changeTableLayout! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 12:23'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^ Color transparent! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:43'!
defaultScrollTarget
	"Answer a new default scroll target."

	^RectangleMorph new
		extent: 200@150! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/11/2011 13:33'!
doLayoutIn: layoutBounds 
	"Compute a new layout based on the given layout bounds."

	|scrollbarChange|
	super doLayoutIn: layoutBounds.
	scrollbarChange := (self vScrollbarShowing = self vScrollbarNeeded) not.
	scrollbarChange := scrollbarChange or: [(self hScrollbarShowing = self hScrollbarNeeded) not].
	self	updateScrollbars.
	scrollbarChange ifFalse: [self resizeScroller]. "if there is a scrollbar change then done already"
	super doLayoutIn: layoutBounds
! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/8/2006 11:06'!
extent: newExtent
	"Update the receiver's extent. Hide/show the scrollbars and resize the scroller
	as neccessary."
	
	|scrollbarChange|
	bounds extent = newExtent ifTrue: [^ self].
	super extent: newExtent.
	scrollbarChange := (self vScrollbarShowing = self vScrollbarNeeded) not.
	scrollbarChange := scrollbarChange or: [(self hScrollbarShowing = self hScrollbarNeeded) not].
	self	updateScrollbars.
	scrollbarChange ifFalse: [self resizeScroller] "if there is a scrollbar change then done already"! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
fitScrollTarget
	"If the scroller is bigger than the scroll target then
	resize the scroll target to fill the scroller."
	
	|extra|
	extra := 0.
	self scroller width > self scrollTarget width
		ifTrue: [self scrollTarget width: self scroller width]
		ifFalse: [extra := self scrollBarThickness].
	self scroller height - extra > self scrollTarget height
		ifTrue: [self scrollTarget height: self scroller height + extra]! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:25'!
hHideScrollbar
	"Hide the horizontal scrollbar."
	
	self hScrollbarShowing ifFalse: [^self].
	self removeMorph: self hScrollbar.
	self vResizeScrollbar.
	self resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:49'!
hPageDelta
	"Answer the horizontal page delta."
	
	|pd tw sw|
	tw := self scrollTarget width.
	sw := self scrollBounds width.
	pd := tw - sw  max: 0.
	pd = 0 ifFalse: [pd := sw / pd].
	^pd! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
hResizeScrollbar
	"Resize the horizontal scrollbar to fit the receiver."
	
	|b|
	b := self innerBounds.
	b := b top: b bottom - self scrollBarThickness.
	self vScrollbarShowing ifTrue: [
		b := b right: b right - self scrollBarThickness].
	self hScrollbar bounds: b! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
hScrollbar
	"Answer the value of hScrollbar"

	^ hScrollbar! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
hScrollbar: anObject
	"Set the value of hScrollbar"

	hScrollbar := anObject! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:37'!
hScrollbarInterval
	"Answer the computed size of the thumb of the horizontal scrollbar."
	
	^self scrollBounds width asFloat / self scrollTarget width min: 1.0.! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/11/2011 14:14'!
hScrollbarNeeded
	"Return whether the horizontal scrollbar is needed."
	
	^self scrollTarget width +
		(self scrollTarget height > self innerBounds height
			 ifTrue: [self scrollBarThickness] ifFalse: [0]) >
		self innerBounds width! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:07'!
hScrollbarShowing
	"Answer whether the horizontal scrollbar is showing."
	
	^self hScrollbar owner notNil
	! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:49'!
hScrollbarValue
	"Answer the computed horizontal scrollbar value."
	
	|tw sw v|
	tw := self scrollTarget width.
	sw := self scrollBounds width.
	v := tw - sw  max: 0.
	v = 0 ifFalse: [v :=  self scroller offset x asFloat / v min: 1.0].
	^v! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/19/2006 10:30'!
hScrollbarValue: scrollValue
	"Set the offset of the scroller to match the 0.0-1.0 scroll value."
	
	|r|
	r := self scrollTarget width - self scrollBounds width max: 0.
	self scroller
		offset: (r * scrollValue) rounded @ self scroller offset y! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:50'!
hSetScrollDelta
	"Set the horizontal scrollbar delta, value and interval, based on the current scroll bounds and offset."
	
	|pd|
	pd := self hPageDelta.
	self hScrollbar
		scrollDelta: pd / 10 
		pageDelta: pd;
		interval: self hScrollbarInterval;
		setValue: self hScrollbarValue! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:28'!
hShowScrollbar
	"Show the horizontal scrollbar."
	
	self hResizeScrollbar.
	self hScrollbarShowing ifTrue: [^self].
	self privateAddMorph: self hScrollbar atIndex: 1.
	self vResizeScrollbar.
	self resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 12/9/2008 12:06'!
hUpdateScrollbar
	"Update the visibility and dimensions of the horizontal scrollbar as needed."
	
	self hScrollbarNeeded
		ifTrue: [self
					hShowScrollbar;
					hResizeScrollbar]
		ifFalse: [self hHideScrollbar]! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 12:16'!
handlesKeyboard: evt
	"Yes for page up/down."
	
	^true! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 1/28/2008 16:49'!
handlesMouseWheel: evt
	"Do I want to receive mouseWheel events?." 

	^true! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:54'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		scroller: self newScroller;
		hScrollbar: self newHScrollbar;
		vScrollbar: self newVScrollbar;
		scrollTarget: self defaultScrollTarget.
	self
		addMorph: self scroller;
		resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 12:16'!
keyStroke: evt
	"If pane is not empty, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"

	(self scrollByKeyboard: evt) ifTrue: [^self].
	self scrollTarget keyStroke: evt! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'GaryChambers 9/8/2011 10:40'!
minHeight
	"Fit the width of the scroll target if vResizing is shrinkWrap."
	
	^self vResizing = #shrinkWrap
		ifTrue: [self scrollTarget minExtent y + self scrollbarThickness + 5]
		ifFalse: [super minHeight]! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'GaryChambers 9/8/2011 10:40'!
minWidth
	"Fit the width of the scroll target if hResizing is shrinkWrap."
	
	^self hResizing = #shrinkWrap
		ifTrue: [self scrollTarget minExtent x + self scrollbarThickness + 5]
		ifFalse: [super minWidth]! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 1/28/2008 16:55'!
mouseWheel: event 
	"Handle a mouseWheel event."
	
	(self scrollTarget handlesMouseWheel: event)
		ifTrue: [^self scrollTarget mouseWheel: event]. "pass on"
	event direction = #up ifTrue: [
		vScrollbar scrollUp: 3].
	event direction = #down ifTrue: [
		vScrollbar scrollDown: 3]! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 7/22/2011 19:07'!
newHScrollbar
	"Answer a new horizontal scrollbar."

	^GeneralScrollBar new
		model: self accessor: #hScrollbarValue! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/11/2011 13:14'!
newScroller
	"Answer a new scroller."

	^TransformWithLayoutMorph new
		color: Color transparent! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 7/22/2011 19:07'!
newVScrollbar
	"Answer a new vertical scrollbar."

	^GeneralScrollBar new
		model: self accessor: #vScrollbarValue! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:57'!
resizeScroller
	"Resize the scroller to fit the scroll bounds."
	
	self scroller bounds: self scrollBounds! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:06'!
scrollBarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^self theme scrollbarThickness! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
scrollBounds
	"Return the visible scroll area taking into account whether
	the scrollbars need to be shown."
	
	|b|
	b := self innerBounds.
	self vScrollbarNeeded ifTrue: [b := b right: (b right - self scrollBarThickness)].
	self hScrollbarNeeded ifTrue: [b := b bottom: (b bottom - self scrollBarThickness)].
	^b! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:50'!
scrollByKeyboard: event 
	"If event is ctrl+up/down then scroll and answer true."
	
	|sb|
	sb := event commandKeyPressed
		ifTrue: [self hScrollbar]
		ifFalse: [self vScrollbar].
	(event keyValue = 30 or: [event keyValue = 11]) ifTrue: [
		sb scrollUp: 3.
		^true].
	(event keyValue = 31 or: [event keyValue = 12])ifTrue: [
		sb scrollDown: 3.
		^true].
	^false! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 09:48'!
scrollTarget
	"Answer the morph that is scrolled."
	
	^self scroller submorphs first! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:48'!
scrollTarget: aMorph
	"Set the morph that is scrolled."
	
	self scroller
		removeAllMorphs;
		addMorph: aMorph.
	self updateScrollbars! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2008 10:19'!
scrollToShow: aRectangle
	"Scroll to include as much of aRectangle as possible, where aRectangle is in the scroller's local space."
	
	|offset|
	offset := self scroller offset.
	((aRectangle top - offset y) >= 0 and: [
		(aRectangle bottom - offset y) <= self innerBounds height])
		ifFalse: [offset := offset x @ (
					(aRectangle top min: self scrollTarget height - self innerBounds height))].
	((aRectangle left - offset x) >= 0 and: [
		(aRectangle right - offset x) <= self innerBounds width])
		ifFalse: [offset := (aRectangle left min: self scrollTarget width - self innerBounds width) @ offset y].
	offset = self scroller offset ifFalse: [
		self scroller offset: offset.
		self setScrollDeltas]! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/17/2009 14:29'!
scrollbarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^ self theme scrollbarThickness! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 09:40'!
scroller
	"Answer the value of scroller"

	^ scroller! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 09:40'!
scroller: anObject
	"Set the value of scroller"

	scroller := anObject! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 11:16'!
setScrollDeltas
	"Set the ScrollBar deltas, value and interval, based on the current scroll pane size, offset and range."
	
	self
		hSetScrollDelta;
		vSetScrollDelta! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 11:16'!
updateScrollbars
	"Update the visibility, dimensions and values of the scrollbars as needed."
	
	self
		vUpdateScrollbar;
		hUpdateScrollbar;
		setScrollDeltas! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:25'!
vHideScrollbar
	"Hide the vertical scrollbar."
	
	self vScrollbarShowing ifFalse: [^self].
	self removeMorph: self vScrollbar.
	self hResizeScrollbar.
	self resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:47'!
vLeftoverScrollRange
	"Return the entire scrolling range minus the currently viewed area."
	
	^self scrollTarget height - self scrollBounds height max: 0
! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:50'!
vPageDelta
	"Answer the vertical page delta."
	
	|pd tw sw|
	tw := self scrollTarget height.
	sw := self scrollBounds height.
	pd := tw - sw  max: 0.
	pd = 0 ifFalse: [pd := sw / pd].
	^pd! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/3/2008 13:07'!
vResizeScrollbar
	"Resize the vertical scrollbar to fit the receiver."
	
	|b|
	b := self innerBounds.
	b := b left: b right - self scrollBarThickness.
	self hScrollbarShowing ifTrue: [
		b := b bottom: b bottom - self scrollBarThickness].
	self vScrollbar bounds: b! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
vScrollbar
	"Answer the value of vScrollbar"

	^ vScrollbar! !

!GeneralScrollPane methodsFor: 'accessing' stamp: 'gvc 9/7/2006 10:16'!
vScrollbar: anObject
	"Set the value of vScrollbar"

	vScrollbar := anObject! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 13:48'!
vScrollbarInterval
	"Answer the computed size of the thumb of the vertical scrollbar."
	
	^self scrollBounds height asFloat / self scrollTarget height min: 1.0.! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/11/2011 14:13'!
vScrollbarNeeded
	"Return whether the vertical scrollbar is needed."
	
	^self scrollTarget height +
		(self scrollTarget width > self innerBounds width
			 ifTrue: [self scrollBarThickness] ifFalse: [0]) >
		self innerBounds height! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:15'!
vScrollbarShowing
	"Answer whether the vertical scrollbar is showing."
	
	^self vScrollbar owner notNil
	! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:50'!
vScrollbarValue
	"Answer the computed vertical scrollbar value."
	
	|tw sw v|
	tw := self scrollTarget height.
	sw := self scrollBounds height.
	v := tw - sw  max: 0.
	v = 0 ifFalse: [v := self scroller offset y asFloat / v min: 1.0].
	^v! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 10/19/2006 10:30'!
vScrollbarValue: scrollValue
	"Set the offset of the scroller to match the 0.0-1.0 scroll value."
	
	|r|
	r := self scrollTarget height - self scrollBounds height max: 0.
	self scroller
		offset: self scroller offset x @ (r * scrollValue) rounded! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:51'!
vSetScrollDelta
	"Set the vertical scrollbar delta, value and interval, based on the current scroll bounds and offset."
	
	|pd|
	pd := self vPageDelta.
	self vScrollbar
		scrollDelta: pd / 10 
		pageDelta: pd;
		interval: self vScrollbarInterval;
		setValue: self vScrollbarValue! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:28'!
vShowScrollbar
	"Show the vertical scrollbar."
	
	self vResizeScrollbar.
	self vScrollbarShowing ifTrue: [^self].
	self privateAddMorph: self vScrollbar atIndex: 1.
	self hResizeScrollbar.
	self resizeScroller! !

!GeneralScrollPane methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2006 10:03'!
vUpdateScrollbar
	"Update the visibility and dimensions of the vertical scrollbar as needed."
	
	self vScrollbarNeeded
		ifTrue: [self
				vShowScrollbar;
				vResizeScrollbar]
		ifFalse: [self vHideScrollbar]! !

Morph subclass: #HSVAColorSelectorMorph
	instanceVariableNames: 'hsvMorph aMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!HSVAColorSelectorMorph commentStamp: 'gvc 5/18/2007 12:55' prior: 0!
Colour selector featuring a saturation/volume area, hue selection strip and alpha selection strip.!

!HSVAColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 14:05'!
aMorph
	"Answer the value of aMorph"

	^ aMorph! !

!HSVAColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 14:05'!
aMorph: anObject
	"Set the value of aMorph"

	aMorph := anObject! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:58'!
alphaSelected: aFloat
	"The alpha has changed."

	self triggerSelectedColor! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:58'!
colorSelected: aColor
	"A color has been selected. Set the base color for the alpha channel."

	self aMorph color: aColor.
	self triggerSelectedColor! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 13:44'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^Color transparent
! !

!HSVAColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 14:05'!
hsvMorph
	"Answer the value of hsvMorph"

	^ hsvMorph! !

!HSVAColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 14:05'!
hsvMorph: anObject
	"Set the value of hsvMorph"

	hsvMorph := anObject! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:47'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		extent: 180@168;
		changeTableLayout;
		cellInset: 4;
		aMorph: self newAColorMorph;
		hsvMorph: self newHSVColorMorph;
		addMorphBack: self hsvMorph;
		addMorphBack: self aMorph.
	self aMorph color: self hsvMorph selectedColor! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:11'!
newAColorMorph
	"Answer a new alpha color morph."

	^AColorSelectorMorph new
		model: self;
		hResizing: #spaceFill;
		vResizing: #rigid;
		setValueSelector: #alphaSelected:;
		extent: 24@24! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 14:00'!
newHSVColorMorph
	"Answer a new hue/saturation/volume color morph."

	^HSVColorSelectorMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		when: #colorSelected send: #colorSelected: to: self! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 14:18'!
selectedColor
	"Answer the selected color."

	^self hsvMorph selectedColor alpha: self aMorph value! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:12'!
selectedColor: aColor
	"Set the hue and sv components."

	self aMorph value: aColor alpha.
	self hsvMorph selectedColor: aColor asNontranslucentColor! !

!HSVAColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 09:57'!
triggerSelectedColor
	"Trigger the event for the selected colour"

	self triggerEvent: #selectedColor with: self selectedColor! !

Morph subclass: #HSVColorSelectorMorph
	instanceVariableNames: 'svMorph hMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!HSVColorSelectorMorph commentStamp: 'gvc 5/18/2007 12:55' prior: 0!
Colour selector featuring a saturation/volume area and a hue selection strip.!

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:28'!
colorSelected: aColor
	"A color has been selected. Make the hue match."

	"self hMorph value: aColor hue / 360.
	self svMorph basicColor: (Color h: aColor hue s: 1.0 v: 1.0)."
	self triggerEvent: #colorSelected with: aColor! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 13:44'!
defaultColor
	"Answer the default color/fill style for the receiver."
	
	^Color transparent
! !

!HSVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/21/2006 13:30'!
hMorph
	"Answer the value of hMorph"

	^ hMorph! !

!HSVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/21/2006 13:30'!
hMorph: anObject
	"Set the value of hMorph"

	hMorph := anObject! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:23'!
hue: aFloat
	"Set the hue in the range 0.0 - 1.0. Update the SV morph and hMorph."

	self hMorph value: aFloat.
	self svMorph color: (Color h: aFloat * 359.9 s: 1.0 v: 1.0)! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 12:25'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderWidth: 0;
		changeTableLayout;
		cellInset: 4;
		listDirection: #leftToRight;
		cellPositioning: #topLeft;
		svMorph: self newSVColorMorph;
		hMorph: self newHColorMorph;
		addMorphBack: self svMorph;
		addMorphBack: self hMorph;
		extent: 192@152;
		hue: 0.5! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 12:33'!
newHColorMorph
	"Answer a new hue color morph."

	^HColorSelectorMorph new
		model: self;
		setValueSelector: #hue:;
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: 36@36! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 12:54'!
newSVColorMorph
	"Answer a new saturation/volume color morph."

	^SVColorSelectorMorph new
		extent: 152@152;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		when: #colorSelected send: #colorSelected: to: self! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 13:41'!
selectedColor
	"Answer the selected color."

	^self svMorph selectedColor! !

!HSVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 13:38'!
selectedColor: aColor
	"Set the hue and sv components."

	self hue: aColor hue / 360.
	self svMorph selectedColor: aColor! !

!HSVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 12:26'!
svMorph
	"Answer the value of svMorph"

	^ svMorph! !

!HSVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 12:26'!
svMorph: anObject
	"Set the value of svMorph"

	svMorph := anObject! !

Morph subclass: #ImagePreviewMorph
	instanceVariableNames: 'imageMorph textMorph defaultImageForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ImagePreviewMorph commentStamp: 'gvc 5/18/2007 12:51' prior: 0!
Displays an image scaled to a fixed size along with a label describing the original dimensions.!

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:33'!
cornerStyle: aSymbol
	"Pass on to selector and content too."

	super cornerStyle: aSymbol.
	self imageMorph cornerStyle: aSymbol! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:59'!
defaultImageFormOfSize: aPoint
	"Answer a default preview image form."

	^(defaultImageForm isNil or: [defaultImageForm extent ~= aPoint])
		ifTrue: [defaultImageForm := Form extent: aPoint]
		ifFalse: [defaultImageForm]! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 12:38'!
image: form size: imageSize
	"Set the image and update the description."
	
	form
		ifNil: [self imageMorph
				image: (self defaultImageFormOfSize: imageSize).
			self textMorph
				contents: '']
	ifNotNil: [self imageMorph
				image: form
				size: imageSize.
			self textMorph
				contents: ('{1} x {2} pixels' translated
							format: {form width asString. form height asString})]
	! !

!ImagePreviewMorph methodsFor: 'accessing' stamp: 'gvc 10/9/2006 14:25'!
imageMorph
	"Answer the value of imageMorph"

	^ imageMorph! !

!ImagePreviewMorph methodsFor: 'accessing' stamp: 'gvc 10/9/2006 14:25'!
imageMorph: anObject
	"Set the value of imageMorph"

	imageMorph := anObject! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:42'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		changeTableLayout;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		cellInset: 16;
		imageMorph: self newImageMorph;
		textMorph: self newTextMorph;
		addMorphBack: self imageMorph;
		addMorphBack: self textMorph! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:42'!
newImageMorph
	"Answer a new image morph."

	^AlphaImageMorph new
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		alpha: 1.0! !

!ImagePreviewMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 14:34'!
newTextMorph
	"Answer a new text morph."

	^StringMorph contents: ''! !

!ImagePreviewMorph methodsFor: 'accessing' stamp: 'gvc 10/9/2006 14:25'!
textMorph
	"Answer the value of textMorph"

	^ textMorph! !

!ImagePreviewMorph methodsFor: 'accessing' stamp: 'gvc 10/9/2006 14:25'!
textMorph: anObject
	"Set the value of textMorph"

	textMorph := anObject! !

!Morph class methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/23/2007 15:48'!
theme
	"Answer the ui theme that provides controls."

	^UITheme current! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/21/2008 16:50'!
activate
	"Mark the receiver and submorphs as active (foreground)."

	self submorphsDo: [:m | m activate]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/18/2006 11:58'!
adoptPaneColor
	"Adopt our pane color."

	self adoptPaneColor: self paneColor! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/20/2009 18:42'!
boundsWithinCorners
 	"Changed to be more realistic..."
	
	^self bounds insetBy: 2! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/16/2007 11:26'!
changed
	"Report that the area occupied by this morph should be redrawn.
	Fixed to include submorphs outside the outerBounds."
	
	^fullBounds 
		ifNil: [self invalidRect: self privateFullBounds]
		ifNotNil: [self invalidRect: fullBounds]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/20/2007 10:31'!
defaultTaskbarThumbnailExtent
	"Answer the default size of a taskbar thumbnail for the receiver."

	^320@320! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/10/2007 13:40'!
dialogWindow
	"Answer the receiver's dialog window."

	^self ownerThatIsA: DialogWindow! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/5/2007 12:55'!
drawKeyboardFocusOn: aCanvas
	"Draw the keyboard focus indication."

	self focusIndicatorMorph
		drawOn: aCanvas! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 12:21'!
enabled
	"Answer whether the receiver is enabled."

	^true! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/16/2009 11:15'!
expandFullBoundsForDropShadow: aRectangle
	"Return an expanded rectangle for an eventual drop shadow."
	
	^(aRectangle expandBy: self shadowOffsetRectangle)
		quickMerge: aRectangle! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 14:29'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^self bounds! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/25/2008 22:42'!
focusChanged
	"Report that the area occupied by the morph's focus indicator should be redrawn.
	Optimized for border-only (no fill)."
	
	|rects fm|
	fm := self focusIndicatorMorph.
	fm fillStyle isTransparent
		ifTrue: [fm borderWidth > 0 ifTrue: [
					rects := fm bounds areasOutside: (fm bounds insetBy: fm borderWidth).
					rects do: [:r | self invalidRect: r]]]
		ifFalse: [self invalidRect: fm bounds]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 14:59'!
focusColor
	"Answer the keyboard focus indication color."

	^self borderStyle color contrastingColor! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/9/2009 17:44'!
focusIndicatorCornerRadius
	"Answer the corner radius preferred for the focus indicator
	for the receiver for themes that support this."

	^self theme focusIndicatorCornerRadiusFor: self ! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/6/2007 15:35'!
focusIndicatorMorph
	"Answer the focus indicator morph for the receiver."

	^self theme focusIndicatorMorphFor: self! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/28/2008 17:21'!
handleMouseWheel: anEvent
	"System level event handling."
	
	anEvent wasHandled ifTrue:[^self].
	(self handlesMouseWheel: anEvent) ifTrue:[
		anEvent wasHandled: true.
		self mouseWheel: anEvent]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/23/2009 13:23'!
handlesDropShadowInHand
	"Answer whether the receiver will handle drop shadow drawing when picked up in the hand."

	^false! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'di 9/14/1998 07:31'!
handlesMouseOver: evt
	"Do I want to receive mouseEnter: and mouseLeave: when the button is up and the hand is empty?  The default response is false, except if you have added sensitivity to mouseEnter: or mouseLeave:, using the on:send:to: mechanism." 

	self eventHandler ifNotNil: [^ self eventHandler handlesMouseOver: evt].
	^ false! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/25/2008 17:34'!
handlesMouseWheel: evt
	"Do I want to receive mouseWheel events?." 

	^false! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 17:21'!
hasKeyboardFocus
	"Answer whether the receiver has keyboard focus."

	^((self world ifNil: [^false]) 
		activeHand ifNil: [^false])  keyboardFocus = self! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/12/2007 10:12'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."

	^Color white! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/9/2007 10:36'!
isTaskbar
	"Answer false in the general case."

	^false! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/10/2011 12:00'!
isWindowActive: aSystemWindow
	"Answer whether the given window is active.
	Implement in morphs that are designed to embed system windows.
	Delegate to owner."
	
	^self owner ifNil: [true] ifNotNil: [:o | o isWindowActive: aSystemWindow]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/27/2007 18:11'!
lastSubmorphRecursive
	"Answer recursive last submorph of the receiver."

	^self hasSubmorphs
		ifTrue: [self lastSubmorph lastSubmorphRecursive]
		ifFalse: [self]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/2/2009 13:24'!
layoutChanged
	"Fixed to always flush layout cache - finally tracked down
	layout anomalies due to cached extents in layout
	policies not being flushed, the previous (incorrect) assumption being
	that it did not matter if layout was to be recomputed (fullBounds being nil).
	Recomputing of the layout apparently does not flush so must be done here."
	
	| layout |
	fullBounds := nil.
	layout := self layoutPolicy.
	layout ifNotNil:[layout flushLayoutCache].
	owner ifNotNil: [owner layoutChanged].
	"note: does not send #ownerChanged here - we'll do this when computing the new layout"! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/26/2010 02:11'!
layoutInBounds: cellBounds
	"Layout specific. Apply the given bounds to the receiver after being layed out in its owner."
	| box aSymbol delta |
	
	cellBounds = self bounds ifTrue:[^self]. "already up to date. Fixed here to use bounds rather than fullBounds for the check."
	cellBounds extent = self bounds extent "nice fit. Fixed here to use bounds rather than fullBounds for the check."
		ifTrue:[^self position: cellBounds origin].
	box := bounds.
	self hResizing == #shrinkWrap
		ifTrue:[box := box origin extent: self minExtent x @ box height].
	self vResizing == #shrinkWrap
		ifTrue:[box := box origin extent: box width @ self minExtent y].
	"match #spaceFill constraints"
	self hResizing == #spaceFill 
		ifTrue:[box := box origin extent: cellBounds width @ box height].
	self vResizing == #spaceFill
		ifTrue:[box := box origin extent: box width @ cellBounds height].
	"align accordingly"
	aSymbol := (owner ifNil:[self]) cellPositioning.
	box := box align: (box perform: aSymbol) with: (cellBounds perform: aSymbol).
	"and install new bounds"
	self bounds: box.! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 14:32'!
minExtent
	"Layout specific. Return the minimum size the receiver can be represented in.
	Implementation note: When this message is sent from an owner trying to lay out its children it will traverse down the morph tree and recompute the minimal arrangement of the morphs based on which the minimal extent is returned. When a morph with some layout strategy is encountered, the morph will ask its strategy to compute the new arrangement. However, since the final size given to the receiver is unknown at the point of the query, the assumption is made that the current bounds of the receiver are the base on which the layout should be computed. This scheme prevents strange layout changes when for instance, a table is contained in another table. Unless the inner table has been resized manually (which means its bounds are already enlarged) the arrangement of the inner table will not change here. Thus the entire layout computation is basically an iterative process which may have different results depending on the incremental changes applied.
	Fixed for shrinkWrap."

	| layout minExtent extra hFit vFit |
	hFit := self hResizing.
	vFit := self vResizing.
	(hFit == #rigid and: [vFit == #rigid]) 
		ifTrue: 
			["The receiver will not adjust to parents layout by growing or shrinking,
		which means that an accurate layout defines the minimum size."

			^self fullBounds extent].

	"An exception -- a receiver with #shrinkWrap constraints but no children is being treated #rigid (the equivalent to a #spaceFill receiver in a non-layouting owner)"
	self hasSubmorphs 
		ifFalse: 
			[hFit == #shrinkWrap ifTrue: [hFit := #rigid].
			vFit == #shrinkWrap ifTrue: [vFit := #rigid]].
	layout := self layoutPolicy.
	layout isNil 
		ifTrue: [minExtent := 0 @ 0]
		ifFalse: [minExtent := layout minExtentOf: self in: self layoutBounds].
	hFit == #rigid 
		ifTrue: [minExtent := self fullBounds extent x @ minExtent y]
		ifFalse: 
			[extra := self bounds width - self layoutBounds width.
			minExtent := (minExtent x + extra) @ minExtent y].
	minExtent := vFit == #rigid 
				ifTrue: [minExtent x @ self fullBounds extent y]
				ifFalse: 
					[extra := self bounds height - self layoutBounds height.
					minExtent x @ (minExtent y + extra)].
	minExtent := minExtent max: self minWidth @ self minHeight.
	^minExtent! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/11/2006 09:37'!
modalLockTo: aSystemWindow
	"Lock the receiver as a modal owner of the given window."

	self lock! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/11/2006 09:38'!
modalUnlockFrom: aSystemWindow
	"Unlock the receiver as a modal owner of the given window."

	self unlock! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/24/2009 13:43'!
morphicLayerNumberWithin: anOwner
	"Helpful for insuring some morphs always appear in front of or behind others.
	Smaller numbers are in front.
	Fixed here to call #morphicLayerNumber rather than access property directly."

	^self morphicLayerNumber! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/25/2008 17:35'!
mouseWheel: evt 
	"Handle a mouseWheel event."! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/7/2006 15:53'!
myDependents
	"Improved performance dependents."
	
	^(self valueOfProperty: #myDependents) ifNil: [super myDependents]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/7/2006 15:55'!
myDependents: aCollectionOrNil
	"Improved performance dependents."
	
	aCollectionOrNil isNil 
		ifTrue: [self removeProperty: #myDependents]
		ifFalse: [self setProperty: #myDependents toValue: aCollectionOrNil]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:40'!
navigateFocusBackward
	"Change the keyboard focus to the previous morph."

	self previousMorphWantingFocus ifNotNil: [:m |
		m takeKeyboardFocus]
	! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:40'!
navigateFocusForward
	"Change the keyboard focus to the next morph."

	self nextMorphWantingFocus ifNotNil: [:m |
		m takeKeyboardFocus]
	! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:40'!
navigationKey: event
	"Check for tab key activity and change focus as appropriate.
	Check for menu key to do popup."

	(self tabKey: event) ifTrue: [^true].
	(event keyCharacter = Character escape and: [
			event anyModifierKeyPressed]) ifTrue: [
		self yellowButtonActivity: false.
		^true].
	self window ifNotNil: [:win |
		(win handlesKeyboard: event) ifTrue: [
			(win keyStroke: event) ifTrue: [^true]]].
	^false! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 11:32'!
nextMorphAcrossInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its next sibling or owner's next sibling etc."

	^self submorphAfter ifNil: [
		(self owner ifNil: [^self]) nextMorphAcrossInWindow]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 11:34'!
nextMorphInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its first child or next sibling or owner's next sibling etc."

	^self hasSubmorphs
		ifTrue: [self submorphs first]
		ifFalse: [self nextMorphAcrossInWindow]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/14/2009 17:53'!
nextMorphWantingFocus
	"Answer the next morph that wants keyboard focus."

	|m|
	m := self nextMorphInWindow ifNil: [^nil].
	[m = self or: [m wantsKeyboardFocusNavigation]]
		whileFalse: [m := m nextMorphInWindow].
	^m wantsKeyboardFocusNavigation
		ifTrue: [m]
	! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/16/2007 15:18'!
openInWindowLabeled: aString inWorld: aWorld
	"Changed to include the inset margin in the bound calculation."

	| window extent |
	window := (SystemWindow labelled: aString) model: nil.
	window 
		" guess at initial extent"
		bounds:  (RealEstateAgent initialFrameFor: window initialExtent: self fullBounds extent world: aWorld);
		addMorph: self frame: (0@0 extent: 1@1);
		updatePaneColors.
	" calculate extent after adding in case any size related attributes were changed.  Use
	fullBounds in order to trigger re-layout of layout morphs"
	extent := self fullBounds extent + 
			(window borderWidth@window labelHeight) + window borderWidth +
			(window class borderWidth * 2 @ (window class borderWidth + 1)). "include inset margin"
	window extent: extent.
	aWorld addMorph: window.
	window activate.
	aWorld startSteppingSubmorphsOf: window.
	^window
! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'StephaneDucasse 6/5/2011 22:38'!
openModal: aSystemWindow
	"Open the given window locking the receiver until it is dismissed.
	Answer the system window.
	Restore the original keyboard focus when closed."

	|area mySysWin keyboardFocus|
	keyboardFocus := self activeHand keyboardFocus.
	mySysWin := self isSystemWindow ifTrue: [self] ifFalse: [self ownerThatIsA: SystemWindow].
	mySysWin ifNil: [mySysWin := self].
	mySysWin modalLockTo: aSystemWindow.
	area := RealEstateAgent maximumUsableArea.
	aSystemWindow extent: aSystemWindow initialExtent.
	aSystemWindow position = (0@0)
		ifTrue: [aSystemWindow
				position: self activeHand position - (aSystemWindow extent // 2)].
	aSystemWindow
		bounds: (aSystemWindow bounds translatedToBeWithin: area).
	[ |aWidget | 
	aWidget := aSystemWindow openAsIs.
	[aWidget world notNil] whileTrue: [
		aWidget outermostWorldMorph doOneCycle]]
		ensure: [mySysWin modalUnlockFrom: aSystemWindow.
				self activeHand newKeyboardFocus: keyboardFocus].
	^aSystemWindow! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/8/2007 09:58'!
optimalExtent
	"Answer the submorphBounds extent plus twice our border width."
	
	^self submorphBounds extent + (self borderWidth * 2)! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/9/2007 12:25'!
paneColor
	"Answer the window's pane color or our color otherwise."

	^self paneColorOrNil ifNil: [self color]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/29/2008 15:14'!
paneColor: aColor
	"Explicitly set the pane color for the reveiver."

	self setProperty: #paneColor toValue: aColor.
	self adoptPaneColor! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/29/2008 14:56'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^self valueOfProperty: #paneColor ifAbsent: [
		(self owner ifNil: [^nil]) paneColorOrNil]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/21/2008 16:51'!
passivate
	"Mark the receiver and submorphs as passive (background)."

	self submorphsDo: [:m | m passivate]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/27/2009 13:47'!
preferredButtonCornerStyle
	"Answer the preferred button corner style
	for submorphs. Answer nil for no preference."

	^nil! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/13/2007 15:25'!
preferredCornerStyle
	"Answer the preferred corner style."

	^#square! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 12:06'!
previousMorphInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its previous sibling's last submorph (recursive)
	or owner's previous sibling's last submorph (recursive) etc."

	^self submorphBefore notNil
		ifTrue: [self submorphBefore lastSubmorphRecursive]
		ifFalse: [self owner]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/8/2007 13:41'!
previousMorphWantingFocus
	"Answer the previous morph that wants keyboard focus."

	|m|
	m := self previousMorphInWindow ifNil: [^nil].
	[m = self or: [m wantsKeyboardFocusNavigation]]
		whileFalse: [m := m previousMorphInWindow ifNil: [^nil]].
	^m wantsKeyboardFocusNavigation
		ifTrue: [m]
	! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'StephaneDucasse 11/1/2009 19:24'!
privateMoveBy: delta 
	"Private!! Use 'position:' instead."
	| fill border|
	bounds := bounds translateBy: delta.
	fullBounds ifNotNil: [fullBounds := fullBounds translateBy: delta].
	fill := self fillStyle.
	fill isOrientedFill ifTrue: [fill origin: fill origin + delta].
	border := self borderStyle.
	(border hasFillStyle and: [border fillStyle isOrientedFill]) ifTrue: [
		border fillStyle origin: border fillStyle origin + delta]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/28/2008 16:17'!
rejectsEvent: anEvent
	"Return true to reject the given event.
	Rejecting an event means neither the receiver nor any of it's submorphs will be given any chance to handle it.
	If the event is a mouse wheel event then only reject if the receiver is not visible."
	
	(anEvent isMouse and: [anEvent isMouseWheel])
		ifTrue: [^self visible not].
	^self isLocked or: [self visible not]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/12/2009 18:12'!
roundedCorners
	"Return a list of those corners to round.

		1-4
		|  |
		2-3

	Returned array contains `codes' of those corners, which should be rounded.

	1 denotes top-left corner
	2 denotes bottom-left corner
	3 denotes bottom-right corner
	4 denotes top-right corner.

	Thus, if this method returned #(2 3) that would mean that bottom (left and right)
	corners would be rounded whereas top (left and right) corners wouldn't be rounded.

	This method returns #(1 2 3 4) and that means that all the corners should be rounded."

	^self valueOfProperty: #roundedCorners ifAbsent: [#(1 2 3 4)]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/12/2009 18:14'!
roundedCorners: anArray
	"Set the corners to round."

	anArray = #(1 2 3 4)
		ifTrue: [self removeProperty: #roundedCorners]
		ifFalse: [self setProperty: #roundedCorners toValue: anArray].
	self changed! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/15/2009 13:35'!
shadowOffsetRectangle
	"Answer a rectangle describing the offsets to the
	receiver's bounds for a drop shadow."

	^self shadowOffset negated corner: self shadowOffset! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 09:55'!
showBalloon: msgString hand: aHand
	"Pop up a balloon containing the given string,
	first removing any existing BalloonMorphs in the world."

	|w h|
	(w := self world) ifNil: [^self].
	h := aHand ifNil: [w activeHand].
	( self theme   builder newBalloonHelp: msgString for: self balloonHelpAligner)
		popUpFor: self hand: h! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/16/2008 16:57'!
tabKey: event
	"Check for tab key activity and change focus as appropriate."

	event controlKeyPressed ifFalse: [
		event keyCharacter = Character tab ifTrue: [
			event shiftPressed
				ifTrue: [self navigateFocusBackward]
				ifFalse: [self navigateFocusForward].
			^true]].
	^false! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/21/2007 14:35'!
takeKeyboardFocus
	"Make the receiver the keyboard focus for the active hand."

	self activeHand newKeyboardFocus: self! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 12:27'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^ false! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/20/2007 11:30'!
taskThumbnailOfSize: thumbExtent
	"Answer a new task thumbnail for the receiver."

	|f t r|
	r := self bounds scaledAndCenteredIn: (0@0 extent: thumbExtent).
	f := Form extent: r extent depth: Display depth.
	t := MatrixTransform2x3 withScale: f extent / self extent.
	f getCanvas
		transformBy: t
		clippingTo: f boundingBox
		during: [:c | c translateBy: self topLeft negated during: [:ct | self fullDrawOn: ct]]
		smoothing: 2.
	^ImageMorph new
		image: f! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/17/2007 17:44'!
taskbarButtonFor: aTaskBar
	"Answer a new task bar button for the receiver.
	Answer nil if not required."

	^nil! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/18/2007 12:30'!
taskbarTask
	"Answer a new taskbar task for the receiver.
	Answer nil if not required."

	^nil! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/11/2007 15:04'!
taskbarThumbnail
	"Answer a new taskbar thumbnail for the receiver."

	^self taskThumbnailOfSize: self taskbarThumbnailExtent! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/11/2007 15:03'!
taskbarThumbnailExtent
	"Answer the size of a taskbar thumbnail for the receiver."

	^self extent min: self defaultTaskbarThumbnailExtent! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/9/2007 10:36'!
taskbars
	"Answer the receiver's taskbars."
	
	^self submorphs select: [:each |
		each isTaskbar]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:40'!
theme
	"Answer the current theme for the receiver."

	(self valueOfProperty: #theme) ifNotNil: [:t | ^ t].
	^(self window ifNil: [self class]) theme! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/10/2008 16:47'!
theme: aUITheme
	"Set the current theme for the receiver."

	self theme = aUITheme ifFalse: [
		self setProperty: #theme toValue: aUITheme.
		self themeChanged]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/9/2007 11:26'!
themeChanged
	"The current theme has changed.
	Update any dependent visual aspects."

	self submorphsDo: [:m | m themeChanged].
	self changed! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/29/2008 16:06'!
toggleVisible
	"Toggle the visibility of the receiver."

	self visible
		ifTrue: [self hide]
		ifFalse: [self show]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/29/2008 16:18'!
toggleVisibleAndRaise
	"Toggle the visibility of the receiver, brining to
	the front if becoming visible."

	self visible
		ifTrue: [self hide]
		ifFalse: [self comeToFront; show]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/17/2006 10:36'!
visible: aBoolean 
	"set the 'visible' attribute of the receiver to aBoolean.
	Must update owner layout since its full bounds may depend
	on the receiver extending beyond its bounds."
	
	(extension isNil and:[aBoolean]) ifTrue: [^ self].
	self visible == aBoolean ifTrue: [^ self].
	self assureExtension visible: aBoolean.
	self changed.
	owner ifNotNil: [owner layoutChanged]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/5/2007 15:22'!
wantsKeyboardFocus
	"Answer whether the receiver would like keyboard focus
	in the general case (mouse action normally)."

	^self takesKeyboardFocus and: [
		self visible and: [self enabled]]! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/5/2007 15:24'!
wantsKeyboardFocusNavigation
	"Answer whether the receiver would like keyboard focus
	when navigated to by keyboard."

	^self wantsKeyboardFocus! !

!Morph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/10/2007 10:07'!
window
	"Answer the receiver's window."

	^self ownerThatIsA: SystemWindow! !

Morph subclass: #MultistateButtonMorph
	instanceVariableNames: 'enabled active over down stateMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!MultistateButtonMorph commentStamp: 'gvc 10/21/2008 13:27' prior: 0!
A simple button that handles multiple fillstyle states:
	Normal
	Mouse-over
	Mouse-down-inside
	Mouse-down outside	
with variants being a combination of passive/active and enabled/disabled.!

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2008 16:50'!
activate
	"Make active."

	super activate.
	self active: true! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 13:28'!
active
	"Answer the value of active"

	^ active! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 15:57'!
active: anObject
	"Set the value of active"

	active := anObject.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:16'!
activeDisabledNotOverDownFillStyle: aFillStyle
	"Set the active, disabled, notOver, down fill style."

	self stateMap atPath: #(active disabled notOver down) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:16'!
activeDisabledNotOverUpFillStyle: aFillStyle
	"Set the active, disabled, notOver, up fill style."

	self stateMap atPath: #(active disabled notOver up) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:17'!
activeDisabledOverDownFillStyle: aFillStyle
	"Set the active, disabled, over, down fill style."

	self stateMap atPath: #(active disabled over down) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:17'!
activeDisabledOverUpFillStyle: aFillStyle
	"Set the active, disabled, over, up fill style."

	self stateMap atPath: #(active disabled over up) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 15:55'!
activeEnabledNotOverDownFillStyle: aFillStyle
	"Set the active, enabled, notOver, down fill style."

	self stateMap atPath: #(active enabled notOver down) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 15:55'!
activeEnabledNotOverUpFillStyle: aFillStyle
	"Set the active, enabled, notOver, up fill style."

	self stateMap atPath: #(active enabled notOver up) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:17'!
activeEnabledOverDownFillStyle: aFillStyle
	"Set the active, enabled, over, down fill style."

	self stateMap atPath: #(active enabled over down) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 15:55'!
activeEnabledOverUpFillStyle: aFillStyle
	"Set the active, enabled, over, up fill style."

	self stateMap atPath: #(active enabled over up) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/22/2008 11:38'!
addDownAction: anActionOrBlock
	"Add a down event handler."
	
	self when: #down evaluate: anActionOrBlock! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/22/2008 11:38'!
addUpAction: anActionOrBlock
	"Add an up event handler."
	
	self when: #up evaluate: anActionOrBlock! !

!MultistateButtonMorph methodsFor: 'updating' stamp: 'gvc 9/11/2009 17:05'!
changed
	"Update the fillStyle here."
	
	self assureExtension.
	extension fillStyle: self fillStyleToUse.
	color := self fillStyle asColor.
	super changed! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 13:31'!
down
	"Answer the value of down"

	^ down! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 15:57'!
down: anObject
	"Set the value of down"

	down := anObject.
	self changed! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 13:28'!
enabled
	"Answer whether the button is rnabled."

	^enabled! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 15:57'!
enabled: anObject
	"Set the value of enabled"

	enabled := anObject.
	self changed! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/22/2008 12:32'!
extent: aPoint
	"Center the fill style origin."
	
	|delta|
	self bounds extent = aPoint ifTrue: [^self].
	delta := aPoint - self extent // 2.
	self fillStyles do: [:fs | fs isOrientedFill ifTrue: [fs origin: fs origin + delta]].
	super extent: aPoint! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:01'!
fillStyleToUse
	"Answer the fill style to used based on the current state."

	|map|
	map := self active
		ifTrue: [self stateMap at: #active ifAbsent: [self stateMap at: #passive ifAbsent: [Dictionary new]]]
		ifFalse: [self stateMap at: #passive ifAbsent: [self stateMap at: #active ifAbsent: [Dictionary new]]].
	map := self enabled
		ifTrue: [map at: #enabled ifAbsent: [map at: #disabled ifAbsent: [Dictionary new]]]
		ifFalse: [map at: #disabled ifAbsent: [map at: #enabled ifAbsent: [Dictionary new]]].
	map := self over
		ifTrue: [map at: #over ifAbsent: [map at: #notOver ifAbsent: [Dictionary new]]]
		ifFalse: [map at: #notOver ifAbsent: [map at: #over ifAbsent: [Dictionary new]]].
	^map at: (self down ifTrue: [#down] ifFalse: [#up]) ifAbsent: [
		map at: (self down ifTrue: [#up] ifFalse: [#down]) ifAbsent: [Color transparent]]! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:13'!
fillStyles
	"Answer all the fill styles"
	
	|styles|
	styles := OrderedCollection new.
	self stateMap do: [:actives |
		actives do: [:enableds |
			enableds do: [:overs |
				overs do: [:fs | styles add: fs]]]].
	^styles! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2008 16:32'!
handlesMouseDown: evt
	"Yes."
	
	^true! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2008 16:27'!
handlesMouseOver: anEvent
	"Answer true, otherwise what is all that
	#mouseEnter:/#mouseLeave: stuff about?"

	^true! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2008 16:34'!
handlesMouseOverDragging: evt
	"Yes, for other states."
	
	^true! !

!MultistateButtonMorph methodsFor: 'initialize-release' stamp: 'gvc 10/21/2008 16:07'!
initialize
	"Initialize the receiver."

	self stateMap: KeyedTree new.
	enabled := true.
	active := true.
	over := false.
	down := false.
	super initialize! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'GaryChambers 2/15/2011 15:43'!
labelGraphic: anObject
	"do nothing. this is a hack to make this multistate button work with a menu on a system window.
	Need to refactor menu boxes!!"! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/22/2008 11:34'!
mouseDown: evt 
	"Handle a mouse down event."
	
	super mouseDown: evt.
	self enabled ifFalse: [^self].
	self down: true.
	self triggerEvent: #down ! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 2/1/2011 14:25'!
mouseEnter: evt
	"Handle a mouseEnter event, meaning the mouse just entered my bounds with no button pressed."

	super mouseEnter: evt.
	self over: true! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2008 16:31'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event, meaning the mouse just entered my bounds with a button pressed or laden with submorphs."

	super mouseEnterDragging: evt.
	self over: true! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 2/1/2011 14:29'!
mouseLeave: evt
	"Handle a mouseLeave event, meaning the mouse just left my bounds with no button pressed."

	super mouseLeave: evt.
	self over: false! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2008 16:30'!
mouseLeaveDragging: evt
	"Handle a mouseLeaveLaden event, meaning the mouse just left my bounds with a button pressed or laden with submorphs."

	super mouseLeaveDragging: evt.
	self over: false! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/22/2008 11:34'!
mouseUp: evt 
	"Handle a mouse up event."
	
	super mouseUp: evt.
	self enabled ifFalse: [^self].
	self down: false.
	(self containsPoint: evt cursorPoint)
		ifTrue: [self triggerEvent: #up]
		ifFalse: [self triggerEvent: #upOutside]! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 13:31'!
over
	"Answer the value of over"

	^ over! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 15:57'!
over: anObject
	"Set the value of over"

	over := anObject.
	self changed! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2008 16:50'!
passivate
	"Make passive."

	super passivate.
	self active: false! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:44'!
passiveDisabledNotOverDownFillStyle: aFillStyle
	"Set the passive, disabled, notOver, down fill style."

	self stateMap atPath: #(passive disabled notOver down) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:44'!
passiveDisabledNotOverUpFillStyle: aFillStyle
	"Set the passive, disabled, notOver, up fill style."

	self stateMap atPath: #(passive disabled notOver up) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:44'!
passiveDisabledOverDownFillStyle: aFillStyle
	"Set the passive, disabled, over, down fill style."

	self stateMap atPath: #(passive disabled over down) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:44'!
passiveDisabledOverUpFillStyle: aFillStyle
	"Set the passive, disabled, over, up fill style."

	self stateMap atPath: #(passive disabled over up) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:44'!
passiveEnabledNotOverDownFillStyle: aFillStyle
	"Set the passive, enabled, notOver, down fill style."

	self stateMap atPath: #(passive enabled notOver down) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:44'!
passiveEnabledNotOverUpFillStyle: aFillStyle
	"Set the passive, enabled, notOver, up fill style."

	self stateMap atPath: #(passive enabled notOver up) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:45'!
passiveEnabledOverDownFillStyle: aFillStyle
	"Set the passive, enabled, over, down fill style."

	self stateMap atPath: #(passive enabled over down) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'visual properties' stamp: 'gvc 10/21/2008 16:45'!
passiveEnabledOverUpFillStyle: aFillStyle
	"Set the passive, enabled, over, up fill style."

	self stateMap atPath: #(passive enabled over up) put: aFillStyle.
	self changed! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2008 16:11'!
privateMoveBy: delta
	"Adjust all the fill styles"
	
	super privateMoveBy: delta.
	(self fillStyles copyWithout: self fillStyle) do: [:fs | fs isOrientedFill ifTrue: [fs origin: fs origin + delta]]! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/22/2008 11:39'!
removeDownActions
	"Remove all down event handlers"
	
	self removeActionsForEvent: #down! !

!MultistateButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/22/2008 11:39'!
removeUpActions
	"Remove all up event handlers"
	
	self removeActionsForEvent: #up! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 13:28'!
stateMap
	"Answer the value of stateMap"

	^ stateMap! !

!MultistateButtonMorph methodsFor: 'accessing' stamp: 'gvc 10/21/2008 13:28'!
stateMap: anObject
	"Set the value of stateMap"

	stateMap := anObject! !

Morph subclass: #SVColorSelectorMorph
	instanceVariableNames: 'selectedColor locationMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!SVColorSelectorMorph commentStamp: 'gvc 8/8/2007 14:36' prior: 0!
A colour selector that displays an area with saturation on the x axis and volume on the y axis. Provides interactive selection of colour by mouse. For the moment it is event rather than model based.
Setting the color will specify the hue and setting the selectedColor will specify the saturation and volume (may have a different hue to that displayed if not in sync).!

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:54'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	self borderStyle baseColor: paneColor twiceDarker! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 14:15'!
basicColor: aColor
	"Set the gradient colors."
	
	super color: aColor asNontranslucentColor.
	self
		fillStyle: self gradient! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:13'!
blackGradient
	"Answer the black gradient. Top to bottom, transparent to black."

	^(InterpolatedGradientFillStyle colors: {Color black alpha: 0. Color black})
		origin: self innerBounds topLeft;
		direction: 0@self innerBounds height! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 11:36'!
blackGradientMorph
	"Answer the black gradient morph."

	^Morph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: self blackGradient! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:19'!
borderWidth: anInteger
	"Update the gradients after setting."
	
	super borderWidth: anInteger.
	self updateGradients! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 14:15'!
color: aColor
	"Set the gradient colors."
	
	self
		basicColor: aColor;
		selectedColor: (Color h: aColor hue s: self selectedColor saturation v: self selectedColor brightness)! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 10:42'!
colorAt: aPoint
	"Answer the color in the world at the given point."
	
	^self isInWorld
		ifTrue: [(Display colorAt: aPoint) asNontranslucentColor ]
		ifFalse: [Color black]! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:33'!
extent: p
	"Update the gradient directions."

	super extent: p.
	self updateGradients! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 10:49'!
fillStyle: fillStyle
	"If it is a color then override with gradient."
	
	fillStyle isColor
		ifTrue: [self color: fillStyle]
		ifFalse: [super fillStyle: fillStyle]! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:52'!
gradient
	"Answer the base gradient."

	|b|
	b := self innerBounds.
	^(GradientFillStyle colors: {Color white. self color})
		origin: b topLeft;
		direction: (b width@0)! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/20/2006 12:50'!
handlesMouseDown: evt
	"Yes for down and move.." 

	^true! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 16:33'!
handlesMouseOverDragging: evt
	"Yes, make the location morph visible when leaving."
	
	^true! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:25'!
hideLocation
	"Hide the location morph and update the display."
	
	self locationMorph visible: false.
	World displayWorldSafely.! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:22'!
initialize
	"Initialize the receiver."

	super initialize.
	self locationMorph: self newLocationMorph.
	self
		clipSubmorphs: true;
		color: Color blue;
		borderStyle: (BorderStyle inset width: 1);
		addMorphBack: self locationMorph;
		addMorphBack: self blackGradientMorph! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 12:23'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Note: written so that #layoutBounds can be changed without touching this method"
	
	super layoutBounds: aRectangle.
	self updateGradients! !

!SVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 13:37'!
locationMorph
	"Answer the value of locationMorph"

	^ locationMorph! !

!SVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/20/2006 13:37'!
locationMorph: anObject
	"Set the value of locationMorph"

	locationMorph := anObject! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/19/2010 16:21'!
mouseDown: evt 
	"Handle a mouse down event. Select the color at the mouse position."
	
	evt redButtonPressed
		ifFalse: [^super mouseDown: evt].
	evt hand showTemporaryCursor: (Cursor crossHair copy offset: -9 @ -9).
	self hideLocation.
	self selectColorAt: evt position.
	^super mouseDown: evt! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/19/2010 16:21'!
mouseEnterDragging: evt
	"Make the location morph invisible when entering."
	
	self hideLocation.
	evt hand showTemporaryCursor: (Cursor crossHair copy offset: -9 @ -9).! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 11:56'!
mouseLeaveDragging: evt
	"Make the location morph visible when leaving."
	
	evt hand showTemporaryCursor: nil.
	self showLocation! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 12:11'!
mouseMove: evt 
	"Handle a mouse move event. Select the color at the mouse position."
	
	evt redButtonPressed
		ifFalse: [^super mouseMove: evt].
	self selectColorAt: evt position.
	^super mouseMove: evt! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 12:12'!
mouseUp: evt 
	"Handle a up event. Show the location morph again."
	
	evt hand showTemporaryCursor: nil.
	self updateSelectedLocation.
	self locationMorph visible: true! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 12:16'!
newLocationMorph
	"Answer a new morph indicating the location of the selected color."

	^ImageMorph new
		image: Cursor crossHair withMask asCursorForm! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 12:12'!
selectColorAt: aPoint
	"Set the color at the given position."
	
	|b p|
	b := self innerBounds.
	p := (b containsPoint: aPoint)
		ifTrue: [aPoint]
		ifFalse: [b pointNearestTo: aPoint].
	p := p - b topLeft / b extent.
	self selectedColor: (Color
		h: self color hue
		s: p x
		v: 1.0 - p y)! !

!SVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/19/2006 15:08'!
selectedColor
	"Answer the value of selectedColor"

	^selectedColor ifNil: [self color]! !

!SVColorSelectorMorph methodsFor: 'accessing' stamp: 'gvc 9/21/2006 14:01'!
selectedColor: aColor
	"Set the value of selectedColor."

	selectedColor := aColor.
	self locationMorph visible ifTrue: [self updateSelectedLocation].
	self triggerEvent: #colorSelected with: aColor! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 15:25'!
selectedLocation
	"Answer the location within the receiver of the selected colour
	relative to the receiver's top left."

	|b c x y|
	b := self innerBounds.
	c := self selectedColor.
	x := c saturation * (b width - 1).
	y := 1 - c brightness * (b height - 1).
	^(x truncated @ y truncated) + b topLeft! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:26'!
showLocation
	"Show the location morph and update the display."
	
	self locationMorph visible: true.
	World displayWorldSafely.! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 13:52'!
updateGradients
	"Update the gradient directions."

	|bgm b|
	b := self innerBounds.
	bgm := self submorphs last.
	bgm bounds: b.
	bgm fillStyle
		origin: b topLeft;
		direction: 0@b height.
	self fillStyle
		origin: b topLeft;
		direction: (b width@0).
	self updateSelectedLocation! !

!SVColorSelectorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2006 12:17'!
updateSelectedLocation
	"Position the location morph to indicate the selected colour."
	
	self locationMorph
		position: (self selectedLocation - (self locationMorph extent // 2 + (self locationMorph extent \\ 2)))! !

Morph subclass: #TaskbarMorph
	instanceVariableNames: 'tasks orderedTasks'
	classVariableNames: 'ShowTaskbar ShowWindowPreview'
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TaskbarMorph commentStamp: 'AlainPlantec 1/7/2010 22:47' prior: 0!
Themed synchronous taskbar (not using #step to poll windows). The buttons provide visual feedback as to whether a window is active or minimised (collapsed) plus a popup menu with options to restore, minimise, maximise and close the associated window. Optional (via settings) preview of the window while mouse is over a taskbar button.
!

!TaskbarMorph class methodsFor: 'initializing' stamp: 'AlainPlantec 12/7/2009 09:28'!
initialize
	"Initialize the receiver."
	self showTaskbarPreferenceChanged! !

!TaskbarMorph class methodsFor: 'initializing' stamp: 'MarcusDenker 3/23/2011 15:31'!
reset
	"Remove the taskbar and add a new one." 
	
	(World submorphs select: [:m | m isKindOf: self])
		do: [:tb | tb delete].
	World createTaskbarIfNecessary! !

!TaskbarMorph class methodsFor: 'setting' stamp: 'AlainPlantec 12/7/2009 08:45'!
showTaskbar
	^ ShowTaskbar ifNil: [ShowTaskbar := true]! !

!TaskbarMorph class methodsFor: 'setting' stamp: 'AlainPlantec 12/7/2009 08:48'!
showTaskbar: aBoolean
	ShowTaskbar ~= aBoolean
		ifTrue: [ShowTaskbar := aBoolean.
			self showTaskbarPreferenceChanged]! !

!TaskbarMorph class methodsFor: 'setting' stamp: 'MarcusDenker 3/23/2011 15:32'!
showTaskbarPreferenceChanged
	"Add or remove the taskbar as appropriate.
	Delegate to the current World."
	
	World showWorldTaskbar:  self showTaskbar! !

!TaskbarMorph class methodsFor: 'setting' stamp: 'AlainPlantec 12/7/2009 09:06'!
showWindowPreview
	^ ShowWindowPreview ifNil: [ShowWindowPreview := true]! !

!TaskbarMorph class methodsFor: 'setting' stamp: 'AlainPlantec 12/7/2009 09:06'!
showWindowPreview: aBoolean
	ShowWindowPreview := aBoolean! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/20/2009 15:03'!
buttonForMorph: aMorph
	"Answer the button corresonding to the given
	morph or nil if none."
	
	|index|
	index := (self orderedTasks collect: [:t | t morph]) indexOf: aMorph.
	^index = 0 ifTrue: [nil] ifFalse: [self submorphs at: index ifAbsent: []]! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 14:44'!
edgeToAdhereTo
	"Must implement. Answer #bottom."
	
	^#bottom! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 16:21'!
handlesMouseDown: evt
	"Best to say we will to avoid being grabbed."
	
	^true! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:42'!
indicateModalChildForMorph: aMorph
	"Flash the button corresonding to the given morph ."
	
	(self buttonForMorph: aMorph) ifNotNil: [:b |
		b indicateModalChild]! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 14:51'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		initializeLayout;
		initializeAppearance;
		tasks: #();
		orderedTasks: OrderedCollection new! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 12:14'!
initializeAppearance
	"Initialize the appearance."

	self
		color: (Color black alpha: 0.3);
		fillStyle: (self theme taskbarFillStyleFor: self)! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 15:27'!
initializeLayout
	"Initialize the layout."

	self
		changeTableLayout;
		layoutInset: 2;
		cellInset: 2;
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		extent: self minimumExtent! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:28'!
intoWorld: aWorld
	"Stick to the bottom left now."
	
	self
		setToAdhereToEdge: #bottomLeft;
		updateBounds.
	super intoWorld: aWorld! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:19'!
isAdheringToBottom
	"Must implement. Answer true."
	
	^true! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:17'!
isAdheringToLeft
	"Must implement. Answer false."
	
	^false! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:17'!
isAdheringToRight
	"Must implement. Answer false."
	
	^false! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:17'!
isAdheringToTop
	"Must implement. Answer false."
	
	^false! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:13'!
isDockingBar
	"Answer yes so we get updated when the Display is resized."

	^true! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 10:35'!
isTaskbar
	"Answer true."

	^true! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 12:09'!
minimumExtent
	"Answer the minimum extent."

	^40@25! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:34'!
morphicLayerNumber
	"Helpful for ensuring some morphs always appear in front of or 
	behind others. Smaller numbers are in front"
	
	^11! !

!TaskbarMorph methodsFor: 'accessing' stamp: 'gvc 4/13/2007 13:52'!
orderedTasks
	"Answer the value of orderedTasks"

	^ orderedTasks! !

!TaskbarMorph methodsFor: 'accessing' stamp: 'gvc 4/13/2007 13:52'!
orderedTasks: anObject
	"Set the value of orderedTasks"

	orderedTasks := anObject! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 10:58'!
ownerChanged
	"The receiver's owner has changed its layout.
	Since this method is called synchronously in the
	ui, delete the receiver if there are any excpetions."
	
	self owner ifNil: [^self].
	[self updateBounds.
	self updateTasks]
		on: Exception
		do: [:ex | self delete. ex pass].
	super ownerChanged! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/27/2009 13:48'!
preferredButtonCornerStyle
	"Answer the preferred button corner style
	for submorphs."

	^#square! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/15/2009 10:31'!
removeFromWorld
	"Delete the receiver from its world after restoring minimized tasks.
	Collapse those that were minimized after removal.
	Turn window animation off for the duration."

	|mins animation|
	mins := self tasks select: [:t | t isMinimized].
	animation := self theme settings animationSettings useAnimation.
	animation ifTrue: [self theme settings animationSettings useAnimation: false].
	[mins do: [:t | t morph restore; resetCollapsedFrame].
	self delete.
	mins do: [:t | t morph minimize]]
		ensure: [animation ifTrue: [self theme settings animationSettings useAnimation: true]]! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/7/2009 09:05'!
showWindowPreview
	^ self class showWindowPreview! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 12:59'!
taskButtonOf: aMorph
	"Answer the task button of the given morph or nil if none."

	^self submorphs detect: [:t | t model = aMorph] ifNone: []! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 12:58'!
taskOf: aMorph
	"Answer the task of the given morph or nil if none."

	^self orderedTasks detect: [:t | t morph = aMorph] ifNone: []! !

!TaskbarMorph methodsFor: 'accessing' stamp: 'gvc 4/13/2007 13:52'!
tasks
	"Answer the value of tasks"

	^ tasks! !

!TaskbarMorph methodsFor: 'accessing' stamp: 'gvc 4/13/2007 13:52'!
tasks: anObject
	"Set the value of tasks"

	tasks := anObject! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 11:28'!
themeChanged
	"The theme has changed. Update our appearance."

	self initializeAppearance.
	self removeAllMorphs.
	super themeChanged.
	self updateTaskButtons! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/20/2011 12:18'!
updateBounds
	"Update the receiver's bounds to fill the world."

	self
		width: self owner width;
		snapToEdgeIfAppropriate! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
updateTaskButtons
	"Make buttons for the ordered tasks."
	
	| oldButtons|
	oldButtons := self submorphs copy.
	self removeAllMorphs.
	WorldState addDeferredUIMessage: [oldButtons do: [:b | b model: nil]]. "release dependency after event handling"
	self orderedTasks do: [:t | | button |
		button := t taskbarButtonFor: self.
		button ifNotNil: [self addMorphBack: button]]! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:42'!
updateTasks
	"Check for changes in the world's submorphs.
	Note that if the task attributes change then a
	task will be considered dead along with a new replacement."
	
	|wm deadTasks newTasks|
	wm := self worldMorphs.
	self tasks: ((wm collect: [:m | m taskbarTask]) select: [:m | m notNil]) asOrderedCollection.
	deadTasks := self orderedTasks difference: self tasks.
	newTasks := self tasks difference: self orderedTasks.
	(newTasks isEmpty and: [deadTasks isEmpty])
		ifTrue: [^self]. "no changes"
	newTasks copy do: [:t |
		(self orderedTasks detect: [:ot | ot morph = t morph] ifNone: []) ifNotNil: [:ot |
			self orderedTasks replaceAll: ot with: t.
			deadTasks remove: ot.
			newTasks remove: t]]. "replace in order any changed tasks."
	self orderedTasks
		removeAll: deadTasks;
		addAll: newTasks reversed.
	self updateTaskButtons.
	WorldState addDeferredUIMessage: [self layoutChanged] "may have a different number of rows"! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/13/2007 13:30'!
wantsToBeTopmost
	"Answer if the receiver want to be one of the topmost
	objects in its owner."
	
	^ true! !

!TaskbarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/18/2007 12:39'!
worldMorphs
	"Answer the world's submorphs plus those in hand.
	Nasty case since hand removes the morph before dropping"
	
	^self world submorphs, 
		((self tasks
			select: [:t | t morph owner = self world activeHand])
			collect: [:t | t morph])! !

Morph subclass: #TasklistMorph
	instanceVariableNames: 'tasks taskList preview'
	classVariableNames: 'KeepOpen'
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TasklistMorph commentStamp: 'gvc 5/18/2007 11:19' prior: 0!
Themed task list/switcher to select the topmost window. Use cmd + left or right arrows (not ideal but the os typically handles cmd + tab/shift-tab).
On Linux, release of the command key is not detected (vm issue), so press and release cmd again or move the mouse!!!

!TasklistMorph class methodsFor: 'settings' stamp: 'AlainPlantec 12/14/2009 19:10'!
keepOpen
	^ KeepOpen ifNil: [KeepOpen := false]! !

!TasklistMorph class methodsFor: 'settings' stamp: 'AlainPlantec 12/14/2009 19:10'!
keepOpen: aBoolean
	KeepOpen := aBoolean! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:02'!
activeTask
	"Answer the active task"
	
	^self tasks detect: [:t | t isActive] ifNone: []! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/12/2011 10:46'!
addMorphs
	"Add our morphs."

	self preview: self newPreviewMorph.
	self taskList: self newTasksMorph.
	self addMorph: (
		( self theme newColumnIn: self for: {
			self preview.
			self taskList})
			vResizing: #shrinkWrap;
			cellInset: 8;
			cellPositioning: #center).
	self layoutChanged! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:40'!
defaultPreviewExtent
	"Answer the default extent of the preview holder."

	^320@320! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 5/23/2011 21:59'!
done
	"Close the tasklist and make the active task current."
	
	self delete.
	self activeTask ifNotNil: [ :t | t activate ]! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 14:51'!
handlesKeyboard: evt
	"Yes, we do it here."
	
	^true! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:12'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		initializeTasks;
		initializeLayout;
		initializeAppearance;
		addMorphs;
		updateButtonsAndPreview;
		adoptPaneColor: self color! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 9/22/2011 00:31'!
initializeAppearance
	"Initialize the appearance."

	self
		color: (Color black alpha: 0.15);
		fillStyle: (self theme tasklistFillStyleFor: self);
		borderStyle: (self theme taskbarThumbnailNormalBorderStyleFor: self);
		cornerStyle: (self theme taskbarThumbnailCornerStyleFor: self)! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 9/22/2011 00:25'!
initializeLayout
	"Initialize the layout."

	self
		changeTableLayout;
		layoutInset: 16;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		extent: self minimumExtent! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:27'!
initializeTasks
	"Set up the current tasks."
	
	self tasks: ((World submorphs
		collect: [:m | m taskbarTask])
		select: [:m | m notNil]) asOrderedCollection! !

!TasklistMorph methodsFor: 'settings' stamp: 'AlainPlantec 12/14/2009 19:11'!
keepOpen
	^ self class keepOpen! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/26/2010 14:30'!
keyStroke: event 
	"Process keys to switch task."
	
	event keyCharacter = Character escape ifTrue: [^self delete].
	event commandKeyPressed ifFalse: [^self done].
	event keyCharacter = Character arrowLeft
		ifTrue: [^self selectPreviousTask].
	event keyCharacter = Character arrowRight
		ifTrue: [^self selectNextTask]! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:14'!
minimumExtent
	"Answer the minimum extent."

	^self defaultPreviewExtent + 64! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:11'!
newPreviewMorph
	"Answer a new preview holder."

	^Morph new
		color: Color transparent;
		extent: self defaultPreviewExtent! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/26/2007 09:45'!
newTasksMorph
	"Answer a new task list."

	^Morph new
		changeTableLayout;
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		cellInset: 1;
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:21'!
openAsIs
	"Open in the world."
	
	self openAsIsIn: self currentWorld! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2007 14:42'!
openAsIsIn: aWorld
	"Update the layout after opening."

	aWorld addMorphCentered: self.
	self allMorphs do: [:m | m layoutChanged].
	aWorld startSteppingSubmorphsOf: self.
	self wantsKeyboardFocus
		ifTrue: [self takeKeyboardFocus]! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 11:11'!
preview
	"Answer the value of preview"

	^ preview! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 11:11'!
preview: anObject
	"Set the value of preview"

	preview := anObject! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:35'!
selectNextTask
	"Make the next task active."
	
	self selectTask: (self tasks
		after: self activeTask
		ifAbsent: [self tasks isEmpty
					ifFalse: [self tasks first]])! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:35'!
selectPreviousTask
	"Make the previous task active."
	
	self selectTask: (self tasks
		before: self activeTask
		ifAbsent: [self tasks isEmpty
					ifFalse: [self tasks last]])! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 5/23/2011 21:58'!
selectTask: aTask
	"Make the given task active and update the buttons."
	
	self tasks do: [:t | t state: #restored].
	aTask ifNotNil: [ aTask state: #active ].
	self updateButtonsAndPreview! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/14/2009 19:11'!
step
	"Check the sensor for the command key to see if we're done."

	(self keepOpen not and: [Sensor commandKeyPressed not])
		ifTrue: [self done]! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 14:59'!
stepTime
	"Check quickly."

	^100! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2007 21:44'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/2/2009 12:22'!
taskClicked: aTask
	"A button for a task has been pressed.
	Close after selecting."
	
	self selectTask: aTask.
	self done! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 10:58'!
taskList
	"Answer the value of taskList"

	^ taskList! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 10:58'!
taskList: anObject
	"Set the value of taskList"

	taskList := anObject! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 10:16'!
tasks
	"Answer the value of tasks"

	^ tasks! !

!TasklistMorph methodsFor: 'accessing' stamp: 'gvc 4/20/2007 10:16'!
tasks: anObject
	"Set the value of tasks"

	tasks := anObject! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 9/22/2011 00:21'!
updateButtonsAndPreview
	"Update the buttons and the preview.."
	
	self
		updateTaskButtons;
		updatePreview.
	self world ifNotNil: 
		[self center: self world center]! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 5/23/2011 21:32'!
updatePreview
	"Update the preview.."
	
	self preview removeAllMorphs.
	self preview addMorphCentered: ( 
		self activeTask 
				ifNil: [ 'No tasks...' asMorph	]
				ifNotNil: [:t | t morph taskThumbnailOfSize: self preview extent])! !

!TasklistMorph methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
updateTaskButtons
	"Make buttons for the ordered tasks."
	
	
	self taskList removeAllMorphs.
	self tasks do: [:t | | button |
		button := t tasklistButtonFor: self.
		button ifNotNil: [self taskList addMorphBack: button]]! !

!BorderStyle class methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/8/2007 17:20'!
dashed
	"Answer a dashed border style"

	^DashedBorder new! !

!BorderStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/25/2008 12:09'!
hasFillStyle
	"Answer false."

	^false! !

!BorderStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/14/2007 10:31'!
isComposite
	"Answer false."

	^false! !

!BorderStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/25/2009 15:35'!
printOn: aStream
	"Print a description of the
	receiver on the given stream."

	self storeOn: aStream! !

!BorderStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/25/2009 15:34'!
storeOn: aStream
	"Store a reconstructable representation of the
	receiver on the given stream."

	aStream
		nextPutAll: '(' , self class name;
		nextPutAll: ' width: '; print: self width;
		nextPutAll: ' color: '; print: self color;
		nextPutAll: ')'! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/26/2007 10:22'!
adoptPaneColor: paneColor
	"Change our color too."
	
	super adoptPaneColor: paneColor.
	self fillStyle: self normalFillStyle! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/9/2007 10:46'!
hasLeftOrTop: aMorph
	"Answer whether the reciver has the given morph
	as one of of its left or top morphs."

	^leftOrTop includes: aMorph! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/9/2007 10:46'!
hasRightOrBottom: aMorph
	"Answer whether the reciver has the given morph
	as one of of its right or bottom morphs."

	^rightOrBottom includes: aMorph! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/9/2007 10:40'!
hideLeftOrTop
	"Hide the receiver and all left or top morphs."

	self hide.
	leftOrTop do: [:m | m hide]! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/9/2007 10:46'!
hideRightOrBottom
	"Hide the receiver and all right or bottom morphs."

	self hide.
	rightOrBottom do: [:m | m hide]! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/19/2008 15:31'!
mouseUp: anEvent
	"Change the cursor back to normal if necessary and change the color back to normal."
	
	(self bounds containsPoint: anEvent cursorPoint)
		ifFalse: [anEvent hand showTemporaryCursor: nil].
	self class fastSplitterResize
		ifTrue: [self updateFromEvent: anEvent].
	traceMorph ifNotNil: [traceMorph delete. traceMorph := nil].
	self adoptPaneColor: self paneColor.
	self triggerEvent: #mouseUp! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme splitterNormalFillStyleFor: self! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 11/10/2006 11:36'!
noteNewOwner: o
	"Update the fill style."
	
	super noteNewOwner: o.
	WorldState addDeferredUIMessage: [self adoptPaneColor: self paneColor]! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/14/2007 13:32'!
overlapsHorizontal: aSplitter
	"Answer whether the receiver overlaps the given spiltter
	in the horizontal plane."

	^aSplitter left <= self right and: [aSplitter right >= self left]! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/14/2007 13:32'!
overlapsVertical: aSplitter
	"Answer whether the receiver overlaps the given spiltter
	in the vertical plane."

	^aSplitter top <= self bottom and: [aSplitter bottom >= self top]! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:55'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	
	^self theme splitterPressedFillStyleFor: self! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/26/2007 10:21'!
setGrabbedColor
	"Set the color of the receiver when it is grabbed."
	
	self fillStyle: self pressedFillStyle! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/13/2008 10:32'!
shouldDraw
	"Answer whether the resizer should be drawn."
	
	^super shouldDraw or: [self class showSplitterHandles]! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/13/2008 10:36'!
shouldInvalidateOnMouseTransition
	"Answer whether the resizer should be invalidated
	when the mouse enters or leaves."
	
	^self class showSplitterHandles! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/9/2007 10:40'!
showLeftOrTop
	"Show the receiver and all left or top morphs."

	self show.
	leftOrTop do: [:m | m show]! !

!ProportionalSplitterMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/9/2007 10:47'!
showRightOrBottom
	"Show the receiver and all right or bottom morphs."

	self show.
	rightOrBottom do: [:m | m show]! !

!Point methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/17/2008 13:36'!
angle
	"Answer the angle in radians between the vectors represented by
	the receiver and (1, 0) from the origin."

	^self y arcTan: self x! !

!Point methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/17/2008 13:36'!
angleWith: aPoint
	"Answer the angle in radians between the vectors represented by
	the receiver and aPoint from the origin."

	|ar ap|
	ar := self angle.
	ap := aPoint angle.
	^ap >= ar
		ifTrue: [ap - ar]
		ifFalse: [Float pi * 2 - ar + ap]! !

!Point methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/12/2006 10:12'!
max
	"Answer a number that is the maximum
	of the x and y of the receiver."

	^self x max: self y! !

!Point methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/12/2006 10:13'!
min
	"Answer a number that is the minimum
	of the x and y of the receiver."

	^self x min: self y! !

!Point methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/17/2008 13:36'!
reflectedAbout: aPoint
	"Answer a new point that is the reflection of the receiver about the given point."

	^(self - aPoint) negated + aPoint! !

!FillStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/21/2008 16:35'!
fillRectangle: aRectangle on: aCanvas
	"Fill the given rectangle on the given canvas with the receiver."
	
	aCanvas fillRectangle: aRectangle basicFillStyle: self! !

!FillStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/20/2008 23:03'!
isCompositeFill
	"Answer whether the receiver is a composite fill.
	False by default."

	^false! !

!IndentingListItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/23/2007 10:47'!
changed
	"Need to invalidate the selection frame."

	container ifNil: [^super changed].
	self invalidRect: self selectionFrame.
	super changed! !

!IndentingListItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/12/2006 15:34'!
drawMouseDownHighlightOn: aCanvas
	"Draw with a dotted border."
	
	|frame|
	self highlightedForMouseDown ifTrue: [
		container ifNil: [^super drawMouseDownHighlightOn: aCanvas].
		frame := self selectionFrame.
		aCanvas 
			frameRectangle: frame
			width: 1
			colors: {container mouseDownHighlightColor. Color transparent}
			 dashes: #(1 1)]! !

!IndentingListItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 13:56'!
lastChild
	"Answer the last child."

	|c|
	c := self firstChild ifNil: [^nil].
	[c nextSibling isNil] whileFalse: [c := c nextSibling].
	^c! !

!IndentingListItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 11/15/2007 14:26'!
openItemPath: anArray
	"Open a path based on wrapper item equivalence. Generally more specific
	than #openPath: (string based)."
	
	| found |
	anArray isEmpty
		ifTrue: [^ container setSelectedMorph: nil].
	found := nil.
	self
		withSiblingsDo: [:each | found
				ifNil: [(each complexContents withoutListWrapper == anArray first
							or: [anArray first isNil])
						ifTrue: [found := each]]].
	found
		ifNotNil: [found isExpanded
				ifFalse: [found toggleExpandedState.
					container adjustSubmorphPositions].
			found changed.
			anArray size = 1
				ifTrue: [^ container setSelectedMorph: found].
			^ found firstChild
				ifNil: [container setSelectedMorph: nil]
				ifNotNil: [found firstChild openItemPath: anArray allButFirst]].
	^container setSelectedMorph: nil! !

!IndentingListItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 13:56'!
outerBounds
	"Return the 'outer' bounds of the receiver, e.g., the bounds that need to be invalidated when the receiver changes."
	
	|box|
	box := super outerBounds.
	container ifNil: [^box].
	^box left: (box left min: self selectionFrame left)! !

!IndentingListItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/12/2006 15:34'!
selectionFrame
	"Answer the selection frame rectangle."

	|frame|
	frame := self bounds: self bounds in: container.
	frame := self
		bounds: ((frame left: container innerBounds left) right: container innerBounds right)
		from: container.
	^frame! !

!IndentingListItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/5/2007 15:07'!
theme
	"Answer the ui theme that provides controls.
	Done directly here to avoid performance hit of
	looking up in window."

	^UITheme current! !

!TranslucentColor methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 14:13'!
pixelWord32
	"Returns an integer representing the bits that appear in a single pixel of this color in a Form of depth 32.
	Transparency: The pixel value zero is reserved for transparent. For depths greater than 8, black maps to the darkest possible blue.
	Just a little quicker if we are dealing with RGBA colors at 32 bit depth."

	| val |
	val := super pixelWord32.
	val at: 4 put: alpha.
	^val
! !

Announcement subclass: #ColorChanged
	instanceVariableNames: 'newColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!ColorChanged commentStamp: 'LaurentLaffont 4/15/2011 20:19' prior: 0!
I'm a Announcement used to indicate a color has changed. 

Example:

(ColorSelectorDialogWindow new
                        title: 'Choose a color';
                        open;
                        announcer) on: ColorChanged  do: [:ann|
                                                                        UIManager inform: 'Selected color: ', ann newColor asString].!

!ColorChanged class methodsFor: 'instance creation' stamp: 'dik 6/27/2010 16:26'!
to: aColor
	^self new 
		newColor: aColor! !

!ColorChanged methodsFor: 'accessing' stamp: 'dik 6/27/2010 16:26'!
newColor
	^ newColor! !

!ColorChanged methodsFor: 'accessing' stamp: 'dik 6/27/2010 16:26'!
newColor: anObject
	newColor := anObject! !

Announcement subclass: #ExpanderMorphAnnouncement
	instanceVariableNames: 'expanderMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ExpanderMorphAnnouncement class methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 13:45'!
on: anExpanderMorph
	"Answer a new announcement for the given expander."

	^self new expanderMorph: anExpanderMorph! !

!ExpanderMorphAnnouncement methodsFor: 'accessing' stamp: 'GaryChambers 1/25/2011 13:32'!
expanderMorph

	^ expanderMorph! !

!ExpanderMorphAnnouncement methodsFor: 'accessing' stamp: 'GaryChambers 1/25/2011 13:32'!
expanderMorph: anObject

	expanderMorph := anObject! !

ExpanderMorphAnnouncement subclass: #ExpanderMorphContracted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ExpanderMorphContracted commentStamp: 'LaurentLaffont 4/15/2011 20:18' prior: 0!
I am an Announcement that occurs when an ExpanderMorph is contracted (rolled-up).
 
Example where visibility of another UI component depends on the expanded/contracted state of Expander 2
 
|builder expanders ex1 ex2 text list row|
builder := UITheme builder.
expanders := builder newColumn: {
 ex1 := builder newExpander: 'Expander 1'.
 ex2 := builder newExpander: 'Expander 2'}.
expanders
 width: 100;
 hResizing: #rigid.
text := builder
 newTextEditorFor: (ValueHolder new contents: 'Some text')
 getText: #contents setText: #contents:.
list := (builder
 newListFor: (ListModel new list: #('One' 'Two' 'Three' 'Four'); selectionIndex: 3)
 list: #list selected: #selectionIndex changeSelected: #selectionIndex:
 help: 'This is a list')
  minWidth: 120;
  visible: false;
  disableTableLayout: true.
ex2 announcer
 when: ExpanderMorphContracted do: [list hide; disableTableLayout: true];
 when: ExpanderMorphExpanded do: [list show; disableTableLayout: false].
row := builder newRow: {
 expanders.
 (builder newRow: {text. list})
  vResizing: #spaceFill}.!

ExpanderMorphAnnouncement subclass: #ExpanderMorphExpanded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/27/2009 16:44'!
adoptPaneColor: paneColor
	"Match the pane colour."
	
	super adoptPaneColor: paneColor.
	scrollBar adoptPaneColor: paneColor.
	hScrollBar adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self borderWidth > 0 ifTrue: [
		self borderStyle: self borderStyleToUse]! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/27/2009 11:57'!
borderStyle: aBorderStyle
	"Optimised when no change."
	
	self borderStyle = aBorderStyle ifTrue: [^self].
	super borderStyle: aBorderStyle.
	self setScrollDeltas! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/27/2009 16:43'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self enabled
		ifTrue: [self theme scrollPaneNormalBorderStyleFor: self]
		ifFalse: [self theme scrollPaneDisabledBorderStyleFor: self]! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/26/2006 15:30'!
getMenuSelector: aSymbol
	"Set the menu selector."

	getMenuSelector := aSymbol! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/24/2006 12:00'!
hScrollValue: scrollValue
	"Set the horizontal scroll value via the scrollbar itself."

	hScrollBar setValue: scrollValue! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 9/8/2011 10:42'!
handlesMouseWheel: evt
	"Do I want to receive mouseWheel events?" 

	^self vIsScrollable! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/30/2006 09:20'!
hideOrShowScrollBar
	"Hide or show the scrollbar depending on if the pane is scrolled/scrollable."

	"Don't do anything with the retractable scrollbar unless we have focus"
	retractableScrollBar & self hasFocus not ifTrue: [^self].
	"Don't show it if we were told not to."
	(self valueOfProperty: #noScrollBarPlease ifAbsent: [false]) ifTrue: [^self].

	self vIsScrollbarNeeded not & self isScrolledFromTop not ifTrue: [self vHideScrollBar].
	self vIsScrollbarNeeded | self isScrolledFromTop ifTrue: [self vShowScrollBar].
! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/15/2007 11:18'!
minHeight
	"Answer the minimum height."

	|noVPlease noHPlease minH|
	noVPlease := self valueOfProperty: #noVScrollBarPlease ifAbsent: [false]. 
	noHPlease := self valueOfProperty: #noHScrollBarPlease ifAbsent: [false]. 
	noVPlease
		ifTrue: [noHPlease
					ifTrue: [minH := 1]
					ifFalse:[minH := self scrollBarThickness]]
		ifFalse: [noHPlease
					ifTrue:[minH := self scrollBarThickness * 3]
					ifFalse: [minH := self scrollBarThickness * 4 + 2]].
	^minH max: super minHeight! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/15/2007 11:14'!
minWidth
	"Answer the minimum width."

	|noVPlease noHPlease minW|
	noVPlease := self valueOfProperty: #noVScrollBarPlease ifAbsent: [false]. 
	noHPlease := self valueOfProperty: #noHScrollBarPlease ifAbsent: [false]. 
	minW := noVPlease
		ifTrue: [noHPlease
					ifTrue: [1]
					ifFalse: [self scrollBarThickness * 3]]
		ifFalse: [noHPlease
					ifTrue: [self scrollBarThickness + 20]
					ifFalse: [self scrollBarThickness * 3 + 2]].
	^minW max: super minWidth! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/28/2008 16:04'!
mouseWheel: event 
	"Handle a mouseWheel event."
	
	event direction = #up ifTrue: [
		scrollBar scrollUp: 3].
	event direction = #down ifTrue: [
		scrollBar scrollDown: 3]! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/3/2008 13:09'!
scrollBarThickness
	"Includes border"
	
	| result |
	result := self theme scrollbarThickness.
	self flatColoredScrollBarLook
		ifFalse: [result := result + 2].
	^ result! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/6/2006 10:28'!
scrollValue
	"Answer the values of the scrollbars as a point."

	^hScrollBar value @ scrollBar value! !

!ScrollPane methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/24/2006 12:00'!
vScrollValue: scrollValue
	"Set the vertical scroll value via the scrollbar itself."

	scrollBar setValue: scrollValue! !

!MCChangeSelector methodsFor: '*Polymorph-Widgets-override' stamp: 'AlainPlantec 12/1/2009 21:46'!
widgetSpecs
	MCCodeTool showAnnotationPane ifFalse: [ ^#(
		((buttonRow) (0 0 1 0) (0 0 0 30))
		((multiListMorph:selection:listSelection:menu: list selection listSelectionAt: methodListMenu:) (0 0 1 0.4) (0 30 0 0))
		((buttonRow: #(('Select All' selectAll 'select all changes') ('Select None' selectNone 'select no changes'))) (0 0.4 1 0.4) (0 0 0 30))
		((textMorph: text) (0 0.4 1 1) (0 30 0 0))
		)].

	^ #(
		((buttonRow) (0 0 1 0) (0 0 0 30))
		((multiListMorph:selection:listSelection:menu: list selection listSelectionAt: methodListMenu:) (0 0 1 0.4) (0 30 0 0))
		((buttonRow: #(('Select All' selectAll 'select all changes') ('Select None' selectNone 'select no changes'))) (0 0.4 1 0.4) (0 0 0 30))
		((textMorph: annotations) (0 0.4 1 0.4) (0 30 0 60))
		((textMorph: text) (0 0.4 1 1) (0 60 0 0))
		)! !

SimpleHierarchicalListMorph subclass: #PluggableTreeMorph
	instanceVariableNames: 'roots selectedWrapper getRootsSelector getChildrenSelector hasChildrenSelector getLabelSelector getIconSelector getSelectedPathSelector getHelpSelector dropItemSelector wantsDropSelector dragItemSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PluggableTreeMorph commentStamp: 'ar 2/12/2005 04:38' prior: 0!
A pluggable tree morph.!

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'mvdg 2/14/2007 14:58'!
acceptDroppingMorph: aMorph event: evt
	| item dropTarget |
	dropItemSelector ifNil:[^self].
	item := aMorph passenger.
	dropTarget := (self itemFromPoint: evt position) withoutListWrapper.
	model perform: dropItemSelector with: item with: dropTarget.
	evt hand releaseMouseFocus: self.
	Cursor normal show.
! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:19'!
balloonTextForNode: node
	getHelpSelector ifNil:[^nil].
	^model perform: getHelpSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 01:13'!
contentsOfNode: node
	| children |
	getChildrenSelector ifNil:[^#()].
	children := model perform: getChildrenSelector with: node item.
	^children collect:[:item| PluggableTreeItemNode with: item model: self]! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/11/2007 13:53'!
dragItemSelector
	^dragItemSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/11/2007 13:53'!
dragItemSelector: aSymbol
	dragItemSelector := aSymbol.
	aSymbol ifNotNil:[self dragEnabled: true].! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
dropItemSelector
	^dropItemSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/9/2007 21:37'!
dropItemSelector: aSymbol
	dropItemSelector := aSymbol.
	aSymbol ifNotNil:[self dropEnabled: true].! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
dropNode: srcNode on: dstNode
	dropItemSelector ifNil:[^nil].
	model perform: dropItemSelector with: srcNode item with: dstNode item! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
getHelpSelector
	^getHelpSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
getHelpSelector: aSymbol
	getHelpSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getIconSelector
	^getIconSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getIconSelector: aSymbol
	getIconSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getLabelSelector
	^getLabelSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:57'!
getMenuSelector
	^getMenuSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getRootsSelector
	^getRootsSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getRootsSelector: aSelector
	getRootsSelector := aSelector.
	self update: getRootsSelector.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 03:33'!
getSelectedPathSelector
	^getSelectedPathSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 03:33'!
getSelectedPathSelector: aSymbol
	getSelectedPathSelector := aSymbol.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
hasChildrenSelector
	^hasChildrenSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
hasChildrenSelector: aSymbol
	hasChildrenSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:11'!
hasNodeContents: node
	hasChildrenSelector ifNil:[^node contents isEmpty not].
	^model perform: hasChildrenSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
iconOfNode: node
	getIconSelector ifNil:[^nil].
	^model perform: getIconSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:02'!
isDraggableNode: node
	^true! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:58'!
keystrokeActionSelector
	^keystrokeActionSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:58'!
keystrokeActionSelector: aSymbol
	keystrokeActionSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
printNode: node
	getLabelSelector ifNil:[^node item printString].
	^model perform: getLabelSelector with: node item! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:22'!
roots
	^roots! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 01:11'!
roots: anArray
	roots := anArray collect:[:item| PluggableTreeItemNode with: item model: self].
	self list: roots.! !

!PluggableTreeMorph methodsFor: 'updating' stamp: 'ar 2/12/2005 17:29'!
selectPath: path in: listItem
	path isEmpty ifTrue: [^self setSelectedMorph: nil].
	listItem withSiblingsDo: [:each | 
		(each complexContents item = path first) ifTrue: [
			each isExpanded ifFalse: [
				each toggleExpandedState.
				self adjustSubmorphPositions.
			].
			each changed.
			path size = 1 ifTrue: [
				^self setSelectedMorph: each
			].
			each firstChild ifNil: [^self setSelectedMorph: nil].
			^self selectPath: path allButFirst in: each firstChild
		].
	].
	^self setSelectedMorph: nil

! !

!PluggableTreeMorph methodsFor: 'selection' stamp: 'LaurentLaffont 3/17/2010 21:41'!
setSelectedMorph: aMorph
	selectedWrapper := aMorph complexContents.
	self selection: selectedWrapper.
	setSelectionSelector ifNotNil:[
		model 
			perform: setSelectionSelector 
			with: (selectedWrapper ifNotNil:[selectedWrapper item]).
	].! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'LaurentLaffont 3/17/2010 21:42'!
setSelectedSelector
	^setSelectionSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'LaurentLaffont 3/17/2010 21:42'!
setSelectedSelector: aSymbol
	setSelectionSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'stephaneDucasse 7/17/2010 16:39'!
startDrag: evt 
	| ddm itemMorph passenger |
	self dragEnabled
		ifTrue: [itemMorph := scroller submorphs
						detect: [:any | any highlightedForMouseDown]
						ifNone: []].
	(itemMorph isNil
			or: [evt hand hasSubmorphs])
		ifTrue: [^ self].
	itemMorph highlightForMouseDown: false.
	itemMorph ~= self selectedMorph
		ifTrue: [self setSelectedMorph: itemMorph].
	passenger := self model perform: dragItemSelector with: itemMorph withoutListWrapper.
	passenger
		ifNotNil: [ddm := TransferMorph withPassenger: passenger from: self.
			ddm dragTransferType: #dragTransfer.
			self theme settings dragNDropWithAnimation
				ifTrue: [self model dragAnimationFor: itemMorph transferMorph: ddm].
			evt hand grabMorph: ddm].
	evt hand releaseMouseFocus: self! !

!PluggableTreeMorph methodsFor: 'updating' stamp: 'ar 2/12/2005 19:11'!
update: what
	what ifNil:[^self].
	what == getRootsSelector ifTrue:[
		self roots: (model perform: getRootsSelector)
	].
	what == getSelectedPathSelector ifTrue:[
		^self selectPath: (model perform: getSelectedPathSelector)
			in: (scroller submorphs at: 1 ifAbsent: [^self]) 
	].
	^super update: what! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
wantsDropSelector
	^wantsDropSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:27'!
wantsDropSelector: aSymbol
	wantsDropSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'stephaneDucasse 7/17/2010 16:39'!
wantsDroppedMorph: aMorph event: anEvent
	aMorph dragTransferType == #dragTransfer ifFalse: [^false].
	dropItemSelector ifNil: [^false].
	wantsDropSelector ifNil: [^true].
	^ (model perform: wantsDropSelector with: aMorph passenger)! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 7/15/2005 12:11'!
wantsDroppedNode: srcNode on: dstNode
	dropItemSelector ifNil:[^false].
	wantsDropSelector ifNil:[^true].
	^(model perform: wantsDropSelector with: srcNode with: dstNode) == true! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 12:12'!
adoptPaneColor: paneColor
	"Pass on to the border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self selectionColor: self selectionColor.
	self borderStyle baseColor: paneColor twiceDarker! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/17/2007 15:20'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/24/2007 10:30'!
expandedForm
	"Answer the form to use for expanded items."
	
	^self theme treeExpandedForm! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 2/13/2011 15:22'!
expandedFormForMorph: aMorph
	"Answer the form to use for expanded items."
	^ (self selectedMorph = aMorph and: [self theme selectionColor luminance < 0.6])
		ifTrue: [self theme whiteTreeExpandedForm]
		ifFalse: [self theme treeExpandedForm]! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/25/2006 11:41'!
getListSelector
	"Answer for compatibility with PluggableListMorph."
	
	^ getListSelector! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/6/2007 14:36'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self focusChanged! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/11/2006 10:40'!
mouseDownHighlightColor
	"Answer a good color to use for drawing the mouse down highlight.
	Used the line color if not transparent, otherwise a contrasting color in the
	same way as the line color is determined.
	Fall back to black if all my owners are transparent."

	|c colored |
	c := self lineColor.
	c isTransparent ifFalse: [^c].
	colored := self color isTransparent
		ifTrue: [self firstOwnerSuchThat: [:o | o isWorldOrHandMorph not and: [o color isTransparent not]]]
		ifFalse: [self].
	colored ifNil: [^Color black].
	^colored color luminance > 0.5
		ifTrue: [Color black]
		ifFalse: [Color white]
! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/24/2007 10:31'!
notExpandedForm
	"Answer the form to use for unexpanded items."
	
	^self theme treeUnexpandedForm! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 2/11/2011 22:41'!
notExpandedFormForMorph: aMorph
	^ (self selectedMorph = aMorph and: [self theme selectionColor luminance < 0.6])
		ifTrue: [self theme whiteTreeUnexpandedForm]
		ifFalse: [self theme treeUnexpandedForm]
! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/13/2006 11:26'!
selectionColor
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColor ifAbsent: [] ! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 2/11/2011 16:30'!
selectionColor: aColor
	"Set the colour for selected items."

	|w|
	aColor
		ifNil: [self removeProperty: #selectionColor]
		ifNotNil: [self setProperty: #selectionColor toValue: aColor].
	w := self ownerThatIsA: SystemWindow.
	self selectionColorToUse: (
		(self theme settings fadedBackgroundWindows not or: [w isNil or: [w isActive]])
			ifTrue: [aColor]
			ifFalse: [self theme unfocusedSelectionColor])! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 10/20/2010 21:32'!
selectionColorToUse
	"Answer the colour to use for selected items."

	^self valueOfProperty: #selectionColorToUse ifAbsent: [self theme settings selectionColor] ! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 12:14'!
selectionColorToUse: aColor
	"Set the colour for selected items."

	aColor = self selectionColorToUse ifTrue: [^self].
	aColor
		ifNil: [self removeProperty: #selectionColorToUse]
		ifNotNil: [self setProperty: #selectionColorToUse toValue: aColor].
	self selectionFrameChanged! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 12:11'!
selectionFrame
	"Answer the frame of the selected morph in the receiver or nil if none."
	
	^selectedMorph
		ifNotNil: [selectedMorph bounds:  selectedMorph selectionFrame in: self]! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 12:11'!
selectionFrameChanged
	"Invalidate frame of the current selection if any."
	
	selectedMorph ifNil: [ ^self ].
	self invalidRect: self selectionFrame! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 14:06'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!SimpleHierarchicalListMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/22/2007 14:50'!
themeChanged
	"Update the selection colour."

	self selectionColor ifNotNil: [
		self selectionColor: self theme selectionColor].
	super themeChanged! !

SimpleHierarchicalListMorph subclass: #TreeListMorph
	instanceVariableNames: 'font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TreeListMorph commentStamp: 'gvc 5/18/2007 10:15' prior: 0!
A SimpleHierarchicalListMorph subclass supporting alternative fonts for all items.!

!TreeListMorph methodsFor: 'private' stamp: 'gvc 5/15/2007 16:23'!
addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean
	"Update the font on each morph."
	
	|answer|
	answer := super addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean.
	self scroller submorphsDo: [:i |
		i
			font: self font;
			extent: i minWidth @ i minHeight].
	^answer! !

!TreeListMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:01'!
font
	"Answer the value of font"

	^font ifNil: [TextStyle defaultFont]! !

!TreeListMorph methodsFor: 'accessing' stamp: 'gvc 9/8/2006 14:00'!
font: anObject
	"Set the value of font"

	font := anObject! !

!TreeListMorph methodsFor: 'private' stamp: 'gvc 5/15/2007 16:16'!
insertNewMorphs: morphList
	"Update the font on each morph."
	
	morphList do: [:m |
		m
			font: self font;
			extent: m minWidth @ m minHeight].
	^super insertNewMorphs: morphList! !

!TreeListMorph methodsFor: 'accessing' stamp: 'gvc 2/22/2010 17:51'!
keystrokeActionSelector
	"Answer the selector of the message to send to the model when a keystroke occurs."

	^keystrokeActionSelector! !

!TreeListMorph methodsFor: 'accessing' stamp: 'gvc 2/22/2010 17:52'!
keystrokeActionSelector: aSymbol
	"Set the selector of the message to send to the model when a keystroke occurs.
	One or two arguments... 1 for character, 2 for character and sender (self)."

	keystrokeActionSelector := aSymbol! !

!TreeListMorph methodsFor: 'private' stamp: 'gvc 1/29/2009 16:34'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Update the scroller and scrollbars now since bounds set directly
	(not via #extent:)."
	
	super layoutBounds: aRectangle.
	self
		resizeScroller;
		setScrollDeltas! !

SimpleBorder subclass: #W2KGroupBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!W2KGroupBorder methodsFor: 'drawing' stamp: 'SS 1/1/2009 01:51'!
drawLineFrom: startPoint to: stopPoint on: aCanvas! !

!W2KGroupBorder methodsFor: 'drawing' stamp: 'SS 1/1/2009 02:17'!
frameOval: aRectangle on: aCanvas! !

!W2KGroupBorder methodsFor: 'drawing' stamp: 'SS 1/1/2009 02:17'!
framePolygon: vertices on: aCanvas! !

!W2KGroupBorder methodsFor: 'drawing' stamp: 'SS 1/1/2009 02:19'!
framePolyline: vertices on: aCanvas ! !

!W2KGroupBorder methodsFor: 'drawing' stamp: 'SS 1/1/2009 03:09'!
frameRectangle: aRectangle on: aCanvas

	aCanvas frameRectangle: (aRectangle insetOriginBy: (0@0) cornerBy: (0@0)) color: Color white.
	aCanvas frameRectangle: (aRectangle insetOriginBy: (1@1) cornerBy: (0@0)) color: Color white.
	aCanvas frameRectangle: (aRectangle insetOriginBy: (0@0) cornerBy: (1@1)) color: Color gray.! !

!W2KGroupBorder methodsFor: 'accessing' stamp: 'SS 1/1/2009 03:32'!
width
	^3! !

Dictionary subclass: #KeyedTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!KeyedTree commentStamp: '<historical>' prior: 0!
Provides path based access to elements contained in the receiver and any subtrees.

Example:

(KeyedTree new
	at: 1 put: 'One';
	at: 2 put: 'Two';
	at: 'Tree' put: (KeyedTree new
					at: $a put: 'Tree-A';
					at: $b put: 'Tree-B';
					yourself);
	yourself) atPath: #('Tree' $b)!

!KeyedTree methodsFor: 'accessing' stamp: 'gvc 12/15/2005 13:57'!
allKeys
	"Answer an ordered collection of the keys of the receiver and any subtrees.
		Please no circular references!!"

	|answer|
	answer := OrderedCollection new.
	answer addAll: self keys.
	self subtrees do: [:t |
		answer addAll: t allKeys].
	^answer! !

!KeyedTree methodsFor: 'accessing' stamp: 'CamilloBruni 4/11/2011 13:30'!
atPath: anArray
	"Answer the element referenced by the give key path.
	Signal an error if not found."

	^self atPath: anArray ifAbsent: [self errorKeyNotFound: anArray]! !

!KeyedTree methodsFor: 'accessing' stamp: 'gvc 2/1/2006 11:01'!
atPath: anArray ifAbsent: aBlock
	"Answer the element referenced by the given key path.
	Answer the value of aBlock if not found."

	|element|
	element := self.
	anArray do: [:key |
		element := element at: key ifAbsent: [^aBlock value]].
	^element! !

!KeyedTree methodsFor: 'accessing' stamp: 'gvc 2/1/2006 11:01'!
atPath: anArray ifAbsentPut: aBlock
	"Answer the element referenced by the given key path.
	Answer the value of aBlock if not found after creating its path."

	|element|
	anArray isEmpty
		ifTrue: [^self].
	element := self.
	anArray allButLastDo: [:key |
		element := element at: key ifAbsentPut: [self species new]].
	^element at: anArray last ifAbsentPut: aBlock! !

!KeyedTree methodsFor: 'accessing' stamp: 'gvc 2/1/2006 11:00'!
atPath: anArray put: aBlock
	"Answer the value of aBlock after creating its path."

	|element|
	anArray isEmpty
		ifTrue: [^self].
	element := self.
	anArray allButLastDo: [:key |
		element := element at: key ifAbsentPut: [self species new]].
	^element at: anArray last put: aBlock! !

!KeyedTree methodsFor: 'printing' stamp: 'gvc 1/17/2008 16:06'!
formattedText
	"Answer a string or text representing the receiver with indentation and, possibly, markup."

	|str|
	str := String new writeStream.
	self putFormattedTextOn: str level: 0 indentString: '  '.
	^str contents! !

!KeyedTree methodsFor: 'printing' stamp: 'gvc 1/17/2008 16:23'!
formattedTextWithDescriptions: aKeyedTree
	"Answer a string or text representing the receiver with indentation and, possibly, markup.
	Descriptions of each item are taken from the given tree with
	the same key structure as the receiver."
	
	|str|
	str := String new writeStream.
	self putFormattedTextOn: str withDescriptions: aKeyedTree level: 0 indentString: '  '.
	^str contents! !

!KeyedTree methodsFor: 'adding' stamp: 'nice 1/5/2010 15:59'!
merge: aKeyedTree
	"Merge the given tree into the receiver, overwriting or extending elements as needed."

	
	aKeyedTree keysAndValuesDo: [:k :v | | subtree |
		(v isKindOf: KeyedTree)
			ifTrue: [subtree := self at: k ifAbsentPut: [v species new].
				 	(subtree isKindOf: KeyedTree) not
						ifTrue: [subtree := self at: k put: v species new].
					subtree merge: v]
			ifFalse: [self at: k put: v]]! !

!KeyedTree methodsFor: 'copying' stamp: 'nice 1/13/2010 21:46'!
postCopy
	"Must copy the associations, or later store will affect both the
		original and the copy.
	Copy any subtrees too!!"

	array := array collect: [:assoc |
			assoc ifNil: [nil]
				ifNotNil: [Association
							key: assoc key
							value: ((assoc value isKindOf: KeyedTree)
									ifTrue: [assoc value copy]
									ifFalse: [assoc value])]]! !

!KeyedTree methodsFor: 'printing' stamp: 'nice 1/5/2010 15:59'!
putFormattedTextOn: aStream level: indentLevel indentString: aString
	"Place a description of the receiver on the given stream with the given indentation level."

	
	(self keys asSortedCollection: self sortBlock) do: [:k | | v |
		indentLevel timesRepeat: [aStream nextPutAll: aString].
		aStream nextPutAll: k printString.
		v := self at: k.
		(v isKindOf: self class)
			ifTrue: [aStream cr.
					v putFormattedTextOn: aStream level: indentLevel + 1 indentString: aString]
			ifFalse: [aStream
						nextPutAll: ' : ';
						nextPutAll: v printString.
					aStream cr]]! !

!KeyedTree methodsFor: 'printing' stamp: 'nice 1/5/2010 15:59'!
putFormattedTextOn: aStream withDescriptions: aKeyedTree level: indentLevel indentString: aString
	"Place a print of the receiver and associated description on the given stream with the given indentation level."

	
	(self keys asSortedCollection: self sortBlock) do: [:k | | v |
		indentLevel timesRepeat: [aStream nextPutAll: aString].
		aStream nextPutAll: k printString.
		v := self at: k.
		(v isKindOf: self class)
			ifTrue: [aStream cr.
					v
						putFormattedTextOn: aStream
						withDescriptions: (aKeyedTree at: k ifAbsent: [self class new])
						level: indentLevel + 1
						indentString: aString]
			ifFalse: [aStream
						nextPutAll: ' : ';
						nextPutAll: v printString;
						tab; tab;
						nextPutAll: (aKeyedTree at: k ifAbsent: ['nondescript']) printString.
					aStream cr]]! !

!KeyedTree methodsFor: 'removing' stamp: 'CamilloBruni 4/11/2011 13:31'!
removePath: anArray
	"Remove and answer the element referenced by the given path.
	Signal an error if not found."

	^self removePath: anArray ifAbsent: [self errorKeyNotFound: anArray]! !

!KeyedTree methodsFor: 'removing' stamp: 'gvc 10/20/2005 18:53'!
removePath: anArray ifAbsent: aBlock
	"Remove and answer the element referenced by the given path.
	Answer the value of aBlock if not found."

	|element|
	anArray isEmpty
		ifTrue: [^self].
	element := self.
	anArray allButLastDo: [:key |
		element := element at: key ifAbsent: [^aBlock value]].
	^element removeKey: anArray last ifAbsent: aBlock	! !

!KeyedTree methodsFor: 'accessing' stamp: 'gvc 1/17/2008 15:37'!
sortBlock
	"Answer the block to sort tree keys with."

	^[:a :b | [a <= b] on: Error do: [a class name <= b class name]]! !

!KeyedTree methodsFor: 'accessing' stamp: 'gvc 12/15/2005 13:54'!
subtrees
	"Answer the subtrees of the receiver."

	^(self select: [:v | v isKindOf: KeyedTree]) values! !

TextMorphForEditView subclass: #TextMorphForEditorView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TextMorphForEditorView commentStamp: 'AlainPlantec 2/21/2011 17:43' prior: 0!
DEPRECATED IN 1.3
!

TextMorphForEditView subclass: #TextMorphForFieldView
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TextMorphForFieldView commentStamp: 'gvc 5/18/2007 12:28' prior: 0!
Single-line text field editor with DialogWindow key integration (return for default, escape for cancel) and keyboard focus navigation (tab/shift-tab).!

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/22/2010 12:03'!
editorClass
	^ TextEditor! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/17/2010 16:38'!
isEditEvent: anEvent
	"Answer whether the given event is a key stroke that
	should be allowed despite the max length."

	|key|
	key := anEvent keyValue asCharacter.
	^key == Character cr or: [
		key == Character escape or: [
		key == Character backspace or: [
		key == Character delete or: [
		key == Character arrowLeft or: [
		key == Character arrowRight or: [
		key == Character home or: [
		key == Character end or: [
			anEvent commandKeyPressed and: [key = $a]]]]]]]]]! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 4/27/2011 15:35'!
keyStroke: evt
	"Don't allow editing keys if the edit view is disabled.
	Do the key if max length has not been reached.
	Don't allow tabs." 
	(self localHandleKeystroke: evt) ifTrue: [^self].
	(self maxLength isNil or: [self text size < self maxLength or: [
			self editor selectionInterval size > 0 or: [self isEditEvent: evt]]])
		ifTrue: [self doAutoAccept: evt].
	super keyStroke: evt! !

!TextMorphForFieldView methodsFor: 'changed' stamp: 'gvc 11/13/2007 11:54'!
keyboardFocusChange: aBoolean 
	"If we are losing focus and have acceptOnFocusChange then accept."
	
	aBoolean
		ifTrue: [self editView selectAll]
		ifFalse: [self editView selectFrom: 1 to: 0].
	super keyboardFocusChange: aBoolean! !

!TextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/28/2010 22:50'!
localHandleKeystroke: evt
	"Answer whether we locally handle the keyStroke event.
	Disregard tabs for now."
	
	(self editView keystrokeFromTextMorph: evt)
		ifTrue: [^ true].
	(self autoAccept and: [evt keyCharacter = Character cr and: [self crAction notNil]])
		 ifTrue: [(self crAction isKindOf: MessageSend)
				ifTrue: [ self crAction value]
				ifFalse: [self crAction value: self text]..
			^ true].
	evt keyCharacter = Character tab ifTrue: [
		evt shiftPressed
			ifTrue: [(self editView respondsTo: #navigateFocusBackward)
						ifTrue: [self editView navigateFocusBackward]]
			ifFalse: [(self editView respondsTo: #navigateFocusForward)
						ifTrue: [self editView navigateFocusForward]].
		^true].
	^false! !

!TextMorphForFieldView methodsFor: 'accessing' stamp: 'gvc 9/18/2006 14:58'!
maxLength
	"Answer the value of maxLength"

	^ maxLength! !

!TextMorphForFieldView methodsFor: 'accessing' stamp: 'gvc 9/18/2006 14:58'!
maxLength: anObject
	"Set the value of maxLength"

	maxLength := anObject! !

!TextMorphForFieldView methodsFor: 'accessing' stamp: 'gvc 10/17/2008 12:35'!
minExtent
	"Overridden to allow text to shrink to minimum extent rather than being (incorrectly)
	treated as rigid. Should be the same for other morphs too. Bah!!"

	| layout minExtent extra hFit vFit |
	hFit := self hResizing.
	vFit := self vResizing.
	(hFit == #spaceFill or: [vFit == #spaceFill]) 
		ifFalse: 
			["The receiver will not adjust to parents layout by growing or shrinking,
		which means that an accurate layout defines the minimum size."

			^self fullBounds extent].
	layout := self layoutPolicy.
	minExtent := layout isNil 
		ifTrue: [0 @ 0]
		ifFalse: [layout minExtentOf: self in: self layoutBounds].
	minExtent := hFit == #rigid 
		ifTrue: [self fullBounds extent x @ minExtent y]
		ifFalse: 
			[extra := self bounds width - self layoutBounds width.
			(minExtent x + extra) @ minExtent y].
	minExtent := vFit == #rigid 
				ifTrue: [minExtent x @ self fullBounds extent y]
				ifFalse: 
					[extra := self bounds height - self layoutBounds height.
					minExtent x @ (minExtent y + extra)].
	minExtent := minExtent max: self minWidth @ self minHeight.
	^minExtent! !

!TextMorphForFieldView methodsFor: 'layout' stamp: 'gvc 6/4/2007 11:22'!
minHeight
	"Answer the height of one line."

	^self minimumExtent y max: super minHeight! !

!TextMorphForFieldView methodsFor: 'layout' stamp: 'gvc 6/4/2007 11:22'!
minWidth
	"Answer the minimum width."

	^self minimumExtent x max: super minWidth! !

!TextMorphForFieldView methodsFor: 'geometry' stamp: 'gvc 6/4/2007 11:55'!
minimumExtent
	"Use the actual paragraph line to take font changes into account."
	
	| minExt |
	textStyle ifNil: [^ 9@16].
	borderWidth ifNil: [^ 9@16].
	minExt := (9@(self paragraph lines first lineHeight ceiling)) + (borderWidth*2).
	margins ifNil: [^ minExt].
	^ ((0@0 extent: minExt) expandBy: margins) extent! !

!TextMorphForFieldView methodsFor: 'event handling' stamp: 'gvc 1/4/2007 16:05'!
mouseMove: evt
	"Allow auto scroll in any direction.
	Something else is preventing the left/right case."
	
	| editEvt |
	self perform: #mouseMove: withArguments: {evt} inSuperclass: TextMorph.
	evt redButtonPressed ifFalse: [^ self].
	editEvt := evt transformedBy: (self transformedFrom: editView) inverseTransformation.
	(editView bounds containsPoint: editEvt position) ifFalse:[
		"Start auto-scrolling"
		self startStepping: #autoScrollView:
			at: Time millisecondClockValue
			arguments: (Array with: editEvt)
			stepTime: 100. "fast enough"
	] ifTrue:[
		self stopSteppingSelector: #autoScrollView:.
	].! !

!TextMorphForFieldView methodsFor: 'private' stamp: 'AlainPlantec 9/15/2011 17:27'!
paragraph
	"Paragraph instantiation is lazy -- create it only when needed.
	Don't adjust rightX (as in TexMorph>>paragraph)
	since wrapFlag must be false for layout to work."
	
	paragraph ifNotNil: [^ paragraph].

self setProperty: #CreatingParagraph toValue: true.

	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	paragraph := (Paragraph new textOwner: self owner).
	paragraph wantsColumnBreaks: successor notNil.
	paragraph
		compose: text
		style: textStyle copy
		from: self startingIndex
		in: self container.
	"don't adjust the right, let it scroll!!"
	paragraph focused: (self currentHand keyboardFocus == self).
	self fit.
self removeProperty: #CreatingParagraph.

	self selectionColor: self selectionColor.
	^ paragraph! !

!TextMorphForFieldView methodsFor: 'find-replace' stamp: 'AlainPlantec 11/11/2010 21:44'!
sharesFindReplace
	^ false! !

!TextMorphForFieldView methodsFor: 'private' stamp: 'AlainPlantec 11/12/2010 22:36'!
useFindReplaceSelection
	^ false! !

!TextMorphForFieldView methodsFor: 'private' stamp: 'AlainPlantec 11/12/2010 21:12'!
useSecondarySelection
	^ false! !

!TextMorphForFieldView methodsFor: 'private' stamp: 'AlainPlantec 11/17/2010 15:26'!
useSelectionBar
	^ false! !

!MenuItemMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 2/26/2010 04:58'!
deselectTimeOut: evt
	"Deselect timout. Now really deselect"
	owner selectedItem == self
	ifTrue: [
		self isInDockingBar
			ifTrue: [evt hand releaseMouseFocus: owner]
			ifFalse: [evt hand newMouseFocus: owner].
		owner selectItem: nil event: evt   ].! !

!MenuItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/17/2008 14:43'!
enabled
	"Delegate to exisitng method."

	^self isEnabled! !

!MenuItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/17/2008 14:43'!
enabled: aBoolean
	"Delegate to exisitng method."

	self isEnabled: aBoolean! !

!MenuItemMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'SeanDeNigris 1/19/2011 20:57'!
mouseDown: evt
	"Handle a mouse down event. Menu items get activated when the mouse is over them."

	evt shiftPressed ifTrue: [^ super mouseDown: evt].  "enable label editing"

	(self isInDockingBar
			and:[isSelected]
			"and:[owner selectedItem == self]")
		ifTrue:[
			evt hand newMouseFocus: nil.
			owner selectItem: nil event: evt. ]
		ifFalse:[
			evt hand newMouseFocus: owner. "Redirect to menu for valid transitions"
			owner selectItem: self event: evt. ]
! !

!MenuItemMorph methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:40'!
themeChanged
	"Also pass on to the submenu if any."

	super themeChanged.
	self subMenu ifNotNil: [:m | m themeChanged]! !

!LayoutFrame methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 8/24/2007 15:51'!
minExtentFrom: minExtent
	"Return the minimal extent the given bounds can be represented in."
	
	|width height widthProp heightProp leftO rightO topO bottomO|
	leftO := leftOffset ifNil: [0].
	rightO := rightOffset ifNil: [0].
	topO := topOffset ifNil: [0].
	bottomO := bottomOffset ifNil: [0].
	"calculate proportional area. bottom/right offsets extend in +ve direction."
	width := minExtent x + leftO - rightO.
	height := minExtent y + topO - bottomO.
	"calculate the effective proportion"
	widthProp := (rightFraction ifNil: [1.0]) - (leftFraction ifNil: [0]).
	heightProp := (bottomFraction ifNil: [1.0]) - (topFraction ifNil: [0]).
	"if the proportions are 0 then the minima cannot be determined and
	minExtent cannot be respected."
	width := widthProp = 0
		ifTrue: [0]
		ifFalse: [width / widthProp].
	height := heightProp = 0
		ifTrue: [0]
		ifFalse: [height / heightProp].
	^width truncated @ height truncated! !

BalloonMorph subclass: #SimpleBalloonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!SimpleBalloonMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 1/30/2009 15:11'!
getVertices: bounds
	"Construct vertices for a balloon up and to left of anchor."

	^(bounds expandBy: 3) corners atAll: #(1 4 3 2)! !

!SimpleBalloonMorph methodsFor: 'initialize-release' stamp: 'AlainPlantec 2/22/2011 17:57'!
initialize
	"Initialize the the receiver."
	
	super initialize.
	self beStraightSegments! !

!SystemProgressBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 1/7/2010 22:43'!
barFillStyle
	"Answer the fillStyle for the bar if present or
	the theme menuTitleColor otherwise."

	^self valueOfProperty: #barFillStyle ifAbsent: [self theme menuTitleColor]! !

!SystemProgressBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/23/2007 17:04'!
barFillStyle: aFillStyle
	"Set the fillStyle for the bar."

	^self setProperty: #barFillStyle toValue: aFillStyle! !

!SystemProgressBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 10:31'!
extent: aPoint
	"Update the bar fillStyle if appropriate."
	
	super extent: aPoint.
	self fillStyle isOrientedFill ifTrue: [
		self fillStyle: (self theme progressBarFillStyleFor: self)].
	self barFillStyle isOrientedFill ifTrue: [
		self barFillStyle: ( self theme progressBarProgressFillStyleFor: self)]! !

!SystemProgressBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/23/2007 17:04'!
privateMoveBy: delta 
	"Update the bar fillStyle if appropriate."
	
	| fill |
	super privateMoveBy: delta.
	fill := self barFillStyle.
	fill isOrientedFill ifTrue: [fill origin: fill origin + delta]! !

PluggableButtonMorph subclass: #ControlButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ControlButtonMorph commentStamp: 'gvc 9/23/2008 12:04' prior: 0!
Specially themed "control" button. Used for drop-lists, expanders etc.!

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:23'!
disabledBorderStyle
	"Return the disabled borderStyle of the receiver."
	
	^self theme controlButtonDisabledBorderStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:24'!
disabledFillStyle
	"Return the disabled fillStyle of the receiver."
	
	^self theme controlButtonDisabledFillStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 12/5/2008 14:58'!
initialize
	"Initialize the receiver."

	super initialize.
	self layoutInset: (self theme controlButtonLabelInsetFor: self)! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/28/2009 17:12'!
minWidth
	"Consult the theme also."

	^self perform: #minWidth withArguments: #() inSuperclass: Morph! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:23'!
mouseOverBorderStyle
	"Return the mouse over borderStyle of the receiver."
	
	^self theme controlButtonMouseOverBorderStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:23'!
mouseOverFillStyle
	"Return the mouse over fillStyle of the receiver."
	
	^self theme controlButtonMouseOverFillStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:23'!
normalBorderStyle
	"Return the normal borderStyle of the receiver."
	
	^self theme controlButtonNormalBorderStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/28/2007 16:52'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme controlButtonNormalFillStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:58'!
pressedBorderStyle
	"Return the pressed borderStyle of the receiver."
	
	^self theme controlButtonPressedBorderStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:59'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	
	^self theme controlButtonPressedFillStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:25'!
selectedDisabledBorderStyle
	"Return the selected disabled borderStyle of the receiver."
	
	^self theme controlButtonSelectedDisabledBorderStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:25'!
selectedDisabledFillStyle
	"Return the selected disabled fillStyle of the receiver."
	
	^self theme controlButtonSelectedDisabledFillStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 12/9/2008 13:04'!
selectedFillStyle
	"Return the selected fillStyle of the receiver."
	
	^self theme controlButtonSelectedFillStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:24'!
selectedMouseOverBorderStyle
	"Return the selected mouse over borderStyle of the receiver."
	
	^self theme controlButtonSelectedMouseOverBorderStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:24'!
selectedMouseOverFillStyle
	"Return the selected mouse over fillStyle of the receiver."
	
	^self theme controlButtonSelectedMouseOverFillStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:24'!
selectedPressedBorderStyle
	"Return the selected pressed borderStyle of the receiver."
	
	^self theme controlButtonSelectedPressedBorderStyleFor: self! !

!ControlButtonMorph methodsFor: 'as yet unclassified' stamp: 'gvc 11/13/2007 11:25'!
selectedPressedFillStyle
	"Return the selected pressed fillStyle of the receiver."
	
	^self theme controlButtonSelectedPressedFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/23/2007 11:25'!
action
	"Answer the action selector."

	^self actionSelector! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/23/2007 11:26'!
actionSelector: aSymbol 
	"Set actionSelector to be the action defined by aSymbol.
	SimpleButtonMorph cross-compatibility"

	actionSelector := aSymbol.
! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 16:14'!
adoptColor: aColor
	"Go through paneColorChanged instead."
	
	self paneColorChanged! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/1/2010 15:13'!
adoptPaneColor: aColor

	super adoptPaneColor: aColor.
	aColor ifNil: [^self].
	self adoptColor: self colorToUse! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/23/2007 11:27'!
arguments
	"Answer the static arguments.
	SimpleButtonMorph cross-compatibility."

	^arguments! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/4/2010 12:16'!
availableBorderStyles
	"Return the selectors of the the available border styles for each state.
	Must match the order of interactionStates."
	
	^#(normalBorderStyle mouseOverBorderStyle pressedBorderStyle disabledBorderStyle
		selectedBorderStyle selectedPressedBorderStyle selectedMouseOverBorderStyle selectedDisabledBorderStyle)! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/4/2010 12:15'!
availableFillStyles
	"Return the selectors of the the available fill styles for each state.
	Must match the order of interactionStates."
	
	^#(normalFillStyle mouseOverFillStyle pressedFillStyle disabledFillStyle
		selectedFillStyle selectedPressedFillStyle selectedMouseOverFillStyle selectedDisabledFillStyle)! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/4/2010 12:17'!
borderStyleToUse
	"Return the borderStyle to use for the receiver."
	
	self gradientLook ifFalse:[^super borderStyle].
	^self perform: (self availableBorderStyles at: (
			self interactionStates indexOf: self interactionState))
! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/4/2010 12:20'!
changed
	"Update the fillStyle here."

	|lc pc bs|
	self assureExtension.
	self borderWidth > 0 ifTrue: [
		extension borderStyle: (bs := self borderStyleToUse).
		borderColor := bs style.
		borderWidth := bs width].
	extension fillStyle: self fillStyleToUse.
	self layoutInset: (self theme buttonLabelInsetFor: self).
	color := self fillStyle asColor.
	(self labelMorph respondsTo: #enabled:)
		ifTrue: [self labelMorph enabled: self enabled].
	(self labelMorph respondsTo: #interactionState:)
		ifTrue: [self labelMorph interactionState: self interactionState]
		ifFalse: [(self labelMorph isNil
			or: [label isMorph]) ifFalse: [
				pc := self normalColor.
				lc := self enabled
					ifTrue: [pc contrastingColor]
					ifFalse: [pc contrastingColor muchDarker].
				self labelMorph color: lc]].
	super changed! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/19/2009 23:58'!
color: aColor
	"Check to avoid repeats of the same color."

	aColor ifNil: [^self].
	((self valueOfProperty: #lastColor) = aColor and: [
	self getModelState = (self valueOfProperty: #lastState)])
		ifTrue: [^self].
	super color: aColor.
	self class gradientButtonLook ifTrue: [self adoptColor: aColor]! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 14:08'!
colorToUse
	"Answer the color we should use."

	|c|
	c := self getModelState
		ifTrue: [onColor
					ifNil: [self paneColor]
					ifNotNil: [onColor isTransparent
								ifTrue: [self paneColor]
								ifFalse: [onColor]]]
		ifFalse: [offColor
					ifNil: [self paneColor]
					ifNotNil: [offColor isTransparent
								ifTrue: [self paneColor]
								ifFalse: [offColor]]].
	^c! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 14:08'!
containsMousePoint
	"Answer whether the mouse is in the receiver and our window is active.
	Not ideal, but no easy way of determining if a mouse over would be sent
	to the receiver."
	
	|w|
	w := self ownerThatIsA: SystemWindow.
	(w notNil and: [w isActive not]) ifTrue: [^false].
	^self containsPoint: (self globalPointToLocal: Sensor peekMousePt)! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/19/2007 13:04'!
contentHolder
	"Answer the alignment morph for extra control."

	^self submorphs first! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/11/2009 16:42'!
cornerStyle: aSymbol
	"Adjust the layout inset."

	super cornerStyle: aSymbol.
	self layoutInset: (self theme buttonLabelInsetFor: self)! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:53'!
disabledBorderStyle
	"Return the disabled borderStyle of the receiver."
	
	^self theme buttonDisabledBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:53'!
disabledFillStyle
	"Return the disabled fillStyle of the receiver."
	
	^self theme buttonDisabledFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'StephaneDucasse 7/18/2010 13:15'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front.
	Draw the focus here since we are using inset bounds
	for the focus rectangle."

	super drawSubmorphsOn: aCanvas.
	(self enabled not and: [self label isMorph and: [(self label respondsTo: #enabled:) not]])
		ifTrue: [aCanvas fillRectangle: self submorphBounds fillStyle: (Color white alpha: 0.5)].
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/10/2009 07:19'!
extent: aPoint 
	"Set the receiver's extent to value provided.
	Update the gradient fills."

	|answer|
	aPoint = self extent ifTrue: [^super extent: aPoint].
	answer := super extent: aPoint.
	self gradientLook ifTrue: [
		self fillStyle isOrientedFill
			ifTrue: [self fillStyle: self fillStyleToUse]].
	^answer! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/1/2010 15:16'!
fillStyleToUse
	"Return the fillStyle to use for the receiver."
	
	^self perform: (self availableFillStyles at: (
			self interactionStates indexOf: self interactionState))
! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 12/4/2007 16:23'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^self theme buttonFocusBoundsFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 15:00'!
focusColor
	"Answer the keyboard focus indication color."

	^self color contrastingColor! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/9/2009 17:47'!
focusIndicatorCornerRadius
	"Answer the corner radius preferred for the focus indicator
	for the receiver for themes that support this."

	^self theme buttonFocusIndicatorCornerRadiusFor: self ! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/13/2007 15:53'!
getMenuSelector: aSymbol
	"Set the menu selector."

	getMenuSelector := aSymbol! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'StephaneDucasse 5/28/2011 13:34'!
getModelState
	"Answer the result of sending the receiver's model the getStateSelector message.
	If the selector expects arguments then supply as for the actionSelector."

	model ifNil: [^ false].
	^getStateSelector ifNil: [false]
		ifNotNil: [getStateSelector numArgs = 0
					ifTrue: [model perform: getStateSelector]
					ifFalse: [argumentsProvider ifNotNil: [
								arguments := argumentsProvider perform: argumentsSelector].
							model perform: getStateSelector withEnoughArguments: arguments]]! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 14:37'!
handlesKeyboard: evt
	"Answer true, we'll handle spacebar for pressing plus the usual
	tab navigation."
	
	^true! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/8/2006 13:40'!
handlesMouseOver: evt

	^ true! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/11/2009 17:56'!
indicateModalChild
	"Flash the button border."
	
	|fs c w d|
	fs := self fillStyle.
	c := self color alphaMixed: 0.5 with: Color black.
	w := self world.
	d := 0.
	self assureExtension.
	2 timesRepeat: [
		(Delay forDuration: d milliSeconds) wait.
		d := 200.
		extension fillStyle: c.
		color := c.
		self invalidRect: self bounds.
		w ifNotNil: [w displayWorldSafely].
		(Delay forDuration: d milliSeconds) wait.
		self fillStyle: fs.
		w ifNotNil: [w displayWorldSafely].
		self invalidRect: self bounds]
! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/4/2010 12:02'!
interactionState
	"Return the state that the receiver is in, #pressed, #normal etc.."
	
	|state mo|
	state := self getModelState.
	mo := self containsMousePoint.
	^(self enabled ifNil: [true])
		ifTrue: [showSelectionFeedback
			ifTrue: [state
				ifTrue: [#selectedPressed]
				ifFalse: [#pressed]]
			ifFalse: [mo
				ifTrue: [state
					ifTrue: [#selectedMouseOver]
					ifFalse: [#mouseOver]]
				ifFalse: [state
					ifTrue: [#selected]
					ifFalse: [#normal]]]]
		ifFalse: [state
			ifTrue: [#selectedDisabled]
			ifFalse: [#disabled]]! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/4/2010 12:14'!
interactionStates
	"Return all the states that the receiver may be in at any given moment."
	
	^#(normal mouseOver pressed disabled
		selected selectedPressed selectedMouseOver selectedDisabled)! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/10/2007 12:13'!
isDefault
	"Answer whether the button is considered to be a default one."

	^self valueOfProperty: #isDefault ifAbsent: [false] ! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/10/2007 12:17'!
isDefault: aBoolean
	"Set whether the button is to be considered default."

	aBoolean
		ifTrue: [self setProperty: #isDefault toValue: true]
		ifFalse: [self removeProperty: #isDefault].
	self changed! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 7/5/2010 14:22'!
keyStroke: event 
	"Process spacebar for action and tab keys for navigation."
	
	(self navigationKey: event) ifTrue: [^self].
	(event keyCharacter = Character space or: [event keyCharacter = Character cr])
		ifTrue: [self performAction]! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/6/2007 14:36'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."

	self focusChanged! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/7/2007 13:21'!
labelMorph
	"Answer the actual label morph."

	self hasSubmorphs ifFalse: [^nil].
	self firstSubmorph hasSubmorphs ifFalse: [^nil].
	^self firstSubmorph firstSubmorph! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/10/2009 07:20'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Update the fillstyle since it may depend on the bounds."
	
	super layoutBounds: aRectangle.
	self gradientLook ifTrue: [
		self fillStyle isOrientedFill
			ifTrue: [self fillStyle: self fillStyleToUse]]! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 12/3/2008 17:23'!
minHeight
	"Consult the theme also."

	^super minHeight max: self theme buttonMinHeight! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 12/3/2008 17:22'!
minWidth
	"Consult the theme also."

	^super minWidth max: self theme buttonMinWidth! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/24/2007 13:34'!
model
	"Answer the receiver's model."
	
	^model! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 2/1/2011 14:26'!
mouseEnter: evt
	"Update the appearance."
	
	self gradientLook
		ifTrue: [self changed]
		ifFalse: ["0.09375 is exact in floating point so no cumulative rounding error will occur"
				self color: (self color adjustBrightness: -0.09375)].
	super mouseEnter: evt! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:53'!
mouseOverBorderStyle
	"Return the mouse over borderStyle of the receiver."
	
	^self theme buttonMouseOverBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:53'!
mouseOverFillStyle
	"Return the mouse over fillStyle of the receiver."
	
	^self theme buttonMouseOverFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
newLabel
	"Answer a new label for the receiver."

	^self theme buttonLabelFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/23/2007 14:40'!
newLabel: aFont
	"Answer a new label for the receiver with the given font."

	^self newLabel
		font: aFont! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
normalBorderStyle
	"Return the normal borderStyle of the receiver."
	
	^self theme buttonNormalBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
normalColor
	"Return the normal colour for the receiver."
	
	^self theme buttonColorFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme buttonNormalFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/25/2007 18:44'!
onColor
	"Answer the on color."
	
	^onColor
! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/2/2010 17:36'!
paneColorChanged
	"Use changed to update the appearance."

	self changed! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
pressedBorderStyle
	"Return the pressed borderStyle of the receiver."
	
	^self theme buttonPressedBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	
	^self theme buttonPressedFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/11/2009 16:40'!
roundedCorners: anArray
	"Adjust the layout inset if necessary."

	super roundedCorners: anArray.
	self layoutInset: (self theme buttonLabelInsetFor: self)! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedBorderStyle
	"Return the selected borderStyle of the receiver."
	
	^self theme buttonSelectedBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedDisabledBorderStyle
	"Return the selected disabled borderStyle of the receiver."
	
	^self theme buttonSelectedDisabledBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedDisabledFillStyle
	"Return the selected disabled fillStyle of the receiver."
	
	^self theme buttonSelectedDisabledFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedFillStyle
	"Return the selected fillStyle of the receiver."
	
	^self theme buttonSelectedFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedMouseOverBorderStyle
	"Return the selected mouse over borderStyle of the receiver."
	
	^self theme buttonSelectedMouseOverBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedMouseOverFillStyle
	"Return the selected mouse over fillStyle of the receiver."
	
	^self theme buttonSelectedMouseOverFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedPressedBorderStyle
	"Return the selected pressed borderStyle of the receiver."
	
	^self theme buttonSelectedPressedBorderStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:54'!
selectedPressedFillStyle
	"Return the selected pressed fillStyle of the receiver."
	
	^self theme buttonSelectedPressedFillStyleFor: self! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/8/2009 14:26'!
showSelectionFeedback
	"Answer whether the feedback should be shown for being pressed."

	^showSelectionFeedback! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/15/2009 12:23'!
showSelectionFeedback: aBoolean
	"Set the feedback."

	showSelectionFeedback := aBoolean! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 12:30'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/11/2009 12:14'!
themeChanged
	"Set the border style to thin gray in the case of going to StandardSqueak."

	|labelColor|
	(self theme isKindOf: UIThemeStandardSqueak)
		ifTrue: [self borderStyle: BorderStyle thinGray].
	self
		layoutInset: (self theme buttonLabelInsetFor: self);
		cornerStyle: (self theme buttonCornerStyleIn: self window).
	(self labelMorph isNil or: [self label isMorph or: [self labelMorph isTextMorph]]) ifFalse: [
		labelColor := self labelMorph color.
		self label: self label font: self labelMorph font.
		self labelMorph color: labelColor].
	super themeChanged! !

!PluggableButtonMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/8/2007 13:43'!
wantsKeyboardFocusNavigation
	"Answer whether the receiver would like keyboard focus
	when navigated to by keyboard."

	^super wantsKeyboardFocusNavigation and: [
		self valueOfProperty: #wantsKeyboardFocusNavigation ifAbsent: [true]]! !

!PluggableCanvas methodsFor: '*Polymorph-Widgets' stamp: 'IgorStasenko 7/18/2011 18:21'!
fillRectangle: aRectangle basicFillStyle: aFillStyle
	"Fill the given rectangle with the given, non-composite, fill style."

	| pattern |

	(aFillStyle isKindOf: InfiniteForm) ifTrue: [
		^self infiniteFillRectangle: aRectangle fillStyle: aFillStyle
	].

	aFillStyle isSolidFill ifTrue:[ ^self fillRectangle: aRectangle color: aFillStyle asColor].

	"We have a very special case for filling with infinite forms"
	(aFillStyle isBitmapFill and:[aFillStyle origin = (0@0)]) ifTrue:[
		pattern := aFillStyle form.
		(aFillStyle direction = (pattern width @ 0) 
			and:[aFillStyle normal = (0@pattern height)]) ifTrue:[
				"Can use an InfiniteForm"
				^self fillRectangle: aRectangle color: (InfiniteForm with: pattern)].
	].
	"Use a BalloonCanvas instead"
	self balloonFillRectangle: aRectangle fillStyle: aFillStyle.
! !

Object subclass: #EntryCompletion
	instanceVariableNames: 'dataSourceBlock filterBlock chooseBlock chooser previousToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!EntryCompletion commentStamp: 'AlainPlantec 11/29/2010 10:58' prior: 0!
An EntryCompletion is a handler for the driving of the completion menu in a PluggableTextFieldMorph. The completion menu is an IdentifierChooserMorph which is typically built and popup when a character is entered in a PluggableTextFieldMorph. 

Instance Variables
	chooseBlock:		<Block>
	chooser:		<IdentifierChooserMorph>
	dataSourceBlock:		<Block>
	filterBlock:		<Block>
	previousToken:		<String>

chooseBlock
	- One argument block which is evaluated when a token is chosen, the token is passed as argument

chooser
	- The IdentifierChooserMorph which is currently opened

dataSourceBlock
	- The block that is evaluated in order to get the list of items

filterBlock
	- The block used to filter the dataSource list, it takes 2 args, the first is an item from the current dataSource list element, the second is the token fetched from the requestor (the PluggableTextFieldMorph). It returns true if the current dataSource list element is to be kept

previousToken
	- Used to be able to not open the list if the current text in the PluggableTextFieldMorph was the previous chosen one
!

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2010 22:28'!
choose: aToken
	chooseBlock 
		ifNotNil: [self closeChooser.
			previousToken := aToken.
			chooseBlock value: aToken]! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/22/2010 16:04'!
chooseBlock

	^ chooseBlock! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/22/2010 16:04'!
chooseBlock: aBlock

	chooseBlock := aBlock! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2010 20:12'!
chooser
	^ chooser! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/29/2010 08:55'!
chooserWith: aToken
	| applicants |
	applicants  := self filteredValuesWith: aToken.
	aToken isNil
		ifTrue: [applicants isEmpty 
			ifFalse: [self setChooserWith: nil labels: applicants]]
		ifFalse: [ | meaningfulApplicants | 
			meaningfulApplicants := (applicants copyWithout: nil) asSet.
			meaningfulApplicants isEmpty 
				ifFalse: [(meaningfulApplicants size = 1 and: [aToken = meaningfulApplicants anyOne])
					ifFalse: [(previousToken isNil or: [previousToken size ~= aToken size])
						ifTrue: [self setChooserWith: aToken labels: applicants]]].
			previousToken := aToken].
	^ chooser! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2010 21:30'!
closeChooser
	chooser 
		ifNotNil: [chooser close.
			chooser := nil].
! !

!EntryCompletion methodsFor: 'event-handling' stamp: 'AlainPlantec 11/27/2010 13:13'!
closeIfNotOver: aMorph
	| mw |
	(chooser notNil and: [(mw := aMorph world) notNil])
		ifTrue: [ | subs |
			subs := mw submorphs.
			(subs indexOf: chooser) > (subs indexOf: aMorph window)
				ifTrue: [self closeChooser]]
! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2010 10:20'!
dataSourceBlock
	^ dataSourceBlock ifNil: [dataSourceBlock := [:token | #()]]! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2010 09:06'!
dataSourceBlock: aBlock
	dataSourceBlock := aBlock! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2010 17:02'!
filterBlock

	^ filterBlock ifNil: [filterBlock := [:currApplicant  :currText | true]]! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2010 18:18'!
filterBlock: aBlock

	filterBlock := aBlock! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/27/2010 07:29'!
filteredValuesWith: aToken
	^ (self dataSourceBlock value: aToken) 
		select: [:v | aToken isNil or: [v isNil or: [self filterBlock value: v value: aToken]]]! !

!EntryCompletion methodsFor: 'event-handling' stamp: 'AlainPlantec 11/26/2010 15:55'!
handlesKeyboard: anEvent
	^ anEvent keyCharacter = Character arrowDown
		or: [chooser notNil and: [ anEvent keyCharacter = Character escape]]! !

!EntryCompletion methodsFor: 'event-handling' stamp: 'AlainPlantec 11/27/2010 22:50'!
keystroke: anEvent from: aMorph
	(self handlesKeyboard: anEvent) 
		ifFalse: [^ false].
	(chooser notNil and: [ anEvent keyCharacter = Character escape])
		ifTrue: [self closeChooser. 
			aMorph takeKeyboardFocus.
			^ true].
	(chooser isNil and: [ anEvent keyCharacter = Character arrowDown])
		ifTrue: [previousToken := nil.
			self openChooserWith: aMorph textMorph text string from: aMorph.
			chooser ifNotNil: [^ true]].
	^ chooser 
		ifNil: [false]
		ifNotNil: [chooser keyStroke: anEvent]
	! !

!EntryCompletion methodsFor: 'event-handling' stamp: 'AlainPlantec 11/24/2010 22:19'!
mouseDownFromTextMorph: anEvent
	self closeChooser! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/29/2010 09:34'!
openChooserWith: aToken from: aFieldMorph 
	self closeChooser.
	self chooserWith: aToken.
	chooser
		ifNotNil: [ | baseColor |
			baseColor := aFieldMorph window
				ifNil: [aFieldMorph color veryMuchLighter]
				ifNotNil: [:w | w paneColor veryMuchLighter].
			chooser baseColor: baseColor.
			chooser oneMenuOfWidth: aFieldMorph bounds width - aFieldMorph layoutInset - (aFieldMorph borderWidth * 2) - 2.
			
			chooser fillStyle: (aFieldMorph theme textEditorNormalFillStyleFor: aFieldMorph).
			chooser open.
			chooser requestor: aFieldMorph.
			chooser position: aFieldMorph bottomLeft + (aFieldMorph borderWidth @ 0).
			chooser boundsInWorld bottomLeft y  > chooser allowedArea bottom
                		ifTrue: [chooser forcesHeight: (chooser allowedArea bottom - (chooser boundsInWorld topLeft y + 2))]].
	^ chooser! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/29/2010 08:57'!
openChooserWithAllOrCloseFrom: aFieldMorph 
	chooser 
		ifNotNil: [self closeChooser]
		ifNil: [self openChooserWith: nil from: aFieldMorph].
	^ chooser! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2010 09:13'!
positionChooser
        "Position the chooser to fit on the display."

   ! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2010 08:23'!
positionChooser: aChooser
        "Position the list morph to fit on the display."

        aChooser boundsInWorld bottomLeft y + aChooser listHeight > aChooser world bottom
                ifTrue: [aChooser listMorph
                                        bounds: (aChooser boundsInWorld topLeft - (0 @ aChooser listHeight) extent: aChooser width @ aChooser listHeight)]
                ifFalse: [aChooser listMorph
                                        bounds: (aChooser boundsInWorld bottomLeft extent: aChooser width @ aChooser listHeight)] ! !

!EntryCompletion methodsFor: 'accessing' stamp: 'AlainPlantec 11/27/2010 13:34'!
setChooserWith: aToken labels: labels
	chooser 
		ifNil: [chooser := IdentifierChooserMorph 
			labels: labels
			chooseBlock: [:token | self choose: token]].
	^ chooser! !

Object subclass: #ExampleRadioButtonModel
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ExampleRadioButtonModel commentStamp: 'gvc 9/23/2008 11:58' prior: 0!
Model used for radio buttons in example of basic controls (see "UITheme exampleBasicControls").!

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:17'!
beCenter
	"Set the option to #center."

	self option: #center! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:17'!
beLeft
	"Set the option to #left."

	self option: #left! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:17'!
beRight
	"Set the option to #right."

	self option: #right! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:17'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		option: #left! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:16'!
isCenter
	"Answer whether the option if #center."

	^self option == #center! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:16'!
isLeft
	"Answer whether the option if #left."

	^self option == #left! !

!ExampleRadioButtonModel methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 13:16'!
isRight
	"Answer whether the option if #right."

	^self option == #right! !

!ExampleRadioButtonModel methodsFor: 'accessing' stamp: 'gvc 8/7/2007 13:13'!
option
	"Answer the value of option"

	^ option! !

!ExampleRadioButtonModel methodsFor: 'accessing' stamp: 'gvc 8/7/2007 13:15'!
option: aSymbol
	"Set the value of option"

	option := aSymbol.
	self
		changed: #isLeft;
		changed: #isCenter;
		changed: #isRight! !

Object subclass: #ListModel
	instanceVariableNames: 'list selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ListModel commentStamp: 'gvc 9/23/2008 11:31' prior: 0!
Resusable model for a simple single selection list.!

!ListModel methodsFor: 'accessing' stamp: 'GaryChambers 8/17/2010 16:09'!
add: anItem
	"Add an item to the list and answer it."

	|answer|
	answer := self list add: anItem.
	self changed: #list.
	^answer! !

!ListModel methodsFor: 'drag and drop' stamp: 'GaryChambers 8/8/2011 16:11'!
dragItem: index
	"Answer the element at the given index."

	^self list at: index! !

!ListModel methodsFor: 'drag and drop' stamp: 'GaryChambers 8/8/2011 16:05'!
dropItem: anObject at: index
	"Drop an item at the given index."

	self list
		remove: anObject;
		add: anObject beforeIndex: index.
	self changed: #list! !

!ListModel methodsFor: 'drag and drop' stamp: 'GaryChambers 8/8/2011 16:02'!
dropWanted: anObject
	"If specified for the list, allow only things that are in the list to
	be dropped (reordering)."

	^self list includes: anObject! !

!ListModel methodsFor: 'initialize-release' stamp: 'gvc 8/2/2007 12:14'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		list: #();
		selectionIndex: 0! !

!ListModel methodsFor: 'accessing' stamp: 'gvc 8/2/2007 12:14'!
list
	"Answer the value of list"

	^ list! !

!ListModel methodsFor: 'accessing' stamp: 'gvc 8/2/2007 12:14'!
list: anObject
	"Set the value of list"

	list := anObject.
	self changed: #list! !

!ListModel methodsFor: 'accessing' stamp: 'gvc 9/23/2008 11:32'!
selectedItem
	"Answer the currently selected item or nil if none."

	^self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self list at: self selectionIndex]! !

!ListModel methodsFor: 'accessing' stamp: 'gvc 8/2/2007 12:14'!
selectionIndex
	"Answer the value of selectionIndex"

	^ selectionIndex! !

!ListModel methodsFor: 'accessing' stamp: 'gvc 8/2/2007 12:14'!
selectionIndex: anObject
	"Set the value of selectionIndex"

	selectionIndex := anObject.
	self changed: #selectionIndex! !

Object subclass: #NullSound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!NullSound class methodsFor: 'playing' stamp: 'gvc 7/30/2009 17:55'!
play
	"Do nothing for the null sound."! !

!Object class methodsFor: '*Polymorph-Widgets' stamp: ''!
taskbarIcon
	"Answer the icon for an instance of the receiver in a task bar
	or nil for the default."

	^nil ! !

!Object class methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/31/2009 15:53'!
taskbarLabel
	"Answer the label string for the receiver in a task bar
	or nil for the default."

	^nil! !

!Object methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/10/2007 11:41'!
okToClose
	"Sent to models when a window closing.
	Allows this check to be independent of okToChange."
	
	^true! !

!Object methodsFor: '*Polymorph-Widgets' stamp: ''!
taskbarIcon
	"Answer the icon for the receiver in a task bar
	or nil for the default."

	^self class taskbarIcon! !

!Object methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/31/2009 15:52'!
taskbarLabel
	"Answer the label string for the receiver in a task bar
	or nil for the default."

	^self class taskbarLabel! !

Object subclass: #ObjectStringConverter
	instanceVariableNames: 'objectClass regex stringTransformBlock objectTransformBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ObjectStringConverter commentStamp: 'GaryChambers 3/9/2011 13:37' prior: 0!
Generic object<->string converter for use with PluggableTextFieldMorph.
Optional regex matching for validation.
Optional transform blocks for each conversion direction.!

!ObjectStringConverter class methodsFor: 'as yet unclassified' stamp: 'gvc 9/18/2006 12:11'!
forClass: aClass
	"Answer a new instance of the receiver that converts to and from
	the given class of object and a string."

	^self new objectClass: aClass! !

!ObjectStringConverter methodsFor: 'conversion' stamp: 'GaryChambers 3/9/2011 13:41'!
configureForIntegers
	"Configure the receiver to match/convert positive or negative integers only."

	self
		objectClass: Integer;
		regexString: '[-]?[0-9]+';
		stringTransformBlock: [:s |
			(s beginsWith: '-')
				ifTrue: ['-', (s select: [:c | c isDigit])]
				ifFalse: [s select: [:c | c isDigit]]]! !

!ObjectStringConverter methodsFor: 'conversion' stamp: 'GaryChambers 3/9/2011 13:42'!
configureForPositiveIntegers
	"Configure the receiver to match/convert positive integers only."

	self
		objectClass: Integer;
		regexString: '[0-9]+';
		stringTransformBlock: [:s |
			s select: [:c | c isDigit]]! !

!ObjectStringConverter methodsFor: 'initialize-release' stamp: 'GaryChambers 3/9/2011 13:33'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		objectTransformBlock: [:obj | obj];
		stringTransformBlock: [:string | string]! !

!ObjectStringConverter methodsFor: 'conversion' stamp: 'GaryChambers 3/8/2011 12:34'!
isStringValid: aString
	"Answer whether the given string is valid for conversion."

	^(self regex isNil or: [self regex matches: aString]) and: [
		[self stringAsObject: aString. true] on: Error do: [false]]! !

!ObjectStringConverter methodsFor: 'conversion' stamp: 'GaryChambers 3/8/2011 12:42'!
needsConversion
	"Answer whether conversion is required for the receiver's object class."

	^self objectClass notNil and: [(self objectClass includesBehavior: String) not]! !

!ObjectStringConverter methodsFor: 'conversion' stamp: 'GaryChambers 3/9/2011 13:39'!
objectAsString: anObject
	"Answer the given object in string form."

	^(self objectTransformBlock value: anObject) asString! !

!ObjectStringConverter methodsFor: 'accessing' stamp: 'gvc 9/18/2006 12:10'!
objectClass
	"Answer the class of object we are dealing with."

	^objectClass! !

!ObjectStringConverter methodsFor: 'accessing' stamp: 'gvc 7/30/2009 14:09'!
objectClass: aClass
	"Set the class of object we are dealing with."

	objectClass := aClass! !

!ObjectStringConverter methodsFor: 'accessing' stamp: 'GaryChambers 3/9/2011 13:31'!
objectTransformBlock

	^ objectTransformBlock! !

!ObjectStringConverter methodsFor: 'accessing' stamp: 'GaryChambers 3/9/2011 13:31'!
objectTransformBlock: anObject

	objectTransformBlock := anObject! !

!ObjectStringConverter methodsFor: 'accessing' stamp: 'GaryChambers 3/8/2011 11:41'!
regex

	^ regex! !

!ObjectStringConverter methodsFor: 'accessing' stamp: 'GaryChambers 3/8/2011 11:41'!
regex: anObject

	regex := anObject! !

!ObjectStringConverter methodsFor: 'accessing' stamp: 'GaryChambers 3/8/2011 11:49'!
regexString: aString
	"Setup the regex based on the given string."

	self regex: aString asRegex! !

!ObjectStringConverter methodsFor: 'conversion' stamp: 'GaryChambers 3/9/2011 13:32'!
stringAsObject: aString
	"Answer the given string in object form."

	|transformed|
	transformed := self stringTransformBlock value: aString.
	^self needsConversion
		ifTrue: [self objectClass readFromString: transformed]
		ifFalse: [transformed]! !

!ObjectStringConverter methodsFor: 'accessing' stamp: 'GaryChambers 3/9/2011 13:31'!
stringTransformBlock

	^ stringTransformBlock! !

!ObjectStringConverter methodsFor: 'accessing' stamp: 'GaryChambers 3/9/2011 13:31'!
stringTransformBlock: anObject

	stringTransformBlock := anObject! !

Object subclass: #SoundTheme
	instanceVariableNames: 'sounds'
	classVariableNames: 'Current UseThemeSounds'
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!SoundTheme commentStamp: 'AlainPlantec 1/7/2010 22:41' prior: 0!
Groups a set of sounds to use with a UITheme.
Note that, although instances may have their sounds changed the settings will still indicate the class of theme that is current.!

SoundTheme subclass: #NullSoundTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!NullSoundTheme class methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 17:57'!
themeName
	"Answer the friendly name of the theme."

	^'No Sounds'! !

!NullSoundTheme methodsFor: 'initialize-release' stamp: 'gvc 7/30/2009 17:56'!
defaultDefaultSound
	"Answer the default default sound!!"

	^NullSound! !

!SoundTheme class methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2007 15:20'!
allThemeClasses
	"Answer the subclasses of the receiver that are considered to be
	concrete (useable as a theme)."

	^self withAllSubclasses reject: [:c | c isAbstract]! !

!SoundTheme class methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 18:27'!
beCurrent
	"Make a new instance of the receiver be the current theme."

	self isAbstract ifTrue: [^self error: self name, ' is abstract, send #beCurrent to a subclass.'].
	self current: self newDefault! !

!SoundTheme class methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 18:25'!
current
	"Answer the current ui theme."

	^Current ifNil: [Current := NullSoundTheme newDefault. Current]! !

!SoundTheme class methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 18:26'!
current: aSoundTheme
	"Set the current sound theme."

	Current := aSoundTheme.
	SoundTheme allThemeClasses do: [:c | c changed: #isCurrent]! !

!SoundTheme class methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2007 14:48'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^false! !

!SoundTheme class methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 18:27'!
isCurrent
	"Answer whether an instance of the receiver is the current theme."

	^self current class == self! !

!SoundTheme class methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2007 10:39'!
newDefault
	"Answer a new instance of the sound theme with
	its default sounds."

	^self new! !

!SoundTheme class methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 18:04'!
themeName
	"Answer the friendly name of the theme."

	^'Beeper sounds'! !

!SoundTheme class methodsFor: 'settings' stamp: 'HenrikSperreJohansen 1/21/2011 14:19'!
useThemeSounds
	 ^ UseThemeSounds ifNil: [UseThemeSounds := true]! !

!SoundTheme class methodsFor: 'settings' stamp: 'HenrikSperreJohansen 1/21/2011 14:19'!
useThemeSounds: aBoolean
	UseThemeSounds := aBoolean! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:48'!
abortSound
	"Answer the abort sound."

	^self sounds at: #abort ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:48'!
alertSound
	"Answer the alert sound."

	^self sounds at: #alert ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:35'!
defaultAbortSound
	"Answer the default abort sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:36'!
defaultAlertSound
	"Answer the default alert sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 7/30/2009 17:49'!
defaultDefaultSound
	"Answer the default default sound!!"

	^Beeper default! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:36'!
defaultDenySound
	"Answer the default deny sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:36'!
defaultMessageSound
	"Answer the default message sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:36'!
defaultQuestionSound
	"Answer the default question sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:48'!
defaultSound
	"Answer the default sound."

	^self sounds at: #default ifAbsent: [self defaultDefaultSound]! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:36'!
defaultWindowCloseSound
	"Answer the default window close sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:36'!
defaultWindowMaximizeSound
	"Answer the default window maximize sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:36'!
defaultWindowMinimizeSound
	"Answer the default window minimize sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:50'!
defaultWindowOpenSound
	"Answer the default window open sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:36'!
defaultWindowRestoreDownSound
	"Answer the default window restore down sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:36'!
defaultWindowRestoreUpSound
	"Answer the default window restore up sound."

	^self defaultSound! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:48'!
denySound
	"Answer the deny sound."

	^self sounds at: #deny ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 14:38'!
initialize
	"Initialize the receiver."

	super initialize.
	self initializeSounds! !

!SoundTheme methodsFor: 'initialize-release' stamp: 'gvc 9/12/2007 17:37'!
initializeSounds
	"Initialize the receiver's event sounds."

	self sounds: Dictionary new.
	self sounds
		at: #default put: self defaultDefaultSound;
		at: #abort put: self defaultAbortSound;
		at: #alert put: self defaultAlertSound;
		at: #deny put: self defaultDenySound;
		at: #message put: self defaultMessageSound;
		at: #question put: self defaultQuestionSound;
		at: #windowMinimize put: self defaultWindowMinimizeSound;
		at: #windowMaximize put: self defaultWindowMaximizeSound;
		at: #windowRestoreUp put: self defaultWindowRestoreUpSound;
		at: #windowRestoreDown put: self defaultWindowRestoreDownSound;
		at: #windowClose put: self defaultWindowCloseSound! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:48'!
messageSound
	"Answer the message sound."

	^self sounds at: #message ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:48'!
questionSound
	"Answer the question sound."

	^self sounds at: #question ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'accessing' stamp: 'gvc 9/12/2007 14:34'!
sounds
	"Answer the value of sounds"

	^ sounds! !

!SoundTheme methodsFor: 'accessing' stamp: 'gvc 9/12/2007 14:34'!
sounds: anObject
	"Set the value of sounds"

	sounds := anObject! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:48'!
windowCloseSound
	"Answer the window close sound."

	^self sounds at: #windowClose ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:48'!
windowMaximizeSound
	"Answer the window maximize sound."

	^self sounds at: #windowMaximize ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:48'!
windowMinimizeSound
	"Answer the window minimize sound."

	^self sounds at: #windowMinimize ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:49'!
windowOpenSound
	"Answer the window open sound."

	^self sounds at: #windowOpen ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:49'!
windowRestoreDownSound
	"Answer the window restore down sound."

	^self sounds at: #windowRestoreDown ifAbsent: [self defaultSound]! !

!SoundTheme methodsFor: 'sounds' stamp: 'gvc 7/30/2009 17:49'!
windowRestoreUpSound
	"Answer the window restore up sound."

	^self sounds at: #windowRestoreUp ifAbsent: [self defaultSound]! !

Object subclass: #TaskbarTask
	instanceVariableNames: 'morph state label icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TaskbarTask commentStamp: 'gvc 5/18/2007 11:20' prior: 0!
Holds the state of a taskbar/tasklist entry.!

!TaskbarTask class methodsFor: 'as yet unclassified' stamp: 'gvc 4/18/2007 12:26'!
morph: aMorph state: aSymbol icon: aForm label: aString
	"Answer a new instance of the receiver with the given parameters."

	^self new
		morph: aMorph;
		state: aSymbol;
		icon: aForm;
		label: aString! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 7/24/2007 12:18'!
= aTaskbarTask
	"Answer whether equal."

	^self species = aTaskbarTask species
		and: [self morph == aTaskbarTask morph
		and: [self state == aTaskbarTask state
		and: [self icon = aTaskbarTask icon
		and: [self label = aTaskbarTask label]]]]! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/23/2007 14:51'!
activate
	"Activate the task."
	
	(self morph respondsTo: #restoreAndActivate)
		ifTrue: [self morph restoreAndActivate]! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 11:06'!
buttonClickedForTasklist: aTasklist
	"Notify the tasklist."
	
	aTasklist taskClicked: self! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 12/12/2007 12:01'!
hash
	"Hash is implemented because #= is implemented."
	
	^self morph hash
		bitXor: (self state hash
		bitXor: (self icon hash
		bitXor: self label hash))! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
icon
	"Answer the value of icon"

	^ icon! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
icon: anObject
	"Set the value of icon"

	icon := anObject! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:49'!
isActive
	"Answer whether the task is active."

	^self state == #active! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:25'!
isMinimized
	"Answer whether the task is minimized."

	^self state == #minimized! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
label
	"Answer the value of label"

	^ label! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
label: anObject
	"Set the value of label"

	label := anObject! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:24'!
morph
	"Answer the value of morph"

	^ morph! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:24'!
morph: anObject
	"Set the value of morph"

	morph := anObject! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
state
	"Answer the value of state"

	^ state! !

!TaskbarTask methodsFor: 'accessing' stamp: 'gvc 4/18/2007 12:20'!
state: anObject
	"Set the value of state"

	state := anObject! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'gvc 4/20/2007 10:21'!
taskbarButtonFor: aTaskBar
	"Answer a button for the task."
	
	^self morph taskbarButtonFor: aTaskBar! !

!TaskbarTask methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/12/2011 10:34'!
tasklistButtonFor: aTasklist
	"Answer a button for the task."
	
	^self theme
		newTasklistButtonIn: aTasklist
		for: self! !

!TaskbarTask methodsFor: 'accessing' stamp: 'FernandoOlivero 4/12/2011 10:35'!
theme
	^ UITheme current ! !

Object subclass: #TextHighlight
	instanceVariableNames: 'color lineRange bounds borderWidth borderColor borderSides fillWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TextHighlight commentStamp: 'gvc 5/18/2007 11:15' prior: 0!
Definition of a clickable highlighted range of text with optional borders.!

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
borderColor
	"Answer the value of borderColor"

	^ borderColor! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
borderColor: anObject
	"Set the value of borderColor"

	borderColor := anObject! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:57'!
borderSides
	"Answer the value of borderSides"

	^ borderSides! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:57'!
borderSides: anObject
	"Set the value of borderSides"

	borderSides := anObject! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
borderWidth
	"Answer the value of borderWidth"

	^ borderWidth! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
borderWidth: anObject
	"Set the value of borderWidth"

	borderWidth := anObject! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:18'!
bounds
	"Answer the value of bounds"

	^ bounds! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:18'!
bounds: anObject
	"Set the value of bounds"

	bounds := anObject! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 16:19'!
clicked: evt
	"The receiver has had a mouse down."

	self triggerEvent: #clicked! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
color
	"Answer the value of color"

	^ color! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/23/2006 10:41'!
color: anObject
	"Set the value of color"

	color := anObject! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/30/2006 16:00'!
containsPoint: aPoint in: rect
	"Answer whther the bounds contain the given (local coordinate) point."

	|r|
	r := self bounds.
	r := self fillWidth
		ifTrue: [rect left @ r top corner: (rect right @ r bottom)]
		ifFalse: [r]. 
	^r containsPoint: aPoint! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/31/2006 16:29'!
drawOn: aCanvas in: rect offset: o
	"Draw the highlight on the given canvas for the given rectangle."

	|r|
	r := self fillWidth
		ifTrue: [rect left @ (self bounds top + rect top) corner: rect right @ (self bounds bottom + rect top)]
		ifFalse: [self bounds translateBy: rect topLeft].
	r := r translateBy: (self fillWidth ifTrue: [0@o y negated] ifFalse: [o negated]).
	self color isTransparent not ifTrue: [
		aCanvas
			fillRectangle: r
			color: self color].
	(self borderWidth > 0 and: [self borderColor isTransparent not]) ifTrue: [
		(self borderSides includes: #top) ifTrue: [
			aCanvas
				fillRectangle: ( r withHeight: self borderWidth)
				color: self borderColor].
		(self borderSides includes: #right) ifTrue: [
			aCanvas
				fillRectangle: (r withLeft: r right - self borderWidth)
				color: self borderColor].
		(self borderSides includes: #bottom) ifTrue: [
			aCanvas
				fillRectangle: ( r withTop: r bottom - self borderWidth)
				color: self borderColor].
		(self borderSides includes: #left) ifTrue: [
			aCanvas
				fillRectangle: ( r withWidth: self borderWidth)
				color: self borderColor]]! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:38'!
fillWidth
	"Answer the value of fillWidth"

	^ fillWidth! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:38'!
fillWidth: anObject
	"Set the value of fillWidth"

	fillWidth := anObject! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/31/2006 11:16'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		color: Color yellow;
		lineRange: (1 to: 0);
		borderWidth: 0;
		borderColor: Color transparent;
		borderSides: #(top right bottom left);
		fillWidth: false! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:03'!
lineNumber
	"Answer the first in the line range."

	^self lineRange first! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:02'!
lineRange
	"Answer the value of lineRange"

	^ lineRange! !

!TextHighlight methodsFor: 'accessing' stamp: 'gvc 10/25/2006 13:02'!
lineRange: anObject
	"Set the value of lineRange"

	lineRange := anObject! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 13:20'!
position
	"Answer the bounds top left."
	
	^self bounds topLeft! !

!TextHighlight methodsFor: 'as yet unclassified' stamp: 'gvc 10/25/2006 13:19'!
position: aPoint
	"Set the bounds top left."
	
	self bounds: (aPoint extent: self bounds extent)! !

Object subclass: #ThemeIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

ThemeIcons class
	instanceVariableNames: 'icons'!

!ThemeIcons commentStamp: 'gvc 5/18/2007 10:25' prior: 0!
Some extra icons in the vein of MenuIcons.!

ThemeIcons class
	instanceVariableNames: 'icons'!

ThemeIcons subclass: #PharoUIThemeIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

PharoUIThemeIcons subclass: #BlueUIThemeIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:22'!
checkboxMarkerForm
	"Answer a new radio button marker form. We make it empty because we already have the selected radio button take care of the state."

	^Form extent: 12@12 depth: 32! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 14:10'!
checkboxSelectedForm
	^ self form16x16FromContents: self checkboxSelectedFormContents 
! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 14:10'!
checkboxSelectedFormContents
	^#( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 0 0 0 0 0 0 4278190080 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190080 0 0 0 0 0 0 4278190080 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190080 0 0 0 0 0 0 4278190080 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190080 0 0 0 0 0 0 4278190080 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190080 0 0 0 0 0 0 4278190080 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190080 0 0 0 0 0 0 4278190080 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190080 0 0 0 0 0 0 4278190080 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190080 0 0 0 0 0 0 4278190080 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190080 0 0 0 0 0 0 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:40'!
checkboxUnselectedForm
	^ self form16x16FromContents: self checkboxUnselectedFormContents 
! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:26'!
checkboxUnselectedFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:39'!
form16x16FromContents: aByteArray 
	^ Form
	extent: 16@16
	depth: 32
	fromArray: aByteArray 
	offset: 0@0! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:40'!
menuPinForm
	^self form16x16FromContents: self menuPinFormContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:26'!
menuPinFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 100663296 83886080 0 0 0 0 0 0 0 0 0 0 0 0 1291845632 3774873600 4194304000 3774873600 788529152 0 0 0 0 0 0 0 0 0 0 1107296256 4278190080 4278190080 4278190080 4278190080 4278190080 788529152 0 0 0 0 0 0 0 0 83886080 3992977408 4278190080 4278190080 4278190080 4278190080 4278190080 3774873600 83886080 0 0 0 0 0 0 0 100663296 4194304000 4278190080 4278190080 4278190080 4278190080 4278190080 4194304000 100663296 0 0 0 0 0 0 0 83886080 3774873600 4278190080 4278190080 4278190080 4278190080 4278190080 3992977408 83886080 0 0 0 0 0 0 0 0 1291845632 4261412864 4278190080 4278190080 4278190080 4261412864 1107296256 0 0 0 0 0 0 0 0 0 0 1107296256 3992977408 4194304000 3774873600 1291845632 0 0 0 0 0 0 0 0 0 0 0 0 83886080 100663296 83886080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 09:11'!
radioButtonMarkerForm
	"Answer a new radio button marker form. We make it empty because we already have the selected radio button take care of the state."

	^Form extent: 12@12 depth: 32! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:40'!
radioButtonSelectedForm
	^ self form16x16FromContents: self radioButtonSelectedFormContents! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:27'!
radioButtonSelectedFormContents
	^#( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 0 0 50331648 0 0 0 0 0 0 0 0 0 0 0 1023410176 3422946822 4043572228 4043572228 3422946822 1023410176 0 0 0 0 0 0 0 0 0 2214987270 4161078533 4284045657 4285690482 4285690482 4284045657 4161078533 1058280468 0 0 0 0 0 0 0 1023410176 4278190080 4285887861 4286611584 4286611584 4286611584 4286611584 4285887861 4278190080 1023410176 0 0 0 0 0 50331648 3422946822 4284045657 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4284045657 3422946822 50331648 0 0 0 0 0 4043572228 4285690482 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4285690482 4043572228 0 0 0 0 0 0 4043572228 4285690482 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4285690482 4043572228 0 0 0 0 0 33554432 3422946822 4284045657 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4284045657 3422946822 50331648 0 0 0 0 0 1006632960 4161078533 4285887861 4286611584 4286611584 4286611584 4286611584 4285887861 4278190080 1023410176 0 0 0 0 0 0 0 2214987270 4278190080 4284045657 4285690482 4285690482 4284045657 4161078533 2214987270 0 0 0 0 0 0 0 0 0 1006632960 3422946822 4043572228 4043572228 3422946822 1023410176 0 0 0 0 0 0 0 0 0 0 0 33554432 0 0 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:40'!
radioButtonUnselectedForm
	^ self form16x16FromContents: self radioButtonUnselectedFormContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:27'!
radioButtonUnselectedFormContents
	^#( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 0 0 50331648 0 0 0 0 0 0 0 0 0 0 0 1023410176 3238002688 3909091328 3909091328 3238002688 1023410176 0 0 0 0 0 0 0 0 0 2097152000 3976200192 1275068416 452984832 452984832 1275068416 3976200192 872415232 0 0 0 0 0 0 0 1023410176 4278190080 335544320 0 0 0 0 335544320 4278190080 1023410176 0 0 0 0 0 50331648 3238002688 1275068416 0 0 0 0 0 0 1275068416 3238002688 50331648 0 0 0 0 0 3909091328 452984832 0 0 0 0 0 0 452984832 3909091328 0 0 0 0 0 0 3909091328 452984832 0 0 0 0 0 0 452984832 3909091328 0 0 0 0 0 33554432 3238002688 1275068416 0 0 0 0 0 0 1275068416 3238002688 50331648 0 0 0 0 0 1006632960 3992977408 335544320 0 0 0 0 335544320 4278190080 1023410176 0 0 0 0 0 0 0 2097152000 4278190080 1275068416 452984832 452984832 1275068416 3976200192 2097152000 0 0 0 0 0 0 0 0 0 1006632960 3238002688 3909091328 3909091328 3238002688 1023410176 0 0 0 0 0 0 0 0 0 0 0 33554432 0 0 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/27/2010 15:14'!
radioSelectedForm
	^ Form fromBinaryStream: ( Base64MimeConverter mimeDecodeToBytes: self radioSelectedFormContents readStream)
 ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/27/2010 15:13'!
radioSelectedFormContents
	^#( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 0 0 50331648 0 0 0 0 0 0 0 0 0 0 0 1023410176 3422946822 4043572228 4043572228 3422946822 1023410176 0 0 0 0 0 0 0 0 0 2214987270 4161078533 4284045657 4285690482 4285690482 4284045657 4161078533 1058280468 0 0 0 0 0 0 0 1023410176 4278190080 4285887861 4286611584 4286611584 4286611584 4286611584 4285887861 4278190080 1023410176 0 0 0 0 0 50331648 3422946822 4284045657 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4284045657 3422946822 50331648 0 0 0 0 0 4043572228 4285690482 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4285690482 4043572228 0 0 0 0 0 0 4043572228 4285690482 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4285690482 4043572228 0 0 0 0 0 33554432 3422946822 4284045657 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4284045657 3422946822 50331648 0 0 0 0 0 1006632960 4161078533 4285887861 4286611584 4286611584 4286611584 4286611584 4285887861 4278190080 1023410176 0 0 0 0 0 0 0 2214987270 4278190080 4284045657 4285690482 4285690482 4284045657 4161078533 2214987270 0 0 0 0 0 0 0 0 0 1006632960 3422946822 4043572228 4043572228 3422946822 1023410176 0 0 0 0 0 0 0 0 0 0 0 33554432 0 0 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/27/2010 15:14'!
radioUnselectedForm
	^ Form fromBinaryStream: ( Base64MimeConverter mimeDecodeToBytes: self radioUnselectedFormContents readStream)
 ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/27/2010 15:13'!
radioUnselectedFormContents
	^#( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 0 0 50331648 0 0 0 0 0 0 0 0 0 0 0 1023410176 3238002688 3909091328 3909091328 3238002688 1023410176 0 0 0 0 0 0 0 0 0 2097152000 3976200192 1275068416 452984832 452984832 1275068416 3976200192 872415232 0 0 0 0 0 0 0 1023410176 4278190080 335544320 0 0 0 0 335544320 4278190080 1023410176 0 0 0 0 0 50331648 3238002688 1275068416 0 0 0 0 0 0 1275068416 3238002688 50331648 0 0 0 0 0 3909091328 452984832 0 0 0 0 0 0 452984832 3909091328 0 0 0 0 0 0 3909091328 452984832 0 0 0 0 0 0 452984832 3909091328 0 0 0 0 0 33554432 3238002688 1275068416 0 0 0 0 0 0 1275068416 3238002688 50331648 0 0 0 0 0 1006632960 3992977408 335544320 0 0 0 0 335544320 4278190080 1023410176 0 0 0 0 0 0 0 2097152000 4278190080 1275068416 452984832 452984832 1275068416 3976200192 2097152000 0 0 0 0 0 0 0 0 0 1006632960 3238002688 3909091328 3909091328 3238002688 1023410176 0 0 0 0 0 0 0 0 0 0 0 33554432 0 0 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:41'!
windowCloseForm
	^ self form16x16FromContents: self windowCloseFormContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/27/2010 15:24'!
windowCloseFormContents
	^#( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 0 0 0 0 0 0 0 0 167772160 3875536896 4076863488 234881024 0 234881024 2919235584 3858759680 0 0 0 0 0 0 0 0 402653184 3674210304 4261412864 3758096384 671088640 3758096384 4261412864 4278190080 335544320 0 0 0 0 0 0 0 0 352321536 3758096384 4143972352 4211081216 4143972352 3758096384 352321536 0 0 0 0 0 0 0 0 0 0 671088640 4211081216 4261412864 4211081216 671088640 0 0 0 0 0 0 0 0 0 0 352321536 3758096384 4143972352 4211081216 4143972352 3758096384 352321536 0 0 0 0 0 0 0 0 335544320 4278190080 4244635648 3758096384 671088640 3758096384 4143972352 3724541952 402653184 0 0 0 0 0 0 0 0 3892314112 2919235584 234881024 0 234881024 4278190080 1761607680 167772160 0 0 0 0 0 0 0 0 167772160 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:41'!
windowCloseInactiveForm
	^ self form16x16FromContents: self windowCloseInactiveFromContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/27/2010 15:23'!
windowCloseInactiveFromContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 176193664 0 0 0 0 0 0 0 0 176193664 3883958400 4085284992 243302528 0 243302528 2927657088 3867181184 0 0 0 0 0 0 0 0 411074688 3682631808 4269834368 3766517888 679049593 3766517888 4269834368 4286611584 343965824 0 0 0 0 0 0 0 0 360282489 3766517888 4152328063 4219436927 4152393856 3766517888 360282489 0 0 0 0 0 0 0 0 0 0 679049593 4219436927 4269834368 4219436927 679049593 0 0 0 0 0 0 0 0 0 0 360282489 3766517888 4152393856 4219436927 4152328063 3766517888 360282489 0 0 0 0 0 0 0 0 343965824 4286611584 4253057152 3766517888 679049593 3766517888 4152328063 3732963456 411074688 0 0 0 0 0 0 0 0 3900735616 2927657088 243302528 0 243302528 4286611584 1769897598 176193664 0 0 0 0 0 0 0 0 176193664 75530368 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:41'!
windowMaximizeForm
	^ self form16x16FromContents: self windowMaximizeFormContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:07'!
windowMaximizeFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:41'!
windowMaximizeInactiveForm
	^ self form16x16FromContents: self windowMaximizeInactiveFormContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/27/2010 15:23'!
windowMaximizeInactiveFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 0 0 0 0 0 0 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:52'!
windowMenuForm
	^self form16x16FromContents: self windowMenuFormContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:52'!
windowMenuFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 3556769792 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3556769792 352321536 0 0 0 0 0 0 0 352321536 3556769792 4278190080 4278190080 4278190080 4278190080 3556769792 352321536 0 0 0 0 0 0 0 0 0 352321536 3556769792 4278190080 4278190080 3556769792 352321536 0 0 0 0 0 0 0 0 0 0 0 369098752 3556769792 3556769792 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 369098752 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:41'!
windowMenuInactiveForm
	^self form16x16FromContents: self windowMenuInactiveFormContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:15'!
windowMenuInactiveFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 360282489 3565191296 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 3565191296 360282489 0 0 0 0 0 0 0 360282489 3565191296 4286611584 4286611584 4286611584 4286611584 3565191296 360282489 0 0 0 0 0 0 0 0 0 360282489 3565191296 4286611584 4286611584 3565191296 360282489 0 0 0 0 0 0 0 0 0 0 0 377520256 3565191296 3565191296 360282489 0 0 0 0 0 0 0 0 0 0 0 0 0 377520256 360282489 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:41'!
windowMinimizeForm
	^self form16x16FromContents: self windowMinimizeFormContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:09'!
windowMinimizeFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/28/2010 13:42'!
windowMinimizeInactiveForm
	^self form16x16FromContents: self windowMinimizeInactiveFormContents ! !

!PharoUIThemeIcons class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/27/2010 15:23'!
windowMinimizeInactiveFormContents
	^ #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 0 0 0 0 0 0 0 0 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
backIcon
	"Private - Generated method"
	^ icons
			at: #'back'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self backIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:42'!
backspaceArrowIcon
	"Private - Generated method"
	^icons
			at: #backspaceArrowIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self backspaceArrowIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - utilities' stamp: 'gvc 7/25/2006 16:33'!
base64ContentsOfFileNamed: aString 
	"Private - convenient method"
	
	| file base64Contents |
	file := FileStream readOnlyFileNamed: aString.
	base64Contents := (Base64MimeConverter mimeEncode: file binary) contents.
	file close.
	^ base64Contents! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'KR 5/4/2006 21:37'!
blankIcon
	^self blankIconOfWidth: 16.
! !

!ThemeIcons class methodsFor: 'private - utilities' stamp: 'AlainPlantec 10/19/2010 20:44'!
blankIconOfWidth: aNumber 
	^ icons
		at: ('blankIcon-' , aNumber asString) asSymbol
		ifAbsentPut: [Form extent: aNumber @ 1 depth:8]! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
checkBoxOffIcon
	"Private - Generated method"
	^ icons
			at: #'checkBoxOff'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self checkBoxOffIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
checkBoxOnIcon
	"Private - Generated method"
	^ icons
			at: #'checkBoxOn'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self checkBoxOnIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
checkBoxPressedIcon
	"Private - Generated method"
	^ icons
			at: #'checkBoxPressed'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self checkBoxPressedIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - utilities' stamp: 'gvc 9/25/2008 15:41'!
clearIcons
	"Clear the forms. Will be recreated on demand."
	
	icons := IdentityDictionary new! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
configurationIcon
	"Private - Generated method"
	^ icons
			at: #'configuration'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self configurationIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 10/12/2004 13:33'!
confirmIcon
	"Private - Generated method"
	^ icons
			at: #'confirm'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self confirmIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - utilities' stamp: 'AlainPlantec 10/24/2010 21:11'!
createIconMethodsFromDirectory: directory 
	"Create the methods for the icons.
	(self createIconMethodsFromDirectory: '')."
	| normalSize smallSize |
	normalSize := self normalSizeNames.
	smallSize := self smallSizeNames.
	normalSize , smallSize
		do: [:each | self createIconMethodsFromFile: each directory: directory]..
	self initializeIcons! !

!ThemeIcons class methodsFor: 'private - utilities' stamp: 'AlainPlantec 10/24/2010 21:25'!
createIconMethodsFromFile: aFileNamePrefix directory: directory 
	"Create the methods for the icon.
	aFileNamePrefix is the png file name prefix (without the .png suffix)
	directory is where the png file is"
	| iconContentsSourceTemplate iconSourceTemplate png base64 contentsSelector selector |
	iconContentsSourceTemplate := '{1}IconContents
	"Private - Method generated with the content of the file {2}"
	^ ''{3}'''.
	iconSourceTemplate := '{1}
	"Private - Generated method"
	^icons 
			at: #{1}
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self {1}Contents readStream) ].'.
	png := directory , FileDirectory slash, aFileNamePrefix , '.png'.
	[base64 := self base64ContentsOfFileNamed: png]
		on: Error
		do: [base64 := nil].
	base64
		ifNotNil: [contentsSelector := (aFileNamePrefix , 'IconContents') asSymbol.
			((self respondsTo: contentsSelector)
					and: [(self perform: contentsSelector)
							= base64])
				ifFalse: [| contentsSource |
					contentsSource := iconContentsSourceTemplate format: {aFileNamePrefix. png. base64}.
					self class compile: contentsSource classified: '*Graphics-Resources-Theme-Icons'].
			selector := (aFileNamePrefix , 'Icon') asSymbol.
			(self respondsTo: selector)
				ifFalse: [| source |
					source := iconSourceTemplate format: {selector}.
					self class compile: source classified: 'private - icons']]! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:49'!
crudeRedoDisabledIcon
	"Private - Generated method"
	^ icons
			at: #'crudeRedoDisabled'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self crudeRedoDisabledIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
crudeRedoIcon
	"Private - Generated method"
	^ icons
			at: #'crudeRedo'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self crudeRedoIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:49'!
crudeUndoDisabledIcon
	"Private - Generated method"
	^ icons
			at: #'crudeUndoDisabled'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self crudeUndoDisabledIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
crudeUndoIcon
	"Private - Generated method"
	^ icons
			at: #'crudeUndo'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self crudeUndoIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:43'!
downArrowIcon
	"Private - Generated method"
	^icons
			at: #downArrowIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self downArrowIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:44'!
errorIcon
	"Private - Generated method"
	^icons
			at: #errorIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self errorIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
expandBoxIcon
	"Private - Generated method"
	^ icons
			at: #'expandBox'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self expandBoxIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - utilities' stamp: 'AlainPlantec 10/19/2010 21:00'!
exportAllIconsAsGif
	"self exportAllIconsAsGif"

	| sels | 
	sels := self class selectors select: [:each |  '*Icon' match: each asString].
	sels do: [:each | self exportIcon: (self perform: each) asGifNamed: each asString].
! !

!ThemeIcons class methodsFor: 'private - utilities' stamp: 'AlainPlantec 10/19/2010 20:59'!
exportAllIconsAsPNG
	"self exportAllIconsAsPNG"

	| sels | 
	sels := self class selectors select: [:each |  '*Icon' match: each asString].
	sels do: [:each | self exportIcon: (self perform: each) asPNGNamed: each asString].
! !

!ThemeIcons class methodsFor: 'private - utilities' stamp: 'AlainPlantec 10/19/2010 20:57'!
exportIcon: image asGifNamed: aString
	"self exportIcon: self newIcon asGifNamed: 'newIcon'"

	| writer |
	writer := GIFReadWriter on: (FileStream newFileNamed: aString, '.gif').
	[ writer nextPutImage: image]	
		ensure: [writer close]! !

!ThemeIcons class methodsFor: 'private - utilities' stamp: 'AlainPlantec 10/19/2010 20:59'!
exportIcon: image asPNGNamed: aString
	"self exportIcon: self newIcon asPNGNamed: 'newIcon'"

	| writer |
	writer := PNGReadWriter on: (FileStream newFileNamed: aString, '.png').
	[ writer nextPutImage: image]	
		ensure: [writer close]! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
eyedropperIcon
	"Private - Generated method"
	^ icons
			at: #'eyedropper'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self eyedropperIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
forwardIcon
	"Private - Generated method"
	^ icons
			at: #'forward'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self forwardIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
fullScreenIcon
	"Private - Generated method"
	^ icons
			at: #'fullScreen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self fullScreenIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
getsIcon
	"Private - Generated method"
	^ icons
			at: #'gets'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self getsIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloCollapseIcon
	"Private - Generated method"
	^ icons
			at: #'haloCollapse'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloCollapseIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloDebugIcon
	"Private - Generated method"
	^ icons
			at: #'haloDebug'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloDebugIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloDismissIcon
	"Private - Generated method"
	^ icons
			at: #'haloDismiss'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloDismissIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloDragIcon
	"Private - Generated method"
	^ icons
			at: #'haloDrag'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloDragIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloDupIcon
	"Private - Generated method"
	^ icons
			at: #'haloDup'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloDupIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloFontEmphIcon
	"Private - Generated method"
	^ icons
			at: #'haloFontEmph'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloFontEmphIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloFontSizeIcon
	"Private - Generated method"
	^ icons
			at: #'haloFontSize'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloFontSizeIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloFontStyleIcon
	"Private - Generated method"
	^ icons
			at: #'haloFontStyle'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloFontStyleIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloGrabIcon
	"Private - Generated method"
	^ icons
			at: #'haloGrab'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloGrabIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloHelpIcon
	"Private - Generated method"
	^ icons
			at: #'haloHelp'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloHelpIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloMenuIcon
	"Private - Generated method"
	^ icons
			at: #'haloMenu'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloMenuIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloPaintIcon
	"Private - Generated method"
	^ icons
			at: #'haloPaint'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloPaintIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloPoohIcon
	"Private - Generated method"
	^ icons
			at: #'haloPooh'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloPoohIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloRecolorIcon
	"Private - Generated method"
	^ icons
			at: #'haloRecolor'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloRecolorIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloRotIcon
	"Private - Generated method"
	^ icons
			at: #'haloRot'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloRotIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloScaleIcon
	"Private - Generated method"
	^ icons
			at: #'haloScale'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloScaleIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
haloViewIcon
	"Private - Generated method"
	^ icons
			at: #'haloView'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self haloViewIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
helpIcon
	"Private - Generated method"
	^ icons
			at: #'help'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self helpIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
homeIcon
	"Private - Generated method"
	^ icons
			at: #'home'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self homeIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - accessing' stamp: 'AlainPlantec 10/20/2010 00:39'!
iconNamed: aSymbol
	^ self iconNamed: aSymbol ifNone: [self blankIcon]! !

!ThemeIcons class methodsFor: 'private - accessing' stamp: 'AlainPlantec 10/19/2009 17:58'!
iconNamed: aSymbol ifNone: aBlock
	^ (self respondsTo: aSymbol) ifFalse: [aBlock value] ifTrue: [self perform: aSymbol]! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
imageIcon
	"Private - Generated method"
	^ icons
			at: #'image'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self imageIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:45'!
infoIcon
	"Private - Generated method"
	^icons
			at: #infoIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self infoIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'class initialization' stamp: 'gvc 12/21/2006 16:02'!
initialize
	"Initialize the class."
	
	self initializeIcons! !

!ThemeIcons class methodsFor: 'class initialization' stamp: 'gvc 9/25/2008 15:41'!
initializeIcons
	"self initializeIcons"
	
	| methods |
	icons := IdentityDictionary new.
	methods := self class selectors
				select: [:each | '*Icon' match: each asString].
	methods
		do: [:each | icons
				at: each
				put: (self perform: each)]! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
jumpIcon
	"Private - Generated method"
	^ icons
			at: #'jump'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self jumpIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:45'!
lockIcon
	"Private - Generated method"
	^icons
			at: #lockIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self lockIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - accessing' stamp: 'gvc 7/23/2008 13:01'!
normalSizeNames
	"Answer the names of the normal icons"
	
	^#('error' 'info' 'lock' 'question' 'warning' 'upArrow' 'downArrow' 'backspaceArrow')! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
objectsIcon
	"Private - Generated method"
	^ icons
			at: #'objects'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self objectsIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/22/2004 19:35'!
openIcon
	"Private - Generated method"
	^ icons
			at: #'open'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self openIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
paintIcon
	"Private - Generated method"
	^ icons
			at: #'paint'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self paintIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
paintTabIcon
	"Private - Generated method"
	^ icons
			at: #'paintTab'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self paintTabIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
paintingIcon
	"Private - Generated method"
	^ icons
			at: #'painting'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self paintingIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'tbn 8/23/2010 18:16'!
pharoIcon
	"Private - Generated method"
	^icons
			at: #pharoIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self pharoIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
projectIcon
	"Private - Generated method"
	^ icons
			at: #'project'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self projectIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
publishIcon
	"Private - Generated method"
	^ icons
			at: #'publish'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self publishIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:45'!
questionIcon
	"Private - Generated method"
	^icons
			at: #questionIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self questionIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
radioButtonOffIcon
	"Private - Generated method"
	^ icons
			at: #'radioButtonOff'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self radioButtonOffIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
radioButtonOnIcon
	"Private - Generated method"
	^ icons
			at: #'radioButtonOn'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self radioButtonOnIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
radioButtonPressedIcon
	"Private - Generated method"
	^ icons
			at: #'radioButtonPressed'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self radioButtonPressedIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
rotateIcon
	"Private - Generated method"
	^ icons
			at: #'rotate'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self rotateIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
scaleIcon
	"Private - Generated method"
	^ icons
			at: #'scale'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self scaleIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 4/10/2006 13:56'!
smallAuthoringToolsIcon
	"Private - Generated method"
	^ icons
			at: #'smallAuthoringTools'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallAuthoringToolsIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallBackIcon
	"Private - Generated method"
	^ icons
			at: #'smallBack'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallBackIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:45'!
smallBarcodeIcon
	"Private - Generated method"
	^icons
			at: #smallBarcodeIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallBarcodeIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:45'!
smallBoldIcon
	"Private - Generated method"
	^icons
			at: #smallBoldIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallBoldIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallCancelIcon
	"Private - Generated method"
	^ icons
			at: #'smallCancel'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallCancelIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 10/12/2004 14:05'!
smallCenteredIcon
	"Private - Generated method"
	^ icons
			at: #'smallCentered'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallCenteredIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallConfigurationIcon
	"Private - Generated method"
	^ icons
			at: #'smallConfiguration'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallConfigurationIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallCopyIcon
	"Private - Generated method"
	^ icons
			at: #'smallCopy'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallCopyIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallCutIcon
	"Private - Generated method"
	^ icons
			at: #'smallCut'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallCutIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 4/10/2006 13:45'!
smallDebugIcon
	"Private - Generated method"
	^ icons
			at: #'smallDebug'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallDebugIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallDeleteIcon
	"Private - Generated method"
	^ icons
			at: #'smallDelete'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallDeleteIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallDoItIcon
	"Private - Generated method"
	^ icons
			at: #'smallDoIt'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallDoItIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:44'!
smallErrorIcon
	"Private - Generated method"
	^icons
			at: #smallErrorIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallErrorIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallExpertIcon
	"Private - Generated method"
	^ icons
			at: #'smallExpert'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallExpertIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 4/20/2006 12:32'!
smallExportIcon
	"Private - Generated method"
	^ icons
			at: #'smallExport'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallExportIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallFindIcon
	"Private - Generated method"
	^ icons
			at: #'smallFind'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallFindIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 10/12/2004 20:58'!
smallFontsIcon
	"Private - Generated method"
	^ icons
			at: #'smallFonts'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallFontsIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallForwardIcon
	"Private - Generated method"
	^ icons
			at: #'smallForward'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallForwardIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallFullScreenIcon
	"Private - Generated method"
	^ icons
			at: #'smallFullScreen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallFullScreenIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallHelpIcon
	"Private - Generated method"
	^ icons
			at: #'smallHelp'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallHelpIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:46'!
smallHierarchyBrowserIcon
	"Private - Generated method"
	^icons
			at: #smallHierarchyBrowserIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallHierarchyBrowserIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 10/7/2004 13:43'!
smallHomeIcon
	"Private - Generated method"
	^ icons
			at: #'smallHome'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallHomeIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:46'!
smallInfoIcon
	"Private - Generated method"
	^icons
			at: #smallInfoIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallInfoIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallInspectItIcon
	"Private - Generated method"
	^ icons
			at: #'smallInspectIt'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallInspectItIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:46'!
smallItalicIcon
	"Private - Generated method"
	^icons
			at: #smallItalicIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallItalicIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallJumpIcon
	"Private - Generated method"
	^ icons
			at: #'smallJump'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallJumpIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 10/12/2004 14:05'!
smallJustifiedIcon
	"Private - Generated method"
	^ icons
			at: #'smallJustified'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallJustifiedIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallLanguageIcon
	"Private - Generated method"
	^ icons
			at: #'smallLanguage'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallLanguageIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 10/12/2004 14:05'!
smallLeftFlushIcon
	"Private - Generated method"
	^ icons
			at: #'smallLeftFlush'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallLeftFlushIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/22/2004 19:35'!
smallLoadProjectIcon
	"Private - Generated method"
	^ icons
			at: #'smallLoadProject'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallLoadProjectIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:46'!
smallLockIcon
	"Private - Generated method"
	^icons
			at: #smallLockIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallLockIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallNewIcon
	"Private - Generated method"
	^ icons
			at: #'smallNew'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallNewIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallObjectCatalogIcon
	"Private - Generated method"
	^ icons
			at: #'smallObjectCatalog'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallObjectCatalogIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallObjectsIcon
	"Private - Generated method"
	^ icons
			at: #'smallObjects'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallObjectsIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallOkIcon
	"Private - Generated method"
	^ icons
			at: #'smallOk'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallOkIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallOpenIcon
	"Private - Generated method"
	^ icons
			at: #'smallOpen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallOpenIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPaintIcon
	"Private - Generated method"
	^ icons
			at: #'smallPaint'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallPaintIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPasteIcon
	"Private - Generated method"
	^ icons
			at: #'smallPaste'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallPasteIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPrintIcon
	"Private - Generated method"
	^ icons
			at: #'smallPrint'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallPrintIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallProjectIcon
	"Private - Generated method"
	^ icons
			at: #'smallProject'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallProjectIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallPublishIcon
	"Private - Generated method"
	^ icons
			at: #'smallPublish'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallPublishIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 3/6/2009 13:10'!
smallPushpinIcon
	"Private - Generated method"
	^icons
			at: #smallPushpinIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallPushpinIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:46'!
smallQuestionIcon
	"Private - Generated method"
	^icons
			at: #smallQuestionIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallQuestionIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallQuitIcon
	"Private - Generated method"
	^ icons
			at: #'smallQuit'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallQuitIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallRedoIcon
	"Private - Generated method"
	^ icons
			at: #'smallRedo'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallRedoIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallRemoteOpenIcon
	"Private - Generated method"
	^ icons
			at: #'smallRemoteOpen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallRemoteOpenIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 10/12/2004 14:05'!
smallRightFlushIcon
	"Private - Generated method"
	^ icons
			at: #'smallRightFlush'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallRightFlushIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallSaveAsIcon
	"Private - Generated method"
	^ icons
			at: #'smallSaveAs'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallSaveAsIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
smallSaveIcon
	"Private - Generated method"
	^ icons
			at: #'smallSave'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallSaveIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/24/2010 21:21'!
smallScreenshotIcon
	"Private - Generated method"
	^icons 
			at: #smallScreenshotIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallScreenshotIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallSelectIcon
	"Private - Generated method"
	^ icons
			at: #'smallSelect'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallSelectIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - accessing' stamp: 'AlainPlantec 10/24/2010 20:24'!
smallSizeNames
	"Answer the names of the small icons"
	
	^#('smallError' 'smallInfo' 'smallLock' 'smallQuestion' 'smallWarning' 'smallPushpin'
		'smallBold' 'smallItalic' 'smallUnderline' 'smallStrikeOut' 'smallBarcode'
		'smallHierarchyBrowser' 'smallSystemBrowser' 'smallScreenshot')! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 10/7/2004 13:42'!
smallSqueakIcon
	"Private - Generated method"
	^ icons
			at: #'smallSqueak'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallSqueakIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:46'!
smallStrikeOutIcon
	"Private - Generated method"
	^icons
			at: #smallStrikeOutIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallStrikeOutIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:46'!
smallSystemBrowserIcon
	"Private - Generated method"
	^icons
			at: #smallSystemBrowserIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallSystemBrowserIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:46'!
smallUnderlineIcon
	"Private - Generated method"
	^icons
			at: #smallUnderlineIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallUnderlineIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallUndoIcon
	"Private - Generated method"
	^ icons
			at: #'smallUndo'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallUndoIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallUpdateIcon
	"Private - Generated method"
	^ icons
			at: #'smallUpdate'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallUpdateIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallVolumeIcon
	"Private - Generated method"
	^ icons
			at: #'smallVolume'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallVolumeIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:45'!
smallWarningIcon
	"Private - Generated method"
	^icons
			at: #smallWarningIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallWarningIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 23:00'!
smallWindowIcon
	"Private - Generated method"
	^ icons
			at: #'smallWindow'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self smallWindowIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
solidMenuIcon
	"Private - Generated method"
	^ icons
			at: #'solidMenu'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self solidMenuIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
squeakyMouseIcon
	"Private - Generated method"
	^ icons
			at: #'squeakyMouse'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self squeakyMouseIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'AlainPlantec 10/19/2009 17:31'!
tinyMenuIcon
	"Private - Generated method"
	^ icons
			at: #'tinyMenu'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self tinyMenuIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:46'!
upArrowIcon
	"Private - Generated method"
	^icons
			at: #upArrowIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self upArrowIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
volumeIcon
	"Private - Generated method"
	^ icons
			at: #'volume'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self volumeIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 9/25/2008 15:45'!
warningIcon
	"Private - Generated method"
	^icons
			at: #warningIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self warningIconContents readStream) ].! !

!ThemeIcons class methodsFor: 'private - icons' stamp: 'dgd 9/25/2004 22:59'!
windowIcon
	"Private - Generated method"
	^ icons
			at: #'window'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self windowIconContents readStream) ].! !

ThemeIcons subclass: #VistaryThemeIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!VistaryThemeIcons commentStamp: 'gvc 9/23/2008 12:07' prior: 0!
Vistary theme specific icons.!

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
errorIconContents
	"Private - Method generated with the content of the file icons\new\error.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAN1wAADdcBQiibeAAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AA7ESURBVGiBvZp7cFRVnsc/59zb3Uk63QmPSIIkJEQU5CWwUjwKtnTAcbZmnJlSynWqZhZr
fNDlUjPW4mo5u1Lq+JydWccZvBIdp8aaYUoEldVRdBFxVnlDYgCNECQBEiAEO6/udN/X2T/6
3k53Hgq6O7fq1L3nJPfe7/f3+/5+53fObaGU4uschmEIYB5wHTARGJ/TBNCe004AW4GdsVjM
/Vov9g7xVQgYhiE9wN8TQtxQUVFRUVVVRSQSoaioiHA4TFFREQCJRIJkMkkikaC7u5vW1lY6
OjrOAW8Am4G/xGIx+29GwDCMfwAer6qqmlFbW0t1dTVaPE5/QwNmaytWZyfW2bNYHR24pomM
RJDRKPqYMYRqaoguXoxbUUFLSwvNzc20tbUdBf4NeDkWi120NS+YgGEYfwc8WVFRcc2CBQsY
AyR37SJ54ABmezuuaeJaFso0s9euaaIsC9d1s00pRWD8eEqWLKHs+9/nfCDArl276OjoOADc
F4vF/vv/nIBhGPeUlJQ8vnDhQlk1ejS977xDYudO3FRqALQHOI+IZeE6ThZ4loTr4iqFAsbe
cAOVsRgn+/rYsWMHfX19v/CIXFCMfCEBwzCCwLrKysoV1y1divXhh/Rt346TSAxYdxD4vDHb
Hhb44D6BAON/+EPG3X4772zdyunTp98CbonFYt1fmYBhGGOAzTNnzly0YPZsejZsINXUNKzF
hxCxLJRtfynwwdcl8+Zx5VNPsevgQT7++OMjwDdjsVjLRRPwLL918eLFi6eWl9P1pz9hnz2b
J5E84INl4+k+1/ojySiv77qEJkzgqro6Pu3tZc+ePZ8A82OxWM9IBOQI48/OnDlz8dSKCuLP
P58B7wFTto2yrAz4QWPZvlL5YHP6yicyTF8pRbK1ld3LlzNl1CimTJkyFdhkGIZ2wQQMw/iX
ysrKWxfMmUP3+vU4vb0ZLfuy8LQ93JgarPkLBZ7rEaUw43H2/uhHLJw1i/Hjxy8VQjx1QQQM
w5hdUlLy5HVLl9K7cSPW2bNDrZvTBo99XeC5/b7jx9l3220su/ZaioqK/tkwjG9ciAeeXLhw
obT37CF95MhQ6/rWtyxEQQGRxYuRRUWZMce5YOAFEyZQftNNyGh0AHiOjHwS53bs4ERdHfPm
zQN43itbhidgGMZ1FRUVS6vKykj89a8DEsm1tjemlZZS+ctfUr56NVW//z1y0qQB4D6JYfrK
dYnMns2cV1/liocfZu6bbxKcOPELvfHpb37DxFGjGDt2bLVS6sfDEvCYPbFgwQIS27fjJpN5
oHMDVZaWcunDDxO45BIAQpEI1b/9Lfrll3+p/ouvuooZ69aheXVSuKyMua+8Qqi6elgZKaWw
ens5/PjjLFy4ECHEfxiGUTCcB66pqqq6amwwSHL37qEZJ0c2lz74IIFx4/KsUFBUxKS1a9Gv
uGJEGRXPnMmMujq0cDjv3nBJCVe/9hpaWVkecD+tukrx2YsvEk2lGDduXIkQ4h+HI/C92tpa
UvX1uKnU0OziySh89dUEysuHiyVCRUVMfvZZ9KlTh+i/ePp0pnvglVKk02m6uro4c+YMbW1t
nO/uxozFaLdt2iyLE5ZFi21z0rZpt21Op9N8sn49tbW1KKVWDyEghPhudXU1/Y2NeYGal4Fs
m8T+/dimOSwBgFBhIVPWrSMwbVrWA4XTplH9618T7+/n5MmTHDt2jJaWFs6cOUM8Hqenp4fO
zk7a+vpIK0XadbE94qZSpFyXhFJ8tGkTNTU1AFNzZSQNw5hTXl5eFUgmMU+cyLP4YCmlT53i
2COPYFvWF5KYWleHc+WVJCdNovhnP6Ozt5euri6SySROTrZSStHf3099fT3WG29kM5mTEw+O
1z/T1ITb0cHYsWOlEGKl/z4dWDZx4kRShw7lp8rBE5VHytm2jSOOw+Q1awgEAnngTdOkt7eX
vr4+LlmzBmwbrbAwGxNAHvhUKkV9fT3Jl17COXAAZ5D+c/uOUjS99hoTFi2is7PzZuApX0JV
kUgEq7196ETlS8kn4hVo9rZtfPrAA1ieJxKJBO3t7bS1tdHd3Y1t22iBAFphYTYrAXnZybd8
csMGnP37s8HrA/f7Tk5gdzY3E4lEAKbkemB8UVERdjw+rP7zxnJf8u67HLQsyn7ykyGyGKn5
JFKpFA0NDSRffhln375stnGVQgkBUoKuI4RAh4wnbJue9naKi4sBIrlBPD4cDmN//vkX6j83
NbpK0W3bnHr7bQ4+9BBmOn1R4D9qaCC5cSPO3r0Z4EIgdB0RCiGLitCLitAKC9ELCxGFhegF
BQTCYfricZ+A9swzzxTneaD3/PmR9Z+T0/sdh7hpZjKFUvR/+CGf2jaX33svmq6PqHelFKZp
0tDQQGLjRty9e1GahpASTddB05BCoIRAAULKzNl7ngAS8TjhgXmkGjik+z3lOPmFmS+bnJwe
N00SjoPra9P7G+3tYFm4UmatPZIXRH09qr4eUVCA1DTQ9YxkvOYCCAFK4cIACdtGDwZxHMeH
fKlPoD2RSEyQxcVDJy9vPeu4Ll2WlQGfM0O6ShGsqmLyY48hQqE8qfgkcq81TWPWihU0njpF
4vBhhKaBpiGEwJUShMh4wbtHeM8SSiGkJDxmDMlkMqN9KbMx0J5MJpGRSFY2WQ94QM+bJomc
vuMBC1VWMvmRR5DFxXkB7pMYLvtous70++8nOncuMhRCBoPIYBA9EEDXdXRNQw8EkLqO9K41
XUfTdYpHjyaRSPgGOZ0lkEgk0KLR/AzkyeRcOk06xxOOFw+hykoue/RRtGh0iFQGF3O53vBJ
XPHTn1I8a1YGYCCArmloXpOahiYlAS8u/PFIjgds284SONnT00NgwoS8hYntOHSm05iOMwDc
AxH0wMtIZMSsY1kWpld2DOcNTdepXbmS8LRp6FJmQEqJJiW6EGhSZsFLT1qjL7uM7u5uAHfV
qlWdPoGtLS0tFM+fn7cY/9yySHvAfb073qK79uc/R2YmlGHBm6ZJfX09jS+9RCqVGlFeuq5T
fdtthKZORfdSoqYUWu4ZMgSkZOqNN9La2grQ6cU3Etjf0dFxygyHKZg8GaUUPZZFv23nAVeu
C0JQs2YNWknJEG37136qTG3dir1lC01PP03amydy7/GvpaYxYcUKVGkpmk/CdQeAeyBLR4/G
LSmhq6sL4C9+KpLefuR/tbS0ULxkCabj0GNZ+VseXuCqggK0UaNGDNZ0Os1HH31Eets2gocP
I4NBnCNHOGoYpNPpYWPDdV2EECRnzkRznAx4z/pSqUwGEoJL587l+PHjvtdfzRLwzq81Nzcz
6vrr+Vwp7Nx6PscDVm8vLRs2DBus6XSaxsZG0tu2oR86hPQzia6jmptpqavLeiL3ftd1aW5u
hs5OdMdBs22k66K5LlIpJKAJwaxbb838H5jpdHrrYALvtre3H+ywLC654QaUTyIn5/uV4bk/
/pHm118fErCNjY30b9uGdugQWjCI8NKg1DSklIhjxzj13HOkB8XE0aNHSTY0UL5/P9KykJ4X
lOuCJ7WJc+fyua7T2dkJ8Pbdd9/dn0fA20i9d+fOnVy+ciUUFIBS2D7wQfn/3Nq1HN28Gcdx
srLpf+89AgcPIr2JSXrZQwiB5mlZa27m7HPP0Z9I4DgOzc3N9NfXU/Xuu2ipVMb6jgOOk5EP
oGsa8x94gN27d/uYHyXnyNtaNAxj67Jly76R2rKFj9euHQCek0Jtn5DrwoIFWDNmIA4fJtDU
lJWNkBLpp8HMS9CUQrou0raxo1E658wh2NFBxa5dSNvGBRxNw9Z1bE3LXGsatd/6FiU/+AHv
v/8+wMZYLLY8l4BO/nHPzp079924YoU8d+AApz/4YCCIvTqdnDmBffvQGxsRwWCmaRpIiZAy
4wUfPGTAWxa64xA4e5aazZuRpom0rEwBp+soKTPltBC4QjBqwgRm3HsvGzdtArA1TbtvEN78
ja1YLFbf19d33ztbtzL/V7+i2NvuyC4qfA94JTC6jggEEJ5sssCFQGTSRSaLOA7CttFcF2FZ
6JaVAZ9KoXmB7UqJ0jRcry4KRSJc88ILvLVlC/39/QD/eccddxz7QgIeiV+cPn36xd0NDSx5
9lkCJSUD2cjzgL+nL7wyGP/sA/ceLAHhuuC6mbPjIFwX5TjguiAlZiiEFQxi6zqOJx1CIa5d
t44P9u/3A3d7R0fH/YOxDkvAO+745JNPdh2Lx7l+40aKa2ry5oNs+vQqSCBz9ptHFKXyrnP3
fWxNIx0KYRUWYodCOIEAlq4TiEZZ9sILNHV1cezYMYBW13VvWrNmzbAfAoclEIvF0sB39+zZ
s7ehtZXvvPoq5YsWDZTSgGNZGat7dbzwgPvSUTBAAq/kAFzADgSwQiHsUAgzFMIMBLACAYor
K/nmK6+wr62NhoYGgIQQ4tt33XXX+REMPaIHiMViHcCSpqaml7e89x5Lf/c7Zt99N1o4nMlG
pjmwhoWMrITIfvvyFySu9zcbcKTE1nUsr5me1d1gkKply/j79et5c/t23/InHMdZsHLlykMj
YYQL/8j37+Fw+MF58+aJS0tL2fHEExz+858RgQCFZWWZ9ElmGSgHZR/h6V54C5OsRwA0jbIZ
M5j30EOc6O1l7969fsD+j23bN65atercl2G7mM+si4DnR48ePWX+/PmELYvGP/yBU3v2kIzH
M3kfMtmITBWJUgivJMhdZRVGo4ydPp3pt99OVzjM7t27/TLZUUqtLSsru2f58uUjbwF+FQI5
RG4Bni4rKxs7adIkampqcDo7aX79dbqOHycVj5Pu7cVMJBCOQ7CggFBhIQXRKCWVlVx+882o
igqOHz/OZ599xvnzWXm/Atwfi8U+vRg8X/WnBjpwC/CvwJWlpaWyqqqKaDRKOBzONshsevX1
9WV/anDixAl6erLf7EwhxNtCiMfuvPPOnRcN5KsSGERGE0L8WCn1T8A0IAoM+ZLiH0qpuBDi
LaXUpmQy+fbq1asTX+f9X5vAcM+sq6sbY5pmhZSyQilVCJwJBAKnR40adeZCtX3BL/t/IPA3
Pf4XvU9EdugvtU8AAAAASUVORK5CYII='! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
infoIconContents
	"Private - Method generated with the content of the file icons\new\info.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!VistaryThemeIcons class methodsFor: 'class initialization' stamp: 'gvc 5/21/2007 16:24'!
initialize
	"Initialize the class."
	
	self initializeIcons! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
lockIconContents
	"Private - Method generated with the content of the file icons\new\lock.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!VistaryThemeIcons class methodsFor: 'private - accessing' stamp: 'gvc 5/18/2007 14:41'!
normalSizeNames
	"Answer the names of the normal icons"
	
	^#('error' 'info' 'lock' 'question' 'warning')! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
questionIconContents
	"Private - Method generated with the content of the file icons\new\question.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallErrorIconContents
	"Private - Method generated with the content of the file icons\new\smallError.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAMiSURBVDiNXZPPSxx3HIafnRl3nTVmo3Gprlus7opBYtSGtoLQWv+AkqSF9BiQIHMQc8oh
gSTnECGkkG0PIaJQgreWeJRGTDAQbRGNtoZWXaG4uuvY2dnZHzPf+fZgK5oPvLf3fT6nJyCl
5PhNTEwMxGKx6/Wq2l9jWc2OphUPdP3XzO7uT6ZpfmcYhne8H/gfkEqlwu2JxESP635dnp2l
tLGBa5pUHAe/qopwXx/ZgQFzOZ3+cnh4eOkEIJVK6f1dXdvNS0tnnZUVXNM8HNs2rusehXCY
+hs35Hyx+O3Q0NAUgALQnkhMxFdWzhZXV/HyebxCAbdQwPO8owjfx8lm2bpzJ9DV0PBjKpWK
ACiTk5Nf9CrKN8XVVTzbpm50lJZnzyCZPBxKSceTJ3wyP4+WTFKxbayHD9V4LPYCQGlqarru
vX59+Nm20Ts7CdXUkHz8mMC5c3wwNoZsbSVnWWQvXmSjXOa3hQUi+Xw3QGBxbu7PhqdP2yoH
B7imiUgmaR0bo+y67OdyCN9HCMHb2Vm2796lXCxScV0+u3mTjaamPqXWcT5083k8y8Itldh7
84Zfrl1jb2/vaLy+sMD2vXtUymXQdbQzZ7C2tgCuaI6q2tWWVVdxHDLFIrbnEbt6FSklQgiE
EMQ6Otjt7aWUTiNVFSElNdEoOcgpB5q24CsK2WKRfKVC461bRC5cwPM83i0u4hQKqJpG5+3b
1HZ0ENZ1wtXVhFtaAKaVTCbzs9/dzT+VCq7rEohG8TyPtZcv+fv+fdYePKCQz+NLSSAaJez7
nNI03HjcB9bUwcHBxUhPz4g9N6eXHIedmRkyuRwHU1MEdR2tVMJZXsZcX6fu1StUIWi+fJk/
4AfDMJ4rhmGIt+l0/0cjI9JVFMr7++Snp1GDQdRgkCohqN7cJDozQ8iyON3WxlYikZFSjpxw
YXx8/Er76dNTm48eqfs7O4QiEYKKQkgIgo5DUAjqL11i8/z5HcuyPjcM490JwH9CnYo1Nr6o
tayP5fZ2oJxOEwyFqIrHKScS/l/Z7PdSytHjRgbe1/kY7FPgK8ACngO/G4bhv9/7FxuHuWxf
1Q6XAAAAAElFTkSuQmCC'! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallInfoIconContents
	"Private - Method generated with the content of the file icons\new\smallInfo.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAMMSURBVDiNXZPNbxR1GMc/Mzvd2dntbku3LtsXInFpxFiCepCSmgIHEkPiS8pF48WkwWYO
RP8C/wCPeBj1VHvwwE2DB29iMJqIJWhFoilLXwid0ul2Z9p5+/1mfh4Wk5bn/P18nuc5fDWl
FAdncXHx/Ojo6JWCOTTtJ5UxQ4WRVdhd2tpyv+10Op/bti0P5rX/BY7jlFsnJhZF5ZXLN+8k
tDdiOl1BGKb06TlTk2XOT2531tp/Xpifn797SOA4jnXq1en1u4/H6ssrIZ1dQRhKZi8M8sMt
j/srPiIVlE345IMhFXm/vDc3N3cdQAdonZhYXH4yXr/XjvADiR8IxoYNPnyrwaU3jiCERKSS
bS/k02ur2vDIqW8cxxkAKLRarXO1YzOf3fojxvclXV/gB5JHbsTPSx1u3NwiChOkEEghiSLB
yrrSL54tv3ny5Itf6iMjI1d+vScJAom/14OlkJBnVC1BzdwnCT2SvU3iYJ0kaHP7tzsE8cBp
AL1UGTrbfpTgBz1YpJI0STjzUs47U0/4aLZKEnqkcReR7CNFhEhD/mmHmuM4Z/RQVo8FT+E4
EkT7HlF3AyX3ieMYlESKFClS8izFKsJg1WB1wweYNQqEe35QOhJGKdGeSxoGPUBKhBDougGZ
YLCmUzLLFDSFUhnPDVcAzzOMfPe2TuNiFGyThgEiTREiJZcZ9Xqdnb0+mo0SZqmArmsoDfI8
4/nRMmR8r7uu+93pVk4adhFC9LanCVkmaDQaGH0G/bUSRtlCWRXyYhnD6mf8qMiBv3XP85xz
L+92rJIiEyky7f1rlTRqtRqaXkCZFnGhQkA/kWZxaeY47uMHX9m2neu2bWdr7b+mr75/XOmq
d4FVVLTXuvy+vMNPS5vEmHRkGV+avNCs0RpadZVSVw91YWFhYbZWn7h+7euHhc2tHQYGTHSz
SKabhBTJKPLu1BCTRx9u+r4/Y9v2v4cETwvV32yO/ujH1dfWXaWtuQlmqch4o49WM8m33Qdf
KKU+PthI7dk6H5C9DrwN+MAN4L5t2/mzuf8Ad6/AAZ+lo8QAAAAASUVORK5CYII='! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallLockIconContents
	"Private - Method generated with the content of the file icons\new\smallLock.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AALVSURBVDiNfdM/aBNhGAbw57vvu/tyd8m1Gmtr26Bp1QoqCBlMUUREHNwcuiiIqKCD0EUc
XFwiFapYCGJ1EcQKWQpWcCmIQkBBaa3oIlSrNbWpNndJ7nJ3uX9OLWKtz/7+eJ8XXhJFEVYy
NDSU1nX9nOM43Y7jLFSr1XyhUPiB/4SsAMPDw8d0XR/VNK27t7f3M6U0WSwWjbm5ucHx8fFn
6wECAExMTKi2bd/MZDIN0zQHBwYGdk1NTWV6enr0/v7+G9lstuW/QKlUutjZ2blnenr6Xi6X
uwsAuVzuW6lUupVOp/va2trOr1shNE5vff9p82OrpqRl+/V1LkaRRCMETQuubWJ6fsdl360t
blE/Xjt+aWFyDRCYRx7o1U9n3j0PoM9TpLaoSHWocM0SqBAinogjJAQfZpe+HL5Q71lToWqY
LQuzHvSfPiQegbEQQejC9RwQkQFMgOXYSCToP+8gaK3cCX0Ks0Kh8hgSigwaeZAEAolSSEzE
0i8DVsP18vn8vnw+H/sTYIvzllye98C5ACoGiIgHs1EHZQwhpfCiAFJMgMJlsU/Z8NoP1CKA
o6sbiIzbzQaDwjk0RUZSUyEENjijiDGGes2C6zowYmdj2exVvn37iyOFQiGxCpS/N+TKkgfK
QoD4qNYNeBEQChQhIbAcB4mEjPZeSR4Z2Y2Zd5MklUreWQUESDaNJGiqjI2aCon4kEUBssgg
cwkVvQorfg7t7ffJ3FcbetkEx9NTY2NjMgAIy2U7RlkIQnz4oYe6ZcIHhQ8CvW5CiSvQUiJc
YwlfZktgaEWz/Ejo6kzeBgDy5smhE3bVHGhRKRQeoa4vgjEGyiiW9RqaHVcObu26kfLMZbx8
tQ3drRUIbg1IDoaWdCBB/vzGvzM6Osr39v20N6szpNmgmPoooUOLEJcJvJDD33TyIVt3GgAh
hFTMfW897JclKWbvzDAXIAEIAfUDVjeM4m+dHTsKS7Yv+wAAAABJRU5ErkJggg=='! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallQuestionIconContents
	"Private - Method generated with the content of the file icons\new\smallQuestion.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAMdSURBVDiNXZPNbxR1HIefmV129qVd2i2026VQdOVkBeFA0SalHrxooogkajxwaGozB6IH
/gMvXkx8OSzxVNsbniQSk4qk6kENiCFUFIt9p+1sup3dme3Mzu83Mz8PRdPyPX+eJ9/Loyml
2H2Tk5MjpVJpLGEUhpwgdyipPD+TqN+pVq2vbdv+3DTNcPde+09QqVSy5WeOTcrc82/+8HvA
wmoLuyHxPME+PebMQJaRgU17eeHeS+Pj43f3CCqVSua5k0Mrd9cPdc3+42HXJXZD4nuSli+Q
QiKFJGvAB+8WlF/7+e3R0dGr/wumv7vx1Xzr1IV7cx71hqS/O8l7b3TT32uwarW4+esWH12Z
IwgCdCI+vtwVrS391mWaZkOfmpo6q3eevHB/3sd1QxxXopQiVoqNTcHhYpqLr5cYPN5OKEOa
TcEnU06iVOqbAUj29vaO/XI/3IGbEscN+fGWzfRPVVIJycSHZQp5jWKnS8tdQQY+t29J3HOD
JwCS6VzhhYVHAY67A0sRErQCgm2bp/ojYmmzth4yPfMQGWwTygApBH8veFqlUhnUvbD9sPsY
bvkSf7uG31glrbtcvngEFUd8OvGAxeUGcSTIpKCjPcnSqgNwPpnAazpuutPzBX7TQnguoRQM
v1igPaexZm3z7ffLdOR10kaWhKZQKuLggRxQqyWTcf22TvfLvruJ8FykEEgpsKrbXLvxiNkH
Wxw8YGCkE+i6htIgjiP6S1mIuK5blnXtRDlGeA2klIRSEIoA3w/It2mEcUxbPk0ym0FlcsSp
LMlMG309Mgb+1Gu1WuXss3U7k1ZEUhAKQSgFY28d4fTxDl4d6UEZGVqJHC5t+FqGV4aPYq3P
f2GaZqybphktL/wxdOmdo0pXOx9kUorrN9eYnWswc8ehhYEdZnFCg6eLecqFJUspdWlPCxMT
E+fzXceufvblYmKjusX+/Qa6kSLSDTxSRKQ4d6bAQM/ihuM4w6Zpzu0RPA6qrVgszTit9lMr
ltKWrQAjnaKvex/lYhBvWvNXlFLv7y5SezLnXbLTwGuAA3wD/GWaZvzk7l+B2cIZLVTLdwAA
AABJRU5ErkJggg=='! !

!VistaryThemeIcons class methodsFor: 'private - accessing' stamp: 'gvc 5/21/2007 12:31'!
smallSizeNames
	"Answer the names of the small icons"
	
	^#('smallError' 'smallInfo' 'smallLock' 'smallQuestion' 'smallWarning')! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
smallWarningIconContents
	"Private - Method generated with the content of the file icons\new\smallWarning.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAAAlw
SFlzAAAEnQAABJ0BfDRroQAAABl0RVh0U29mdHdhcmUAd3d3Lmlua3NjYXBlLm9yZ5vuPBoA
AAJtSURBVDiNjZBNSFRhFIaf77v3juV1dMYZf2auTqb9CGVBEkhta9uqheFCUIqIaFOr9gXh
oiRCZjRxITrgKG5aBC2CFFuUtHAhRcgglObYjD/3jqNz79fKWjhKB87m8Lwv73lRSnHYxuPx
F4lEovcoRiilKDUjIyNXQqHQjFJqL5vNBrq7u/OlOFlSDUQikcHWs0Oiwfrs8/v9Tw7jSsZK
JpMd8/PDnnKF2t6sU3NzH+xkMmmUYksmiMViryL1AwIUprlKqPptuWmaD/7rhcnJycvB4LdL
6fR37t3vovf2DWprBqmvr32cSqUO8AcOlmUNVPr7MHSFzxfGcSQGq/i0N9Wu63YdaTA1NdVR
UfGlPRpZwDy+QzqdZmNjBTsHZd4QTU0n+kZHR8WhBpZlxasD/eQ3QbgujrNFVaUPOwei8ANR
eFenadrNkgbT09PX/eanC6axiJ0Dr+CxuPgVwwiynQU7B/mVBM3NJ59nMpmDBtFoNO6jHzsL
2zko2h6R+jDBSomdAzsL7tYyO+vvrdnZ2c59nVBKMTEx0Xm6eXk8qD1kdwd281DIw+paDIo5
ythkdwf28pB3m2i5lvrZ3t4e/ZsgEAi81AvjFByLgtPAbqERO3+RR8/KmZ65ilLNQAtSP4VZ
ZuD8+hhJpVK9APrw8PDdpkYtXGGewy2exyclmiGQhkZb6wJtZ8JU1saA/fIFtrNEMNj6FHgt
4vH4WDQSvlXtX0EXAil1pNBRSuK5ChAIKQCJ8jyKrsceVWw4OmtrazW6pml3VlZ/j2XWy49p
mlYUQrhAUUrpAp5SyvvXl8TzQKlN4bruUk9PT+YPUsxAEGFWxzgAAAAASUVORK5CYII='! !

!VistaryThemeIcons class methodsFor: 'private - icons' stamp: 'gvc 8/28/2007 17:08'!
warningIconContents
	"Private - Method generated with the content of the file icons\new\warning.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABHNCSVQICAgIfAhkiAAAAAlw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'! !

ThemeIcons subclass: #WateryThemeIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!WateryThemeIcons commentStamp: 'gvc 9/23/2008 12:07' prior: 0!
Watery theme specific icons.!

!WateryThemeIcons class methodsFor: 'private - accessing' stamp: 'gvc 10/24/2007 11:43'!
normalSizeNames
	"Answer the names of the normal icons"
	
	^#('error' 'info' 'lock' 'question' 'warning')! !

!WateryThemeIcons class methodsFor: 'private - accessing' stamp: 'gvc 10/24/2007 11:38'!
smallSizeNames
	"Answer the names of the small icons"
	
	^#('smallError' 'smallInfo' 'smallLock' 'smallQuestion' 'smallWarning')! !

Object subclass: #UITheme
	instanceVariableNames: 'settings forms soundTheme focusIndicator'
	classVariableNames: 'Builder Current'
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

UITheme class
	instanceVariableNames: 'defaultSettings'!

!UITheme commentStamp: 'StephaneDucasse 10/2/2009 16:15' prior: 0!
Common superclass for User Interface themes. Provides methods for creating new morphs in a standard way, various "services" like a file dialog, message dialogs etc. and also methods for customising aspects of the appearance of various morphs.
Though conceptually abstract, no code is "missing". Subclasses, therefore, should override the aspects they wish to change.

UITheme exampleBasicControls
UITheme exampleBuilder
UITheme exampleColorControls
UITheme exampleDialogs
UITheme exampleGroups
UITheme exampleOtherControls
UITheme exampleWindowWithToolbars!

UITheme class
	instanceVariableNames: 'defaultSettings'!

UITheme subclass: #BlueUITheme
	instanceVariableNames: 'windowActiveDropShadowStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!BlueUITheme commentStamp: 'TudorGirba 1/30/2011 22:51' prior: 0!
The theme is developed in the context of the Glamour project, and its goal is to create a look that:
- does not look like a specific operating system. In particular, the icons should be operating system agnostic, because, for example, people in Windows are confused by the red, yellow, green buttons of apple.
- uses a limited amount of colors and effects.
- is fast.

self defaultSettings: nil.
self beCurrent. !

!BlueUITheme class methodsFor: 'accessing' stamp: 'TudorGirba 4/8/2011 01:03'!
baseColor
	^ (Color r: 190 g: 190 b: 190 range: 255)! !

!BlueUITheme class methodsFor: 'accessing' stamp: 'tg 9/5/2010 20:50'!
basePassiveBackgroundColor
	^ Color r: 245 g: 245 b: 245 range: 255! !

!BlueUITheme class methodsFor: 'accessing' stamp: 'tg 9/5/2010 21:46'!
baseSelectionColor
	^ Color r: 97 g: 163 b: 225 range: 255! !

!BlueUITheme class methodsFor: 'accessing' stamp: 'tg 9/9/2010 22:43'!
darkBaseColor
	^ Color r: 180 g: 180 b: 180 range: 255! !

!BlueUITheme class methodsFor: 'private' stamp: 'tg 11/5/2010 20:50'!
importGlamorousIcons
	"utility method to import the icons necessary for the theme from the file system"
	"self importGlamorousIcons"
	| icons |
	icons := #(
		'glamorousMax'
		'glamorousMin'
		'glamorousClose'
		'glamorousMenu'
		'glamorousMaxInactive'
		'glamorousMinInactive'
		'glamorousCloseInactive'
		'glamorousMenuInactive'
		'glamorousMenuPin'
		'glamorousCheckboxSelected'
		'glamorousCheckboxUnselected'
		'glamorousRadioSelected'
		'glamorousRadioUnselected').
	self importIcons: icons fromFolder: 'icons' inClass: BlueUIThemeIcons category: '*glamour-morphic-theme'! !

!BlueUITheme class methodsFor: 'private' stamp: 'tg 9/3/2010 14:28'!
importIcons: icons fromFolder: aString inClass: aClass category: aCategory
	icons
		do: [:each |
			| method form |
			form := PNGReadWriter formFromFileNamed: aString, '/', each , '.png'.
			method := each , Character cr asString ,
				(aClass methodStart: each),		
				form storeString,
				aClass methodEnd.
			aClass class compile: method classified: aCategory ].
	aClass initialize! !

!BlueUITheme class methodsFor: 'testing' stamp: 'TudorGirba 4/7/2011 23:45'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^false! !

!BlueUITheme class methodsFor: 'accessing' stamp: 'tg 9/9/2010 22:37'!
lightBaseColor
	^ Color r: 200 g: 200 b: 200 range: 255! !

!BlueUITheme class methodsFor: 'accessing' stamp: 'tg 9/7/2010 13:51'!
lightSelectionColor
	^ Color r: 175 g: 213 b: 250 range: 255! !

!BlueUITheme class methodsFor: 'settings' stamp: 'tg 9/7/2010 13:47'!
newDefaultSettings
	BalloonMorph setBalloonColorTo: self lightSelectionColor.
	^super newDefaultSettings
		menuColor: self baseColor;
		menuTitleColor: self baseColor;
		windowColor: self baseColor;
		selectionColor: self lightSelectionColor;
		menuSelectionColor: self baseSelectionColor;
		progressBarColor: self baseColor;
		standardColorsOnly: true;
		autoSelectionColor: false;
		preferRoundCorner: false;
		flatMenu: true! !

!BlueUITheme class methodsFor: 'settings' stamp: 'MarcusDenker 4/12/2011 09:53'!
setPreferredShoutColors
	"self setPreferredShoutColors"

	Smalltalk globals at: #SHTextStylerST80 ifPresent: [:cls | cls styleTable: 
		#(
			"(symbol color [emphasisSymbolOrArray [textStyleName [pixelHeight]]])" 
			(default 								black)
			(invalid 									red)
			(excessCode 							red)
			(comment 								(gray darker))
			(unfinishedComment 					(red muchDarker))
			(#'$' 									(red muchDarker))
			(character 								(red muchDarker))
			(integer 								(red muchDarker))
			(number 								(red muchDarker)) 
			(#- 										(red muchDarker))
			(symbol 								(magenta muchDarker)) 
			(stringSymbol 							(magenta muchDarker)) 
			(literalArray 							(magenta muchDarker))
			(string 									(magenta muchDarker) normal)
			(unfinishedString 						red normal)
			(assignment 							nil)
			(ansiAssignment 						nil)
			(literal 									nil italic)
			(keyword 								(black))
			(binary 									(black)) 
			(unary 									(black))
			(incompleteKeyword 					red)
			(incompleteBinary 						red) 
			(incompleteUnary 						red )
			(undefinedKeyword 					red)
			(undefinedBinary 						red) 
			(undefinedUnary 						red) 
			(patternKeyword 						nil bold)
			(patternBinary 							nil bold)
			(patternUnary 							nil bold) 
			(#self 									(cyan muchDarker ))
			(#super 								(cyan muchDarker ))
			(#true 									(red muchDarker))
			(#false 									(red muchDarker))
			(#nil 									(red muchDarker))
			(#thisContext 							(cyan muchDarker ))
			(#return 								(cyan muchDarker ) bold)
			(patternArg 							(blue muchDarker)) 
			(methodArg 							(blue muchDarker))
			(blockPatternArg 						(blue muchDarker))
			(blockArg 								(blue muchDarker))
			(argument 								(blue muchDarker))
			(blockArgColon 						black)
			(leftParenthesis 						black)
			(rightParenthesis 						black)
			(leftParenthesis1 						(green muchDarker))
			(rightParenthesis1 						(green muchDarker))
			(leftParenthesis2 						(magenta muchDarker))
			(rightParenthesis2 						(magenta muchDarker))
			(leftParenthesis3 						(red muchDarker))
			(rightParenthesis3 						(red muchDarker))
			(leftParenthesis4 						(green darker))
			(rightParenthesis4 						(green darker))
			(leftParenthesis5 						(orange darker))
			(rightParenthesis5 						(orange darker))
			(leftParenthesis6 						(magenta darker))
			(rightParenthesis6 						(magenta darker))
			(leftParenthesis7 						blue)
			(rightParenthesis7 						blue)
			(blockStart 								black)
			(blockEnd 								black)
			(blockStart1 							(green muchDarker))
			(blockEnd1 								(green muchDarker))
			(blockStart2 							(magenta muchDarker))
			(blockEnd2 								(magenta muchDarker))
			(blockStart3 							(red muchDarker))
			(blockEnd3 								(red muchDarker))
			(blockStart4 							(green darker))
			(blockEnd4 								(green darker))
			(blockStart5 							(orange darker))
			(blockEnd5 								(orange darker))
			(blockStart6 							(magenta darker))
			(blockEnd6 								(magenta darker))
			(blockStart7 							blue)
			(blockEnd7 								blue) 
			(arrayStart 								black)
			(arrayEnd 								black)
			(arrayStart1 							black)
			(arrayEnd1 								black)
			(leftBrace 								black)
			(rightBrace 								black)
			(cascadeSeparator 					black)
			(statementSeparator 					black)
			(externalCallType 						black)
			(externalCallTypePointerIndicator 		black)
			(primitiveOrExternalCallStart 			black bold)
			(primitiveOrExternalCallEnd 			black bold)
			(methodTempBar 						(black))
			(blockTempBar 						(black))
			(blockArgsBar 							(black))
			(primitive 								(green muchDarker))
			(pragmaKeyword 						(green muchDarker))
			(pragmaUnary 							(green muchDarker))
			(pragmaBinary 							(green muchDarker)) 
			(externalFunctionCallingConvention 	(green muchDarker) bold)
			(module 								(green muchDarker) bold)
			(blockTempVar 						(blue muchDarker))
			(blockPatternTempVar 					(blue muchDarker))
			(instVar 								(blue muchDarker))
			(workspaceVar 							(blue muchDarker))
			(undefinedIdentifier 					red)
			(incompleteIdentifier 					red)
			(tempVar 								(blue muchDarker))
			(patternTempVar 						(blue muchDarker))
			(poolConstant 							(blue muchDarker))
			(classVar 								(blue muchDarker))
			(globalVar 								(blue muchDarker)))]
! !

!BlueUITheme class methodsFor: 'settings' stamp: 'TudorGirba 4/8/2011 00:13'!
setPreferredWorldBackground
	"self setPreferredWorldBackground"
	World color: Color white! !

!BlueUITheme class methodsFor: 'accessing' stamp: 'StephaneDucasse 4/11/2011 22:28'!
themeName
	^ 'Blue Pharo'! !

!BlueUITheme class methodsFor: 'accessing' stamp: 'tg 9/7/2010 13:51'!
veryLightSelectionColor
	^ Color r: 218 g: 234 b: 250 range: 255! !

!BlueUITheme methodsFor: 'border-styles-buttons' stamp: 'tg 9/4/2010 23:06'!
buttonCornerStyleIn: aThemedMorph
	"If asked, we only allow square corners"
	
	^ #square! !

!BlueUITheme methodsFor: 'label-styles' stamp: 'tg 8/31/2010 08:32'!
buttonLabelForText: aTextOrString
	"Answer the label to use for the given text."
	^aTextOrString isString
		ifTrue: [(LabelMorph contents: aTextOrString) color: Color black]
		ifFalse: [super buttonLabelForText: aTextOrString]! !

!BlueUITheme methodsFor: 'defaults' stamp: 'tg 9/6/2010 14:04'!
buttonMinHeight
	"Answer the minumum height of a button for this theme."
	
	^24! !

!BlueUITheme methodsFor: 'defaults' stamp: 'tg 9/6/2010 14:04'!
buttonMinWidth
	"Answer the minumum width of a button for this theme."
	
	^24! !

!BlueUITheme methodsFor: 'border-styles-buttons' stamp: 'tg 9/9/2010 22:43'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	| outerColor innerColor |
	(aButton valueOfProperty: #noBorder ifAbsent: [false]) ifTrue: [
		^ SimpleBorder new width: 0; baseColor: Color transparent ].
	outerColor := self glamorousDarkBaseColorFor: aButton.
	^SimpleBorder new
					width: 1;
					baseColor: outerColor! !

!BlueUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 9/3/2010 12:21'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	(aButton valueOfProperty: #noFill ifAbsent: [false]) ifTrue: [^ SolidFillStyle color: Color transparent ].
	^ self glamorousNormalFillStyleFor: aButton height: aButton height! !

!BlueUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 9/13/2010 10:37'!
buttonSelectedFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	| top bottom |
	top := self glamorousLightSelectionColorFor: aButton.
	bottom := self glamorousLightColorFor: aButton.

	^(GradientFillStyle ramp: {
			0.0->top.
			0.7->bottom.})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 09:08'!
checkboxForm
	"Answer the form to use for a normal checkbox."

	^self  checkboxUnselectedForm! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 14:10'!
checkboxSelectedForm
	"Answer the form to use for a selected checkbox."

	^BlueUIThemeIcons checkboxSelectedForm! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 13:54'!
checkboxUnselectedForm
	"Answer the form to use for a selected checkbox."

	^ BlueUIThemeIcons checkboxUnselectedForm! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'TudorGirba 1/13/2011 23:06'!
configureWindowBorderFor: aWindow
"	super configureWindowBorderFor: aWindow.
	aWindow roundedCorners: #()"
		| aStyle |
	
	
	aStyle := 
		SimpleBorder new 
			color: (Color black alpha: 0.5);
			width: 1.
			
	aWindow borderStyle: aStyle.! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'TudorGirba 1/13/2011 22:59'!
configureWindowDropShadowFor: aWindow

	aWindow hasDropShadow: false! !

!BlueUITheme methodsFor: 'label-styles' stamp: 'TudorGirba 4/8/2011 00:12'!
configureWindowLabelAreaFor: aWindow
	"Configure the label area for the given window."

	|padding|
	padding := 0.
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow hasCloseBox ifTrue: [aWindow addCloseBox. padding := padding + 1].
	aWindow hasCollapseBox ifTrue: [aWindow addCollapseBox. padding := padding + 1].
	aWindow hasExpandBox ifTrue: [aWindow addExpandBox. padding := padding + 1].
	aWindow hasMenuBox ifTrue: [padding := padding - 1].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0; hResizing: #spaceFill).
	aWindow basicLabel ifNotNil: [:label | aWindow labelArea addMorphBack: label; hResizing: #shrinkWrap].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0; hResizing: #spaceFill).
	padding > 0 ifTrue: [
		aWindow labelArea
			addMorphBack: (Morph new extent: (aWindow boxExtent x * padding) @ 0)].
	aWindow hasMenuBox ifTrue: [aWindow addMenuControl].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0)! !

!BlueUITheme methodsFor: 'label-styles' stamp: 'TudorGirba 4/8/2011 01:17'!
createCollapseBoxFor: aSystemWindow
	"Answer a button for minimising the window."
	
	|form msb|
	form := self windowMinimizeForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMinimizePassiveForm.
	msb extent: form extent.
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMinimizeOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMinimizePassiveForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: [aSystemWindow collapseBoxHit];
		setBalloonText: 'Collapse this window' translated;
		extent: aSystemWindow boxExtent.
	^msb! !

!BlueUITheme methodsFor: 'label-styles' stamp: 'TudorGirba 4/8/2011 01:17'!
createExpandBoxFor: aSystemWindow
	"Answer a button for maximising/restoring the window."
	
	|form msb|
	form := self windowMaximizeForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMaximizePassiveForm.
	msb extent: form extent.
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMaximizeOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMaximizePassiveForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: [aSystemWindow expandBoxHit];
		setBalloonText: 'Expand to full screen' translated;
		extent: aSystemWindow boxExtent.
	^msb! !

!BlueUITheme methodsFor: 'label-styles' stamp: 'tg 9/3/2010 11:34'!
createMenuBoxFor: aSystemWindow
	"Answer a button for the window menu."
	
"	^aSystemWindow createBox
		labelGraphic: (self windowMenuIconFor: aSystemWindow);
		extent: aSystemWindow boxExtent;
		actWhen: #buttonDown;
		actionSelector: #offerWindowMenu;
		setBalloonText: 'window menu' translated"
	
	|form msb|
	form := self windowMenuForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMenuPassiveForm.
	msb extent: form extent.
	msb activeDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMenuForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMenuPassiveForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: [aSystemWindow offerWindowMenu];
		setBalloonText: 'window menu' translated;
		extent: aSystemWindow boxExtent.
	^msb! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/3/2010 12:30'!
dockingBarNormalFillStyleFor: aToolDockingBar
	^ SolidFillStyle color: Color transparent! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:47'!
dropListDisabledFillStyleFor: aDropList
	"Return the disabled fillStyle for the given drop list."
	
	^ self textEditorDisabledFillStyleFor: aDropList! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'tg 9/4/2010 22:55'!
dropListNormalBorderStyleFor: aDropList
	"Return the normal borderStyle for the given drop list"

	^ self buttonNormalBorderStyleFor: aDropList! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/4/2010 23:04'!
dropListNormalFillStyleFor: aDropList
	"Return the normal fillStyle for the given drop list."
	
	^ SolidFillStyle color: Color white! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'TudorGirba 1/25/2011 15:39'!
expanderTitleNormalFillStyleFor: anExpanderTitle
	"Return the normal expander title fillStyle for the given expander title."
	
	^ self buttonNormalFillStyleFor: anExpanderTitle! !

!BlueUITheme methodsFor: 'private' stamp: 'tg 9/3/2010 12:32'!
glamorousBaseColorFor: aButton
	^ self class baseColor
	"unfortunately, it looks like paneColor does not always return the wanted color"
	"aButton paneColorOrNil ifNil: [Color r: 200 g: 200 b: 200 range: 255]"! !

!BlueUITheme methodsFor: 'private' stamp: 'tg 9/5/2010 20:40'!
glamorousBasePassiveBackgroundColorFor: aButton
	^ self class basePassiveBackgroundColor! !

!BlueUITheme methodsFor: 'private' stamp: 'tg 9/5/2010 20:40'!
glamorousBaseSelectionColorFor: aButton
	^ self class baseSelectionColor! !

!BlueUITheme methodsFor: 'private' stamp: 'tg 9/9/2010 22:50'!
glamorousDarkBaseColorFor: aButton
	^ self class darkBaseColor! !

!BlueUITheme methodsFor: 'private' stamp: 'tg 9/9/2010 22:02'!
glamorousLightColorFor: aButton
	^ self class lightBaseColor! !

!BlueUITheme methodsFor: 'private' stamp: 'tg 9/5/2010 21:44'!
glamorousLightSelectionColorFor: aMorph
	^ self class lightSelectionColor! !

!BlueUITheme methodsFor: 'private' stamp: 'tg 9/13/2010 10:49'!
glamorousNormalFillStyleFor: aMorph height: anInteger
	"Return the normal button fillStyle for the given button."
	
	| baseColor |
	baseColor := self glamorousBaseColorFor: aMorph.
	^ self glamorousNormalFillStyleWithBaseColor: baseColor for: aMorph height: anInteger
! !

!BlueUITheme methodsFor: 'private' stamp: 'tg 9/13/2010 10:49'!
glamorousNormalFillStyleWithBaseColor: aColor for: aMorph height: anInteger
	
	| top bottom |
	top := aColor twiceLighter.
	bottom := aColor.
	^(GradientFillStyle ramp: {
			0.0->top.
			0.7->bottom.})
		origin: aMorph bounds origin;
		direction: 0 @ anInteger;
		radial: false! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'tg 9/9/2010 23:51'!
groupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a group panel."

	^ SimpleBorder new
		width: 1;
		baseColor: ((self glamorousBaseColorFor: aGroupPanel))! !

!BlueUITheme methodsFor: 'initialize-release' stamp: 'tg 8/31/2010 13:51'!
initialize
	"self beCurrent"

	super initialize.
	self windowActiveDropShadowStyle: #nodiffuse! !

!BlueUITheme methodsFor: 'initialize-release' stamp: 'TudorGirba 4/8/2011 01:09'!
initializeForms
	"Initialize the receiver's image forms."

	|inactiveForm|
	super initializeForms.
	inactiveForm := self newWindowInactiveControlForm.
	self forms
		at: #windowCloseOver put: self newWindowCloseOverForm;
		at: #windowMinimizeOver put: self newWindowMinimizeOverForm;
		at: #windowMaximizeOver put: self newWindowMaximizeOverForm;
		at: #windowClosePassive put: inactiveForm;
		at: #windowMinimizePassive put: inactiveForm;
		at: #windowMaximizePassive put: inactiveForm! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:48'!
listDisabledFillStyleFor: aList
	"Return the disabled fillStyle for the given list."
	
	^ self textEditorDisabledFillStyleFor: aList! !

!BlueUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 9/10/2010 08:12'!
menuItemInDockingBarSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item that is in a docking bar."
	^ self buttonSelectedFillStyleFor: aMenuItem! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 09:09'!
menuPinForm
	"Answer the form to use for the pin button of a menu."

	^ BlueUIThemeIcons menuPinForm! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 09:09'!
newCheckboxMarkerForm
	"Answer a new checkbox marker form."

	^BlueUIThemeIcons checkboxMarkerForm! !

!BlueUITheme methodsFor: 'morph creation' stamp: 'TudorGirba 4/8/2011 01:15'!
newCloseControlIn: aThemedMorph for: aModel action: aValuable help: helpText
	"Answer a button for closing things."
	
	|form msb|
	form := self windowCloseForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowClosePassiveForm.
	msb extent: form extent.
	msb activeDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowCloseOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowClosePassiveForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: aValuable;
		setBalloonText: helpText.
	^msb! !

!BlueUITheme methodsFor: 'morph creation' stamp: 'tg 9/5/2010 21:28'!
newFocusIndicatorMorphFor: aMorph
	"Answer a new focus indicator for the given morph."

	|radius|
	radius := aMorph focusIndicatorCornerRadius.
	^ BorderedMorph new
		fillStyle: Color transparent;
		borderStyle: (SimpleBorder new
			 width: 1;
			baseColor: (self glamorousBaseSelectionColorFor: aMorph));
		bounds: aMorph focusBounds! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 09:46'!
newRadioButtonMarkerForm
	"Answer a new radio button marker form. We make it empty because we already have the selected radio button take care of the state."

	^BlueUIThemeIcons radioButtonMarkerForm  ! !

!BlueUITheme methodsFor: 'initialize-release' stamp: 'tg 9/6/2010 14:38'!
newRadioMarkerForm
	"Answer a new checkbox marker form."

	^Form extent: 12@12 depth: 32! !

!BlueUITheme methodsFor: 'initialize-release' stamp: 'TudorGirba 4/8/2011 01:06'!
newTreeExpandedForm
	"Answer a new form for an expanded tree item."

	^(Form
	extent: 9@9
	depth: 32
	fromArray: #( 1049135240 2290649224 2290649224 2290649224 2290649224 2290649224 2290649224 2290649224 1200130184 478709896 4169697416 4287137928 4287137928 4287137928 4287137928 4287137928 4236806280 646482056 16777215 2508753032 4287137928 4287137928 4287137928 4287137928 4287137928 2726856840 16777215 16777215 495487112 4186474632 4287137928 4287137928 4287137928 4236806280 612927624 16777215 16777215 16777215 2542307464 4287137928 4287137928 4287137928 2676525192 16777215 16777215 16777215 16777215 478709896 4169697416 4287137928 4220029064 579373192 16777215 16777215 16777215 16777215 16777215 2424866952 4287137928 2626193544 16777215 16777215 16777215 16777215 16777215 16777215 394823816 4018702472 529041544 16777215 16777215 16777215 16777215 16777215 16777215 16777215 864585864 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!BlueUITheme methodsFor: 'initialize-release' stamp: 'TudorGirba 4/8/2011 01:06'!
newTreeUnexpandedForm
	"Answer a new form for an unexpanded tree item."

	^(Form
	extent: 9@9
	depth: 32
	fromArray: #( 1049135240 461932680 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2324203656 4152920200 2458421384 428378248 16777215 16777215 16777215 16777215 16777215 2357758088 4287137928 4287137928 4152920200 2408089736 394823816 16777215 16777215 16777215 2391312520 4287137928 4287137928 4287137928 4287137928 4119365768 2324203656 344492168 16777215 2408089736 4287137928 4287137928 4287137928 4287137928 4287137928 4287137928 3968370824 780699784 2391312520 4287137928 4287137928 4287137928 4287137928 4236806280 2659747976 529041544 16777215 2357758088 4287137928 4287137928 4253583496 2810742920 646482056 16777215 16777215 16777215 2324203656 4253583496 2777188488 696813704 16777215 16777215 16777215 16777215 16777215 1200130184 663259272 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 13:05'!
newWindowCloseForm
	"Answer a new form for a window close box."

	^ BlueUIThemeIcons windowCloseForm ! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 14:18'!
newWindowCloseOverForm
	"Answer a new form for a window menu box."

	^ self newWindowCloseForm! !

!BlueUITheme methodsFor: 'initialize-release' stamp: 'TudorGirba 4/8/2011 01:08'!
newWindowInactiveControlForm
	"Answer a new form for an inactive window control box."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291677645 4288585374 4286085240 4284243036 4284243036 4286085240 4288585374 4291677645 0 0 0 0 0 0 0 4289572269 4285756275 4286479998 4288716960 4289835441 4289835441 4288716960 4286479998 4285756275 4289572269 0 0 0 0 0 4289506476 4284835173 4287335307 4290559164 4292598747 4293322470 4293322470 4292598747 4290559164 4287335307 4284703587 4289506476 0 0 0 4291546059 4285493103 4286414205 4288980132 4291217094 4292335575 4292598747 4292598747 4292335575 4291282887 4288980132 4286282619 4285493103 4291546059 0 0 4288980132 4285361517 4287466893 4288782753 4289835441 4290295992 4290295992 4290427578 4290164406 4289835441 4288782753 4287466893 4285361517 4288980132 0 0 4286282619 4286611584 4288059030 4288716960 4289177511 4289572269 4289835441 4289835441 4289703855 4289374890 4288782753 4288059030 4286611584 4286282619 0 0 4285164138 4287664272 4288782753 4289374890 4289835441 4290427578 4290624957 4290624957 4290559164 4290032820 4289374890 4288914339 4287664272 4285164138 0 0 4285361517 4288322202 4289703855 4290295992 4290822336 4291414473 4291677645 4291677645 4291414473 4291085508 4290427578 4289703855 4288453788 4285624689 0 0 4287072135 4288716960 4290427578 4291217094 4291677645 4292203989 4292598747 4292598747 4292335575 4291809231 4291217094 4290427578 4288716960 4287203721 0 0 4288980132 4288256409 4290624957 4291677645 4292335575 4292927712 4293256677 4293256677 4293059298 4292598747 4291809231 4290822336 4288256409 4289177511 0 0 4291677645 4287664272 4290295992 4292006610 4293059298 4293454056 4293585642 4293585642 4293454056 4293125091 4292203989 4290427578 4287730065 4291677645 0 0 4293256677 4290032820 4288124823 4291217094 4292796126 4293322470 4293717228 4293717228 4293454056 4292927712 4291677645 4288256409 4290032820 4293256677 0 0 0 4293454056 4290032820 4288322202 4289967027 4291546059 4292598747 4292664540 4291677645 4290295992 4288716960 4290032820 4293454056 0 0 0 0 0 4293322470 4292203989 4289835441 4288782753 4288322202 4288453788 4288980132 4289835441 4292335575 4293322470 0 0 0 0 0 0 0 4293059298 4293585642 4293717228 4293585642 4293585642 4293585642 4293585642 4293059298 0 0 0 0)
	offset: 0@0)! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 13:06'!
newWindowMaximizeForm
	"Answer a new form for a window maximize box."

	^ BlueUIThemeIcons windowMaximizeForm! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 14:18'!
newWindowMaximizeOverForm
	"Answer a new form for a window menu box."

	^ self newWindowMaximizeForm! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 13:08'!
newWindowMenuForm
	"Answer a new form for a window menu box."

	^ BlueUIThemeIcons windowMenuForm! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 13:15'!
newWindowMenuPassiveForm
	"Answer a new form for a window menu box."

	^ BlueUIThemeIcons windowMenuInactiveForm! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 13:10'!
newWindowMinimizeForm
	"Answer a new form for a window minimize box."

	^ BlueUIThemeIcons windowMinimizeForm! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 15:09'!
newWindowMinimizeOverForm
	"Answer a new form for a window menu box."

	^ self newWindowMinimizeForm! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'tg 9/3/2010 14:50'!
plainGroupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a plain group panel."

	^SimpleBorder new
		width: 1;
		baseColor: Color transparent! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:51'!
progressBarFillStyleFor: aProgressBar
	^ self glamorousBasePassiveBackgroundColorFor: aProgressBar! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/7/2010 13:52'!
progressBarProgressFillStyleFor: aProgressBar
	^ (self glamorousLightSelectionColorFor: aProgressBar)! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 14:11'!
radioButtonForm
	"Answer the form to use for a normal radio button."

	^ BlueUIThemeIcons radioButtonUnselectedForm! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 14:11'!
radioButtonSelectedForm
	"Answer the form to use for a selected radio button."

	^ BlueUIThemeIcons radioButtonSelectedForm ! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 1/14/2010 03:10'!
resizerGripNormalFillStyleFor: aResizer
	"Return the normal fillStyle for the given resizer.
	For the moment, answer a transparent colour for no drawing,
	non transparent to draw as normal."
	
	^Color transparent! !

!BlueUITheme methodsFor: 'fill-styles-scrollbars' stamp: 'tg 9/4/2010 21:03'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	^ "(self glamorousBaseColorFor: aScrollbar) muchLighter"
	Color r: 245 g: 245 b: 245 range: 255! !

!BlueUITheme methodsFor: 'border-styles-scrollbars' stamp: 'TudorGirba 4/8/2011 00:01'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	^ BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!BlueUITheme methodsFor: 'fill-styles-scrollbars' stamp: 'tg 9/13/2010 10:50'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	^ (self glamorousNormalFillStyleWithBaseColor: aScrollbar paneColor for:  aScrollbar height: aScrollbar height)
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0])! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/4/2010 23:14'!
separatorFillStyleFor: aSeparator
	"Return the separator fillStyle for the given separator."
	
	^ SolidFillStyle color: (self glamorousBaseColorFor: aSeparator) darker! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:48'!
sliderDisabledFillStyleFor: aSlider
	"Return the disabled fillStyle for the given slider."
	
	^ self textEditorDisabledFillStyleFor: aSlider! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:41'!
splitterNormalFillStyleFor: aSplitter
	"Return the normal splitter fillStyle for the given splitter."
	
	^ SolidFillStyle color: Color transparent! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:41'!
splitterPressedFillStyleFor: aSplitter
	"Return the pressed splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := self glamorousBaseColorFor: aSplitter.
	^ (GradientFillStyle ramp: {0.0->aColor lighter. 0.9-> aColor})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!BlueUITheme methodsFor: 'basic-colors' stamp: 'tg 9/13/2010 10:36'!
subgroupColorFrom: paneColor
	"Answer the colour for a subgroup given the pane colour."

	^ self glamorousLightColorFor: paneColor" self class baseColor"! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'tg 8/31/2010 15:28'!
tabLabelNormalBorderStyleFor: aTabLabel
"	^SimpleBorder new
		width: 0;
		baseColor: (self buttonBaseColorFor: aTabLabel) darker
"	^ self buttonNormalBorderStyleFor: aTabLabel! !

!BlueUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 8/31/2010 11:13'!
tabLabelNormalFillStyleFor: aTabLabel
	^ self buttonNormalFillStyleFor: aTabLabel ! !

!BlueUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 8/31/2010 11:13'!
tabLabelSelectedFillStyleFor: aTabLabel
	^ self buttonSelectedFillStyleFor: aTabLabel ! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'StephaneDucasse 4/11/2011 22:31'!
tabPanelBorderStyleFor: aTabGroup
	^ ExtendedTabPanelBorder new 
		width: 1;
		baseColor: ((self glamorousDarkBaseColorFor: aTabGroup));
		tabSelector: aTabGroup tabSelectorMorph! !

!BlueUITheme methodsFor: 'basic-colors' stamp: 'tg 9/6/2010 15:03'!
taskbarButtonLabelColorFor: aButton
	"Answer the colour for the label of the given taskbar button."

	^aButton model
		ifNil: [super taskbarButtonLabelColorFor: aButton]
		ifNotNil: [:win |
			win isActive
				ifTrue: [Color black]
				ifFalse: [Color gray darker]]! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 8/31/2010 12:51'!
taskbarFillStyleFor: aTaskbar
	^ self buttonNormalFillStyleFor: aTaskbar! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'tg 9/4/2010 20:23'!
taskbarThumbnailCornerStyleFor: aMorph
	"Answer the corner style for the taskbar thumbnail/tasklist."
	
	^#square! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'tg 9/4/2010 20:56'!
taskbarThumbnailNormalBorderStyleFor: aWindow
	^ self buttonNormalBorderStyleFor: aWindow! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:46'!
textEditorDisabledFillStyleFor: aTextEditor
	"Return the disabled fillStyle for the given text editor."
	
	^self glamorousBasePassiveBackgroundColorFor: aTextEditor! !

!BlueUITheme methodsFor: 'border-styles' stamp: 'tg 9/4/2010 23:09'!
textEditorNormalBorderStyleFor: aTextEditor
	"Return the normal text editor borderStyle for the given text editor."

	^self buttonNormalBorderStyleFor: aTextEditor! !

!BlueUITheme methodsFor: 'basic-colors' stamp: 'TudorGirba 4/8/2011 00:02'!
treeLineWidth
	"Answer the width of the tree lines."

	^0! !

!BlueUITheme methodsFor: 'accessing' stamp: 'TudorGirba 4/7/2011 23:46'!
windowActiveDropShadowStyle: anObject
	"Set the value of windowActiveDropShadowStyle"
	windowActiveDropShadowStyle := anObject! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/13/2010 10:41'!
windowActiveFillStyleFor: aWindow
	"We do not want the lighting effect when the window goes inactive"
	^SolidFillStyle color: self class baseColor! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'TudorGirba 4/7/2011 23:53'!
windowActiveTitleFillStyleFor: aWindow
	^ "self glamorousNormalFillStyleFor: aWindow height: aWindow labelHeight"
	self windowActiveFillStyleFor: aWindow  ! !

!BlueUITheme methodsFor: 'label-styles' stamp: 'TudorGirba 4/8/2011 01:13'!
windowCloseOverForm
	"Answer the form to use for mouse over window close buttons"

	^self forms at: #windowCloseOver ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 13:17'!
windowClosePassiveForm
	"Answer the form to use for passive (background) window close buttons"

	^BlueUIThemeIcons windowCloseInactiveForm! !

!BlueUITheme methodsFor: 'fill-styles' stamp: 'tg 9/2/2010 13:52'!
windowInactiveFillStyleFor: aWindow
	"We do not want the lighting effect when the window goes inactive"
	^self windowActiveFillStyleFor: aWindow! !

!BlueUITheme methodsFor: 'label-styles' stamp: 'TudorGirba 4/8/2011 01:14'!
windowMaximizeOverForm
	"Answer the form to use for mouse over window maximize buttons"

	^self forms at: #windowMaximizeOver ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 13:18'!
windowMaximizePassiveForm
	"Answer the form to use for passive (background) window maximize/restore buttons"

	^BlueUIThemeIcons windowMaximizeInactiveForm! !

!BlueUITheme methodsFor: 'label-styles' stamp: 'tg 9/3/2010 10:52'!
windowMenuPassiveForm
	"Answer the form to use for passive (background) window menu buttons"

	^self newWindowMenuPassiveForm! !

!BlueUITheme methodsFor: 'label-styles' stamp: 'TudorGirba 4/8/2011 01:14'!
windowMinimizeOverForm
	"Answer the form to use for mouse over window minimize buttons"

	^self forms at: #windowMinimizeOver ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!BlueUITheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 13:18'!
windowMinimizePassiveForm
	"Answer the form to use for passive (background) window minimize buttons"

	^BlueUIThemeIcons windowMinimizeInactiveForm! !

!UITheme class methodsFor: 'query' stamp: 'gvc 12/1/2008 15:43'!
allThemeClasses
	"Answer the subclasses of the receiver that are considered to be
	concrete (useable as a theme)."

	^(self allSubclasses reject: [:c | c isAbstract]) asSortedCollection: [:a :b |
		a themeName <= b themeName]! !

!UITheme class methodsFor: 'query' stamp: 'gvc 6/22/2007 14:25'!
beCurrent
	"Make a new instance of the receiver be the current theme."

	self isAbstract ifTrue: [^self error: self name, ' is abstract, send #beCurrent to a subclass.'].
	self current: self newDefault! !

!UITheme class methodsFor: 'accessing' stamp: 'gvc 2/6/2007 11:43'!
builder
	"Answer a morph that has the TEasilyThemed trait."

	^Builder ifNil: [Builder := self newBuilder. Builder]! !

!UITheme class methodsFor: 'examples' stamp: 'StephaneDucasse 7/17/2010 13:23'!
closeExampleDialogs
	"Close the example dialogs."
	"self closeExampleDialogs"
	
	DialogWindow allSubInstances do: [:d | d cancel]! !

!UITheme class methodsFor: 'accessing' stamp: 'MarcusDenker 7/2/2011 12:24'!
current
	"Answer the current ui theme."

	^Current ifNil: [Current := PharoTheme newDefault. Current]! !

!UITheme class methodsFor: 'accessing' stamp: 'gvc 7/30/2009 18:26'!
current: aUITheme
	"Set the current ui theme."

	Current := aUITheme.
	UITheme allThemeClasses do: [:c | c changed: #isCurrent].
	SystemProgressMorph reset. "reset to use new fill styles"
	ScrollBar initializeImagesCache. "reset to use new arrows"
	aUITheme updateWorldDockingBars.
	World themeChanged! !

!UITheme class methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2009 10:27'!
currentAnimationSettings
	"Answer the current ui theme settings."

	^ self currentSettings animationSettings! !

!UITheme class methodsFor: 'accessing' stamp: 'AlainPlantec 12/13/2009 13:24'!
currentSettings
	"Answer the current ui theme settings."

	^ self current settings! !

!UITheme class methodsFor: 'accessing' stamp: 'gvc 10/16/2008 16:04'!
defaultSettings
	"Answer the default settings for the theme."
	
	^defaultSettings ifNil: [
		self defaultSettings: self newDefaultSettings.
		defaultSettings]! !

!UITheme class methodsFor: 'accessing' stamp: 'gvc 10/16/2008 16:05'!
defaultSettings: aThemeSettings
	"Set the default settings for the theme."
	
	defaultSettings := aThemeSettings! !

!UITheme class methodsFor: 'examples' stamp: 'GaryChambers 1/20/2011 12:14'!
exampleBasicControls
	"Open a window with examples of each of the basic controls."
	"self exampleBasicControls"
	
	|dialog builder radioModel treeModel|
	builder := self exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Example basic controls') useDefaultOKButton.
	radioModel := ExampleRadioButtonModel new.
	treeModel := ValueHolder new contents: TextStyle actualTextStyles explorerContents.
	dialog contentMorph: ((dialog newRow: {
		dialog newLabelGroup: {
			'Normal Label'->(dialog newLabel: 'A Label').
			'Disabled Label'->(dialog newLabel: 'A Disabled Label') disable.
			'Normal Button'->(dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button').
			'Default Button'->((dialog newButtonFor: nil action: nil label: 'Default Button' help: 'This is a default button') isDefault: true).
			'Disabled Button'->(dialog newButtonFor: nil action: nil label: 'Disabled Button'
							help: 'This is a disabled button') disable.
			'Selected Button'->(dialog newButtonFor: (ValueHolder new contents: true) getState: #contents
							action: nil arguments: #() getEnabled: nil label: 'A Button' help: 'This is a selected button').
			'Selected Disabled Button'->(dialog newButtonFor: (ValueHolder new contents: true) getState: #contents
							action: nil arguments: #() getEnabled: nil label: 'Disabled Button'
							help: 'This is a selected disabled button') disable.
			'Checkbox'->(dialog newCheckboxFor: (ValueHolder new contents: true)
							getSelected: #contents setSelected: #contents: label: 'A Checkbox' help: 'This is a checkbox').
			'Disabled Checkbox'->(dialog newCheckboxFor: (ValueHolder new contents: true)
							getSelected: #contents setSelected: #contents:
							label: 'A Disabled Checkbox' help: 'This is a disabled checkbox') disable.
			'Radio Buttons'->((dialog newColumn: {
								(dialog newRadioButtonFor: radioModel
									getSelected: #isLeft setSelected: #beLeft label: 'Left' help: 'This is a radio buton').
								(dialog newRadioButtonFor: radioModel
									getSelected: #isCenter setSelected: #beCenter label: 'Center' help: 'This is a radio buton').
								(dialog newRadioButtonFor: radioModel
									getSelected: #isRight setSelected: #beRight label: 'Right' help: 'This is a radio buton')})
								vResizing: #shrinkWrap).
			'Disabled Radio Button'->(dialog newRadioButtonFor: radioModel
									getSelected: #isRight setSelected: #beRight label: 'Right'
									help: 'This is a disabled radio buton') disable.
			'Text Entry'->(dialog newTextEntryFor: (ValueHolder new contents: 'Hello')
							getText: #contents setText: #contents: help: 'This is a text entry').
			'Disabled Text Entry'->(dialog newTextEntryFor: (ValueHolder new contents: 'Hello')
							getText: #contents setText: #contents: help: 'This is a disabled text entry') disable.
			'Slider'->(dialog newSliderFor: (ValueHolder new contents: 0.5)
							getValue: #contents setValue: #contents: help: 'This is a slider').
			'Disabled Slider'->(dialog newSliderFor: (ValueHolder new contents: 0.75)
							getValue: #contents setValue: #contents: help: 'This is a disabled slider') disable}.
			dialog newVerticalSeparator.
			dialog newLabelGroup: {
			'Drop List'->(dialog newDropListFor: (ListModel new list: #('One' 'Two' 'Three' 'Four'))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex: help: 'This is a drop list').
			'Disabled Drop List'->(dialog newDropListFor: (ListModel new list: #('One' 'Two' 'Three' 'Four'); selectionIndex: 3)
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a disabled drop list') disable.
			'Editable Drop List'->(dialog newEditableDropListFor: (ListModel new list: SortedCollection new)
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							addToList: #add: ghostText: 'Enter new items' getEnabled: nil help: 'This is an editable drop list').
			'Morph Drop List'->(dialog newMorphDropListFor: (ListModel new list: ({Color red. Color green. Color blue}
									collect: [:c | Morph new extent: 60@12; color: c]))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a morph drop list').
			'Normal List'->((dialog newListFor: (ListModel new list: #('One' 'Two' 'Three' 'Four'); selectionIndex: 3)
							list: #list selected: #selectionIndex changeSelected: #selectionIndex:
							help: 'This is a list') minWidth: 120).
			'Disabled List'->(dialog newListFor: (ListModel new list: #('One' 'Two' 'Three' 'Four'); selectionIndex: 3)
							list: #list selected: #selectionIndex changeSelected: #selectionIndex:
							help: 'This is a disabled list') disable.
			'Morph List'->(dialog newMorphListFor: (ListModel new list: ((Color red wheel: 20)
									collect: [:c | Morph new extent: 80@12; color: c]))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a morph list').
			'Tree'->((dialog newTreeFor: treeModel list: #contents selected: nil changeSelected: nil) minHeight: 100)}.
			dialog newVerticalSeparator.
			dialog newColumn: {
				dialog newTitle: 'Text Editor' for: (
					(dialog newTextEditorFor: (ValueHolder new contents: 'Hello')
						getText: #contents setText: #contents:) minWidth: 100).
				dialog newTitle: 'Disabled Text Editor' for: (
					(dialog newTextEditorFor: (ValueHolder new contents: 'Hello')
						getText: #contents setText: #contents:) disable)}})
			vResizing: #spaceFill);
		model: nil.
	builder openModal: dialog! !

!UITheme class methodsFor: 'examples' stamp: 'StephaneDucasse 2/12/2011 16:37'!
exampleBuilder
	"Answer a morph that implements TEasilyThemed but without honouring modality
	for the example dialogs."
	"self exampleBuilder"

	^ExampleBuilderMorph new! !

!UITheme class methodsFor: 'examples' stamp: 'StephaneDucasse 10/2/2009 16:18'!
exampleColorControls
	"Open a window with examples of each of the color controls."
	"self exampleColorControls"

	|dialog builder|
	builder := self exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Example color controls') useDefaultOKButton.
	dialog contentMorph: (dialog newRow: {
		dialog newLabelGroup: {
			'Alpha Selector'->(dialog newAlphaSelector: (ValueHolder new contents: 0)
							getAlpha: #contents setAlpha: #contents: help: 'This is an alpha channel selector').
			'Hue Selector'->(dialog newHueSelector: (ValueHolder new contents: 0)
							getHue: #contents setHue: #contents: help: 'This is a hue selector').
			'SV Color Selector'->((dialog newSVSelector: Color yellow
									help: 'This is a saturation-volume selector') minHeight: 80).
			'HSV Color Selector'->((dialog newHSVSelector: Color green
									help: 'This is a hue-saturation-volume selector') minHeight: 80; minWidth: 120)}.
		dialog newVerticalSeparator.
		dialog newTitle: 'HSVA Color Selector' for:
			((dialog newHSVASelector: Color cyan
					help: 'This is a hue-saturation-volume-alpha selector')
					minHeight: 184; minWidth: 184)});
		model: nil.
	builder openModal: dialog! !

!UITheme class methodsFor: 'examples' stamp: 'StephaneDucasse 10/2/2009 16:18'!
exampleDialogs
	"Open an example of each services dialog.
	(self exampleDialogs)."
	"self exampleDialogs"

	self exampleBuilder
		chooseFont: TextStyle default defaultFont;
		chooseColor: (Color r: 0.529 g: 0.611 b: 0.004);
		chooseDirectory: 'Choose folder';
		chooseFileName: 'Pick a file name' extensions: nil path: nil preview: nil;
		textEntry: 'Choose a name for the project' title: 'Save project' entryText: 'My Project';
		chooseDropList: 'Pick one!!' list: #('One' 'Two' 'Three' 'Four');
		deny: 'Opening the safe is not possible!!';
		message: 'Hello!!';
		proceed: 'Save image?';
		alert: 'Danger!!';
		abort: 'Something has gone wrong...';
		question: 'Save the file?' title: 'Exiting application';
		questionWithoutCancel: 'Save image as well?' title: 'Exiting application'! !

!UITheme class methodsFor: 'examples' stamp: 'GaryChambers 1/20/2011 12:10'!
exampleGroups
	"Open a window with examples of each of the group type morphs."

	|dialog builder|
	builder := self exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Example groups') useDefaultOKButton.
	dialog contentMorph: ((dialog newRow: {
		dialog newLabelGroup: {
			'Plain Groupbox'->(dialog newGroupboxForAll: {
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'.
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'}).
			'Groupbox'->(dialog newGroupbox: 'A groupbox' forAll: {
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'.
				dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'})}.
		dialog newLabelGroup: {
			'Tab Group'->(dialog newTabGroup: {
				(dialog newRow: {dialog newImage: self current smallLeftFlushIcon. dialog newLabel: 'Page 1'})->
					(dialog newGroupbox: 'A groupbox' forAll: {
						dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'.
						dialog newButtonFor: nil action: nil label: 'A Button' help: 'This is a button'}).
				'Page 2'->(dialog newCheckboxFor: (ValueHolder new contents: true)
							getSelected: #contents setSelected: #contents: label: 'A Checkbox'
							help: 'This is a checkbox')})}})
		vResizing: #spaceFill);
		model: nil.
	builder openModal: dialog! !

!UITheme class methodsFor: 'examples' stamp: 'GaryChambers 1/20/2011 12:05'!
exampleOtherControls
	"Open a window with examples of each of the other controls."
	"self exampleOtherControls"
	
	|dialog builder image emboss fuzzy|
	builder := self exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Example other controls') useDefaultOKButton.
	emboss := (dialog newString: 'Hello there') trackPaneColor: false.
	fuzzy := (dialog newFuzzyLabel: 'A Fuzzy Label') minHeight: 40; minWidth: 160.
	dialog contentMorph: (dialog newRow: {
		dialog newTitle: 'Alpha Image' for: (
			dialog newColumn: {
				((image := dialog newAlphaImage: nil help: 'This is an alpha image')
					borderWidth: 1;
					extent: 160@160).
				dialog newLabelGroup: {
				'Scale'->(dialog newSliderFor: image getValue: #scale setValue: #scale:
					min: 0 max: 4 quantum: nil
					getEnabled: nil help: 'The image scale 0..1').
				'Alpha'->((dialog newAlphaSelector: image getAlpha: #alpha setAlpha: #alpha: help: 'The image alpha')
					vResizing: #shrinkWrap;
					minHeight: 16).
				'Layout'->(dialog newDropListFor: image list: #layoutSymbols
					getSelected: #layout setSelected: #layout:
					getEnabled: nil useIndex: false help: 'The image layout')}}).
		dialog newVerticalSeparator.
		dialog newLabelGroup: {
			'Color presenter'->((dialog newColorPresenterFor: (ValueHolder new contents: (Color blue alpha: 0.6))
					getColor: #contents help: 'This is a color presenter')
					vResizing: #shrinkWrap).
			'Color chooser'->(dialog newColorChooserFor: emboss
					getColor: #color setColor: #color: help: 'This is a color chooser').
			'Row with dashed border'->((dialog newRow: {dialog newLabel: 'I have a dashed border!!'})
					borderStyle: (DashedBorder width: 3
							dashColors: {Color red. Color green. Color blue} dashLengths: #(1 2 3))).
			'Embossed string'->emboss.
			'Style'->(dialog newDropListFor: emboss list: #styleSymbols
					getSelected: #style setSelected: #style:
					getEnabled: nil useIndex: false help: 'The embossed string style').
			'Fuzzy label'->fuzzy.
			'Offset'->(dialog newSliderFor: fuzzy getValue: #offset setValue: #offset:
					min: 0 max: 5 quantum: 1
					getEnabled: nil help: 'The fuzzy label offset').
			'Alpha'->((dialog newAlphaSelector: fuzzy getAlpha: #alpha setAlpha: #alpha:
					help: 'The fuzzy label alpha')
					vResizing: #shrinkWrap;
					minHeight: 16)}.
		dialog newVerticalSeparator.
		dialog newTitle: 'Expanders' for: (
			(dialog newColumn: {
				(dialog newExpander: 'An Expander' forAll: {
					dialog newLabel: 'Expanded!!'.
					builder newMorphListFor: (ListModel new list: ((Color red wheel: 15)
									collect: [:c | Morph new extent: 80@12; color: c]))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a morph drop list'}) minWidth: 100.
				dialog newExpander: 'Another' forAll: {
					dialog newLabel: 'Expanded!!'.
					builder newMorphDropListFor: (ListModel new list: ((Color red wheel: 8)
									collect: [:c | Morph new extent: 80@12; color: c]))
							list: #list getSelected: #selectionIndex setSelected: #selectionIndex:
							help: 'This is a morph drop list'}})
				cellInset: 0;
				borderStyle: (BorderStyle inset baseColor: dialog paneColor; width: 1))});
		model: nil.
	builder openModal: dialog! !

!UITheme class methodsFor: 'examples' stamp: 'AlainPlantec 10/19/2010 21:21'!
exampleWindowWithToolbars
	"Open an example window with toolbars."
	"self exampleWindowWithToolbars"

	|win fileMenu tools dock text holder|
	win := StandardWindow new.
	fileMenu := win newMenu.
	fileMenu
		addToggle: 'Open' translated
		target: nil "would be model"
		selector: #openFile.
	fileMenu lastItem
		font: win theme menuFont;
		icon: win theme smallOpenIcon;
		keyText: 'Ctrl+O'.
	fileMenu
		addToggle: 'Save' translated
		target: nil
		selector: #saveFile
		getStateSelector: nil
		enablementSelector: nil.
	fileMenu lastItem
		font: win theme menuFont;
		keyText: 'Ctrl+S'.
	fileMenu
		addToggle: 'Print...' translated
		target: nil
		selector: #print.
	fileMenu lastItem
		font: win theme menuFont;
		icon: win theme smallPrintIcon;
		keyText: 'Ctrl+P'.
	tools := win newToolbar: {win
			newButtonFor: nil "if we had a model it would go here"
			getState: nil
			action: #openFile
			arguments: nil
			getEnabled: nil
			labelForm: win theme smallOpenIcon
			help: 'Open file' translated.
		win
			newButtonFor: nil
			getState: nil
			action: #saveFile
			arguments: nil
			getEnabled: nil
			labelForm: win theme smallSaveIcon
			help: 'Save file' translated.
		win
			newButtonFor: nil
			getState: nil
			action: #print
			arguments: nil
			getEnabled: nil
			labelForm: win theme smallPrintIcon
			help: 'Print' translated}.
		holder := StringHolder new.
		text := win
			newTextEditorFor: holder
			getText:  #contents
			setText: #contents:
			getEnabled: nil.
		dock := win newToolDockingBar.
		dock
			add: 'File' translated
			font: win theme menuBarFont
			icon: win theme smallOpenIcon
			help: 'File operations' translated
			subMenu: fileMenu;
			addMorphBack: tools.
		win
			addMorph: dock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0 @ dock minExtent y));
			addMorph: text
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@dock minExtent y corner: 0 @ 0)).
		win
			themeChanged;
			openInWorld
		
		! !

!UITheme class methodsFor: 'initialize-release' stamp: 'StephaneDucasse 10/9/2010 08:15'!
initialize
	"self initialize"
	self current class = UITheme
		ifTrue: [self current: nil
			"due to change to being abstract"].
	Smalltalk addToStartUpList: self! !

!UITheme class methodsFor: 'testing' stamp: 'gvc 6/22/2007 14:24'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^true! !

!UITheme class methodsFor: 'testing' stamp: 'gvc 6/22/2007 15:19'!
isCurrent
	"Answer whether an instance of the receiver is the current theme."

	^Current class == self! !

!UITheme class methodsFor: 'accessing' stamp: 'gvc 2/6/2007 11:44'!
newBuilder
	"Answer a new builder morph."

	^ComposableMorph new! !

!UITheme class methodsFor: 'accessing' stamp: 'gvc 8/24/2006 18:28'!
newDefault
	"Answer a new default ui theme."

	^self new! !

!UITheme class methodsFor: 'accessing' stamp: 'MarcusDenker 9/27/2010 15:31'!
newDefaultSettings
	"Answer a new original default settings."

	^ThemeSettings new
		buttonColor: Color gray;
		scrollbarColor: Color gray;
		yourself! !

!UITheme class methodsFor: 'accessing' stamp: 'AlainPlantec 5/14/2010 16:12'!
resetAllDefaultSettings
	"Reset the default settings of all themes"
	"self resetAllDefaultSettings"
	self withAllSubclassesDo: [:cls | cls defaultSettings: nil]! !

!UITheme class methodsFor: 'accessing' stamp: 'gvc 10/16/2008 16:16'!
resetDefaultSettings
	"Reset the default settings to use the original values."

	self defaultSettings: nil! !

!UITheme class methodsFor: 'accessing' stamp: 'MarcusDenker 7/2/2011 12:24'!
standardThemeClass
	^ PharoTheme ! !

!UITheme class methodsFor: 'accessing' stamp: 'gvc 5/10/2007 10:14'!
startUp
	"Reset the system progress morph in case of font changes."

	SystemProgressMorph reset! !

!UITheme class methodsFor: 'examples' stamp: 'AlainPlantec 11/27/2010 16:29'!
textEntryWithCompletionDialog
	"self textEntryWithCompletionDialog"
	| applicants entryCompletion |
	applicants := (Array
				streamContents: [:strm | Symbol
						allSymbolTablesDo: [:each | (each notEmpty
									and: [each first canBeGlobalVarInitial
											and: [Smalltalk globals includesKey: each]])
								ifTrue: [strm nextPut: each]]]) sort.
	entryCompletion := EntryCompletion new
				dataSourceBlock: [:currText | applicants];
				
				filterBlock: [:currApplicant :currText | currText size > 3
						and: [currApplicant asUppercase includesSubString: currText asString asUppercase]].
	UIManager default
		request: 'Enter a class name fragment (at least 4 characters)'
		initialAnswer: ''
		title: 'Text entry with completion example: simple find a class'
		entryCompletion: entryCompletion! !

!UITheme class methodsFor: 'accessing' stamp: 'gvc 6/22/2007 15:18'!
themeName
	"Answer the friendly name of the theme."

	self subclassResponsibility! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:14'!
abortIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of an error dialog (true) with the given label and title."

	self abortSound play.
	^(aThemedMorph openModal: (
		ErrorDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:45'!
abortSound
	"Answer the abort sound."

	^self soundTheme abortSound! !

!UITheme methodsFor: 'services' stamp: 'HenrikSperreJohansen 1/21/2011 14:23'!
alertIn: aThemedMorph text: aStringOrText title: aString configure: aBlock
	"Answer the result of an alert dialog (true) with the given label and title."

	|dialog|
	SoundTheme useThemeSounds ifTrue: [self alertSound play].
	dialog := AlertDialogWindow new
		textFont: self textFont;
		title: aString;
		text: aStringOrText.
	aBlock value: dialog.
	aThemedMorph openModal: dialog.
	^dialog cancelled not! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:45'!
alertSound
	"Answer the alert sound."

	^self soundTheme alertSound! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
backIcon
	^ ThemeIcons backIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
backspaceArrowIcon
	^ ThemeIcons backspaceArrowIcon! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 11/27/2010 20:36'!
basicCreateArrowOfDirection: aSymbolDirection size: finalSizeInteger color: aColor 
	"PRIVATE - create an arrow with aSymbolDirectionDirection,  
	finalSizeInteger and aColor.
	aSymbolDirectionDirection = #top, #bottom. #left or #right .
	Try with:  
	(UITheme current
		basicCreateArrowOfDirection: #top 
		size: 32 
		color: Color lightGreen) asMorph openInHand. 
	Fixed to work with translucent colours."
	
	|form resizeFactor arrow resizedForm |
	resizeFactor := 4.
	form := Form
		extent: finalSizeInteger asPoint * resizeFactor
		depth: Display depth.
	form fillColor: Color transparent.
	arrow := (self createArrowOfDirection: aSymbolDirection in: form boundingBox)
		borderWidth: 1;
		borderColor: aColor lighter.
	self
		updateScrollBarButtonAspect: arrow
		color: (aColor alphaMixed: 0.7 with: Color black).
	arrow fullDrawOn: form getCanvas.
	resizedForm := form
		magnify: form boundingBox
		by: 1 / resizeFactor
		smoothing: 4.
	^resizedForm trimBordersOfColor: Color transparent! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
blankIcon
	^ ThemeIcons blankIcon! !

!UITheme methodsFor: 'icons-utilities' stamp: 'AlainPlantec 10/19/2010 20:44'!
blankIconOfWidth: aNumber 
	^ ThemeIcons blankIconOfWidth: aNumber ! !

!UITheme methodsFor: 'accessing' stamp: 'FernandoOlivero 4/12/2011 09:43'!
builder
	^ self class builder! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 4/16/2007 12:57'!
buttonColorFor: aButton
	"Answer the colour for the given button."

	^self settings standardColorsOnly
		ifTrue: [self settings buttonColor]
		ifFalse: [aButton colorToUse]! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'MarcusDenker 12/11/2009 09:35'!
buttonCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^aThemedMorph
		ifNil: [#square]
		ifNotNil: [:tm | 
			tm preferredButtonCornerStyle
				ifNil: [tm preferredCornerStyle]
				ifNotNil: [:bcs | bcs]]! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 17:27'!
buttonDisabledBorderStyleFor: aButton
	"Return the disabled button borderStyle for the given button."

	^self buttonNormalBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/26/2007 09:58'!
buttonDisabledFillStyleFor: aButton
	"Return the disabled button fillStyle for the given color."

	^self buttonNormalFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 12/4/2007 16:22'!
buttonFocusBoundsFor: aButton
	"Answer the bounds for drawing the focus indication for the
	given button."

	^(aButton bounds extent min < 6)
		ifTrue: [aButton bounds]
		ifFalse: [aButton bounds insetBy: aButton borderWidth + 
					(aButton label isMorph ifTrue: [1] ifFalse: [2])]! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 1/9/2009 17:45'!
buttonFocusIndicatorCornerRadiusFor: aButton
	"Answer the default corner radius preferred for the focus indicator
	for the button for themes that support this."

	^self focusIndicatorCornerRadiusFor: aButton! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 11/29/2009 21:36'!
buttonFont
	"Answer the button font to use."

	^StandardFonts buttonFont! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 3/6/2010 15:50'!
buttonLabelFor: aButton
	"Answer the label to use for the given button."

	|label|
	label := self buttonLabelForText: aButton label.
	(label respondsTo: #enabled:) ifTrue: [
		label enabled: aButton enabled].
	label font: self buttonFont.
	^label! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 6/15/2009 13:00'!
buttonLabelForText: aTextOrString
	"Answer the label to use for the given text."

	^aTextOrString isString
		ifTrue: [(LabelMorph contents: aTextOrString)
					disabledStyle: self disabledItemStyle]
		ifFalse: [|t|
				t := TextMorph new newContents: aTextOrString.
				t
					extent: t optimalExtent;
					margins: (0@0 corner: 0@1);
					lock]! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 12/5/2008 14:56'!
buttonLabelInsetFor: aButton
	"Answer the inset to use for a button's label."

	^2! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 12/3/2008 17:22'!
buttonMinHeight
	"Answer the minumum height of a button for this theme."
	
	^16! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 12/3/2008 17:22'!
buttonMinWidth
	"Answer the minumum width of a button for this theme."
	
	^16! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 3/23/2007 17:16'!
buttonMouseOverBorderStyleFor: aButton
	"Return the mouse over button borderStyle for the given button."
	
	^self buttonNormalBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:54'!
buttonMouseOverFillStyleFor: aButton
	"Return the button mouse over fillStyle for the given color."

	^self buttonNormalFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 17:25'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	|c|
	c := aButton colorToUse.
	aButton isDefault
		ifTrue: [c := c alphaMixed: 0.5 with: Color black].
	^BorderStyle simple
		width: 1;
		baseColor: c! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:24'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	^self buttonColorFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 15:06'!
buttonPanelNormalFillStyleFor: aPanel
	"Return the normal panel fillStyle for the given panel."
	
	^aPanel paneColor! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 18:12'!
buttonPressedBorderStyleFor: aButton
	"Return the pressed button borderStyle for the given button."

	^self buttonSelectedBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:52'!
buttonPressedFillStyleFor: aButton
	"Return the button pressed fillStyle for the given color."
	
	^self buttonMouseOverFillStyleFor: aButton! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 6/8/2009 14:20'!
buttonPressedLabelInsetFor: aButton
	"Answer the inset to use for a button's label when pressed."

	^self buttonLabelInsetFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 17:27'!
buttonSelectedBorderStyleFor: aButton
	"Return the selected button borderStyle for the given button."

	^self buttonNormalBorderStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 4/25/2007 17:29'!
buttonSelectedDisabledBorderStyleFor: aButton
	"Return the selecteddisabled button borderStyle for the given button."

	^self buttonSelectedBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:53'!
buttonSelectedDisabledFillStyleFor: aButton
	"Return the button selected disabled fillStyle for the given color."
	
	^self buttonSelectedFillStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:53'!
buttonSelectedFillStyleFor: aButton
	"Return the button selected fillStyle for the given color."
	
	^self buttonNormalFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 3/23/2007 17:19'!
buttonSelectedMouseOverBorderStyleFor: aButton
	"Return the selected mouse over button borderStyle for the given button."

	^self buttonSelectedBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:53'!
buttonSelectedMouseOverFillStyleFor: aButton
	"Return the button selected mouse over fillStyle for the given color."
	
	^self buttonSelectedFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 3/23/2007 17:19'!
buttonSelectedPressedBorderStyleFor: aButton
	"Return the selected pressed button borderStyle for the given button."

	^self buttonNormalBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:52'!
buttonSelectedPressedFillStyleFor: aButton
	"Return the button selected pressed fillStyle for the given color."

	^self buttonSelectedMouseOverFillStyleFor: aButton! !

!UITheme methodsFor: 'services' stamp: 'BenjaminVanRyseghem 5/13/2011 14:19'!
centeredAlertIn: aThemedMorph text: aStringOrText title: aString configure: aBlock
	"Answer the result of an alert dialog (true) with the given label and title."

	|dialog|
	SoundTheme useThemeSounds ifTrue: [self alertSound play].
	dialog := AlertDialogWindow new
		textFont: self textFont;
		title: aString;
		text: aStringOrText.
	aBlock value: dialog.
	aThemedMorph openModal: dialog.
	dialog left: ((World width / 2) - (dialog width /2)).
	dialog top: ((World height / 2) - (dialog height /2)).
	^dialog cancelled not! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
checkBoxOffIcon
	^ ThemeIcons checkBoxOffIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
checkBoxOnIcon
	^ ThemeIcons checkBoxOnIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
checkBoxPressedIcon
	^ ThemeIcons checkBoxPressedIcon! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 5/23/2007 12:26'!
checkboxButtonDisabledBorderStyleFor: aCheckboxButton
	"Return the disabled checkbox button borderStyle for the given button."

	^BorderStyle simple
		width: 1;
		baseColor: aCheckboxButton paneColor darker! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 5/23/2007 12:17'!
checkboxButtonDisabledFillStyleFor: aCheckboxButton
	"Return the disabled checkbox button fillStyle for the given button."
	
	^aCheckboxButton paneColor
		alphaMixed: 0.3
		with: Color white! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 5/23/2007 12:28'!
checkboxButtonNormalBorderStyleFor: aCheckboxButton
	"Return the normal checkbox button borderStyle for the given button."

	^BorderStyle simple
		width: 1;
		baseColor: aCheckboxButton paneColor twiceDarker! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 5/23/2007 12:03'!
checkboxButtonNormalFillStyleFor: aCheckboxButton
	"Return the normal checkbox button fillStyle for the given button."
	
	^Color white! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 2/29/2008 22:00'!
checkboxButtonSelectedBorderStyleFor: aCheckboxButton
	"Return the selected checkbox button borderStyle for the given button."

	^self checkboxButtonNormalBorderStyleFor: aCheckboxButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 2/29/2008 22:00'!
checkboxButtonSelectedDisabledBorderStyleFor: aCheckboxButton
	"Return the selected disabled checkbox button borderStyle for the given button."

	^self checkboxButtonDisabledBorderStyleFor: aCheckboxButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 2/29/2008 21:47'!
checkboxButtonSelectedDisabledFillStyleFor: aCheckboxButton
	"Return the selected disabled checkbox button fillStyle for the given button."
	
	^self checkboxButtonDisabledFillStyleFor: aCheckboxButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 2/29/2008 21:48'!
checkboxButtonSelectedFillStyleFor: aCheckboxButton
	"Return the selected checkbox button fillStyle for the given button."
	
	^self checkboxButtonNormalFillStyleFor: aCheckboxButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 12/8/2008 19:17'!
checkboxCornerStyleFor: aCheckbox
	"Answer the corner style for checkbox buttons."
	
	^#square! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 8/2/2007 16:01'!
checkboxLabelFor: aCheckbox
	"Answer the label to use for the given checkbox."

	^self checkboxLabelForText: aCheckbox label! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 6/15/2009 12:58'!
checkboxLabelForText: aTextOrString
	"Answer the label to use for the given text."

	|morph|
	morph := aTextOrString isString
		ifTrue: [(LabelMorph contents: aTextOrString)
				disabledStyle: self disabledItemStyle]
		ifFalse: [|t|
				t := TextMorph new newContents: aTextOrString.
				t extent: t optimalExtent].
	^morph 
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		lock! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 10/25/2007 17:06'!
checkboxMarkerForm
	"Answer the form to use for a checkbox marker."

	^self forms at: #checkboxMarker ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UITheme methodsFor: 'services' stamp: 'gvc 9/22/2006 11:01'!
chooseColorIn: aThemedMorph title: aString color: aColor
	"Answer the result of a color selector dialog with the given title and initial color."

	|d|
	d := aThemedMorph openModal: (
		ColorSelectorDialogWindow new
			title: aString;
			selectedColor: aColor).
	^d  cancelled
		ifFalse: [d selectedColor]! !

!UITheme methodsFor: 'services' stamp: 'StephaneDucasse 6/5/2011 22:41'!
chooseColorIn: aThemedMorph title: aString color: aColor for: aBlock
	"execute block with result of a color selector dialog with the given title and initial color."

	|d newColor |
	
	d := ColorSelectorDialogWindow new
			title: aString;
			selectedColor: aColor.
	d extent: d initialExtent.
	d announcer on: ColorChanged do: [:ann | 
		aBlock value: ann newColor].
	
	d openInHand.
	self runModal: d.
	
	newColor := d  cancelled
		ifTrue: [aColor]
		ifFalse: [d selectedColor].
				
	aBlock value: newColor.! !

!UITheme methodsFor: 'services' stamp: 'gvc 1/15/2007 14:44'!
chooseDirectoryIn: aThemedMorph title: title path: path
	"Answer the result of a file dialog with the given title, choosing directories only."

	|fd|
	fd := FileDialogWindow basicNew
		initialize;
		title: title;
		answerDirectory.
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 1/12/2007 14:21'!
chooseDropListIn: aThemedMorph text: aStringOrText title: aString list: aList
	"Answer the result of a drop list chooser with the given label, title and list."

	^(aThemedMorph openModal: (
		ChooseDropListDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText;
			list: aList)) selectedItem! !

!UITheme methodsFor: 'services' stamp: 'gvc 4/4/2007 16:07'!
chooseFileIn: aThemedMorph title: title extensions: exts path: path preview: preview
	"Answer the result of a file open dialog with the given title, extensions path and preview type.
	Answer nil or a filename."

	|fd|
	fd := FileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerFileEntry.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 4/4/2007 16:07'!
chooseFileNameIn: aThemedMorph title: title extensions: exts path: path preview: preview
	"Answer the result of a file name chooser dialog with the given title, extensions
	path and preview type.
	Answer nil or a filename."

	|fd|
	fd := FileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerFileName.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'GaryChambers 12/17/2010 11:27'!
chooseFileNameIn: aThemedMorph title: title patterns: patterns path: path preview: preview
	"Answer the result of a file name chooser dialog with the given title, patterns
	path and preview type.
	Answer nil or a filename."

	|fd|
	fd := FileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerFileName.
	patterns ifNotNil: [
		fd fileSelectionBlock: [:de |
			(fd defaultFileSelectionBlock value: de) and: [
				de isDirectory or: [patterns anySatisfy: [:pat | pat match: de name]]]]].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 9/26/2008 14:36'!
chooseFontIn: aThemedMorph title: aString font: aFont
	"Answer the result of a font selector dialog with the given title and initial font."

	|d|
	d := aThemedMorph openModal: (
		Cursor wait showWhile: [
			self newFontSelector
				title: aString;
				selectedFont: aFont]).
	^d  cancelled
		ifFalse: [d selectedFont]! !

!UITheme methodsFor: 'services' stamp: 'GaryChambers 7/12/2011 10:22'!
chooseFullFileNameIn: aThemedMorph title: title extensions: exts path: path preview: preview
	"Answer the result of a file name chooser dialog with the given title, extensions
	path and preview type.
	Answer nil or a full filename."

	|fd|
	fd := FileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerPathName.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'CarloTeixeira 5/23/2011 15:35'!
chooseFullFileNameIn: aThemedMorph title: title patterns: patterns path: path preview: preview
	"Answer the result of a file name chooser dialog with the given title, patterns
	path and preview type.
	Answer nil or a filename."

	|fd|
	fd := FileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerPathName.
	patterns ifNotNil: [
		fd fileSelectionBlock: [:de |
			(fd defaultFileSelectionBlock value: de) and: [
				de isDirectory or: [patterns anySatisfy: [:pat | pat match: de name]]]]].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 1/17/2007 15:48'!
chooseIn: aThemedMorph title: title labels: labels values: values lines: lines
	"Answer the result of a popup choice with the given title, labels, values and lines."

	|pd|
	pd := PopupChoiceDialogWindow new
		title: (title isEmpty ifTrue: ['Choose' translated] ifFalse: [title asString]);
		labels: labels;
		lines: (lines ifNil: [#()]);
		model: values.
	^(aThemedMorph openModal: pd) choice! !

!UITheme methodsFor: 'services' stamp: 'alain.plantec 2/6/2009 10:06'!
chooseIn: aThemedMorph title: title message: aMessage labels: labels values: values lines: lines
	"Answer the result of a popup choice with the given title, labels, values and lines."

	|pd|
	pd := PopupChoiceDialogWindowWithMessage  new
		title: (title isEmpty ifTrue: ['Choose' translated] ifFalse: [title asString]);
		textFont: self textFont;
		message: aMessage;
		labels: labels;
		lines: (lines ifNil: [#()]);
		model: values.
	^(aThemedMorph openModal: pd) choice! !

!UITheme methodsFor: 'services' stamp: 'EstebanLorenzano 11/21/2009 16:51'!
chooseOrRequestIn: aThemedMorph title: title labels: labels values: values lines: lines
	"Answer the result of a popup choice with the given title, labels, values and lines."

	| dialog choice |
	dialog := PopupChoiceOrRequestDialogWindow new
		title: (title isEmpty ifTrue: ['Choose' translated] ifFalse: [title asString]);
		labels: labels;
		lines: (lines ifNil: [#()]);
		model: values.
	choice := (aThemedMorph openModal: dialog) choice.
	dialog cancelled ifTrue: [ ^nil ].
	choice 
		ifNotNil: [ ^choice ]
		ifNil: [ ^dialog filterValue ]! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
configurationIcon
	^ ThemeIcons configurationIcon! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 6/1/2009 12:20'!
configureDialogWindowLabelAreaFrameFor: aWindow
	"Configure the layout frame for the label area for the given dialog window."

	|frame|
	self configureWindowLabelAreaFrameFor: aWindow.
	aWindow labelArea ifNil: [^ self].	
	frame := aWindow labelArea layoutFrame.
	frame
		leftOffset: 0;
		rightOffset: 0! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 6/2/2009 11:30'!
configureWindowBorderFor: aWindow
	"Configure the border for the given window."

	aWindow roundedCorners: #(1 2 3 4).
	aWindow borderStyle: (BorderStyle
		width: 1 color: Color lightGray)! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/9/2009 17:12'!
configureWindowDropShadowFor: aWindow
	"Configure the drop shadow for the given window."

	aWindow
		addDropShadow;
		shadowColor: self windowShadowColor;
		shadowOffset: 1@1! !

!UITheme methodsFor: 'label-styles' stamp: 'MarcusDenker 12/11/2009 07:43'!
configureWindowLabelAreaFor: aWindow
	"Configure the label area for the given window."

	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow hasCloseBox ifTrue: [aWindow addCloseBox].
	aWindow hasMenuBox ifTrue: [aWindow addMenuControl].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow basicLabel ifNotNil: [:label |
		label hResizing: #spaceFill.
		aWindow labelArea addMorphBack: label].
	aWindow hasExpandBox ifTrue: [aWindow addExpandBox].
	aWindow hasCollapseBox ifTrue: [aWindow addCollapseBox].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0)! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 6/1/2009 12:05'!
configureWindowLabelAreaFrameFor: aWindow
	"Configure the layout frame for the label area for the given window."

	|frame windowBorderWidth|
	aWindow labelArea ifNil: [^ self].	
	windowBorderWidth := aWindow class borderWidth.
	aWindow labelArea
		layoutPolicy: RowLayout new;
		cellPositioning: #topCenter;
		hResizing: #spaceFill;
		wrapCentering: #topLeft;
		layoutInset: (0@windowBorderWidth corner: 0@1).
	frame := LayoutFrame
		fractions: (0@0 corner: 1@0)
		offsets: (0 @ (aWindow labelHeight negated)
					corner: 0 @ 0).
	aWindow labelArea layoutFrame: frame! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
confirmIcon
	^ ThemeIcons confirmIcon! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 11/13/2007 11:33'!
controlButtonDisabledBorderStyleFor: aButton
	"Return the disabled control button borderStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."

	^self buttonDisabledBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 11/13/2007 11:29'!
controlButtonDisabledFillStyleFor: aButton
	"Return the disabled control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonDisabledFillStyleFor: aButton! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 12/5/2008 16:54'!
controlButtonLabelInsetFor: aButton
	"Answer the inset to use for a control button's label."

	^self buttonLabelInsetFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 11/13/2007 11:33'!
controlButtonMouseOverBorderStyleFor: aButton
	"Return the mouse over control button borderStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."

	^self buttonMouseOverBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 11/13/2007 11:29'!
controlButtonMouseOverFillStyleFor: aButton
	"Return the mouse over control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonMouseOverFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 11/13/2007 11:32'!
controlButtonNormalBorderStyleFor: aButton
	"Return the normal control button borderStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."

	^self buttonNormalBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 10/28/2007 16:53'!
controlButtonNormalFillStyleFor: aButton
	"Return the normal control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonNormalFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 11/13/2007 11:58'!
controlButtonPressedBorderStyleFor: aButton
	"Return the pressed control button borderStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."

	^self buttonPressedBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 11/13/2007 11:59'!
controlButtonPressedFillStyleFor: aButton
	"Return the pressed button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonPressedFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 11/13/2007 11:33'!
controlButtonSelectedDisabledBorderStyleFor: aButton
	"Return the selected disabled control button borderStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."

	^self buttonSelectedDisabledBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 11/13/2007 11:30'!
controlButtonSelectedDisabledFillStyleFor: aButton
	"Return the selected disabled control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonSelectedDisabledFillStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 12/9/2008 13:05'!
controlButtonSelectedFillStyleFor: aButton
	"Return the selected control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonSelectedFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 11/13/2007 11:34'!
controlButtonSelectedMouseOverBorderStyleFor: aButton
	"Return the selected mouse over control button borderStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."

	^self buttonSelectedMouseOverBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 11/13/2007 11:30'!
controlButtonSelectedMouseOverFillStyleFor: aButton
	"Return the selected mouse over control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonSelectedMouseOverFillStyleFor: aButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 11/13/2007 11:34'!
controlButtonSelectedPressedBorderStyleFor: aButton
	"Return the selected pressed control button borderStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."

	^self buttonSelectedPressedBorderStyleFor: aButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 11/13/2007 11:31'!
controlButtonSelectedPressedFillStyleFor: aButton
	"Return the selected pressed button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonSelectedPressedFillStyleFor: aButton! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:25'!
createArrowImagesCache
	"creates the cache to store the arrow forms"
	^ LRUCache
		size: 40
		factory: [:key | ""
			self
				scrollbarArrowOfDirection: key first
				size: key second
				color: key third]! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 5/7/2010 23:01'!
createArrowOfDirection: aSymbol in: aRectangle 
	"PRIVATE - create an arrow bounded in aRectangle"

	| arrow vertices |
	vertices := self scrollBarButtonArrowVertices: aRectangle.
	""
	arrow := PolygonMorph 
				vertices: vertices
				color: Color transparent
				borderWidth: 0
				borderColor: Color black.
	""
	arrow bounds: (arrow bounds insetBy: (aRectangle width / 6) rounded).
	""
	aSymbol == #right 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 90].
	aSymbol == #bottom 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 180].
	aSymbol == #left 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 270].
	""
	^arrow! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:20'!
createArrowOfDirection: aSymbolDirection size: finalSizeInteger color: aColor 
	"Defer to current UITheme if available."
	
	^self
		scrollbarArrowOfDirection: aSymbolDirection
		size: finalSizeInteger
		color: aColor! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:17'!
createBoxImagesCache
	"creates the cache to store the arrow forms"
	^ LRUCache
		size: 20
		factory: [:key | self createBoxOfSize: key first color: key second]! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:32'!
createBoxIn: aRectangle 
	"PRIVATE - create an box bounded in aRectangle"
	| box |
	box := RectangleMorph new.
	box extent: (aRectangle scaleBy: 1 / 2) extent rounded;
		 borderWidth: 0.
	""
	^ box! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:39'!
createBoxOfSize: finalSizeInteger color: aColor 
	"PRIVATE - create a box with finalSizeInteger and aColor  
	 
	Try with:  
	(UITheme current createBoxOfSize: 32 color: Color lightGreen) 
          asMorph openInHand.  
	"
	| resizeFactor outerBox innerBox resizedForm |
	resizeFactor := 4.
	outerBox := RectangleMorph new.
	outerBox extent: finalSizeInteger asPoint * resizeFactor;
		 borderWidth: 0;
		 color: aColor.
	""
	innerBox := self createBoxIn: outerBox bounds.
	self updateScrollBarButtonAspect: innerBox color: aColor muchDarker.
	outerBox addMorphCentered: innerBox.
	""
	resizedForm := outerBox imageForm
				magnify: outerBox imageForm boundingBox
				by: 1 / resizeFactor
				smoothing: 4.
	""
	^ (resizedForm replaceColor: aColor withColor: Color transparent)
		trimBordersOfColor: Color transparent! !

!UITheme methodsFor: 'label-styles' stamp: 'GaryChambers 8/10/2010 16:35'!
createCloseBoxFor: aSystemWindow
	"Answer a button for closing the window."
	
	^(self
		newCloseControlIn: aSystemWindow
		for: aSystemWindow
		action: [aSystemWindow closeBoxHit]
		help: 'Close this window' translated)
		extent: aSystemWindow boxExtent! !

!UITheme methodsFor: 'label-styles' stamp: 'tbn 7/29/2010 21:27'!
createCollapseBoxFor: aSystemWindow
	"Answer a button for minimising the window."
	
	^aSystemWindow createBox
		labelGraphic: self windowMinimizeForm;
		extent: aSystemWindow boxExtent;
		actionSelector: #collapseBoxHit;
		setBalloonText: 'Collapse this window' translated! !

!UITheme methodsFor: 'label-styles' stamp: 'tbn 7/29/2010 21:27'!
createExpandBoxFor: aSystemWindow
	"Answer a button for maximising/restoring the window."
	
	^aSystemWindow createBox
		labelGraphic: self windowMaximizeForm;
		extent: aSystemWindow boxExtent;
		actionSelector: #expandBoxHit;
		setBalloonText: 'Expand to full screen' translated! !

!UITheme methodsFor: 'label-styles' stamp: 'tbn 7/29/2010 21:27'!
createMenuBoxFor: aSystemWindow
	"Answer a button for the window menu."
	
	^aSystemWindow createBox
		labelGraphic: (self windowMenuIconFor: aSystemWindow);
		extent: aSystemWindow boxExtent;
		actWhen: #buttonDown;
		actionSelector: #offerWindowMenu;
		setBalloonText: 'Window menu' translated! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
crudeRedoDisabledIcon
	^ ThemeIcons crudeRedoDisabledIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
crudeRedoIcon
	^ ThemeIcons crudeRedoIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
crudeUndoDisabledIcon
	^ ThemeIcons crudeUndoDisabledIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
crudeUndoIcon
	^ ThemeIcons crudeUndoIcon! !

!UITheme methodsFor: 'accessing' stamp: 'FernandoOlivero 4/12/2011 09:47'!
currentSettings
	^ self class currentSettings! !

!UITheme methodsFor: 'services' stamp: 'GaryChambers 8/23/2010 12:14'!
customQuestionIn: aThemedMorph text: labelText yesText: yesText noText: noText cancelText: cancelText default: defaultOption title: aString
	"Answer the result of a question dialog with the given label, button labels and title.
	defaultOption should be one of true, false or nil to set the default button."

	self questionSound play.
	^(aThemedMorph openModal: (
		CustomQuestionDialogWindow new
			textFont: self textFont;
			title: aString;
			text: labelText;
			yesText: yesText help: nil;
			noText: noText help: nil;
			cancelText: cancelText help: nil;
			default: defaultOption)) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:14'!
customQuestionIn: aThemedMorph text: labelText yesText: yesText noText: noText title: aString
	"Answer the result of a question dialog with the given label, button labels and title."

	self questionSound play.
	^(aThemedMorph openModal: (
		CustomQuestionDialogWindow new
			textFont: self textFont;
			title: aString;
			text: labelText;
			yesText: yesText help: nil;
			noText: noText help: nil)) answer! !

!UITheme methodsFor: 'icons-utilities' stamp: 'AlainPlantec 10/20/2010 00:33'!
decorateMenu: aMenu 
	"decorate aMenu with icons"

	| maxWidth |
	self settings menuWithIcons ifFalse: [^ self].
	maxWidth := 10.

	aMenu items do: [:item | 
		item icon isNil ifTrue: [
			| icon | 
			icon := self iconForMenuItem: item.
			icon isNil ifFalse: [
				item icon:  icon.
				maxWidth := maxWidth max: item icon width.
			]
		]
		ifFalse: [
			item icon:  item icon.
			maxWidth := maxWidth max: item icon width
		].

		item hasSubMenu ifTrue: [
			self decorateMenu: item subMenu.
		].
	].

	maxWidth isZero ifFalse: [
		aMenu addBlankIconsIfNecessary: (self blankIconOfWidth: maxWidth).
	].
! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 2/22/2008 21:28'!
defaultButtonBorderColor
	"Answer the color to use for a 'default' button."

	^self settings selectionColor! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 12/13/2009 18:02'!
defaultMenuColor
	"Answer the default color to use for a menu
	in the absence of an override in settings."

	^ self settings fallbackMenuColor ! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 12/21/2009 11:31'!
defaultMenuTitleColor
	"Answer the default color to use for a menu title
	in the absence of an override in settings."

	^self settings menuTitleColor! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 10/16/2008 16:18'!
defaultSettings
	"Answer the default settings."

	^self class defaultSettings copy! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 7/30/2009 18:33'!
defaultSoundTheme
	"Answer the default sound theme.
	Answer the system sound theme by default."

	^SoundTheme current! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:14'!
denyIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of an deny dialog (true) with the given label and title."

	self denySound play.
	^(aThemedMorph openModal: (
		DenyDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:45'!
denySound
	"Answer the deny sound."

	^self soundTheme denySound! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 3/9/2010 15:09'!
desktopImageFor: aWorld
	"Answer the desktop image for the given world.
	Look for an image file with the name of the theme.
	Answer nil for none available."

	|filename|
	filename := FileDirectory fileName: self class themeName extension: 'jpg'.
	^(FileDirectory default fileExists:	filename) ifTrue: [
		ImageReadWriter formFromFileNamed: filename]! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 3/9/2010 15:13'!
desktopImageLayout
	"Answer the layout symbol for any desktop image.
	See AlphaImageMorph>>layoutSymbols."

	^self settings desktopImageLayout! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:53'!
dialogWindowActiveFillStyleFor: aWindow
	"Return the dialog window active fillStyle for the given window."
	
	^aWindow paneColorToUse lighter! !

!UITheme methodsFor: 'fill-styles' stamp: 'AlainPlantec 12/14/2009 14:30'!
dialogWindowInactiveFillStyleFor: aWindow
	"Return the dialog window inactive fillStyle for the given window."
	
	^self settings  fadedBackgroundWindows
		ifTrue: [aWindow paneColorToUse lighter
					alphaMixed: 0.9
					with: (Color white alpha: aWindow paneColorToUse alpha)]
		ifFalse: [aWindow paneColorToUse lighter]! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 6/2/2009 10:18'!
dialogWindowPreferredCornerStyleFor: aDialogWindow
	"Answer the preferred corner style for the given dialog."

	^#rounded! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 10/17/2008 12:19'!
disabledItemStyle
	"Answer either #plain or #inset to determine how
	diabled text is drawn."

	^#plain! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 7/30/2009 14:11'!
dockingBarNormalFillStyleFor: aToolDockingBar
	"Return the normal docking bar fillStyle for the given color."
	
	|aColor|
	aColor := aToolDockingBar originalColor.
	^(GradientFillStyle ramp: {
			0.0->aColor whiter whiter. 0.2->aColor lighter.
			0.8->aColor darker. 1.0->aColor blacker})
		origin: aToolDockingBar topLeft;
		direction: (aToolDockingBar isVertical
			ifTrue: [aToolDockingBar width @ 0]
			ifFalse: [0 @ aToolDockingBar height]);
		radial: false! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
downArrowIcon
	^ ThemeIcons downArrowIcon! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 6/2/2009 10:58'!
drawTabGroupFinishingFor: aTabGroupMorph on: aCanvas
	"Patch up any visuals for the selected tab."! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 9/1/2009 15:26'!
drawTextAdornmentFor: aPluggableTextMorph color: aColor on: aCanvas
	"Indicate edit status for the given morph."
	
	aCanvas frameRectangle: aPluggableTextMorph innerBounds width: 2 color: aColor! !

!UITheme methodsFor: 'border-styles' stamp: 'GaryChambers 3/8/2011 12:03'!
drawTextAdornmentsFor: aPluggableTextMorph on: aCanvas
	"Indicate edit status for the given morph."
	
	(aPluggableTextMorph model notNil and: [aPluggableTextMorph model refusesToAcceptCode])
		ifTrue: [^self drawTextAdornmentFor: aPluggableTextMorph color: Color tan on: aCanvas].
	(aPluggableTextMorph hasEditingConflicts or: [aPluggableTextMorph hasValidText not])
		ifTrue: [^self drawTextAdornmentFor: aPluggableTextMorph color: Color red on: aCanvas].
	aPluggableTextMorph hasUnacceptedEdits
		ifTrue: [aPluggableTextMorph model wantsDiffFeedback
					ifTrue: [^self drawTextAdornmentFor: aPluggableTextMorph color: Color yellow darker on: aCanvas]
					ifFalse: [^self drawTextAdornmentFor: aPluggableTextMorph color: Color orange on: aCanvas]].
	aPluggableTextMorph model wantsDiffFeedback
		ifTrue: [self drawTextAdornmentFor: aPluggableTextMorph color: Color green on: aCanvas]! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/16/2009 17:21'!
drawWindowActiveDropShadowFor: aSystemWindow on: aCanvas
	"Draw the active drop shadow for the given window."
	
	
	^self windowActiveDropShadowStyle == #diffuse
		ifTrue: [self drawWindowDiffuseDropShadowFor: aSystemWindow on: aCanvas]
		ifFalse: [self drawWindowPlainDropShadowFor: aSystemWindow on: aCanvas]! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 3/4/2009 15:09'!
drawWindowDiffuseDropShadowFor: aSystemWindow on: aCanvas
	"Draw the diffuse drop shadow for the given window."
	
	|or b r o gc|
	or := self windowActiveDropShadowOffsetRectangleFor: aSystemWindow.
	o := or bottom.
	b := aSystemWindow bounds expandBy: or.
	gc := {Color black alpha: 0.6. Color transparent}.
	r := b topLeft extent: o asPoint.
	aCanvas
		fillRectangle: r
		fillStyle: ((GradientFillStyle colors: gc)
					origin: r bottomRight;
					direction: o@0;
					radial: true).
	r := b topLeft + (o@0) extent: (b width - o - o @ o).
	aCanvas
		fillRectangle: r
		fillStyle: ((GradientFillStyle colors: gc)
					origin: r bottomLeft;
					direction: 0@o negated).
	r := b topRight - (o@0) extent: o asPoint.
	aCanvas
		fillRectangle: r
		fillStyle: ((GradientFillStyle colors: gc)
					origin: r bottomLeft;
					direction: o@0;
					radial: true).
	r := b topRight + (o negated@o) extent: (o @ (b height - o - o)).
	aCanvas
		fillRectangle: r
		fillStyle: ((GradientFillStyle colors: gc)
					origin: r topLeft;
					direction: o@0).
	r := b bottomRight - o asPoint extent: o asPoint.
	aCanvas
		fillRectangle: r
		fillStyle: ((GradientFillStyle colors: gc)
					origin: r topLeft;
					direction: o@0;
					radial: true).
	r := b bottomLeft + (o@o negated) extent: (b width - o - o @ o).
	aCanvas
		fillRectangle: r
		fillStyle: ((GradientFillStyle colors: gc)
					origin: r topLeft;
					direction: 0@o).
	r := b bottomLeft - (0@o) extent: o asPoint.
	aCanvas
		fillRectangle: r
		fillStyle: ((GradientFillStyle colors: gc)
					origin: r topRight;
					direction: o@0;
					radial: true).
	r := b topLeft + (0@o) extent: (o @ (b height - o - o)).
	aCanvas
		fillRectangle: r
		fillStyle: ((GradientFillStyle colors: gc)
					origin: r topRight;
					direction: o negated@0)! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/16/2009 17:21'!
drawWindowInactiveDropShadowFor: aSystemWindow on: aCanvas
	"Draw the inactive drop shadow for the given window."
	
	self drawWindowPlainDropShadowFor: aSystemWindow on: aCanvas! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/16/2009 17:20'!
drawWindowPlainDropShadowFor: aSystemWindow on: aCanvas
	"Draw the plain drop shadow for the given window."
	
	|blOffset brOffset trOffset|
	(aSystemWindow owner notNil and: [aSystemWindow owner isHandMorph])
		ifTrue: [^self]. "skip if being dragged"
	blOffset := (aSystemWindow wantsRoundedCorners and: [aSystemWindow roundedCorners includes: 2])	
		ifTrue: [7] ifFalse: [1].
	brOffset := (aSystemWindow wantsRoundedCorners and: [aSystemWindow roundedCorners includes: 3])	
		ifTrue: [7] ifFalse: [1].
	trOffset := (aSystemWindow wantsRoundedCorners and: [aSystemWindow roundedCorners includes: 4])	
		ifTrue: [7] ifFalse: [1].
	aCanvas
		fillRectangle: (aSystemWindow bounds bottomLeft + (blOffset @ 0)
						corner: aSystemWindow bounds bottomRight - (brOffset @ -1))
		fillStyle: aSystemWindow shadowColor;
		fillRectangle: (aSystemWindow bounds topRight + (0 @ trOffset)
						corner: aSystemWindow bounds bottomRight + (1 @ brOffset negated))
		fillStyle: aSystemWindow shadowColor.
	aCanvas
		clipBy: (aSystemWindow bounds bottomRight - brOffset
			corner: aSystemWindow bounds bottomRight + (1@1))
			during: [:c | ((RoundedBorder new
							baseColor: aSystemWindow shadowColor;
							width: 1) cornerRadius: brOffset - 1)
							frameRectangle: (aSystemWindow bounds translateBy: 1)
							on: c]! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 6/1/2009 11:40'!
dropListButtonLabelFor: aDropList
	"Answer the label for the button of the given drop list."

	^AlphaImageMorph new
		image: (ScrollBar
			arrowOfDirection: #bottom
			size: aDropList buttonWidth - 3
			color: aDropList paneColor darker);
		enabled: aDropList enabled! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 1/28/2009 17:07'!
dropListControlButtonWidth
	"Answer the width of a drop list control button for this theme."
	
	^self buttonMinWidth! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/7/2007 12:41'!
dropListDisabledBorderStyleFor: aDropList
	"Return the disabled borderStyle for the given drop list."

	^self dropListNormalBorderStyleFor: aDropList! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 10:56'!
dropListDisabledFillStyleFor: aDropList
	"Return the disabled fillStyle for the given drop list."
	
	^aDropList paneColor alphaMixed: 0.3 with: Color white! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 1/23/2009 12:27'!
dropListFocusBoundsFor: aDropList
	"Answer the bounds for drawing the focus indication for the
	given drop list."

	^(aDropList innerBounds
		insetBy: (0@0 corner: aDropList buttonMorph width@0))
		insetBy: aDropList layoutInset! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 1/20/2009 16:39'!
dropListFocusIndicatorCornerRadiusFor: aDropList
	"Answer the default corner radius preferred for the focus indicator
	for the drop list for themes that support this."

	^self focusIndicatorCornerRadiusFor: aDropList! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 12/19/2006 13:10'!
dropListFont
	"Answer the drop list font to use."

	^self textFont! !

!UITheme methodsFor: 'defaults' stamp: 'GaryChambers 8/18/2010 17:52'!
dropListInsetFor: aDropList
	"Answer the inset to use for drop-list layout."

	^(1@0 corner: -1@0)! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/7/2007 12:42'!
dropListNormalBorderStyleFor: aDropList
	"Return the normal borderStyle for the given drop list"

	^BorderStyle inset
		width: 1;
		baseColor: aDropList paneColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 10:56'!
dropListNormalFillStyleFor: aDropList
	"Return the normal fillStyle for the given drop list."
	
	^Color white! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 1/13/2009 14:00'!
dropListNormalListBorderStyleFor: aDropList
	"Return the normal borderStyle for the list of the given given drop list"

	^BorderStyle inset
		width: 1;
		baseColor: aDropList paneColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:07'!
dropListNormalListFillStyleFor: aDropList
	"Return the normal fillStyle for the list of the given drop list."
	
	^Color white! !

!UITheme methodsFor: 'defaults' stamp: 'GaryChambers 8/18/2010 17:52'!
editableDropListInsetFor: aDropList
	"Answer the inset to use for an editable drop-list layout."

	^(0@0 corner: -1@0)! !

!UITheme methodsFor: 'defaults' stamp: 'GaryChambers 8/18/2010 17:49'!
editableDropListMargins
	"Answer the text margins for an editable drop list for this theme."
	
	^0 @ 1 corner: 2 @ 1! !

!UITheme methodsFor: 'services' stamp: 'GaryChambers 7/5/2010 15:59'!
enterOrRequestIn: aThemedMorph title: title labels: labels values: values lines: lines
	"Answer the result of a popup choice with the given title, labels, values and lines."

	| dialog choice |
	dialog := PopupChoiceOrRequestDialogWindow new
		title: (title isEmpty ifTrue: ['Choose' translated] ifFalse: [title asString]);
		labels: labels;
		lines: (lines ifNil: [#()]);
		model: values.
	choice := (aThemedMorph openModal: dialog) choice.
	dialog cancelled ifTrue: [ ^nil ].
	choice 
		ifNotNil: [ ^choice ]
		ifNil: [ ^dialog filterValue ]! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:48'!
errorIcon
	"Answer an error icon."

	^ThemeIcons errorIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
expandBoxIcon
	^ ThemeIcons expandBoxIcon! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 1/28/2009 17:08'!
expanderTitleControlButtonWidth
	"Answer the width of an expander title control button for this theme."
	
	^self buttonMinWidth! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 12/5/2008 14:55'!
expanderTitleInsetFor: anExpanderTitle
	"Answer the inset to use for expander title layout."

	^anExpanderTitle borderWidth negated! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 14:25'!
expanderTitleNormalFillStyleFor: anExpanderTitle
	"Return the normal expander title fillStyle for the given expander title."
	
	^anExpanderTitle paneColor! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
eyedropperIcon
	^ ThemeIcons eyedropperIcon! !

!UITheme methodsFor: 'services' stamp: 'gvc 9/27/2006 13:43'!
fileOpenIn: aThemedMorph title: title extensions: exts path: path preview: preview
	"Answer the result of a file open dialog with the given title, extensions path and preview type."

	|fd|
	fd := FileDialogWindow basicNew
		previewType: preview;
		initialize;
		title: title;
		answerOpenFile.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'services' stamp: 'gvc 8/31/2006 15:29'!
fileSaveIn: aThemedMorph title: title extensions: exts path: path
	"Answer the result of a file save dialog with the given title, extensions and path."

	|fd|
	fd := FileDialogWindow new
		title: title;
		answerSaveFile.
	exts ifNotNil: [fd validExtensions: exts].
	path ifNotNil: [fd selectPathName: path].
	^(aThemedMorph openModal: fd) answer! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 9/12/2007 14:40'!
focusIndicator
	"Answer the value of focusIndicator"

	^ focusIndicator! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 9/12/2007 14:40'!
focusIndicator: anObject
	"Set the value of focusIndicator"

	focusIndicator := anObject! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 1/20/2009 17:00'!
focusIndicatorCornerRadiusFor: aMorph
	"Answer the default corner radius preferred for the focus indicator
	for the morph for themes that support this."

	^aMorph wantsRoundedCorners
		ifTrue: [6]
		ifFalse: [2]! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/20/2009 11:09'!
focusIndicatorMorphFor: aMorph
	"Answer a (cached) focus indicator for the given morph."

	(self focusIndicator isNil or: [
			self focusIndicator isMorph
				ifTrue: [self focusIndicator ~~ aMorph]
				ifFalse: [self focusIndicator key ~~ aMorph]])
		ifTrue: [self focusIndicator: aMorph ->(self newFocusIndicatorMorphFor: aMorph)].
	^self focusIndicator value 
		privateBounds: aMorph focusBounds! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 5/14/2007 11:39'!
forms
	"Answer the value of forms"

	^ forms! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 5/14/2007 11:39'!
forms: anObject
	"Set the value of forms"

	forms := anObject! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
forwardIcon
	^ ThemeIcons forwardIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
fullScreenIcon
	^ ThemeIcons fullScreenIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
getsIcon
	^ ThemeIcons getsIcon! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 1/25/2008 14:43'!
groupLabelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a group label."

	^BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 1/16/2008 13:44'!
groupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a group panel."

	^BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloCollapseIcon
	^ ThemeIcons haloCollapseIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloDebugIcon
	^ ThemeIcons haloDebugIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloDismissIcon
	^ ThemeIcons haloDismissIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloDragIcon
	^ ThemeIcons haloDragIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloDupIcon
	^ ThemeIcons haloDupIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloFontEmphIcon
	^ ThemeIcons haloFontEmphIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloFontSizeIcon
	^ ThemeIcons haloFontSizeIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloFontStyleIcon
	^ ThemeIcons haloFontStyleIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloGrabIcon
	^ ThemeIcons haloGrabIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloHelpIcon
	^ ThemeIcons haloHelpIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloMenuIcon
	^ ThemeIcons haloMenuIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloPaintIcon
	^ ThemeIcons haloPaintIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloRecolorIcon
	^ ThemeIcons haloRecolorIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloRotIcon
	^ ThemeIcons haloRotIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloScaleIcon
	^ ThemeIcons haloScaleIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
haloViewIcon
	^ ThemeIcons haloViewIcon! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/23/2009 13:32'!
handlesWindowDropShadowInHandFor: aSystemWindow
	"Answer whether the receiver will handle drop shadow drawing
	for a window when picked up in the hand. We will when diffuse."

	^self windowActiveDropShadowStyle == #diffuse and: [
		aSystemWindow isActive]! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
helpIcon
	^ ThemeIcons helpIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
homeIcon
	^ ThemeIcons homeIcon! !

!UITheme methodsFor: 'icons-utilities' stamp: 'AlainPlantec 10/19/2010 21:46'!
iconForMenuItem: anItem
	"Answer the icon (or nil) corresponding to the (translated) string."
	| itemKey |
	itemKey := anItem contents asString asLowercase.
	^ (self menuIcons detect: [:cpl | cpl key includes: itemKey] ifNone: [])
		ifNotNil: [:assoc | assoc value].
! !

!UITheme methodsFor: 'icons-utilities' stamp: 'AlainPlantec 10/19/2010 20:51'!
iconNamed: aSymbol
	^ThemeIcons iconNamed: aSymbol! !

!UITheme methodsFor: 'icons-utilities' stamp: 'AlainPlantec 10/19/2010 20:53'!
iconNamed: aSymbol ifNone: aBlock
	^ThemeIcons iconNamed: aSymbol ifNone: aBlock! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
imageIcon
	^ ThemeIcons imageIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:32'!
infoIcon
	"Answer an information icon."

	^ThemeIcons infoIcon! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 7/30/2009 18:32'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		initializeForms;
		settings: self defaultSettings! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 10/25/2007 17:02'!
initializeForms
	"Initialize the receiver's image forms."

	self forms: Dictionary new.
	self forms
		at: #checkboxMarker put: self newCheckboxMarkerForm;
		at: #radioButtonMarker put: self newRadioButtonMarkerForm;
		at: #treeExpanded put: self newTreeExpandedForm;
		at: #treeUnexpanded put: self newTreeUnexpandedForm;
		at: #windowClose put: self newWindowCloseForm;
		at: #windowMinimize put: self newWindowMinimizeForm;
		at: #windowMaximize put: self newWindowMaximizeForm;
		at: #windowMenu put: self newWindowMenuForm! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
jumpIcon
	^ ThemeIcons jumpIcon! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 9/8/2006 13:59'!
labelFont
	"Answer the label font to use."

	^self textFont! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/7/2007 12:41'!
listDisabledBorderStyleFor: aList
	"Return the disabled borderStyle for the given list."

	^self listNormalBorderStyleFor: aList! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 12:39'!
listDisabledFillStyleFor: aList
	"Return the disabled fillStyle for the given list."
	
	^aList paneColor alphaMixed: 0.3 with: Color white! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 6/1/2009 15:18'!
listFocusBoundsFor: aListMorph
	"Answer the bounds for drawing the focus indication."

	^aListMorph bounds! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 11/29/2009 22:00'!
listFont
	"Answer the list font to use."

	^StandardFonts listFont! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/7/2007 12:42'!
listNormalBorderStyleFor: aList
	"Return the normal borderStyle for the given list"

	^BorderStyle inset
		width: 1;
		baseColor: aList paneColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 12:39'!
listNormalFillStyleFor: aList
	"Return the normal fillStyle for the given list."
	
	^Color white! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:27'!
lockIcon
	"Answer a lock icon."

	^ThemeIcons lockIcon! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:15'!
longMessageIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of a (potentially long) message dialog (true) with the given label and title."

	self messageSound play.
	^(aThemedMorph openModal: (
		LongMessageDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 9/13/2006 11:26'!
menuBarFont
	"Answer the menu bar font to use."

	^self textFont! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 2/10/2009 12:55'!
menuCloseForm
	"Answer the form to use for the close button of a menu."

	^self windowCloseForm! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 10/26/2006 16:48'!
menuColor
	"Answer the menu color to use."

	^self settings menuColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 10/16/2008 15:38'!
menuColorFor: aThemedMorph
	"Answer the menu color to use."

	|w|
	^self menuColor ifNil: [
		aThemedMorph ifNil: [^self defaultMenuColor].
		w := aThemedMorph isSystemWindow
			ifTrue: [aThemedMorph]
			ifFalse: [aThemedMorph ownerThatIsA: SystemWindow].
		w isNil
			ifTrue: [self defaultMenuColor]
			ifFalse: [(w valueOfProperty: #paneColor) ifNil: [self defaultMenuColor]]]! !

!UITheme methodsFor: 'fill-styles' stamp: 'AlainPlantec 11/24/2010 11:09'!
menuFillStyleFor: aMenu
	"Return the fillStyle for the given menu."
	
	| bc fill |
	bc := aMenu valueOfProperty: #basicColor ifAbsent: [self settings derivedMenuColor].
	fill := GradientFillStyle ramp: {0.0 -> (bc alphaMixed: 0.2 with: Color white). 1.0 -> bc}.
	fill
		radial: false;
		origin: aMenu topLeft;
		direction: 0 @ aMenu height.
	^ fill.! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 11/29/2009 22:05'!
menuFont
	"Answer the menu font to use."

	^StandardFonts menuFont! !

!UITheme methodsFor: 'icons-utilities' stamp: 'AlainPlantec 10/20/2010 00:39'!
menuIcons
	"answer a collection of associations wordings -> icon
	to decorate the menus all over the image"
	
	^ { 
	#('select' ) -> self smallSelectIcon.
	#('Tools...' ) -> self smallOpenIcon.
	#('System...' ) -> self smallConfigurationIcon.
	#('open...' ) -> self smallOpenIcon.
	#('windows...' ) -> self smallWindowIcon.
	#('debug...' ) -> self smallDebugIcon.
	#('export...' ) -> self smallExportIcon.
	#('save' ) -> self smallSaveIcon.
	#('save project on file...' ) -> self smallPublishIcon.
	#('save as...' 'save as new version' ) -> self smallSaveAsIcon.
	#('quit' 'save and quit' ) -> self smallQuitIcon.
	#('load project from file...' ) -> self smallLoadProjectIcon.
	""
	#('do it (d)' ) -> self smallDoItIcon.
	#('inspect it (i)' 'explore it (I)' 'inspect world' 'explore world' 'inspect model' 'inspect morph' 'explore morph' 'inspect owner chain' 'explore' 'inspect' 'explore (I)' 'inspect (i)' 'basic inspect' ) -> self smallInspectItIcon.
	#('print it (p)' ) -> self smallPrintIcon.
	#('debug it (D)' ) -> self smallDebugIcon.
	#('watch it' ) -> self blankIcon.
	#('profile it' ) -> self blankIcon.
	""
	#('copy (c)' 'copy to paste buffer' 'copy text' ) -> self smallCopyIcon.
	#('paste (v)' 'paste...' ) -> self smallPasteIcon.
	#('cut (x)' ) -> self smallCutIcon.
	""
	#('accept (s)' 'yes' 'Yes' ) -> self smallOkIcon.
	#('cancel (l)' 'no' 'No' ) -> self smallCancelIcon.
	""
	#('do again (j)' ) -> self smallRedoIcon.
	#('undo (z)' ) -> self smallUndoIcon.
	""
	#('find...(f)' 'find again (g)' 'find class... (f)' 'find method...' 'extended search...') -> self smallFindIcon.
	""
	#('remove' 'remove class (x)' 'delete method from changeset (d)' 'remove method from system (x)' 'delete class from change set (d)' 'remove class from system (x)' 'destroy change set (X)' ) -> self smallDeleteIcon.
	#('add item...' 'new category...' 'new change set... (n)' ) -> self smallNewIcon.
	""
	#('new morph...' 'objects (o)' ) -> self smallObjectCatalogIcon.
	#('authoring tools...')  -> self smallAuthoringToolsIcon.
	""
	#('leftFlush' ) -> self smallLeftFlushIcon.
	#('rightFlush' ) -> self smallRightFlushIcon.
	#('centered' 'set alignment... (u)' ) -> self smallCenteredIcon.
	#('justified' ) -> self smallJustifiedIcon.
	""
	#('set font... (k)' 'list font...' 'set subtitles font' 'change font' 'system fonts...' 'change font...' ) -> self smallFontsIcon.
	#(StandardFonts  systemFontLabels)-> self smallFontsIcon.
	#('full screen on' 'full screen off' ) -> self smallFullScreenIcon.
	}
! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 3/1/2010 15:55'!
menuItemDisabledTextColorFor: aMenuItem
	"Answer the color to use for disabled menu item text."

	^((aMenuItem color luminance - aMenuItem owner color luminance) abs < 0.3)
		ifTrue: [aMenuItem owner color contrastingColor muchDarker]
		ifFalse: [aMenuItem owner color muchDarker]! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 6/4/2007 13:05'!
menuItemInDockingBarSelectedBorderStyleFor: aMenuItem
	"Return the selected menu item borderStyle when in a docking bar for the given menu item."

	^self menuItemSelectedBorderStyleFor: aMenuItem! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'AlainPlantec 12/19/2009 14:17'!
menuItemInDockingBarSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item that is in a docking bar."
	
	^ self menuItemSelectedFillStyleFor: aMenuItem
! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 3/1/2010 15:43'!
menuItemNormalTextColorFor: aMenuItem
	"Answer the color to use for normal menu item text."

	^((aMenuItem color luminance - aMenuItem owner paneColor luminance) abs < 0.3)
		ifTrue: [aMenuItem owner paneColor contrastingColor]
		ifFalse: [aMenuItem color]! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 6/4/2007 13:03'!
menuItemSelectedBorderStyleFor: aMenuItem
	"Return the selected menu item borderStyle for the given menu item."

	^BorderStyle simple
		width: 0! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'AlainPlantec 12/19/2009 14:17'!
menuItemSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item."
	
	Display depth <= 2 ifTrue: [^ Color gray].
	^ self settings menuSelectionColor.
! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 2/11/2011 21:07'!
menuItemSelectedTextColorFor: aMenuItem
	"Answer the color to use for selected menu item text."

	^ self settings menuSelectionTextColor! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 3/6/2009 13:10'!
menuPinForm
	"Answer the form to use for the pin button of a menu."

	^ThemeIcons smallPushpinIcon! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 12/21/2009 11:20'!
menuTitleColor
	"Answer the menu title color to use."
	^self settings menuTitleColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'AlainPlantec 12/21/2009 11:20'!
menuTitleColorFor: aThemedMorph
	"Answer the menu titlecolor to use."

	|w|
	^self menuTitleColor ifNil: [
		aThemedMorph ifNil: [^self defaultMenuTitleColor].
		w := aThemedMorph isSystemWindow
			ifTrue: [aThemedMorph]
			ifFalse: [aThemedMorph ownerThatIsA: SystemWindow].
		w isNil
			ifTrue: [self defaultMenuTitleColor]
			ifFalse: [(w valueOfProperty: #paneColor) darker ifNil: [self defaultMenuTitleColor]]]! !

!UITheme methodsFor: 'fill-styles' stamp: 'HilaireFernandes 8/3/2010 10:07'!
menuTitleFillStyleFor: aMenuTitle
	"Return the fillStyle for the given title menu."
	| fill |

	fill := GradientFillStyle ramp: {0.0 -> aMenuTitle color twiceLighter. 1 -> aMenuTitle color twiceDarker}.
	fill
		origin: aMenuTitle topLeft;
		direction: aMenuTitle width @ 0.
	^ fill! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:15'!
messageIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of a message dialog (true) with the given label and title."

	self messageSound play.
	^(aThemedMorph openModal: (
		MessageDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:45'!
messageSound
	"Answer the message sound."

	^self soundTheme messageSound! !

!UITheme methodsFor: 'fill-styles' stamp: 'AlainPlantec 2/11/2011 22:29'!
morphTreeSplitterNormalFillStyleFor: aSplitter
	"Return the normal splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := aSplitter paneColor.
	^(GradientFillStyle ramp: {
		0.0->aColor whiter whiter. 0.2->aColor lighter.
		0.8->aColor darker. 1.0->aColor blacker})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!UITheme methodsFor: 'fill-styles' stamp: 'AlainPlantec 2/11/2011 22:31'!
morphTreeSplitterPressedFillStyleFor: aSplitter
	"Return the pressed splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := aSplitter paneColor twiceDarker.
	^(GradientFillStyle ramp: {
			0.0->Color white. 0.4-> aColor twiceLighter.
			1.0->aColor darker duller})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 1/28/2009 18:00'!
multiFormFillStyleFrom: anArray cornerWidths: widthArray in: aRectangle
	"Answer a composite fill style from the given forms and central colour
	in the given bounds. Use the widths specified for the portion of the
	corner forms to display."
	
	|tl tm tr ml mr bl bm br c tlw trw blw brw|
	tl := anArray first. tlw:= widthArray first.
	tm := anArray second.
	tr := anArray third. trw := widthArray second.
	ml  := anArray fourth.
	c := anArray fifth.
	mr  := anArray sixth.
	bl := anArray seventh. blw := widthArray third.
	bm := anArray eighth.
	br := anArray ninth. brw := widthArray fourth.
	^CompositeFillStyle fillStyles: {
		(ImageFillStyle form: tl)
			origin: aRectangle topLeft;
			extent: tlw@tl height.
		(AlphaInfiniteForm with: tm)
			origin: aRectangle topLeft + (tlw@0);
			extent: (aRectangle width - trw - tlw)@tm height.
		(ImageFillStyle form: tr)
			origin: aRectangle topRight - (tr width@0);
			extent: trw@tr height;
			offset: (tr width - trw)@0.
		(AlphaInfiniteForm with: ml)
			origin: aRectangle topLeft + (0@tl height);
			extent: ml width@(aRectangle height - tl height - bl height).
		(ColorFillStyle color: c)
			origin: aRectangle topLeft + (tlw@tl height);
			extent: aRectangle extent - (tlw@tl height) - (brw@br height).
		(AlphaInfiniteForm with: mr)
			origin: aRectangle topRight + (trw negated@tr height);
			extent: mr width@(aRectangle height - tr height - br height).
		(ImageFillStyle form: bl)
			origin: aRectangle bottomLeft - (0@bl height);
			extent: blw@bl height.
		(AlphaInfiniteForm with: bm)
			origin: aRectangle bottomLeft - (blw negated@bl height);
			extent: (aRectangle width - blw - brw)@bm height.
		(ImageFillStyle form: br)
			origin: aRectangle bottomRight - br extent;
			extent: brw@br height;
			offset: (br width - brw)@0}! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 1/28/2009 17:43'!
multiFormFillStyleFrom: anArray in: aRectangle
	"Answer a composite fill style from the given forms and central colour
	in the given bounds."
	
	|tl tm tr ml mr bl bm br c|
	tl := anArray first.
	tm := anArray second.
	tr := anArray third.
	ml  := anArray fourth.
	c := anArray fifth.
	mr  := anArray sixth.
	bl := anArray seventh.
	bm := anArray eighth.
	br := anArray ninth.
	^CompositeFillStyle fillStyles: {
		(ImageFillStyle form: tl) origin: aRectangle topLeft.
		(AlphaInfiniteForm with: tm)
			origin: aRectangle topLeft + (tl width@0);
			extent: (aRectangle width - tl width - tr width)@tm height.
		(ImageFillStyle form: tr)
			origin: aRectangle topRight - (tr width@0).
		(AlphaInfiniteForm with: ml)
			origin: aRectangle topLeft + (0@tl height);
			extent: ml width@(aRectangle height - tl height - bl height).
		(ColorFillStyle color: c)
			origin: aRectangle topLeft + tl extent;
			extent: aRectangle extent - tl extent - br extent.
		(AlphaInfiniteForm with: mr)
			origin: aRectangle topRight + (tr width negated@tr height);
			extent: mr width@(aRectangle height - tr height - br height).
		(ImageFillStyle form: bl) origin: aRectangle bottomLeft - (0@bl height).
		(AlphaInfiniteForm with: bm)
			origin: aRectangle bottomLeft - (bl width negated@bl height);
			extent: (aRectangle width - bl width - br width)@bm height.
		(ImageFillStyle form: br)
			origin: aRectangle bottomRight - br extent}! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 1/12/2009 18:23'!
multiFormTopFillStyleFrom: anArray in: aRectangle
	"Answer a composite fill style from the given forms and central colour
	in the given bounds. Only top and middle sections are considered."
	
	|tl tm tr ml mr c|
	tl := anArray first.
	tm := anArray second.
	tr := anArray third.
	ml  := anArray fourth.
	c := anArray fifth.
	mr  := anArray sixth.
	^CompositeFillStyle fillStyles: {
		(ImageFillStyle form: tl) origin: aRectangle topLeft.
		(AlphaInfiniteForm with: tm)
			origin: aRectangle topLeft + (tl width@0);
			extent: (aRectangle width - tl width - tr width)@tm height.
		(ImageFillStyle form: tr)
			origin: aRectangle topRight - (tr width@0).
		(AlphaInfiniteForm with: ml)
			origin: aRectangle topLeft + (0@tr height);
			extent: ml width@(aRectangle height - tl height).
		(ColorFillStyle color: c)
			origin: aRectangle topLeft + tl extent;
			extent: aRectangle extent - tl extent - (mr width @0).
		(AlphaInfiniteForm with: mr)
			origin: aRectangle topRight + (tr width negated@tr height);
			extent: mr width@(aRectangle height - tr height)}! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 15:16'!
newAlphaImageIn: aThemedMorph image: aForm help: helpText
	"Answer an alpha image morph."
	
	|answer|
	answer := AlphaImageMorph new
		hResizing: #rigid;
		vResizing: #rigid;
		setBalloonText: helpText.
	aForm ifNotNil: [answer image: aForm].
	^answer! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/2/2009 12:39'!
newAlphaSelectorIn: aThemedMorph for: aModel getAlpha: getSel setAlpha: setSel help: helpText
	"Answer an alpha selector ."

	^(AColorSelectorMorph
			on: aModel
			getValue: getSel
			setValue: setSel)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'AlainPlantec 2/21/2011 18:59'!
newAutoAcceptTextEditorIn: aThemedMorph for: aModel getText: getSel setText: setSel getEnabled: enabledSel
	"Answer a text editor for the given model."

	^PluggableTextMorph new
		autoAccept: true;
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		selectionColor: self selectionColor! !

!UITheme methodsFor: 'morph creation' stamp: 'AlainPlantec 11/25/2010 09:43'!
newAutoAcceptTextEntryIn: aThemedMorph for: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel font: aFont help: helpText 
	"Answer a text entry for the given model.
	Object conversion will be automatic based on the class of
	object returned after performing the get selector, aClass
	is provided in case of initial nil returns."
	^ self
		newAutoAcceptTextEntryIn: aThemedMorph
		for: aModel
		get: getSel
		set: setSel
		class: aClass 
		getEnabled: enabledSel
		font: aFont
		help: helpText
		entryCompletion: nil! !

!UITheme methodsFor: 'morph creation' stamp: 'AlainPlantec 11/25/2010 09:53'!
newAutoAcceptTextEntryIn: aThemedMorph for: aModel  get: getSel set: setSel class: aClass getEnabled: enabledSel font: aFont help: helpText entryCompletion: anEntryCompletion
	"Answer a text entry for the given model.
	Object conversion will be automatic based on the class of
	object returned after performing the get selector, aClass
	is provided in case of initial nil returns."

	|pt|
	pt := PluggableTextFieldMorph new
		autoAccept: true;
		alwaysAccept: true;
		convertTo: aClass;
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: enabledSel;
		font: aFont;
		cornerStyle: (self textEntryCornerStyleIn: aThemedMorph);
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		selectionColor: self selectionColor;
		hideScrollBarsIndefinitely;
		extent: 24@(aFont height + 8);
		setBalloonText: helpText;
		entryCompletion: anEntryCompletion.
	pt textMorph
		autoFit: true;
		wrapFlag: false;
		margins: (2@1 corner: 2@1).
	^pt
! !

!UITheme methodsFor: 'morph creation' stamp: 'AlainPlantec 11/25/2010 09:45'!
newAutoAcceptTextEntryIn: aThemedMorph for: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText 
	"Answer a text entry for the given model.
	Object conversion will be automatic based on the class of
	object returned after performing the get selector, aClass
	is provided in case of initial nil returns."
	^ self
		newAutoAcceptTextEntryIn: aThemedMorph
		for: aModel
		get: getSel
		set: setSel
		class: aClass
		getEnabled: enabledSel
		help: helpText
		entryCompletion: nil ! !

!UITheme methodsFor: 'morph creation' stamp: 'AlainPlantec 11/25/2010 09:44'!
newAutoAcceptTextEntryIn: aThemedMorph for: aModel  get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText entryCompletion: anEntryCompletion
	"Answer a text entry for the given model.
	Object conversion will be automatic based on the class of
	object returned after performing the get selector, aClass
	is provided in case of initial nil returns."

	^self
		newAutoAcceptTextEntryIn: aThemedMorph
		for: aModel
		get: getSel
		set: setSel
		class: aClass
		getEnabled: enabledSel
		font: self textFont
		help: helpText
		entryCompletion: anEntryCompletion! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/30/2009 15:09'!
newBalloonHelpIn: aThemedMorph contents: aTextStringOrMorph for: aMorph corner: cornerSymbol
	"Answer a new balloon help morph with the given text
	and positioning for aMorph."
	
	^SimpleBalloonMorph
		string: aTextStringOrMorph
		for: aMorph
		corner: cornerSymbol! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/8/2009 13:09'!
newBracketSliderIn: aThemedMorph for: aModel getValue: getSel setValue: setSel min: minValue max: maxValue quantum: quantum getEnabled: enabledSel help: helpText
	"Answer a bracket slider."

	^(BracketSliderMorph
			on: aModel
			getValue: getSel
			setValue: setSel
			min: minValue
			max: maxValue
			quantum: quantum)
		getEnabledSelector: enabledSel;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'MarcusDenker 7/29/2010 20:39'!
newButtonIn: aThemedMorph for: aModel getState: stateSel action: actionSel arguments: args getEnabled: enabledSel getLabel: labelSel help: helpText
	"Answer a new button."

	|b|
	b := PluggableButtonMorph
			on: aModel
			getState: stateSel
			action: actionSel
			label: labelSel.
	b
		arguments: (args ifNil: [{b}]);
		getEnabledSelector: enabledSel;
		cornerStyle: (self buttonCornerStyleIn: aThemedMorph);
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		setBalloonText: helpText;
		extent: b minExtent.
	^b! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 12/5/2008 14:04'!
newButtonIn: aThemedMorph for: aModel getState: stateSel action: actionSel arguments: args getEnabled: enabledSel label: label help: helpText
	"Answer a new button."

	|b|
	b := PluggableButtonMorph
			on: aModel getState: stateSel action: actionSel.
	b
		arguments: (args ifNil: [{b}]);
		getEnabledSelector: enabledSel;
		cornerStyle: (self buttonCornerStyleIn: aThemedMorph);
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		label: label font: self buttonFont;
		setBalloonText: helpText;
		extent: b minExtent;
		hResizing: #rigid;
		vResizing: #rigid.
	^b! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 8/10/2010 16:01'!
newButtonLabelIn: aThemedMorph for: aModel label: aString getEnabled: enabledSel
	"Answer a new button text label."

	^(self buttonLabelForText: aString)
		model: aModel;
		getEnabledSelector: enabledSel! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 2/2/2009 15:11'!
newCancelButtonIn: aThemedMorph for: aModel
	"Answer a new cancel button."

	^self
		newButtonIn: aThemedMorph
		for: aModel
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel' translated
		help: 'Cancel changes and close the window' translated! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/18/2006 16:27'!
newCheckboxIn: aThemedMorph for: aModel getSelected: getSel setSelected: setSel getEnabled: enabledSel label: label help: helpText
	"Answer a checkbox with the given label ."

	^(CheckboxMorph
			on: aModel selected: getSel changeSelected: setSel)
		getEnabledSelector: enabledSel;
		font: self labelFont;
		label: label;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 10/25/2007 17:47'!
newCheckboxMarkerForm
	"Answer a new checkbox marker form."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1342177280 1610612736 134217728 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278190080 1476395008 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 671088640 4278190080 4009754624 134217728 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2147483648 4278190080 2533359616 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3607101440 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1073741824 4278190080 3875536896 16777215 16777215 16777215 16777215 16777215 1207959552 3204448256 134217728 16777215 2801795072 4278190080 2147483648 16777215 16777215 16777215 16777215 134217728 3607101440 4278190080 2936012800 268435456 4143972352 4278190080 536870912 16777215 16777215 16777215 16777215 16777215 536870912 4009754624 4278190080 3607101440 4278190080 3070230528 16777215 16777215 16777215 16777215 16777215 16777215 16777215 805306368 4009754624 4278190080 4278190080 1342177280 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 671088640 2936012800 2801795072 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 2/2/2009 15:11'!
newCloseButtonIn: aThemedMorph for: aModel
	"Answer a new close button."

	^self
		newButtonIn: aThemedMorph
		for: aModel
		getState: nil
		action: #close
		arguments: nil
		getEnabled: nil
		label: 'Close' translated
		help: 'Close the window' translated! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 8/10/2010 16:33'!
newCloseControlIn: aThemedMorph for: aModel action: aValuable help: helpText
	"Answer a button for closing things."
	
	|form msb|
	form := self windowCloseForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb
		activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form);
		addUpAction: aValuable;
		setBalloonText: helpText.
	^msb! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/6/2010 15:27'!
newColorChooserIn: aThemedMorph for: aModel getColor: getSel setColor: setSel getEnabled: enabledSel help: helpText
	"Answer a color chooser ."

	^(ColorChooserMorph
			on: aModel color: getSel changeColor: setSel)
		getEnabledSelector: enabledSel;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/6/2010 17:43'!
newColorPresenterIn: aThemedMorph for: aModel getColor: getSel help: helpText
	"Answer a color presenter."

	^(ColorPresenterMorph
			on: aModel color: getSel)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/6/2010 15:28'!
newColumnIn: aThemedMorph for: controls
	"Answer a morph laid out with a column of controls."

	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 8;
		cellPositioning: #leftCenter.
	controls do: [:m | answer addMorphBack: m].
	^answer
			! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 5/15/2007 17:41'!
newDialogPanelIn: aThemedMorph
	"Answer a new (main) dialog panel."

	^self newPanelIn: aThemedMorph! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 16:03'!
newDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a drop list for the given model."

	^(DropListMorph
			on: aModel
			list: listSel
			selected: getSel
			changeSelected: setSel
			useIndex: useIndex)
		selectionColor: self selectionColor;
		getEnabledSelector: enabledSel;
		font: self dropListFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 8/17/2010 16:06'!
newEditableDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel addToList: addSel class: aClass default: defaultValue ghostText: ghostText getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer an editable drop list for the given model."

	^(EditableDropListMorph
			on: aModel
			list: listSel
			selected: getSel
			changeSelected: setSel
			useIndex: useIndex
			addToList: addSel
			class: aClass
			getEnabled: enabledSel
			default: defaultValue)
		ghostText: ghostText;
		selectionColor: self selectionColor;
		font: self dropListFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/16/2007 14:15'!
newEmbeddedMenuIn: aThemedMorph for: aModel
	"Answer a new menu."

	^EmbeddedMenuMorph new
		defaultTarget: aModel;
		color: (self menuColorFor: aThemedMorph)! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 9/8/2011 10:43'!
newExpanderIn: aThemedMorph label: aString forAll: controls
	"Answer an expander with the given label and controls."

	|answer|
	answer := ExpanderMorph new
		font: self menuFont;
		titleText: aString.
	controls do: [:m |
		answer addMorphBack: m].
	^answer! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/6/2007 15:27'!
newFocusIndicatorMorphFor: aMorph
	"Answer a new focus indicator for the given morph."

	^BorderedMorph new
		fillStyle: Color transparent;
		borderStyle: (DashedBorder
						width: 1
						dashColors: {aMorph focusColor. Color transparent} dashLengths: #(1 1));
		bounds: aMorph focusBounds! !

!UITheme methodsFor: 'morph creation' stamp: 'MarcusDenker 9/23/2011 10:03'!
newFontSelector
	"Answer a new font selector dialog"
		^FreeTypeFontSelectorDialogWindow new
	! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 12:57'!
newFuzzyLabelIn: aThemedMorph for: aModel label: aString offset: offset alpha: alpha getEnabled: enabledSel
	"Answer a new fuzzy label."

	^(FuzzyLabelMorph contents: aString font: self labelFont)
		offset: offset;
		alpha: alpha;
		model: aModel;
		getEnabledSelector: enabledSel	! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 15:55'!
newGroupboxIn: aThemedMorph
	"Answer a plain groupbox."

	^PlainGroupboxMorph new
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/19/2006 09:59'!
newGroupboxIn: aThemedMorph for: control
	"Answer a plain groupbox."

	^(self newGroupboxIn: aThemedMorph)
		addMorph: control! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 16:19'!
newGroupboxIn: aThemedMorph forAll: controls
	"Answer a plain groupbox."

	^self
		newGroupboxIn: aThemedMorph
		for: (self newColumnIn: aThemedMorph for: controls)! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/8/2006 14:57'!
newGroupboxIn: aThemedMorph label: aString
	"Answer a groupbox with the given label."

	^GroupboxMorph new
		font: self labelFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		label: aString;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 10:12'!
newGroupboxIn: aThemedMorph label: aString for: control
	"Answer a groupbox with the given label and control."

	^(self newGroupboxIn: aThemedMorph label: aString)
		addContentMorph: control;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 14:36'!
newGroupboxIn: aThemedMorph label: aString forAll: controls
	"Answer a groupbox with the given label and controls."

	^(self newGroupboxIn: aThemedMorph label: aString)
		addContentMorph: (self newColumnIn: aThemedMorph for: controls);
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/6/2010 17:29'!
newHSVASelectorIn: aThemedMorph color: aColor help: helpText
	"Answer a hue-saturation-volume-alpha selector."

	^HSVAColorSelectorMorph new
		selectedColor: aColor;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/6/2010 17:22'!
newHSVSelectorIn: aThemedMorph color: aColor help: helpText
	"Answer a hue-saturation-volume selector."

	^HSVColorSelectorMorph new
		selectedColor: aColor;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/2/2009 13:00'!
newHueSelectorIn: aThemedMorph for: aModel getHue: getSel setHue: setSel help: helpText
	"Answer a hue selector ."

	^(HColorSelectorMorph
			on: aModel
			getValue: getSel
			setValue: setSel)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 8/30/2011 15:34'!
newImageIn: aThemedMorph for: aModel get: getSel help: helpText
	"Answer a new image morph."

	^AlphaImageMorph new
		model: aModel;
		borderStyle: (BorderStyle inset width: 0);
		getImageSelector: getSel;
		setBalloonText: helpText;
		updateImage! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 10/11/2006 13:12'!
newImageIn: aThemedMorph form: aForm
	"Answer a new text label."

	^self
		newImageIn: aThemedMorph
		form: aForm
		size: aForm extent! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 6/7/2011 15:12'!
newImageIn: aThemedMorph form: aForm size: aPoint
	"Answer a new image morph."

	^AlphaImageMorph new
		borderStyle: (BorderStyle inset width: 0);
		image: aForm size: aPoint! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/8/2009 13:17'!
newIncrementalSliderIn: aThemedMorph for: aModel getValue: getSel setValue: setSel min: min max: max quantum: quantum getEnabled: enabledSel help: helpText
	"Answer a slider inrement/decrement buttons."

	^(IncrementalSliderMorph
			on: aModel
			getValue: getSel
			setValue: setSel
			min: min
			max: max
			quantum: quantum)
		getEnabledSelector: enabledSel;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 9/8/2011 10:44'!
newLabelGroupIn: aThemedMorph for: labelsAndControls
	"Answer a morph laid out with a column of labels and a column of associated controls.
	The vResizing for each row will be #spaceFill if the control for that row specifies
	this, otherwise #shrinkWrap."

	| answer labels labelWidth lc |
	lc := labelsAndControls collect: [:a |
		(a key isMorph
			ifTrue: [a key]
			ifFalse: [a key ifNotNil: [self newLabelIn: aThemedMorph label: a key asString]])
			-> a value].
	answer := Morph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent;
		changeTableLayout;
		cellInset: 4.
	labels := Morph new
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		changeTableLayout.
	lc do: [:a |
		a key ifNotNil: [labels addMorphBack: a key]].
	labelWidth := labels minExtent x.
	lc do: [:a | | row |
		a key ifNotNil: [a key hResizing: #rigid; extent: labelWidth@ a key height].
		row := self newRowIn: aThemedMorph for: (a key ifNil: [{a value}] ifNotNil: [{a key. a value}]).
		row vResizing: (a value vResizing = #spaceFill ifTrue: [#spaceFill] ifFalse: [#shrinkWrap]).
		answer addMorphBack: row].
	^answer
			! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 7/22/2011 13:37'!
newLabelGroupIn: aThemedMorph for: labelsAndControls font: aFont labelColor: aColor
	"Answer a morph laid out with a column of labels and a column of associated controls.
	If spaceFill is tru then each row will share available space to pad."

	| answer labels labelWidth lc|
	lc := labelsAndControls collect: [:a |
		(a key isMorph
			ifTrue: [a key]
			ifFalse: [(self newLabelIn: aThemedMorph label: (a key ifNil: ['']) asString)
						font: aFont;
						color: aColor])
			-> a value].
	answer := Morph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent;
		changeTableLayout;
		cellInset: 4.
	labels := Morph new
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		changeTableLayout.
	lc do: [:a |
		labels addMorphBack: a key].
	labelWidth := labels minExtent x.
	lc do: [:a | | row |
		a key hResizing: #rigid; extent: labelWidth@ a key height.
		row := self newRowIn: aThemedMorph for: {a key. a value}.
		row vResizing: (a value vResizing = #spaceFill ifTrue: [#spaceFill] ifFalse: [#shrinkWrap]).
		answer addMorphBack: row].
	^answer
			
! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 7/30/2010 13:28'!
newLabelIn: aThemedMorph for: aModel getLabel: labelSel getEnabled: enabledSel
	"Answer a new text label."

	^(LabelMorph contents: '' font: self labelFont)
		model: aModel;
		getEnabledSelector: enabledSel;
		getTextSelector: labelSel! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/16/2007 15:49'!
newLabelIn: aThemedMorph for: aModel label: aString getEnabled: enabledSel
	"Answer a new text label."

	^(LabelMorph contents: aString font: self labelFont)
		model: aModel;
		getEnabledSelector: enabledSel! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/16/2007 15:49'!
newLabelIn: aThemedMorph label: aString
	"Answer a new text label."

	^self
		newLabelIn: aThemedMorph
		for: nil
		label: aString
		getEnabled: nil! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/7/2007 11:43'!
newListIn: aThemedMorph for: aModel list: listSelector selected: getSelector changeSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a list for the given model."

	^PluggableListMorph new
		selectionColor: self selectionColor;
		font: self listFont;
		on: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		menu: nil
		keystroke: nil;
		autoDeselect: false;
		cornerStyle: aThemedMorph preferredCornerStyle;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		getEnabledSelector: enabledSel;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 7/15/2011 10:17'!
newListIn: aThemedMorph for: aModel list: listSelector selected: getSelector changeSelected: setSelector icon: iconSelector getEnabled: enabledSel help: helpText
	"Answer an icon list for the given model."

	^PluggableIconListMorph new
		selectionColor: self selectionColor;
		font: self listFont;
		on: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		menu: nil
		keystroke: nil;
		autoDeselect: false;
		cornerStyle: aThemedMorph preferredCornerStyle;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		getIconSelector: iconSelector;
		getEnabledSelector: enabledSel;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 10/26/2006 16:48'!
newMenuIn: aThemedMorph for: aModel
	"Answer a new menu."

	^MenuMorph new
		defaultTarget: aModel;
		color: (self menuColorFor: aThemedMorph)! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 13:16'!
newMorphDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a morph drop list for the given model."

	^self
		newMorphDropListIn: aThemedMorph
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 6/1/2009 13:18'!
newMorphDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a morph drop list for the given model."

	^(MorphDropListMorph
			on: aModel
			list: listSel
			selected: getSel
			changeSelected: setSel
			useIndex: useIndex)
		selectionColor: self selectionColor;
		getEnabledSelector: enabledSel;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 10/1/2007 12:16'!
newMorphListIn: aThemedMorph for: aModel list: listSelector getSelected: getSelector setSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a morph list for the given model."

	^(PluggableMorphListMorph
			on: aModel
			list: listSelector
			selected: getSelector
			changeSelected: setSelector
			menu: nil
			keystroke: nil)
		selectionColor: self selectionColor;
		autoDeselect: false;
		cornerStyle: aThemedMorph preferredCornerStyle;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		getEnabledSelector: enabledSel;
		setBalloonText: helpText
		! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 10/5/2010 13:40'!
newMultistateButtonIn: aThemedMorph
	"Answer a new multistate button morph."

	^MultistateButtonMorph new! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/16/2007 15:51'!
newNoButtonIn: aThemedMorph for: aModel
	"Answer a new No button."

	^(self
			newButtonIn: aThemedMorph
			for: aModel
			getState: nil
			action: #no
			arguments: nil
			getEnabled: nil
			label: 'No' translated
			help: 'Answer no and close the window' translated)
		hResizing: #rigid;
		vResizing: #rigid! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/23/2007 15:57'!
newOKButtonIn: aThemedMorph for: aModel getEnabled: enabledSel
	"Answer a new OK button."

	^(self
			newButtonIn: aThemedMorph
			for: aModel
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: enabledSel
			label: 'OK' translated
			help: 'Apply changes and close the window' translated)
		hResizing: #rigid;
		vResizing: #rigid! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 10/5/2010 13:50'!
newOverflowRowIn: aThemedMorph forAll: aCollectionOfMorphs
	"Answer a new overflow row morph with the given contents."

	^OverflowRowMorph new
		baseMorphs: aCollectionOfMorphs;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/4/2007 11:54'!
newPanelIn: aThemedMorph
	"Answer a new panel."

	^PanelMorph new
		changeTableLayout;
		layoutInset: 4;
		cellInset: 8;
		cornerStyle: aThemedMorph preferredCornerStyle;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 7/30/2009 14:12'!
newPluggableDialogWindowIn: aThemedMorph title: title for: contentMorph
	"Answer a new pluggable dialog panel with the given content."

	|answer|
	answer := PluggableDialogWindow new
		setWindowColor: aThemedMorph paneColor;
		title: title;
		contentMorph: contentMorph.
	contentMorph ifNotNil: [answer model: nil].
	^answer! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 5/22/2007 15:39'!
newRadioButtonIn: aThemedMorph for: aModel getSelected: getSel setSelected: setSel getEnabled: enabledSel label: label help: helpText
	"Answer a checkbox (radio button appearance) with the given label ."

	^(CheckboxMorph
			on: aModel selected: getSel changeSelected: setSel)
		getEnabledSelector: enabledSel;
		font: self labelFont;
		label: label;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		setBalloonText: helpText;
		beRadioButton! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 10/25/2007 17:27'!
newRadioButtonMarkerForm
	"Answer a new radio button marker form."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 2533359616 2533359616 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2399141888 4278190080 4278190080 4278190080 4009754624 2399141888 16777215 16777215 16777215 16777215 16777215 1207959552 4278190080 4278190080 4278190080 4278190080 4278190080 4143972352 1207959552 16777215 16777215 16777215 16777215 2533359616 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2533359616 16777215 16777215 16777215 16777215 2533359616 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2399141888 16777215 16777215 16777215 16777215 1207959552 4278190080 4278190080 4278190080 4278190080 4143972352 4278190080 1073741824 16777215 16777215 16777215 16777215 16777215 2399141888 4278190080 4278190080 4278190080 4278190080 2399141888 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 2533359616 2533359616 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/6/2010 16:12'!
newRowIn: aThemedMorph for: controls
	"Answer a morph laid out with a row of controls."

	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8;
		cellPositioning: #center.
	controls do: [:m | answer addMorphBack: m].
	^answer
			! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/6/2010 17:24'!
newSVSelectorIn: aThemedMorph color: aColor help: helpText
	"Answer a saturation-volume selector."

	^SVColorSelectorMorph new
		color: aColor;
		selectedColor: aColor;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: helpText! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 10/5/2010 13:30'!
newScrollPaneIn: aThemedMorph for: aMorph
	"Answer a new GeneralScrollPane with given content morph."

	^GeneralScrollPane new
		scrollTarget: aMorph;
		yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/23/2007 16:25'!
newSeparatorIn: aThemedMorph
	"Answer a new horizontal separator."

	^SeparatorMorph new
		fillStyle: Color transparent;
		borderStyle: (BorderStyle inset baseColor: Color blue; width: 1);
		extent: 2@2;
		hResizing: #spaceFill! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 1/20/2011 12:06'!
newSliderIn: aThemedMorph for: aModel getValue: getSel setValue: setSel min: min max: max quantum: quantum getEnabled: enabledSel help: helpText
	"Answer a slider. Resizing set for horizontal usage by default."

	^(PluggableSliderMorph
			on: aModel
			getValue: getSel
			setValue: setSel
			min: min
			max: max
			quantum: quantum)
		getEnabledSelector: enabledSel;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		setBalloonText: helpText;
		minHeight: 16! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 10/21/2009 14:44'!
newStackIn: aThemedMorph for: controls
	"Answer a morph laid out with a stack of controls."

	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		layoutPolicy: StackLayout new.
	controls do: [:m | answer addMorphBack: m].
	^answer
			! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/9/2007 11:41'!
newStringIn: aThemedMorph label: aStringOrText font: aFont style: aStyle
	"Answer a new string/text morph."

	^(EmbossedStringMorph contents: aStringOrText font: aFont)
		style: aStyle! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/17/2008 11:28'!
newTabGroupIn: aThemedMorph for: labelsAndControls
	"Answer a tab group morph with the given tab labels and associated pages."

	^(TabGroupMorph new
		font: self labelFont;
		cornerStyle: (self tabGroupCornerStyleIn: aThemedMorph);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		labelsAndPages: labelsAndControls)
		selectedPageIndex: (labelsAndControls isEmpty ifTrue: [0] ifFalse: [1])! !

!UITheme methodsFor: 'morph creation' stamp: 'NickAlexander 2/6/2011 12:46'!
newTaskbarButtonIn: aTaskbar for: aWindow
	"Answer a taskbar button morph for the given window."

	|lm lab button labSize|
	labSize := (150 // (aTaskbar tasks size + 1) max: 10) min: 30.
	lab := (self buttonLabelForText: (aWindow taskbarLabel truncateWithElipsisTo: labSize)).
	aWindow isActive
		ifTrue: [ lab emphasis: 1 "1 -> bold" ].
	lm := self
		newRowIn: aTaskbar
		for: {(aWindow taskbarIcon ifNil: [^nil]) asMorph. lab}.
	lm cellInset: 2.
	button := self
		newButtonIn: aTaskbar
		for: aWindow
		getState: #isActive
		action: #taskbarButtonClicked
		arguments: #()
		getEnabled: nil
		label: lm
		help: nil.
	button
		wantsYellowButtonMenu: true;
		getMenuSelector: #taskbarButtonMenu:;
		on: #mouseEnter send: #taskbarButtonEntered:event:in: to: aWindow withValue: button;
		on: #mouseLeave send: #taskbarButtonLeft:event:in: to: aWindow withValue: button.
	aWindow isCollapsed
		ifTrue:  [ lab color: (self taskbarButtonLabelColorForCollapsed: button) ]
		ifFalse: [ lab color: (self taskbarButtonLabelColorForExpanded: button). ].
	^button! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/2/2009 12:31'!
newTaskbarThumbnailIn: aThemedMorph for: aWindow
	"Answer a taskbar thumbnail morph for the given window."

	|answer thumb|
	thumb := aWindow taskbarThumbnail.
	answer := PanelMorph new
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		layoutInset: 8;
		cellInset: 4;
		addMorphBack: thumb;
		addMorphBack: (self
			buttonLabelForText: (aWindow labelString truncateWithElipsisTo: 50)).
	answer
		extent: answer minExtent;
		fillStyle: (self tasklistFillStyleFor: answer);
		borderStyle: (self taskbarThumbnailNormalBorderStyleFor: aWindow);
		cornerStyle: (self taskbarThumbnailCornerStyleFor: answer).
	^answer! !

!UITheme methodsFor: 'morph creation' stamp: 'AlainPlantec 9/22/2011 00:40'!
newTasklistButtonIn: aTasklist for: aTask
	"Answer a tasklist button morph for the given task."
	
	|lm lab button |
	lab := (self buttonLabelForText: (aTask label contractTo: 40)).
	aTask isActive
		ifTrue: [ lab emphasis: 1 "1 -> bold" ].
	lm := self
		newRowIn: aTasklist
		for: {(aTask icon ifNil: [self smallWindowIcon]) asMorph. lab}.
	button := self
		newButtonIn: aTasklist
		for: aTask morph
		getState: #isActive
		action: #buttonClickedForTasklist:
		arguments: {aTasklist}
		getEnabled: nil
		label: lm
		help: nil.
	button
		useSquareCorners;
		onColor: (self taskbarMinimizedButtonColorFor: button)
		offColor: (aTask isActive
				ifTrue: [self taskbarActiveButtonColorFor: button]
				ifFalse: [self taskbarButtonColorFor: button]);
		hResizing: #spaceFill.
	lab color: (self taskbarButtonLabelColorFor: button).
	button model: aTask.
	^button! !

!UITheme methodsFor: 'morph creation' stamp: 'FernandoOlivero 5/30/2011 07:48'!
newTextEditorIn: aThemedMorph for: aModel getText: getSel setText: setSel getEnabled: enabledSel
	^ self newTextEditorIn: aThemedMorph for: aModel getText: getSel setText: setSel getEnabled: enabledSel menu: nil! !

!UITheme methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 5/30/2011 07:48'!
newTextEditorIn: aThemedMorph for: aModel getText: getSel setText: setSel getEnabled: enabledSel menu: aMenuSelector
	"Answer a text editor for the given model."

	^PluggableTextMorph new
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: aMenuSelector ;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		selectionColor: self selectionColor! !

!UITheme methodsFor: 'morph creation' stamp: 'AlainPlantec 11/27/2010 16:45'!
newTextEntryIn: aThemedMorph for: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText
	"Answer a text entry for the given model."

	|pt|
	pt := PluggableTextFieldMorph new
		convertTo: aClass;
		alwaysAccept: true;
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: (self textEntryCornerStyleIn: aThemedMorph);
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		selectionColor: self selectionColor;
		hideScrollBarsIndefinitely;
		extent: 24@(self textFont height + 8);
		setBalloonText: helpText.
	pt textMorph
		autoFit: true;
		wrapFlag: false;
		margins: (2@1 corner: 2@1).
	^pt! !

!UITheme methodsFor: 'morph creation' stamp: 'AlainPlantec 11/25/2010 17:47'!
newTextEntryIn: aThemedMorph for: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText entryCompletion: anEntryCompletion
	"Answer a text entry for the given model."

	|pt|
	pt := PluggableTextFieldMorph new
		convertTo: aClass;
		alwaysAccept: true;
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: (self textEntryCornerStyleIn: aThemedMorph);
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		selectionColor: self selectionColor;
		hideScrollBarsIndefinitely;
		extent: 24@(self textFont height + 8);
		setBalloonText: helpText;
		entryCompletion: anEntryCompletion.

	pt textMorph
		autoFit: true;
		wrapFlag: false;
		margins: (2@1 corner: 2@1).
	^pt! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/11/2006 09:46'!
newTextIn: aThemedMorph text: aStringOrText
	"Answer a new text."

	^TextMorph new
		wrapFlag: true;
		contents: aStringOrText;
		font: self textFont;
		autoFit: true;
		lock;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 8/25/2006 14:38'!
newTitleIn: aThemedMorph label: aString for: control
	"Answer a morph laid out with a column with the title and control aligned to the left."

	^(self newColumnIn: aThemedMorph for: {
		self newLabelIn: aThemedMorph label: aString.
		control})
		cellPositioning: #leftCenter;
		cellInset: 2! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 6/20/2007 09:37'!
newToolDockingBarIn: aThemedMorph
	"Answer a new tool docking bar."

	^ToolDockingBarMorph new
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		clipSubmorphs: true! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 9/19/2006 10:03'!
newToolSpacerIn: aThemedMorph
	"Answer a new tool spacer."

	^Morph new
		borderWidth: 0;
		color: Color transparent;
		extent: 3@3! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 4/16/2007 11:08'!
newToolbarHandleIn: aThemedMorph
	"Answer a new toolbar handle."

	^PanelMorph new
		fillStyle: Color transparent; "non pane color tracking"
		borderStyle: (BorderStyle raised baseColor: Color blue; width: 1);
		extent: 4@3;
		vResizing: #spaceFill! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 2/25/2010 19:53'!
newToolbarIn: aThemedMorph
	"Answer a new toolbar."

	|bar|
	bar := PanelMorph new
		changeTableLayout;
		layoutInset: (0@1 corner: 0@1);
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	bar
		addMorphBack: (self newToolSpacerIn: aThemedMorph);
		addMorphBack: (self newToolbarHandleIn: aThemedMorph);
		addMorphBack: (self newToolSpacerIn: aThemedMorph).
	^bar! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 7/30/2009 14:12'!
newToolbarIn: aThemedMorph for: controls
	"Answer a new toolbar with the given controls."

	|answer|
	answer := self newToolbarIn: aThemedMorph.
	controls do: [:m | answer addMorphBack: m].
	^answer! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/14/2007 11:44'!
newTreeExpandedForm
	"Answer a new form for an expanded tree item."

	^(Form
		extent: 9@9
		depth: 32
		fromArray: #( 3749280121 4285822068 4285822068 4285822068 4285822068 4285822068 4285822068 4285822068 3816191606 4218778997 4293256677 4293322470 4292861919 4292401368 4291940817 4291546059 4290953922 4285822068 4218778997 4293059298 4293125091 4292664540 4292203989 4291743438 4291282887 4290624957 4285822068 4218778997 4292664540 4292664540 4292203989 4291743438 4291282887 4290822336 4290164406 4285822068 4218778997 4291809231 4278519045 4278519045 4278519045 4278519045 4278519045 4289769648 4285822068 4218778997 4291743438 4291743438 4291282887 4290822336 4290361785 4289901234 4289309097 4285822068 4218778997 4291348680 4291282887 4290822336 4290361785 4289901234 4289440683 4288848546 4285822068 4218778997 4290559164 4290493371 4290032820 4289638062 4289177511 4288716960 4288256409 4285822068 3665262455 4218713204 4218713204 4218713204 4218713204 4218713204 4218713204 4218713204 3749016949)
		offset: 0@0)
			asFormOfDepth: Display depth;
			replaceColor: Color white withColor: Color transparent;
			yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 10/17/2006 12:27'!
newTreeIn: aThemedMorph for: aModel list: listSelector selected: getSelector changeSelected: setSelector
	"Answer a new tree morph."
	
	^TreeListMorph new
		selectionColor: self selectionColor;
		font: self listFont;
		on: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		menu: nil
		keystroke: nil;
		cornerStyle: aThemedMorph preferredCornerStyle;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		autoDeselect: false;
		yourself
		! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/14/2007 11:44'!
newTreeUnexpandedForm
	"Answer a new form for an unexpanded tree item."

	^(Form
		extent: 9@9
		depth: 32
		fromArray: #( 3749280121 4285822068 4285822068 4285822068 4285822068 4285822068 4285822068 4285822068 3816191606 4218778997 4293256677 4293322470 4292861919 4292401368 4291940817 4291546059 4290953922 4285822068 4218778997 4293059298 4293125091 4292203989 4278519045 4291348680 4291282887 4290624957 4285822068 4218778997 4292664540 4292664540 4291743438 4278190080 4290822336 4290822336 4290164406 4285822068 4218778997 4291809231 4278519045 4278519045 4278190080 4278519045 4278519045 4289769648 4285822068 4218778997 4291743438 4291743438 4290822336 4278190080 4289967027 4289901234 4289309097 4285822068 4218778997 4291348680 4291282887 4290361785 4278190080 4289506476 4289440683 4288848546 4285822068 4218778997 4290559164 4290493371 4290032820 4289638062 4289177511 4288716960 4288256409 4285822068 3665262455 4218713204 4218713204 4218713204 4218713204 4218713204 4218713204 4218713204 3749016949)
		offset: 0@0)
			asFormOfDepth: Display depth;
			replaceColor: Color white withColor: Color transparent;
			yourself! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 1/23/2007 16:39'!
newVerticalSeparatorIn: aThemedMorph
	"Answer a new vertical separator."

	^SeparatorMorph new
		fillStyle: Color transparent;
		borderStyle: (BorderStyle inset baseColor: Color blue; width: 1);
		extent: 2@2;
		vResizing: #spaceFill! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/24/2007 10:11'!
newWindowCloseForm
	"Answer a new form for a window close box."

	^Form
		extent: 10@10
		depth: 32
		fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 3326099520 3330310272 0 0 0 0 0 0 0 0 4144038145 3326099520 3330310272 0 0 0 4144038145 3326099520 0 0 0 4227924225 3326099520 3330310272 0 4144038145 3326099520 3330310272 0 0 0 0 4144038145 3326099520 4144038145 3326099520 3330310272 3336494814 0 0 0 0 0 4227924225 3326099520 3330310272 3336494814 0 0 0 0 0 4144038145 3326099520 4144038145 3326099520 3330310272 3336494814 0 0 0 4144038145 3326099520 3330310272 3336494814 4144038145 3326099520 3330310272 0 0 4144038145 3326099520 3330310272 3336494814 0 0 4144038145 3326099520 0 0 0 3330310272 3336494814 0 0 0 0 0 0)
		offset: 0@0! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 10/5/2010 13:26'!
newWindowIn: aThemedMorph for: aModel title: titleString
	"Answer a new StandardWindow with given model and title."

	^StandardWindow new
		title: titleString;
		model: aModel;
		yourself! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/24/2007 10:11'!
newWindowMaximizeForm
	"Answer a new form for a window maximize box."

	^Form
		extent: 10@10
		depth: 32
		fromArray: #( 3875602689 3875602689 3875602689 3875602689 3875602689 3875602689 0 0 0 0 3875602689 0 0 0 0 4127260929 3877181721 3877181721 3875602689 0 3875602689 0 0 0 0 3875602689 3212869760 0 3875602689 3212869760 3875602689 0 0 0 0 3875602689 3212869760 0 3875602689 3212869760 3875602689 0 0 0 0 3875602689 3212869760 0 3875602689 3212869760 3875602689 4127260929 3875602689 3875602689 3875602689 3875602689 3212869760 0 3875602689 3212869760 0 3877181721 3212869760 3212869760 3212869760 3212869760 3212869760 0 3875602689 3212869760 0 3877181721 0 0 0 0 0 0 3875602689 3212869760 0 3875602689 3875602689 3875602689 3875602689 3875602689 3875602689 3875602689 3875602689 3212869760 0 0 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760)
		offset: 0@0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/24/2007 10:12'!
newWindowMenuForm
	"Answer a new form for a window menu box."

	^Form
		extent: 10@10
		depth: 32
		fromArray: #( 4227858432 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4227858432 0 4127195136 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 4127195136 3212869760 4127195136 3212869760 0 0 0 0 0 0 4127195136 3212869760 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 3212869760 4127195136 3212869760 0 0 0 0 0 0 4127195136 3212869760 4127195136 3212869760 0 0 0 0 0 0 4127195136 3212869760 4227858432 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 3212869760 4127195136 3212869760 0 0 0 0 0 0 4127195136 3212869760 4227858432 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4127195136 4227858432 3212869760 0 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760)
		offset: 0@0! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 5/24/2007 10:11'!
newWindowMinimizeForm
	"Answer a new form for a window minimize box."

	^Form
		extent: 10@10
		depth: 32
		fromArray: #( 0 0 4127260929 4127260929 4127260929 4127260929 4127260929 0 0 0 0 3875602689 3212869760 3212869760 3212869760 3212869760 3212869760 4227924225 0 0 4127260929 3212869760 3212869760 0 0 0 0 3212869760 4127260929 0 4127260929 3212869760 0 0 0 0 0 0 4127260929 3212869760 4127260929 3212869760 0 0 0 0 0 0 4127260929 3212869760 4127260929 3212869760 0 0 0 0 0 0 4127260929 3212869760 4128708375 3212869760 0 0 0 0 0 0 4127260929 3212869760 0 4127260929 3212869760 0 0 0 0 4127260929 3208659008 3212869760 0 3208659008 4127260929 4127260929 4127260929 4127260929 4127260929 3208659008 3212869760 0 0 0 3212869760 3212869760 3212869760 3212869760 3212869760 3212869760 0 0)
		offset: 0@0! !

!UITheme methodsFor: 'morph creation' stamp: 'GaryChambers 10/5/2010 14:06'!
newWorkAreaIn: aThemedMorph
	"Answer a new work area morph."

	^WorkAreaMorph new! !

!UITheme methodsFor: 'morph creation' stamp: 'gvc 3/16/2007 15:51'!
newYesButtonIn: aThemedMorph for: aModel
	"Answer a new Yes button."

	^(self
			newButtonIn: aThemedMorph
			for: aModel
			getState: nil
			action: #yes
			arguments: nil
			getEnabled: nil
			label: 'Yes' translated
			help: 'Answer yes and close the window' translated)
		hResizing: #rigid;
		vResizing: #rigid! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
objectsIcon
	^ ThemeIcons objectsIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
openIcon
	^ ThemeIcons openIcon! !

!UITheme methodsFor: 'services' stamp: 'gvc 4/20/2007 15:04'!
openTasklist: event
	"Open a tasklist to choose a window.
	Answer true if handled, false otherwise."

	Sensor commandKeyPressed ifFalse: [^false].
	 event keyCharacter = Character arrowLeft
		ifTrue: [TasklistMorph new openAsIs selectPreviousTask.
			^true].
	event keyCharacter = Character arrowRight
		ifTrue: [TasklistMorph new openAsIs selectNextTask.
			^true].
	^false! !

!UITheme methodsFor: 'cursor' stamp: 'AlainPlantec 2/1/2011 09:39'!
overTextCursorFor: aTextMorph
	"Answer the pointer cursor when over an active text 
	(answer nil if no particular cursor is wanted)."

	^ Cursor overEditableText! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
paintIcon
	^ ThemeIcons paintIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
paintTabIcon
	^ ThemeIcons paintTabIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
paintingIcon
	^ ThemeIcons paintingIcon! !

!UITheme methodsFor: 'fill-styles' stamp: 'GaryChambers 2/15/2011 12:40'!
paneColorFor: aWindow
	"Answer the pane color that should be used."
	
	| cc |
	(cc := aWindow valueOfProperty: #paneColor) 
		ifNotNil: [
			^self settings fadedBackgroundWindows
				ifTrue: [aWindow isActive
					ifTrue: [cc]
					ifFalse: [cc alphaMixed: 0.5 with: (Color white alpha: cc alpha)]]
				ifFalse: [cc]].
	cc := aWindow paneMorphs isEmptyOrNil ifFalse: [aWindow paneMorphs first color].
	aWindow setProperty: #paneColor toValue: (cc ifNil: [aWindow defaultBackgroundColor]).
	^aWindow paneColor! !

!UITheme methodsFor: 'services' stamp: 'gvc 12/3/2008 14:07'!
passwordEntryIn: aThemedMorph text: aStringOrText title: aString entryText: defaultEntryText
	"Answer the result of a password entry dialog (a string or nil if cancelled)
	with the given label and title."

	^(aThemedMorph openModal: (
		PasswordDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText;
			entryText: defaultEntryText)) entryText! !

!UITheme methodsFor: 'basic-colors' stamp: 'AlainPlantec 12/16/2009 22:13'!
patchworkUIThemeColorFor: aWindowOrModel
	"Answer the colour for the given window."
	^ aWindowOrModel ifNotNil: [
		(aWindowOrModel respondsTo: #patchworkUIThemeColor) 
		ifTrue: [aWindowOrModel patchworkUIThemeColor]
		ifFalse: [(aWindowOrModel class respondsTo: #patchworkUIThemeColor) 
			ifTrue: [aWindowOrModel class patchworkUIThemeColor]
			ifFalse: [self settings windowColor]]]! !

!UITheme methodsFor: 'icons' stamp: 'tbn 8/23/2010 18:20'!
pharoIcon
	"Answer an information icon."

	^ThemeIcons pharoIcon! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 1/17/2008 11:44'!
plainGroupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a plain group panel."

	^BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!UITheme methodsFor: 'copying' stamp: 'gvc 9/22/2006 17:20'!
postCopy
	"Copy the settings too."
	
	super postCopy.
	self settings: self settings copy! !

!UITheme methodsFor: 'fill-styles' stamp: 'AlainPlantec 12/13/2009 11:29'!
preferGradientFill
	^ self settings preferGradientFill! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:15'!
proceedIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of a proceed dialog with the given label and title."

	self questionSound play.
	^(aThemedMorph openModal: (
		ProceedDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) cancelled not! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 4/25/2007 17:17'!
progressBarBorderStyleFor: aProgressBar
	"Return the progress bar borderStyle for the given progress bar."

	|c|
	c := self progressBarColorFor: aProgressBar.
	^BorderStyle simple
		width: 1;
		baseColor: c darker! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 4/23/2007 17:22'!
progressBarColorFor: aProgressBar
	"Answer the colour for the given progress bar."

	^self settings progressBarColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/24/2007 11:44'!
progressBarFillStyleFor: aProgressBar
	"Return the progress bar fillStyle for the given progress bar."
	
	|aColor area|
	aColor := self progressBarColorFor: aProgressBar.
	area :=  aProgressBar bounds.
	^(GradientFillStyle ramp: {
			0.0->aColor darker duller. 0.2-> aColor darker.
			0.8->aColor twiceLighter. 1.0->aColor})	
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 4/24/2007 11:45'!
progressBarProgressColorFor: aProgressBar
	"Answer the colour for the progress part of the given progress bar."

	^self settings progressBarProgressColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/24/2007 11:47'!
progressBarProgressFillStyleFor: aProgressBar
	"Return the progress bar progress fillStyle for the given progress bar."
	
	|aColor area|
	aColor := self progressBarProgressColorFor: aProgressBar.
	area :=  aProgressBar innerBounds.
	^(GradientFillStyle ramp: {
			0.0->(aColor alphaMixed: 0.3 with: (Color white alpha: aColor alpha)).
			0.2-> aColor twiceLighter.
			0.8->aColor darker.
			1.0->aColor darker duller})	
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UITheme methodsFor: 'fill-styles' stamp: 'HilaireFernandes 8/3/2010 10:20'!
progressFillStyleFor: aProgress
	"Return the progress fillStyle for the given progress morph."
	| fill |
	fill := GradientFillStyle ramp: {0.0 -> Color white. 1 ->aProgress color}.
	fill radial: false;
		origin: aProgress topLeft;
		direction: 0 @ aProgress height.
	^ fill! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
projectIcon
	^ ThemeIcons projectIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
publishIcon
	^ ThemeIcons publishIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:27'!
questionIcon
	"Answer a question icon."

	^ThemeIcons questionIcon! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:15'!
questionIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of a question dialog with the given label and title."

	self questionSound play.
	^(aThemedMorph openModal: (
		QuestionDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) answer! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:43'!
questionSound
	"Answer the question sound."

	^self soundTheme questionSound! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:15'!
questionWithoutCancelIn: aThemedMorph text: aStringOrText title: aString
	"Answer the result of a question dialog with the given label and title."

	self questionSound play.
	^(aThemedMorph openModal: (
		QuestionWithoutCancelDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText)) answer! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 12/8/2008 19:17'!
radioButtonCornerStyleFor: aRadioButton
	"Answer the corner style for radio buttons."
	
	^#rounded! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 8/10/2007 10:14'!
radioButtonDisabledBorderStyleFor: aRadioButton
	"Return the disabled radio button borderStyle for the given button."

	^self checkboxButtonDisabledBorderStyleFor: aRadioButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 8/10/2007 11:48'!
radioButtonDisabledFillStyleFor: aRadioButton
	"Return the disabled radio button fillStyle for the given button."
	
	^self checkboxButtonDisabledFillStyleFor: aRadioButton! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 10/25/2007 17:06'!
radioButtonMarkerForm
	"Answer the form to use for a radio button marker."

	^self forms at: #radioButtonMarker ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 8/10/2007 10:14'!
radioButtonNormalBorderStyleFor: aRadioButton
	"Return the disabled radio button borderStyle for the given button."

	^self checkboxButtonNormalBorderStyleFor: aRadioButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 8/10/2007 11:48'!
radioButtonNormalFillStyleFor: aRadioButton
	"Return the normal radio button fillStyle for the given button."
	
	^self checkboxButtonNormalFillStyleFor: aRadioButton! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
radioButtonOffIcon
	^ ThemeIcons radioButtonOffIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
radioButtonOnIcon
	^ ThemeIcons radioButtonOnIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
radioButtonPressedIcon
	^ ThemeIcons radioButtonPressedIcon! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 2/29/2008 22:08'!
radioButtonSelectedBorderStyleFor: aRadioButton
	"Return the selected radio button borderStyle for the given button."

	^self radioButtonNormalBorderStyleFor: aRadioButton! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'gvc 2/29/2008 22:01'!
radioButtonSelectedDisabledBorderStyleFor: aRadioButton
	"Return the selecteddisabled radio button borderStyle for the given button."

	^self radioButtonDisabledBorderStyleFor: aRadioButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 2/29/2008 21:50'!
radioButtonSelectedDisabledFillStyleFor: aRadioButton
	"Return the selected disabled radio button fillStyle for the given button."
	
	^self checkboxButtonSelectedDisabledFillStyleFor: aRadioButton! !

!UITheme methodsFor: 'fill-styles-buttons' stamp: 'gvc 2/29/2008 21:50'!
radioButtonSelectedFillStyleFor: aRadioButton
	"Return the selected radio button fillStyle for the given button."
	
	^self checkboxButtonSelectedFillStyleFor: aRadioButton! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 3/27/2008 21:35'!
resizerGripNormalFillStyleFor: aResizer
	"Return the normal fillStyle for the given resizer.
	For the moment, answer a transparent colour for no drawing,
	non transparent to draw as normal."
	
	^Color white! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
rotateIcon
	^ ThemeIcons rotateIcon! !

!UITheme methodsFor: 'services' stamp: 'StephaneDucasse 6/5/2011 22:39'!
runModal: aWidget
	
	[aWidget world notNil] whileTrue: [
		aWidget outermostWorldMorph doOneCycle]! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
scaleIcon
	^ ThemeIcons scaleIcon! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:45'!
scrollBarButtonArrowVertices: aRectangle 
	^ self verticesForComplexArrow: aRectangle! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 1/27/2009 16:43'!
scrollPaneDisabledBorderStyleFor: aScrollPane
	"Return the disabled borderStyle for the given scroll pane."

	^self scrollPaneNormalBorderStyleFor: aScrollPane! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 1/27/2009 16:43'!
scrollPaneNormalBorderStyleFor: aScrollPane
	"Return the normal borderStyle for the given scroll pane"

	^BorderStyle inset
		width: 1;
		baseColor: aScrollPane paneColor! !

!UITheme methodsFor: 'label-styles' stamp: 'AlainPlantec 12/17/2009 11:33'!
scrollbarArrowOfDirection: aSymbol size: finalSizeInteger color: aColor
	"Answer a new scrollbar arrow form (normally cached by Scrollbar)."
	
	^self basicCreateArrowOfDirection: aSymbol size: finalSizeInteger color: aColor! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 10/24/2007 15:14'!
scrollbarButtonCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#square! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 4/16/2007 12:59'!
scrollbarColorFor: aScrollbar
	"Answer the colour for the given scrollbar."

	^self settings standardColorsOnly
		ifTrue: [self settings scrollbarColor]
		ifFalse: [(aScrollbar valueOfProperty: #lastPaneColor)
					 ifNil: [Color white]]! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/26/2007 14:02'!
scrollbarImageColorFor: aScrollbar
	"Return the scrollbar image colour (on buttons) for the given scrollbar."
	
	^self scrollbarColorFor: aScrollbar! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 10/7/2008 11:45'!
scrollbarMinimumThumbThickness
	"Answer the minumum width or height of a scrollbar thumb 
	as appropriate to its orientation."
	
	^7! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:15'!
scrollbarMouseOverBarButtonBorderStyleFor: aScrollbar
	"Return the button borderStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalButtonBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 15:15'!
scrollbarMouseOverBarButtonFillStyleFor: aScrollbar
	"Return the button fillStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalButtonFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:41'!
scrollbarMouseOverBarThumbBorderStyleFor: aScrollbar
	"Return the thumb borderStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 15:42'!
scrollbarMouseOverBarThumbFillStyleFor: aScrollbar
	"Return the thumb fillStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:16'!
scrollbarMouseOverBorderStyleFor: aScrollbar
	"Return the mouse over borderStyle for the given scrollbar."

	^self scrollbarNormalBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:16'!
scrollbarMouseOverButtonBorderStyleFor: aScrollbar
	"Return the mouse over button borderStyle for the given scrollbar."

	^self scrollbarNormalButtonBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:09'!
scrollbarMouseOverButtonFillStyleFor: aScrollbar
	"Return the scrollbar mouse over button fillStyle for the given color."

	^self scrollbarNormalButtonFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:08'!
scrollbarMouseOverFillStyleFor: aScrollbar
	"Return the scrollbar mouse over fillStyle for the given color."

	^self scrollbarNormalFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:16'!
scrollbarMouseOverThumbBorderStyleFor: aScrollbar
	"Return the mouse over thumb borderStyle for the given scrollbar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:50'!
scrollbarMouseOverThumbButtonBorderStyleFor: aScrollbar
	"Return the button borderStyle for the given scrollbar when
	the mouse is over the thumb."

	^self scrollbarMouseOverBarButtonBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 15:51'!
scrollbarMouseOverThumbButtonFillStyleFor: aScrollbar
	"Return the button fillStyle for the given scrollbar when
	the mouse is over the thumb."

	^self scrollbarMouseOverBarButtonFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:15'!
scrollbarMouseOverThumbFillStyleFor: aScrollbar
	"Return the scrollbar mouse over thumb fillStyle for the given color."

	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:30'!
scrollbarNormalBorderStyleFor: aScrollbar
	"Return the normal button borderStyle for the given scrollbar."

	^BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 3/30/2007 10:27'!
scrollbarNormalButtonBorderStyleFor: aScrollbar
	"Return the normal button borderStyle for the given scrollbar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:28'!
scrollbarNormalButtonFillStyleFor: aScrollbar
	"Return the normal scrollbar button fillStyle for the given scrollbar."
	
	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/17/2007 11:36'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^(aColor alphaMixed: 0.4 with: Color white)
		alphaMixed: 0.9 with: Color black! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/25/2007 17:15'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^BorderStyle simple
		width: 1;
		baseColor: aColor twiceDarker! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/25/2007 18:21'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar thumb fillStyle for the given scrollbar."
	
	^self scrollbarColorFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 10/24/2007 15:04'!
scrollbarPagingAreaCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#square! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/5/2007 14:24'!
scrollbarPressedBorderStyleFor: aScrollbar
	"Return the pressed borderStyle for the given scrollbar."

	^self scrollbarNormalBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/2/2007 14:04'!
scrollbarPressedButtonBorderStyleFor: aScrollbar
	"Return the pressed button borderStyle for the given scrollbar."

	^self scrollbarPressedThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:42'!
scrollbarPressedButtonFillStyleFor: aScrollbar
	"Return the pressed scrollbar button fillStyle for the given scrollbar."
	
	^self scrollbarPressedThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 3/30/2007 10:29'!
scrollbarPressedFillStyleFor: aScrollbar
	"Return the pressed scrollbar fillStyle for the given scrollbar."
	
	^self scrollbarNormalFillStyleFor: aScrollbar ! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/25/2007 17:11'!
scrollbarPressedThumbBorderStyleFor: aScrollbar
	"Return the pressed thumb borderStyle for the given scrollbar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/25/2007 18:22'!
scrollbarPressedThumbFillStyleFor: aScrollbar
	"Return the pressed scrollbar thumb fillStyle for the given scrollbar."
	
	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 12/17/2009 14:36'!
scrollbarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^ self settings scrollBarThickness! !

!UITheme methodsFor: 'border-styles-scrollbars' stamp: 'gvc 10/24/2007 15:05'!
scrollbarThumbCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#square! !

!UITheme methodsFor: 'defaults' stamp: 'IgorStasenko 1/14/2011 13:30'!
selectionBarColor

	^ self settings selectionBarColor

! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 10/12/2006 14:01'!
selectionColor
	"Answer the selection color to use.."

	^self settings selectionColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 1/12/2009 13:11'!
separatorFillStyleFor: aSeparator
	"Return the separator fillStyle for the given separator."
	
	|aColor|
	aColor := aSeparator paneColor.
	^(GradientFillStyle ramp: {
		0.0->aColor whiter whiter. 0.2->aColor lighter.
		0.8->aColor darker. 1.0->aColor blacker})
		origin: aSeparator topLeft;
		direction: (aSeparator bounds isWide
			ifTrue: [0 @ aSeparator height]
			ifFalse: [aSeparator width @ 0]);
		radial: false! !

!UITheme methodsFor: 'defaults' stamp: 'HilaireFernandes 8/3/2010 10:20'!
setSystemProgressMorphDefaultParameters: aProgressMorph
	"Set up the given progress morph."
	aProgressMorph color: self settings derivedMenuColor.
	self settings preferRoundCorner
		ifTrue: [aProgressMorph useRoundedCorners].
	aProgressMorph borderWidth: self settings menuBorderWidth.
	aProgressMorph borderColor: self settings menuBorderColor.
	aProgressMorph	updateColor.! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 9/22/2006 17:19'!
settings
	"Answer the value of settings"

	^ settings! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 9/22/2006 17:19'!
settings: anObject
	"Set the value of settings"

	settings := anObject! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/3/2007 15:25'!
sliderDisabledBorderStyleFor: aSlider
	"Return the disabled slider borderStyle for the given text editor."

	^self sliderNormalBorderStyleFor: aSlider! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:38'!
sliderDisabledFillStyleFor: aSlider
	"Return the disabled fillStyle for the given slider."
	
	^aSlider paneColor alphaMixed: 0.3 with: Color white! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 8/3/2007 15:26'!
sliderNormalBorderStyleFor: aSlider
	"Return the normal slider borderStyle for the given text editor."

	^BorderStyle inset
		width: 1;
		baseColor: aSlider paneColor twiceDarker! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 8/3/2007 15:27'!
sliderNormalFillStyleFor: aSlider
	"Return the normal fillStyle for the given slider."
	
	^Color white! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallAuthoringToolsIcon
	^ ThemeIcons smallAuthoringToolsIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallBackIcon
	^ ThemeIcons smallBackIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:39'!
smallBarcodeIcon
	"Answer a small barcode icon."

	^ThemeIcons smallBarcodeIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:28'!
smallBoldIcon
	"Answer a small bold text icon."

	^ThemeIcons smallBoldIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallCancelIcon
	^ ThemeIcons smallCancelIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallCenteredIcon
	^ ThemeIcons smallCenteredIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallConfigurationIcon
	^ ThemeIcons smallConfigurationIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallCopyIcon
	^ ThemeIcons smallCopyIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallCutIcon
	^ ThemeIcons smallCutIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/22/2007 10:44'!
smallDebugIcon
	"Answer a small debug icon."

	^self smallErrorIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallDeleteIcon
	^ ThemeIcons smallDeleteIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallDoItIcon
	^ ThemeIcons smallDoItIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:44'!
smallErrorIcon
	"Answer a small error icon."

	^ThemeIcons smallErrorIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallExpertIcon
	^ ThemeIcons smallExpertIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallExportIcon
	^ ThemeIcons smallExportIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallFindIcon
	^ ThemeIcons smallFindIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallFontsIcon
	^ ThemeIcons smallFontsIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallForwardIcon
	^ ThemeIcons smallForwardIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallFullScreenIcon
	^ ThemeIcons smallFullScreenIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallHelpIcon
	^ ThemeIcons smallHelpIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:33'!
smallHierarchyBrowserIcon
	"Answer a small hierarchy browser icon."

	^ThemeIcons smallHierarchyBrowserIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallHomeIcon
	^ ThemeIcons smallHomeIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 13:08'!
smallInfoIcon
	"Answer a small information icon."

	^ThemeIcons smallInfoIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallInspectItIcon
	^ ThemeIcons smallInspectItIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:28'!
smallItalicIcon
	"Answer a small italic text icon."

	^ThemeIcons smallItalicIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallJumpIcon
	^ ThemeIcons smallJumpIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallJustifiedIcon
	^ ThemeIcons smallJustifiedIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallLanguageIcon
	^ ThemeIcons smallLanguageIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallLeftFlushIcon
	^ ThemeIcons smallLeftFlushIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallLoadProjectIcon
	^ ThemeIcons smallLoadProjectIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:45'!
smallLockIcon
	"Answer a small lock icon."

	^ThemeIcons smallLockIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallNewIcon
	^ ThemeIcons smallNewIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallObjectCatalogIcon
	^ ThemeIcons smallObjectCatalogIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallObjectsIcon
	^ ThemeIcons smallObjectsIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallOkIcon
	^ ThemeIcons smallOkIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallOpenIcon
	^ ThemeIcons smallOpenIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallPaintIcon
	^ ThemeIcons smallPaintIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallPasteIcon
	^ ThemeIcons smallPasteIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallPrintIcon
	^ ThemeIcons smallPrintIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallProjectIcon
	^ ThemeIcons smallProjectIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallPublishIcon
	^ ThemeIcons smallPublishIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallPushpinIcon
	^ ThemeIcons smallPushpinIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:45'!
smallQuestionIcon
	"Answer a small question icon."

	^ThemeIcons smallQuestionIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallQuitIcon
	^ ThemeIcons smallQuitIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallRedoIcon
	^ ThemeIcons smallRedoIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallRemoteOpenIcon
	^ ThemeIcons smallRemoteOpenIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallRightFlushIcon
	^ ThemeIcons smallRightFlushIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallSaveAsIcon
	^ ThemeIcons smallSaveAsIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallSaveIcon
	^ ThemeIcons smallSaveIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/24/2010 21:28'!
smallScreenshotIcon
	^ ThemeIcons smallScreenshotIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallSelectIcon
	^ ThemeIcons smallSelectIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:29'!
smallStrikeOutIcon
	"Answer a small strike text icon."

	^ThemeIcons smallStrikeOutIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:31'!
smallSystemBrowserIcon
	"Answer a small browser icon."

	^ThemeIcons smallSystemBrowserIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:29'!
smallUnderlineIcon
	"Answer a small underlined text icon."

	^ThemeIcons smallUnderlineIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallUndoIcon
	^ ThemeIcons smallUndoIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallUpdateIcon
	^ ThemeIcons smallUpdateIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallVolumeIcon
	^ ThemeIcons smallVolumeIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:45'!
smallWarningIcon
	"Answer a small warning icon."

	^ThemeIcons smallWarningIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
smallWindowIcon
	^ ThemeIcons smallWindowIcon! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
solidMenuIcon
	^ ThemeIcons solidMenuIcon! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 7/30/2009 18:34'!
soundTheme
	"Answer the sound theme to use, if not specified
	use the default sound theme."

	^soundTheme ifNil: [self defaultSoundTheme]! !

!UITheme methodsFor: 'accessing' stamp: 'gvc 7/30/2009 18:32'!
soundTheme: anObject
	"Set the sound theme specific to this instance of ui theme,"

	soundTheme := anObject! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 10:12'!
splitterNormalFillStyleFor: aSplitter
	"Return the normal splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := aSplitter paneColor.
	^(GradientFillStyle ramp: {
		0.0->aColor whiter whiter. 0.2->aColor lighter.
		0.8->aColor darker. 1.0->aColor blacker})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 10:14'!
splitterPressedFillStyleFor: aSplitter
	"Return the pressed splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := aSplitter paneColor twiceDarker.
	^(GradientFillStyle ramp: {
			0.0->Color white. 0.4-> aColor twiceLighter.
			1.0->aColor darker duller})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
squeakyMouseIcon
	^ ThemeIcons squeakyMouseIcon! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 12/1/2008 11:40'!
statusFont
	"Answer the status font to use."

	^((TextStyle named: #BitstreamVeraSansMono) ifNil: [TextStyle default])
		fontOfPointSize: 8! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 1/16/2008 13:35'!
subgroupColorFrom: paneColor
	"Answer the colour for a subgroup given the pane colour."

	^paneColor whiter whiter! !

!UITheme methodsFor: 'border-styles' stamp: 'MarcusDenker 12/11/2009 09:35'!
tabGroupCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^aThemedMorph
		ifNil: [#square]
		ifNotNil: [:tm | tm preferredCornerStyle]! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 1/14/2009 15:27'!
tabLabelInsetFor: aButton
	"Answer the inset to use for a tab label."

	^4@2 corner: 4@0! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 1/7/2008 11:19'!
tabLabelNormalBorderStyleFor: aTabLabel
	"Answer the normal border style for a tab label."

	^BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 1/7/2008 11:13'!
tabLabelNormalFillStyleFor: aTabLabel
	"Return the normal fillStyle for the given tab label."
	
	^aTabLabel paneColor lighter! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 1/7/2008 11:19'!
tabLabelSelectedBorderStyleFor: aTabLabel
	"Answer the selected border style for a tab label."

	^self tabLabelNormalBorderStyleFor: aTabLabel! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 1/7/2008 11:14'!
tabLabelSelectedFillStyleFor: aTabLabel
	"Return the selected fillStyle for the given tab label."
	
	^aTabLabel paneColor! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 1/7/2008 14:12'!
tabPanelBorderStyleFor: aTabPanel
	"Answer the normal border style for a tab panel."

	^BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 1/7/2008 14:54'!
tabSelectorCellInsetFor: aTabSelector
	"Answer the cell inset to use for the given tab selector."

	^2@0! !

!UITheme methodsFor: 'defaults' stamp: 'nice 3/5/2010 22:42'!
tabSelectorMorphMinExtentFor: aTabSelectorMorph
	"Answer the min extent of the given tab selector."
	
	^aTabSelectorMorph basicMinExtent + (8 @ 1)! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:33'!
taskbarActiveButtonColorFor: aButton
	"Answer the colour for the given active taskbar button."

	^(self taskbarButtonColorFor: aButton) twiceDarker! !

!UITheme methodsFor: 'basic-colors' stamp: 'AlainPlantec 12/16/2009 14:41'!
taskbarButtonColorFor: aButton
	"Answer the colour for the given taskbar button." 
	^ self windowColorFor: aButton model! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:17'!
taskbarButtonLabelColorFor: aButton
	"Answer the colour for the label of the given taskbar button."

	^Color black! !

!UITheme methodsFor: 'basic-colors' stamp: 'NickAlexander 2/6/2011 12:28'!
taskbarButtonLabelColorForCollapsed: aButton
	"Answer the colour for the label of the given taskbar button, given that the corresponding window is collapsed."

	^Color darkGray! !

!UITheme methodsFor: 'basic-colors' stamp: 'NickAlexander 2/6/2011 12:01'!
taskbarButtonLabelColorForExpanded: aButton
	"Answer the colour for the label of the given taskbar button, given that the corresponding window is expanded."

	^Color black! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 3/14/2007 13:06'!
taskbarFillStyleFor: aTaskbar
	"Return the taskbar fillStyle for the given taskbar."
	
	|aColor|
	aColor := aTaskbar color.
	^(GradientFillStyle ramp: {
			0.0->(aColor alphaMixed: 0.3 with: (Color white alpha: aColor alpha)).
			0.2-> aColor twiceLighter.
			0.8->aColor darker.
			1.0->aColor darker duller})	
		origin: aTaskbar position;
		direction: 0@27;
		radial: false! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:11'!
taskbarMinimizedButtonColorFor: aButton
	"Answer the colour for the given minimized taskbar button."

	^self taskbarButtonColorFor: aButton! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 3/2/2009 12:27'!
taskbarThumbnailCornerStyleFor: aMorph
	"Answer the corner style for the taskbar thumbnail/tasklist."
	
	^#rounded! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 4/18/2007 11:48'!
taskbarThumbnailNormalBorderStyleFor: aWindow
	"Return the normal thumbnail borderStyle for the given button."

	|c|
	c := self windowColorFor: aWindow.
	^BorderStyle raised
		width: 1;
		baseColor: c! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/20/2007 10:46'!
tasklistFillStyleFor: aTasklist
	"Return the tasklist fillStyle for the given tasklist."
	
	|aColor|
	aColor := aTasklist color.
	^(GradientFillStyle ramp: {
			0.0->aColor whiter whiter. 0.2->aColor lighter.
			0.8->aColor darker. 1.0->aColor blacker})
		origin: aTasklist topLeft;
		direction: 0 @ aTasklist height;
		radial: false! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 5/23/2007 13:10'!
textEditorDisabledBorderStyleFor: aTextEditor
	"Return the disabled text editor borderStyle for the given text editor."

	^self textEditorNormalBorderStyleFor: aTextEditor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 13:13'!
textEditorDisabledFillStyleFor: aTextEditor
	"Return the disabled fillStyle for the given text editor."
	
	^aTextEditor paneColor alphaMixed: 0.3 with: Color white! !

!UITheme methodsFor: 'services' stamp: 'gvc 5/1/2007 11:32'!
textEditorIn: aThemedMorph text: aStringOrText title: aString entryText: defaultEntryText
	"Answer the result of a text editor (multiline) dialog ( a string or nil if cancelled)
	with the given label and title."

	^self
		textEditorIn: aThemedMorph
		text: aStringOrText
		title: aString
		entryText: defaultEntryText
		entryHeight: 64! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:15'!
textEditorIn: aThemedMorph text: aStringOrText title: aString entryText: defaultEntryText entryHeight: entryHeight
	"Answer the result of a text editor (multiline) dialog ( a string or nil if cancelled)
	with the given label and title."

	self questionSound play.
	^(aThemedMorph openModal: (
		TextEditorDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText;
			entryText: defaultEntryText;
			entryHeight: entryHeight)) entryText! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 5/23/2007 13:10'!
textEditorNormalBorderStyleFor: aTextEditor
	"Return the normal text editor borderStyle for the given text editor."

	^BorderStyle inset
		width: 1;
		baseColor: aTextEditor paneColor! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 12:56'!
textEditorNormalFillStyleFor: aTextEditor
	"Return the normal fillStyle for the given text editor."
	
	^Color white! !

!UITheme methodsFor: 'border-styles-buttons' stamp: 'MarcusDenker 12/11/2009 09:35'!
textEntryCornerStyleIn: aThemedMorph
	"Answer the corner style to use for text entry morphs."
	
	^aThemedMorph
		ifNil: [#square]
		ifNotNil: [:tm | tm preferredCornerStyle]! !

!UITheme methodsFor: 'services' stamp: 'gvc 7/30/2009 18:15'!
textEntryIn: aThemedMorph text: aStringOrText title: aString entryText: defaultEntryText
	"Answer the result of a text entry dialog ( a string or nil if cancelled)
	with the given label and title."

	self questionSound play.
	^(aThemedMorph openModal: (
		TextEntryDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText;
			entryText: defaultEntryText)) entryText! !

!UITheme methodsFor: 'services' stamp: 'AlainPlantec 11/25/2010 18:02'!
textEntryIn: aThemedMorph text: aStringOrText title: aString entryText: defaultEntryText entryCompletion: anEntryCompletion
	"Answer the result of a text entry dialog ( a string or nil if cancelled)
	with the given label and title."

	self questionSound play.
	^(aThemedMorph openModal: (
		TextEntryDialogWindow new
			textFont: self textFont;
			title: aString;
			text: aStringOrText;
			entryText: defaultEntryText;
			entryCompletion: anEntryCompletion)) entryText! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 5/23/2007 13:11'!
textFieldDisabledBorderStyleFor: aTextField
	"Return the disabled text field borderStyle for the given text field."

	^self textEditorDisabledBorderStyleFor: aTextField! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 13:06'!
textFieldDisabledFillStyleFor: aTextField
	"Return the disabled fillStyle for the given text field."
	
	^self textEditorDisabledFillStyleFor: aTextField! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 5/23/2007 13:11'!
textFieldNormalBorderStyleFor: aTextField
	"Return the normal text field borderStyle for the given text field."

	^self textEditorNormalBorderStyleFor: aTextField! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/23/2007 13:06'!
textFieldNormalFillStyleFor: aTextField
	"Return the normal fillStyle for the given text field."
	
	^self textEditorNormalFillStyleFor: aTextField! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 6/2/2009 12:16'!
textFocusBoundsFor: aPluggableTextMorph
	"Answer the bounds for drawing the focus indication."

	^aPluggableTextMorph bounds! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 11/29/2009 21:55'!
textFont
	"Answer the text font to use."

	^StandardFonts defaultFont! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
tinyMenuIcon
	^ ThemeIcons tinyMenuIcon! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/14/2007 11:49'!
treeExpandedForm
	"Answer the form to use for an expanded tree item."

	^self forms at: #treeExpanded ifAbsent: [Form extent: 10@9 depth: Display depth]! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 9/5/2007 15:04'!
treeLineColorsFrom: aColor
	"Answer the colours to use for the tree lines.
	The given colour is the preferred colour."

	^{aColor. Color transparent}! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 9/5/2007 15:05'!
treeLineDashes
	"Answer the dash lengths to use for the tree lines."

	^#(1 1)! !

!UITheme methodsFor: 'basic-colors' stamp: 'gvc 9/5/2007 15:08'!
treeLineWidth
	"Answer the width of the tree lines."

	^1! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/14/2007 11:49'!
treeUnexpandedForm
	"Answer the form to use for an unexpanded tree item."

	^self forms at: #treeUnexpanded ifAbsent: [Form extent: 10@9 depth: Display depth]! !

!UITheme methodsFor: 'defaults' stamp: 'AlainPlantec 2/8/2011 10:10'!
unfocusedSelectionColor
	^ self settings unfocusedSelectionColor! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
upArrowIcon
	^ ThemeIcons upArrowIcon! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 14:02'!
updateScrollBarButtonAspect: aMorph color: aColor 
	"update aMorph with aColor"
	| fill direction |
	aMorph isNil ifTrue: [^ self].
	aMorph color: aColor.
! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 11:13'!
updateScrollBarButtonsAspect: aCollection color: aColor 
	"update aCollection of morphs with aColor"
	
	
	aCollection
		do: [:each | self updateScrollBarButtonAspect: each color: aColor]! !

!UITheme methodsFor: 'initialize-release' stamp: 'gvc 2/14/2009 17:38'!
updateWorldDockingBars
	"Update the world docking bar gradients."
	
	World mainDockingBars do: [:d |
		d
			color: (self worldMainDockingBarColorFor: d);
			gradientRamp: (self class current
				worldMainDockingBarNormalFillStyleFor: d) colorRamp;
			borderStyle: (self worldMainDockingBarBorderStyleFor: d)]! !

!UITheme methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 2/22/2008 21:17'!
useScrollbarThumbShadow
	"Answer whether a shadow morph should be displayed when
	dragging a scrollbar thumb."

	^true! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:11'!
verticesForComplexArrow: aRectangle 
	"PRIVATE - answer a collection of vertices to draw a complex arrow"

	|r vertices aux b c|
	r := aRectangle origin extent: aRectangle width asPoint.
	aux := (r width / 5) rounded.
	b := (aux * aux * 2) sqrt.
	c := (b * b * 2) sqrt rounded.
	vertices := OrderedCollection new.
	vertices add: r bottomLeft - (0 @ aux).
	vertices add: r topCenter + (0 @ aux).
	vertices add: r bottomRight - (0 @ aux).
	vertices add: r bottomRight - (aux @ 0).
	vertices add: r topCenter + (0 @ (aux + c)).
	vertices add: r bottomLeft + (aux @ 0).
	^vertices! !

!UITheme methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:12'!
verticesForSimpleArrow: aRectangle 
	"PRIVATE - answer a collection of vertices to draw a simple arrow"
	| vertices |
	vertices := OrderedCollection new.
	""
	vertices add: aRectangle bottomLeft.
	vertices add: aRectangle center x @ (aRectangle top + (aRectangle width / 8)).
	vertices add: aRectangle bottomRight.
	vertices add: aRectangle bottomRight + (0@0.01).
	""
	^ vertices! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
volumeIcon
	^ ThemeIcons volumeIcon! !

!UITheme methodsFor: 'icons' stamp: 'gvc 5/18/2007 10:27'!
warningIcon
	"Answer a warning icon."

	^ThemeIcons warningIcon! !

!UITheme methodsFor: 'label-styles' stamp: 'AlainPlantec 2/11/2011 16:26'!
whiteTreeExpandedForm
	"Answer the form to use for an expanded tree item when a contrasting one is needed."

	^self forms 
		at: #whiteTreeExpanded 
		ifAbsent: [ | f |
			f := self treeExpandedForm deepCopy.
			f replaceColor: Color white withColor: Color transparent.
			(f colorsUsed reject: [:c | c isTransparent]) do: [:c | f replaceColor:  c withColor: c whiter whiter whiter whiter whiter whiter].
			self forms at: #whiteTreeExpanded put: f.
			self whiteTreeExpandedForm]! !

!UITheme methodsFor: 'label-styles' stamp: 'AlainPlantec 2/11/2011 16:26'!
whiteTreeUnexpandedForm
	"Answer the form to use for an unexpanded tree item when a contrasting one is needed."

	^self forms 
		at: #whiteTreeUnexpanded
		ifAbsent: [ | f |
			f := self treeUnexpandedForm deepCopy.
			f replaceColor: Color white withColor: Color transparent.
			(f colorsUsed reject: [:c | c isTransparent]) do: [:c | f replaceColor:  c withColor: c whiter whiter whiter whiter whiter whiter].
			self forms at: #whiteTreeUnexpanded put: f.
			self whiteTreeUnexpandedForm]! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/16/2009 17:19'!
windowActiveDropShadowOffsetRectangleFor: aSystemWindow
	"Answer a rectangle describing the offsets for each corner
	of the the active window bounds for the drop shadow area."
	
	^self windowActiveDropShadowStyle == #diffuse
		ifTrue: [self windowDiffuseDropShadowOffsetRectangleFor: aSystemWindow]
		ifFalse: [self windowPlainDropShadowOffsetRectangleFor: aSystemWindow]! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/16/2009 17:18'!
windowActiveDropShadowStyle
	"Answer the style of drop shadow to use for active windows."
	
	^#plain! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 18:01'!
windowActiveFillStyleFor: aWindow
	"Return the window active fillStyle for the given window."
	
	^aWindow paneColorToUse! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 11:16'!
windowActiveLabelFillStyleFor: aWindow
	"Return the window active label fillStyle for the given window."
	
	^Color black! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 4/25/2007 17:32'!
windowActiveTitleFillStyleFor: aWindow
	"Return the window active title fillStyle for the given color."
	
	^Color transparent! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 10:01'!
windowCloseForm
	"Answer the form to use for the close button of a window."

	^self forms at: #windowClose ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:40'!
windowCloseSound
	"Answer the window close sound."

	^self soundTheme windowCloseSound! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 10/12/2006 14:53'!
windowColor
	"Answer the window color to use."

	^self settings windowColor! !

!UITheme methodsFor: 'basic-colors' stamp: 'AlainPlantec 12/16/2009 22:13'!
windowColorFor: aWindowOrModel 
	"Answer the colour for the given window."
	| c |
	^ self settings standardColorsOnly
		ifTrue: [self settings windowColor]
		ifFalse: [c := aWindowOrModel isMorphicModel
						ifTrue: [self patchworkUIThemeColorFor: aWindowOrModel model].
			c
				ifNil: [(self patchworkUIThemeColorFor: aWindowOrModel)
						ifNil: [self settings windowColor]]] ! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/16/2009 17:17'!
windowDiffuseDropShadowOffsetRectangleFor: aSystemWindow
	"Answer a rectangle describing the offsets for each corner
	of the the active window bounds for the drop shadow area
	when the difuse style is used."
	
	^8@4 corner: 8@10! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 10/1/2007 14:22'!
windowEdgeNormalFillStyleFor: anEdgeGrip
	"Return the normal window edge fillStyle for the given edge grip."
	
	^Color transparent! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 10/1/2007 14:21'!
windowEdgePressedFillStyleFor: anEdgeGrip
	"Return the pressed window edge fillStyle for the given edge grip."
	
	^self windowEdgeNormalFillStyleFor: anEdgeGrip! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 6/2/2009 16:04'!
windowExtentChangedFor: aWindow
	"Update any extent related visuals."
! !

!UITheme methodsFor: 'icons' stamp: 'AlainPlantec 10/19/2010 20:13'!
windowIcon
	^ ThemeIcons windowIcon! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/16/2009 17:22'!
windowInactiveDropShadowOffsetRectangleFor: aSystemWindow
	"Answer a rectangle describing the offsets for each corner
	of the the inactive window bounds for the drop shadow area."
	
	^self windowPlainDropShadowOffsetRectangleFor: aSystemWindow! !

!UITheme methodsFor: 'fill-styles' stamp: 'AlainPlantec 12/14/2009 14:30'!
windowInactiveFillStyleFor: aWindow
	"Return the window inactive fillStyle for the given window."
	
	^self settings fadedBackgroundWindows
		ifTrue: [aWindow paneColorToUse
					alphaMixed: 0.9
					with: (Color white alpha: aWindow paneColorToUse alpha)]
		ifFalse: [aWindow paneColorToUse]! !

!UITheme methodsFor: 'fill-styles' stamp: 'AlainPlantec 12/14/2009 14:30'!
windowInactiveLabelFillStyleFor: aWindow
	"Return the window inactive label fillStyle for the given window."
	
	^self settings fadedBackgroundWindows
		ifTrue: [aWindow paneColorToUse alphaMixed: 0.6 with: Color black]
		ifFalse: [self windowActiveLabelFillStyleFor: aWindow]! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 10:53'!
windowInactiveTitleFillStyleFor: aWindow
	"Return the window inactive title fillStyle for the given color."
	
	^self windowActiveTitleFillStyleFor: aWindow! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/7/2007 12:50'!
windowLabelFor: aWindow
	"Answer the label to use for the given window."

	^self windowLabelForText: aWindow labelString! !

!UITheme methodsFor: 'label-styles' stamp: 'AlainPlantec 11/29/2009 22:13'!
windowLabelForText: aTextOrString
	"Answer the window label to use for the given text."

	^LabelMorph new
		contents: aTextOrString;
		font: StandardFonts windowTitleFont emphasis: 0! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 10:00'!
windowMaximizeForm
	"Answer the form to use for the maximize button of a window."

	^self forms at: #windowMaximize ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:45'!
windowMaximizeSound
	"Answer the window maximize sound."

	^self soundTheme windowMaximizeSound! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 10:01'!
windowMenuForm
	"Answer the form to use for the menu button of a window."

	^self forms at: #windowMenu ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/25/2007 10:01'!
windowMenuIconFor: aWindow
	"Answer the menu icon for the given window."

	^aWindow taskbarIcon ifNil: [self windowMenuForm]! !

!UITheme methodsFor: 'label-styles' stamp: 'gvc 5/15/2007 10:00'!
windowMinimizeForm
	"Answer the form to use for the minimize button of a window."

	^self forms at: #windowMinimize ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:46'!
windowMinimizeSound
	"Answer the window minimize sound."

	^self soundTheme windowMinimizeSound! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 17:49'!
windowOpenSound
	"Answer the window open sound."

	^self soundTheme windowOpenSound! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 12/1/2008 15:29'!
windowPaneBorderStyleFor: aMorph in: aSystemWindow
	"Answer the border style for a morph that is to be added
	as a pane in the given system window,"

	^BorderStyle inset
		color: aSystemWindow paneColor;
		width: (aMorph borderWidth = 0 ifTrue: [0] ifFalse: [1])! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 2/16/2009 17:16'!
windowPlainDropShadowOffsetRectangleFor: aSystemWindow
	"Answer a rectangle describing the offsets for each corner
	of the the active window bounds for the drop shadow area
	when the plain style is used."
	
	^aSystemWindow shadowOffset negated corner: aSystemWindow shadowOffset! !

!UITheme methodsFor: 'defaults' stamp: 'GaryChambers 6/10/2011 11:36'!
windowPreferredCornerStyleFor: aWindow
	"Answer the preferred corner style for the given window."

	aWindow isEmbedded ifTrue: [^#square].
	^(self settings preferRoundCorner  or: [
			aWindow cornerStyle == #rounded])
		ifTrue: [#rounded]
		ifFalse: [#square]! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:46'!
windowRestoreDownSound
	"Answer the window restore down sound."

	^self soundTheme windowRestoreDownSound! !

!UITheme methodsFor: 'sounds' stamp: 'gvc 9/12/2007 14:46'!
windowRestoreUpSound
	"Answer the window restore up sound."

	^self soundTheme windowRestoreUpSound! !

!UITheme methodsFor: 'defaults' stamp: 'gvc 2/9/2009 17:12'!
windowShadowColor
	"Answer the window shadow color to use."

	^Color black alpha: 0.5! !

!UITheme methodsFor: 'border-styles' stamp: 'gvc 5/13/2008 15:17'!
worldMainDockingBarBorderStyleFor: aDockingBar
	"Return the world main docking bar borderStyle for the given docking bar."

	^BorderStyle raised
		width: 2;
		color: aDockingBar color! !

!UITheme methodsFor: 'basic-colors' stamp: 'AlainPlantec 12/13/2009 22:30'!
worldMainDockingBarColorFor: aDockingBar
	"Answer the base colour to use for a world main docking bar in this theme."

	^self settings derivedMenuColor ! !

!UITheme methodsFor: 'fill-styles' stamp: 'gvc 10/24/2007 11:34'!
worldMainDockingBarNormalFillStyleFor: aDockingBar
	"Return the world main docking bar fillStyle for the given docking bar."
	
	|aColor|
	aColor := aDockingBar originalColor.
	^(GradientFillStyle ramp: {0.0 -> aColor muchLighter. 1.0 -> aColor})
		origin: aDockingBar topLeft;
		direction: (aDockingBar isVertical
			ifTrue: [aDockingBar width @ 0]
			ifFalse: [0 @ aDockingBar height]);
		radial: false! !

UITheme subclass: #UIThemeStandardSqueak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!UIThemeStandardSqueak commentStamp: 'gvc 5/18/2007 10:04' prior: 0!
A UI theme that tries to make things look like a standard (3.9) Squeak image. Do UIThemeStandardSqueak beCurrent to use.!

!UIThemeStandardSqueak class methodsFor: 'testing' stamp: 'gvc 6/22/2007 14:26'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^false! !

!UIThemeStandardSqueak class methodsFor: 'accessing' stamp: 'MarcusDenker 9/27/2010 15:32'!
newDefaultSettings
	"Answer a new original default settings."

	^super newDefaultSettings
		preferGradientFill: false;
		yourself
! !

!UIThemeStandardSqueak class methodsFor: 'accessing' stamp: 'gvc 6/22/2007 15:19'!
themeName
	"Answer the friendly name of the theme."

	^'Standard Squeak'! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/26/2007 09:58'!
buttonDisabledFillStyleFor: aButton
	"Return the disabled button fillStyle for the given color."

	^aButton offColor
		ifNil: [Color darkGray]
		ifNotNil: [aButton offColor muchDarker]! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:30'!
buttonMouseOverFillStyleFor: aButton
	"Return the button mouse over fillStyle for the given color."

	^(self buttonNormalFillStyleFor: aButton) adjustBrightness: -0.09375! !

!UIThemeStandardSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 5/15/2007 17:54'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	^aButton borderStyle isComposite
		ifTrue: [aButton borderStyle borders first]
		ifFalse: [aButton borderStyle]! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 5/15/2007 17:44'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	^aButton offColor
		ifNil: [Color transparent]
		ifNotNil: [aButton offColor]! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:37'!
buttonPanelNormalFillStyleFor: aPanel
	"Return the normal panel fillStyle for the given panel."
	
	^Color white! !

!UIThemeStandardSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 5/15/2007 17:55'!
buttonPressedBorderStyleFor: aButton
	"Return the pressed button borderStyle for the given button."

	aButton borderStyle isComposite
		ifTrue: [^aButton borderStyle].
	^(CompositeBorder new width: 1)
		borders: {aButton borderStyle.
				BorderStyle simple
				color: Color red;
				width: 2}! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:48'!
buttonSelectedFillStyleFor: aButton
	"Return the button selected fillStyle for the given color."
	
	^aButton onColor
		ifNil: [Color white darker darker]
		ifNotNil: [aButton onColor]! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-buttons' stamp: 'gvc 4/25/2007 18:49'!
buttonSelectedMouseOverFillStyleFor: aButton
	"Return the button selected mouse over fillStyle for the given color."
	
	^(self buttonSelectedFillStyleFor: aButton) adjustBrightness: -0.09375! !

!UIThemeStandardSqueak methodsFor: 'border-styles-buttons' stamp: 'gvc 5/15/2007 17:53'!
buttonSelectedPressedBorderStyleFor: aButton
	"Return the selected pressed button borderStyle for the given button."

	aButton borderStyle isComposite
		ifTrue: [^aButton borderStyle].
	^(CompositeBorder new width: 1)
		borders: {aButton borderStyle.
				BorderStyle simple
				color: Color red;
				width: 2}! !

!UIThemeStandardSqueak methodsFor: 'label-styles' stamp: 'GaryChambers 8/10/2010 15:05'!
createCloseBoxFor: aSystemWindow
	"Answer a button for closing the window."
	
	^aSystemWindow createBox
		labelGraphic: self windowCloseForm;
		extent: aSystemWindow boxExtent;
		actionSelector: #closeBoxHit;
		setBalloonText: 'Close this window' translated! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:54'!
dialogWindowActiveFillStyleFor: aWindow
	"Return the dialog window active fillStyle for the given window."
	
	^self windowActiveFillStyleFor: aWindow! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 09:54'!
dialogWindowInactiveFillStyleFor: aWindow
	"Return the dialog window inactive fillStyle for the given window."
	
	^self windowInactiveFillStyleFor: aWindow! !

!UIThemeStandardSqueak methodsFor: 'border-styles' stamp: 'GaryChambers 3/8/2011 12:48'!
drawTextAdornmentsFor: aPluggableTextMorph on: aCanvas
	"Indicate edit status for the given morph.
	Include a thin red inset border for unaccepted edits, or, if the unaccepted edits are known to conflict with a change made somewhere else to the same method (typically), put a thick red frame"

	aPluggableTextMorph wantsFrameAdornments ifTrue:
		[(aPluggableTextMorph model notNil and: [aPluggableTextMorph model refusesToAcceptCode])
			ifTrue:  "Put up feedback showing that code cannot be submitted in this state"
				[aCanvas frameRectangle: aPluggableTextMorph innerBounds width: 2 color: Color tan]
			ifFalse:
				[(aPluggableTextMorph hasEditingConflicts or: [aPluggableTextMorph hasValidText not])
					ifTrue:
						[aCanvas frameRectangle: aPluggableTextMorph innerBounds width: 3 color: Color red] 
					ifFalse:
						[aPluggableTextMorph hasUnacceptedEdits
							ifTrue:
								[aPluggableTextMorph model wantsDiffFeedback
									ifTrue:
										[aCanvas frameRectangle: aPluggableTextMorph innerBounds width: 3 color: Color green]
									ifFalse:
										[aCanvas frameRectangle: aPluggableTextMorph innerBounds width: 1 color: Color red]]
							ifFalse:
								[aPluggableTextMorph model wantsDiffFeedback
									ifTrue:
										[aCanvas frameRectangle: aPluggableTextMorph innerBounds width: 1 color: Color green]]]]]! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 10/16/2008 16:27'!
menuColorFor: aThemedMorph
	"Answer the menu color to use."

	^self defaultMenuColor! !

!UIThemeStandardSqueak methodsFor: 'label-styles' stamp: 'gvc 3/6/2009 13:30'!
menuPinForm
	"Answer the form to use for the pin button of a menu."

	^MenuMorph pushPinImage! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 10/16/2008 16:27'!
menuTitleColorFor: aThemedMorph
	"Answer the menu title color to use."

	^self defaultMenuTitleColor! !

!UIThemeStandardSqueak methodsFor: 'morph creation' stamp: 'gvc 1/30/2009 14:23'!
newBalloonHelpIn: aThemedMorph contents: aTextStringOrMorph for: aMorph corner: cornerSymbol
	"Answer a new balloon help morph with the given text
	and positioning for aMorph."
	
	^BalloonMorph
		string: aTextStringOrMorph
		for: aMorph
		corner: cornerSymbol! !

!UIThemeStandardSqueak methodsFor: 'initialize-release' stamp: 'gvc 5/14/2007 11:43'!
newTreeExpandedForm
	"Answer a new form for an expanded tree item."

	^(Form
		extent: 10@9
		depth: 8
		fromArray: #( 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4278255873 16843009 16842752 4294902089 1229539657 33488896 4294967041 1229539585 4294901760 4294967295 21561855 4294901760 4294967295 4278321151 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760)
		offset: 0@0)
			asFormOfDepth: Display depth;
			replaceColor: Color white withColor: Color transparent;
			yourself! !

!UIThemeStandardSqueak methodsFor: 'initialize-release' stamp: 'gvc 5/14/2007 11:43'!
newTreeUnexpandedForm
	"Answer a new form for an unexpanded tree item."

	^(Form
		extent: 10@9
		depth: 8
		fromArray: #( 4294967041 4294967295 4294901760 4294967041 33554431 4294901760 4294967041 1224867839 4294901760 4294967041 1229521407 4294901760 4294967041 1229539585 4294901760 4294967041 1229521407 4294901760 4294967041 1224867839 4294901760 4294967041 33554431 4294901760 4294967041 4294967295 4294901760)
		offset: 0@0)
			asFormOfDepth: Display depth;
			replaceColor: Color white withColor: Color transparent;
			yourself! !

!UIThemeStandardSqueak methodsFor: 'border-styles' stamp: 'AlainPlantec 1/25/2010 13:19'!
progressBarBorderStyleFor: aProgressBar 
	"Return the progress bar borderStyle for the given progress bar."
	^ BorderStyle simple width: 1;
		 baseColor: self settings progressBarColor darker ! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 6/4/2007 14:25'!
progressBarFillStyleFor: aProgressBar
	"Return the progress bar fillStyle for the given progress bar."
	
	^self progressBarColorFor: aProgressBar! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 6/4/2007 14:24'!
progressBarProgressFillStyleFor: aProgressBar
	"Return the progress bar progress fillStyle for the given progress bar."
	
	^self progressBarProgressColorFor: aProgressBar! !

!UIThemeStandardSqueak methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:46'!
scrollBarButtonArrowVertices: aRectangle 
	^ self verticesForSimpleArrow: aRectangle! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/26/2007 14:26'!
scrollbarImageColorFor: aScrollbar
	"Return the scrollbar image colour (on buttons) for the given scrollbar."
	
	^((self scrollbarColorFor: aScrollbar)
		alphaMixed: 0.5 with: (Color gray: 0.95)) twiceDarker darker! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/25/2007 18:58'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	^aScrollbar sliderColor alphaMixed: 0.3 with: Color white! !

!UIThemeStandardSqueak methodsFor: 'border-styles-scrollbars' stamp: 'gvc 4/25/2007 17:16'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	^BorderStyle simple
		width: 1;
		baseColor: Color lightGray! !

!UIThemeStandardSqueak methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/26/2007 14:04'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar thumb fillStyle for the given scrollbar."
	
	^aScrollbar sliderColor
		alphaMixed: 0.5 with: (Color gray: 0.95)! !

!UIThemeStandardSqueak methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 16:36'!
scrollbarPressedButtonBorderStyleFor: aScrollbar
	"Return the pressed button borderStyle for the given scrollbar."

	^BorderStyle inset
		width: 1! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 10:19'!
splitterNormalFillStyleFor: aSplitter
	"Return the normal splitter fillStyle for the given splitter."
	
	^aSplitter getOldColor! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 10:19'!
splitterPressedFillStyleFor: aSplitter
	"Return the pressed splitter fillStyle for the given splitter."
	
	^Color black! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'AlainPlantec 12/13/2009 18:07'!
taskbarFillStyleFor: aTaskbar
	"Return the taskbar fillStyle for the given taskbar."
	
	 ^ self settings derivedMenuColor.! !

!UIThemeStandardSqueak methodsFor: 'border-styles' stamp: 'AlainPlantec 12/21/2009 11:27'!
taskbarThumbnailNormalBorderStyleFor: aWindow
	"Return the normal thumbnail borderStyle for the given button."

	^BorderStyle simple
		width: 1;
		baseColor: self settings menuColor! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'AlainPlantec 12/13/2009 18:08'!
tasklistFillStyleFor: aTasklist
	"Return the tasklist fillStyle for the given tasklist."
	
	^ self settings derivedMenuColor.! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 11:04'!
windowActiveFillStyleFor: aWindow
	"Return the window active fillStyle for the given window."
	
	^aWindow
		gradientWithColor: aWindow paneColorToUse lighter lighter lighter! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 11:04'!
windowInactiveFillStyleFor: aWindow
	"Return the window inactive fillStyle for the given window."
	
	^aWindow
		gradientWithColor: aWindow paneColorToUse duller! !

!UIThemeStandardSqueak methodsFor: 'label-styles' stamp: 'gvc 5/25/2007 10:02'!
windowMenuIconFor: aWindow
	"Answer the menu icon for the given window."
	
	^self windowMenuForm! !

!UIThemeStandardSqueak methodsFor: 'defaults' stamp: 'gvc 2/9/2009 17:12'!
windowShadowColor
	"Answer the window shadow color to use."

	^Color black alpha: 0.333! !

!UIThemeStandardSqueak methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 15:56'!
worldMainDockingBarNormalFillStyleFor: aDockingBar
	"Return the world main docking bar fillStyle for the given docking bar."
	
	|aColor|
	aColor := aDockingBar originalColor.
	^(GradientFillStyle ramp: {0.0 -> aColor muchLighter. 1.0 -> aColor twiceDarker})
		origin: aDockingBar topLeft;
		direction: (aDockingBar isVertical
			ifTrue: [aDockingBar width @ 0]
			ifFalse: [0 @ aDockingBar height]);
		radial: false! !

UITheme subclass: #UIThemeVistary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!UIThemeVistary commentStamp: 'gvc 5/18/2007 10:02' prior: 0!
A Vista-style UI theme. Do UIThemeVistary beCurrent to use.!

!UIThemeVistary class methodsFor: 'testing' stamp: 'gvc 6/22/2007 14:26'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^false! !

!UIThemeVistary class methodsFor: 'accessing' stamp: 'MarcusDenker 9/27/2010 15:32'!
newDefaultSettings
	"Answer a new original default settings."

	^super newDefaultSettings
		autoSelectionColor: false;
		windowColor:  (Color r: 0.675 g: 0.76 b: 0.838);
		selectionColor: (Color r: 62 g: 142 b: 220 range: 255);
		buttonColor: Color black;
		scrollbarColor: Color black;
		progressBarProgressColor: (Color r: 0.544 g: 0.819 b: 0.09);
		yourself! !

!UIThemeVistary class methodsFor: 'accessing' stamp: 'gvc 6/22/2007 15:19'!
themeName
	"Answer the friendly name of the theme."

	^'Vistary'! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 3/14/2007 15:58'!
buttonCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#square! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/22/2008 17:47'!
buttonDisabledBorderStyleFor: aButton
	"Return the disabled button borderStyle for the given button."

	|pc mc ic|
	pc := self buttonColorFor: aButton.
	mc := (pc alphaMixed: 0.6 with: Color black) alpha: 0.5.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {RoundedBorder new
					cornerRadius: 2;
					width: 1;
					baseColor: mc.
				RoundedBorder new
					cornerRadius: 1;
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/13/2007 10:16'!
buttonDisabledFillStyleFor: aButton
	"Return the disabled button fillStyle for the given color."
	
	^aButton colorToUse lighter whiter alpha: 0.6! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 4/16/2007 11:14'!
buttonLabelForText: aTextOrString
	"Answer the label to use for the given text."
	
	^aTextOrString isString
		ifTrue: [(FuzzyLabelMorph contents: aTextOrString)
					alpha: 0.3]
		ifFalse: [super buttonLabelForText: aTextOrString]! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/22/2008 17:47'!
buttonMouseOverBorderStyleFor: aButton
	"Return the mouse over button borderStyle for the given button."
	
	|pc mc ic selcol|
	pc := self buttonColorFor: aButton.
	selcol := (self selectionColor adjustSaturation: 0.3 brightness: 0.5).
	mc := pc alphaMixed: 0.4 with: (Color black alphaMixed: 0.3 with: selcol).
	ic := (Color white alphaMixed: 0.7 with: selcol) alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {RoundedBorder new
					cornerRadius: 2;
					width: 1;
					baseColor: mc.
				RoundedBorder new
					cornerRadius: 1;
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/28/2007 14:53'!
buttonMouseOverFillStyleFor: aButton
	"Return the button mouse over fillStyle for the given color."
	
	|aColor c cm cd cb selcol|
	aColor := aButton colorToUse.
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.7 with: selcol.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.3 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	^(GradientFillStyle ramp: {
			0.0->c. 0.5->cm. 0.51->cd. 0.8->cb. 1.0->Color white})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/22/2008 21:32'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	|pc mc ic|
	pc := self buttonColorFor: aButton.
	mc := aButton isDefault
		ifTrue: [self defaultButtonBorderColor]
		ifFalse: [pc alphaMixed: 0.7 with: Color black].
	ic := aButton isDefault
		ifTrue: [self defaultButtonBorderColor alpha: 0.5]
		ifFalse: [Color white alpha: 0.3]. 
	^(CompositeBorder new width: 1)
		borders: {RoundedBorder new
					cornerRadius: 2;
					width: 1;
					baseColor: mc.
				RoundedBorder new
					cornerRadius: 1;
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 2/22/2008 21:21'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given color."
	
	|aColor c cm cd cb|
	aColor := self buttonColorFor: aButton.
	c := aColor alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.8 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.5->cm. 0.51->cd. 1.0->cb})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 15:15'!
buttonPanelNormalFillStyleFor: aPanel
	"Return the normal panel fillStyle for the given panel."
	
	|aColor c cm cd cb|
	aColor := aPanel paneColor.
	c := aColor  alphaMixed: 0.7 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.50->cm. 0.51->cd. 1.0->cb})
		origin: aPanel topLeft;
		direction: 0 @ aPanel height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 13:24'!
buttonPressedFillStyleFor: aButton
	"Return the button pressed fillStyle for the given button."
		
	^self buttonSelectedFillStyleFor: aButton! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/22/2008 17:47'!
buttonSelectedBorderStyleFor: aButton
	"Return the selected borderStyle for the given button."
	
	|pc mc ic selcol|
	pc := self buttonColorFor: aButton.
	selcol := (self selectionColor adjustSaturation: 0.3 brightness: 0.5).
	mc := pc alphaMixed: 0.4 with: (Color black alphaMixed: 0.2 with: selcol).
	ic := (Color white alphaMixed: 0.6 with: selcol) alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {RoundedBorder new
					cornerRadius: 2;
					width: 1;
					baseColor: mc.
				RoundedBorder new
					cornerRadius: 1;
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 12:40'!
buttonSelectedDisabledFillStyleFor: aButton
	"Return the button selected disabled fillStyle for the given color."
	
	|aColor selcol|
	aColor := aButton colorToUse.
	selcol := (aColor mixed: 0.5 with: self selectionColor) lighter whiter.
	^(GradientFillStyle ramp: {0.0->selcol. 1.0->selcol})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/28/2007 14:52'!
buttonSelectedFillStyleFor: aButton
	"Return the button selected fillStyle for the given button."
	
	|aColor c cm cd cb selcol|
	aColor := aButton colorToUse.
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.4 with: selcol.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.1 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	^(GradientFillStyle ramp: {
			0.0->c. 0.5->cm. 0.51->cd. 0.8->cb. 1.0->Color white})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 4/30/2007 15:10'!
buttonSelectedMouseOverBorderStyleFor: aButton
	"Return the selected mouse over button borderStyle for the given button."

	^self buttonMouseOverBorderStyleFor: aButton! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 13:23'!
buttonSelectedMouseOverFillStyleFor: aButton
	"Return the button selected mouse over fillStyle for the given button."
	
	^self buttonMouseOverFillStyleFor: aButton! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 3/14/2007 13:24'!
buttonSelectedPressedFillStyleFor: aButton
	"Return the button selected pressed fillStyle for the given button."
	
	^self buttonNormalFillStyleFor: aButton! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/22/2008 21:50'!
checkboxButtonDisabledBorderStyleFor: aCheckboxButton
	"Return the disabled checkbox button borderStyle for the given button."

	|pc oc mc ic|
	pc := aCheckboxButton paneColor lighter.
	oc := pc twiceDarker.
	mc := (pc alphaMixed: 0.4 with: Color white).
	ic := pc lighter. 
	^(CompositeBorder new width: 2)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle inset
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 10/9/2007 11:35'!
checkboxButtonDisabledFillStyleFor: aCheckboxButton
	"Return the disabled checkbox button fillStyle for the given button."
	
	|c ib|
	c := aCheckboxButton colorToUse
		alphaMixed: 0.3
		with: Color white.
	ib := aCheckboxButton innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2->c darker.
			0.5->c lighter.
			1.0->c twiceLighter})
		origin: aCheckboxButton innerBounds origin;
		direction: ib extent;
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 9/5/2007 13:40'!
checkboxButtonNormalBorderStyleFor: aCheckboxButton
	"Return the normal checkbox button borderStyle for the given button."

	|pc oc mc ic|
	pc := self buttonColorFor: aCheckboxButton.
	oc := pc twiceDarker.
	mc := (pc alphaMixed: 0.4 with: Color white).
	ic := pc lighter. 
	^(CompositeBorder new width: 2)
		borders: {BorderStyle simple
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle inset
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 10/9/2007 11:34'!
checkboxButtonNormalFillStyleFor: aCheckboxButton
	"Return the normal checkbox button fillStyle for the given button."
	
	|c ib|
	c := aCheckboxButton colorToUse
		alphaMixed: 0.2
		with: Color white.
	ib := aCheckboxButton innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.2->c darker.
			0.5->c lighter.
			1.0->c twiceLighter})
		origin: aCheckboxButton innerBounds origin;
		direction: ib extent;
		radial: false! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'MarcusDenker 12/11/2009 07:43'!
configureWindowLabelAreaFor: aWindow
	"Configure the label area for the given window."
	
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow hasMenuBox ifTrue: [aWindow addMenuControl].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow basicLabel ifNotNil: [:label |
		label hResizing: #spaceFill.
		aWindow labelArea addMorphBack: label].
	aWindow hasCollapseBox ifTrue: [aWindow addCollapseBox].
	aWindow hasExpandBox ifTrue: [aWindow addExpandBox].
	aWindow hasCloseBox ifTrue: [aWindow addCloseBox].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0)! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/21/2008 15:11'!
controlButtonDisabledBorderStyleFor: aButton
	"Return the disabled button borderStyle for the given control button."

	|pc mc ic|
	pc := self buttonColorFor: aButton.
	mc := (pc alphaMixed: 0.6 with: Color black) alpha: 0.5.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/21/2008 15:11'!
controlButtonMouseOverBorderStyleFor: aButton
	"Return the mouse over button borderStyle for the given control button."
	
	|pc mc ic selcol|
	pc := self buttonColorFor: aButton.
	selcol := (self selectionColor adjustSaturation: 0.3 brightness: 0.5).
	mc := pc alphaMixed: 0.4 with: (Color black alphaMixed: 0.3 with: selcol).
	ic := (Color white alphaMixed: 0.7 with: selcol) alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/21/2008 15:10'!
controlButtonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given control button."

	|pc mc ic|
	pc := self buttonColorFor: aButton.
	mc := pc alphaMixed: 0.7 with: Color black.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/23/2008 16:25'!
controlButtonPressedBorderStyleFor: aButton
	"Return the pressed control button borderStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."

	^self controlButtonSelectedBorderStyleFor: aButton! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/21/2008 15:10'!
controlButtonSelectedBorderStyleFor: aButton
	"Return the selected borderStyle for the given control button."
	
	|pc mc ic selcol|
	pc := self buttonColorFor: aButton.
	selcol := (self selectionColor adjustSaturation: 0.3 brightness: 0.5).
	mc := pc alphaMixed: 0.4 with: (Color black alphaMixed: 0.2 with: selcol).
	ic := (Color white alphaMixed: 0.6 with: selcol) alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'tbn 7/29/2010 21:28'!
createCollapseBoxFor: aSystemWindow
	"Answer a button for minimising the window."
	
	|form msb|
	form := self windowMinimizeForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb
		activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMinimizeOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMinimizeDownForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: [aSystemWindow collapseBoxHit];
		setBalloonText: 'Collapse this window' translated;
		extent: aSystemWindow boxExtent.
	^msb! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'tbn 7/29/2010 21:28'!
createExpandBoxFor: aSystemWindow
	"Answer a button for maximising/restoring the window."
	
	|form msb|
	form := self windowMaximizeForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb
		activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMaximizeOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMaximizeDownForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: [aSystemWindow expandBoxHit];
		setBalloonText: 'Expand to full screen' translated;
		extent: aSystemWindow boxExtent.
	^msb! !

!UIThemeVistary methodsFor: 'defaults' stamp: 'gvc 2/22/2008 21:31'!
defaultButtonBorderColor
	"Answer the color to use for a 'default' button."

	^Color r: 0.005 g: 0.619 b: 0.736! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 10/17/2008 12:19'!
disabledItemStyle
	"Answer either #plain or #inset to determine how
	diabled text is drawn."

	^#inset! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 3/14/2007 13:38'!
dockingBarNormalFillStyleFor: aToolDockingBar
	"Return the normal docking bar fillStyle for the given color."
	
	|aColor c cm cd cb|
	aColor := aToolDockingBar originalColor.
	c := aColor  alphaMixed: 0.7 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.50->cm. 0.51->cd. 1.0->cb})
		origin: aToolDockingBar topLeft;
		direction: (aToolDockingBar isVertical
			ifTrue: [aToolDockingBar width @ 0]
			ifFalse: [0 @ aToolDockingBar height]);
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:12'!
dropListDisabledFillStyleFor: aDropList
	"Return the disabled fillStyle for the given drop list."
	
	|c inner|
	c := aDropList paneColor alphaMixed: 0.3 with: Color white.
	inner := aDropList innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c darker.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'defaults' stamp: 'GaryChambers 8/18/2010 17:53'!
dropListInsetFor: aDropList
	"Answer the inset to use for drop-list layout."

	^(1@0 corner: 0@0)! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:11'!
dropListNormalFillStyleFor: aDropList
	"Return the normal fillStyle for the given drop list."
	
	|c inner|
	c := aDropList paneColor alphaMixed: 0.1 with: Color white.
	inner := aDropList innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:18'!
dropListNormalListFillStyleFor: aDropList
	"Return the normal fillStyle for the list of the given drop list."
	
	|c inner|
	c := aDropList paneColor alphaMixed: 0.1 with: Color white.
	inner := aDropList listMorph innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c darker.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'defaults' stamp: 'GaryChambers 8/18/2010 17:55'!
editableDropListInsetFor: aDropList
	"Answer the inset to use for an editable drop-list layout."

	^0! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:49'!
errorIcon
	"Answer an error icon."

	^VistaryThemeIcons errorIcon! !

!UIThemeVistary methodsFor: 'defaults' stamp: 'gvc 2/23/2008 16:30'!
expanderTitleInsetFor: aDropList
	"Answer the inset to use for expander title layout."

	^(0@0 corner: -1@0)! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 2/23/2008 16:33'!
expanderTitleNormalFillStyleFor: anExpanderTitle
	"Return the normal expander title fillStyle for the given expander title."
	
	|aColor c cm cd cb|
	aColor := anExpanderTitle paneColor.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.9 with: Color white.
	cd := cm alphaMixed: 0.9 with: Color black.
	cb := aColor alphaMixed: 0.6 with: Color black.
	^(GradientFillStyle ramp: {0.0->c. 0.50->cm. 0.51->cd. 1.0->cb})
		origin: anExpanderTitle topLeft;
		direction: 0 @ anExpanderTitle height;
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 1/25/2008 14:44'!
groupLabelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a group label."

	^BorderStyle simple
		width: 1;
		baseColor: (aGroupPanel paneColor lighter alphaMixed: 0.8 with: Color black)! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 1/25/2008 14:38'!
groupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a group panel."

	^TabPanelBorder new
		width: 1;
		baseColor: (aGroupPanel paneColor lighter alphaMixed: 0.8 with: Color black);
		tabSelector: aGroupPanel! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 3/26/2008 17:56'!
hThumbForm
	"Answer the form to use for horizontal thumbs."

	^self forms at: #hThumb ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:49'!
infoIcon
	"Answer an information icon."

	^VistaryThemeIcons infoIcon! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 10/28/2008 15:37'!
initializeForms
	"Initialize the receiver's image forms."

	super initializeForms.
	self forms
		at: #vThumb put: self newVThumbForm;
		at: #hThumb put: self newHThumbForm;
		at: #windowCloseOver put: self newWindowCloseOverForm;
		at: #windowCloseDown put: self newWindowCloseDownForm;
		at: #windowClosePassive put: self newWindowClosePassiveForm;
		at: #windowMinimizeOver put: self newWindowMinimizeOverForm;
		at: #windowMinimizeDown put: self newWindowMinimizeDownForm;
		at: #windowMaximizeOver put: self newWindowMaximizeOverForm;
		at: #windowMaximizeDown put: self newWindowMaximizeDownForm! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:49'!
lockIcon
	"Answer a lock icon."

	^VistaryThemeIcons lockIcon! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/4/2007 12:54'!
menuItemInDockingBarSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item that is in a docking bar."
	
	|c fill|
	Display depth <= 2 ifTrue: [^ Color gray].
	c := aMenuItem owner color isTransparent
		ifTrue: [aMenuItem paneColor darker]
		ifFalse: [aMenuItem owner color darker].
	fill := GradientFillStyle ramp: {
		0.0->Color white.
		0.2->c lighter.
		1.0->Color white}.
	fill origin: aMenuItem topLeft.
	aMenuItem owner isVertical
		ifTrue: [fill direction: aMenuItem width @ 0]
		ifFalse: [fill direction: 0 @ aMenuItem height].
	^ fill! !

!UIThemeVistary methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/4/2007 12:59'!
menuItemSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item."
	
	|c aColor selcol cm cd cb|
	Display depth <= 2 ifTrue: [^ Color gray].
	aColor := aMenuItem owner color isTransparent
		ifTrue: [aMenuItem paneColor darker]
		ifFalse: [aMenuItem owner color darker].
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.4 with: selcol.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.1 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	^(GradientFillStyle ramp: {
			0.0->c. 0.5->cm. 0.51->cd. 0.8->cb. 1.0->Color white})
		origin: aMenuItem topLeft;
		direction: 0 @ aMenuItem height! !

!UIThemeVistary methodsFor: 'morph creation' stamp: 'GaryChambers 8/10/2010 16:33'!
newCloseControlIn: aThemedMorph for: aModel action: aValuable help: helpText
	"Answer a button for closing things."
	
	| form msb |
	form := self windowCloseForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowClosePassiveForm.
	msb extent: form extent.
	msb activeDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowCloseOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowCloseDownForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: aValuable;
		setBalloonText: helpText.
	^msb! !

!UIThemeVistary methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 16:56'!
newDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a drop list for the given model."
	
	^(super
		newDropListIn: aThemedMorph
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText)
		roundedCorners: #(1 2)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 3/26/2008 19:40'!
newHThumbForm
	"Answer a new form for a horizontal thumb (mostly for scrollbars)."

	^Form
	extent: 10@9
	depth: 32
	fromArray: #( 0 2164260863 2164260863 150994943 2164260863 2164260863 33554431 2164260863 2164260863 33554431 2164260863 2147483648 2151694400 2164260863 2147483648 2151694400 2164260863 2147483648 2151694400 2164260863 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2147483648 2155905152 2164260863 2164260863 2151694400 2155905152 2164260863 2151694400 2155905152 2164260863 2151694400 2155905152 2164260863 0 2164260863 2164260863 0 2164260863 2164260863 0 2164260863 2164260863 0)
	offset: 0@0! !

!UIThemeVistary methodsFor: 'morph creation' stamp: 'gvc 8/8/2007 16:57'!
newMorphDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a morph drop list for the given model."

	^(super
		newMorphDropListIn: aThemedMorph
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText)
		roundedCorners: #(1 2)! !

!UIThemeVistary methodsFor: 'morph creation' stamp: 'gvc 3/2/2009 12:31'!
newTaskbarThumbnailIn: aThemedMorph for: aWindow
	"Answer a taskbar thumbnail morph for the given window."

	|answer thumb|
	thumb := aWindow taskbarThumbnail.
	answer := PanelMorph new
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		layoutInset: 8;
		cellInset: 4;
		addMorphBack: thumb;
		addMorphBack: ((self
			buttonLabelForText: (aWindow labelString truncateWithElipsisTo: 50))
				color: Color white).
	answer
		extent: answer minExtent;
		fillStyle: (self tasklistFillStyleFor: answer);
		borderStyle: (self taskbarThumbnailNormalBorderStyleFor: aWindow);
		cornerStyle: (self taskbarThumbnailCornerStyleFor: answer).
	^answer
			! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 9/5/2007 14:51'!
newTreeExpandedForm
	"Answer a new form for an expanded tree item."

	^(Form
		extent: 9@9
		depth: 32
		fromArray: #( 16777215 16777215 16777215 16777215 16777215 805306368 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1006961930 4026795016 50331648 16777215 16777215 16777215 16777215 16777215 301989888 3725726500 4046204508 973078528 16777215 16777215 16777215 16777215 16777216 3255701277 4283585959 4282533261 2533951764 16777215 16777215 16777215 16777215 2265779739 4114629505 4283849140 4282730394 3590850580 16777215 16777215 16777215 1091045392 3928237641 4284046778 4282993825 4282006408 3859549217 335544320 16777215 369098752 3993372173 4012715870 3995609688 3995083083 3994490942 4077389851 1577058307 16777215 419430400 939524096 939524096 939524096 939524096 939524096 939524096 486539264 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 9/5/2007 14:57'!
newTreeUnexpandedForm
	"Answer a new form for an unexpanded tree item."

	^(Form
	extent: 9@9
	depth: 32
	fromArray: #( 16777215 134217728 270409246 16777215 16777215 16777215 16777215 16777215 16777215 16777215 402653184 3565586054 1045582418 16777215 16777215 16777215 16777215 16777215 16777215 402653184 4191606486 3973371092 2003068004 16777215 16777215 16777215 16777215 16777215 402653184 4191606486 4294967295 4243714545 2860153466 270409246 16777215 16777215 16777215 402653184 4191606486 4294967295 4294967295 4294901502 2975620188 16777215 16777215 16777215 402653184 4191606486 4294967295 4226739950 2659090046 167772160 16777215 16777215 16777215 402653184 4191606486 3905933263 1785293161 16777215 16777215 16777215 16777215 16777215 402653184 3531505278 928207699 16777215 16777215 16777215 16777215 16777215 16777215 117440512 202642452 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 3/26/2008 19:39'!
newVThumbForm
	"Answer a new form for a vertical thumb (mostly for scrollbars)."

	^Form
	extent: 9@10
	depth: 32
	fromArray: #( 0 2164260863 2164260863 2164260863 2164260863 2164260863 2164260863 2164260863 0 2164260863 2147483648 2147483648 2147483648 2147483648 2147483648 2147483648 2151694400 2164260863 2164260863 2151694400 2155905152 2155905152 2155905152 2155905152 2155905152 2155905152 2164260863 150994943 2164260863 2164260863 2164260863 2164260863 2164260863 2164260863 2164260863 0 2164260863 2147483648 2147483648 2147483648 2147483648 2147483648 2147483648 2151694400 2164260863 2164260863 2151694400 2155905152 2155905152 2155905152 2155905152 2155905152 2155905152 2164260863 33554431 2164260863 2164260863 2164260863 2164260863 2164260863 2164260863 2164260863 0 2164260863 2147483648 2147483648 2147483648 2147483648 2147483648 2147483648 2151694400 2164260863 2164260863 2151694400 2155905152 2155905152 2155905152 2155905152 2155905152 2155905152 2164260863 33554431 2164260863 2164260863 2164260863 2164260863 2164260863 2164260863 2164260863 0)
	offset: 0@0! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 10/27/2008 13:49'!
newWindowCloseDownForm
	"Answer a new form for a window close box in mouse down over state."

	^(Form
		extent: 18@18
		depth: 32
		fromArray: #( 150863872 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 117309440 1711144960 1711144960 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2818441216 2717777920 2717777920 1711144960 1711144960 1711144960 2717777920 4288710531 4288841603 4288841345 4288841345 4288841345 4288841345 4288841345 4288841345 4288841345 4288841345 4288841345 4288841345 4288841345 4288841603 2717777920 1711144960 1711144960 2717777920 4288709760 4288709760 4288709502 4288709502 4288709502 4288709502 4288709502 4288709502 4288709502 4288709502 4288709502 4288709502 4288709502 4288709760 2717777920 1711144960 1711144960 2717777920 4288577403 4288577403 4284898397 4282269510 4282269510 4282269510 4284898140 4288577403 4284897884 4282269510 4282269510 4282269510 4284898397 4288577403 2717777920 1711144960 1711144960 2717777920 4288313975 4288445302 4282269510 4290624957 4290624957 4290624957 4282269510 4284897626 4282269510 4290624957 4290624957 4290624957 4282269510 4288445302 2717777920 1711144960 1711144960 2717777920 4288247410 4288247152 4284700247 4282269510 4290427578 4290624957 4290427578 4282269510 4290427578 4290624957 4290624957 4282401352 4284700247 4288313202 2717777920 1711144960 1711144960 2717777920 4287917673 4287917673 4287917673 4284699733 4282269510 4290361785 4290427578 4290361785 4290427578 4290427578 4282401352 4284568148 4287917416 4287917673 2717777920 1711144960 1711144960 2717777920 4287456094 4287456093 4287587422 4287587422 4284436047 4282269510 4289440683 4289638062 4289638062 4282401352 4284436048 4287456093 4287587422 4287456093 2717777920 1711144960 1711144960 2717777920 4286201912 4286201912 4286267961 4286267961 4283908416 4282269510 4289440683 4289638062 4289638062 4282269510 4283908160 4286267961 4286267961 4286267961 2717777920 1711144960 1711144960 2717777920 4285938482 4286069811 4286069811 4283907903 4282269510 4289243304 4289243304 4289243304 4289243304 4289243304 4282269510 4283907903 4286069811 4286069554 2717777920 1711144960 1711144960 2717777920 4286070840 4286202425 4283908416 4282269510 4288848546 4288980132 4288980132 4282335302 4288848546 4288980132 4288848546 4282269510 4283908416 4286202425 2717777920 1711144960 1711144960 2717777920 4286270016 4286269759 4282269510 4288585374 4288716960 4288716960 4282335302 4283909186 4282269510 4288585374 4288716960 4288585374 4282269510 4286269759 2717777920 1711144960 1711144960 2717777920 4286534216 4286534216 4284041287 4282269510 4282269510 4282269510 4284041030 4286665032 4284172360 4282269510 4282269510 4282269510 4284041287 4286534216 2717777920 1711144960 1711144960 2717777920 4286930260 4286930258 4286930260 4286930258 4286930258 4286930258 4286930258 4287061588 4286930258 4286930258 4286930258 4287061588 4286930258 4286930260 2717777920 1711144960 1711144960 2717777920 4287194716 4287194716 4287325531 4287456861 4287456861 4287456861 4287456861 4287456861 4287456861 4287456861 4287457117 4287456861 4287456861 4287194716 2717777920 1711144960 1711144960 1711144960 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 1711144960 1711144960 50200576 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 184418304)
	offset: 0@0)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 5/15/2007 10:47'!
newWindowCloseForm
	"Answer a new form for a window close box."

	^Form
		extent: 14@14
		depth: 32
		fromArray: #( 4293504934 4293636006 4293701540 4293767076 4293767076 4293767076 4293767076 4293767076 4293767076 4293767076 4293767076 4293767076 4293701540 4293636006 4293503392 4293503392 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293503392 4293436828 4293502364 4287789179 4283717479 4283717479 4283717479 4287854715 4293567642 4287920252 4283717479 4283717479 4283717479 4287789179 4293502364 4293238164 4293369236 4283651686 4294835709 4294901502 4294901502 4283717479 4287788409 4283651686 4294835709 4294901502 4294901502 4283717479 4293369236 4293105548 4293171084 4287590772 4283717479 4294769916 4294835709 4294769916 4283717479 4294704123 4294835709 4294835709 4283783272 4287590772 4293236620 4292840319 4292905855 4292840062 4287589743 4283717479 4294572537 4294638330 4294572537 4294638330 4294638330 4283783272 4287523951 4292905597 4292971391 4292443503 4292509039 4292574575 4292574575 4287391593 4283717479 4293454056 4293519849 4293519849 4283783272 4287391337 4292508782 4292574575 4292509039 4291316278 4291447350 4291578934 4291644470 4286993233 4283651686 4293454056 4293519849 4293519849 4283717479 4286927441 4291513398 4291644470 4291512886 4291117870 4291248942 4291380270 4286926926 4283651686 4292927714 4293059298 4293059298 4293059298 4292993506 4283717478 4286926670 4291380270 4291380014 4291185719 4291317047 4286927697 4283651686 4292532956 4292664540 4292664540 4283783270 4292598748 4292664540 4292598748 4283717478 4286927697 4291382583 4291188800 4291319872 4283651686 4292204247 4292335575 4292335575 4283783270 4286863189 4283717478 4292269783 4292335575 4292270039 4283717478 4291385408 4291454286 4291454286 4286930267 4283717478 4283717478 4283717478 4286995803 4291585101 4287061339 4283717478 4283717478 4283717478 4286930267 4291454286 4291655006 4291720542 4291655006 4291851614 4291851614 4291851614 4291851614 4291917150 4291851614 4291851614 4291851614 4291851870 4291786334 4291720798 4291985771 4291985771 4292182378 4292247914 4292247914 4292247914 4292247914 4292247914 4292247914 4292247914 4292248170 4292248171 4292248171 4291986026)
		offset: 0@0! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 10/27/2008 13:48'!
newWindowCloseOverForm
	"Answer a new form for a window close box in mouse over state."

	^(Form
		extent: 18@18
		depth: 32
		fromArray: #( 150863872 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 117309440 1711144960 1711144960 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2818441216 2717777920 2717777920 1711144960 1711144960 1711144960 2717777920 4293504934 4293636006 4293701540 4293767076 4293767076 4293767076 4293767076 4293767076 4293767076 4193103780 4293767076 4293767076 4293701540 4293636006 2717777920 1711144960 1711144960 2717777920 4293503392 4293503392 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293634976 4293503392 2717777920 1711144960 1711144960 2717777920 4293436828 4293502364 4287789179 4283717479 4283717479 4283717479 4287854715 4293567642 4287920252 4283717479 4283717479 4283717479 4287789179 4293502364 2717777920 1711144960 1711144960 2717777920 4293238164 4293369236 4283651686 4294835709 4294901502 4294901502 4283717479 4287788409 4283651686 4294835709 4294901502 4294901502 4283717479 4293369236 2717777920 1711144960 1711144960 2717777920 4293105548 4293171084 4287590772 4283717479 4294769916 4294835709 4294769916 4283717479 4294704123 4294835709 4294835709 4283783272 4287590772 4293236620 2717777920 1711144960 1711144960 2717777920 4292840319 4292905855 4292840062 4287589743 4283717479 4294572537 4294638330 4294572537 4294638330 4294638330 4283783272 4287523951 4292905597 4292971391 2717777920 1711144960 1711144960 2717777920 4292443503 4292509039 4292574575 4292574575 4287391593 4283717479 4293454056 4293519849 4293519849 4283783272 4287391337 4292508782 4292574575 4292509039 2717777920 1711144960 1711144960 2717777920 4291316278 4291447350 4291578934 4291644470 4286993233 4283651686 4293454056 4293519849 4293519849 4283717479 4286927441 4291513398 4291644470 4291512886 2717777920 1711144960 1711144960 2717777920 4291117870 4291248942 4291380270 4286926926 4283651686 4292927714 4293059298 4293059298 4293059298 4292993506 4283717478 4286926670 4291380270 4291380014 2717777920 1711144960 1711144960 2717777920 4291185719 4291317047 4286927697 4283651686 4292532956 4292664540 4292664540 4283783270 4292598748 4292664540 4292598748 4283717478 4286927697 4291382583 2717777920 1711144960 1711144960 2717777920 4291188800 4291319872 4283651686 4292204247 4292335575 4292335575 4283783270 4286863189 4283717478 4292269783 4292335575 4292270039 4283717478 4291385408 2717777920 1711144960 1711144960 2717777920 4291454286 4291454286 4286930267 4283717478 4283717478 4283717478 4286995803 4291585101 4287061339 4283717478 4283717478 4283717478 4286930267 4291454286 2717777920 1711144960 1711144960 2717777920 4291655006 4291720542 4291655006 4291851614 4291851614 4291851614 4291851614 4291917150 4291851614 4291851614 4291851614 4291851870 4291786334 4291720798 2717777920 1711144960 1711144960 2717777920 4291985771 4291985771 4292182378 4292247914 4292247914 4292247914 4292247914 4292247914 4292247914 4292247914 4292248170 4292248171 4292248171 4291986026 2717777920 1711144960 1711144960 1711144960 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 2717777920 1711144960 1711144960 50200576 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 1711144960 184418304)
	offset: 0@0)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 10/22/2008 15:08'!
newWindowClosePassiveForm
	"Answer a new form for a passive window close box."

	^(Form
		extent: 14@14
		depth: 32
		fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287789179 4283717479 4283717479 4283717479 4287854715 0 4287920252 4283717479 4283717479 4283717479 4287789179 0 0 0 4283651686 4294835709 4294901502 4294901502 4283717479 4287788409 4283651686 4294835709 4294901502 4294901502 4283717479 0 0 0 4287590772 4283717479 4294769916 4294835709 4294769916 4283717479 4294704123 4294835709 4294835709 4283783272 4287590772 0 0 0 0 4287589743 4283717479 4294572537 4294638330 4294572537 4294638330 4294638330 4283783272 4287523951 0 0 0 0 0 0 4287391593 4283717479 4293454056 4293519849 4293519849 4283783272 4287391337 0 0 0 0 0 0 0 4286993233 4283651686 4293454056 4293519849 4293519849 4283717479 4286927441 0 0 0 0 0 0 4286926926 4283651686 4292927714 4293059298 4293059298 4293059298 4292993506 4283717478 4286926670 0 0 0 0 4286927697 4283651686 4292532956 4292664540 4292664540 4283783270 4292598748 4292664540 4292598748 4283717478 4286927697 0 0 0 4283651686 4292204247 4292335575 4292335575 4283783270 4286863189 4283717478 4292269783 4292335575 4292270039 4283717478 0 0 0 4286930267 4283717478 4283717478 4283717478 4286995803 0 4287061339 4283717478 4283717478 4283717478 4286930267 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 10/28/2008 15:35'!
newWindowMaximizeDownForm
	"Answer a new form for a mouse down window maximize box."

	^(Form
		extent: 18@18
		depth: 32
		fromArray: #( 50331647 50331647 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 167772159 33554431 33554431 33554431 33554431 55175422 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 38398206 33554431 33554431 1699342590 1682434302 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 1682434302 1699342590 33554431 33554431 1699342590 2705844222 3375444796 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 3408999228 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4281414460 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4281414460 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4281414460 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4281414460 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4281414460 4287927444 4287927444 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 4287927444 4287927444 4281414460 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4281414460 4287137928 4287269514 4281414460 2705844222 2705844222 2705844222 2705844222 4281414460 4287137928 4287269514 4281414460 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4281414460 4287137928 4287269514 4281414460 2705844222 2705844222 2705844222 2705844222 4281414460 4287137928 4287269514 4281414460 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4281414460 4286940549 4286940549 4281479996 4281414460 4281414460 4281414460 4281414460 4281414460 4286940549 4286940549 4281479996 2705844222 1699342590 452984831 33554431 1699342590 2705844222 4281414460 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4281479996 2705844222 1699342590 33554431 33554431 2154819071 2705844222 4281414460 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4281479996 2705844222 1699342590 33554431 33554431 1716250879 2705844222 3375444796 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 3375444796 2705844222 1699342590 33554431 33554431 1699342590 1682434302 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 1682434302 1699342590 33554431 33554431 38398206 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 71952638 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431)
	offset: 0@0)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 5/15/2007 11:08'!
newWindowMaximizeForm
	"Answer a new form for a window maximize box."

	^Form
		extent: 14@14
		depth: 32
		fromArray: #( 14410989 14476525 14476525 14410989 14410989 14410989 14476525 14410989 14279659 14213610 14016230 13950180 13818594 13687007 14476525 14476525 14476525 14476525 14476525 14410989 14410989 14410988 14279403 14213610 14016230 13950180 13818594 13687007 14476525 3377747815 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 3411302247 13687007 14345195 4283717479 4294638330 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4283717479 13358300 14082024 4283717479 4294704123 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4283717479 13029336 13490402 4283717479 4294704123 4294769916 4283783272 4283717479 4283717479 4283717479 4283717479 4283717479 4294704123 4294769916 4283717479 12371663 12964315 4283717479 4293454056 4293519849 4283717479 12503765 12569302 12437973 12306386 4283717479 4293454056 4293519849 4283717479 11582405 10859972 4283717479 4293454056 4293519849 4283717479 10399422 10464959 10268092 10070713 4283717479 4293454056 4293519849 4283717479 9017253 10662339 4283717479 4292993506 4293059298 4283717478 4283717479 4283717479 4283717479 4283717479 4283651686 4292993506 4293059298 4283717478 8688033 10728391 4283717479 4292598748 4292664540 4292598748 4292598748 4292598748 4292598748 4292598748 4292598748 4292664540 4292664540 4283717478 8819620 10794440 4283717479 4292269783 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4283717478 8951720 11057614 3377747815 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 3377747815 9280942 11517651 11583187 11517393 11385807 11320015 11122893 11057101 10925514 10662598 10531013 10267583 10070204 9938105 9806517 11978203 12175067 12043738 11846616 11846359 11649237 11583445 11451859 11188943 11122893 10793928 10662084 10529986 10201789)
		offset: 0@0! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 10/27/2008 16:50'!
newWindowMaximizeOverForm
	"Answer a new form for a mouse over window maximize box."

	^(Form
		extent: 18@18
		depth: 32
		fromArray: #( 50331647 50331647 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 167772159 33554431 33554431 33554431 33554431 55175422 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 38398206 33554431 33554431 1699342590 1682434302 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 1682434302 1699342590 33554431 33554431 1699342590 2705844222 3377747815 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 3411302247 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4283717479 4294638330 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4283717479 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4283717479 4294704123 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4283717479 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4283717479 4294704123 4294769916 4283783272 4283717479 4283717479 4283717479 4283717479 4283717479 4294704123 4294769916 4283717479 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4283717479 4293454056 4293519849 4283717479 2705844222 2705844222 2705844222 2705844222 4283717479 4293454056 4293519849 4283717479 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4283717479 4293454056 4293519849 4283717479 2705844222 2705844222 2705844222 2705844222 4283717479 4293454056 4293519849 4283717479 2705844222 1699342590 33554431 33554431 1699342590 2705844222 4283717479 4292993506 4293059298 4283717478 4283717479 4283717479 4283717479 4283717479 4283651686 4292993506 4293059298 4283717478 2705844222 1699342590 452984831 33554431 1699342590 2705844222 4283717479 4292598748 4292664540 4292598748 4292598748 4292598748 4292598748 4292598748 4292598748 4292664540 4292664540 4283717478 2705844222 1699342590 33554431 33554431 2154819071 2705844222 4283717479 4292269783 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4283717478 2705844222 1699342590 33554431 33554431 1716250879 2705844222 3377747815 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 3377747815 2705844222 1699342590 33554431 33554431 1699342590 1682434302 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 1682434302 1699342590 33554431 33554431 38398206 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 71952638 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431 33554431)
	offset: 0@0)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 5/15/2007 11:09'!
newWindowMenuForm
	"Answer a new form for a window menu box."

	^Form
		extent: 14@14
		depth: 32
		fromArray: #( 14410989 14476525 14476525 14410989 14410989 14410989 14476525 14410989 14279659 14213610 14016230 13950180 13818594 13687007 14476525 14476525 14476525 14476525 14476525 14410989 14410989 14410988 14279403 14213610 14016230 13950180 13818594 13687007 14476525 3360970599 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 3360970599 13687007 14345195 4283717479 4294638330 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4294704123 4283717479 13358300 14082024 4283717479 4294704123 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4294769916 4294769916 4294769916 4283717479 13029336 13490402 4283717479 4294704123 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4283717479 12371663 12964315 4283717479 4293454056 4283717479 4283717479 4283717479 4293519849 4283717479 4283717479 4283717479 4293454056 4293519849 4283717479 11582405 10859972 4283717479 4293454056 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293454056 4293519849 4283717479 9017253 10662339 4283717479 4292993506 4283717479 4283717479 4292993506 4283717479 4283717479 4292993506 4283717479 4292993506 4293059298 4283717478 8688033 10728391 4283717479 4292598748 4292664540 4292598748 4292598748 4292598748 4292598748 4292598748 4292598748 4292664540 4292664540 4283717478 8819620 10794440 4283717479 4292269783 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4283717478 8951720 11057614 3377747815 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 3411302247 9280942 11517651 11583187 11517393 11385807 11320015 11122893 11057101 10925514 10662598 10531013 10267583 10070204 9938105 9806517 11978203 12175067 12043738 11846616 11846359 11649237 11583445 11451859 11188943 11122893 10793928 10662084 10529986 10201789)
		offset: 0@0! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 10/28/2008 15:35'!
newWindowMinimizeDownForm
	"Answer a new form for a mouse down window minimize box."

	^(Form
		extent: 18@18
		depth: 32
		fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 55044350 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 55044350 0 0 1682434302 1682434302 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 1682434302 1682434302 0 0 1682434302 2705844222 3358667580 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 4281414460 3408999228 2705844222 1682434302 0 0 1682434302 2705844222 4281414460 4288059030 4288059030 4288059030 4288059030 4288059030 4288059030 4288059030 4288059030 4288059030 4288059030 4281414460 2705844222 1682434302 0 0 1682434302 2705844222 4281414460 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4286743170 4281479996 2705844222 1682434302 0 0 1682434302 2705844222 4281414460 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4286545791 4281479996 2705844222 1682434302 0 0 1682434302 2705844222 3492885308 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 4281479996 3560059966 2705844222 1682434302 0 0 1682434302 1682434302 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 1682434302 1682434302 0 0 71821566 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 105375998 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 5/15/2007 11:09'!
newWindowMinimizeForm
	"Answer a new form for a window minimize box."

	^Form
		extent: 14@14
		depth: 32
		fromArray: #( 14345196 14345452 14345452 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14410989 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14476525 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14345196 14279660 14147817 14147817 14147817 14147817 14147817 14147817 14147817 14147817 14213353 14213353 14147817 14147817 14147817 14082025 13687523 13687523 13687523 13687523 13687523 13687523 13687523 13687523 13687524 13687524 13687523 13621731 13555939 13490403 13095901 13161437 13161437 13161437 13161437 13161437 13161437 13161437 13161437 13161181 13161181 13030109 12964316 12832988 11188679 3360970599 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 3411302247 10728645 10991559 4283651686 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4283717479 10399940 11188940 4283651686 4292598748 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4283717478 10465992 11320526 4283651686 4292269783 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4283717478 10465993 11583699 3495188327 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 3562363241 10532044 11912409 11912152 11912152 11912152 11912152 11912152 11912151 11912151 11846358 11715030 11517909 11189203 10992082 10860754 12372960 12372960 12438496 12438496 12438496 12438496 12372703 12372703 12241375 12109789 11978204 11583963 11452377 11255513)
		offset: 0@0! !

!UIThemeVistary methodsFor: 'initialize-release' stamp: 'gvc 10/27/2008 13:36'!
newWindowMinimizeOverForm
	"Answer a new form for a mouse over window minimize box."

	^(Form
		extent: 18@18
		depth: 32
		fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 55044350 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 55044350 0 0 1682434302 1682434302 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 1682434302 1682434302 0 0 1682434302 2705844222 3360970599 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 4283717479 3411302247 2705844222 1682434302 0 0 1682434302 2705844222 4283651686 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4283717479 2705844222 1682434302 0 0 1682434302 2705844222 4283651686 4292598748 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4283717478 2705844222 1682434302 0 0 1682434302 2705844222 4283651686 4292269783 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4283717478 2705844222 1682434302 0 0 1682434302 2705844222 3495188327 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 4283717478 3562363241 2705844222 1682434302 0 0 1682434302 1682434302 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 2705844222 1682434302 1682434302 0 0 71821566 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 1682434302 105375998 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 1/17/2008 11:45'!
plainGroupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a plain group panel."

	^BorderStyle simple
		width: 1;
		baseColor: (aGroupPanel paneColor lighter alphaMixed: 0.8 with: Color black)! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 2/29/2008 21:32'!
progressBarBorderStyleFor: aProgressBar
	"Return the progress bar borderStyle for the given progress bar."

	|pc mc ic|
	pc := self progressBarColorFor: aProgressBar.
	mc := pc alphaMixed: 0.7 with: Color black.
	ic := Color white alpha: 0.3.
	^(CompositeBorder new width: 1)
		borders: {RoundedBorder new
					cornerRadius: 1;
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 7/3/2007 12:30'!
progressBarFillStyleFor: aProgressBar
	"Return the progress bar fillStyle for the given progress bar."
	
	|aColor area c cm cd cb|
	aColor := self progressBarColorFor: aProgressBar.
	area :=  aProgressBar bounds.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.49->cm. 0.5->cd. 1.0->cb})
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 4/24/2007 11:57'!
progressBarProgressFillStyleFor: aProgressBar
	"Return the progress bar progress fillStyle for the given progress bar."
	
	|aColor area c cm cd cb|
	aColor := self progressBarProgressColorFor: aProgressBar.
	area :=  aProgressBar innerBounds.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.49->cm. 0.5->cd. 1.0->cb})
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:47'!
questionIcon
	"Answer a question icon."

	^VistaryThemeIcons questionIcon! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 2/22/2008 22:08'!
radioButtonDisabledBorderStyleFor: aRadioButton
	"Return the disabled radio button borderStyle for the given button."

	|pc|
	pc := self buttonColorFor: aRadioButton.
	^BorderStyle simple
		width: 1;
		baseColor: (pc twiceDarker alphaMixed: 0.7 with: Color white).! !

!UIThemeVistary methodsFor: 'border-styles-buttons' stamp: 'gvc 9/5/2007 13:37'!
radioButtonNormalBorderStyleFor: aRadioButton
	"Return the disabled radio button borderStyle for the given button."

	|pc|
	pc := self buttonColorFor: aRadioButton.
	^BorderStyle simple
		width: 1;
		baseColor: pc twiceDarker! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 3/27/2008 21:35'!
resizerGripNormalFillStyleFor: aResizer
	"Return the normal fillStyle for the given resizer.
	For the moment, answer a transparent colour for no drawing,
	non transparent to draw as normal."
	
	^Color transparent! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:48'!
scrollbarMouseOverBarButtonBorderStyleFor: aScrollbar
	"Return the button borderStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalThumbBorderStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 15:47'!
scrollbarMouseOverBarButtonFillStyleFor: aScrollbar
	"Return the button fillStyle for the given scrollbar when
	the mouse is over the bar."

	^self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 15:20'!
scrollbarMouseOverButtonBorderStyleFor: aScrollbar
	"Return the mouse over button borderStyle for the given scrollbar."

	^self scrollbarMouseOverThumbBorderStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/5/2007 14:23'!
scrollbarMouseOverButtonFillStyleFor: aScrollbar
	"Return the mouse over scrollbar button fillStyle for the given scrollbar."
	
	^self scrollbarMouseOverThumbFillStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 2/22/2008 21:01'!
scrollbarMouseOverThumbBorderStyleFor: aScrollbar
	"Return the mouse over thumb borderStyle for the given scrollbar."

	|aColor oc ic|
	aColor := self scrollbarColorFor: aScrollbar.
	oc := (aColor alphaMixed: 0.2 with: aColor darker)
		alphaMixed: 0.6 with: self selectionColor.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {RoundedBorder new
					cornerRadius: 1;
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 5/27/2008 21:07'!
scrollbarMouseOverThumbFillStyleFor: aScrollbar
	"Return the scrollbar mouse over thumb fillStyle for the given color."
	
	|aColor c cm cd cb selcol thumb grad offset|
	aColor := self scrollbarColorFor: aScrollbar.
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.5 with: selcol.
	cd := aColor alphaMixed: 0.9 with: Color black.
	cb := aColor alphaMixed: 0.3 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	grad := (GradientFillStyle ramp: {0.0->c. 0.48->cm. 0.49->cd. 1.0->cb})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false.
	aScrollbar bounds isWide
		ifTrue: [thumb := self hThumbForm.
				offset := thumb extent // 2 + (0@1)]
		ifFalse: [thumb := self vThumbForm.
				offset := thumb extent // 2 + (1@0)].
	^((aScrollbar slider bounds isWide and: [aScrollbar slider width > (thumb width * 2)]) or: [
			aScrollbar slider bounds isWide not and: [aScrollbar slider height > (thumb height * 2)]])
		ifTrue: [CompositeFillStyle fillStyles: {
				grad.
				(ImageFillStyle
					form: thumb)
					origin: aScrollbar slider bounds center - offset;
					direction: thumb width@0}]
		ifFalse: [grad]! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/4/2007 14:55'!
scrollbarNormalButtonBorderStyleFor: aScrollbar
	"Return the normal button borderStyle for the given scrollbar."

	^BorderStyle simple
		width: 0! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/17/2007 16:19'!
scrollbarNormalButtonFillStyleFor: aScrollbar
	"Return the normal scrollbar button fillStyle for the given scrollbar."
	
	^self scrollbarNormalFillStyleFor: aScrollbar! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/4/2007 14:53'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	|aColor c|
	aColor := (self scrollbarColorFor: aScrollbar) alphaMixed: 0.3 with: Color white.
	c := aColor alphaMixed: 0.9 with: Color black.
	^(GradientFillStyle ramp: {0.0->c. 0.15->aColor. 0.9->aColor. 1.0->c})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles-scrollbars' stamp: 'gvc 2/22/2008 17:49'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	|aColor oc ic|
	aColor := self scrollbarColorFor: aScrollbar.
	oc := aColor alphaMixed: 0.2 with: aColor darker.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {RoundedBorder new
					cornerRadius: 1;
					width: 1;
					baseColor: oc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 5/27/2008 21:07'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar thumb fillStyle for the given scrollbar."
	
	|aColor c cm cd cb thumb grad offset|
	aColor := self scrollbarColorFor: aScrollbar.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.9 with: Color white.
	cd := cm alphaMixed: 0.9 with: Color black.
	cb := aColor alphaMixed: 0.6 with: Color black.
	grad := (GradientFillStyle ramp: {0.0->c. 0.48->cm. 0.49->cd. 1.0->cb})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false.
	aScrollbar bounds isWide
		ifTrue: [thumb := self hThumbForm.
				offset := thumb extent // 2 + (0@1)]
		ifFalse: [thumb := self vThumbForm.
				offset := thumb extent // 2 + (1@0)].
	^((aScrollbar slider bounds isWide and: [aScrollbar slider width > (thumb width * 2)]) or: [
			aScrollbar slider bounds isWide not and: [aScrollbar slider height > (thumb height * 2)]])
		ifTrue: [CompositeFillStyle fillStyles: {
				grad.
				(ImageFillStyle
					form: thumb)
					origin: aScrollbar slider bounds center - offset;
					direction: thumb width@0}]
		ifFalse: [grad]! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 4/16/2007 13:05'!
scrollbarPressedFillStyleFor: aScrollbar
	"Return the pressed scrollbar fillStyle for the given scrollbar."
	
	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^aColor alphaMixed: 0.6 with: Color white! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 5/27/2008 21:08'!
scrollbarPressedThumbFillStyleFor: aScrollbar
	"Return the pressed scrollbar thumb fillStyle for the given scrollbar."
	
	|aColor c cm cd cb selcol thumb grad offset|
	aColor := self scrollbarColorFor: aScrollbar.
	selcol := (self selectionColor adjustSaturation: 0.2 brightness: 0.5).
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.4 with: selcol.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.1 with: (self selectionColor adjustSaturation: 0.7 brightness: 1.0) whiter.
	grad := (GradientFillStyle ramp: {0.0->c. 0.48->cm. 0.49->cd. 1.0->cb})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false.
	aScrollbar bounds isWide
		ifTrue: [thumb := self hThumbForm.
				offset := thumb extent // 2 + (0@1)]
		ifFalse: [thumb := self vThumbForm.
				offset := thumb extent // 2 + (1@0)].
	^((aScrollbar slider bounds isWide and: [aScrollbar slider width > (thumb width * 2)]) or: [
			aScrollbar slider bounds isWide not and: [aScrollbar slider height > (thumb height * 2)]])
		ifTrue: [CompositeFillStyle fillStyles: {
				grad.
				(ImageFillStyle
					form: thumb)
					origin: aScrollbar slider bounds center - offset;
					direction: thumb width@0}]
		ifFalse: [grad]! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:38'!
sliderDisabledFillStyleFor: aSlider
	"Return the disabled fillStyle for the given slider."
	
	|c inner|
	c := aSlider paneColor alphaMixed: 0.3 with: Color white.
	inner := aSlider innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:37'!
sliderNormalFillStyleFor: aSlider
	"Return the normal fillStyle for the given slider."
	
	|c inner|
	c := aSlider paneColor alphaMixed: 0.1 with: Color white.
	inner := aSlider innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/22/2007 10:45'!
smallDebugIcon
	"Answer a small debug icon."

	^self smallWarningIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:53'!
smallErrorIcon
	"Answer a small error icon."

	^VistaryThemeIcons smallErrorIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 13:08'!
smallInfoIcon
	"Answer a small information icon."

	^VistaryThemeIcons smallInfoIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:53'!
smallLockIcon
	"Answer a small lock icon."

	^VistaryThemeIcons smallLockIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:53'!
smallQuestionIcon
	"Answer a small question icon."

	^VistaryThemeIcons smallQuestionIcon! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/21/2007 12:53'!
smallWarningIcon
	"Answer a small warning icon."

	^VistaryThemeIcons smallWarningIcon! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 1/16/2008 13:38'!
subgroupColorFrom: paneColor
	"Answer the colour for a subgroup given the pane colour."

	^paneColor! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 1/17/2008 11:29'!
tabGroupCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#square! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 1/17/2008 10:42'!
tabLabelNormalBorderStyleFor: aTabLabel
	"Answer the normal border style for a tab label."

	|pc mc ic|
	pc := aTabLabel paneColor lighter.
	mc := pc alphaMixed: 0.8 with: Color black.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 1/7/2008 14:59'!
tabLabelNormalFillStyleFor: aTabLabel
	"Return the normal fillStyle for the given tab label."
	
	|aColor c cm cd cb|
	aColor := aTabLabel paneColor lighter.
	c := aColor alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.8 with: Color black.
	cb := aColor alphaMixed: 0.8 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.5->cm. 0.51->cd. 1.0->cb})
		origin: aTabLabel bounds origin;
		direction: 0 @ aTabLabel height;
		radial: false! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 1/17/2008 10:43'!
tabLabelSelectedBorderStyleFor: aTabLabel
	"Answer the selected border style for a tab label."

	^BorderStyle simple
		width: 1;
		baseColor: (aTabLabel paneColor lighter alphaMixed: 0.8 with: Color black)! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 1/17/2008 10:43'!
tabPanelBorderStyleFor: aTabGroup
	"Answer the normal border style for a tab group."

	^TabPanelBorder new
		width: 1;
		baseColor: (aTabGroup paneColor lighter alphaMixed: 0.8 with: Color black);
		tabSelector: aTabGroup tabSelectorMorph! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 1/7/2008 14:54'!
tabSelectorCellInsetFor: aTabSelector
	"Answer the cell inset to use for the given tab selector."

	^0! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:21'!
taskbarActiveButtonColorFor: aButton
	"Answer the colour for the given active taskbar button."

	^self selectionColor! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:19'!
taskbarButtonColorFor: aButton
	"Answer the colour for the given taskbar button."

	^Color black! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:20'!
taskbarButtonLabelColorFor: aButton
	"Answer the colour for the label of the given taskbar button."

	^Color white! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 4/16/2007 12:11'!
taskbarFillStyleFor: aTaskbar
	"Return the taskbar fillStyle for the given taskbar."
	
	|aColor c cm cd cb|
	aColor := aTaskbar color.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.49->cm. 0.5->cd. 1.0->cb})
		origin: aTaskbar position;
		direction: 0@27;
		radial: false
	! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 5/9/2007 15:20'!
taskbarMinimizedButtonColorFor: aButton
	"Answer the colour for the given minimized taskbar button."

	^Color darkGray! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 3/2/2009 12:27'!
taskbarThumbnailCornerStyleFor: aMorph
	"Answer the corner style for the taskbar thumbnail/tasklist."
	
	^#square! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 2/23/2008 16:54'!
taskbarThumbnailNormalBorderStyleFor: aWindow
	"Return the normal thumbnail borderStyle for the given button."

	|pc oc mc ic|
	pc := self windowColorFor: aWindow.
	oc := (pc alphaMixed: 0.4 with: Color white) alpha: 0.4.
	mc := pc alphaMixed: 0.7 with: Color black.
	ic := Color white alpha: 0.3. 
	^(CompositeBorder new width: 2)
		borders: {RoundedBorder new
					cornerRadius: 2;
					width: 1;
					baseColor: oc.
				RoundedBorder new
					cornerRadius: 1;
					width: 1;
					baseColor: mc.
				BorderStyle simple
					width: 1;
					baseColor: ic}! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 4/20/2007 11:26'!
tasklistFillStyleFor: aTasklist
	"Return the tasklist fillStyle for the given tasklist."
	
	|aColor c cm cd cb|
	aColor := aTasklist color.
	c := aColor  alphaMixed: 0.7 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.50->cm. 0.51->cd. 1.0->cb})
		origin: aTasklist topLeft;
		direction: 0 @ aTasklist height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 10:46'!
textEditorDisabledFillStyleFor: aTextEditor
	"Return the disabled fillStyle for the given text editor."
	
	|c inner|
	c := aTextEditor paneColor alphaMixed: 0.3 with: Color white.
	inner := aTextEditor innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c darker.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 10:46'!
textEditorNormalFillStyleFor: aTextEditor
	"Return the normal fillStyle for the given text editor."
	
	|c inner|
	c := aTextEditor paneColor alphaMixed: 0.1 with: Color white.
	inner := aTextEditor innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.1-> c lighter.
			0.9->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:02'!
textFieldDisabledFillStyleFor: aTextField
	"Return the disabled fillStyle for the given text field."
	
	|c inner|
	c := aTextField paneColor alphaMixed: 0.3 with: Color white.
	inner := aTextField innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 8/7/2007 11:02'!
textFieldNormalFillStyleFor: aTextField
	"Return the normal fillStyle for the given text field."
	
	|c inner|
	c := aTextField paneColor alphaMixed: 0.1 with: Color white.
	inner := aTextField innerBounds.
	^(GradientFillStyle ramp: {
			0.0->c darker duller.
			0.15-> c darker.
			0.8->c twiceLighter.
			1.0->c darker})
		origin: inner topLeft;
		direction: 0 @ inner height;
		radial: false! !

!UIThemeVistary methodsFor: 'defaults' stamp: 'gvc 9/5/2007 15:11'!
treeLineWidth
	"Answer the width of the tree lines."

	^0! !

!UIThemeVistary methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 2/22/2008 21:17'!
useScrollbarThumbShadow
	"Answer whether a shadow morph should be displayed when
	dragging a scrollbar thumb."

	^false! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 3/26/2008 17:56'!
vThumbForm
	"Answer the form to use for vertical thumbs."

	^self forms at: #vThumb ifAbsent: [Form extent: 10@10 depth: Display depth]! !

!UIThemeVistary methodsFor: 'icons' stamp: 'gvc 5/18/2007 14:49'!
warningIcon
	"Answer a warning icon."

	^VistaryThemeIcons warningIcon! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 10/9/2007 14:50'!
windowActiveFillStyleFor: aWindow
	"Return the window active fillStyle for the given window."
	
	^aWindow paneColorToUse alpha: self windowFillStyleAlpha! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 5/22/2007 11:24'!
windowActiveLabelFillStyleFor: aWindow
	"Return the window active label fillStyle for the given window."
	
	^aWindow paneColorToUse alphaMixed: 0.3 with: Color black! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 10/9/2007 14:52'!
windowActiveTitleFillStyleFor: aWindow
	"Return the window active title fillStyle for the given window."
	
	|aColor c cm cd cb|
	aColor := aWindow paneColorToUse alpha: self windowFillStyleAlpha / 2.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.46->cm. 0.47->cd. 1.0->cb})
		origin: aWindow labelArea topLeft;
		direction: 0 @ aWindow labelHeight;
		radial: false
	! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 10/22/2008 13:39'!
windowCloseDownForm
	"Answer the form to use for window close buttons with mouse down and over."

	^self forms at: #windowCloseDown ifAbsent: [Form extent: 18@18 depth: Display depth]! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 10/22/2008 13:38'!
windowCloseOverForm
	"Answer the form to use for window close buttons with mouse over."

	^self forms at: #windowCloseOver ifAbsent: [Form extent: 18@18 depth: Display depth]! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 10/22/2008 14:46'!
windowClosePassiveForm
	"Answer the form to use for passive (background) window close buttons"

	^self forms at: #windowClosePassive ifAbsent: [Form extent: 14@14 depth: Display depth]! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 10/9/2007 15:01'!
windowFillStyleAlpha
	"Answer the alpha value for the window background."
	
	^0.6! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'AlainPlantec 12/14/2009 14:30'!
windowInactiveFillStyleFor: aWindow
	"Return the window inactive fillStyle for the given window."
	
	^self settings fadedBackgroundWindows
		ifTrue: [(aWindow paneColorToUse alpha: self windowFillStyleAlpha)
					alphaMixed: 0.9
					with: (Color white alpha: aWindow paneColorToUse alpha)]
		ifFalse: [aWindow paneColorToUse alpha: self windowFillStyleAlpha]! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 7/18/2007 14:22'!
windowInactiveLabelFillStyleFor: aWindow
	"Return the window inactive label fillStyle for the given window."
	
	^aWindow paneColorToUse alphaMixed: 0.6 with: Color black! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'AlainPlantec 11/29/2009 22:13'!
windowLabelForText: aStringOrText
	"Answer the window label to use for the given text."

	^FuzzyLabelMorph new
		contents: aStringOrText;
		font: StandardFonts windowTitleFont emphasis: 1! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 10/28/2008 15:37'!
windowMaximizeDownForm
	"Answer the form to use for window maximise buttons with mouse down."

	^self forms at: #windowMaximizeDown ifAbsent: [Form extent: 18@18 depth: Display depth]! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 10/27/2008 16:51'!
windowMaximizeOverForm
	"Answer the form to use for window maximise buttons with mouse over."

	^self forms at: #windowMaximizeOver ifAbsent: [Form extent: 18@18 depth: Display depth]! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 10/28/2008 15:37'!
windowMinimizeDownForm
	"Answer the form to use for window minimise buttons with mouse down."

	^self forms at: #windowMinimizeDown ifAbsent: [Form extent: 18@18 depth: Display depth]! !

!UIThemeVistary methodsFor: 'label-styles' stamp: 'gvc 10/27/2008 13:38'!
windowMinimizeOverForm
	"Answer the form to use for window minimise buttons with mouse over."

	^self forms at: #windowMinimizeOver ifAbsent: [Form extent: 18@18 depth: Display depth]! !

!UIThemeVistary methodsFor: 'border-styles' stamp: 'gvc 5/13/2008 15:15'!
worldMainDockingBarBorderStyleFor: aDockingBar
	"Return the world main docking bar borderStyle for the given docking bar."

	^BorderStyle simple
		width: 0;
		color: Color transparent! !

!UIThemeVistary methodsFor: 'basic-colors' stamp: 'gvc 5/13/2008 15:14'!
worldMainDockingBarColorFor: aDockingBar
	"Answer the base colour to use for a world main docking bar in this theme."

	^(Color r: 0.607 g: 0.694 b: 0.066) alpha: 0.3! !

!UIThemeVistary methodsFor: 'fill-styles' stamp: 'gvc 4/26/2007 15:31'!
worldMainDockingBarNormalFillStyleFor: aDockingBar
	"Return the world main docking bar fillStyle for the given docking bar."
	
	|aColor  c cm cd cb|
	aColor := aDockingBar originalColor.
	c := aColor  alphaMixed: 0.1 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.49->cm. 0.5->cd. 1.0->cb})
		origin: aDockingBar topLeft;
		direction: (aDockingBar isVertical
			ifTrue: [aDockingBar width @ 0]
			ifFalse: [0 @ aDockingBar height]);
		radial: false! !

UITheme subclass: #UIThemeW2K
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

UIThemeW2K class
	instanceVariableNames: 'windowColor'!

UIThemeW2K class
	instanceVariableNames: 'windowColor'!

!UIThemeW2K class methodsFor: 'testing' stamp: 'SS 1/1/2009 05:52'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^false! !

!UIThemeW2K class methodsFor: 'accessing' stamp: 'MarcusDenker 9/27/2010 15:32'!
newDefaultSettings
	"Answer a new original default settings."
	
	|grey|
	grey := Color h: 40.0 s: 0.06  v: 0.83.
	^super newDefaultSettings
		standardColorsOnly: true;
		autoSelectionColor: false;
		buttonColor: grey;
		windowColor: grey;
		scrollbarColor: grey;
		selectionColor: (Color r: 62 g: 142 b: 220 range: 255) ;
		progressBarColor: grey;
		progressBarProgressColor: (Color r: 62 g: 142 b: 220 range: 255);
		yourself! !

!UIThemeW2K class methodsFor: 'defaults' stamp: 'AlainPlantec 11/30/2009 09:37'!
setup
	
	"self setup"
	"setup the fonts/background color ala a real desktop.. this assumes these fonts exist on your system"
	
	| aStandardFont aBoldFont |	
		
	aStandardFont := LogicalFont familyName: 'Arial' pointSize: 9 stretchValue: 5 weightValue: 400 slantValue: 0.
	aBoldFont := LogicalFont familyName: 'Arial' pointSize: 9 stretchValue: 5 weightValue: 700 slantValue: 0.

	StandardFonts windowTitleFont: aBoldFont.	
	StandardFonts balloonFont: aStandardFont.
	StandardFonts buttonFont: aStandardFont.
	StandardFonts codeFont: aStandardFont.
	StandardFonts haloFont: aStandardFont.
	StandardFonts listFont: aStandardFont.
	StandardFonts menuFont: aStandardFont.
	StandardFonts defaultFont: aStandardFont.
	
	self world color: (Color r: 0.227 g: 0.431 b: 0.646).
	self beCurrent.! !

!UIThemeW2K class methodsFor: 'accessing' stamp: 'gvc 6/2/2009 11:53'!
themeName
	"Answer the friendly name of the theme."

	^'W2K'! !

!UIThemeW2K class methodsFor: 'accessing' stamp: 'SS 1/1/2009 06:56'!
windowColor
	"UIThemeWatery3 windowColor: nil."
	windowColor ifNil: [self windowColor: (Color gray: 0.5)].
	^windowColor! !

!UIThemeW2K class methodsFor: 'accessing' stamp: 'SS 1/1/2009 06:56'!
windowColor: aColor
 	"UIThemeWatery3 windowColor:nil."
	windowColor := aColor.! !

!UIThemeW2K class methodsFor: 'accessing' stamp: 'SS 1/1/2009 07:26'!
world
	
	^World! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 07:33'!
backgroundColor

	^Color h: 40.0 s: 0.06  v: 0.83! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'SS 1/1/2009 09:20'!
buttonCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#square! !

!UIThemeW2K methodsFor: 'defaults' stamp: 'gvc 6/15/2009 12:20'!
buttonLabelInsetFor: aButton
	"Answer the inset to use for a button's label."

	^(aButton showSelectionFeedback xor: aButton getModelState)
		ifTrue: [3@3 corner: 1@1]
		ifFalse: [2]! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'gvc 6/15/2009 12:12'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	| aStyle |
	aButton isDefault ifTrue: [^self buttonNormalDefaultBorderStyle].
	aStyle := BorderStyle complexRaised.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	^aStyle.! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'gvc 6/15/2009 12:15'!
buttonNormalDefaultBorderStyle
	"Answer the border style for default buttons."
	
	| aComp theBorders |
	aComp := CompositeBorder new.
	aComp width: 2.
	theBorders := OrderedCollection new.
	theBorders add: (SimpleBorder color: Color black width: 1). 
	theBorders add: (BorderStyle raised color: (Color gray: 0.80); width: 1). 
	aComp borders: theBorders.
	^aComp! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'SS 1/1/2009 10:12'!
buttonPressedBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	| aStyle |
	aStyle := BorderStyle complexInset.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	^aStyle.! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'gvc 6/15/2009 12:14'!
buttonSelectedBorderStyleFor: aButton
	"Return the selected button borderStyle for the given button."

	aButton isDefault ifTrue: [^self buttonSelectedDefaultBorderStyle].
	^self buttonPressedBorderStyleFor: aButton! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'gvc 6/15/2009 12:10'!
buttonSelectedDefaultBorderStyle
	"Answer the border style for selected default buttons."
	
	| aComp theBorders |
	aComp := CompositeBorder new.
	aComp width: 2.
	theBorders := OrderedCollection new.
	theBorders add: (SimpleBorder color: Color black width: 1). 
	theBorders add: (BorderStyle inset color: (Color gray: 0.50); width: 1). 
	aComp borders: theBorders.
	^aComp! !

!UIThemeW2K methodsFor: 'fill-styles-buttons' stamp: 'SS 1/1/2009 09:57'!
buttonSelectedFillStyleFor: aButton
	"Return the button selected fillStyle for the given color."
	
	^Color gray lighter lighter lighter lighter! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'SS 1/1/2009 11:42'!
checkboxButtonDisabledBorderStyleFor: aCheckboxButton
	"Return the disabled checkbox button borderStyle for the given button."

	^self checkboxButtonNormalBorderStyleFor: aCheckboxButton.! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'gvc 6/2/2009 16:11'!
checkboxButtonNormalBorderStyleFor: aCheckboxButton
	"Return the normal checkbox button borderStyle for the given button."

	| aStyle |
	aStyle := BorderStyle complexInset.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	aStyle baseColor: self backgroundColor.
	^aStyle! !

!UIThemeW2K methodsFor: 'label-styles' stamp: 'gvc 6/2/2009 10:49'!
configureDialogWindowLabelAreaFrameFor: aWindow
	"Configure the layout frame for the label area for the given dialog window."

	|frame|
	self configureWindowLabelAreaFrameFor: aWindow.
	aWindow labelArea ifNil: [^ self].	
	frame := aWindow labelArea layoutFrame.
	frame
		leftOffset: -1;
		rightOffset: -1! !

!UIThemeW2K methodsFor: 'border-styles' stamp: 'SS 1/1/2009 10:58'!
configureWindowBorderFor: aWindow
	"Configure the border for the given window."

	"aWindow roundedCorners: #(1 2 3 4)"
	| aStyle |
	
	
	aStyle := BorderStyle complexRaised.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	aStyle baseColor: self backgroundColor.

	aWindow borderStyle: aStyle.
	

! !

!UIThemeW2K methodsFor: 'label-styles' stamp: 'MarcusDenker 12/11/2009 07:43'!
configureWindowLabelAreaFor: aWindow
	"Configure the label area for the given window."
	
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow hasMenuBox ifTrue: [aWindow addMenuControl].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow basicLabel ifNotNil: [:label |
		label hResizing: #spaceFill.
		aWindow labelArea addMorphBack: label].
	aWindow hasCollapseBox ifTrue: [aWindow addCollapseBox].
	aWindow hasExpandBox ifTrue: [aWindow addExpandBox].
	aWindow hasCloseBox ifTrue: [	
		aWindow labelArea
			addMorphBack: (Morph new extent: 2@0).
		aWindow addCloseBox].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0)! !

!UIThemeW2K methodsFor: 'label-styles' stamp: 'gvc 6/1/2009 12:15'!
configureWindowLabelAreaFrameFor: aWindow
	"Configure the layout frame for the label area for the given window."

	| windowBorderWidth frame |
	super configureWindowLabelAreaFrameFor: aWindow.
	windowBorderWidth := aWindow class borderWidth.
	aWindow labelArea
		cellPositioning: #center;
		layoutInset: (0@2 corner: -2@1).
	frame := LayoutFrame
		fractions: (0@0 corner: 1@0)
		offsets: (0 @ (aWindow labelHeight negated + 1) corner: -2 @ windowBorderWidth negated).
	aWindow labelArea layoutFrame: frame! !

!UIThemeW2K methodsFor: 'label-styles' stamp: 'GaryChambers 8/10/2010 15:13'!
createCloseBoxFor: aSystemWindow
	"Answer a button for closing the window."
	
	^(super createCloseBoxFor: aSystemWindow)
		setBalloonText: 'Close' translated! !

!UIThemeW2K methodsFor: 'label-styles' stamp: 'tbn 7/29/2010 21:28'!
createCollapseBoxFor: aSystemWindow
	"Answer a button for closing the window."
	
	|form msb|
	form := self windowMinimizeForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb activeEnabledOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	
	form := self windowMinimizeDownForm.
	msb activeEnabledOverDownFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledOverDownFillStyle: (ImageFillStyle form: form).
	msb addUpAction: [aSystemWindow collapseBoxHit ].
	msb setBalloonText: 'Minimize' translated.
	"	extent: aSystemWindow boxExtent."
	^msb! !

!UIThemeW2K methodsFor: 'label-styles' stamp: 'tbn 7/29/2010 21:28'!
createExpandBoxFor: aSystemWindow
	"Answer a button for closing the window."
	
	|form msb|
	form := self windowMaximizeForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb activeEnabledOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	
	form := self windowMaximizeDownForm.
	msb activeEnabledOverDownFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledOverDownFillStyle: (ImageFillStyle form: form).
	msb addUpAction: [aSystemWindow expandBoxHit].
	msb setBalloonText: 'Maximize' translated.
	"	extent: aSystemWindow boxExtent."
	^msb! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 10:46'!
dialogWindowActiveFillStyleFor: aWindow
	"Return the dialog window active fillStyle for the given window."
	
	^self backgroundColor! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 10:47'!
dialogWindowInactiveFillStyleFor: aWindow
	"Return the dialog window active fillStyle for the given window."
	
	^self backgroundColor! !

!UIThemeW2K methodsFor: 'defaults' stamp: 'gvc 6/2/2009 10:19'!
dialogWindowPreferredCornerStyleFor: aDialogWindow
	"Answer the preferred corner style for the given dialog."

	^#square! !

!UIThemeW2K methodsFor: 'label-styles' stamp: 'gvc 6/15/2009 12:55'!
disabledItemStyle
	"Answer either #plain or #inset to determine how
	disabled text is drawn."

	^#inset! !

!UIThemeW2K methodsFor: 'tabs' stamp: 'GaryChambers 6/8/2011 12:32'!
drawTabGroupFinishingFor: aTabGroupMorph on: aCanvas
	"Patch up any visuals for the selected tab."
	
 	| aSTB aCover myOrigin sOrigin sExtent aContentMorph aBW| 
	
	(aTabGroupMorph selectedTab isNil or: [aTabGroupMorph selectedTab owner isNil]) ifTrue: [^self].
	aSTB := aTabGroupMorph selectedTab bounds.
	aContentMorph := aTabGroupMorph contentMorph.
	aBW := aContentMorph borderWidth.
	myOrigin := aContentMorph bounds origin.
	sOrigin := aSTB bottomLeft.
	sExtent := aSTB bottomRight.
	
	aCover := Rectangle origin: (((sOrigin x) + aBW)@ myOrigin y) corner: (sExtent x @ ((myOrigin y) + (aBW))). 

	aCanvas fillRectangle: aCover color: self backgroundColor
	
! !

!UIThemeW2K methodsFor: 'icons' stamp: 'gvc 6/1/2009 13:01'!
dropListButtonLabelFor: aDropList
	"Answer the label for the button."
	
	|aMorph|
	aMorph := AlphaImageMorph new image: (self dropListDownArrowForm).
	aMorph enabled: aDropList enabled.
	^aMorph
! !

!UIThemeW2K methodsFor: 'defaults' stamp: 'gvc 6/2/2009 16:32'!
dropListControlButtonWidth
	"Answer the width of a drop list control button for this theme."
	
	^17! !

!UIThemeW2K methodsFor: 'icons' stamp: 'gvc 6/1/2009 13:02'!
dropListDownArrowForm
	"Answer the form to use for window close buttons with mouse down and over."

	^self forms at: #dropListDownArrow ifAbsent: [Form extent: 7@7 depth: Display depth]! !

!UIThemeW2K methodsFor: 'border-styles' stamp: 'gvc 6/2/2009 12:22'!
dropListNormalBorderStyleFor: aDropList
	"Return the normal borderStyle for the given drop list"

	| aStyle |
	aStyle := BorderStyle complexInset.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	aStyle baseColor: self backgroundColor.
	^aStyle! !

!UIThemeW2K methodsFor: 'border-styles' stamp: 'gvc 6/2/2009 12:18'!
dropListNormalListBorderStyleFor: aDropList
	"Return the normal borderStyle for the given drop list"

	^BorderStyle inset
		width: 1;
		baseColor: Color black! !

!UIThemeW2K methodsFor: 'defaults' stamp: 'gvc 6/1/2009 13:28'!
expanderTitleControlButtonWidth
	"Answer the width of an expander title control button for this theme."
	
	^19! !

!UIThemeW2K methodsFor: 'icons' stamp: 'gvc 6/1/2009 12:58'!
initializeForms
	"Initialize the receiver's image forms."

	super initializeForms.
	self forms
		at: #windowCloseDown put: self newWindowCloseDownForm;
		at: #windowMinimizeDown put: self newWindowMinimizeDownForm;
		at: #windowMaximizeDown put: self newWindowMaximizeDownForm;
		at: #dropListDownArrow put: self newDropListDownArrowForm! !

!UIThemeW2K methodsFor: 'initialize-release' stamp: 'gvc 6/1/2009 11:58'!
initializeLabelAreaFor: aWindow
	
	| windowBorderWidth frame |
	super initializeLabelAreaFor: aWindow.
	windowBorderWidth := aWindow class borderWidth.
	aWindow labelArea
		layoutInset: (0@windowBorderWidth corner: 1@1).
	frame := LayoutFrame
		fractions: (0@0 corner: 1@0)
		offsets: (0 @ (aWindow labelHeight negated + 1) corner: -2 @ windowBorderWidth negated).
	aWindow labelArea layoutFrame: frame! !

!UIThemeW2K methodsFor: 'border-styles' stamp: 'gvc 6/1/2009 15:19'!
listFocusBoundsFor: aListMorph
	"Answer the bounds for drawing the focus indication."

	^aListMorph innerBounds! !

!UIThemeW2K methodsFor: 'border-styles' stamp: 'gvc 6/2/2009 13:22'!
listNormalBorderStyleFor: aList
	"Return the normal borderStyle for the given list"

	| aStyle |
	aStyle := BorderStyle complexInset.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	aStyle baseColor: self backgroundColor.
	^aStyle! !

!UIThemeW2K methodsFor: 'menus' stamp: 'SW 5/22/2009 13:25'!
menuColor
	"Answer the menu color to use."

	^self backgroundColor! !

!UIThemeW2K methodsFor: 'menus' stamp: 'SW 5/22/2009 13:25'!
menuColorFor: aThemedMorph
	"Answer the menu color to use."

	|w|
	^self backgroundColor! !

!UIThemeW2K methodsFor: 'fill-styles-buttons' stamp: 'gvc 6/15/2009 12:50'!
menuItemSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item."
	
	^Color h: 224 s: 0.91 v: 0.42! !

!UIThemeW2K methodsFor: 'menus' stamp: 'SW 5/22/2009 14:09'!
menuTitleColor
	"Answer the menu title color to use."

	^Color h: 0 s: 0 v: 0.65.! !

!UIThemeW2K methodsFor: 'menus' stamp: 'SW 5/22/2009 14:07'!
menuTitleColorFor: aThemedMorph
	"Answer the menu titlecolor to use."
	^self menuTitleColor! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'GaryChambers 8/10/2010 16:33'!
newCloseControlIn: aThemedMorph for: aModel action: aValuable help: helpText
	"Answer a button for closing things."
	
	|form msb|
	form := self windowCloseForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb activeEnabledOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	
	form := self windowCloseDownForm.
	msb
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: aValuable;
		setBalloonText: helpText.
	^msb! !

!UIThemeW2K methodsFor: 'icons' stamp: 'gvc 6/8/2009 15:31'!
newDropListDownArrowForm
	"Answer a new black down arrow."
	
	^self scrollbarArrowOfDirection: #bottom size: 15 color: Color black! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'SS 1/1/2009 12:10'!
newDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a drop list for the given model."

	^(DropListMorph
			on: aModel
			list: listSel
			selected: getSel
			changeSelected: setSel
			useIndex: useIndex)
		selectionColor: self selectionColor;
		getEnabledSelector: enabledSel;
		font: self dropListFont;
		cornerStyle: #square;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

!UIThemeW2K methodsFor: 'groupbox' stamp: 'SS 1/1/2009 13:25'!
newGroupboxIn: aThemedMorph
	"Answer a plain groupbox."

	^PlainGroupboxMorph new
		cornerStyle: #square;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself! !

!UIThemeW2K methodsFor: 'groupbox' stamp: 'gvc 6/2/2009 11:52'!
newGroupboxIn: aThemedMorph label: aString
	"Answer a groupbox with the given label."
	
	|aMorph |
	
	aMorph := W2KGroupboxMorph new
		font: self labelFont;
		cornerStyle: #square;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		label: aString;
		yourself.
			
	aMorph borderStyle: W2KGroupBorder new.
	^aMorph! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'gvc 6/15/2009 12:53'!
newLabelIn: aThemedMorph for: aModel label: aString getEnabled: enabledSel
	"Answer a new text label."

	^(super newLabelIn: aThemedMorph for: aModel label: aString getEnabled: enabledSel)
		disabledStyle: #inset! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'SS 1/1/2009 11:54'!
newListIn: aThemedMorph for: aModel list: listSelector selected: getSelector changeSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a list for the given model."

	^PluggableListMorph new
		selectionColor: self selectionColor;
		font: self listFont;
		on: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		menu: nil
		keystroke: nil;
		autoDeselect: false;
		cornerStyle: #square;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1; baseColor: Color black);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		getEnabledSelector: enabledSel;
		setBalloonText: helpText! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'gvc 6/1/2009 13:22'!
newMorphDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a morph drop list for the given model."

	^(super newMorphDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText)
		useSquareCorners! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'SS 1/1/2009 11:54'!
newMorphListIn: aThemedMorph for: aModel list: listSelector getSelected: getSelector setSelected: setSelector getEnabled: enabledSel help: helpText
	"Answer a morph list for the given model."

	^(PluggableMorphListMorph
			on: aModel
			list: listSelector
			selected: getSelector
			changeSelected: setSelector
			menu: nil
			keystroke: nil)
		selectionColor: self selectionColor;
		autoDeselect: false;
		cornerStyle: #square;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1; baseColor: Color black);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		getEnabledSelector: enabledSel;
		setBalloonText: helpText
		! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'SS 1/1/2009 12:41'!
newPanelIn: aThemedMorph
	"Answer a new panel."

	^PanelMorph new
		changeTableLayout;
		layoutInset: 4;
		cellInset: 8;
		cornerStyle: #square;
		yourself! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'SS 1/1/2009 10:41'!
newPluggableDialogWindowIn: aThemedMorph title: title for: contentMorph
	"Answer a new pluggable dialog panel with the given content."

	|answer|
	answer := PluggableDialogWindow new
		setWindowColor: self backgroundColor;
		title: title;
		contentMorph: contentMorph.
	contentMorph ifNotNil: [answer model: nil].
	answer color: self backgroundColor.
	^answer! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'AlainPlantec 2/21/2011 18:59'!
newTextEditorIn: aThemedMorph for: aModel getText: getSel setText: setSel getEnabled: enabledSel 
	"Answer a text editor for the given model."

	^PluggableTextMorph new
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: #square;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white! !

!UIThemeW2K methodsFor: 'morph creation' stamp: 'SS 1/1/2009 11:53'!
newTreeIn: aThemedMorph for: aModel list: listSelector selected: getSelector changeSelected: setSelector
	"Answer a new tree morph."
	
	^TreeListMorph new
		selectionColor: self selectionColor;
		font: self listFont;
		on: aModel
		list: listSelector
		selected: getSelector
		changeSelected: setSelector
		menu: nil
		keystroke: nil;
		cornerStyle: #square;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1; baseColor: Color black);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		autoDeselect: false;
		yourself! !

!UIThemeW2K methodsFor: 'icons' stamp: 'SS 1/1/2009 11:21'!
newWindowCloseDownForm

	^((ColorForm
	extent: 16@14
	depth: 8
	fromArray: #( 16843009 16843009 16843009 16843012 16908802 33686018 33686018 33686276 16909059 50529027 50529027 50529028 16909059 50529027 50529027 50529028 16909059 50331651 50529024 197380 16909059 50528256 50528256 50529028 16909059 50529024 3 50529028 16909059 50529027 771 50529028 16909059 50529024 3 50529028 16909059 50528256 50528256 50529028 16909059 50331651 50529024 197380 16909059 50529027 50529027 50529028 16974595 50529027 50529027 50529028 67372036 67372036 67372036 67372036)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(0.25 0.25 0.25) #(0.501 0.501 0.501) #(0.831 0.815 0.784) #(1.0 1.0 1.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!UIThemeW2K methodsFor: 'icons' stamp: 'SS 1/1/2009 10:57'!
newWindowCloseForm
	^((ColorForm
	extent: 16@14
	depth: 8
	fromArray: #( 67372036 67372036 67372036 67372033 67306243 50529027 50529027 50528769 67306243 50529027 50529027 50528769 67306243 771 50528256 50528769 67306243 50331651 50331651 50528769 67306243 50528256 771 50528769 67306243 50529024 197379 50528769 67306243 50528256 771 50528769 67306243 50331651 50331651 50528769 67306243 771 50528256 50528769 67306243 50529027 50529027 50528769 67306243 50529027 50529027 50528769 67240450 33686018 33686018 33686017 16843009 16843009 16843009 16843009)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(0.25 0.25 0.25) #(0.501 0.501 0.501) #(0.831 0.815 0.784) #(1.0 1.0 1.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!UIThemeW2K methodsFor: 'icons' stamp: 'SS 1/1/2009 11:49'!
newWindowMaximizeDownForm

	^((ColorForm
	extent: 16@14
	depth: 8
	fromArray: #( 16843009 16843009 16843009 16843012 16908802 33686018 33686018 33686276 16909059 50529027 50529027 50529028 16909059 0 0 197380 16909059 0 0 197380 16909059 197379 50529027 197380 16909059 197379 50529027 197380 16909059 197379 50529027 197380 16909059 197379 50529027 197380 16909059 197379 50529027 197380 16909059 197379 50529027 197380 16909059 0 0 197380 16974595 50529027 50529027 50529028 67372036 67372036 67372036 67372036)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(0.25 0.25 0.25) #(0.501 0.501 0.501) #(0.831 0.815 0.784) #(1.0 1.0 1.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!UIThemeW2K methodsFor: 'icons' stamp: 'SS 1/1/2009 12:17'!
newWindowMaximizeForm

	^((ColorForm
	extent: 16@14
	depth: 8
	fromArray: #( 67372036 67372036 67372036 67372033 67306243 50529027 50529027 50528769 67306240 0 0 50528769 67306240 0 0 50528769 67306240 50529027 50529024 50528769 67306240 50529027 50529024 50528769 67306240 50529027 50529024 50528769 67306240 50529027 50529024 50528769 67306240 50529027 50529024 50528769 67306240 50529027 50529024 50528769 67306240 0 0 50528769 67306243 50529027 50529027 50528769 67240450 33686018 33686018 33686017 16843009 16843009 16843009 16843009)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(0.25 0.25 0.25) #(0.501 0.501 0.501) #(0.831 0.815 0.784) #(1.0 1.0 1.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!UIThemeW2K methodsFor: 'icons' stamp: 'SS 1/1/2009 12:09'!
newWindowMinimizeDownForm

	^((ColorForm
	extent: 16@14
	depth: 8
	fromArray: #( 16843009 16843009 16843009 16843012 16908802 33686018 33686018 33686276 16909059 50529027 50529027 50529028 16909059 50529027 50529027 50529028 16909059 50529027 50529027 50529028 16909059 50529027 50529027 50529028 16909059 50529027 50529027 50529028 16909059 50529027 50529027 50529028 16909059 50529027 50529027 50529028 16909059 50529027 50529027 50529028 16909059 50331648 3 50529028 16909059 50331648 3 50529028 16974595 50529027 50529027 50529028 67372036 67372036 67372036 67372036)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(0.25 0.25 0.25) #(0.501 0.501 0.501) #(0.831 0.815 0.784) #(1.0 1.0 1.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!UIThemeW2K methodsFor: 'icons' stamp: 'SS 1/1/2009 12:13'!
newWindowMinimizeForm

	^((ColorForm
	extent: 16@14
	depth: 8
	fromArray: #( 67372036 67372036 67372036 67372033 67306243 50529027 50529027 50528769 67306243 50529027 50529027 50528769 67306243 50529027 50529027 50528769 67306243 50529027 50529027 50528769 67306243 50529027 50529027 50528769 67306243 50529027 50529027 50528769 67306243 50529027 50529027 50528769 67306243 50529027 50529027 50528769 67306243 0 771 50528769 67306243 0 771 50528769 67306243 50529027 50529027 50528769 67240450 33686018 33686018 33686017 16843009 16843009 16843009 16843009)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(0.25 0.25 0.25) #(0.501 0.501 0.501) #(0.831 0.815 0.784) #(1.0 1.0 1.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 11:44'!
paneColor
	^self backgroundColor! !

!UIThemeW2K methodsFor: 'fill-styles' stamp: 'GaryChambers 2/15/2011 12:54'!
paneColorFor: aWindow
	"Answer the pane color that should be used."
	
	^self windowColorFor: aWindow! !

!UIThemeW2K methodsFor: 'groupbox' stamp: 'gvc 6/2/2009 11:51'!
plainGroupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a plain group panel."

	^W2KGroupBorder new! !

!UIThemeW2K methodsFor: 'progressbar' stamp: 'SW 5/22/2009 13:20'!
progressBarBorderStyleFor: aProgressBar
	"Return the progress bar borderStyle for the given progress bar."

	| aStyle |
	aStyle := BorderStyle complexInset.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	^aStyle.! !

!UIThemeW2K methodsFor: 'progressbar' stamp: 'SW 5/22/2009 13:20'!
progressBarColorFor: aProgressBar
	"Answer the colour for the given progress bar."

	^self backgroundColor! !

!UIThemeW2K methodsFor: 'progressbar' stamp: 'SW 5/22/2009 13:23'!
progressBarFillStyleFor: aProgressBar
	"Return the progress bar fillStyle for the given progress bar."
	
	^self backgroundColor! !

!UIThemeW2K methodsFor: 'progressbar' stamp: 'SW 5/22/2009 13:49'!
progressBarProgressColorFor: aProgressBar
	"Answer the colour for the progress part of the given progress bar."

	^Color r: 0.227 g: 0.431 b: 0.646! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'gvc 6/2/2009 16:15'!
radioButtonDisabledBorderStyleFor: aRadioButton
	"Return the disabled radio button borderStyle for the given button."

	^self radioButtonNormalBorderStyleFor: aRadioButton! !

!UIThemeW2K methodsFor: 'border-styles-buttons' stamp: 'SS 1/1/2009 11:51'!
radioButtonNormalBorderStyleFor: aRadioButton
	"Return the disabled radio button borderStyle for the given button."

	^BorderStyle simple
		width: 1;
		baseColor: Color black! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 16:01'!
resizerGripNormalFillStyleFor: aResizer
	"Return the normal fillStyle for the given resizer.
	For the moment, answer a transparent colour for no drawing,
	non transparent to draw as normal."
	
	^Color transparent! !

!UIThemeW2K methodsFor: 'scrollbars' stamp: 'AlainPlantec 12/17/2009 13:47'!
scrollBarButtonArrowVertices: aRectangle 
	^ self verticesForSimpleArrow: aRectangle! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 16:29'!
scrollbarColorFor: aScrollbar
	"Answer the colour for the given scrollbar."

	^self backgroundColor.! !

!UIThemeW2K methodsFor: 'scrollbars' stamp: 'SS 1/1/2009 12:01'!
scrollbarMinimumThumbThickness
	"Answer the minumum width or height of a scrollbar thumb 
	as appropriate to its orientation."
	
	^8! !

!UIThemeW2K methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/15/2009 11:51'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	|aColor|
	aColor := self scrollbarColorFor: aScrollbar.
	^aColor alphaMixed: 0.4 with: Color white! !

!UIThemeW2K methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/15/2009 12:13'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal button borderStyle for the given scrollbar."
	
	| aStyle |
	aStyle := BorderStyle complexRaised.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	^aStyle! !

!UIThemeW2K methodsFor: 'border-styles-scrollbars' stamp: 'gvc 6/15/2009 12:13'!
scrollbarPressedButtonBorderStyleFor: aScrollbar
	"Return the pressed button borderStyle for the given scrollbar."

	| aStyle |
	aStyle := BorderStyle complexInset.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	^aStyle! !

!UIThemeW2K methodsFor: 'scrollbars' stamp: 'SS 1/1/2009 11:58'!
scrollbarThickness

	^16! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 11:48'!
selectionColor
	"Answer the window color to use."

	^self backgroundColor! !

!UIThemeW2K methodsFor: 'progressbar' stamp: 'AlainPlantec 12/20/2009 00:26'!
setSystemProgressMorphDefaultParameters: aProgressMorph

	aProgressMorph color: self backgroundColor.
	aProgressMorph borderWidth: self settings menuBorderWidth.
	aProgressMorph borderStyle: BorderStyle thinGray.
	aProgressMorph
			addDropShadow;
			shadowColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.666);
			shadowOffset: 1 @ 1! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 13:14'!
subgroupColorFrom: paneColor
	"Answer the colour for a subgroup given the pane colour."

	^paneColor! !

!UIThemeW2K methodsFor: 'tabs' stamp: 'SW 5/22/2009 20:34'!
tabGroupCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#square! !

!UIThemeW2K methodsFor: 'tabs' stamp: 'gvc 6/2/2009 11:51'!
tabLabelNormalBorderStyleFor: aTabLabel
	"Answer the normal border style for a tab label."

	| aStyle |
	aStyle := W2KComplexTabBorder new.
	aStyle width: 1.
	aStyle color: self backgroundColor.
	^aStyle.! !

!UIThemeW2K methodsFor: 'tabs' stamp: 'SW 5/22/2009 20:43'!
tabLabelNormalFillStyleFor: aTabLabel
	"Return the normal fillStyle for the given tab label."
	
	^self tabLabelSelectedFillStyleFor: aTabLabel! !

!UIThemeW2K methodsFor: 'tabs' stamp: 'gvc 6/2/2009 11:51'!
tabLabelSelectedBorderStyleFor: aTabLabel 
	"Answer the normal border style for a tab panel."

	| aStyle |
	aStyle := W2KComplexTabBorder new.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	^aStyle.! !

!UIThemeW2K methodsFor: 'tabs' stamp: 'SW 5/22/2009 20:42'!
tabLabelSelectedFillStyleFor: aTabLabel
	"Return the selected fillStyle for the given tab label."
	
	^self backgroundColor! !

!UIThemeW2K methodsFor: 'tabs' stamp: 'SW 5/22/2009 20:39'!
tabPanelBorderStyleFor: aTabPanel
	"Answer the normal border style for a tab panel."

	| aStyle |
	aStyle := BorderStyle complexRaised.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	^aStyle.! !

!UIThemeW2K methodsFor: 'tabs' stamp: 'SW 5/23/2009 17:16'!
tabSelectorCellInsetFor: aTabSelector
	"Answer the cell inset to use for the given tab selector."

	^0@0! !

!UIThemeW2K methodsFor: 'tabs' stamp: 'GaryChambers 6/7/2011 14:58'!
tabSelectorMorphMinExtentFor: aTabSelectorMorph
	"Answer the min extent of the given tab selector."

	^aTabSelectorMorph basicMinExtent! !

!UIThemeW2K methodsFor: 'fill-styles' stamp: 'gvc 6/2/2009 16:03'!
tasklistFillStyleFor: aTasklist
	"Return the tasklist fillStyle for the given tasklist."
	
	^Color r: 0.478 g: 0.611 b: 0.796! !

!UIThemeW2K methodsFor: 'border-styles' stamp: 'SS 1/1/2009 11:14'!
textEditorNormalBorderStyleFor: aTextEditor
	"Return the normal text editor borderStyle for the given text editor."

	| aStyle |
	aStyle := BorderStyle complexInset.
	aStyle width: 2.
	aStyle color: self backgroundColor.
	aStyle baseColor: self backgroundColor.
	^aStyle! !

!UIThemeW2K methodsFor: 'border-styles' stamp: 'SS 1/1/2009 11:58'!
textEntryCornerStyleIn: aThemedMorph
	"Answer the corner style to use for text entry morphs."
	
	^#square! !

!UIThemeW2K methodsFor: 'border-styles' stamp: 'gvc 6/2/2009 12:16'!
textFocusBoundsFor: aPluggableTextMorph
	"Answer the bounds for drawing the focus indication."

	^aPluggableTextMorph innerBounds! !

!UIThemeW2K methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 6/15/2009 11:52'!
useScrollbarThumbShadow
	"Answer whether a shadow morph should be displayed when
	dragging a scrollbar thumb."

	^false! !

!UIThemeW2K methodsFor: 'fill-styles' stamp: 'SS 1/1/2009 12:04'!
windowActiveFillStyleFor: aWindow
	"Return the window inactive fillStyle for the given window."
	
	^self windowColorFor: aWindow! !

!UIThemeW2K methodsFor: 'fill-styles' stamp: 'gvc 6/15/2009 13:05'!
windowActiveLabelFillStyleFor: aWindow
	"Return the window active label fillStyle for the given window."
	
	^Color white! !

!UIThemeW2K methodsFor: 'fill-styles' stamp: 'SS 1/1/2009 11:31'!
windowActiveTitleFillStyleFor: aWindow
	"Return the window active title fillStyle for the given window."

	|aColor aLColor |
	aColor := Color h: 224 s: 0.91 v: 0.42.
	aLColor := Color h: 211 s: 0.31 v: 0.94.
	^(GradientFillStyle ramp: {0.0 -> aColor. 1.0 -> aLColor })
		origin: aWindow topLeft;
		direction: aWindow width @ 0;
		radial: false
! !

!UIThemeW2K methodsFor: 'icons' stamp: 'SS 1/1/2009 11:16'!
windowCloseDownForm
	"Answer the form to use for window close buttons with mouse down and over."

	^self forms at: #windowCloseDown ifAbsent: [Form extent: 18@18 depth: Display depth]! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 11:47'!
windowColor
	"Answer the window color to use."

	^self backgroundColor! !

!UIThemeW2K methodsFor: 'basic-colors' stamp: 'SS 1/1/2009 09:59'!
windowColorFor: aWindowOrModel
	"Answer the colour for the given window."

	"^self class windowColor."
	^self backgroundColor! !

!UIThemeW2K methodsFor: 'fill-styles' stamp: 'gvc 6/2/2009 16:07'!
windowExtentChangedFor: aWindow
	"Update any extent related visuals."

	aWindow setStripeColorsFrom: aWindow paneColor! !

!UIThemeW2K methodsFor: 'fill-styles' stamp: 'SS 1/1/2009 12:04'!
windowInactiveFillStyleFor: aWindow
	"Return the window inactive fillStyle for the given window."
	
	^self windowActiveFillStyleFor: aWindow! !

!UIThemeW2K methodsFor: 'fill-styles' stamp: 'gvc 6/15/2009 13:06'!
windowInactiveLabelFillStyleFor: aWindow
	"Return the window inactive label fillStyle for the given window."
	
	^Color gray: 0.8! !

!UIThemeW2K methodsFor: 'fill-styles' stamp: 'SS 1/1/2009 11:31'!
windowInactiveTitleFillStyleFor: aWindow
	"Return the window inactive title fillStyle for the given window."
	
	|aColor aLColor |
	
	aColor := Color gray.
	aLColor := Color h: 0 s: 0 v: 0.75.
	^(GradientFillStyle ramp: {0.0 -> aColor. 1.0 -> aLColor })
		origin: aWindow topLeft;
		direction: aWindow width @ 0;
		radial: false
! !

!UIThemeW2K methodsFor: 'icons' stamp: 'SS 1/1/2009 11:53'!
windowMaximizeDownForm
	"Answer the form to use for window close buttons with mouse down and over."

	^self forms at: #windowMaximizeDown ifAbsent: [Form extent: 18@18 depth: Display depth]! !

!UIThemeW2K methodsFor: 'icons' stamp: 'SS 1/1/2009 11:53'!
windowMinimizeDownForm
	"Answer the form to use for window close buttons with mouse down and over."

	^self forms at: #windowMinimizeDown ifAbsent: [Form extent: 18@18 depth: Display depth]! !

!UIThemeW2K methodsFor: 'defaults' stamp: 'gvc 6/2/2009 10:19'!
windowPreferredCornerStyleFor: aWindow
	"Answer the preferred corner style for the given window."

	^#square! !

!UIThemeW2K methodsFor: 'border-styles' stamp: 'SS 1/1/2009 11:45'!
windowShadowColor
	"Answer the window shadow color to use."

	^Color transparent.! !

UITheme subclass: #UIThemeWatery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!UIThemeWatery commentStamp: 'gvc 11/5/2007 14:54' prior: 0!
An OSX-style UI theme. Do UIThemeWatery beCurrent to use.!

!UIThemeWatery class methodsFor: 'testing' stamp: 'gvc 10/24/2007 11:31'!
isAbstract
	"Answer whether the receiver is considered to be abstract."

	^false! !

!UIThemeWatery class methodsFor: 'accessing' stamp: 'MarcusDenker 9/27/2010 15:32'!
newDefaultSettings
	"Answer a new original default settings."
	"self defaultSettings: nil"
	^super newDefaultSettings
		standardColorsOnly: true;
		autoSelectionColor: false;
		buttonColor: (Color r: 232 g: 232 b: 232 range: 255);
		windowColor: (Color r: 232 g: 232 b: 232 range: 255);
		scrollbarColor: (Color r: 62 g: 142 b: 220 range: 255) ;
		selectionColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.8 alpha: 0.2) ;
		menuSelectionColor: (Color r: 51 g: 76 b: 230 range: 255) ;
		progressBarColor: (Color r: 232 g: 232 b: 232 range: 255);
		progressBarProgressColor: (Color r: 62 g: 142 b: 220 range: 255);
		yourself! !

!UIThemeWatery class methodsFor: 'accessing' stamp: 'gvc 10/24/2007 11:46'!
themeName
	"Answer the friendly name of the theme."

	^'Watery'! !

!UIThemeWatery methodsFor: 'border-styles-buttons' stamp: 'MarcusDenker 12/11/2009 09:36'!
buttonCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^aThemedMorph
		ifNil: [#rounded]
		ifNotNil: [:tm | 
			tm preferredButtonCornerStyle
				ifNil: [#rounded]
				ifNotNil: [:bcs | bcs]]! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 1/23/2009 13:00'!
buttonFocusBoundsFor: aButton
	"Answer the bounds for drawing the focus indication for the
	given button."

	^aButton bounds! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'gvc 11/13/2007 13:17'!
buttonLabelForText: aTextOrString
	"Answer the label to use for the given text."
	
	^aTextOrString isString
		ifTrue: [(FuzzyLabelMorph contents: aTextOrString)
					alpha: 0.3]
		ifFalse: [super buttonLabelForText: aTextOrString]! !

!UIThemeWatery methodsFor: 'border-styles-buttons' stamp: 'gvc 10/24/2007 13:34'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	|c|
	c := aButton colorToUse darker.
	aButton isDefault
		ifTrue: [c := c alphaMixed: 0.5 with: Color black].
	^BorderStyle simple
		width: 1;
		baseColor: c! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 10/9/2008 17:44'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	|aColor|
	aColor := aButton colorToUse.
	aColor = aButton paneColor ifTrue: [aColor := self buttonColorFor: aButton].
	^(GradientFillStyle ramp: {
			0.0->Color white.
			0.3->Color white.
			0.4->aColor.
			0.6->Color white.
			1.0->Color white})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 11/12/2007 15:39'!
buttonPanelNormalFillStyleFor: aPanel
	"Return the normal panel fillStyle for the given panel."
	
	^(BitmapFillStyle fromForm: self stripesForm)
		origin: aPanel topLeft! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 10/28/2007 16:41'!
buttonPressedFillStyleFor: aButton
	"Return the button pressed fillStyle for the given button."
		
	^self buttonSelectedFillStyleFor: aButton! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 10/28/2007 16:38'!
buttonSelectedFillStyleFor: aButton
	"Return the button selected fillStyle for the given button."
	
	|c|
	c := (aButton onColor isNil or: [aButton onColor isTransparent])
		ifTrue: [self settings scrollbarColor]
		ifFalse: [aButton colorToUse].
	^(GradientFillStyle ramp: {
			0.0->c twiceLighter.
			0.3->c twiceLighter.
			0.4->c darker.
			0.7->c twiceLighter.
			1.0->Color white})
		origin: aButton topLeft;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 1/12/2009 13:20'!
buttonSelectedPressedFillStyleFor: aButton
	"Return the button selected pressed fillStyle for the given color."

	^self buttonNormalFillStyleFor: aButton! !

!UIThemeWatery methodsFor: 'border-styles-buttons' stamp: 'gvc 2/29/2008 22:06'!
checkboxButtonNormalBorderStyleFor: aCheckboxButton
	"Return the normal checkbox button borderStyle for the given button."

	|c|
	c := Color white twiceDarker alphaMixed: 0.7 with: Color black.
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: (Color black alpha: 0.1).
				BorderStyle simple
					width: 1;
					baseColor: c}! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 2/29/2008 21:57'!
checkboxButtonNormalFillStyleFor: aCheckboxButton
	"Return the normal checkbox button fillStyle for the given button."
	
	|c ib|
	c := Color white twiceDarker.
	ib := aCheckboxButton innerBounds.
	^(GradientFillStyle ramp: {
			0.0->(c alphaMixed: 0.4 with: Color white).
			0.3->(c alphaMixed: 0.4 with: Color white).
			0.4->c.
			1.0->Color white})
		origin: aCheckboxButton innerBounds origin;
		direction: 0@ib height;
		radial: false! !

!UIThemeWatery methodsFor: 'border-styles-buttons' stamp: 'gvc 2/29/2008 22:06'!
checkboxButtonSelectedBorderStyleFor: aCheckboxButton
	"Return the normal checkbox button borderStyle for the given button."

	|c|
	c := self settings scrollbarColor alphaMixed: 0.7 with: Color black.
	^(CompositeBorder new width: 1)
		borders: {BorderStyle simple
					width: 1;
					baseColor: (Color black alpha: 0.1).
				BorderStyle simple
					width: 1;
					baseColor: c}! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 2/29/2008 21:54'!
checkboxButtonSelectedFillStyleFor: aCheckboxButton
	"Return the selected checkbox button fillStyle for the given button."
	
	|c ib|
	c := self settings scrollbarColor.
	ib := aCheckboxButton innerBounds.
	^(GradientFillStyle ramp: {
			0.0->(c alphaMixed: 0.4 with: Color white).
			0.3->(c alphaMixed: 0.4 with: Color white).
			0.4->c.
			1.0->Color white})
		origin: aCheckboxButton innerBounds origin;
		direction: 0@ib height;
		radial: false! !

!UIThemeWatery methodsFor: 'border-styles' stamp: 'gvc 6/2/2009 11:31'!
configureWindowBorderFor: aWindow
	"Configure the border for the given window."

	super configureWindowBorderFor: aWindow.
	aWindow roundedCorners: #(1 4) "just top"! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'MarcusDenker 12/11/2009 07:43'!
configureWindowLabelAreaFor: aWindow
	"Configure the label area for the given window."

	|padding|
	padding := 0.
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0).
	aWindow hasCloseBox ifTrue: [aWindow addCloseBox. padding := padding + 1].
	aWindow hasCollapseBox ifTrue: [aWindow addCollapseBox. padding := padding + 1].
	aWindow hasExpandBox ifTrue: [aWindow addExpandBox. padding := padding + 1].
	aWindow hasMenuBox ifTrue: [padding := padding - 1].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0; hResizing: #spaceFill).
	aWindow basicLabel ifNotNil: [:label | aWindow labelArea addMorphBack: label; hResizing: #shrinkWrap].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0; hResizing: #spaceFill).
	padding > 0 ifTrue: [
		aWindow labelArea
			addMorphBack: (Morph new extent: (aWindow boxExtent x * padding) @ 0)].
	aWindow hasMenuBox ifTrue: [aWindow addMenuControl].
	aWindow labelArea
		addMorphBack: (Morph new extent: aWindow class borderWidth @ 0)! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 11/13/2007 11:55'!
controlButtonMouseOverFillStyleFor: aButton
	"Return the mouse over control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self controlButtonNormalFillStyleFor: aButton! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 10/28/2007 16:53'!
controlButtonNormalFillStyleFor: aButton
	"Return the control button normal fillStyle for the given button."
	
	|c|
	c := (aButton onColor isNil or: [aButton onColor isTransparent])
		ifTrue: [self settings scrollbarColor]
		ifFalse: [aButton colorToUse].
	^(GradientFillStyle ramp: {
			0.0->c twiceLighter.
			0.3->c twiceLighter.
			0.4->c darker.
			0.7->c twiceLighter.
			1.0->Color white})
		origin: aButton topLeft;
		direction: 0 @ aButton height;
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'gvc 11/13/2007 12:00'!
controlButtonPressedFillStyleFor: aButton
	"Return the pressed button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonNormalFillStyleFor: aButton! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'tbn 7/29/2010 21:28'!
createCollapseBoxFor: aSystemWindow
	"Answer a button for minimising the window."
	
	|form msb|
	form := self windowMinimizeForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMinimizePassiveForm.
	msb extent: form extent.
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMinimizeOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMinimizePassiveForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: [aSystemWindow collapseBoxHit];
		setBalloonText: 'Collapse this window' translated;
		extent: aSystemWindow boxExtent.
	^msb! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'tbn 7/29/2010 21:28'!
createExpandBoxFor: aSystemWindow
	"Answer a button for maximising/restoring the window."
	
	|form msb|
	form := self windowMaximizeForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMaximizePassiveForm.
	msb extent: form extent.
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMaximizeOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMaximizePassiveForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: [aSystemWindow expandBoxHit];
		setBalloonText: 'Expand to full screen' translated;
		extent: aSystemWindow boxExtent.
	^msb! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'GaryChambers 2/15/2011 15:51'!
createMenuBoxFor: aSystemWindow
	"Answer a button for the window menu."
	
	|form msb|
	form := self windowMenuForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMenuPassiveForm.
	msb extent: form extent.
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMenuOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMenuPassiveForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: [aSystemWindow offerWindowMenu];
		setBalloonText: 'Window menu' translated;
		extent: form extent.
	^msb! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 11/13/2007 12:05'!
dialogWindowActiveFillStyleFor: aWindow
	"Return the dialog window active fillStyle for the given window."
	
	^(BitmapFillStyle fromForm: self stripesForm)
		origin: aWindow topLeft! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 11/13/2007 12:06'!
dialogWindowInactiveFillStyleFor: aWindow
	"Return the dialog window inactive fillStyle for the given window."
	
	^self dialogWindowActiveFillStyleFor: aWindow! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 10/25/2007 17:51'!
dockingBarNormalFillStyleFor: aToolDockingBar
	"Return the normal docking bar fillStyle for the given bar."
		
	^(BitmapFillStyle fromForm: self stripesForm)
		origin: aToolDockingBar topLeft! !

!UIThemeWatery methodsFor: 'border-styles' stamp: 'gvc 9/1/2009 15:37'!
drawTextAdornmentFor: aPluggableTextMorph color: aColor on: aCanvas
	"Indicate edit status for the given morph."
	
	|bounds size fillStyle|
	bounds := aPluggableTextMorph innerBounds.
	size := 25.
	fillStyle := (GradientFillStyle ramp: {
			0.0->(Color white alpha: 0.01).
			0.8->aColor.
			1.0->aColor})
		origin: bounds topRight - (size@0);
		direction: (size @ size negated) // 4;
		radial: false.
	aCanvas
		drawPolygon:  {bounds topRight. bounds topRight + (0@size). bounds topRight - (size@0)}
		fillStyle: fillStyle! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'GaryChambers 8/18/2010 18:01'!
dropListFocusBoundsFor: aDropList
	"Answer the bounds for drawing the focus indication for the
	given drop list."

	^aDropList bounds! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 1/13/2009 13:57'!
dropListNormalFillStyleFor: aDropList
	"Return the normal fillStyle for the given drop list."
	
	|c|
	c := self windowColor.
	^(GradientFillStyle ramp: {
			0.0->c twiceDarker.
			0.05-> c lighter.
			0.15-> Color white.
			1.0->Color white})
		origin: aDropList topLeft;
		direction: 0 @ aDropList height;
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 1/23/2009 12:31'!
expanderTitleNormalFillStyleFor: anExpanderTitle
	"Return the normal expander title fillStyle for the given expander title."
	
	|aColor|
	aColor := anExpanderTitle paneColor.
	^(GradientFillStyle ramp: {
			0.0->Color white.
			0.05-> aColor lighter.
			1.0->aColor darker})
		origin: anExpanderTitle topLeft;
		direction: 0 @ anExpanderTitle height;
		radial: false! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'GaryChambers 2/15/2011 15:22'!
initializeForms
	"Initialize the receiver's image forms."

	|inactiveForm|
	super initializeForms.
	inactiveForm := self newWindowInactiveControlForm.
	self forms
		at: #stripes put: self newStripesForm;
		at: #windowCloseOver put: self newWindowCloseOverForm;
		at: #windowMinimizeOver put: self newWindowMinimizeOverForm;
		at: #windowMaximizeOver put: self newWindowMaximizeOverForm;
		at: #windowMenuOver put: self newWindowMenuOverForm;
		at: #windowClosePassive put: inactiveForm;
		at: #windowMinimizePassive put: inactiveForm;
		at: #windowMaximizePassive put: inactiveForm;
		at: #windowMenuPassive put: self newWindowMenuPassiveForm! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'AlainPlantec 12/13/2009 18:09'!
menuItemInDockingBarSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item that is in a docking bar."
	
	| fill baseColor |
	Display depth <= 2
		ifTrue: [^ Color gray].
	baseColor := self settings derivedMenuColor.
	self preferGradientFill ifFalse: [^baseColor].
	fill := GradientFillStyle ramp: {0.0 -> baseColor twiceDarker . 1 -> baseColor twiceLighter}.
	fill
		origin: aMenuItem topLeft;
		direction: 0@aMenuItem height.
	^ fill! !

!UIThemeWatery methodsFor: 'fill-styles-buttons' stamp: 'AlainPlantec 12/20/2009 00:27'!
menuItemSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item."
	
	| fill baseColor preferenced |
	Display depth <= 2 ifTrue: [^ Color gray].
	preferenced := self settings menuSelectionColor.
	baseColor := preferenced isNil
		ifTrue: [aMenuItem owner color negated]
		ifFalse: [preferenced].
	self preferGradientFill
		ifFalse: [^baseColor].
	fill := GradientFillStyle ramp: {0.0 -> baseColor twiceLighter . 1 -> baseColor twiceDarker}.
	fill
		origin: aMenuItem topLeft;
		direction: 0@aMenuItem height.
	^ fill! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'gvc 11/5/2007 15:16'!
newCheckboxMarkerForm
	"Answer a new checkbox marker form."

	^(Form
	extent: 12@14
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1342177280 1610612736 134217728 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3338665984 4278190080 1476395008 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 671088640 4278190080 4009754624 134217728 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2147483648 4278190080 2533359616 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3607101440 4278190080 1207959552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1073741824 4278190080 3875536896 16777215 16777215 16777215 16777215 16777215 1207959552 3204448256 134217728 16777215 2801795072 4278190080 2147483648 16777215 16777215 16777215 16777215 134217728 3607101440 4278190080 2936012800 268435456 4143972352 4278190080 536870912 16777215 16777215 16777215 16777215 16777215 536870912 4009754624 4278190080 3607101440 4278190080 3070230528 16777215 16777215 16777215 16777215 16777215 16777215 16777215 805306368 4009754624 4278190080 4278190080 1342177280 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 671088640 2936012800 2801795072 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'morph creation' stamp: 'GaryChambers 8/10/2010 16:33'!
newCloseControlIn: aThemedMorph for: aModel action: aValuable help: helpText
	"Answer a button for closing things."
	
	|form msb|
	form := self windowCloseForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowClosePassiveForm.
	msb extent: form extent.
	msb activeDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowCloseOverForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowClosePassiveForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: aValuable;
		setBalloonText: helpText.
	^msb! !

!UIThemeWatery methodsFor: 'morph creation' stamp: 'gvc 11/13/2007 12:09'!
newDialogPanelIn: aThemedMorph
	"Answer a new (main) dialog panel."

	^(super 
		newDialogPanelIn: aThemedMorph)
		fillStyle: (SolidFillStyle color: Color transparent) "no pane colour tracking"! !

!UIThemeWatery methodsFor: 'morph creation' stamp: 'gvc 1/9/2009 17:41'!
newFocusIndicatorMorphFor: aMorph
	"Answer a new focus indicator for the given morph."

	|radius|
	radius := aMorph focusIndicatorCornerRadius.
	^BorderedMorph new
		fillStyle: Color transparent;
		borderStyle: ((CompositeBorder new width: radius)
						borders: {RoundedBorder new
									cornerRadius: radius;
									width: 1;
									baseColor: self settings scrollbarColor.
								RoundedBorder new	
									cornerRadius: radius - 1;
									width: 1;
									baseColor: (self settings scrollbarColor alpha: 0.4)});
		bounds: aMorph focusBounds! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'gvc 10/25/2007 17:26'!
newRadioButtonMarkerForm
	"Answer a new radio button marker form."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 0 0 0 0 0 0 0 0 16777215 16777215 16777215 16777215 0 0 268435456 1392508928 1392508928 268435456 0 0 16777215 16777215 16777215 16777215 0 268435456 3439329280 4278190080 4211081216 3355443200 268435456 0 16777215 16777215 16777215 16777215 0 1392508928 4278190080 4278190080 4278190080 4244635648 1392508928 0 16777215 16777215 16777215 16777215 0 1392508928 4278190080 4278190080 4261412864 4261412864 1308622848 0 16777215 16777215 16777215 16777215 0 268435456 3439329280 4278190080 4261412864 3422552064 234881024 0 16777215 16777215 16777215 16777215 0 0 268435456 1392508928 1392508928 268435456 0 0 16777215 16777215 16777215 16777215 0 0 0 0 0 0 0 0 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'gvc 10/24/2007 12:16'!
newStripesForm
	"Answer the form for the stripes in panels etc."

	^(Form
	extent: 32@32
	depth: 32
	fromArray: #( 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'morph creation' stamp: 'gvc 3/2/2009 12:31'!
newTaskbarThumbnailIn: aThemedMorph for: aWindow
	"Answer a taskbar thumbnail morph for the given window."

	|answer thumb|
	thumb := aWindow taskbarThumbnail.
	answer := PanelMorph new
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		layoutInset: 8;
		cellInset: 4;
		addMorphBack: thumb;
		addMorphBack: ((self
			buttonLabelForText: (aWindow labelString truncateWithElipsisTo: 50))
				color: Color white).
	answer
		extent: answer minExtent;
		fillStyle: (self tasklistFillStyleFor: answer);
		borderStyle: (self taskbarThumbnailNormalBorderStyleFor: aWindow);
		cornerStyle: (self taskbarThumbnailCornerStyleFor: answer).
	^answer
			! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'gvc 11/5/2007 15:08'!
newTreeExpandedForm
	"Answer a new form for an expanded tree item."

	^(Form
	extent: 9@9
	depth: 32
	fromArray: #( 1049135240 2290649224 2290649224 2290649224 2290649224 2290649224 2290649224 2290649224 1200130184 478709896 4169697416 4287137928 4287137928 4287137928 4287137928 4287137928 4236806280 646482056 16777215 2508753032 4287137928 4287137928 4287137928 4287137928 4287137928 2726856840 16777215 16777215 495487112 4186474632 4287137928 4287137928 4287137928 4236806280 612927624 16777215 16777215 16777215 2542307464 4287137928 4287137928 4287137928 2676525192 16777215 16777215 16777215 16777215 478709896 4169697416 4287137928 4220029064 579373192 16777215 16777215 16777215 16777215 16777215 2424866952 4287137928 2626193544 16777215 16777215 16777215 16777215 16777215 16777215 394823816 4018702472 529041544 16777215 16777215 16777215 16777215 16777215 16777215 16777215 864585864 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'gvc 11/5/2007 15:08'!
newTreeUnexpandedForm
	"Answer a new form for an unexpanded tree item."

	^(Form
	extent: 9@9
	depth: 32
	fromArray: #( 1049135240 461932680 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2324203656 4152920200 2458421384 428378248 16777215 16777215 16777215 16777215 16777215 2357758088 4287137928 4287137928 4152920200 2408089736 394823816 16777215 16777215 16777215 2391312520 4287137928 4287137928 4287137928 4287137928 4119365768 2324203656 344492168 16777215 2408089736 4287137928 4287137928 4287137928 4287137928 4287137928 4287137928 3968370824 780699784 2391312520 4287137928 4287137928 4287137928 4287137928 4236806280 2659747976 529041544 16777215 2357758088 4287137928 4287137928 4253583496 2810742920 646482056 16777215 16777215 16777215 2324203656 4253583496 2777188488 696813704 16777215 16777215 16777215 16777215 16777215 1200130184 663259272 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'gvc 10/24/2007 12:42'!
newWindowCloseForm
	"Answer a new form for a window close box."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290361785 4285822068 4282071867 4279440147 4279440147 4282071867 4285822068 4290361785 0 0 0 0 0 0 0 4287335307 4281808438 4283254086 4286543478 4288254096 4288188560 4286543478 4283254086 4281808438 4287335307 0 0 0 0 0 4287138185 4280425243 4285027670 4289633180 4292135884 4293254878 4293320928 4292267469 4289567644 4285093206 4280490779 4287203978 0 0 0 4290164406 4282134834 4284233271 4288637549 4291401881 4292653234 4292850869 4292785333 4292653234 4291467161 4288637549 4284364600 4282266163 4290230199 0 0 4286545534 4283178015 4287182138 4289281086 4290597711 4290995037 4291126110 4291126109 4290929244 4290662991 4289281086 4287182394 4283309344 4286611327 0 0 4283383359 4285867306 4288685092 4289799715 4290590512 4290856252 4290988611 4291054147 4290922044 4290590256 4289930531 4288619300 4285867562 4283711040 0 0 4282782229 4287833644 4289996837 4290787376 4291381825 4291909968 4292173910 4292239446 4292106833 4291578692 4290984239 4290193702 4287833644 4283044630 0 0 4284026900 4289014315 4291051835 4291973448 4292633434 4293226345 4293556336 4293622129 4293358699 4292896092 4292236105 4291445307 4289014058 4284092436 0 0 4285414719 4289343786 4291712331 4293027933 4293949038 4294280317 4294479236 4294479236 4294346110 4294015086 4293224799 4291974475 4289343785 4285545791 0 0 4287264888 4288555300 4292239449 4293818479 4294542716 4294546314 4294614419 4294614676 4294546828 4294543230 4293884271 4292501850 4288751652 4287330424 0 0 4290558650 4286658615 4291253841 4293951868 4294481292 4294615447 4294617247 4294618017 4294616217 4294481550 4294214781 4291779154 4286789430 4290493114 0 0 4292664540 4288385426 4287573545 4292374633 4293892240 4294289824 4294555050 4294555308 4294356387 4293958547 4292835183 4287836460 4288385426 4292664540 0 0 0 4292993505 4288320403 4286993487 4289421400 4291463295 4292845463 4293043354 4291660419 4289684573 4287256400 4288254867 4292993505 0 0 0 0 0 4292927712 4291282630 4287858566 4286996058 4286533190 4286598726 4287324509 4287858309 4291348680 4292927712 0 0 0 0 0 0 0 4292401368 4293125091 4293454056 4293190884 4293190884 4293190884 4293125091 4292401368 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'GaryChambers 7/26/2010 13:00'!
newWindowCloseOverForm
	"Answer a new form for a window close box for use when the mouse is over it."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290361785 4285822068 4282071867 4279440147 4279440147 4282071867 4285822068 4290361785 0 0 0 0 0 0 0 4287335307 4281808438 4283254086 4286543478 4288254096 4288188560 4286543478 4283254086 4281808438 4287335307 0 0 0 0 0 4287138185 4280425243 4285027670 4289633180 4292135884 4293254878 4293320928 4292267469 4289567644 4285093206 4280490779 4287203978 0 0 0 4290164406 4282134834 4284233271 4287126365 4286603617 4292192940 4292850869 4292785333 4292192940 4286011738 4286666328 4284364600 4282266163 4290230199 0 0 4286545534 4283178015 4286985273 4284555811 4284360999 4285741623 4291126110 4290272343 4285676086 4284360743 4284555811 4287182394 4283309344 4286611327 0 0 4283383359 4285867306 4288685092 4289012512 4285079066 4284293404 4285344037 4285803560 4284293404 4285472540 4289340193 4288619300 4285867562 4283711040 0 0 4282782229 4287833644 4289996837 4290787376 4291381825 4285870380 4284886569 4284952105 4286395695 4291578692 4290984239 4290193702 4287833644 4283044630 0 0 4284026900 4289014315 4291051835 4291973448 4292502105 4286988605 4285544758 4285610550 4287054910 4292830299 4292236105 4291445307 4289014058 4284092436 0 0 4285414719 4289343786 4291712331 4292502618 4287513921 4285808187 4287779662 4287713869 4285808443 4287514433 4292699484 4291974475 4289343785 4285545791 0 0 4287264888 4288555300 4292239449 4288171078 4286333501 4287320653 4294614419 4294351761 4287846482 4286333758 4287448897 4292501850 4288751652 4287330424 0 0 4290558650 4286658615 4291253841 4291718762 4287518032 4293564045 4294617247 4294618017 4293827729 4287518289 4291193701 4291779154 4286789430 4290493114 0 0 4292664540 4288385426 4287573545 4292374633 4293629325 4294289824 4294555050 4294555308 4294356387 4293958547 4292835183 4287836460 4288385426 4292664540 0 0 0 4292993505 4288320403 4286993487 4289421400 4291463295 4292845463 4293043354 4291660419 4289684573 4287256400 4288254867 4292993505 0 0 0 0 0 4292927712 4291282630 4287858566 4286996058 4286533190 4286598726 4287324509 4287858309 4291348680 4292927712 0 0 0 0 0 0 0 4292401368 4293125091 4293454056 4293190884 4293190884 4293190884 4293125091 4292401368 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'gvc 4/21/2009 15:59'!
newWindowInactiveControlForm
	"Answer a new form for an inactive window control box."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291677645 4288585374 4286085240 4284243036 4284243036 4286085240 4288585374 4291677645 0 0 0 0 0 0 0 4289572269 4285756275 4286479998 4288716960 4289835441 4289835441 4288716960 4286479998 4285756275 4289572269 0 0 0 0 0 4289506476 4284835173 4287335307 4290559164 4292598747 4293322470 4293322470 4292598747 4290559164 4287335307 4284703587 4289506476 0 0 0 4291546059 4285493103 4286414205 4288980132 4291217094 4292335575 4292598747 4292598747 4292335575 4291282887 4288980132 4286282619 4285493103 4291546059 0 0 4288980132 4285361517 4287466893 4288782753 4289835441 4290295992 4290295992 4290427578 4290164406 4289835441 4288782753 4287466893 4285361517 4288980132 0 0 4286282619 4286611584 4288059030 4288716960 4289177511 4289572269 4289835441 4289835441 4289703855 4289374890 4288782753 4288059030 4286611584 4286282619 0 0 4285164138 4287664272 4288782753 4289374890 4289835441 4290427578 4290624957 4290624957 4290559164 4290032820 4289374890 4288914339 4287664272 4285164138 0 0 4285361517 4288322202 4289703855 4290295992 4290822336 4291414473 4291677645 4291677645 4291414473 4291085508 4290427578 4289703855 4288453788 4285624689 0 0 4287072135 4288716960 4290427578 4291217094 4291677645 4292203989 4292598747 4292598747 4292335575 4291809231 4291217094 4290427578 4288716960 4287203721 0 0 4288980132 4288256409 4290624957 4291677645 4292335575 4292927712 4293256677 4293256677 4293059298 4292598747 4291809231 4290822336 4288256409 4289177511 0 0 4291677645 4287664272 4290295992 4292006610 4293059298 4293454056 4293585642 4293585642 4293454056 4293125091 4292203989 4290427578 4287730065 4291677645 0 0 4293256677 4290032820 4288124823 4291217094 4292796126 4293322470 4293717228 4293717228 4293454056 4292927712 4291677645 4288256409 4290032820 4293256677 0 0 0 4293454056 4290032820 4288322202 4289967027 4291546059 4292598747 4292664540 4291677645 4290295992 4288716960 4290032820 4293454056 0 0 0 0 0 4293322470 4292203989 4289835441 4288782753 4288322202 4288453788 4288980132 4289835441 4292335575 4293322470 0 0 0 0 0 0 0 4293059298 4293585642 4293717228 4293585642 4293585642 4293585642 4293585642 4293059298 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'MarcusDenker 11/23/2010 14:53'!
newWindowMaximizeForm
	"Answer a new form for a window minimize box."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290295992 4285822068 4282071867 4279440147 4279440147 4282071867 4285822068 4290295992 0 0 0 0 0 0 0 4287269514 4281611316 4282795590 4285953654 4287664528 4287730320 4285953654 4282861383 4281611316 4287269514 0 0 0 0 0 4287137928 4280360481 4283914839 4288455580 4291547084 4292731360 4292796894 4291547341 4288390044 4283980376 4280294689 4287203721 0 0 0 4290164406 4281348144 4282010170 4285369453 4288527772 4290565299 4291025080 4291025080 4290630835 4288593820 4285303917 4282009913 4281348144 4290164406 0 0 4286479998 4280431648 4282282296 4283995198 4286033222 4286821198 4286952786 4287018578 4286755662 4285967429 4284060735 4282216504 4280497696 4286545791 0 0 4282402111 4281097769 4282549797 4283800345 4284982554 4285771048 4285903149 4285837356 4285771304 4285114397 4283866393 4282484773 4281097769 4282402111 0 0 4279972116 4282219307 4283997212 4285114906 4285969451 4286824254 4287152961 4287218498 4286890301 4286167084 4285246490 4284260124 4282219308 4280037908 0 0 4279975186 4283600171 4285640744 4286561842 4287547718 4288336981 4288731227 4288731228 4288402775 4287614279 4286627889 4285772072 4283600683 4280172817 0 0 4282736189 4284126245 4286692666 4287877449 4288797275 4289586536 4290112367 4290112368 4289718377 4288863579 4287877448 4286758970 4284126756 4282803005 0 0 4286284920 4283533850 4287283524 4288731993 4289718632 4290507893 4291099774 4291165055 4290705785 4289850729 4288797788 4287415878 4283599642 4286350968 0 0 4290362041 4283331374 4286560575 4289322854 4290770809 4291559299 4291952522 4292083595 4291690372 4290903163 4289455464 4286889281 4283462959 4290362040 0 0 4292664540 4287928465 4283793702 4288007509 4290572412 4291689100 4292607381 4292607382 4291885710 4290900861 4288666201 4284122406 4287928465 4292664540 0 0 0 4292993505 4288059538 4284842051 4286688328 4289384043 4290962050 4291224710 4289646450 4287083084 4285171781 4287928466 4292993505 0 0 0 0 0 4292927712 4291217093 4287402885 4285630033 4284907832 4284973881 4285893715 4287468677 4291348680 4292927712 0 0 0 0 0 0 0 4292401368 4293125091 4293454056 4293190884 4293190884 4293190884 4293125091 4292401368 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'MarcusDenker 11/23/2010 14:52'!
newWindowMaximizeOverForm
	"Answer a new form for a window maximize box for use when the mouse is over it."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290295992 4285822068 4282071867 4279440147 4279440147 4282071867 4285822068 4290295992 0 0 0 0 0 0 0 4287269514 4281611316 4282795590 4285953654 4287664528 4287730320 4285953654 4282861383 4281611316 4287269514 0 0 0 0 0 4287137928 4280360481 4283914839 4288455580 4291547084 4288980902 4289046437 4291547341 4288390044 4283980376 4280294689 4287203721 0 0 0 4290164406 4281348144 4282010170 4285369453 4288527772 4287405445 4284113749 4284113749 4287405445 4288593820 4285303917 4282009913 4281348144 4290164406 0 0 4286479998 4280431648 4282282296 4283995198 4286033222 4284581178 4282209061 4282274853 4284515642 4285967429 4284060735 4282216504 4280497696 4286545791 0 0 4282402111 4281097769 4282549797 4282216466 4283070226 4283793437 4281749780 4281684244 4283661853 4283201813 4282282258 4282484773 4281097769 4282402111 0 0 4279972116 4282219307 4282347796 4281355787 4281750291 4282210588 4282276125 4282144028 4282210588 4281881876 4281421323 4282544916 4282219308 4280037908 0 0 4279975186 4283600171 4283531037 4281815829 4282473504 4282604837 4282999593 4282999594 4282736679 4282539552 4281881621 4283662365 4283600683 4280172817 0 0 4282736189 4284126245 4286692666 4285175604 4285832770 4286424651 4283657010 4283657267 4286490700 4285898818 4285175604 4286758970 4284126756 4282803005 0 0 4286284920 4283533850 4287283524 4288731993 4289718632 4287346007 4284118074 4284183610 4287478106 4289850729 4288797788 4287415878 4283599642 4286350968 0 0 4290362041 4283331374 4286560575 4289322854 4290770809 4288134753 4284511807 4284577344 4288200290 4290903163 4289455464 4286889281 4283462959 4290362040 0 0 4292664540 4287928465 4283793702 4288007509 4290572412 4291689100 4288920687 4288920687 4291885710 4290900861 4288666201 4284122406 4287928465 4292664540 0 0 0 4292993505 4288059538 4284842051 4286688328 4289384043 4290962050 4291224710 4289646450 4287083084 4285171781 4287928466 4292993505 0 0 0 0 0 4292927712 4291217093 4287402885 4285630033 4284907832 4284973881 4285893715 4287468677 4291348680 4292927712 0 0 0 0 0 0 0 4292401368 4293125091 4293454056 4293190884 4293190884 4293190884 4293125091 4292401368 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'GaryChambers 2/15/2011 15:55'!
newWindowMenuForm
	"Answer a new form for a window menu box."

	^(Form
	extent: 24@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4293125091 4287335307 4283453520 4281150765 4280690214 4280821800 4280821800 4280821800 4280821800 4280821800 4280821800 4280821800 4280821800 4280690214 4281150765 4283453520 4287335307 4293125091 0 0 0 0 0 4293059298 4285493103 4282795590 4287072135 4289638062 4290493371 4290822336 4290756543 4290756543 4290822336 4290822336 4290756543 4290756543 4290822336 4290493371 4289638062 4287072135 4282795590 4285493103 4293059298 0 0 0 0 4287335307 4282598211 4288322202 4291875024 4292927712 4293322470 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293322470 4292927712 4291875024 4288322202 4282598211 4287401100 0 0 0 0 4283585106 4285953654 4289967027 4291677645 4292269782 4292401368 4292401368 4292401368 4292335575 4292335575 4292335575 4292335575 4292401368 4292401368 4292401368 4292269782 4291677645 4289967027 4285953654 4283585106 0 0 0 0 4281742902 4287861651 4290493371 4291085508 4291480266 4291546059 4291611852 4291611852 4291546059 4291480266 4291480266 4291546059 4291611852 4291611852 4291546059 4291480266 4291085508 4290493371 4287861651 4281742902 0 0 0 0 4281940281 4288782753 4291414473 4292203989 4292664540 4292796126 4292927712 4292796126 4292861919 4292927712 4292927712 4292861919 4292796126 4292927712 4292796126 4292664540 4292203989 4291414473 4288782753 4281874488 0 0 0 0 4284045657 4288256409 4291546059 4293190884 4294177779 4294572537 4294440951 4294572537 4294506744 4294572537 4294572537 4294506744 4294572537 4294440951 4294572537 4294177779 4293190884 4291546059 4288256409 4284045657 0 0 0 0 4287269514 4283914071 4290624957 4293190884 4294638330 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294769916 4294638330 4293190884 4290624957 4283914071 4287269514 0 0 0 0 4292467161 4286414205 4283387727 4287993237 4291019715 4292269782 4292467161 4292467161 4292467161 4292467161 4292467161 4292467161 4292467161 4292467161 4292598747 4291611852 4287993237 4283387727 4286414205 4292467161 0 0 0 0 4292401368 4292467161 4288124823 4284177243 4281150765 4280229663 4280361249 4280361249 4280361249 4280361249 4280361249 4280361249 4280361249 4280361249 4280229663 4281282351 4284177243 4288124823 4292467161 4292401368 0 0 0 0 0 4292203989 4292203989 4292335575 4292401368 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292664540 4292401368 4292335575 4292269782 4292203989 0 0 0 0 0 0 0 4292006610 4292401368 4292467161 4292730333 4292730333 4292730333 4292730333 4292730333 4292730333 4292730333 4292730333 4292730333 4292796126 4292467161 4292401368 4292006610 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'GaryChambers 2/15/2011 16:15'!
newWindowMenuOverForm
	"Answer a new form for a window menu box when the mouse is over it."

	^(Form
	extent: 24@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4293257970 4287735753 4284054189 4281884573 4281490073 4281555866 4281555866 4281555866 4281555866 4281555866 4281555866 4281555866 4281555866 4281490073 4281884573 4284054189 4287735753 4293257970 0 0 0 0 0 4293192178 4286026172 4283462312 4287538375 4289970905 4290759648 4291088354 4291022817 4291022817 4291088354 4291088354 4291022817 4291022817 4291088354 4290759648 4289970905 4287538375 4283462312 4286026172 4293192178 0 0 0 0 4287735753 4283265191 4288721616 4292074729 4293060849 4293455092 4293652469 4293652469 4293652469 4293652469 4293652469 4293652469 4293652469 4293652469 4293455092 4293060849 4292074729 4288721616 4283265191 4287801545 0 0 0 0 4284185518 4286420927 4290233820 4291877352 4292468972 4292535021 4292535021 4292535021 4292534765 4292534765 4292534765 4292534765 4292535021 4292535021 4292535021 4292468972 4291877352 4290233820 4286420927 4284185518 0 0 0 0 4282476193 4288261581 4290759648 4291351268 4291680231 4291746023 4291811559 4291811559 4291746023 4291680231 4291680231 4291746023 4291811559 4291811559 4291746023 4291680231 4291351268 4290759648 4288261581 4282476193 0 0 0 0 4282673314 4289116371 4291614438 4292403180 4292797935 4292929264 4293060849 4292929264 4292995056 4293060849 4293060849 4292995056 4292929264 4293060849 4292929264 4292797935 4292403180 4291614438 4289116371 4282607522 0 0 0 0 4284645809 4288655823 4291746023 4293323763 4294244090 4294638589 4294507004 4294638589 4294572796 4294638589 4294638589 4294572796 4294638589 4294507004 4294638589 4294244090 4293323763 4291746023 4288655823 4284645809 0 0 0 0 4287669960 4284514224 4290891232 4293323763 4294704381 4294835710 4294901503 4294901503 4294901503 4294901503 4294901503 4294901503 4294901503 4294901503 4294835710 4294704381 4293323763 4290891232 4284514224 4287669960 0 0 0 0 4292600558 4286880962 4283988397 4288392910 4291285731 4292468972 4292600558 4292600558 4292600558 4292600558 4292600558 4292600558 4292600558 4292600558 4292732143 4291811559 4288392910 4283988397 4286880962 4292600558 0 0 0 0 4292535021 4292600558 4288524495 4284777138 4281884573 4281029782 4281161367 4281161367 4281161367 4281161367 4281161367 4281161367 4281161367 4281161367 4281029782 4282015902 4284777138 4288524495 4292600558 4292535021 0 0 0 0 0 4292403180 4292403180 4292534765 4292535021 4293060849 4293060849 4293060849 4293060849 4293060849 4293060849 4293060849 4293060849 4293060849 4292797935 4292535021 4292534765 4292468972 4292403180 0 0 0 0 0 0 0 4292206058 4292535021 4292600558 4292863472 4292863472 4292863472 4292863472 4292863472 4292863472 4292863472 4292863472 4292863472 4292929264 4292600558 4292535021 4292206058 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'GaryChambers 2/15/2011 16:15'!
newWindowMenuPassiveForm
	"Answer a new form for a window menu box when inactive."

	^(Form
	extent: 24@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294046193 4291085508 4289111718 4287927444 4287664272 4287730065 4287730065 4287730065 4287730065 4287730065 4287730065 4287730065 4287730065 4287664272 4287927444 4289111718 4291085508 4294046193 0 0 0 0 0 4293980400 4290164406 4288782753 4290953922 4292269782 4292664540 4292861919 4292796126 4292796126 4292861919 4292861919 4292796126 4292796126 4292861919 4292664540 4292269782 4290953922 4288782753 4290164406 4293980400 0 0 0 0 4291085508 4288651167 4291546059 4293388263 4293914607 4294111986 4294243572 4294243572 4294243572 4294243572 4294243572 4294243572 4294243572 4294243572 4294111986 4293914607 4293388263 4291546059 4288651167 4291085508 0 0 0 0 4289177511 4290361785 4292401368 4293322470 4293585642 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293585642 4293322470 4292401368 4290361785 4289177511 0 0 0 0 4288190616 4291348680 4292664540 4292993505 4293190884 4293190884 4293256677 4293256677 4293190884 4293190884 4293190884 4293190884 4293256677 4293256677 4293190884 4293190884 4292993505 4292664540 4291348680 4288190616 0 0 0 0 4288322202 4291809231 4293125091 4293585642 4293783021 4293848814 4293914607 4293848814 4293914607 4293914607 4293914607 4293914607 4293848814 4293914607 4293848814 4293783021 4293585642 4293125091 4291809231 4288322202 0 0 0 0 4289374890 4291546059 4293190884 4294046193 4294572537 4294769916 4294704123 4294769916 4294704123 4294769916 4294769916 4294704123 4294769916 4294704123 4294769916 4294572537 4294046193 4293190884 4291546059 4289374890 0 0 0 0 4291019715 4289309097 4292730333 4294046193 4294769916 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294835709 4294769916 4294046193 4292730333 4289309097 4291019715 0 0 0 0 4293717228 4290624957 4289045925 4291414473 4292927712 4293585642 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293783021 4293256677 4291414473 4289045925 4290624957 4293717228 0 0 0 0 4293651435 4293717228 4291480266 4289440683 4287927444 4287466893 4287532686 4287532686 4287532686 4287532686 4287532686 4287532686 4287532686 4287532686 4287466893 4287993237 4289440683 4291480266 4293717228 4293651435 0 0 0 0 0 4293585642 4293585642 4293651435 4293651435 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293783021 4293651435 4293651435 4293585642 4293585642 0 0 0 0 0 0 0 4293454056 4293651435 4293717228 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293717228 4293651435 4293454056 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'gvc 10/24/2007 12:44'!
newWindowMinimizeForm
	"Answer a new form for a window minimize box."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290295992 4285953140 4282726971 4280619283 4280619283 4282661434 4285953140 4290295992 0 0 0 0 0 0 0 4287400586 4282921779 4284629572 4287526262 4288909456 4288974992 4287591798 4284761414 4282856243 4287400586 0 0 0 0 0 4287334536 4282588703 4286796631 4290682268 4292529868 4293385950 4293385950 4292529612 4290682268 4286731095 4282654242 4287400329 0 0 0 4290164406 4283247407 4286332215 4290281068 4292457116 4293447349 4293579448 4293579447 4293447349 4292457116 4290346605 4286660409 4283771952 4290164406 0 0 4287004286 4284555291 4289551160 4291461439 4292647750 4292978252 4292978510 4292978510 4292912459 4292516422 4291461695 4289485625 4285736224 4287004543 0 0 4284694079 4287316261 4291129383 4292379927 4292907543 4293237538 4293434920 4293369896 4293303330 4293104407 4292380439 4291130151 4288301098 4284694078 0 0 4285013269 4289947179 4292577049 4293498387 4293959974 4294159159 4294291774 4294357567 4294291256 4294091813 4293695508 4292774682 4290144044 4285013782 0 0 4286197779 4291263275 4293565218 4294486826 4294752322 4294754384 4294624599 4294756183 4294755663 4294753345 4294618155 4293828129 4291395115 4286263315 0 0 4286797373 4291592487 4294093364 4294753602 4294822482 4294825059 4294826346 4294826603 4294825828 4294822740 4294753602 4294225462 4291855399 4286928446 0 0 4287791736 4290870043 4294029633 4294691156 4294826081 4294894447 4294962297 4294963066 4294895474 4294892130 4294691669 4294096449 4291001115 4287857272 0 0 4290558649 4287916079 4292847677 4294431071 4294829938 4294964349 4294965892 4294966661 4294964606 4294896499 4294563169 4292980029 4287981872 4290558648 0 0 4292664540 4288452497 4288312611 4292590416 4294239351 4294636933 4294835601 4294835346 4294637704 4294306681 4293052245 4288576291 4288452497 4292664540 0 0 0 4292993505 4288321426 4287199810 4289700930 4291873639 4293321856 4293387137 4292005738 4290096709 4287463236 4288321426 4292993505 0 0 0 0 0 4292927712 4291282629 4287861124 4287137103 4286939445 4286939701 4287532112 4287926916 4291348680 4292927712 0 0 0 0 0 0 0 4292401368 4293125091 4293454056 4293190884 4293190884 4293190884 4293125091 4292401368 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'initialize-release' stamp: 'MarcusDenker 11/23/2010 14:52'!
newWindowMinimizeOverForm
	"Answer a new form for a window maximize box for use when the mouse is over it."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290295992 4285953140 4282726971 4280619283 4280619283 4282661434 4285953140 4290295992 0 0 0 0 0 0 0 4287400586 4282921779 4284629572 4287526262 4288909456 4288974992 4287591798 4284761414 4282856243 4287400586 0 0 0 0 0 4287334536 4282588703 4286796631 4290682268 4292529868 4293385950 4293385950 4292529612 4290682268 4286731095 4282654242 4287400329 0 0 0 4290164406 4283247407 4286332215 4290281068 4292457116 4293447349 4293579448 4293579447 4293447349 4292457116 4290346605 4286660409 4283771952 4290164406 0 0 4287004286 4284555291 4289551160 4291461439 4292647750 4292978252 4292978510 4292978510 4292912459 4292516422 4291461695 4289485625 4285736224 4287004543 0 0 4284694079 4287316261 4291129383 4288438288 4288833808 4289097752 4289229341 4289164317 4289098008 4288965136 4288438544 4291130151 4288301098 4284694078 0 0 4285013269 4289947179 4288569618 4285154312 4285483537 4285615897 4285616412 4285616669 4285616153 4285549585 4285285641 4288766994 4290144044 4285013782 0 0 4286197779 4291263275 4289294360 4285287186 4285748254 4285420579 4285487142 4285618471 4285618211 4285814302 4285352722 4289491479 4291395115 4286263315 0 0 4286797373 4291592487 4294093364 4290152751 4290220603 4290222407 4290223436 4290223693 4290222920 4290220860 4290152751 4294225462 4291855399 4286928446 0 0 4287791736 4290870043 4294029633 4294691156 4294826081 4294894447 4294962297 4294963066 4294895474 4294892130 4294691669 4294096449 4291001115 4287857272 0 0 4290558649 4287916079 4292847677 4294431071 4294829938 4294964349 4294965892 4294966661 4294964606 4294896499 4294563169 4292980029 4287981872 4290558648 0 0 4292664540 4288452497 4288312611 4292590416 4294239351 4294636933 4294835601 4294835346 4294637704 4294306681 4293052245 4288576291 4288452497 4292664540 0 0 0 4292993505 4288321426 4287199810 4289700930 4291873639 4293321856 4293387137 4292005738 4290096709 4287463236 4288321426 4292993505 0 0 0 0 0 4292927712 4291282629 4287861124 4287137103 4286939445 4286939701 4287532112 4287926916 4291348680 4292927712 0 0 0 0 0 0 0 4292401368 4293125091 4293454056 4293190884 4293190884 4293190884 4293125091 4292401368 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'GaryChambers 2/15/2011 12:42'!
paneColorFor: aWindow
	"Answer the pane color that should be used."
	
	^self windowColor! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 11/13/2007 13:06'!
progressBarFillStyleFor: aProgressBar
	"Return the progress bar fillStyle for the given progress bar."
	
	|area c|
	c := self progressBarColorFor: aProgressBar.
	area :=  aProgressBar bounds.
	^(GradientFillStyle ramp: {
			0.0->c twiceDarker.
			0.2->c twiceLighter lighter.
			0.3->c twiceLighter lighter.
			0.4->c darker.
			0.6->c twiceLighter lighter.
			1.0->Color white})
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 11/13/2007 13:06'!
progressBarProgressFillStyleFor: aProgressBar
	"Return the progress bar progress fillStyle for the given progress bar."
	
	|area c|
	c := self progressBarProgressColorFor: aProgressBar.
	area :=  aProgressBar bounds.
	^(GradientFillStyle ramp: {
			0.0->c twiceDarker.
			0.2->c twiceLighter lighter.
			0.3->c twiceLighter lighter.
			0.4->c darker.
			0.6->c twiceLighter lighter.
			1.0->Color white})
		origin: area origin;
		direction: 0@area height;
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 3/27/2008 21:36'!
resizerGripNormalFillStyleFor: aResizer
	"Return the normal fillStyle for the given resizer.
	For the moment, answer a transparent colour for no drawing,
	non transparent to draw as normal."
	
	^Color transparent! !

!UIThemeWatery methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 10/24/2007 14:28'!
scrollbarImageColorFor: aScrollbar
	"Return the scrollbar image colour (on buttons) for the given scrollbar."
	
	^Color darkGray! !

!UIThemeWatery methodsFor: 'defaults' stamp: 'gvc 10/7/2008 11:49'!
scrollbarMinimumThumbThickness
	"Answer the minumum width or height of a scrollbar thumb 
	as appropriate to its orientation."
	
	^15! !

!UIThemeWatery methodsFor: 'border-styles-scrollbars' stamp: 'gvc 10/24/2007 14:33'!
scrollbarNormalButtonBorderStyleFor: aScrollbar
	"Return the normal button borderStyle for the given scrollbar."

	^BorderStyle simple
		width: 0! !

!UIThemeWatery methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 10/25/2007 16:16'!
scrollbarNormalButtonFillStyleFor: aScrollbar
	"Return the normal scrollbar button fillStyle for the given scrollbar."
	
	| c|
	c := Color lightGray twiceLighter.
	^(GradientFillStyle ramp: {0.0->c. 0.1->Color white. 0.3->Color white.
			0.5->c. 0.7-> Color white. 1.0->Color white})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 10/24/2007 14:11'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	|aColor c|
	aColor := Color lightGray twiceLighter.
	c := aColor alphaMixed: 0.9 with: Color black.
	^(GradientFillStyle ramp: {0.0->c. 0.15->aColor. 0.7-> Color white. 1.0->Color white})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeWatery methodsFor: 'border-styles-scrollbars' stamp: 'gvc 11/5/2007 14:38'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	|c|
	c := self settings scrollbarColor alphaMixed: 0.7 with: Color black.
	^(CompositeBorder new width: 2)
		borders: {BorderStyle simple
					width: 1;
					baseColor: c.
				BorderStyle simple
					width: 1;
					baseColor: c twiceLighter}! !

!UIThemeWatery methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 11/5/2007 14:38'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar thumb fillStyle for the given scrollbar."
	
	|c|
	c := self scrollbarColorFor: aScrollbar.
	^(GradientFillStyle ramp: {
			0.0->c twiceLighter.
			0.3->c twiceLighter.
			0.4->c darker.
			0.6->c twiceLighter.
			1.0->Color white})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeWatery methodsFor: 'border-styles-scrollbars' stamp: 'gvc 10/24/2007 15:05'!
scrollbarPagingAreaCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#rounded! !

!UIThemeWatery methodsFor: 'border-styles-scrollbars' stamp: 'gvc 10/24/2007 15:13'!
scrollbarPressedButtonBorderStyleFor: aScrollbar
	"Return the pressed button borderStyle for the given scrollbar."

	^self scrollbarNormalButtonBorderStyleFor: aScrollbar! !

!UIThemeWatery methodsFor: 'border-styles-scrollbars' stamp: 'gvc 10/24/2007 15:05'!
scrollbarThumbCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#rounded! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 1/12/2009 13:16'!
splitterNormalFillStyleFor: aSplitter
	"Return the normal splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := aSplitter paneColor.
	^(GradientFillStyle ramp: {
		0.0->aColor twiceLighter. 1.0->aColor darker})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 1/12/2009 13:14'!
splitterPressedFillStyleFor: aSplitter
	"Return the pressed splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := aSplitter paneColor duller.
	^(GradientFillStyle ramp: {
			0.0->aColor twiceLighter. 1.0->aColor twiceDarker})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 10/24/2007 12:18'!
stripesForm
	"Answer the form to use for the stripes of various elements."

	^self forms at: #stripes ifAbsent: [Form extent: 32@32 depth: Display depth]! !

!UIThemeWatery methodsFor: 'defaults' stamp: 'gvc 1/14/2009 15:28'!
tabLabelInsetFor: aButton
	"Answer the inset to use for a tab label."

	^8@2 corner: 8@2! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 1/7/2008 11:27'!
tabLabelNormalFillStyleFor: aTabLabel
	"Return the normal fillStyle for the given tab label."
	
	|aColor|
	aColor := aTabLabel paneColor.
	^(GradientFillStyle ramp: {
			0.0->Color white.
			0.3->Color white.
			0.4->aColor.
			0.6->Color white.
			1.0->Color white})
		origin: aTabLabel bounds origin;
		direction: 0 @ aTabLabel height;
		radial: false! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 1/7/2008 15:16'!
tabLabelSelectedFillStyleFor: aTabLabel
	"Return the selected fillStyle for the given tab label."
	
	|aColor|
	aColor := self settings scrollbarColor.
	^(GradientFillStyle ramp: {
			0.0->aColor twiceLighter.
			0.3->aColor twiceLighter.
			0.4->aColor darker.
			0.7->aColor twiceLighter.
			1.0->Color white})
		origin: aTabLabel bounds origin;
		direction: 0 @ aTabLabel height;
		radial: false! !

!UIThemeWatery methodsFor: 'basic-colors' stamp: 'gvc 11/5/2007 14:52'!
taskbarActiveButtonColorFor: aButton
	"Answer the colour for the given active taskbar button."

	^self settings scrollbarColor alphaMixed: 0.7 with: Color white! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 11/13/2007 12:30'!
taskbarFillStyleFor: aTaskbar
	"Return the taskbar fillStyle for the given taskbar."
	
	|aColor c cm cd cb|
	aColor := self settings scrollbarColor alphaMixed: 0.5 with: aTaskbar color.
	c := aColor  alphaMixed: 0.3 with: Color white.
	cm := aColor alphaMixed: 0.8 with: Color white.
	cd := aColor alphaMixed: 0.6 with: Color black.
	cb := aColor alphaMixed: 0.7 with: Color white.
	^(GradientFillStyle ramp: {0.0->c. 0.1->cm. 0.9->cd. 1.0->cb})
		origin: aTaskbar position;
		direction: 0@27;
		radial: false! !

!UIThemeWatery methodsFor: 'basic-colors' stamp: 'gvc 11/5/2007 14:50'!
taskbarMinimizedButtonColorFor: aButton
	"Answer the colour for the given minimized taskbar button."

	^Color transparent! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'GaryChambers 8/17/2010 16:53'!
textEditorDisabledFillStyleFor: aTextEditor
	"Return the disabled fillStyle for the given text editor."
	
	^self windowColor lighter! !

!UIThemeWatery methodsFor: 'border-styles-buttons' stamp: 'gvc 1/27/2009 14:04'!
textEntryCornerStyleIn: aThemedMorph
	"Answer the corner style to use for text entry morphs."
	
	^#square! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 1/13/2009 13:58'!
textFieldNormalFillStyleFor: aTextField
	"Return the normal fillStyle for the given text field."
	
	|c|
	c := self windowColor.
	^(GradientFillStyle ramp: {
			0.0->c twiceDarker.
			0.05-> c lighter.
			0.15-> Color white.
			1.0->Color white})
		origin: aTextField topLeft;
		direction: 0 @ aTextField height;
		radial: false! !

!UIThemeWatery methodsFor: 'defaults' stamp: 'gvc 10/28/2007 16:42'!
treeLineWidth
	"Answer the width of the tree lines."

	^0! !

!UIThemeWatery methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 10/3/2008 13:11'!
useScrollbarThumbShadow
	"Answer whether a shadow morph should be displayed when
	dragging a scrollbar thumb."

	^false! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 10/26/2007 21:25'!
windowActiveFillStyleFor: aWindow
	"Return the window active fillStyle for the given window."
	
	^self windowColor! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 10/26/2007 21:29'!
windowActiveTitleFillStyleFor: aWindow
	"Return the window active title fillStyle for the given window."
	
	|aColor|
	aColor := self windowColor.
	^(GradientFillStyle ramp: {
			0.0->Color white.
			0.03->Color white.
			0.05-> aColor lighter.
			1.0->aColor darker})	
		origin: aWindow labelArea topLeft;
		direction: 0 @ aWindow labelHeight;
		radial: false! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'GaryChambers 7/26/2010 12:35'!
windowCloseOverForm
	"Answer the form to use for mouse over window close buttons"

	^self forms at: #windowCloseOver ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'gvc 4/21/2009 16:03'!
windowClosePassiveForm
	"Answer the form to use for passive (background) window close buttons"

	^self forms at: #windowClosePassive ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 10/24/2007 12:54'!
windowInactiveFillStyleFor: aWindow
	"Return the window inactive fillStyle for the given window."
	
	^self windowActiveFillStyleFor: aWindow! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 10/26/2007 21:25'!
windowInactiveTitleFillStyleFor: aWindow
	"Return the window inactive title fillStyle for the given window."
	
	^(BitmapFillStyle fromForm: self stripesForm)
		origin: aWindow topLeft! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'GaryChambers 7/26/2010 12:35'!
windowMaximizeOverForm
	"Answer the form to use for mouse over window maximize buttons"

	^self forms at: #windowMaximizeOver ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'gvc 4/21/2009 16:17'!
windowMaximizePassiveForm
	"Answer the form to use for passive (background) window maximize/restore buttons"

	^self forms at: #windowMaximizePassive ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'gvc 10/24/2007 12:45'!
windowMenuIconFor: aWindow
	"Answer the menu icon for the given window."
	
	^self windowMenuForm! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'GaryChambers 2/15/2011 15:25'!
windowMenuOverForm
	"Answer the form to use for mouse over window menu buttons"

	^self forms at: #windowMenuOver ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'GaryChambers 2/15/2011 15:26'!
windowMenuPassiveForm
	"Answer the form to use for inactive window menu buttons"

	^self forms at: #windowMenuPassive ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'GaryChambers 7/26/2010 12:36'!
windowMinimizeOverForm
	"Answer the form to use for mouse over window minimize buttons"

	^self forms at: #windowMinimizeOver ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!UIThemeWatery methodsFor: 'label-styles' stamp: 'gvc 4/21/2009 16:17'!
windowMinimizePassiveForm
	"Answer the form to use for passive (background) window minimize buttons"

	^self forms at: #windowMinimizePassive ifAbsent: [Form extent: 16@16 depth: Display depth]! !

!UIThemeWatery methodsFor: 'border-styles' stamp: 'gvc 1/12/2009 17:38'!
windowPaneBorderStyleFor: aMorph in: aSystemWindow
	"Answer the border style for a morph that is to be added
	as a pane in the given system window,"

	^BorderStyle simple
		color: aSystemWindow paneColor;
		width: (aMorph borderWidth = 0 ifTrue: [0] ifFalse: [1])! !

!UIThemeWatery methodsFor: 'border-styles' stamp: 'gvc 5/13/2008 15:17'!
worldMainDockingBarBorderStyleFor: aDockingBar
	"Return the world main docking bar borderStyle for the given docking bar."

	^BorderStyle simple
		width: 0;
		color: Color transparent! !

!UIThemeWatery methodsFor: 'fill-styles' stamp: 'gvc 11/13/2007 12:31'!
worldMainDockingBarNormalFillStyleFor: aDockingBar
	"Return the world main docking bar fillStyle for the given docking bar."
	
	|aColor|
	aColor := aDockingBar originalColor alpha: 0.7.
	^(GradientFillStyle ramp: {
			0.0->(aColor alphaMixed: 0.3 with: (Color white alpha: aColor alpha)).
			0.8->aColor darker.
			1.0->aColor darker duller})
		origin: aDockingBar topLeft;
		direction: (aDockingBar isVertical
			ifTrue: [aDockingBar width @ 0]
			ifFalse: [0 @ aDockingBar height]);
		radial: false! !

UIThemeWatery subclass: #UIThemeWatery2
	instanceVariableNames: 'windowActiveDropShadowStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

UIThemeWatery2 subclass: #PharoTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!PharoTheme commentStamp: '<historical>' prior: 0!
self defaultSettings: nil.
self beCurrent. !

PharoTheme subclass: #PharoOrangeTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!PharoOrangeTheme commentStamp: '<historical>' prior: 0!
I am GLMUITheme2, a small customization based on GLMUITheme (Glamorous) by Tudor Girba.

GLMUITheme2 defaultSettings: nil.

GLMUITheme2 beCurrent.

GLMUITheme2 setPreferredWorldBackground.
World backgroundMorph: nil.
!

!PharoOrangeTheme class methodsFor: 'accessing' stamp: 'StephaneDucasse 1/17/2011 12:37'!
baseSelectionColor
	
	^ Color orange alpha: 0.66! !

!PharoOrangeTheme class methodsFor: 'accessing' stamp: 'IgorStasenko 1/14/2011 13:37'!
lightSelectionColor
	^ self baseSelectionColor! !

!PharoOrangeTheme class methodsFor: 'settings' stamp: 'SvenVanCaekenberghe 9/19/2010 18:48'!
setDejaVuFontsLarge
	StandardFonts setFontsFromSpec: #(
		(buttonFont: 'BitmapDejaVu' 12)
		(codeFont: 'BitmapDejaVu' 12)
		(defaultFont: 'BitmapDejaVu' 12)
		(listFont: 'BitmapDejaVu' 12)
		(menuFont: 'BitmapDejaVu' 12)
		(balloonFont: 'BitmapDejaVu' 9)
		(haloFont: 'BitmapDejaVu' 9)
		(windowTitleFont: 'BitmapDejaVuBold' 12))! !

!PharoOrangeTheme class methodsFor: 'settings' stamp: 'SvenVanCaekenberghe 9/19/2010 18:48'!
setDejaVuFontsSmall
	StandardFonts setFontsFromSpec: #(
		(buttonFont: 'BitmapDejaVu' 9)
		(codeFont: 'BitmapDejaVu' 9)
		(defaultFont: 'BitmapDejaVu' 9)
		(listFont: 'BitmapDejaVu' 9)
		(menuFont: 'BitmapDejaVu' 9)
		(balloonFont: 'BitmapDejaVu' 7)
		(haloFont: 'BitmapDejaVu' 7)
		(windowTitleFont: 'BitmapDejaVuBold' 9))! !

!PharoOrangeTheme class methodsFor: 'accessing' stamp: 'StephaneDucasse 4/3/2011 22:39'!
themeName
	^ 'Orange Pharo'! !

!PharoOrangeTheme class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 9/11/2010 12:35'!
veryLightSelectionColor
	^ self lightSelectionColor lighter ! !

!PharoOrangeTheme methodsFor: 'fill-styles-buttons' stamp: 'IgorStasenko 1/13/2011 01:15'!
buttonMouseOverFillStyleFor: aButton
	"Return the button mouse over fillStyle for the given color."

	^ CompositeFillStyle 
		fillStyles: {
			self buttonNormalFillStyleFor: aButton.
			SolidFillStyle color: (Color black alpha: 0.1)
		}			
! !

!PharoOrangeTheme methodsFor: 'fill-styles-buttons' stamp: 'IgorStasenko 1/13/2011 17:54'!
buttonSelectedFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	| top bottom |
	top := settings selectionColor lighter lighter.
	bottom := Color gray alpha: 0.1. 

	^ CompositeFillStyle 
		fillStyles: {
			self buttonNormalFillStyleFor: aButton.
			
			(GradientFillStyle ramp: {
			0.8->bottom.
			0.9->top.
			1.0->top.})
			origin: aButton bounds origin;
			direction: 0 @ aButton height;
			radial: false
		}			

! !

!PharoOrangeTheme methodsFor: 'fill-styles-buttons' stamp: 'IgorStasenko 1/13/2011 01:17'!
buttonSelectedMouseOverFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."

	^ CompositeFillStyle 
		fillStyles: {
			self buttonSelectedFillStyleFor: aButton.
			SolidFillStyle color: (Color black alpha: 0.1)
		}			
! !

!PharoOrangeTheme methodsFor: 'fill-styles-buttons' stamp: 'IgorStasenko 1/13/2011 17:08'!
controlButtonMouseOverFillStyleFor: aButton
	^ self buttonMouseOverFillStyleFor: aButton
! !

!PharoOrangeTheme methodsFor: 'fill-styles-buttons' stamp: 'IgorStasenko 1/13/2011 17:07'!
controlButtonNormalFillStyleFor: aButton
	"Return the normal control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonNormalFillStyleFor: aButton! !

!PharoOrangeTheme methodsFor: 'defaults' stamp: 'IgorStasenko 1/13/2011 16:35'!
dialogWindowPreferredCornerStyleFor: aDialogWindow
	"Answer the preferred corner style for the given dialog."

	^#square! !

!PharoOrangeTheme methodsFor: 'private' stamp: 'IgorStasenko 1/13/2011 17:59'!
glamorousBaseSelectionColorFor: aButton
	^ settings selectionColor! !

!PharoOrangeTheme methodsFor: 'border-styles' stamp: 'IgorStasenko 1/13/2011 16:40'!
listNormalBorderStyleFor: listMorph

	^  SimpleBorder new 
			color: (Color black alpha: 0.2);
			width: 1.
	! !

!PharoOrangeTheme methodsFor: 'fill-styles-buttons' stamp: 'IgorStasenko 1/13/2011 18:03'!
menuItemSelectedFillStyleFor: aMenuItem

	^ settings selectionColor! !

!PharoOrangeTheme methodsFor: 'border-styles' stamp: 'IgorStasenko 1/13/2011 16:43'!
scrollPaneNormalBorderStyleFor: aScrollPane
	"Return the normal borderStyle for the given scroll pane."


	^  SimpleBorder new 
			color: (Color black alpha: 0.2);
			width: 1.
	! !

!PharoOrangeTheme methodsFor: 'defaults' stamp: 'IgorStasenko 1/14/2011 13:32'!
selectionBarColor

	^ self selectionColor alpha: 0.15

! !

!PharoTheme class methodsFor: 'accessing' stamp: 'tg 9/4/2010 22:22'!
baseColor
	^ Color r: 190 g: 190 b: 190 range: 255! !

!PharoTheme class methodsFor: 'accessing' stamp: 'tg 9/5/2010 20:50'!
basePassiveBackgroundColor
	^ Color r: 245 g: 245 b: 245 range: 255! !

!PharoTheme class methodsFor: 'accessing' stamp: 'tg 9/5/2010 21:46'!
baseSelectionColor
	^ Color r: 97 g: 163 b: 225 range: 255! !

!PharoTheme class methodsFor: 'accessing' stamp: 'tg 9/9/2010 22:43'!
darkBaseColor
	^ Color r: 180 g: 180 b: 180 range: 255! !

!PharoTheme class methodsFor: 'private' stamp: 'StephaneDucasse 4/11/2011 22:33'!
importGlamorousIcons
	"utility method to import the icons necessary for the theme from the file system"
	"self importGlamorousIcons"
	| icons |
	icons := #(
		'glamorousMax'
		'glamorousMin'
		'glamorousClose'
		'glamorousMenu'
		'glamorousMaxInactive'
		'glamorousMinInactive'
		'glamorousCloseInactive'
		'glamorousMenuInactive'
		'glamorousMenuPin'
		'glamorousCheckboxSelected'
		'glamorousCheckboxUnselected'
		'glamorousRadioSelected'
		'glamorousRadioUnselected').
	self importIcons: icons fromFolder: 'icons' inClass: PharoUIThemeIcons category: '*glamour-morphic-theme'! !

!PharoTheme class methodsFor: 'private' stamp: 'tg 9/3/2010 14:28'!
importIcons: icons fromFolder: aString inClass: aClass category: aCategory
	icons
		do: [:each |
			| method form |
			form := PNGReadWriter formFromFileNamed: aString, '/', each , '.png'.
			method := each , Character cr asString ,
				(aClass methodStart: each),		
				form storeString,
				aClass methodEnd.
			aClass class compile: method classified: aCategory ].
	aClass initialize! !

!PharoTheme class methodsFor: 'accessing' stamp: 'tg 9/9/2010 22:37'!
lightBaseColor
	^ Color r: 200 g: 200 b: 200 range: 255! !

!PharoTheme class methodsFor: 'accessing' stamp: 'tg 9/7/2010 13:51'!
lightSelectionColor
	^ Color r: 175 g: 213 b: 250 range: 255! !

!PharoTheme class methodsFor: 'settings' stamp: 'AlainPlantec 2/11/2011 20:58'!
newDefaultSettings
	BalloonMorph setBalloonColorTo: self lightSelectionColor.
	^super newDefaultSettings
		unfocusedSelectionColor: nil;
		menuColor: self baseColor;
		menuTitleColor: self baseColor;
		windowColor: self baseColor;
		selectionColor: self lightSelectionColor;
		menuSelectionColor: self baseSelectionColor;
		progressBarColor: self baseColor;
		standardColorsOnly: true;
		autoSelectionColor: false;
		preferRoundCorner: false;
		flatMenu: true! !

!PharoTheme class methodsFor: 'settings' stamp: 'tg 9/13/2010 10:40'!
setPreferredWorldBackground
	"self setPreferredWorldBackground"
	"World color: (
		(GradientFillStyle 
			ramp: { 0.0 -> Color white.  1.0 -> Color gray})
			origin: 50 @ 50;
			direction: 800@0;
			normal: 0@800;
		radial: true)"
	World color: Color white! !

!PharoTheme class methodsFor: 'accessing' stamp: 'StephaneDucasse 4/3/2011 22:39'!
themeName
	^ 'Pharo'! !

!PharoTheme class methodsFor: 'accessing' stamp: 'tg 9/7/2010 13:51'!
veryLightSelectionColor
	^ Color r: 218 g: 234 b: 250 range: 255! !

!PharoTheme methodsFor: 'border-styles-buttons' stamp: 'tg 9/4/2010 23:06'!
buttonCornerStyleIn: aThemedMorph
	"If asked, we only allow square corners"
	
	^ #square! !

!PharoTheme methodsFor: 'label-styles' stamp: 'tg 8/31/2010 08:32'!
buttonLabelForText: aTextOrString
	"Answer the label to use for the given text."
	^aTextOrString isString
		ifTrue: [(LabelMorph contents: aTextOrString) color: Color black]
		ifFalse: [super buttonLabelForText: aTextOrString]! !

!PharoTheme methodsFor: 'border-styles-buttons' stamp: 'tg 9/9/2010 22:43'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	| outerColor innerColor |
	(aButton valueOfProperty: #noBorder ifAbsent: [false]) ifTrue: [
		^ SimpleBorder new width: 0; baseColor: Color transparent ].
	outerColor := self glamorousDarkBaseColorFor: aButton.
	^SimpleBorder new
					width: 1;
					baseColor: outerColor! !

!PharoTheme methodsFor: 'fill-styles-buttons' stamp: 'tg 9/3/2010 12:21'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	(aButton valueOfProperty: #noFill ifAbsent: [false]) ifTrue: [^ SolidFillStyle color: Color transparent ].
	^ self glamorousNormalFillStyleFor: aButton height: aButton height! !

!PharoTheme methodsFor: 'fill-styles-buttons' stamp: 'tg 9/13/2010 10:37'!
buttonSelectedFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	| top bottom |
	top := self glamorousLightSelectionColorFor: aButton.
	bottom := self glamorousLightColorFor: aButton.

	^(GradientFillStyle ramp: {
			0.0->top.
			0.7->bottom.})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!PharoTheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 09:08'!
checkboxForm
	"Answer the form to use for a normal checkbox."

	^self  checkboxUnselectedForm! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:33'!
checkboxSelectedForm
	"Answer the form to use for a selected checkbox."

	^PharoUIThemeIcons checkboxSelectedForm! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
checkboxUnselectedForm
	"Answer the form to use for a selected checkbox."

	^ PharoUIThemeIcons checkboxUnselectedForm! !

!PharoTheme methodsFor: 'border-styles' stamp: 'TudorGirba 1/13/2011 23:06'!
configureWindowBorderFor: aWindow
"	super configureWindowBorderFor: aWindow.
	aWindow roundedCorners: #()"
		| aStyle |
	
	
	aStyle := 
		SimpleBorder new 
			color: (Color black alpha: 0.5);
			width: 1.
			
	aWindow borderStyle: aStyle.! !

!PharoTheme methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/13/2011 22:59'!
configureWindowDropShadowFor: aWindow

	aWindow hasDropShadow: false! !

!PharoTheme methodsFor: 'label-styles' stamp: 'tg 9/3/2010 11:34'!
createMenuBoxFor: aSystemWindow
	"Answer a button for the window menu."
	
"	^aSystemWindow createBox
		labelGraphic: (self windowMenuIconFor: aSystemWindow);
		extent: aSystemWindow boxExtent;
		actWhen: #buttonDown;
		actionSelector: #offerWindowMenu;
		setBalloonText: 'window menu' translated"
	
	|form msb|
	form := self windowMenuForm.
	msb := MultistateButtonMorph new extent: form extent.
	msb activeEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMenuPassiveForm.
	msb extent: form extent.
	msb activeDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveEnabledNotOverUpFillStyle: (ImageFillStyle form: form).
	msb passiveDisabledNotOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMenuForm.
	msb extent: form extent.
	msb
		activeEnabledOverUpFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverUpFillStyle: (ImageFillStyle form: form).
	form := self windowMenuPassiveForm.
	msb
		extent: form extent;
		activeEnabledOverDownFillStyle: (ImageFillStyle form: form);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: form);
		addUpAction: [aSystemWindow offerWindowMenu];
		setBalloonText: 'window menu' translated;
		extent: aSystemWindow boxExtent.
	^msb! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/3/2010 12:30'!
dockingBarNormalFillStyleFor: aToolDockingBar
	^ SolidFillStyle color: Color transparent! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:47'!
dropListDisabledFillStyleFor: aDropList
	"Return the disabled fillStyle for the given drop list."
	
	^ self textEditorDisabledFillStyleFor: aDropList! !

!PharoTheme methodsFor: 'border-styles' stamp: 'tg 9/4/2010 22:55'!
dropListNormalBorderStyleFor: aDropList
	"Return the normal borderStyle for the given drop list"

	^ self buttonNormalBorderStyleFor: aDropList! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/4/2010 23:04'!
dropListNormalFillStyleFor: aDropList
	"Return the normal fillStyle for the given drop list."
	
	^ SolidFillStyle color: Color white! !

!PharoTheme methodsFor: 'private' stamp: 'tg 9/3/2010 12:32'!
glamorousBaseColorFor: aButton
	^ self class baseColor
	"unfortunately, it looks like paneColor does not always return the wanted color"
	"aButton paneColorOrNil ifNil: [Color r: 200 g: 200 b: 200 range: 255]"! !

!PharoTheme methodsFor: 'private' stamp: 'tg 9/5/2010 20:40'!
glamorousBasePassiveBackgroundColorFor: aButton
	^ self class basePassiveBackgroundColor! !

!PharoTheme methodsFor: 'private' stamp: 'tg 9/5/2010 20:40'!
glamorousBaseSelectionColorFor: aButton
	^ self class baseSelectionColor! !

!PharoTheme methodsFor: 'private' stamp: 'tg 9/9/2010 22:50'!
glamorousDarkBaseColorFor: aButton
	^ self class darkBaseColor! !

!PharoTheme methodsFor: 'private' stamp: 'tg 9/9/2010 22:02'!
glamorousLightColorFor: aButton
	^ self class lightBaseColor! !

!PharoTheme methodsFor: 'private' stamp: 'tg 9/5/2010 21:44'!
glamorousLightSelectionColorFor: aMorph
	^ self class lightSelectionColor! !

!PharoTheme methodsFor: 'private' stamp: 'tg 9/13/2010 10:49'!
glamorousNormalFillStyleFor: aMorph height: anInteger
	"Return the normal button fillStyle for the given button."
	
	| baseColor |
	baseColor := self glamorousBaseColorFor: aMorph.
	^ self glamorousNormalFillStyleWithBaseColor: baseColor for: aMorph height: anInteger
! !

!PharoTheme methodsFor: 'private' stamp: 'tg 9/13/2010 10:49'!
glamorousNormalFillStyleWithBaseColor: aColor for: aMorph height: anInteger
	
	| top bottom |
	top := aColor twiceLighter.
	bottom := aColor.
	^(GradientFillStyle ramp: {
			0.0->top.
			0.7->bottom.})
		origin: aMorph bounds origin;
		direction: 0 @ anInteger;
		radial: false! !

!PharoTheme methodsFor: 'border-styles' stamp: 'tg 9/9/2010 23:51'!
groupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a group panel."

	^ SimpleBorder new
		width: 1;
		baseColor: ((self glamorousBaseColorFor: aGroupPanel))! !

!PharoTheme methodsFor: 'initialize-release' stamp: 'tg 8/31/2010 13:51'!
initialize
	"self beCurrent"

	super initialize.
	self windowActiveDropShadowStyle: #nodiffuse! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:48'!
listDisabledFillStyleFor: aList
	"Return the disabled fillStyle for the given list."
	
	^ self textEditorDisabledFillStyleFor: aList! !

!PharoTheme methodsFor: 'fill-styles-buttons' stamp: 'tg 9/10/2010 08:12'!
menuItemInDockingBarSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item that is in a docking bar."
	^ self buttonSelectedFillStyleFor: aMenuItem! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
menuPinForm
	"Answer the form to use for the pin button of a menu."

	^ PharoUIThemeIcons menuPinForm! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
newCheckboxMarkerForm
	"Answer a new checkbox marker form."

	^PharoUIThemeIcons checkboxMarkerForm! !

!PharoTheme methodsFor: 'morph creation' stamp: 'tg 9/5/2010 21:28'!
newFocusIndicatorMorphFor: aMorph
	"Answer a new focus indicator for the given morph."

	|radius|
	radius := aMorph focusIndicatorCornerRadius.
	^ BorderedMorph new
		fillStyle: Color transparent;
		borderStyle: (SimpleBorder new
			 width: 1;
			baseColor: (self glamorousBaseSelectionColorFor: aMorph));
		bounds: aMorph focusBounds! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
newRadioButtonMarkerForm
	"Answer a new radio button marker form. We make it empty because we already have the selected radio button take care of the state."

	^PharoUIThemeIcons radioButtonMarkerForm  ! !

!PharoTheme methodsFor: 'initialize-release' stamp: 'tg 9/6/2010 14:38'!
newRadioMarkerForm
	"Answer a new checkbox marker form."

	^Form extent: 12@12 depth: 32! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
newWindowCloseForm
	"Answer a new form for a window close box."

	^ PharoUIThemeIcons windowCloseForm ! !

!PharoTheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 14:18'!
newWindowCloseOverForm
	"Answer a new form for a window menu box."

	^ self newWindowCloseForm! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
newWindowMaximizeForm
	"Answer a new form for a window maximize box."

	^ PharoUIThemeIcons windowMaximizeForm! !

!PharoTheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 14:18'!
newWindowMaximizeOverForm
	"Answer a new form for a window menu box."

	^ self newWindowMaximizeForm! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
newWindowMenuForm
	"Answer a new form for a window menu box."

	^ PharoUIThemeIcons windowMenuForm! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
newWindowMenuPassiveForm
	"Answer a new form for a window menu box."

	^ PharoUIThemeIcons windowMenuInactiveForm! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
newWindowMinimizeForm
	"Answer a new form for a window minimize box."

	^ PharoUIThemeIcons windowMinimizeForm! !

!PharoTheme methodsFor: 'forms' stamp: 'FernandoOlivero 10/28/2010 15:09'!
newWindowMinimizeOverForm
	"Answer a new form for a window menu box."

	^ self newWindowMinimizeForm! !

!PharoTheme methodsFor: 'border-styles' stamp: 'tg 9/3/2010 14:50'!
plainGroupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a plain group panel."

	^SimpleBorder new
		width: 1;
		baseColor: Color transparent! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:51'!
progressBarFillStyleFor: aProgressBar
	^ self glamorousBasePassiveBackgroundColorFor: aProgressBar! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/7/2010 13:52'!
progressBarProgressFillStyleFor: aProgressBar
	^ (self glamorousLightSelectionColorFor: aProgressBar)! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
radioButtonForm
	"Answer the form to use for a normal radio button."

	^ PharoUIThemeIcons radioButtonUnselectedForm! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
radioButtonSelectedForm
	"Answer the form to use for a selected radio button."

	^ PharoUIThemeIcons radioButtonSelectedForm ! !

!PharoTheme methodsFor: 'fill-styles-scrollbars' stamp: 'tg 9/13/2010 10:52'!
scrollbarNormalButtonFillStyleFor: aScrollbar
	"Return the normal scrollbar button fillStyle for the given scrollbar."
	
	^ self scrollbarNormalThumbFillStyleFor: aScrollbar! !

!PharoTheme methodsFor: 'fill-styles-scrollbars' stamp: 'tg 9/4/2010 21:03'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	^ "(self glamorousBaseColorFor: aScrollbar) muchLighter"
	Color r: 245 g: 245 b: 245 range: 255! !

!PharoTheme methodsFor: 'fill-styles-scrollbars' stamp: 'tg 9/13/2010 10:50'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	^ (self glamorousNormalFillStyleWithBaseColor: aScrollbar paneColor for:  aScrollbar height: aScrollbar height)
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0])! !

!PharoTheme methodsFor: 'border-styles-scrollbars' stamp: 'tg 8/31/2010 13:27'!
scrollbarPagingAreaCornerStyleIn: aThemedMorph	
	^#square! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/4/2010 23:14'!
separatorFillStyleFor: aSeparator
	"Return the separator fillStyle for the given separator."
	
	^ SolidFillStyle color: (self glamorousBaseColorFor: aSeparator) darker! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:48'!
sliderDisabledFillStyleFor: aSlider
	"Return the disabled fillStyle for the given slider."
	
	^ self textEditorDisabledFillStyleFor: aSlider! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:41'!
splitterNormalFillStyleFor: aSplitter
	"Return the normal splitter fillStyle for the given splitter."
	
	^ SolidFillStyle color: Color transparent! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:41'!
splitterPressedFillStyleFor: aSplitter
	"Return the pressed splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := self glamorousBaseColorFor: aSplitter.
	^ (GradientFillStyle ramp: {0.0->aColor lighter. 0.9-> aColor})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!PharoTheme methodsFor: 'basic-colors' stamp: 'tg 9/13/2010 10:36'!
subgroupColorFrom: paneColor
	"Answer the colour for a subgroup given the pane colour."

	^ self glamorousLightColorFor: paneColor" self class baseColor"! !

!PharoTheme methodsFor: 'border-styles' stamp: 'tg 8/31/2010 15:28'!
tabLabelNormalBorderStyleFor: aTabLabel
"	^SimpleBorder new
		width: 0;
		baseColor: (self buttonBaseColorFor: aTabLabel) darker
"	^ self buttonNormalBorderStyleFor: aTabLabel! !

!PharoTheme methodsFor: 'fill-styles-buttons' stamp: 'tg 8/31/2010 11:13'!
tabLabelNormalFillStyleFor: aTabLabel
	^ self buttonNormalFillStyleFor: aTabLabel ! !

!PharoTheme methodsFor: 'fill-styles-buttons' stamp: 'tg 8/31/2010 11:13'!
tabLabelSelectedFillStyleFor: aTabLabel
	^ self buttonSelectedFillStyleFor: aTabLabel ! !

!PharoTheme methodsFor: 'border-styles' stamp: 'StephaneDucasse 4/11/2011 22:31'!
tabPanelBorderStyleFor: aTabGroup
	^ ExtendedTabPanelBorder new 
		width: 1;
		baseColor: ((self glamorousDarkBaseColorFor: aTabGroup));
		tabSelector: aTabGroup tabSelectorMorph! !

!PharoTheme methodsFor: 'basic-colors' stamp: 'tg 9/6/2010 15:03'!
taskbarButtonLabelColorFor: aButton
	"Answer the colour for the label of the given taskbar button."

	^aButton model
		ifNil: [super taskbarButtonLabelColorFor: aButton]
		ifNotNil: [:win |
			win isActive
				ifTrue: [Color black]
				ifFalse: [Color gray darker]]! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 8/31/2010 12:51'!
taskbarFillStyleFor: aTaskbar
	^ self buttonNormalFillStyleFor: aTaskbar! !

!PharoTheme methodsFor: 'border-styles' stamp: 'tg 9/4/2010 20:23'!
taskbarThumbnailCornerStyleFor: aMorph
	"Answer the corner style for the taskbar thumbnail/tasklist."
	
	^#square! !

!PharoTheme methodsFor: 'border-styles' stamp: 'tg 9/4/2010 20:56'!
taskbarThumbnailNormalBorderStyleFor: aWindow
	^ self buttonNormalBorderStyleFor: aWindow! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/5/2010 20:46'!
textEditorDisabledFillStyleFor: aTextEditor
	"Return the disabled fillStyle for the given text editor."
	
	^self glamorousBasePassiveBackgroundColorFor: aTextEditor! !

!PharoTheme methodsFor: 'border-styles' stamp: 'tg 9/4/2010 23:09'!
textEditorNormalBorderStyleFor: aTextEditor
	"Return the normal text editor borderStyle for the given text editor."

	^self buttonNormalBorderStyleFor: aTextEditor! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/13/2010 10:41'!
windowActiveFillStyleFor: aWindow
	"We do not want the lighting effect when the window goes inactive"
	^SolidFillStyle color: self class baseColor! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/3/2010 12:22'!
windowActiveTitleFillStyleFor: aWindow
	^ self glamorousNormalFillStyleFor: aWindow height: aWindow labelHeight! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
windowClosePassiveForm
	"Answer the form to use for passive (background) window close buttons"

	^PharoUIThemeIcons windowCloseInactiveForm! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/2/2010 13:52'!
windowInactiveFillStyleFor: aWindow
	"We do not want the lighting effect when the window goes inactive"
	^self windowActiveFillStyleFor: aWindow! !

!PharoTheme methodsFor: 'fill-styles' stamp: 'tg 9/2/2010 13:51'!
windowInactiveTitleFillStyleFor: aWindow
	"We do not want the lighting effect when the window goes inactive"
	^self windowActiveTitleFillStyleFor: aWindow! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
windowMaximizePassiveForm
	"Answer the form to use for passive (background) window maximize/restore buttons"

	^PharoUIThemeIcons windowMaximizeInactiveForm! !

!PharoTheme methodsFor: 'label-styles' stamp: 'tg 9/3/2010 10:52'!
windowMenuPassiveForm
	"Answer the form to use for passive (background) window menu buttons"

	^self newWindowMenuPassiveForm! !

!PharoTheme methodsFor: 'forms' stamp: 'StephaneDucasse 4/11/2011 22:32'!
windowMinimizePassiveForm
	"Answer the form to use for passive (background) window minimize buttons"

	^PharoUIThemeIcons windowMinimizeInactiveForm! !

!UIThemeWatery2 class methodsFor: 'accessing' stamp: 'MarcusDenker 9/27/2010 15:32'!
newDefaultSettings
	"Answer a new original default settings."
	"self defaultSettings: nil"
	^super newDefaultSettings
		windowColor: (Color r: 170 g: 170 b: 170 range: 255);
		menuColor: (Color r: 200 g: 200 b: 200 range: 255);
		menuTitleColor: (Color r: 190 g: 190 b: 190 range: 255);
		yourself! !

!UIThemeWatery2 class methodsFor: 'accessing' stamp: 'gvc 10/3/2008 11:25'!
themeName
	"Answer the friendly name of the theme."

	^'Watery 2'! !

!UIThemeWatery2 methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 2/3/2009 14:28'!
baseScrollbarColorFor: aScrollbar
	"Return the scrollbar last pane colour or that of our settings if unavailable"
	
	^(aScrollbar valueOfProperty: #lastPaneColor) ifNil: [self settings scrollbarColor]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 13:59'!
buttonBottomLeftForm
	"Answer the form to use for the bottom left of a button."

	^self forms at: #buttonBottomLeft ifAbsent: [Form extent: 11@11 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 14:00'!
buttonBottomMiddleForm
	"Answer the form to use for the bottom middle of a button."

	^self forms at: #buttonBottomMiddle ifAbsent: [Form extent: 1@11 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 14:00'!
buttonBottomRightForm
	"Answer the form to use for the bottom right of a button."

	^self forms at: #buttonBottomRight ifAbsent: [Form extent: 11@11 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'GaryChambers 8/17/2010 14:07'!
buttonColouredFillStyleFor: aButton
	"Return the coloured button fillStyle for the given button."
	
	|round roundCorners tl t tr l m r bl b br|
	round := aButton wantsRoundedCorners.
	roundCorners := aButton roundedCorners.
	tl := (round and: [roundCorners includes: 1]) ifTrue: [self buttonSelectedTopLeftForm] ifFalse: [self buttonSquareSelectedTopLeftForm].
	t := self buttonSelectedTopMiddleForm.
	tr:= (round and: [roundCorners includes: 4]) ifTrue: [self buttonSelectedTopRightForm] ifFalse: [self buttonSquareSelectedTopRightForm].
	l := self buttonSelectedMiddleLeftForm. m := Color r: 102 g: 127 b: 168 range: 255. r := self buttonSelectedMiddleRightForm.
	bl := (round and: [roundCorners includes: 2]) ifTrue: [self buttonSelectedBottomLeftForm] ifFalse: [self buttonSquareSelectedBottomLeftForm].
	b := self buttonSelectedBottomMiddleForm.
	br := (round and: [roundCorners includes: 3]) ifTrue: [self buttonSelectedBottomRightForm] ifFalse: [self buttonSquareSelectedBottomRightForm].
	^self
		multiFormFillStyleFrom: {tl. t. tr. l. m. r. bl. b. br}
		in: aButton bounds! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'gvc 1/9/2009 17:52'!
buttonFocusIndicatorCornerRadiusFor: aButton
	"Answer the default corner radius preferred for the focus indicator
	for the button for themes that support this."

	^aButton wantsRoundedCorners
		ifTrue: [7]
		ifFalse: [2]! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'gvc 2/19/2009 11:34'!
buttonLabelInsetFor: aButton
	"Answer the inset to use for a button's label."

	|left right|
	^aButton wantsRoundedCorners
		ifTrue: [left := ((aButton roundedCorners includesAnyOf: #(1 2)) ifTrue: [8] ifFalse: [4]).
				right := ((aButton roundedCorners includesAnyOf: #(3 4)) ifTrue: [8] ifFalse: [4]).
				left@2 corner: right@2]		
		ifFalse: [3@2]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 14:00'!
buttonMiddleLeftForm
	"Answer the form to use for the middle left of a button."

	^self forms at: #buttonMiddleLeft ifAbsent: [Form extent: 11@1 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 14:00'!
buttonMiddleRightForm
	"Answer the form to use for the middle right of a button."

	^self forms at: #buttonMiddleRight ifAbsent: [Form extent: 11@1 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'gvc 12/3/2008 17:23'!
buttonMinHeight
	"Answer the minumum height of a button for this theme."
	
	^24! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'gvc 1/23/2009 12:23'!
buttonMinWidth
	"Answer the minumum width of a button for this theme."
	
	^24! !

!UIThemeWatery2 methodsFor: 'border-styles-buttons' stamp: 'gvc 12/5/2008 14:33'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	^BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'GaryChambers 8/17/2010 14:08'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	^aButton isDefault 
		ifTrue: [self buttonColouredFillStyleFor: aButton]
		ifFalse: [self buttonPlainFillStyleFor: aButton]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/9/2008 13:23'!
buttonPanelNormalFillStyleFor: aPanel
	"Return the normal panel fillStyle for the given panel."
	
	^aPanel paneColor! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'GaryChambers 8/17/2010 14:06'!
buttonPlainFillStyleFor: aButton
	"Return the plain button fillStyle for the given button."
	
	|round roundCorners tl t tr l m r bl b br|
	round := aButton wantsRoundedCorners.
	roundCorners := aButton roundedCorners.
	tl := (round and: [roundCorners includes: 1]) ifTrue: [self buttonTopLeftForm] ifFalse: [self buttonSquareTopLeftForm].
	t := self buttonTopMiddleForm.
	tr:= (round and: [roundCorners includes: 4]) ifTrue: [self buttonTopRightForm] ifFalse: [self buttonSquareTopRightForm].
	l := self buttonMiddleLeftForm. m := Color r: 211 g: 211 b: 211 range: 255. r := self buttonMiddleRightForm.
	bl := (round and: [roundCorners includes: 2]) ifTrue: [self buttonBottomLeftForm] ifFalse: [self buttonSquareBottomLeftForm].
	b := self buttonBottomMiddleForm.
	br := (round and: [roundCorners includes: 3]) ifTrue: [self buttonBottomRightForm] ifFalse: [self buttonSquareBottomRightForm].
	^self
		multiFormFillStyleFrom: {tl. t. tr. l. m. r. bl. b. br}
		in: aButton bounds! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:30'!
buttonSelectedBottomLeftForm
	"Answer the form to use for the bottom left of a selected button."

	^self forms at: #buttonSelectedBottomLeft ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:30'!
buttonSelectedBottomMiddleForm
	"Answer the form to use for the bottom middle of a selected button."

	^self forms at: #buttonSelectedBottomMiddle ifAbsent: [Form extent: 1@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:30'!
buttonSelectedBottomRightForm
	"Answer the form to use for the bottom right of a selected button."

	^self forms at: #buttonSelectedBottomRight ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'GaryChambers 8/17/2010 14:08'!
buttonSelectedFillStyleFor: aButton
	"Return the selected button fillStyle for the given button."
	
	^aButton isDefault 
		ifTrue: [self buttonPlainFillStyleFor: aButton]
		ifFalse: [self buttonColouredFillStyleFor: aButton]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:30'!
buttonSelectedMiddleLeftForm
	"Answer the form to use for the middle left of a selected button."

	^self forms at: #buttonSelectedMiddleLeft ifAbsent: [Form extent: 12@1 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:30'!
buttonSelectedMiddleRightForm
	"Answer the form to use for the middle right of a selected button."

	^self forms at: #buttonSelectedMiddleRight ifAbsent: [Form extent: 12@1 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:30'!
buttonSelectedTopLeftForm
	"Answer the form to use for the top left of a selected button."

	^self forms at: #buttonSelectedTopLeft ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 12:41'!
buttonSelectedTopMiddleForm
	"Answer the form to use for the top middle of a selected button."

	^self forms at: #buttonSelectedTopMiddle ifAbsent: [Form extent: 1@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:31'!
buttonSelectedTopRightForm
	"Answer the form to use for the top right of a selected button."

	^self forms at: #buttonSelectedTopRight ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 15:22'!
buttonSquareBottomLeftForm
	"Answer the form to use for the bottom left of a square button."

	^self forms at: #buttonSquareBottomLeft ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 15:23'!
buttonSquareBottomRightForm
	"Answer the form to use for the bottom right of a square button."

	^self forms at: #buttonSquareBottomRight ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:37'!
buttonSquareSelectedBottomLeftForm
	"Answer the form to use for the bottom left of a selected square button."

	^self forms at: #buttonSquareSelectedBottomLeft ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:38'!
buttonSquareSelectedBottomRightForm
	"Answer the form to use for the bottom right of a selected square button."

	^self forms at: #buttonSquareSelectedBottomRight ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:38'!
buttonSquareSelectedTopLeftForm
	"Answer the form to use for the top left of a selected square button."

	^self forms at: #buttonSquareSelectedTopLeft ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 14:38'!
buttonSquareSelectedTopRightForm
	"Answer the form to use for the top right of a selected square button."

	^self forms at: #buttonSquareSelectedTopRight ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 15:24'!
buttonSquareTopLeftForm
	"Answer the form to use for the top left of a square button."

	^self forms at: #buttonSquareTopLeft ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 1/22/2009 15:24'!
buttonSquareTopRightForm
	"Answer the form to use for the top right of a square button."

	^self forms at: #buttonSquareTopRight ifAbsent: [Form extent: 12@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 14:00'!
buttonTopLeftForm
	"Answer the form to use for the top left of a button."

	^self forms at: #buttonTopLeft ifAbsent: [Form extent: 11@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 14:00'!
buttonTopMiddleForm
	"Answer the form to use for the top middle of a button."

	^self forms at: #buttonTopMiddle ifAbsent: [Form extent: 1@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 14:01'!
buttonTopRightForm
	"Answer the form to use for the top right of a button."

	^self forms at: #buttonTopRight ifAbsent: [Form extent: 11@12 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'border-styles-buttons' stamp: 'gvc 12/9/2008 13:06'!
checkboxButtonDisabledBorderStyleFor: aCheckboxButton
	"Return the disabled checkbox button borderStyle for the given button."

	^self checkboxButtonNormalBorderStyleFor: aCheckboxButton! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 12/9/2008 13:08'!
checkboxButtonDisabledFillStyleFor: aCheckboxButton
	"Return the disabled checkbox button fillStyle for the given button."
	
	^self checkboxButtonNormalFillStyleFor: aCheckboxButton! !

!UIThemeWatery2 methodsFor: 'border-styles-buttons' stamp: 'gvc 12/9/2008 12:46'!
checkboxButtonNormalBorderStyleFor: aChecboxButton
	"Return the normal checkbox button borderStyle for the given button."

	^BorderStyle simple
		width: 1;
		baseColor: Color transparent! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 12/9/2008 12:45'!
checkboxButtonNormalFillStyleFor: aCheckboxButton
	"Return the normal checkbox button fillStyle for the given checkbox button."
	
	^(ImageFillStyle form: self checkboxForm) origin: aCheckboxButton topLeft! !

!UIThemeWatery2 methodsFor: 'border-styles-buttons' stamp: 'gvc 12/9/2008 13:06'!
checkboxButtonSelectedBorderStyleFor: aCheckboxButton
	"Return the selected checkbox button borderStyle for the given button."

	^self checkboxButtonNormalBorderStyleFor: aCheckboxButton! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 12/9/2008 12:45'!
checkboxButtonSelectedFillStyleFor: aCheckboxButton
	"Return the selected checkbox button fillStyle for the given checkbox button."
	
	^(ImageFillStyle form: self checkboxSelectedForm) origin: aCheckboxButton topLeft! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/9/2008 12:43'!
checkboxForm
	"Answer the form to use for a normal checkbox."

	^self forms at: #checkbox ifAbsent: [Form extent: 14@14 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/9/2008 12:43'!
checkboxSelectedForm
	"Answer the form to use for a selected checkbox."

	^self forms at: #checkboxSelected ifAbsent: [Form extent: 14@14 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'GaryChambers 8/17/2010 14:38'!
controlButtonDisabledFillStyleFor: aButton
	"Return the disabled control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self controlButtonSelectedFillStyleFor: aButton! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'gvc 12/5/2008 14:58'!
controlButtonLabelInsetFor: aButton
	"Answer the inset to use for a control button's label."

	^2! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 1/20/2010 12:02'!
controlButtonNormalFillStyleFor: aButton
	"Return the normal control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonSelectedFillStyleFor: aButton! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 1/28/2009 17:55'!
controlButtonPressedFillStyleFor: aButton
	"Return the pressed button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self controlButtonSelectedFillStyleFor: aButton! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 1/28/2009 17:53'!
controlButtonSelectedDisabledFillStyleFor: aButton
	"Return the selected disabled control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self controlButtonSelectedFillStyleFor: aButton! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 1/20/2010 12:02'!
controlButtonSelectedFillStyleFor: aButton
	"Return the selected control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self buttonNormalFillStyleFor: aButton! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 1/28/2009 17:54'!
controlButtonSelectedMouseOverFillStyleFor: aButton
	"Return the selected mouse over control button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self controlButtonSelectedFillStyleFor: aButton! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 1/20/2010 12:02'!
controlButtonSelectedPressedFillStyleFor: aButton
	"Return the selected pressed button fillStyle for the given button.
	Control buttons are generally used for drop-lists and expanders."
	
	^self controlButtonNormalFillStyleFor: aButton! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/9/2008 17:25'!
dialogWindowActiveFillStyleFor: aWindow
	"Return the window active fillStyle for the given window."
	
	^self windowActiveFillStyleFor: aWindow! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/9/2008 17:25'!
dialogWindowInactiveFillStyleFor: aWindow
	"Return the window active fillStyle for the given window."
	
	^self windowInactiveFillStyleFor: aWindow! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/9/2008 13:26'!
dockingBarNormalFillStyleFor: aToolDockingBar
	"Return the normal docking bar fillStyle for the given color."
	
	^aToolDockingBar paneColor! !

!UIThemeWatery2 methodsFor: 'border-styles-buttons' stamp: 'gvc 1/28/2009 17:09'!
dropListControlButtonWidth
	"Answer the width of a drop list control button for this theme."
	
	^20! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'GaryChambers 8/17/2010 14:37'!
dropListDisabledFillStyleFor: aDropList
	"Return the disabled fillStyle for the given drop list."
	
	^self dropListNormalFillStyleFor: aDropList! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'GaryChambers 8/18/2010 17:16'!
dropListFocusIndicatorCornerRadiusFor: aDropList
	"Answer the default corner radius preferred for the focus indicator
	for the drop list for themes that support this."

	^aDropList wantsRoundedCorners
		ifTrue: [7]
		ifFalse: [2]! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'GaryChambers 8/18/2010 17:36'!
dropListInsetFor: aDropList
	"Answer the inset to use for drop-list layout."

	^6 @ 0 corner: 0 @ 0! !

!UIThemeWatery2 methodsFor: 'border-styles' stamp: 'GaryChambers 8/18/2010 17:14'!
dropListNormalBorderStyleFor: aDropList
	"Return the normal borderStyle for the given drop list"

	^BorderStyle simple
		width: 0;
		baseColor: Color transparent! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'GaryChambers 8/18/2010 17:06'!
dropListNormalFillStyleFor: aDropList
	"Return the normal fillStyle for the given drop list."
	
	|round roundCorners tl t tr l m r bl b br|
	round := aDropList wantsRoundedCorners.
	roundCorners := aDropList roundedCorners.
	tl := (round and: [roundCorners includes: 1]) ifTrue: [self buttonTopLeftForm] ifFalse: [self buttonSquareTopLeftForm].
	t := self buttonTopMiddleForm.
	tr:= (round and: [roundCorners includes: 4]) ifTrue: [self buttonTopRightForm] ifFalse: [self buttonSquareTopRightForm].
	l := self buttonMiddleLeftForm. m := Color r: 211 g: 211 b: 211 range: 255. r := self buttonMiddleRightForm.
	bl := (round and: [roundCorners includes: 2]) ifTrue: [self buttonBottomLeftForm] ifFalse: [self buttonSquareBottomLeftForm].
	b := self buttonBottomMiddleForm.
	br := (round and: [roundCorners includes: 3]) ifTrue: [self buttonBottomRightForm] ifFalse: [self buttonSquareBottomRightForm].
	^self
		multiFormFillStyleFrom: {tl. t. tr. l. m. r. bl. b. br}
		in: aDropList bounds! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'GaryChambers 8/18/2010 17:37'!
editableDropListInsetFor: aDropList
	"Answer the inset to use for an editable drop-list layout."

	^5 @ 0 corner: 0 @ 0! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'GaryChambers 8/18/2010 17:32'!
editableDropListMargins
	"Answer the text margins for an editable drop list for this theme."
	
	^0 @ 3 corner: 2 @ 1! !

!UIThemeWatery2 methodsFor: 'border-styles-buttons' stamp: 'gvc 1/28/2009 17:11'!
expanderTitleControlButtonWidth
	"Answer the width of an expander title control button for this theme."
	
	^20! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'gvc 1/23/2009 12:35'!
expanderTitleInsetFor: aDropList
	"Answer the inset to use for expander title layout."

	^0! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 2/16/2009 17:22'!
initialize
	"Initialize the receiver."

	super initialize.
	self windowActiveDropShadowStyle: #diffuse! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:22'!
initializeForms
	"Initialize the receiver's image forms."

	super initializeForms.
	self forms
		at: #sbHThumbLeft put: self newScrollbarThumbLeftForm;
		at: #sbHThumbMiddle put: self newScrollbarThumbHorizontalMiddleForm;
		at: #sbHThumbRight put: self newScrollbarThumbRightForm;
		at: #sbVThumbTop put: self newScrollbarThumbTopForm;
		at: #sbVThumbMiddle put: self newScrollbarThumbVerticalMiddleForm;
		at: #sbVThumbBottom put: self newScrollbarThumbBottomForm;
		at: #buttonTopLeft put: self newButtonTopLeftForm;
		at: #buttonTopMiddle put: self newButtonTopMiddleForm;
		at: #buttonTopRight put: self newButtonTopRightForm;
		at: #buttonMiddleLeft put: self newButtonMiddleLeftForm;
		at: #buttonMiddleRight put: self newButtonMiddleRightForm;
		at: #buttonBottomLeft put: self newButtonBottomLeftForm;
		at: #buttonBottomMiddle put: self newButtonBottomMiddleForm;
		at: #buttonBottomRight put: self newButtonBottomRightForm;
		at: #buttonSquareTopLeft put: self newButtonSquareTopLeftForm;
		at: #buttonSquareTopRight put: self newButtonSquareTopRightForm;
		at: #buttonSquareBottomLeft put: self newButtonSquareBottomLeftForm;
		at: #buttonSquareBottomRight put: self newButtonSquareBottomRightForm;
		at: #buttonSelectedTopLeft put: self newButtonSelectedTopLeftForm;
		at: #buttonSelectedTopMiddle put: self newButtonSelectedTopMiddleForm;
		at: #buttonSelectedTopRight put: self newButtonSelectedTopRightForm;
		at: #buttonSelectedMiddleLeft put: self newButtonSelectedMiddleLeftForm;
		at: #buttonSelectedMiddleRight put: self newButtonSelectedMiddleRightForm;
		at: #buttonSelectedBottomLeft put: self newButtonSelectedBottomLeftForm;
		at: #buttonSelectedBottomMiddle put: self newButtonSelectedBottomMiddleForm;
		at: #buttonSelectedBottomRight put: self newButtonSelectedBottomRightForm;
		at: #buttonSquareSelectedTopLeft put: self newButtonSquareSelectedTopLeftForm;
		at: #buttonSquareSelectedTopRight put: self newButtonSquareSelectedTopRightForm;
		at: #buttonSquareSelectedBottomLeft put: self newButtonSquareSelectedBottomLeftForm;
		at: #buttonSquareSelectedBottomRight put: self newButtonSquareSelectedBottomRightForm;
		at: #radioButton put: self newRadioButtonForm;
		at: #radioButtonSelected put: self newRadioButtonSelectedForm;
		at: #checkbox put: self newCheckboxForm;
		at: #checkboxSelected put: self newCheckboxSelectedForm! !

!UIThemeWatery2 methodsFor: 'border-styles' stamp: 'gvc 12/9/2008 12:08'!
listNormalBorderStyleFor: aList
	"Return the normal borderStyle for the given list"

	^BorderStyle simple
		width: 1;
		baseColor: aList paneColor! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:17'!
newButtonBottomLeftForm
	"Answer the form for the bottom left of a button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 3716317826 4291743438 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 2842718320 4290953922 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 1784635231 4255886251 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 978802519 4170157967 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 374427985 3815599469 4291611852 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 41975936 1699499084 4168973693 4293190884 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 0 154745145 2891010385 4271873951 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 0 16777216 675299392 3764280926 4290098613 4293980400 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 0 0 33554432 1295332661 3595850836 4253583496 4292993505 4294309365 4294309365 4294309365 4294309365 4294309365 0 0 0 33554432 640626479 2688433726 4083574374 4289835441 4293125091 4294506744 4294572537 4294572537 0 0 0 0 16777216 138428480 1546267178 3510780482 3981989976 4184895600 4270360712 4288651167 0 0 0 0 0 0 33554432 338044454 941629472 1511989023 2268016431 3124575549)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:17'!
newButtonBottomMiddleForm
	"Answer the form for the bottom middle of a button."

	^(Form
	extent: 1@12
	depth: 32
	fromArray: #( 4292072403 4292401368 4292664540 4292927712 4293190884 4293454056 4293717228 4294046193 4294309365 4294572537 4289506476 3443342653)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:18'!
newButtonBottomRightForm
	"Answer the form for the bottom right of a button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4291282887 3548216701 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4290230199 2607574124 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4238187933 1616731485 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4119365768 962156889 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4290756543 3697895785 374427985 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4292730333 4118378873 1666010445 41975936 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4254175633 2790215503 154745145 0 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4293848814 4289177511 3663288665 675299392 16777216 0 4294309365 4294309365 4294309365 4294309365 4294309365 4292467161 4253188738 3545453395 1295332661 33554432 0 0 4294572537 4294572537 4294440951 4292861919 4289309097 4066797158 2655010880 640626479 33554432 0 0 0 4288519581 4270294919 4168052591 3965081174 3477291843 1546267178 138428480 16777216 0 0 0 0 3107864126 2268016431 1511989023 941629472 338044454 33554432 0 0 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:18'!
newButtonMiddleLeftForm
	"Answer the form for the middle left of a button."

	^(Form
	extent: 12@1
	depth: 32
	fromArray: #( 3968305031 4292138196 4292138196 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:18'!
newButtonMiddleRightForm
	"Answer the form for the middle right of a button."

	^(Form
	extent: 12@1
	depth: 32
	fromArray: #( 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 3934750599)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:28'!
newButtonSelectedBottomLeftForm
	"Answer the form for the bottom left of a selected button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 3713688967 4284841382 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 2840812155 4284841122 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 1783452780 4251022487 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 977750885 4166608772 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 373704285 3813365101 4285499564 4286092476 4286092476 4286092476 4286092476 4286092476 4286092476 4286092476 4286092476 4286092476 33554560 1698382676 4166082166 4286224317 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 0 154745173 2889761365 4267668108 4286685125 4286685125 4286685125 4286685125 4286685125 4286685125 4286685125 4286685125 0 16777216 674444102 3762375258 4285103772 4286948554 4286948554 4286948554 4286948554 4286948554 4286948554 4286948554 0 0 33554432 1294675516 3594273360 4250231929 4286619071 4287277775 4287277775 4287277775 4287277775 4287277775 0 0 0 33554432 640165935 2687513663 4081274461 4285169818 4286882243 4287606740 4287606740 4287606740 0 0 0 0 16777216 134234176 1545872426 3509597758 3980150095 4182267235 4267009399 4284642698 0 0 0 0 0 0 33554432 338044454 941629472 1511791647 2267424813 3123524408)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:28'!
newButtonSelectedBottomMiddleForm
	"Answer the form for the bottom middle of a selected button."

	^(Form
	extent: 1@12
	depth: 32
	fromArray: #( 4284907432 4285171117 4285500082 4285763767 4286092732 4286356417 4286685381 4286948810 4287278031 4287606996 4285038229 3442226232)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:28'!
newButtonSelectedBottomRightForm
	"Answer the form for the bottom right of a selected button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284775331 3545850757 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 4285170861 4284643228 2605931385 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 4285499826 4233915791 1615745901 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4116079488 961039463 4286092476 4286092476 4286092476 4286092476 4286092476 4286092476 4286092476 4286092476 4286092476 4285169827 3695858538 373704285 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 4286092472 4115618674 1664828245 33554560 4286685125 4286685125 4286685125 4286685125 4286685125 4286685125 4286685125 4286685125 4250495363 2789098069 154745173 0 4286948554 4286948554 4286948554 4286948554 4286948554 4286948554 4286882504 4284642962 3661580376 674444102 16777216 0 4287277775 4287277775 4287277775 4287277775 4287277775 4286421177 4250034292 3543876175 1294675516 33554432 0 0 4287606740 4287606740 4287540947 4286750399 4284906131 4064496988 2654025280 640165935 33554432 0 0 0 4284445576 4266943863 4165424226 3963307086 3476109119 1545872426 134234176 16777216 0 0 0 0 3106812728 2267424813 1511791647 941629472 338044454 33554432 0 0 0 0 0 0)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:28'!
newButtonSelectedMiddleLeftForm
	"Answer the form for the middle left of a selected button."

	^(Form
	extent: 12@1
	depth: 32
	fromArray: #( 3965347464 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:28'!
newButtonSelectedMiddleRightForm
	"Answer the form for the middle right of a selected button."

	^(Form
	extent: 12@1
	depth: 32
	fromArray: #( 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 3931727240)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:29'!
newButtonSelectedTopLeftForm
	"Answer the form for the top left of a selected button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 0 33554431 362719975 1268031205 2541850575 3279521477 3765271736 0 0 0 0 0 111848191 2407633100 4049957547 4266548622 4284838039 4287271854 4290099916 0 0 0 16777471 814060743 3581116602 4266877583 4288982209 4292730856 4292994026 4292994026 4292994026 0 0 16777471 1903987394 4099960739 4285430685 4291349978 4292270819 4292270819 4292270819 4292270819 4292270819 0 0 713067455 4083709352 4288259003 4291547356 4291547356 4291547356 4291547356 4291547356 4291547356 4291547356 0 75464703 3580787373 4287535542 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 33554431 2389802158 4251744930 4290297809 4290297809 4290297809 4290297809 4290297809 4290297809 4290297809 4290297809 4290297809 258373546 4016337568 4286878386 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 1097823911 4200558234 4287207349 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 2070376603 4284182168 4286155693 4288654276 4288654276 4288654276 4288654276 4288654276 4288654276 4288654276 4288654276 4288654276 3160435603 4284314525 4284577696 4287668413 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 3780930190 4284578211 4284578211 4285301417 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:29'!
newButtonSelectedTopMiddleForm
	"Answer the form for the top middle of a selected button."

	^(Form
	extent: 1@12
	depth: 32
	fromArray: #( 3966269361 4291941599 4292994026 4292205027 4291547356 4290889943 4290297809 4289640652 4289114568 4288588740 4288128705 4286353587)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:29'!
newButtonSelectedTopRightForm
	"Answer the form for the top right of a selected button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 3748625849 3262810310 2441121744 1184342758 295085538 33554431 0 0 0 0 0 0 4290099916 4287271854 4284904087 4266680208 4016534958 2156237519 75464703 0 0 0 0 0 4292994026 4292994026 4292994026 4292730856 4288981953 4250297491 3463873727 646616786 16777471 0 0 0 4292270819 4292270819 4292270819 4292270819 4292270819 4291284185 4285233565 4066800809 1551994565 16777471 0 0 4291547356 4291547356 4291547356 4291547356 4291547356 4291547356 4291547356 4287929784 4016798124 545033153 0 0 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 4287009457 3379658160 61516543 0 4290297809 4290297809 4290297809 4290297809 4290297809 4290297809 4290297809 4290297809 4290166480 4234639009 2003992240 33554431 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4286286508 3949425826 258373546 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4286747057 4167135387 896300710 4288654276 4288654276 4288654276 4288654276 4288654276 4288654276 4288654276 4288654276 4288654276 4285760937 4250693017 1785229980 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4287471035 4284446367 4284314268 2841668498 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4285038503 4284578211 4284578211 3663554701)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:19'!
newButtonSquareBottomLeftForm
	"Answer the form for the bottom left of a square button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 3968305031 4292138196 4292138196 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 3967976066 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 3967778687 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 3967449722 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 3967252343 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 3966923378 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 3966660206 4293783021 4293783021 4293783021 4293783021 4293783021 4293783021 4293783021 4293783021 4293717228 4293717228 4293717228 3966397034 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 3966133862 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 3830929239 4293783021 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 2502963248 4252596601 4289309097 4289506476 4289506476 4289506476 4289506476 4289506476 4289506476 4289506476 4289506476 4289506476 622599196 2352034097 3409854014 3443342653 3443342653 3443342653 3443342653 3443342653 3443342653 3443342653 3443342653 3443342653)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:20'!
newButtonSquareBottomRightForm
	"Answer the form for the bottom right of a square button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 4292072403 3934750599 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292401368 4292335575 3934421634 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 3934158462 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 3933895290 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 3933632118 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 4293454056 3933368946 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 3933039981 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 4294046193 3932776809 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 3932447844 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 4294572537 4293388263 3780400212 4289506476 4289506476 4289506476 4289506476 4289506476 4289506476 4289506476 4289506476 4289506476 4289243304 4235556213 2452565807 3443342653 3443342653 3443342653 3443342653 3443342653 3443342653 3443342653 3443342653 3443342653 3393076798 2352034097 622599196)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:35'!
newButtonSquareSelectedBottomLeftForm
	"Answer the form for the bottom left of a selected square button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 3965347464 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 3965215874 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 3964952703 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 3964821113 4285763767 4285763767 4285763767 4285763767 4285763767 4285763767 4285763767 4285763767 4285763767 4285763767 4285763767 3964623476 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 3964426350 4286421953 4286421953 4286421953 4286421953 4286356417 4286356417 4286356417 4286356417 4286356417 4286356417 4286356417 3964294248 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 4286685381 4286685381 4286685381 3964097124 4287014602 4287014602 4287014602 4287014346 4287014346 4287014346 4287014346 4287014346 4287014346 4287014346 4287014346 3963833950 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 3829154896 4287211978 4287607252 4287606996 4287606996 4287606996 4287606996 4287606996 4287606996 4287606996 4287606996 4287606996 2502502958 4249705579 4284972435 4285038229 4285038229 4285038229 4285038229 4285038229 4285038229 4285038229 4285038229 4285038229 622599196 2351311407 3408802615 3442226232 3442226232 3442226232 3442226232 3442226232 3442226232 3442226232 3442226232 3442226232)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:35'!
newButtonSquareSelectedBottomRightForm
	"Answer the form for the bottom right of a selected square button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 4284907432 3931727240 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285171117 4285170861 3931595651 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 3931464061 4285763767 4285763767 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 4285763511 3931200888 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 3931003251 4286356417 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 4286356160 3930871661 4286685381 4286685381 4286685381 4286685381 4286685381 4286685381 4286685381 4286685381 4286685381 4286685381 4286685381 3930674280 4286948810 4286948810 4286948810 4286948810 4286948810 4286948810 4286948810 4286948810 4286948810 4286948810 4286948810 3930476899 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 3930345054 4287606996 4287606996 4287606996 4287606996 4287606996 4287606996 4287606996 4287541460 4287541460 4287541460 4286948549 3778691918 4285038229 4285038229 4285038229 4285038485 4285038485 4285038485 4285038485 4285038485 4285038485 4284841105 4232796519 2452040237 3442226232 3442226232 3442226232 3442226232 3442226232 3442226232 3442226232 3442226232 3442226232 3392025400 2351311407 622599196)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:36'!
newButtonSquareSelectedTopLeftForm
	"Answer the form for the top left of a selected square button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 630892779 3329853638 3949492146 3966269361 3966269361 3966269361 3966269361 3966269361 3966269361 3966269361 3966269361 3966269361 3028455632 4282141565 4285561500 4291744478 4291876062 4291876062 4291876062 4291876062 4291876062 4291876062 4291876062 4291876062 3916792766 4281944439 4289771209 4292928234 4292928234 4292928234 4292928234 4292928234 4292994026 4292994026 4292994026 4292994026 3966992312 4282207868 4289705673 4292139234 4292205027 4292205027 4292205027 4292205027 4292205027 4292205027 4292205027 4292205027 3966860723 4282537089 4289311174 4291481564 4291481564 4291481564 4291481564 4291481564 4291481564 4291547356 4291547356 4291547356 3966598062 4282800518 4288785346 4290889686 4290889686 4290889686 4290889686 4290889686 4290889686 4290889686 4290889686 4290889686 3966334888 4283129739 4288456639 4290232273 4290232273 4290232273 4290232273 4290232273 4290297809 4290297809 4290297809 4290297809 3966268835 4283393168 4288062397 4289640396 4289640652 4289640652 4289640652 4289640652 4289640652 4289640652 4289640652 4289640652 3966071197 4283722133 4287799227 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 3965874072 4283985818 4287405242 4288523204 4288523204 4288588740 4288588740 4288588740 4288588740 4288588740 4288588740 4288588740 3965741971 4284314782 4287208120 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 3965544845 4284578467 4285893551 4286288050 4286288050 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 14:36'!
newButtonSquareSelectedTopRightForm
	"Answer the form for the top right of a selected square button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 3966269361 3966269361 3966269361 3966269361 3966269361 3966269105 3966269105 3966269105 3966269105 3949492146 3246098890 547072752 4291941599 4291941599 4291941599 4291941599 4291941599 4291941599 4291941599 4291941599 4291810270 4285298585 4282338943 2927923665 4292994026 4292994026 4292994026 4292994026 4292994026 4292994283 4292994283 4292994283 4292994283 4289442502 4281878647 3883238334 4292205027 4292270819 4292270819 4292270819 4292270819 4292270819 4292270819 4292270819 4292270819 4289442758 4282207868 3933503928 4291547356 4291547356 4291547356 4291547356 4291547356 4291547356 4291612893 4291612893 4291612893 4289048003 4282471297 3933240756 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 4290889943 4288653760 4282800518 3933043629 4290297809 4290297809 4290297809 4290297809 4290297809 4290298066 4290298066 4290298066 4290298066 4288325054 4283063947 3932911528 4289640652 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4289706189 4287930812 4283393168 3932714660 4289114568 4289114568 4289114568 4289114568 4289114568 4289114568 4289180360 4289180360 4289180360 4287602105 4283656596 3932516765 4288588740 4288588740 4288654532 4288654532 4288654532 4288654532 4288654532 4288654532 4288654532 4287339448 4283985817 3932319385 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4288128705 4288194497 4288194497 4287142327 4284314782 3932187795 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4286353587 4285827758 4284578467 3931924878)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:21'!
newButtonSquareTopLeftForm
	"Answer the form for the top left of a square button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 633520834 3333994680 3954422707 3971199923 3971199923 3971199923 3971199923 3971199923 3971199923 3971199923 3971199923 3971199923 3032004792 4289243304 4290822336 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 3920736689 4289374890 4292730333 4294111986 4294111986 4294111986 4294111986 4294111986 4294111986 4294111986 4294111986 4294111986 3970805165 4289638062 4292796126 4293783021 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 3970476200 4289901234 4292664540 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 3970278821 4290164406 4292532954 4293322470 4293322470 4293322470 4293322470 4293322470 4293322470 4293322470 4293322470 4293322470 3970015649 4290493371 4292532954 4293190884 4293190884 4293190884 4293125091 4293125091 4293190884 4293190884 4293190884 4293190884 3969686684 4290756543 4292467161 4292993505 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 3969423512 4291019715 4292467161 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 3969160340 4291282887 4292467161 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 3968831375 4291546059 4292467161 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 3968568203 4291809231 4292203989 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:21'!
newButtonSquareTopRightForm
	"Answer the form for the top right of a square button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 3971199923 3971199923 3971199923 3971199923 3971199923 3971199923 3971199923 3971199923 3971199923 3954422707 3250240186 549042617 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293585642 4290690750 4289243304 2931341496 4294111986 4294111986 4294111986 4294111986 4294111986 4294111986 4294111986 4294111986 4294111986 4292598747 4289374890 3887182257 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4293848814 4292664540 4289638062 3937184940 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4292532954 4289901234 3936987561 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292467161 4290164406 3936658596 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4292401368 4290427578 3936329631 4293059298 4293059298 4293059298 4293059298 4293059298 4292993505 4292993505 4292993505 4292993505 4292335575 4290690750 3936132252 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292401368 4291019715 3935803287 4292796126 4292796126 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292401368 4291282887 3935540115 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292467161 4291546059 3935276943 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292203989 4291809231 3935013771)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:19'!
newButtonTopLeftForm
	"Answer the form for the top left of a button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 0 33554431 365151171 1270791870 2545662907 3283663032 3770004917 0 0 0 0 0 111848106 2411247800 4054954417 4272729260 4290427578 4291546059 4292796126 0 0 0 33554431 817083315 3585192369 4273058225 4292401368 4293980400 4294111986 4294111986 4294111986 0 0 33554431 1907076011 4105022893 4290953922 4293454056 4293848814 4293848814 4293848814 4293848814 4293848814 0 0 715696296 4088179884 4292269782 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 0 79675327 3584402853 4291940817 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 33554431 2392628380 4256938939 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 261724569 4020281504 4292006610 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 1099795853 4205488810 4292269782 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 2072413830 4290361785 4292006610 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 3163196042 4291217094 4291611852 4292664540 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 3784150413 4291809231 4291809231 4292006610 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:19'!
newButtonTopMiddleForm
	"Answer the form for the top middle of a button."

	^(Form
	extent: 1@12
	depth: 32
	fromArray: #( 3971199923 4293585642 4294111986 4293848814 4293585642 4293322470 4293190884 4293059298 4292927712 4292796126 4292796126 4292335575)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 1/22/2009 15:19'!
newButtonTopRightForm
	"Answer the form for the top right of a button."

	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 3753227701 3266885816 2445065404 1187103169 298042307 33554431 0 0 0 0 0 0 4292796126 4291546059 4290427578 4272729260 4021334192 2159655353 75464575 0 0 0 0 0 4294111986 4294111986 4294111986 4293980400 4292401368 4256346802 3467817650 649113776 33554431 0 0 0 4293848814 4293848814 4293848814 4293848814 4293848814 4293388263 4290822336 4071534254 1554886061 33554431 0 0 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4292072403 4020873641 548055722 0 0 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4291611852 3382944675 67108863 0 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293125091 4239701172 2006686619 33554431 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4291809231 3953041054 261724569 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292072403 4171473827 898206089 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4291875024 4256215216 1787069572 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292532954 4291611852 4290822336 2843968387 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4292335575 4291940817 4291809231 4291677645 3666380936)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 12/11/2008 16:38'!
newCheckboxForm
	"Answer the form for a normal checkbox."

	^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 594242411 3918960278 4138774704 4138774704 4138774704 4138774704 4138774704 4138774704 4138774704 4138774704 4138774704 4138774704 3919026071 594242411 2575072380 4292467161 4294177779 4294177779 4294177779 4294177779 4294177779 4294177779 4294177779 4294177779 4294177779 4294177779 4292467161 2524806525 2658695288 4292664540 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4292664540 2608429433 2658432116 4292532954 4293322470 4293322470 4293322470 4293322470 4293322470 4293322470 4293322470 4293322470 4293322470 4293322470 4292532954 2608232054 2658366323 4292467161 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4293059298 4292467161 2608100468 2658037358 4292532954 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292532954 2607771503 2657839979 4292138196 4292138196 4292138196 4292138196 4292138196 4292138196 4292138196 4292138196 4292138196 4292138196 4292138196 4292138196 2607639917 2657642600 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 2607442538 2657313635 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 4293190884 2607113573 2657116256 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 4293717228 2606850401 2606455643 4294046193 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294046193 2556255581 1311978291 4237003659 4289967027 4289967027 4289967027 4289967027 4289967027 4289967027 4289967027 4289967027 4289967027 4289967027 4237003659 1278555445 50331648 1210986030 1647917369 1647917369 1647917369 1647917369 1647917369 1647917369 1647917369 1647917369 1647917369 1647917369 1210986030 50331648)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 12/11/2008 16:38'!
newCheckboxSelectedForm
	"Answer the form for a selected checkbox."

	^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 591416973 3914425236 4134435746 4134435746 4134435746 4134435746 4134435746 4134435746 4134435746 4134435746 4134435746 4134435746 3914425236 591416973 2571195527 4289245124 4293125612 4293125612 4293125612 4293125612 4293125612 4293125612 4293125612 4293125612 4293125612 4293125612 4289245124 2520929417 2655015551 4289114053 4291744479 4291744479 4291744479 4291744479 4291744479 4291744479 4291744479 4291744479 4291744479 4291744479 4289114053 2604684160 2654949242 4288456640 4290560980 4290560980 4290560980 4290560980 4290560980 4290560980 4290560980 4290560980 4290560980 4290560980 4288456640 2604748668 2654817654 4287799485 4289443276 4289443276 4289443276 4289443276 4289443276 4289443276 4289443276 4289443276 4289443276 4289443276 4287799485 2604486007 2654686063 4287273914 4288457669 4288457669 4288457669 4288457669 4288457669 4288457669 4288457669 4288457669 4288457669 4288457669 4287273914 2604420207 2654816618 4284907433 4284907433 4284907433 4284907433 4284907433 4284907433 4284907433 4284907433 4284907433 4284907433 4284907433 4284907433 2604484971 2654619492 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 2604353637 2654684509 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 4286092732 2604352863 2654487128 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 4286685382 2604221017 2603892560 4287146187 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287278031 4287146187 2553626706 1310531626 4232599666 4284512149 4284512149 4284512149 4284512149 4284512149 4284512149 4284512149 4284512149 4284512149 4284512149 4232599666 1276977451 50331648 1210064935 1646208047 1646208047 1646208047 1646208047 1646208047 1646208047 1646208047 1646208047 1646208047 1646208047 1210064935 50331648)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 12/8/2008 18:37'!
newRadioButtonForm
	"Answer the form for a normal radio button."

	^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 16777215 16777215 16777215 198234320 2645865652 3568415153 4072521149 4055875519 3551637937 2578756788 164021958 16777215 16777215 16777215 16777215 16777215 1437906100 4038506166 4292598747 4293914607 4294111986 4294111986 4293914607 4292598747 4021728950 1303556786 16777215 16777215 16777215 1386916522 4257465283 4293388263 4293651435 4293651435 4293651435 4293651435 4293651435 4293651435 4293388263 4240556481 1219144362 16777215 195207842 4038177201 4293125091 4293256677 4293256677 4293256677 4293256677 4293256677 4293256677 4293256677 4293256677 4293059298 3987713967 144678815 2627640990 4291875024 4292993505 4292993505 4292993505 4292993505 4292993505 4292993505 4292993505 4292993505 4292993505 4292993505 4291743438 2459803037 3584139681 4292072403 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292861919 4292006610 3500056222 3970476200 4291809231 4292467161 4292532954 4292532954 4292532954 4292532954 4292532954 4292532954 4292532954 4292532954 4292467161 4291809231 3919947173 3919749794 4292203989 4292203989 4292203989 4292203989 4292203989 4292203989 4292203989 4292203989 4292203989 4292203989 4292203989 4292203989 3869154974 3515846543 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 3431697291 2289333364 4291480266 4293125091 4293125091 4293125091 4293125091 4293125091 4293125091 4293125091 4293125091 4293125091 4293125091 4291151301 2154918257 189154886 3817178501 4293256677 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293585642 4293059298 3766583681 189154886 16777215 960906822 4120221077 4293322470 4294111986 4294111986 4294111986 4294111986 4294111986 4294111986 4293256677 4103180689 927549769 16777215 16777215 16777215 910048830 3682039671 4290756543 4293256677 4294572537 4294506744 4293190884 4273847741 3648287860 893337407 16777215 16777215 16777215 16777215 16777215 169482778 1799570243 3042202708 3681710706 3664867697 3025359699 1799636036 169482778 16777215 16777215 16777215)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 12/8/2008 18:38'!
newRadioButtonSelectedForm
	"Answer the form for a selected radio button."

	^(Form
	extent: 14@14
	depth: 32
	fromArray: #( 16777215 16777215 16777215 195273727 2641329849 3563221416 4067918510 4051207088 3546444457 2574352313 160337634 16777215 16777215 16777215 16777215 16777215 1433764797 4033509543 4289442502 4292467941 4292928234 4292928234 4292467941 4289442502 4016797863 1299613120 16777215 16777215 16777215 1383498170 4252665514 4291152600 4291744478 4291744478 4291744478 4291744478 4291744478 4291744478 4291087064 4235822507 1216120505 16777215 192187321 4033181089 4290232016 4290560980 4290560980 4290560980 4290560980 4290560980 4290560980 4290560980 4290560980 4290100687 3982914979 140541887 2623959968 4286746800 4289574859 4289574859 4289574859 4289574859 4289574859 4289574859 4289574859 4289574859 4289574859 4289574859 4286549679 2456319395 3579801242 4286353071 4288654533 4288654533 4288654533 4288654533 4288654533 4288654533 4288654533 4288654533 4288654533 4288654533 4286089901 3495980954 3965612183 4284709539 4286944951 4287011000 4287011000 4287011000 4287011000 4287011000 4287011000 4287011000 4287011000 4286813622 4284643746 3915280279 3915345555 4284973226 4284973226 4284973226 4284973226 4284973226 4284973226 4284973226 4284973226 4284973226 4284973226 4284973226 4284973226 3864947858 3512362887 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 4285500082 3428345476 2286835828 4285433514 4286026683 4286026683 4286026683 4286026683 4286026683 4286026683 4286026683 4286026683 4286026683 4286026683 4285235879 2152552048 187582022 3813958010 4286421439 4286553283 4286553283 4286553283 4286553283 4286553283 4286553283 4286553283 4286553283 4286355645 3763494776 187582022 16777215 959790667 4116343939 4286685122 4287014603 4287014603 4287014603 4287014603 4287014603 4287014603 4286619329 4099500930 926039117 16777215 16777215 16777215 908735550 3679148137 4285630628 4286882500 4287541204 4287541204 4286816707 4268787875 3645527655 892024127 16777215 16777215 16777215 16777215 16777215 169482778 1798387264 3040494156 3679082084 3662239075 3023716940 1798452800 169482778 16777215 16777215 16777215)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 10/3/2008 13:22'!
newScrollbarThumbBottomForm
	"Answer the form for the bottom of a scrollbar thumb."

	^(Form
	extent: 13@7
	depth: 32
	fromArray: #( 4284182411 4287142063 4287931577 4287602613 4287208113 4286879149 4286484649 4286155685 4285761185 4285432221 4285103257 4284577427 4282669690 4284182411 4286287012 4287931577 4287602613 4287208113 4286879149 4286484649 4286155685 4285761185 4285432221 4285103257 4284182670 4282669690 2906411633 4284445326 4287536820 4287602613 4287208113 4286879149 4286484649 4286155685 4285761185 4285432221 4285103257 4283261825 3023720303 2033601901 4284182411 4285037205 4287339698 4287208113 4286879149 4286484649 4286155685 4285761185 4285432221 4283919242 4282801275 2503363949 1149473452 2755548019 4284050825 4284248204 4285958562 4286681770 4286484649 4286155685 4285037464 4283656069 4282998397 3023720559 1262704758 0 422725477 2083867754 2671004523 4283787654 4283656068 4283656325 4283392897 4283195776 3023786609 2688176497 926700403 73298833 0 0 0 1345735788 1999981163 2671004523 2671004523 2671004523 2167753578 1580616556 171134054 0 0)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 10/3/2008 13:22'!
newScrollbarThumbHorizontalMiddleForm
	"Answer the form for the middle of a horizontal scrollbar thumb."

	^(Form
	extent: 1@13
	depth: 32
	fromArray: #( 4284182411 4288326078 4287931577 4287602613 4287208113 4286879149 4286484649 4286155685 4285761185 4285432221 4285103257 4284709013 4282669690)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 10/3/2008 13:22'!
newScrollbarThumbLeftForm
	"Answer the form for the left hand side of a scrollbar thumb."

	^(Form
	extent: 7@13
	depth: 32
	fromArray: #( 0 0 1149473452 2033601901 2906411633 4284182411 4284182411 0 422725477 2755548019 4284182411 4284445326 4286287012 4287142063 0 2083867754 4284050825 4285037205 4287536820 4287931577 4287931577 1345735788 2671004523 4284248204 4287339698 4287602613 4287602613 4287602613 1999981163 4283787654 4285958562 4287208113 4287208113 4287208113 4287208113 2671004523 4283656068 4286681770 4286879149 4286879149 4286879149 4286879149 2671004523 4283656325 4286484649 4286484649 4286484649 4286484649 4286484649 2671004523 4283392897 4286155685 4286155685 4286155685 4286155685 4286155685 2167753578 4283195776 4285037464 4285761185 4285761185 4285761185 4285761185 1580616556 3023786609 4283656069 4285432221 4285432221 4285432221 4285432221 171134054 2688176497 4282998397 4283919242 4285103257 4285103257 4285103257 0 926700403 3023720559 4282801275 4283261825 4284182670 4284577427 0 73298833 1262704758 2503363949 3023720303 4282669690 4282669690)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 10/3/2008 13:22'!
newScrollbarThumbRightForm
	"Answer the form for the right hand side of a scrollbar thumb."

	^(Form
	extent: 7@13
	depth: 32
	fromArray: #( 4284182411 4284182411 2587118699 1396330353 211462590 0 0 4287010734 4285629341 4284182411 4284182411 2033601901 0 0 4287931577 4287931577 4286682026 4284313740 4284050825 1261587049 0 4287602613 4287602613 4287602613 4286418855 4283919239 2587118699 422725477 4287208113 4287208113 4287208113 4287208113 4284971669 4283787654 1345735788 4286879149 4286879149 4286879149 4286879149 4285629597 4283656068 1832209003 4286484649 4286484649 4286484649 4286484649 4285695391 4283458947 1999981163 4286155685 4286155685 4286155685 4286155685 4285169048 4283392897 1916095595 4285761185 4285761185 4285761185 4285761185 4284379535 4283195776 1345735788 4285432221 4285432221 4285432221 4285037464 4283195775 2671004523 758270315 4285103257 4285103257 4284905878 4283327362 4282998397 1664502380 0 4284380048 4283853961 4282932861 4282801275 2419477869 171134054 0 4282669690 4282669690 2755021932 2436846708 322261099 0 0)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 10/3/2008 13:22'!
newScrollbarThumbTopForm
	"Answer the form for the top of a scrollbar thumb."

	^(Form
	extent: 13@7
	depth: 32
	fromArray: #( 0 0 0 422725477 1345735788 1832209003 1999981163 1916095595 1345735788 758270315 0 0 0 0 0 1261587049 2587118699 4283787654 4283656068 4283458947 4283392897 4283195776 2671004523 1664502380 171134054 0 211462590 2033601901 4284050825 4283919239 4284971669 4285629597 4285695391 4285169048 4284379535 4283195775 4282998397 2419477869 322261099 1396330353 4284182411 4284313740 4286418855 4287208113 4286879149 4286484649 4286155685 4285761185 4285037464 4283327362 4282801275 2436846708 2587118699 4284182411 4286682026 4287602613 4287208113 4286879149 4286484649 4286155685 4285761185 4285432221 4284905878 4282932861 2755021932 4284182411 4285629341 4287931577 4287602613 4287208113 4286879149 4286484649 4286155685 4285761185 4285432221 4285103257 4283853961 4282669690 4284182411 4287010734 4287931577 4287602613 4287208113 4286879149 4286484649 4286155685 4285761185 4285432221 4285103257 4284380048 4282669690)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'initialize-release' stamp: 'gvc 10/3/2008 13:22'!
newScrollbarThumbVerticalMiddleForm
	"Answer the form for the middle of a vertical scrollbar thumb."

	^(Form
	extent: 13@1
	depth: 32
	fromArray: #( 4284182411 4288326078 4287931577 4287602613 4287208113 4286879149 4286484649 4286155685 4285761185 4285432221 4285103257 4284709013 4282669690)
	offset: 0@0)! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'GaryChambers 2/15/2011 12:52'!
paneColorFor: aWindow
	"Answer the pane color that should be used."
	
	^self settings fadedBackgroundWindows
		ifTrue: [aWindow fillStyleToUse asColor]
		ifFalse: [(self windowActiveFillStyleFor: aWindow) asColor]! !

!UIThemeWatery2 methodsFor: 'border-styles-buttons' stamp: 'gvc 12/8/2008 19:15'!
radioButtonCornerStyleFor: aRadioButton
	"Answer the corner style for radio buttons.
	Answer square when not disabled since the form is rounded."
	
	^aRadioButton enabled
		ifTrue: [#square]
		ifFalse: [#rounded]! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 12/9/2008 13:10'!
radioButtonDisabledFillStyleFor: aRadioButton
	"Return the disabled radio button fillStyle for the given button."
	
	^self radioButtonNormalFillStyleFor: aRadioButton! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 18:40'!
radioButtonForm
	"Answer the form to use for a normal radio button."

	^self forms at: #radioButton ifAbsent: [Form extent: 14@14 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 12/8/2008 18:41'!
radioButtonNormalFillStyleFor: aRadioButton
	"Return the normal radio button fillStyle for the given button."
	
	^(ImageFillStyle form: self radioButtonForm) origin: aRadioButton topLeft! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 12/9/2008 13:11'!
radioButtonSelectedDisabledFillStyleFor: aRadioButton
	"Return the selected disabled radio button fillStyle for the given button."
	
	^self radioButtonNormalFillStyleFor: aRadioButton! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 12/8/2008 18:42'!
radioButtonSelectedFillStyleFor: aRadioButton
	"Return the selected radio button fillStyle for the given button."
	
	^(ImageFillStyle form: self radioButtonSelectedForm) origin: aRadioButton topLeft! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 12/8/2008 18:40'!
radioButtonSelectedForm
	"Answer the form to use for a selected radio button."

	^self forms at: #radioButtonSelected ifAbsent: [Form extent: 14@14 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'border-styles' stamp: 'gvc 1/27/2009 16:44'!
scrollPaneNormalBorderStyleFor: aScrollPane
	"Return the normal borderStyle for the given scroll pane."

	^BorderStyle simple
		width: 1;
		baseColor: aScrollPane paneColor! !

!UIThemeWatery2 methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 2/3/2009 14:28'!
scrollbarImageColorFor: aScrollbar
	"Return the scrollbar image colour (on buttons) for the given scrollbar."
	
	^(self baseScrollbarColorFor: aScrollbar) darker! !

!UIThemeWatery2 methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 2/3/2009 14:28'!
scrollbarNormalButtonFillStyleFor: aScrollbar
	"Return the normal scrollbar button fillStyle for the given scrollbar."
	
	|c|
	c := self baseScrollbarColorFor: aScrollbar.
	^(GradientFillStyle ramp: {0.0->c twiceLighter. 1.0->c darker})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeWatery2 methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 2/3/2009 14:29'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	|aColor c|
	aColor := (self baseScrollbarColorFor: aScrollbar) muchLighter.
	c := aColor alphaMixed: 0.9 with: Color black.
	^(GradientFillStyle ramp: {0.0->c. 0.15->aColor. 0.75-> aColor lighter. 1.0->c})
		origin: aScrollbar topLeft;
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0]);
		radial: false! !

!UIThemeWatery2 methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 10/3/2008 13:32'!
scrollbarNormalHorizontalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar horizontal thumb fillStyle for the given scrollbar."
	
	|s l m r|
	s := aScrollbar slider.
	l := self scrollbarThumbLeftForm.
	m := self scrollbarThumbHorizontalMiddleForm.
	r := self scrollbarThumbRightForm.
	^CompositeFillStyle fillStyles: {
		(ImageFillStyle form: l) origin: s topLeft.
		(AlphaInfiniteForm with: m)
			origin: s topLeft + (l width@0);
			extent: (s width - l width - r width)@m height.
		(ImageFillStyle form: r)
			origin: s topRight - (r width@0)}! !

!UIThemeWatery2 methodsFor: 'border-styles-scrollbars' stamp: 'gvc 10/3/2008 11:45'!
scrollbarNormalThumbBorderStyleFor: aScrollbar
	"Return the normal thumb borderStyle for the given scrollbar."

	^BorderStyle simple width: 0! !

!UIThemeWatery2 methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 10/3/2008 13:33'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar thumb fillStyle for the given scrollbar."
	
	^aScrollbar bounds isWide
		ifTrue: [self scrollbarNormalHorizontalThumbFillStyleFor: aScrollbar]
		ifFalse: [self scrollbarNormalVerticalThumbFillStyleFor: aScrollbar]! !

!UIThemeWatery2 methodsFor: 'fill-styles-scrollbars' stamp: 'gvc 10/3/2008 13:30'!
scrollbarNormalVerticalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar vertical thumb fillStyle for the given scrollbar."
	
	|s t m b|
	s := aScrollbar slider.
	t := self scrollbarThumbTopForm.
	m := self scrollbarThumbVerticalMiddleForm.
	b := self scrollbarThumbBottomForm.
	^CompositeFillStyle fillStyles: {
		(ImageFillStyle form: t) origin: s topLeft.
		(AlphaInfiniteForm with: m)
			origin: s topLeft + (0@t height);
			extent: m width@(s height - t height - b height).
		(ImageFillStyle form: b)
			origin: s bottomLeft - (0@b height)}! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'gvc 10/3/2008 13:05'!
scrollbarThickness
	"Answer the width or height of a scrollbar as appropriate to
	its orientation."
	
	^13! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/3/2008 13:28'!
scrollbarThumbBottomForm
	"Answer the form to use for the bottom of a vertical scrollbar."

	^self forms at: #sbVThumbBottom ifAbsent: [Form extent: 13@7 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'border-styles-scrollbars' stamp: 'gvc 10/3/2008 12:30'!
scrollbarThumbCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^#square! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/3/2008 13:28'!
scrollbarThumbHorizontalMiddleForm
	"Answer the form to use for the middle of a horizontal scrollbar."

	^self forms at: #sbHThumbMiddle ifAbsent: [Form extent: 1@13 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/3/2008 13:26'!
scrollbarThumbLeftForm
	"Answer the form to use for the left of a horizontal scrollbar."

	^self forms at: #sbHThumbLeft ifAbsent: [Form extent: 7@13 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/3/2008 13:27'!
scrollbarThumbRightForm
	"Answer the form to use for the right of a horizontal scrollbar."

	^self forms at: #sbHThumbRight ifAbsent: [Form extent: 7@13 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/3/2008 13:28'!
scrollbarThumbTopForm
	"Answer the form to use for the top of a vertical scrollbar."

	^self forms at: #sbVThumbTop ifAbsent: [Form extent: 13@7 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/3/2008 13:28'!
scrollbarThumbVerticalMiddleForm
	"Answer the form to use for the middle of a vertical scrollbar."

	^self forms at: #sbVThumbMiddle ifAbsent: [Form extent: 13@1 depth: Display depth]! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 2/14/2009 18:49'!
tabLabelNormalFillStyleFor: aTabLabel
	"Return the normal fillStyle for the given tab label."
	
	|round roundCorners tl t tr l m r|
	round := aTabLabel wantsRoundedCorners.
	roundCorners := aTabLabel roundedCorners.
	tl := (round and: [roundCorners includes: 1]) ifTrue: [self buttonTopLeftForm] ifFalse: [self buttonSquareTopLeftForm].
	t := self buttonTopMiddleForm.
	tr := (round and: [roundCorners includes: 4]) ifTrue: [self buttonTopRightForm] ifFalse: [self buttonSquareTopRightForm].
	l := self buttonMiddleLeftForm. m := Color r: 211 g: 211 b: 211 range: 255. r := self buttonMiddleRightForm.
	^self
		multiFormTopFillStyleFrom: {tl. t. tr. l. m. r}
		in: aTabLabel bounds! !

!UIThemeWatery2 methodsFor: 'fill-styles-buttons' stamp: 'gvc 2/14/2009 18:49'!
tabLabelSelectedFillStyleFor: aTabLabel
	"Return the selected fillStyle for the given tab label."
	
	|round roundCorners tl t tr l m r|
	round := aTabLabel wantsRoundedCorners.
	roundCorners := aTabLabel roundedCorners.
	tl := (round and: [roundCorners includes: 1]) ifTrue: [self buttonSelectedTopLeftForm] ifFalse: [self buttonSquareSelectedTopLeftForm].
	t := self buttonSelectedTopMiddleForm.
	tr := (round and: [roundCorners includes: 4]) ifTrue: [self buttonSelectedTopRightForm] ifFalse: [self buttonSquareSelectedTopRightForm].
	l := self buttonSelectedMiddleLeftForm. m := Color r: 102 g: 127 b: 168 range: 255. r := self buttonSelectedMiddleRightForm.
	^self
		multiFormTopFillStyleFrom: {tl. t. tr. l. m. r}
		in: aTabLabel bounds! !

!UIThemeWatery2 methodsFor: 'border-styles' stamp: 'gvc 1/12/2009 18:28'!
tabPanelBorderStyleFor: aTabGroup
	"Answer the normal border style for a tab group."

	^TabPanelBorder new
		width: 1;
		baseColor: (aTabGroup paneColor alphaMixed: 0.8 with: Color black);
		tabSelector: aTabGroup tabSelectorMorph! !

!UIThemeWatery2 methodsFor: 'defaults' stamp: 'gvc 1/14/2009 15:32'!
tabSelectorCellInsetFor: aTabSelector
	"Answer the cell inset to use for the given tab selector."

	^0! !

!UIThemeWatery2 methodsFor: 'basic-colors' stamp: 'MarcusDenker 12/11/2009 09:36'!
taskbarButtonLabelColorFor: aButton
	"Answer the colour for the label of the given taskbar button."

	^aButton model
		ifNil: [super taskbarButtonLabelColorFor: aButton]
		ifNotNil: [:win |
			win isActive
				ifTrue: [self selectionColor darker]
				ifFalse: [super taskbarButtonLabelColorFor: aButton]]! !

!UIThemeWatery2 methodsFor: 'accessing' stamp: 'gvc 2/16/2009 17:24'!
windowActiveDropShadowStyle
	"Answer the style of drop shadow to use for active windows."
	
	^windowActiveDropShadowStyle! !

!UIThemeWatery2 methodsFor: 'accessing' stamp: 'gvc 2/16/2009 17:22'!
windowActiveDropShadowStyle: anObject
	"Set the value of windowActiveDropShadowStyle"

	windowActiveDropShadowStyle := anObject! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'gvc 10/7/2008 12:26'!
windowActiveTitleFillStyleFor: aWindow
	"Return the window active title fillStyle for the given window."
	
	|aColor|
	aColor := self windowColor.
	^(GradientFillStyle ramp: {
			0.0->aColor twiceLighter.
			1.0->aColor})	
		origin: aWindow labelArea topLeft;
		direction: 0 @ aWindow labelHeight;
		radial: false! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'GaryChambers 2/15/2011 12:47'!
windowInactiveFillStyleFor: aWindow
	"Return the window inactive fillStyle for the given window."
	
	^self settings fadedBackgroundWindows
		ifTrue: [self windowColor muchLighter]
		ifFalse: [self windowColor]
! !

!UIThemeWatery2 methodsFor: 'fill-styles' stamp: 'AlainPlantec 10/23/2010 17:44'!
windowInactiveTitleFillStyleFor: aWindow
	"Return the window inactive title fillStyle for the given window."
	
	|aColor|
	aColor := self windowInactiveFillStyleFor: aWindow.
	^(GradientFillStyle ramp: {
			0.0->aColor twiceLighter.
			1.0->aColor})	
		origin: aWindow labelArea topLeft;
		direction: 0 @ aWindow labelHeight;
		radial: false! !

!MouseEvent methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/28/2008 13:14'!
isMouseWheel
	"Answer whether the receiver is a mouse wheel event."
	
	^false! !

!TopRightGripMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/12/2007 10:53'!
containsPoint: aPoint
	"Answer true only if on edges."
	
	|w|
	^(super containsPoint: aPoint) and: [
		w := SystemWindow borderWidth.
		((self bounds translateBy: w negated@w)
			containsPoint: aPoint) not]! !

!TopRightGripMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 5/13/2008 10:21'!
drawOn: aCanvas
	"Draw the grip on the given canvas."

	| dotBounds alphaCanvas windowBorderWidth dotBounds2 |
	
	self shouldDraw ifFalse: [^self].

	windowBorderWidth := SystemWindow borderWidth.
	alphaCanvas := aCanvas asAlphaBlendingCanvas: 0.7.	
	"alphaCanvas
		frameRectangle: bounds color: Color blue."

	dotBounds := self bounds.
	dotBounds2 := dotBounds left: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.
	
	dotBounds2 := dotBounds right: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 left: (dotBounds2 left + 7).
	dotBounds2 := dotBounds2 right: (dotBounds2 right - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor.

	dotBounds2 := dotBounds left: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 top + windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 top: (dotBounds2 top + 7).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor! !

!BorderedMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/9/2006 15:50'!
colorForInsets
	"Return the color to be used for shading inset borders."
	
	self owner isSystemWindow
		ifTrue: [^self owner colorForInsets].
	^super colorForInsets! !

BorderedMorph subclass: #IdentifierChooserMorph
	instanceVariableNames: 'requestor labels choiceMenus chooseBlock maxLines choicesMorph scrollPaneWidth baseColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!IdentifierChooserMorph commentStamp: 'AlainPlantec 11/29/2010 10:50' prior: 0!
An IdentifierChooserMorph is a menu builder which takes a list of labels as input and build/popup  a menu for them. The morph could be made of one menu in one column for all labels of of several menus in a scrollabe row. The action which is performed when a menu item is selected is also parametrized (see examples below).
The morph can take the keyboard focus and then, up, down, left and right arrows can be used to choose a menu item.
It is the responsibility of the user of this morph to decide when and how the keyboard focus is token.
The design is widely inpired from PopupChoiceDialogWindow.

example 1
A very simple example with three label. The nil value will be represented as a menu line in the resulting morph.
(IdentifierChooserMorph 
		labels: {'aaaaaa'. 'bbbbbbb'. nil. 'cccccccc'}
		chooseBlock: [ :chosen | UIManager default inform: (chosen, (' has been chosen' translated))])
			open
			
example 2
The same except that a color is specified		
(IdentifierChooserMorph 
		labels: {'aaaaaa'. 'bbbbbbb'. nil. 'cccccccc'}
		chooseBlock: [ :chosen | UIManager default inform: (chosen, (' has been chosen' translated))])
			baseColor: Color white;
			open

example 3
Allows the presentation of one menu (one column) vith two fixed labels followed by the list of all classes.
(IdentifierChooserMorph 
		labels: ({'aaaaaa'. 'bbbbbbb'}, { nil }, (Object allSubclasses collect: [:c | c theNonMetaClass  name]) asSet asArray sort)
		chooseBlock: [ :chosen | (Smalltalk globals at: chosen asSymbol) ifNotNil: [:c | c browse] ]) 
			oneMenuOfWidth: 300;
			baseColor: Color white;
			open

Instance Variables
	baseColor:		<Color>
	choiceMenus:		<Array>
	choicesMorph:		<AlignmentMorph>
	chooseBlock:		<Block>
	labels:		<Array>
	maxLines:		<Integer>
	requestor:		<Morph>
	scrollPaneWidth:		<Integer>

baseColor
	- The color used for the menu items and the receiver

choiceMenus
	- The array of EmbeddedMenuMorph

choicesMorph
	- The AlignmentMorph which contains all menus

chooseBlock
	- A block with one argument which is evaluated when a menu item is selected. The argument takes the chosen label as argument

labels
	- The array of labels 

maxLines
	- If not nil, gives the maximum number of lines for one menu

requestor
	- if not nil, a Morph from which the receiver is built

scrollPaneWidth
	- The maximum width of the scrollPane, this contraints the width of the receiver.
!

!IdentifierChooserMorph class methodsFor: 'accessing' stamp: 'AlainPlantec 11/29/2010 10:52'!
allowedArea
	"The area allowed for the building and positioning of the morph"
	| allowedArea |
	allowedArea := Display usableArea.
	allowedArea := allowedArea intersect: World visibleClearArea.
	^allowedArea! !

!IdentifierChooserMorph class methodsFor: 'instance creation' stamp: 'AlainPlantec 11/29/2010 10:51'!
labels: aCollection chooseBlock: aBlock
	"return a new chooser or nil"
	^ aCollection isEmpty
		ifFalse: [ self new chooseBlock: aBlock; labels: aCollection; yourself].
! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/29/2010 10:53'!
activate: evt
	"Backstop."
	! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2010 09:33'!
allowedArea
	^ self class allowedArea! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/29/2010 09:22'!
baseColor
	^ baseColor ifNil: [baseColor := self defaultBaseColor]! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/29/2010 09:23'!
baseColor: aColor
	baseColor := aColor.
	self setColor: aColor! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/21/2010 13:41'!
choiceMenuItems
	"Answer the value of choiceMenus"

	^ Array streamContents: [:strm | self choiceMenus  do: [:menu | strm nextPutAll: menu menuItems]].
! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/21/2010 13:41'!
choiceMenus
	"Answer the value of choiceMenus"

	^ choiceMenus! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/21/2010 13:41'!
choiceMenus: anObject
	"Set the value of choiceMenus"

	choiceMenus := anObject! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/21/2010 18:59'!
choicesMorph: aMorph
	choicesMorph := aMorph! !

!IdentifierChooserMorph methodsFor: 'action' stamp: 'AlainPlantec 11/26/2010 18:22'!
choose: index
	"Set the given choice and ok."
	| chosen |
	chosen := index > 0 ifTrue: [self labels at: index] ifFalse: [nil].
	chooseBlock value: chosen.
	self close.
	requestor ifNotNil: [requestor takeKeyboardFocus]
! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/21/2010 14:02'!
chooseBlock: aBlock
	chooseBlock := aBlock! !

!IdentifierChooserMorph methodsFor: 'action' stamp: 'AlainPlantec 11/26/2010 16:54'!
close
	self delete.
! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/29/2010 09:12'!
defaultBaseColor
	^ Color transparent! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/21/2010 13:41'!
deleteIfPopUp: evt
	"For compatibility with MenuMorph."! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/26/2010 09:54'!
forcesHeight: aHeight
	| sp |
	(sp := self scrollPane) minHeight: aHeight.
	sp height: sp minHeight.
 	self height: sp height. ! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/21/2010 13:41'!
handlesKeyboard: evt
	"True when either the filter morph doesn't have the focus and the key
	is a text key or backspace or no menus have the focus and is up or down arrow."
	^(super handlesKeyboard: evt) or: [
		(self hasKeyboardFocus)
			ifTrue: [	evt keyCharacter = Character escape
						or: [evt keyCharacter = Character cr
						or: [evt keyCharacter = Character arrowLeft
						or: [evt keyCharacter = Character arrowRight
						or: [evt keyCharacter = Character arrowUp
						or: [evt keyCharacter = Character arrowDown]]]]]]
			ifFalse: [	evt keyCharacter = Character escape
						or: [evt keyCharacter = Character arrowUp
						or: [evt keyCharacter = Character arrowDown
						or: [evt keyCharacter = Character arrowLeft
						or: [evt keyCharacter = Character arrowRight]]]]]]! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/29/2010 09:27'!
initialize
	super initialize.
	self borderWidth: 1.
	self layoutInset: 0@0.
	self changeTableLayout.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	self color: self defaultBaseColor.
! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/26/2010 16:55'!
keyStroke: anEvent
	anEvent keyCharacter = Character escape 
		ifTrue: [self close. 
			requestor 
				ifNotNil: [requestor takeKeyboardFocus]. 
				^true].
	anEvent keyCharacter = Character arrowUp ifTrue: [self selectPreviousItem. ^true].
	anEvent keyCharacter = Character arrowDown ifTrue: [self selectNextItem. ^true].
	anEvent keyCharacter = Character arrowLeft ifTrue: [self switchToPreviousColumn. ^true].
	anEvent keyCharacter = Character arrowRight ifTrue: [self switchToNextColumn. ^true].
	(anEvent keyCharacter ~= Character cr 
		and: [anEvent keyCharacter < Character space]) ifTrue: [^false]. "ignore pageup/down etc."
	(anEvent keyCharacter = Character space or: [ anEvent keyCharacter = Character cr]) 
		ifTrue: [ ^self processEnter: anEvent ].
	^false! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/21/2010 13:41'!
labels
	"Answer the value of labels"

	^ labels! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/29/2010 10:55'!
labels: aCollectionOfString
	"Set the value of labels"
	labels := aCollectionOfString! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2010 09:00'!
listHeight
	"Answer the height for the list."

	^ choicesMorph height! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2010 09:01'!
listMorph
	"Answer the height for the list."

	^ choicesMorph! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/21/2010 16:31'!
maxLines
	^ maxLines ifNil: [maxLines := 6]! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/21/2010 16:32'!
maxLines: anInteger
	maxLines := anInteger! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/29/2010 09:24'!
newChoiceButtonFor: index
	"Answer a new choice button."
	^ (self labels at: index) 
		ifNotNil: [:v | (ToggleMenuItemMorph new
			contents: v asText;
			target: self;
			selector: #choose:;
			arguments: {index})
			cornerStyle: #square;
			hResizing: #spaceFill]
		ifNil: [MenuLineMorph new]
		! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/25/2010 09:24'!
newChoicesMorph
	"Answer a row of columns of buttons and separators based on the model."

	| answer morphs str  |
	answer := self newRow
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self labels ifEmpty: [^answer].
	self labels first isNil
		ifTrue: [self labels: self labels allButFirst].
	self labels ifEmpty: [^answer].
	self labels last isNil
		ifTrue: [self labels: self labels allButLast].
	self labels ifEmpty: [^answer].
	morphs := OrderedCollection new.
	1 to: self labels size do: [:i |
		morphs add: (self newChoiceButtonFor: i)].
	str := morphs readStream.
	[str atEnd] whileFalse: [
		answer
			addMorphBack: (self newMenuWith: (str next: self maxLines));
			addMorphBack: self newVerticalSeparator].
	answer removeMorph: answer submorphs last.
	answer submorphs last hResizing: #spaceFill.
	scrollPaneWidth ifNotNil: [answer hResizing: #spaceFill. answer submorphs last hResizing: #rigid. answer submorphs last width: scrollPaneWidth].
	self choiceMenus: (answer submorphs select: [:m| m isKindOf: MenuMorph]).
	^answer! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/29/2010 09:01'!
newContentMorph
	"Answer a new content morph."

	| sp choices |
	self choicesMorph: (choices := self newChoicesMorph).
	sp := (self newScrollPaneFor: choices)
		color: Color transparent;
		scrollTarget: choices;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	sp
		minWidth: (scrollPaneWidth ifNil: [(choicesMorph width min: (Display width // 2) - 50) + sp scrollBarThickness]);
		minHeight: (choicesMorph height min: (Display height // 3)).
	choicesMorph width > sp minWidth
		ifTrue: [sp minHeight: sp minHeight + sp scrollBarThickness].
	^ sp! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/21/2010 22:04'!
newMenu 
	^ self theme
		newEmbeddedMenuIn: self
		for: self! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/29/2010 09:26'!
newMenuWith: menuItems
	"Answer menu with the given morphs."

	| menu |
	menu := self newMenu.
	menu cornerStyle: #square.
	menuItems do: [:m | menu addMenuItem: m].
	menu
		borderWidth: 0;
		color: self baseColor;
		borderColor:  Color transparent;
		stayUp: true;
		beSticky;
		removeDropShadow;
		popUpOwner: (MenuItemMorph new privateOwner: self).
	^ menu! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/21/2010 13:41'!
newRow
	^ AlignmentMorph new
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		extent: 1@1;
		borderWidth: 0;
		color: Color transparent.
! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/21/2010 13:41'!
newScrollPaneFor: aMorph
	^ self theme
		newScrollPaneIn: self
		for: aMorph! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/21/2010 13:41'!
newVerticalSeparator

	^ SeparatorMorph new
		fillStyle: Color transparent;
		borderStyle: (BorderStyle inset baseColor: Color gray; width: 1);
		extent: 1@1;
		vResizing: #spaceFill! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/27/2010 12:41'!
oneMenuOfWidth: anInteger
	self maxLines: 999999999.
	scrollPaneWidth := anInteger.
! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/29/2010 09:24'!
open
	self addMorph: self newContentMorph.
	self openInWorld.
! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/21/2010 13:41'!
processEnter: anEvent
	self choiceMenus do: [:embeddedMenu | 
		embeddedMenu selectedItem ifNotNil: [:item |
			item invokeWithEvent: anEvent.
			^true ] ].
	^false! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2010 16:54'!
requestor
	^ requestor! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2010 16:32'!
requestor: aTextMorph
	requestor := aTextMorph! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/21/2010 13:41'!
scrollPane
	"Answer the scroll pane."

	^self findDeeplyA: GeneralScrollPane! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/21/2010 13:41'!
selectFirstItem
	"Select the first item in the embedded menus"

	self choiceMenus first selectItem:  self choiceMenuItems first event: nil.
	self activeHand newKeyboardFocus: self.! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/21/2010 13:41'!
selectLastItem
	"Select the last item in the embedded menus"

	self choiceMenus last selectItem:  self choiceMenuItems last event: nil.
	self activeHand newKeyboardFocus: self.
! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/24/2010 21:44'!
selectNextItem
	"Select the next item in the embedded menus"

	| idx next |
	self choiceMenus 
		do: [:embeddedMenu | embeddedMenu menuItems 
			do: [:mi | ((mi isKindOf: MenuItemMorph)  and: [mi isSelected])
				ifTrue: [idx := embeddedMenu menuItems indexOf: mi.
					idx = embeddedMenu menuItems size
						ifTrue: [idx := 0].
					idx := idx + 1. 
					[(embeddedMenu menuItems at: idx) isKindOf: MenuItemMorph]
						whileFalse: [idx := idx+ 1].
					next := embeddedMenu menuItems at: idx.
					self activeHand newKeyboardFocus: self.
					self scrollPane ifNotNil: [:sp | sp scrollToShow: next bounds].
					^ embeddedMenu selectItem: next event: nil]]].
	self selectFirstItem! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/24/2010 21:44'!
selectPreviousItem
	"Select the previous item in the embedded menus"

	| idx previous |
	self choiceMenus 
		do: [:embeddedMenu | embeddedMenu menuItems 
			do: [:mi | ((mi isKindOf: MenuItemMorph)  and: [mi isSelected])
				ifTrue: [idx := embeddedMenu menuItems indexOf: mi.
					idx = 1
						ifTrue: [idx := embeddedMenu menuItems size + 1].
					idx := idx - 1. 
					[(embeddedMenu menuItems at: idx) isKindOf: MenuItemMorph]
						whileFalse: [idx := idx- 1].
					previous := embeddedMenu menuItems at: idx.
					self scrollPane ifNotNil: [:sp | sp scrollToShow: previous bounds].
					^ embeddedMenu selectItem: previous event: nil]]].
	self selectFirstItem.
! !

!IdentifierChooserMorph methodsFor: 'ui-building' stamp: 'AlainPlantec 11/29/2010 09:08'!
setColor: aColor
	self color: aColor.
	self choiceMenus 
		ifNotNil: [:menus | menus 
			do: [:cm | cm color: aColor]]! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/21/2010 13:41'!
switchToNextColumn
	"Give the next embedded menu keyboard focus."

	self switchToOtherColumn: [:prevIdx | 
		prevIdx =  self choiceMenus size
				ifTrue: [1]
				ifFalse: [prevIdx + 1]]
! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/24/2010 21:36'!
switchToOtherColumn: aBlock
	"Give the next embedded menu keyboard focus. 
	The next menu indice is computed by the argument"

	| menuWithFocus idx menu sub subIdx |
	(self choiceMenus isNil or: [self choiceMenus isEmpty]) 
		ifTrue: [^self].
	menuWithFocus := self choiceMenus
		detect: [:m | m menuItems 
			anySatisfy: [:sm | 
				((sm isKindOf: MenuItemMorph)  and: [sm isSelected]) 
					ifTrue: [sub := sm]. 
				sm isSelected]]
		ifNone: [].
	self choiceMenus do: [:embeddedMenu | embeddedMenu selectItem: nil event: nil].
	menuWithFocus isNil
		ifTrue: [self selectFirstItem]
		ifFalse: [
			idx := aBlock value: (self choiceMenus indexOf: menuWithFocus).
			menu := (self choiceMenus at: idx).
			subIdx := sub ifNil: [1] ifNotNil: [(menuWithFocus menuItems indexOf: sub) min: menu menuItems size].
			menu selectItem: (menu menuItems at: subIdx) event: nil.
			self scrollPane ifNotNil: [:sp | sp scrollToShow: menu bounds]].
	self activeHand newKeyboardFocus: self.! !

!IdentifierChooserMorph methodsFor: 'event handling' stamp: 'AlainPlantec 11/21/2010 13:41'!
switchToPreviousColumn
	"Give the previous embedded menu keyboard focus."

	self switchToOtherColumn: [:prevIdx | 
		prevIdx =  1
			ifTrue: [self choiceMenus size]
			ifFalse: [prevIdx - 1]]
! !

!IdentifierChooserMorph methodsFor: 'accessing' stamp: 'AlainPlantec 11/21/2010 13:41'!
theme
		^ UITheme current! !

BorderedMorph subclass: #PanelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PanelMorph commentStamp: 'gvc 5/18/2007 12:38' prior: 0!
A container morph that tracks the owner's pane colour unless an explicit fillStyle is specified. Additionally allows hooking of mouseOver events (no button down).!

PanelMorph subclass: #ExpanderMorph
	instanceVariableNames: 'titleMorph announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ExpanderMorph commentStamp: 'gvc 5/18/2007 13:13' prior: 0!
A morph that can expand or collapse to show its contents.!

!ExpanderMorph class methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:54'!
titleText: aStringOrText
	"Answer a new instance of the receiver with the given title text."

	^self new titleText: aStringOrText! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 11:24'!
addedMorph: aMorph
	"Notify the receiver that the given morph was just added."

	aMorph == self titleMorph ifFalse: [
		self titleMorph ifNotNil: [
			aMorph
				visible: self expanded;
				disableTableLayout: self expanded not]]! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 13:46'!
announce: anAnnouncement
	"see Announcements packages.
	No need to announce if no subscribers."
	
	announcer ifNotNil: [announcer announce: anAnnouncement]! !

!ExpanderMorph methodsFor: 'accessing' stamp: 'GaryChambers 1/25/2011 13:48'!
announcer
	"Answer the receiver's announcer, creating if required."
	
	^ announcer ifNil: [ announcer := Announcer new ]! !

!ExpanderMorph methodsFor: 'accessing' stamp: 'GaryChambers 1/25/2011 13:40'!
announcer: anObject

	announcer := anObject! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:33'!
defaultTitleMorph
	"Answer a default title morph for the receiver."

	^ExpanderTitleMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 11:23'!
expanded
	"Answer whether the title is expanded."
	
	^self titleMorph expanded! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 11:23'!
expanded: aBoolean
	"Set whether the title is expanded."
	
	self titleMorph expanded: aBoolean! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/24/2011 13:23'!
expandedSizingRigid
	"Set the vResizing to be (temporarily) #rigid."

	self expanded ifTrue: [self vResizing: #rigid]! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/18/2006 11:57'!
fixLayout
	"Fix the owner layout, nasty!!"

	self owner ifNil: [^self].
	self owner allMorphsDo: [:m |
		(m respondsTo: #resetExtent) ifTrue: [		
			WorldState addDeferredUIMessage: 
				(MessageSend receiver: m selector: #resetExtent).
			WorldState addDeferredUIMessage: 
				(MessageSend receiver: m selector: #setScrollDeltas)].
		(m isKindOf: self class)
			ifTrue: [WorldState addDeferredUIMessage: 
				(MessageSend receiver: m selector: #adoptPaneColor)]].
	WorldState addDeferredUIMessage: 
				(MessageSend receiver: self owner selector: #changed)! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:29'!
font
	"Answer the title font"

	^self titleMorph font! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:30'!
font: aFont
	"Set the title font"

	self titleMorph font: aFont! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:37'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		changeTableLayout;
		listDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		titleMorph: self defaultTitleMorph! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 11:32'!
showMorphs: aBoolean
	"Hide/Show the other morphs."

	self submorphs do: [:m |
		m == self titleMorph ifFalse: [
			m
				visible: aBoolean;
				disableTableLayout: aBoolean not]]! !

!ExpanderMorph methodsFor: 'accessing' stamp: 'gvc 7/27/2006 10:30'!
titleMorph
	"Answer the value of titleMorph"

	^ titleMorph! !

!ExpanderMorph methodsFor: 'accessing' stamp: 'gvc 7/27/2006 10:35'!
titleMorph: aMorph
	"Set the value of titleMorph"

	titleMorph ifNotNil: [titleMorph delete; removeDependent: self].
	titleMorph := aMorph.
	aMorph ifNotNil: [
		aMorph addDependent: self.
		 self addMorph: aMorph]! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:55'!
titleText: aStringOrText
	"Set the text if the title morph is capable."

	(self titleMorph respondsTo: #titleText:)
		ifTrue: [self titleMorph titleText: aStringOrText]! !

!ExpanderMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 13:45'!
update: aspect
	"Update the receiver."

	aspect = #expanded
		ifTrue: [self vResizing: (self expanded
					ifTrue: [#spaceFill]
					ifFalse: [#shrinkWrap]).
				self showMorphs: self expanded.
				self fixLayout.
				self expanded
					ifTrue: [self announce: (ExpanderMorphExpanded on: self)]
					ifFalse: [self announce: (ExpanderMorphContracted on: self)]]! !

PanelMorph subclass: #ExpanderTitleMorph
	instanceVariableNames: 'labelMorph buttonMorph expanded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ExpanderTitleMorph commentStamp: 'gvc 5/18/2007 13:12' prior: 0!
The titlebar area for and ExpanderMorph. Includes title label and expand/collapse button.!

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/23/2009 16:30'!
adoptPaneColor: paneColor
	"Update the fill styles, corner styles, label colour
	and expansion button indicator."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self normalFillStyle.
	self borderStyle baseColor: paneColor twiceDarker.
	self buttonMorph cornerStyle: self cornerStyle.
	self labelMorph color: paneColor contrastingColor.
	self changed: #expandLabel! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'gvc 1/22/2009 15:37'!
buttonMorph
	"Answer the value of buttonMorph"

	^ buttonMorph! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'gvc 1/22/2009 15:37'!
buttonMorph: anObject
	"Set the value of buttonMorph"

	buttonMorph := anObject! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/17/2009 14:33'!
buttonWidth
	"Answer based on scrollbar size."
	
	^(self theme scrollbarThickness + 3)
		max: self theme expanderTitleControlButtonWidth! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/23/2006 16:46'!
defaultBorderStyle
	"Answer the default border style for the receiver."

	^BorderStyle raised width: 1! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/31/2009 16:41'!
expandLabel
	"Answer the label for the expand button."

	^AlphaImageMorph new image: (
		ScrollBar
			arrowOfDirection: (self expanded ifTrue: [#top] ifFalse: [#bottom])
			size: self buttonWidth - 3
			color: self paneColor darker)! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'gvc 7/27/2006 10:16'!
expanded
	"Answer the value of expanded"

	^ expanded! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'gvc 7/27/2006 10:24'!
expanded: aBoolean
	"Set the value of expanded"

	expanded := aBoolean.
	self
		changed: #expanded;
		changed: #expandLabel! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:29'!
font
	"Answer the label font"

	^((self labelMorph isKindOf: StringMorph) or: [self labelMorph isTextMorph])
		ifTrue: [self labelMorph font]! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:28'!
font: aFont
	"Set the label font"

	((self labelMorph isKindOf: StringMorph) or: [self labelMorph isTextMorph])
		ifTrue: [self labelMorph font: aFont]! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/22/2009 15:37'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		expanded: false;
		changeTableLayout;
		borderStyle: self defaultBorderStyle;
		layoutInset: (self theme expanderTitleInsetFor: self);
		listDirection: #leftToRight;
		listCentering: #center;
		wrapCentering: #center;
		buttonMorph: self newExpandButtonMorph;
		addMorph: self buttonMorph;
		labelMorph: self newLabelMorph;
		on: #mouseUp send: #toggleExpanded to: self! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'gvc 9/13/2006 10:23'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!ExpanderTitleMorph methodsFor: 'accessing' stamp: 'GaryChambers 7/27/2011 18:04'!
labelMorph: anObject
	"Set the value of labelMorph.
	need to wrap to provide clipping!!"

	labelMorph ifNotNil: [self removeMorph: labelMorph owner].
	labelMorph := anObject.
	labelMorph ifNotNil: [self addMorph: (
		Morph new
			color: Color transparent;
			changeTableLayout;
			layoutInset: 4 @ 0;
			listDirection: #leftToRight;
			listCentering: #center;
			hResizing: #spaceFill;
			vResizing: #shrinkWrap;
			clipSubmorphs: true;
			addMorph: labelMorph)]! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/22/2009 15:35'!
newExpandButtonMorph
	"Answer a new expand button."

	^(ControlButtonMorph
			on: self
			getState: nil
			action: #toggleExpanded
			label: #expandLabel)
		hResizing: #rigid;
		vResizing: #spaceFill;
		cornerStyle: self cornerStyle;
		extent: self buttonWidth asPoint! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/27/2011 17:10'!
newLabelMorph
	"Answer a new label morph for the receiver."

	^LabelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 14:28'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme expanderTitleNormalFillStyleFor: self! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/20/2010 11:59'!
themeChanged
	"Update the button corner style from default
	to match the receiver."
	
	super themeChanged.
	self buttonMorph cornerStyle: self cornerStyle! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/18/2006 11:15'!
titleText
	"Answer the text if the title morph is capable."

	^((self labelMorph isKindOf: StringMorph) or: [self labelMorph isTextMorph])
		ifTrue: [self labelMorph contents]
		ifFalse: ['']! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 10:24'!
titleText: aStringOrText
	"Set the text if the title morph is capable."

	((self labelMorph isKindOf: StringMorph) or: [self labelMorph isTextMorph])
		ifTrue: [self labelMorph contents: aStringOrText]! !

!ExpanderTitleMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:23'!
toggleExpanded
	"Toggle the expanded state."

	self expanded: self expanded not! !

PanelMorph subclass: #OverflowRowMorph
	instanceVariableNames: 'baseMorphs moreButton moreMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!OverflowRowMorph commentStamp: 'gvc 1/12/2010 13:32' prior: 0!
Instances of this class accept, via #baseMorph:, a morph that is expected to be row-like containing submorphs.
Based on the receiver's layout, the base morphs that are able to fit within the receiver (subject to minExtents) are layed out along with, if necessary, a button to pop-up a column of any remaining, unfittable, base morphs.
Handy for button bars etc.

Example:

(OverflowRowMorph new
	baseMorph: (UITheme builder newRow: ((1 to: 6) collect: [:i | |label|
		label := 'Button ', i asString.
		(UITheme builder
			newButtonFor: Transcript
			getState: nil
			action: #show:
			arguments: {label}
			getEnabled: nil
			label: label
			help: nil)
			hResizing: #spaceFill]))) openInWindow
		
	!

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/18/2010 16:41'!
adoptPaneColor: paneColor
	"Pass on to the list morph and border too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self moreButton cornerStyle: self cornerStyle.
	self changed: #moreButtonLabel.
	self moreMorphs do: [:m |
		m adoptPaneColor: paneColor]! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2010 18:55'!
baseMorph: aRowMorph
	"Configure the receiver to match the specifications for the given morph and
	store the given morph's submorphs for later reallocation."
	
	self baseMorphs: aRowMorph submorphs.
	self
		cellInset: aRowMorph cellInset;
		layoutInset: aRowMorph layoutInset;
		height: aRowMorph minExtent y;
		minHeight: self height.
	self fitBaseMorphs! !

!OverflowRowMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 19:13'!
baseMorphs
	"Answer the value of baseMorphs"

	^ baseMorphs! !

!OverflowRowMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 19:13'!
baseMorphs: anObject
	"Set the value of baseMorphs"

	baseMorphs := anObject! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2010 18:54'!
buttonWidth
	"Answer the width for the more button."

	^self theme scrollbarThickness + 3! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/1/2010 12:26'!
desiredMoreMorphPosition
	"Answer the position the more morph should be placed."

	^self moreButton boundsInWorld bottom + self moreMorph height > self world height
		ifTrue: [self moreButton boundsInWorld topRight - (self moreMorph width@self moreMorph height)]
		ifFalse: [self moreButton boundsInWorld bottomRight - (self moreMorph width@0)]! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/1/2010 13:53'!
extent: aPoint
	"Refit the base morphs and potential 'more' button'"

	super extent: aPoint.
	self fitBaseMorphs.
	WorldState addDeferredUIMessage: [self layoutChanged]
		"since possibly changing actual submorphs during layout processing"! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/1/2010 13:29'!
fitBaseMorphs
	"Replace the receiver's submorphs with the base morphs that
	can fit in the receiver's bounds. Critically, morphs must be replaced in
	one go to avoid #extent: recursion."

	|proposed|
	self hideMore.
	proposed := self newPotentialMorph.
	[proposed width <= self width or: [proposed submorphCount = 0]] whileFalse: [
		proposed
			removeMorph: proposed lastSubmorph;
			extent: proposed minExtent].
	proposed submorphCount < self baseMorphs size ifTrue: [
		self moreButton hResizing: #shrinkWrap.
		proposed
			addMorphBack: self moreButton;
			extent: proposed minExtent].
	[proposed width > self width and: [proposed submorphCount > 1]] whileTrue: [
		proposed
			removeMorph: (proposed submorphs at: proposed submorphs size - 1);
			extent: proposed minExtent].
	(proposed submorphCount = 1 and: [self moreButton owner notNil]) ifTrue: [
		self moreButton hResizing: #spaceFill].
	self
		removeAllMorphs;
		addAllMorphs: proposed submorphs
	! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 4/29/2011 00:37'!
hideMore
	"Hide the morphs that don't fit."

	self moreVisible ifTrue: [
		self moreMorph delete.
		WorldState addDeferredUIMessage: [self world ifNotNil: [:w |
				w invalidRect: self moreMorph bounds]]]! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/1/2010 15:01'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		baseMorphs: #();
		moreButton: self newMoreButton;
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #shrinkWrap! !

!OverflowRowMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 19:14'!
moreButton
	"Answer the value of moreButton"

	^ moreButton! !

!OverflowRowMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 19:14'!
moreButton: anObject
	"Set the value of moreButton"

	moreButton := anObject! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2010 18:35'!
moreButtonLabel
	"Answer the label for the more button."

	^AlphaImageMorph new image: (
		ScrollBar
			arrowOfDirection: #right
			size: self buttonWidth
			color: self paneColor darker)! !

!OverflowRowMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 20:01'!
moreMorph
	"Answer the value of moreMorph"

	^ moreMorph! !

!OverflowRowMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 20:01'!
moreMorph: anObject
	"Set the value of moreMorph"

	moreMorph := anObject! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/1/2010 15:02'!
moreMorphs
	"Answer those base morphs that are not currently part of the
	receiver's submorphs."

	^self baseMorphs
		ifEmpty: [#()]
		ifNotEmpty: [self baseMorphs copyFrom: self submorphs size to: self baseMorphs size]! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2010 12:48'!
moreVisible
	"Answer whether the more column is visible."

	^(self moreMorph ifNil: [^false]) owner notNil! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2010 13:14'!
newMoreButton
	"Answer a new button for popping up the base morphs that are currently
	unable to fit in the allotted space."

	^(ControlButtonMorph
			on: self
			getState: nil
			action: #popMore
			label: #moreButtonLabel)
		hResizing: #rigid;
		vResizing: #spaceFill;
		cornerStyle: #square;
		extent: self buttonWidth asPoint! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/12/2011 10:11'!
newPotentialMorph
	"Answer a morph for trialing potential layout."

	|potential|
	potential := self theme builder newRow: self baseMorphs.
	potential extent: potential minExtent.
	^potential! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2010 12:47'!
outOfWorld: aWorld
	"Get rid of the more column if visible."

	self hideMore.
	^super outOfWorld: aWorld! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/18/2010 15:25'!
popMore
	"Hide / show the unshown base morphs."

	(self moreMorph isNil or: [self moreMorph owner isNil])
		ifTrue: [self showMore]
		ifFalse: [self hideMore]! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/12/2011 10:11'!
recreateMoreMorph
	"Answer a new morph showing the undisplayed base morphs.
	Assign to moreMorph."

	self moreMorph: (self theme builder newColumn: self moreMorphs).
	self moreMorph
		setProperty: #morphicLayerNumber toValue: 6;
		layoutInset: 4;
		borderStyle: (self theme taskbarThumbnailNormalBorderStyleFor: self moreMorph);
		extent: self moreMorph minExtent;
		position: self desiredMoreMorphPosition;
		paneColor: self paneColor;
		color: self paneColor.
	^self moreMorph! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2010 18:37'!
showMore
	"Show the morphs that don't fit."

	self hideMore.
	self recreateMoreMorph.
	self world addMorphInLayer: self moreMorph! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 4/29/2011 00:37'!
step
	"Move the more column if it is showing."

	self moreVisible ifTrue: [
		self window ifNotNil: [:w |
			w isActive ifFalse: [self hideMore]].
		self moreMorph position = self desiredMoreMorphPosition
			ifFalse: [self hideMore]]! !

!OverflowRowMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2010 12:48'!
stepTime
	"Answer the desired time between steps in milliseconds."

	^100! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/11/2009 17:54'!
adoptPaneColor: paneColor
	"Change our color too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self assureExtension.
	extension fillStyle ifNil: [self color: paneColor].
	self borderStyle baseColor: paneColor darker! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/26/2006 17:31'!
defaultBorderWidth
	"Answer the default border width for the receiver."
	
	^0! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 7/27/2006 10:36'!
defaultColor
	"Answer the default color for the receiver."

	^Color transparent! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/20/2009 15:49'!
enabled: aBoolean
	"Pass on to submorphs."

	self submorphsDo: [:m |
		(m respondsTo: #enabled:) ifTrue: [
			m enabled: aBoolean]]! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/29/2011 15:29'!
handleMouseOver: anEvent
	"System level event handling."
	
	super handleMouseOver: anEvent.
	(self handlesMouseOver: anEvent) ifTrue:[
		anEvent wasHandled: true.
		self mouseOver: anEvent]! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/12/2007 10:49'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."

	^Color transparent! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 12:33'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		clipSubmorphs: true;
		beSticky "stop being grabbed"! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/4/2010 12:21'!
interactionState: aSymbol
	"Pass on to submorphs."

	self submorphsDo: [:m |
		(m respondsTo: #interactionState:) ifTrue: [
			m interactionState: aSymbol]]! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:26'!
mouseOver: anEvent
	"Handle a mouseOver event, meaning the mouse just moved within the receiver
	with no button pressed. The default response is to let my eventHandler, if any, handle it."

	self eventHandler ifNotNil:
		[self eventHandler mouseOver: anEvent fromMorph: self]! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:25'!
on: eventName send: selector to: recipient
	"Register a recipient for handling an event."
	
	self eventHandler ifNil: [self eventHandler: EventHandlerPlus new].
	self eventHandler on: eventName send: selector to: recipient! !

!PanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:26'!
on: eventName send: selector to: recipient withValue: value
	"Register a recipient for handling an event."
	
	self eventHandler ifNil: [self eventHandler: EventHandlerPlus new].
	self eventHandler on: eventName send: selector to: recipient withValue: value
! !

PanelMorph subclass: #PlainGroupboxMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PlainGroupboxMorph commentStamp: 'gvc 5/18/2007 12:36' prior: 0!
Groupbox without title with a vertical layout. Appears in a lighter colour than the owner's pane colour.!

!PlainGroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2008 11:45'!
adoptPaneColor: paneColor
	"Change our color too."
	
	super adoptPaneColor: (self theme subgroupColorFrom: paneColor).
	self borderStyle: (self theme plainGroupPanelBorderStyleFor: self)! !

!PlainGroupboxMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/17/2008 11:44'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		borderStyle: (self theme plainGroupPanelBorderStyleFor: self);
		changeTableLayout; 
		layoutInset: (4@4 corner: 4@4);
		cellInset: 8;
		vResizing: #spaceFill;
		hResizing: #spaceFill! !

!PlainGroupboxMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:41'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^super paneColorOrNil ifNotNil: [:c | self theme subgroupColorFrom: c]! !

PanelMorph subclass: #RowScrollerMorph
	instanceVariableNames: 'leftButton rightButton scroller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 16:51'!
adoptPaneColor: paneColor
	"Update the fill styles, corner styles, label colour
	and expansion button indicator."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self
		changed: #leftButtonLabel;
		changed: #rightButtonLabel! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 16:33'!
buttonWidth
	"Answer the width for a scroll button."

	^self theme scrollbarThickness + 3! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 16:57'!
checkButtonAvailability
	"Check whether the buttons should be visible."

	|currentIndex leftmostIndex leftVisible rightVisible|
	currentIndex := self currentMorphIndex.
	leftVisible := currentIndex ~= 1.
	self leftButton
		disableTableLayout: leftVisible not;
		visible: leftVisible.
	rightVisible := self scroller localSubmorphBounds right - self scroller offset x > self scroller width.
	self rightButton
		disableTableLayout: rightVisible not;
		visible: rightVisible.
	leftmostIndex := self leftmostFitableMorphIndex.
	(leftmostIndex > 0 and: [currentIndex >= leftmostIndex]) ifTrue: [
		self scroller offset: (self targetMorphs at: leftmostIndex) left@0]! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:11'!
currentMorphIndex
	"Answer the index of the target morph that is considered the current leftmost."

	|x index|
	x := self scroller offset x.
	index := 1.
	self targetMorphs do: [:m |
		(x between: m left and: m right) ifTrue: [^index].
		index := index + 1].
	^index! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:37'!
extent: aPoint
	"Set the extent of the receiver.
	Check whether the buttons should be visible."

	super extent: aPoint.
	self checkButtonAvailability! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:56'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		leftButton: self newLeftButton;
		rightButton: self newRightButton;
		scroller: self newScroller;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 2;
		addMorphBack: self leftButton;
		addMorphBack: self scroller;
		addMorphBack: self rightButton! !

!RowScrollerMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 12:45'!
leftButton
	"Answer the value of leftButton"

	^ leftButton! !

!RowScrollerMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 12:45'!
leftButton: anObject
	"Set the value of leftButton"

	leftButton := anObject! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 16:49'!
leftButtonLabel
	"Answer the label for a button for scrolling left."

	^AlphaImageMorph new image: (
		ScrollBar
			arrowOfDirection: #left
			size: self buttonWidth - 3
			color: self paneColor darker)! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 16:18'!
leftmostFitableMorphIndex
	"Answer the index of the target morph that, if the receiver was scrolled to
	would allow all remaining targets to fit in the current scroller bounds."

	|index scrollerWidth targetRight|
	index := self targetMorphs size + 1.
	scrollerWidth := self scroller width.
	targetRight := self scrollTarget right.
	self targetMorphs reverseDo: [:m |
		targetRight - m left > scrollerWidth ifTrue: [
			^index min: self targetMorphs size].
		index := index - 1].
	^index! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 16:48'!
newLeftButton
	"Answer a new button for scrolling left."

	^(ControlButtonMorph
			on: self
			getState: nil
			action: #scrollLeft
			label: #leftButtonLabel)
		hResizing: #rigid;
		vResizing: #spaceFill;
		cornerStyle: #square;
		extent: self buttonWidth asPoint! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 16:51'!
newRightButton
	"Answer a new button for scrolling right."

	^(ControlButtonMorph
			on: self
			getState: nil
			action: #scrollRight
			label: #rightButtonLabel)
		hResizing: #rigid;
		vResizing: #spaceFill;
		cornerStyle: #square;
		extent: self buttonWidth asPoint! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/12/2011 10:14'!
newScrollTarget
	"Answer a new default scroll target."

	^(self theme builder newRow: {
		Morph new color: Color red.
		Morph new color: Color green})
		vResizing: #spaceFill! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:55'!
newScroller
	"Answer a new morph for the scroll area."

	^(TransformMorph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #spaceFill)
		color: Color transparent;
		addMorph: self newScrollTarget! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:04'!
nextLeftMorph
	"Answer the next morph to the left of the current or
		the current if at the last."

	|index|
	index := self currentMorphIndex - 1 max: 1.
	^self targetMorphs at: index! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:03'!
nextRightMorph
	"Answer the next morph to the right of the current or
		the current if at the last."

	|index|
	index := self currentMorphIndex + 1 min: self targetMorphs size.
	^self targetMorphs at: index! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 12:53'!
preferredButtonCornerStyle
	"Answer the preferred button corner style
	for submorphs."

	^#square! !

!RowScrollerMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 12:45'!
rightButton
	"Answer the value of rightButton"

	^ rightButton! !

!RowScrollerMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 12:45'!
rightButton: anObject
	"Set the value of rightButton"

	rightButton := anObject! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 16:51'!
rightButtonLabel
	"Answer the label for a button for scrolling right."

	^AlphaImageMorph new image: (
		ScrollBar
			arrowOfDirection: #right
			size: self buttonWidth - 3
			color: self paneColor darker)! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:23'!
scrollLeft
	"Scroll to the left."

	self scroller offset: self nextLeftMorph left@0.
	self checkButtonAvailability! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:13'!
scrollRight
	"Scroll to the right."

	self scroller offset: self nextRightMorph left@0.
	self checkButtonAvailability! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:06'!
scrollTarget
	"Answer the scrollTarget."

	^self scroller firstSubmorph! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:48'!
scrollTarget: aMorph
	"Set the morph that is scrolled."
	
	self scroller
		removeAllMorphs;
		offset: 0@0;
		addMorph: aMorph.
	aMorph position: self scroller topLeft negated.
	self checkButtonAvailability! !

!RowScrollerMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 12:45'!
scroller
	"Answer the value of scroller"

	^ scroller! !

!RowScrollerMorph methodsFor: 'accessing' stamp: 'gvc 1/8/2010 12:45'!
scroller: anObject
	"Set the value of scroller"

	scroller := anObject! !

!RowScrollerMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2010 13:06'!
targetMorphs
	"Answer the submorphs of the scrollTarget."

	^self scrollTarget submorphs! !

PanelMorph subclass: #SeparatorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!SeparatorMorph commentStamp: 'gvc 6/4/2007 14:13' prior: 0!
Simple themed separator morph.!

!SeparatorMorph methodsFor: 'as yet unclassified' stamp: 'gvc 6/4/2007 14:21'!
adoptPaneColor: paneColor
	"Change our fill too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: (self theme separatorFillStyleFor: self)! !

PanelMorph subclass: #TabLabelMorph
	instanceVariableNames: 'tabSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TabLabelMorph commentStamp: 'gvc 9/23/2008 11:49' prior: 0!
Specially themed label used for tab selector items. !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/7/2008 12:01'!
adoptPaneColor: paneColor
	"Use the theme for fillStyle and border."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/7/2008 11:29'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self isSelected
		ifTrue: [self theme tabLabelSelectedBorderStyleFor: self]
		ifFalse: [self theme tabLabelNormalBorderStyleFor: self]! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 17:49'!
extent: aPoint
	"Set the extent of the receiver.
	Update the pane color for size dependent fill/border styles."

	super extent: aPoint.
	self adoptPaneColor! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/7/2008 11:10'!
fillStyleToUse
	"Answer the basic fill style for the receiver."

	^self isSelected
		ifTrue: [self selectedFillStyle] 
		ifFalse: [self normalFillStyle]! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 16:26'!
focusBounds
	"Answer the bounds for drawing the focus indication."

	^(self bounds width < 6 or: [self bounds height < 6])
		ifTrue: [super focusBounds]
		ifFalse: [super focusBounds insetBy: (2@2 corner: 2@0)]! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/7/2011 17:14'!
font: aFont
	"Set the label font"

	self allMorphsDo: [:m |
		(m ~= self and: [m respondsTo: #font:])
			ifTrue: [m font: aFont]]! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/7/2008 11:16'!
initialize
	"Initialize the receiver."
	
	super initialize.
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 13:47'!
isSelected
	"Answer whether the tab is selected."

	^self tabSelector
		ifNil: [false]
		ifNotNil: [:selector | selector selectedTab == self]! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/10/2011 13:50'!
isVisible
	"Answer whether the tab is currently visible."

	^self tabSelector
		ifNil: [false]
		ifNotNil: [:selector | selector visibleTabs includes: self]! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 14:42'!
label
	"Answer the label contents."

	^self firstSubmorph userString ifNil: [self firstSubmorph]! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 14:18'!
label: aStringOrMorph
	"Change the label contents"

	|l|
	l := aStringOrMorph isMorph
		ifTrue: [aStringOrMorph]
		ifFalse: [(self theme buttonLabelForText: aStringOrMorph)
					vResizing: #shrinkWrap;
					hResizing: #shrinkWrap].
	self
		removeAllMorphs;
		addMorph: l! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/14/2009 15:25'!
minWidth
	"Consult the theme also."

	^super minWidth max: self theme buttonMinWidth! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/7/2008 11:11'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme tabLabelNormalFillStyleFor: self! !

!TabLabelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/7/2008 11:11'!
selectedFillStyle
	"Return the selected fillStyle of the receiver."
	
	^self theme tabLabelSelectedFillStyleFor: self! !

!TabLabelMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/10/2011 13:44'!
tabSelector

	^ tabSelector! !

!TabLabelMorph methodsFor: 'accessing' stamp: 'GaryChambers 6/10/2011 13:44'!
tabSelector: anObject

	tabSelector := anObject! !

BorderedMorph subclass: #WorkAreaMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!WorkAreaMorph commentStamp: 'gvc 5/18/2007 09:56' prior: 0!
This class is designed to be used as the container for morphs that are placed at absolute positions and is placed within a scroller.
An example would be the background behind a page view in a word processor.
Optimises #layoutChanged to not propagate to owner (assumed to be in a scroller).!

!WorkAreaMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 14:24'!
adoptPaneColor: paneColor
	"Make the receiver's color a bit whiter than the pane color."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self color: (paneColor alphaMixed: 0.4 with: Color white)! !

!WorkAreaMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:43'!
layoutChanged
	"Don't pass to owner, since the receiver doesn't care!! Improves frame rate."
	
	fullBounds := nil.
	self layoutPolicy ifNotNil:[:l | l flushLayoutCache].! !

!AbstractResizerMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/27/2008 21:34'!
adoptPaneColor: paneColor
	"Just get the resizer fill style for the theme."
	
	paneColor ifNil: [^super adoptPaneColor: paneColor].
	self fillStyle: (self theme resizerGripNormalFillStyleFor: self)! !

!AbstractResizerMorph methodsFor: '*Polymorph-Widgets' stamp: 'jrp 7/5/2005 21:37'!
handlesMouseOver: anEvent

	^ true
	! !

!AbstractResizerMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/13/2008 10:36'!
mouseEnter: anEvent

	self isCursorOverHandle ifTrue:
		[self setInverseColors.
		self shouldInvalidateOnMouseTransition ifTrue: [self changed]. "avoid unnecessary invalidation"
		anEvent hand showTemporaryCursor: self resizeCursor]! !

!AbstractResizerMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/13/2008 10:36'!
mouseLeave: anEvent

	anEvent hand showTemporaryCursor: nil.
	self setDefaultColors.
	self shouldInvalidateOnMouseTransition ifTrue: [self changed]. "avoid unnecessary invalidation"! !

!AbstractResizerMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/12/2007 10:59'!
mouseUp: anEvent
	"Change the cursor back to normal if necessary."
	
	(self bounds containsPoint: anEvent cursorPoint) ifFalse: [
		anEvent hand showTemporaryCursor: nil.
		self
			setDefaultColors;
			changed]! !

!AbstractResizerMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/13/2008 10:20'!
shouldDraw
	"Answer whether the resizer should be drawn."
	
	^self fillStyle isTransparent not! !

!AbstractResizerMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/13/2008 10:35'!
shouldInvalidateOnMouseTransition
	"Answer whether the resizer should be invalidated
	when the mouse enters or leaves."
	
	^false! !

AbstractResizerMorph subclass: #EdgeGripMorph
	instanceVariableNames: 'target edgeName fitTargetOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!EdgeGripMorph commentStamp: 'gvc 9/23/2008 11:58' prior: 0!
Similar to a ProportionalSplitterMorph but designed to attach to an edge of a single morph only.!

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:26'!
adoptPaneColor: paneColor
	"Change our color too."
	
	super adoptPaneColor: paneColor.
	self fillStyle: self normalFillStyle! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 13:53'!
bottomLayoutFrame
	"Answer the layout frame for a bottom edge."
	
	^LayoutFrame
		fractions: (0 @ 1 corner: 1 @ 1)
		offsets: (22 @ SystemWindow borderWidth negated corner: -22 @ 0)! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 13:10'!
defaultHeight
	"Answer the default height for the receiver."
	
	^ProportionalSplitterMorph splitterWidth! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 13:10'!
defaultWidth
	"Answer the default width for the receiver."
	
	^ProportionalSplitterMorph splitterWidth! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'gvc 10/1/2007 13:03'!
edgeName
	"Answer the value of edgeName"

	^ edgeName! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'GaryChambers 1/25/2011 13:17'!
edgeName: aSymbol
	"Set the value of edgeName. This is the edge of the target
	that will be manipulated by the grip."

	edgeName := aSymbol.
	self
		setLayoutSizingFor: aSymbol;
		layoutFrame: self gripLayoutFrame;
		layoutChanged! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/19/2007 21:25'!
extent: aPoint
	"If our minor extent changes then adopt the pane colour to
	reflect any size based gradient in the theme.
	Assumes fillStyle will not change on the major extent for
	performance reasons."

	|ext|
	ext := self extent.
	super extent: aPoint.
	self isHorizontal
		ifTrue: [self extent y ~= ext y ifTrue: [
					self adoptPaneColor: self paneColor]]
		ifFalse: [self extent x ~= ext x ifTrue: [
					self adoptPaneColor: self paneColor]]
	! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 13:13'!
fitTargetBoundsInOwner: aRect
	"Reset the target bounds if required to
	ensure that the owner's submorphs fit within the owner's
	exisiting bounds when layed out."

	|ownerMinExt targetOwner|
	targetOwner := self target owner ifNil: [^self].
	ownerMinExt :=  targetOwner minExtent.
	ownerMinExt x > self target owner width
		ifTrue: [self edgeName = #left
				ifTrue: [self target bounds: (aRect left + (ownerMinExt x - targetOwner width) @ aRect top extent: (aRect width - (ownerMinExt x - targetOwner width)) @ aRect height)]
				ifFalse: [self target bounds: (aRect origin extent: (aRect width - (ownerMinExt x - targetOwner width)) @ aRect height)]].
	ownerMinExt y > self target owner height
		ifTrue: [self edgeName = #top
				ifTrue: [self target bounds: (aRect left @ (aRect top + (ownerMinExt y - targetOwner height)) extent: aRect width @ (aRect height - (ownerMinExt y - targetOwner height)))]
				ifFalse: [self target bounds: (aRect origin extent: aRect width @ (aRect height - (ownerMinExt y - targetOwner height)))]]
		
	! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'GaryChambers 1/25/2011 13:05'!
fitTargetOwner

	^ fitTargetOwner! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'GaryChambers 1/25/2011 13:05'!
fitTargetOwner: anObject

	fitTargetOwner := anObject! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:03'!
gripLayoutFrame
	"Answer the layout frame dependinbg on our edge."
	
	self edgeName == #top ifTrue: [^self topLayoutFrame].
	self edgeName == #bottom ifTrue: [^self bottomLayoutFrame].
	self edgeName == #left ifTrue: [^self leftLayoutFrame].
	^self rightLayoutFrame! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 13:12'!
initialize
	"Initialize the receiver."
	
	super initialize.
	self
		fitTargetOwner: false;
		edgeName: #right;
		extent: self defaultWidth @ self defaultHeight;
		hResizing: #spaceFill;
		vResizing: #spaceFill! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:20'!
isHorizontal
	"Answer true if the receiver has a horizontal layout."
	
	^self edgeName == #top
		or: [self edgeName == #bottom]! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:07'!
leftLayoutFrame
	"Answer the layout frame for a left edge."
	
	^LayoutFrame
		fractions: (0 @ 0 corner: 0 @ 1)
		offsets: (0 @ -7 corner: SystemWindow borderWidth @ (SystemWindow borderWidth - 26))! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/24/2011 13:11'!
mouseDown: anEvent
	"Remember the receiver and target offsets too."
	
	|cp|
	(self bounds containsPoint: anEvent cursorPoint)
		ifTrue: [self fillStyle: self pressedFillStyle].
	cp := anEvent cursorPoint.
	lastMouse := {cp. cp - self position. cp - self targetPoint}.
	self eventHandler
		ifNotNil: [self eventHandler mouseDown: anEvent fromMorph: self]
! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/20/2011 11:23'!
mouseMove: anEvent
	"Track the mouse for resizing."
	
	target ifNil: [^self].
	self theme settings fastDragging
		ifTrue: [target doFastReframe: self edgeName] 
		ifFalse: [
			lastMouse at: 1 put: anEvent cursorPoint.
			self targetPoint: lastMouse first - lastMouse last.
			self positionPoint: (lastMouse first - lastMouse second)].! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:33'!
mouseUp: anEvent
	"Change the cursor back to normal if necessary and change the color back to normal."
	
	(self bounds containsPoint: anEvent cursorPoint)
		ifFalse: [anEvent hand showTemporaryCursor: nil].
	self adoptPaneColor: self paneColor! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:23'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme splitterNormalFillStyleFor: self! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 13:05'!
positionPoint: aPoint
	"Reposition based on ptName."
	
	(#(top bottom) includes: self edgeName)
		ifTrue: [^self position: self left @ aPoint y].
	(#(left right) includes: self edgeName)
		ifTrue: [^self position: aPoint x @ self top].
	^self position: aPoint! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:23'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	
	^self theme splitterPressedFillStyleFor: self! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 13:05'!
resizeCursor

	^ Cursor resizeForEdge: self edgeName! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:09'!
rightLayoutFrame
	"Answer the layout frame for a right edge."
	
	^LayoutFrame
		fractions: (1 @ 0 corner: 1 @ 1)
		offsets: (SystemWindow borderWidth negated @ -7 corner: 0 @ (SystemWindow borderWidth - 26))! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 13:20'!
setLayoutSizingFor: aSymbol
	"Adjust the sizing for use within table layouts."

	(aSymbol = #left or: [aSymbol = #right])
		ifTrue: [self hResizing: #rigid; vResizing: #spaceFill].
	(aSymbol = #top or: [aSymbol = #bottom])
		ifTrue: [self hResizing: #spaceFill; vResizing: #rigid]! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 15:13'!
setTargetBounds: aRect
	"Set the target bounds, taking owner into account if required."

	self target bounds: aRect.
	self fitTargetOwner ifTrue: [
		self fitTargetBoundsInOwner: aRect]! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 12/3/2007 15:11'!
splitsTopAndBottom
	"Answer true if the receiver has a horizontal layout."
	
	^self isHorizontal! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'gvc 2/12/2007 16:43'!
target
	"Answer the value of target"

	^ target! !

!EdgeGripMorph methodsFor: 'accessing' stamp: 'gvc 7/30/2009 13:58'!
target: aMorph
	"Set the value of target"

	target := aMorph! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 13:05'!
targetPoint
	"Answer the reference point of the target."

	^self target bounds pointAtSideOrCorner: self edgeName! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 1/25/2011 15:24'!
targetPoint: aPoint
	"Set the reference point of the target."

	|minExt rect ownerMinExt|
	rect := self target bounds withSideOrCorner: self edgeName setToPoint: aPoint.
	minExt := (self target layoutPolicy notNil and: [self target layoutPolicy isTableLayout])
		ifTrue: [self target layoutPolicy minExtentOf: self target in: self target layoutBounds]
		ifFalse: [self target minimumExtent].
	rect width <= minExt x ifTrue: [
		rect := self edgeName = #left
			ifTrue: [rect withSideOrCorner: #left setToPoint: self target bounds bottomRight - minExt]
			ifFalse: [rect withSideOrCorner: #right setToPoint: self target bounds topLeft + minExt]].
	rect height <= minExt y ifTrue: [
		rect := self edgeName = #top
			ifTrue: [rect withSideOrCorner: #top setToPoint: self target bounds bottomRight - minExt]
			ifFalse: [rect withSideOrCorner: #bottom setToPoint: self target bounds topLeft + minExt]].
	self setTargetBounds: rect! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 14:26'!
themeChanged
	"Update the fill style."

	self fillStyle: self normalFillStyle.
	super themeChanged! !

!EdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:47'!
topLayoutFrame
	"Answer the layout frame for a top edge."
	
	^LayoutFrame
		fractions: (0 @ 0 corner: 1 @ 0)
		offsets: (22 @ -29 corner: -22 @ (SystemWindow borderWidth - 29))! !

EdgeGripMorph subclass: #WindowEdgeGripMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!WindowEdgeGripMorph commentStamp: 'gvc 9/23/2008 11:47' prior: 0!
Window edge gripper allowing resizing of a window by a particular side.!

!WindowEdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:43'!
mouseDown: anEvent
	"Activate the window if not currently so."
	
	(self bounds containsPoint: anEvent cursorPoint)
		ifTrue: [self window ifNotNil: [:w | w activate]].
	^super mouseDown: anEvent! !

!WindowEdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:17'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme windowEdgeNormalFillStyleFor: self! !

!WindowEdgeGripMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/1/2007 14:17'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	
	^self theme windowEdgePressedFillStyleFor: self! !

!BorderedSubpaneDividerMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/2/2007 13:56'!
adoptPaneColor: paneColor
	"Match the color."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self color: paneColor! !

MenuMorph subclass: #EmbeddedMenuMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!EmbeddedMenuMorph commentStamp: 'gvc 5/18/2007 13:18' prior: 0!
Menu designed to be embedded in another morph rather than popped up directly.!

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/17/2008 17:04'!
allEnabledSiblingItems
	"Answer the receiver's submorphs followed by the (wrapping) owner's
	submorph items. Answer only enabled items."

	^self allSiblingItems select: [:item | item isEnabled]! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/20/2008 21:18'!
allSiblingItems
	"Answer the receiver's submorphs followed by the (wrapping) owner's
	submorph items. Nasty."

	|menus str index|
	str := (Array new: 40) writeStream.
	menus := self owner submorphs select: [:m | m isKindOf: self class].
	menus := (menus copyFrom: (index := menus indexOf: self) to: menus size), (menus copyFrom: 1 to: index - 1).
	menus do: [:menu |
		str nextPutAll: menu items].
	^str contents! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 14:17'!
drawOn: aCanvas
	"Draw the receiver on the canvas."

	self perform: #drawOn: withArguments: {aCanvas} inSuperclass: Morph.
	self hasKeyboardFocus ifTrue: [self drawKeyboardFocusOn: aCanvas]! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 14:22'!
handlesKeyboard: evt
	"Answer whether the receiver handles the keystroke represented by the event"

	^true! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/21/2007 14:37'!
keyStroke: evt
	"Handle tabbing and arrows and cr/space."
	
	|char selectable|
	(self navigationKey: evt) ifTrue: [^self].
	char := evt keyCharacter.
	char = Character space 
		ifTrue: 
			[selectedItem ifNotNil: 
					[selectedItem hasSubMenu 
						ifTrue: 
							[evt hand newMouseFocus: selectedItem subMenu.
							^selectedItem subMenu takeKeyboardFocus]
						ifFalse: 
							[^selectedItem invokeWithEvent: evt]].
			(selectable := self items) size = 1 
				ifTrue: [^selectable first invokeWithEvent: evt].
			^self].
	(char = Character arrowLeft or: [char = Character arrowRight]) ifTrue: [
		(selectedItem notNil and: [selectedItem hasSubMenu]) ifTrue: [
			evt hand newMouseFocus: selectedItem subMenu.
			selectedItem subMenu moveSelectionDown: 1 event: evt.
			^evt hand newKeyboardFocus: selectedItem subMenu]].
	char = Character arrowUp ifTrue: [^self moveSelectionDown: -1 event: evt].	"up arrow key"
	char = Character arrowDown ifTrue: [^self moveSelectionDown: 1 event: evt].	"down arrow key"
	char = Character pageUp ifTrue: [^self moveSelectionDown: -5 event: evt].	"page up key"
	char = Character pageDown ifTrue: [^self moveSelectionDown: 5 event: evt].	"page down key"
! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:38'!
keyboardFocusChange: aBoolean
	"Nasty hack for scrolling upon keyboard focus."

	super keyboardFocusChange: aBoolean.
	aBoolean
		ifTrue: [(self ownerThatIsA: GeneralScrollPane) ifNotNil: [:sp |
					sp scrollToShow: self bounds]]
		ifFalse: [self selectItem: nil event: nil]! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
moveSelectionDown: anInteger event: anEvent
	"Move the selection down or up (negative number) by (at least)
	the specified amount. If the item is not enabled, scan one at a time
	in that direction. If we move off the top/bottom then switch focus to any
	sibling menu and start scanning at the relevant end."

	| allEnabledSiblingItems index|
	allEnabledSiblingItems := self allEnabledSiblingItems.
	index := (allEnabledSiblingItems indexOf: selectedItem ifAbsent: [0 + (anInteger negative ifTrue: [1] ifFalse: [0])]) + anInteger.
	allEnabledSiblingItems do: "Ensure finite"
		[:unused | | m | m := allEnabledSiblingItems atWrap: index.
		((m isKindOf: MenuItemMorph) and: [m isEnabled]) ifTrue:
			[m owner = self owner ifFalse: [
				anEvent hand newKeyboardFocus: m owner].
				^m owner selectItem: m event: anEvent].
		"Keep looking for an enabled item"
		index := index + anInteger sign].
	^self selectItem: nil event: anEvent! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/6/2008 14:56'!
selectItem: aMenuItem event: anEvent
	"Deselect any sibling menus."
	
	|menus|
	menus := self owner submorphs select: [:m | (m isKindOf: self class) and: [m ~~ self]].
	menus do: [:menu |
		menu perform: #selectItem:event: withArguments: {nil. anEvent} inSuperclass: self class superclass].
	^super selectItem: aMenuItem event: anEvent! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/5/2010 15:47'!
selectLastMatch: aString
	"Answer the last subitem that has text that includes the given substring.
	Answer nil if none.
	Disable non-matching items and enable matching items."

	|lastMatch|
	self items reverseDo: [:item | | match |
		match := aString isEmpty or: [item contents asString asLowercase includesSubString: aString].
		item isEnabled: match.
		(match and: [lastMatch isNil]) ifTrue: [lastMatch := item]].
	^lastMatch! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/5/2010 15:47'!
selectLastPrefix: aString
	"Answer the last subitem that has text that matches the given prefix.
	Answer nil if none.
	Disable non-matching items and enable matching items."

	|lastMatch|
	self items reverseDo: [:item | | match |
		match := aString isEmpty or: [item contents asString asLowercase beginsWith: aString].
		item isEnabled: match.
		(match and: [lastMatch isNil]) ifTrue: [lastMatch := item]].
	^lastMatch! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/5/2010 15:48'!
selectMatch: aString
	"Answer the first subitem that has text that includes the given substring.
	Answer nil if none.
	Disable non-matching items and enable matching items."

	|firstMatch|
	self items do: [:item | | match |
		match := aString isEmpty or: [item contents asString asLowercase includesSubString: aString].
		item isEnabled: match.
		(match and: [firstMatch isNil]) ifTrue: [firstMatch := item]].
	^firstMatch! !

!EmbeddedMenuMorph methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
selectPrefix: aString
	"Answer the first subitem that has text that matches the given prefix.
	Answer nil if none.
	Disable non-matching items and enable matching items."

	| firstMatch|
	self items do: [:item | | match |
		match := aString isEmpty or: [item contents asString asLowercase beginsWith: aString].
		item isEnabled: match.
		(match and: [firstMatch isNil]) ifTrue: [firstMatch := item]].
	^firstMatch! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'BenjaminVanRyseghem 3/28/2011 15:00'!
addMenuItem: anItem
	self addMorphBack: anItem.
	^ self menuItems add: anItem.
! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 11/20/2007 13:34'!
addToggle: aString selector: aSymbol
	"Append a menu item with the given label. If the item is selected,
	it will send the given selector to the default target object."

	self addToggle: aString
		target: defaultTarget
		selector: aSymbol
		getStateSelector: nil
		argumentList: EmptyArray! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/12/2006 15:32'!
addToggle: aString target: anObject selector: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self addToggle: aString
		target: anObject
		selector: aSymbol
		getStateSelector: nil
		argumentList: EmptyArray! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/9/2006 09:25'!
addToggle: aString target: anObject selector: aSymbol getStateSelector: stateSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self addToggle: aString
		target: anObject
		selector: aSymbol
		getStateSelector: stateSymbol
		argumentList: EmptyArray! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/9/2006 09:39'!
addToggle: aString target: anObject selector: aSymbol getStateSelector: stateSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self addToggle: aString
		target: anObject
		selector: aSymbol
		getStateSelector: stateSymbol
		enablementSelector: nil
		argumentList: argList! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/9/2006 09:45'!
addToggle: aString target: anObject selector: aSymbol getStateSelector: stateSymbol enablementSelector: enableSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self addToggle: aString
		target: anObject
		selector: aSymbol
		getStateSelector: stateSymbol
		enablementSelector: enableSymbol
		argumentList: EmptyArray! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'BenjaminVanRyseghem 3/28/2011 15:00'!
addToggle: aString target: anObject selector: aSymbol getStateSelector: stateSymbol enablementSelector: enableSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	|item|
	item := ToggleMenuItemMorph new
		contents: aString;
		target: anObject;
		selector: aSymbol;
		arguments: argList asArray;
		getStateSelector: stateSymbol;
		enablementSelector: enableSymbol.
	^ self addMenuItem: item.
! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/29/2007 16:28'!
adoptPaneColor: paneColor
	"Change our color."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self color: paneColor! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 14:28'!
color: aColor
	"Set the receiver's color. Remember the base color in the case of a gradient background."

	super color: aColor.
	self setProperty: #basicColor toValue: aColor! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'GuillermoPolito 8/9/2010 21:25'!
menuItems
	^menuItems ifNil:[menuItems:= OrderedCollection new].
! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'mtf 9/19/2007 12:26'!
mouseDownInTitle: evt
	"Handle a mouse down event in the title bar."
	"Grab the menu and drag it to some other place"
	evt hand grabMorph: self.! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/16/2007 12:59'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!MenuMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/16/2008 16:37'!
themeChanged
	"Update the colour if specified."

	self color: (self theme menuColorFor: nil).
	super themeChanged! !

!DockingBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/29/2007 15:31'!
add: wordingString font: aFont icon: aForm help: helpString subMenu: aMenuMorph 
	"Append the given submenu with the given label."
	
	| item |
	item := ToggleMenuItemMorph new.
	item
		font: aFont;
		contents: wordingString;
		subMenu: aMenuMorph;
		icon: aForm.
	helpString isNil
		ifFalse: [item setBalloonText: helpString].
	self addMorphBack: item! !

!DockingBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/25/2006 13:37'!
adoptPaneColor: paneColor
	"Change our color too."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	originalColor :=  paneColor.
	self borderStyle baseColor: paneColor.
	self updateColor! !

!DockingBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 14:24'!
extent: aPoint 
	"Change the receiver's extent.
	optimized to not keep updating the (gradient) color!!"
	
	|old|
	old := self extent.
	super extent: aPoint.
	self extent = old ifTrue: [^self].
	self updateColor! !

!DockingBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/26/2010 11:19'!
mouseDown: anEvent
	"Release the mouse focus if clicked outside the receiver."

	(self fullContainsPoint: anEvent position)
		ifFalse: [anEvent hand releaseMouseFocus: self].
	^super mouseDown: anEvent! !

!DockingBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/26/2007 15:27'!
originalColor
	"Answer the original color."
	
	^originalColor! !

!DockingBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 11/14/2006 15:37'!
updatePosition
	"private - update the receiver's position.
	Fixed so as not to keep changing position!!
	(called twice if adhereing)"
	
	| edgeSymbol margin |
	edgeSymbol := self edgeToAdhereTo.
	edgeSymbol == #none
		ifTrue: [self
				perform: (edgeSymbol , ':') asSymbol
				with: (self owner perform: edgeSymbol)].
	""
	margin := self avoidVisibleBordersAtEdge
				ifTrue: [self borderWidth asPoint]
				ifFalse: [0 asPoint].
	""
	self isAdheringToTop
		ifTrue: [| usedHeight | 
			usedHeight := self usedHeightByPredominantDockingBarsOfChastes: #(#top ).
			self topLeft: self owner topLeft - margin + (0 @ usedHeight)].
	self isAdheringToBottom
		ifTrue: [| usedHeight | 
			usedHeight := self usedHeightByPredominantDockingBarsOfChastes: #(#bottom ).
			self bottomLeft: self owner bottomLeft + (-1 @ 1 * margin) - (0 @ usedHeight)].
	""
	self isAdheringToLeft
		ifTrue: [| usedHeight usedWidth | 
			usedHeight := self usedHeightByPredominantDockingBarsOfChastes: #(#top ).
			usedWidth := self usedWidthByPredominantDockingBarsOfChastes: #(#left ).
			self topLeft: self owner topLeft - margin + (usedWidth @ usedHeight)].
	self isAdheringToRight
		ifTrue: [| usedHeight usedWidth | 
			usedHeight := self usedHeightByPredominantDockingBarsOfChastes: #(#top ).
			usedWidth := self usedWidthByPredominantDockingBarsOfChastes: #(#right ).
			self topRight: self owner topRight + (1 @ -1 * margin) + (usedWidth negated @ usedHeight)]! !

!DockingBarMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/18/2009 22:32'!
wantsYellowButtonMenu
	"Answer true if the receiver wants a yellow button menu.
	Fixed for when defaultYellowButtonMenuEnabled setting is off"
	
	^ self defaultYellowButtonMenuEnabled! !

DockingBarMorph subclass: #ToolDockingBarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!ToolDockingBarMorph commentStamp: 'gvc 5/18/2007 10:20' prior: 0!
A non user-moveable docking bar that uses theme-based fill styles.!

!ToolDockingBarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 13:28'!
gradientRamp
	"If not set answer based on orininal color."
	
	^self normalFillStyle colorRamp! !

!ToolDockingBarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 14:28'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^self theme dockingBarNormalFillStyleFor: self! !

!ToolDockingBarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 13:29'!
updateColor
	"private - update the receiver's color"
	
	self autoGradient
		ifFalse: [^ self].
	self fillStyle: self normalFillStyle! !

!ToolDockingBarMorph methodsFor: 'as yet unclassified' stamp: 'gvc 10/16/2006 14:27'!
wantsYellowButtonMenu
	"Answer true if the receiver wants a yellow button menu."
	
	^false! !

!BalloonCanvas methodsFor: '*Polymorph-Widgets' stamp: 'StephaneDucasse 2/9/2011 14:34'!
fillRectangle: aRectangle basicFillStyle: aFillStyle
	"Fill the given rectangle with the given, non-composite, fill style."
	
	^self drawRectangle: aRectangle
			color: aFillStyle
			borderWidth: 0
			borderColor: nil
! !

EventHandler subclass: #EventHandlerPlus
	instanceVariableNames: 'mouseOverRecipient mouseOverSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!EventHandlerPlus commentStamp: 'gvc 5/18/2007 13:13' prior: 0!
Support for handling mouseOver events (no button down).!

!EventHandlerPlus methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:19'!
handlesMouseOver: evt
	"Answer whether we can handle the event."
	
	mouseOverRecipient ifNotNil: [^ true].
	^super handlesMouseOver: evt! !

!EventHandlerPlus methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 8/21/2011 17:51'!
methodRefList
	"Return a MethodReference for each message I can send."
	
	|list sel|
	list := super methodRefList.
	sel := mouseOverSelector.
	mouseOverRecipient ifNotNil: 
		[:recipient | 
			list add: 
				(RGMethodDefinition
					realClass: (recipient class whichClassIncludesSelector: sel)
					selector: sel)].
	^list! !

!EventHandlerPlus methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:20'!
mouseOver: event fromMorph: sourceMorph
	"Relay the event."
	
	^ self send: mouseOverSelector to: mouseOverRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandlerPlus methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 17:24'!
on: eventName send: selector to: recipient
	"Register the selector and recipient for the given event name."
	
	eventName == #mouseOver ifTrue:
		[mouseOverRecipient := recipient.  mouseOverSelector := selector. ^ self].
	^super on: eventName send: selector to: recipient! !

TabPanelBorder subclass: #ExtendedTabPanelBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!ExtendedTabPanelBorder commentStamp: '<historical>' prior: 0!
Specialized border for TabGroup. Does not draw border beneath the selectd tab and only draws on top.!

!ExtendedTabPanelBorder methodsFor: 'as yet unclassified' stamp: 'GaryChambers 6/8/2011 12:02'!
frameRectangle: aRectangle on: aCanvas
	"Draw the border taking the currently selected tab into account.
	Only works for top-positioned tabs for the moment."
	
	|w h r tab|
	w := self width.
	w isPoint ifTrue: [h := w y. w := w x] ifFalse:[h := w].
	tab := self selectedTab.
	(tab isNil or: [tab owner isNil]) ifTrue: [
		r := aRectangle topLeft + (w@0) corner: aRectangle topRight - (w@h negated).
		aCanvas fillRectangle: r color: self color.
		^self]. "top"
	r := aRectangle topLeft + (w@0) corner: tab bounds left + w@(aRectangle top + h).
	aCanvas fillRectangle: r color: self color. "top 1"
	r := tab bounds left + w@ aRectangle top corner: tab bounds right - w@(aRectangle top + h).
	aCanvas fillRectangle: r color: tab paneColor. "top 2"
	r :=  tab bounds right - w@ aRectangle top corner: aRectangle topRight - (w@h negated).
	aCanvas fillRectangle: r color: self color. "top 3"! !

!OrientedFillStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 12:19'!
= anOrientedFillStyle
	"Answer whether equal."

	^self species = anOrientedFillStyle species
		and: [self origin = anOrientedFillStyle origin
		and: [self direction = anOrientedFillStyle direction
		and: [self normal = anOrientedFillStyle normal]]]! !

!OrientedFillStyle methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/24/2007 12:20'!
hash
	"Hash is implemented because #= is implemented."
	
	^self species hash
		bitXor: (self origin hash
		bitXor: (self direction hash
		bitXor: (self normal hash)))! !

!BottomLeftGripMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 13:47'!
containsPoint: aPoint
	"Answer true only if on edges."
	
	|w|
	^(super containsPoint: aPoint) and: [
		w := SystemWindow borderWidth.
		((self bounds translateBy: w@w negated)
			containsPoint: aPoint) not]! !

ListItemWrapper subclass: #PluggableTreeItemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!PluggableTreeItemNode commentStamp: 'ar 2/12/2005 04:37' prior: 0!
Tree item for PluggableTreeMorph.!

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
acceptDroppingObject: anotherItem
	^model dropNode: anotherItem on: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
asString
	^model printNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
balloonText
	^model balloonTextForNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:02'!
canBeDragged
	^model isDraggableNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:03'!
contents
	^model contentsOfNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
hasContents
	^model hasNodeContents: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:04'!
icon
	^model iconOfNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
wantsDroppedObject: anotherItem
	^model wantsDroppedNode: anotherItem on: self! !

!Form methodsFor: '*Polymorph-Widgets-Themes' stamp: 'AlainPlantec 5/13/2011 09:15'!
setAsBackground
	"Set this form as a background image."
	| world |
	world := self currentWorld.
	world backgroundMorph: ((UITheme current builder newAlphaImage: self help: nil) autoSize: false;
			 layout: #scaled;
			 lock) ! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 10:11'!
backgroundImage: aForm layout: aSymbol
	"Set a background image, replacing the current background morph, if any,
	with the given layout (see AlphaImageMorph layoutSymbols). "

	self backgroundMorph: (
		(self theme builder
			newAlphaImage: aForm help: nil)
			autoSize: false;
			layout: aSymbol;
			lock)! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/3/2010 17:59'!
backgroundMorph
	"Answer the background morph if any."
	
	^backgroundMorph! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 5/13/2011 09:16'!
backgroundMorph: aMorph
	"Set the background morph.
	Probably best if locked prior to adding."

	self backgroundMorph isNil ifFalse: [
		self backgroundMorph delete].
	backgroundMorph := aMorph.
	aMorph isNil ifFalse: [
		aMorph bounds: self bounds.
		self addMorphBack: aMorph]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/18/2007 16:14'!
currentWindow
	"Answer the top window."

	^SystemWindow topWindow! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/12/2007 17:06'!
handlerForMouseDown: anEvent
	"If we have a modal dialog then answer nil otherwise as usual.."
	
	^(self hasProperty: #submorphLockStates)
		ifFalse: [super handlerForMouseDown: anEvent]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/10/2011 12:02'!
isWindowActive: aSystemWindow
	"Answer whether the given window is active.
	True if the current top window."
	
	^self currentWindow == aSystemWindow! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 14:10'!
modalLockTo: aSystemWindow
	"Don't lock the world!! Lock the submorphs.
	The modal window gets opened afterwards so is OK."
	
	|lockStates|
	lockStates := IdentityDictionary new.
	self submorphsDo: [:m |
		lockStates at: m put: m isLocked.
		m lock].
	self
		setProperty: #submorphLockStates
		toValue: lockStates! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/12/2007 17:01'!
modalUnlockFrom: aSystemWindow
	"Don't unlock the world!! Unlock the submorphs
	that were not originally locked."
	
	|lockStates|
	lockStates := self
		valueOfProperty: #submorphLockStates
		ifAbsent: [^self].
	self removeProperty: #submorphLockStates.
	lockStates keysAndValuesDo: [:m :locked |
		locked ifFalse: [m unlock]]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets-override' stamp: 'MarcusDenker 4/29/2011 00:37'!
mouseDown: evt
	"Handle a mouse down event."
	| grabbedMorph handHadHalos |

	(self defaultYellowButtonMenuEnabled
			and: [evt yellowButtonPressed])
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].

	grabbedMorph := self morphToGrab: evt.
	grabbedMorph ifNotNil: [
		grabbedMorph isSticky ifTrue: [^self].
		^evt hand grabMorph: grabbedMorph].

	(super handlesMouseDown: evt)
		ifTrue: [^super mouseDown: evt].

	handHadHalos := evt hand halo notNil.

	evt hand removeHalo. "shake off halos"
	self isWorldMorph ifTrue: [
		self currentWindow ifNotNil: [:topWindow |
			SystemWindow passivateTopWindow]]. "since pasteup will release keyboard focus now"
	evt hand releaseKeyboardFocus. "shake of keyboard foci"

	self submorphs
		select: [:each | each hasProperty: #morphHierarchy]
		thenDo: [:each | each delete].
 
	(evt shiftPressed not
			and: [ self isWorldMorph not 
				and: [ self wantsEasySelection not ]])
		ifTrue: [
		"explicitly ignore the event if we're not the world and we'll not select,
		so that we could be picked up if need be"
		evt wasHandled: false.
		^ self.
	].

	( evt shiftPressed or: [ self wantsEasySelection ] )
		 ifTrue: [
			"We'll select on drag, let's decide what to do on click"
			| clickSelector |
			clickSelector := nil.
			evt shiftPressed 
				ifTrue: [ clickSelector := #findWindow:.]
				ifFalse: [self isWorldMorph 
							ifTrue: [clickSelector := handHadHalos
										ifTrue: [ #delayedInvokeWorldMenu: ]
										ifFalse: [ #invokeWorldMenu: ]]].
		evt hand 
				waitForClicksOrDrag: self 
				event: evt 
				selectors: { clickSelector. nil. nil. #dragThroughOnDesktop: }
				threshold: 5.
	]
	ifFalse: [
		"We wont select, just bring world menu if I'm the world"
		self isWorldMorph ifTrue: [
			handHadHalos
				ifTrue: [ self delayedInvokeWorldMenu: evt ]
				ifFalse: [ self invokeWorldMenu: evt ]
		]
	].
! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'StephaneDucasse 3/10/2011 15:32'!
navigateVisibleWindowForward
	"Change the active window to the next visible and not collapsed window."
 
	self nextVisibleWindow
		ifNil: [SystemWindow passivateTopWindow]
		ifNotNil: [:m | m activate]
 ! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:41'!
navigateWindowBackward
	"Change the active window to the previous window."

	self previousWindow ifNotNil: [:m |
		m isCollapsed ifTrue: [m collapseOrExpand].
		m activate]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:42'!
navigateWindowForward
	"Change the active window to the next window."

	self nextWindow ifNotNil: [:m |
		self currentWindow ifNotNil: [:w | w sendToBack].
		m isCollapsed ifTrue: [m collapseOrExpand].
		m activate]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 10:11'!
navigationKey: event
	"Check for active window navigation."
	
	(event commandKeyPressed and: [event shiftPressed not]) ifTrue: [
		(self theme openTasklist: event) ifTrue: [^true].
		event keyCharacter = Character arrowLeft
			ifTrue: [self navigateWindowBackward. 
					^true].
		event keyCharacter = Character arrowRight
			ifTrue: [self navigateWindowForward. 
					^true]].
	^false! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/29/2008 10:59'!
nextVisibleWindow
	"Answer the next (visible) window to navigate to."
	
	|sys|
	sys := self visibleSystemWindows.
	sys ifEmpty: [^nil].
	^sys after: self currentWindow ifAbsent: [sys first]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/18/2007 16:18'!
nextWindow
	"Answer the next window to navigate to."

	|sys|
	sys := self systemWindows.
	sys ifEmpty: [^nil].
	^sys after: self currentWindow ifAbsent: [sys first]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 12/11/2007 16:53'!
openModal: aSystemWindow
	"Open the given window locking the receiver until it is dismissed.
	Set the pane color to match the current theme.
	Answer the system window."
	
	aSystemWindow
		setWindowColor: self theme windowColor.
	^super openModal: aSystemWindow! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/18/2007 16:18'!
previousWindow
	"Answer the previous window to navigate to."

	|sys|
	sys := self systemWindows.
	sys ifEmpty: [^nil].
	^sys before: self currentWindow ifAbsent: [sys last]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/3/2010 17:59'!
resizeBackgroundMorph
	"Resize the background morph to fit the world."

	self backgroundMorph isNil ifFalse: [
		self backgroundMorph extent: self extent]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/18/2007 14:36'!
systemWindows
	"Answer the system windows in the world."
	
	^self submorphsSatisfying: [:m | m isSystemWindow]! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 4/29/2011 00:37'!
themeChanged
	"The theme has changed.
	Update the desktop wallpaper if appropriate."

	(self theme desktopImageFor: self) ifNotNil: [:aForm |
		self color: Color white.
		self backgroundImage: aForm layout: self theme desktopImageLayout].
	super themeChanged! !

!PasteUpMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/29/2008 11:00'!
visibleSystemWindows
	"Answer the visible system windows in the world."
	
	^self submorphsSatisfying: [:m | m isSystemWindow and: [m visible]]! !

!Color methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/17/2007 11:41'!
contrastingColor
	"Answer black or white depending on the luminance."

	self isTransparent ifTrue: [^Color black].
	^self luminance > 0.5
		ifTrue: [Color black]
		ifFalse: [Color white]! !

!Color methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/21/2008 16:35'!
fillRectangle: aRectangle on: aCanvas
	"Fill the given rectangle on the given canvas with the receiver."
	
	aCanvas fillRectangle: aRectangle basicFillStyle: self! !

!Color methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/21/2006 09:48'!
pixelWord32
	"Returns an integer representing the bits that appear in a single pixel of this color in a Form of depth 32.
	Transparency: The pixel value zero is reserved for transparent. For depths greater than 8, black maps to the darkest possible blue.
	Just a little quicker if we are dealing with RGBA colors at 32 bit depth."

	| val |
	"eight bits per component; top 8 bits set to all ones (opaque alpha)"
	val := LargePositiveInteger new: 4.
	val at: 3 put: ((rgb bitShift: -22) bitAnd: 16rFF).
	val at: 2 put: ((rgb bitShift: -12) bitAnd: 16rFF).
	val at: 1 put: ((rgb bitShift: -2) bitAnd: 16rFF).
	val = 0 ifTrue: [val at: 1 put: 1].  "closest non-transparent black"
	val at: 4 put: 16rFF.  "opaque alpha"
	^val
! !

!TransformMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 11/17/2006 10:12'!
clipSubmorphs
	"Answer true since we do!!
	This avoids the senseless over-invalidation
	with lists etc."
	
	^true! !

!TransformMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/16/2007 11:35'!
extent: aPoint
	"Changed to not cause layoutChanged on the receiver."
	
	bounds extent = aPoint ifTrue: [^ self].
	self changed.
	bounds := (bounds topLeft extent: aPoint) rounded.
	super layoutChanged. "skip submorph bounds recalculation"
	self changed.
! !

TransformMorph subclass: #TransformWithLayoutMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TransformWithLayoutMorph commentStamp: 'gvc 5/18/2007 10:18' prior: 0!
A transform morph that allows the use of a layout policy to arrange submorphs.!

!TransformWithLayoutMorph methodsFor: 'as yet unclassified' stamp: 'gvc 9/1/2006 16:06'!
doLayoutIn: layoutBounds 
	"Compute a new layout based on the given layout bounds."

	"Note: Testing for #bounds or #layoutBounds would be sufficient to
	figure out if we need an invalidation afterwards but #outerBounds
	is what we need for all leaf nodes so we use that."

	| layout box priorBounds |
	priorBounds := self outerBounds.
	submorphs isEmpty ifTrue: [^fullBounds := priorBounds].
	"Send #ownerChanged to our children"
	submorphs do: [:m | m ownerChanged].
	layout := self layoutPolicy.
	layout ifNotNil: [layout layout: self in: (0@0 extent: layoutBounds extent // self scale)].
	self adjustLayoutBounds.
	fullBounds := self privateFullBounds.
	box := self outerBounds.
	box = priorBounds 
		ifFalse: [self invalidRect: (priorBounds quickMerge: box)]! !

!TransformWithLayoutMorph methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2006 14:56'!
fullBounds
	"Do the ordinary thing. See comment in superclass."

	^self perform: #fullBounds withArguments: #() inSuperclass: Morph! !

!Canvas methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/21/2008 16:34'!
fillRectangle: aRectangle basicFillStyle: aFillStyle
	"Fill the given rectangle with the given, non-composite, fill style
	Note: The default implementation does not recognize any enhanced fill styles."
	
	self fillRectangle: aRectangle color: aFillStyle asColor.! !

!Canvas methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/14/2006 14:33'!
frameRectangle: aRectangle width: width colors: colors dashes: dashes
	"Draw a rectangle with the given width, colors and dash lengths."

	self
		frameRectangle: aRectangle
		width: width
		colors: colors
		dashes: dashes
		offset: self origin! !

!Canvas methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/18/2006 16:52'!
frameRectangle: aRectangle width: width colors: colors dashes: dashes offset: offset
	"Draw a rectangle with the given width, colors and dash lengths.
	The offset specifies how the coordinate system is translated from the screen origin
	(infinite forms are 0@0 screen based)."

	|o s hf vf c r ds di d os l|
	width < 1 ifTrue: [^self].
	dashes size < 2
		ifTrue: [^self  frameRectangle: aRectangle width: width color: colors first].
	r := aRectangle.
	s := dashes sum * width.
	ds := dashes size.
	di := 1.
	d := (dashes at: di) * width.
	c := colors at: di.
	hf := Form extent: s @ 1 depth: 32.
	r height >= width ifTrue: [
		o := r left + offset x \\ s.
		0 to: s - 1 do: [:x |
			hf colorAt: x + o \\ s  @ 0 put: c.
			d := d - 1.
			d = 0 ifTrue: [
				di := di \\ ds + 1.
				d := (dashes at: di) * width.
				c := colors at: di]].
		os := 0.
		l := r width truncateTo: width.
		self
			fillRectangle: (r topLeft + (os@0) extent: l@width)
			color: (InfiniteForm with: hf)].
	vf := Form extent: 1 @ s depth: 32.
	r width >= width ifTrue: [
		o := r top + offset y + width + (s - (r width \\ s)) \\ s.
		0 to: s - 1 do: [:y |
			vf colorAt: 0 @ (y + o \\ s) put: c.
			d := d - 1.
			d = 0 ifTrue: [
				di := di \\ ds + 1.
				d := (dashes at: di) * width.
				c := colors at: di]].
		os := width - (r width \\ width).
		l := r height - os truncateTo: width.
		self
			fillRectangle: (r topRight + (width negated @ os) extent: width@l)
			color: (InfiniteForm with: vf)].
	r height > width ifTrue: [
		o := r right + offset x - (width * 2) + (r height \\ s) + (r width \\ s) \\ s.
		0 to: s - 1 do: [:x |
			hf colorAt: o + s -1 - x \\ s  @ 0 put: c.
			d := d - 1.
			d = 0 ifTrue: [
				di := di \\ ds + 1.
				d := (dashes at: di) * width.
				c := colors at: di]].
		os := width - (r width \\ width + (r height \\ width) \\ width).
		l := r width - os truncateTo: width.
		os := (r width - os) \\ width.
		self
			fillRectangle: (r bottomLeft + (os @ width negated) extent: l@width)
			color: (InfiniteForm with: hf)].
	r width > width ifTrue: [
		o :=  r top + offset y + (r height * 2 \\ s) + (r width * 2 \\ s) - (width * 3) \\ s.
		0 to: s - 1 do: [:y |
			vf colorAt: 0 @ (o + s -1 - y \\ s) put: c.
			d := d - 1.
			d = 0 ifTrue: [
				di := di \\ ds + 1.
				d := (dashes at: di) * width.
				c := colors at: di]].
		l := r height - (2 * width) + os.
		os := width.
		self
			fillRectangle: (r topLeft + (0@os) extent: width@l)
			color: (InfiniteForm with: vf)]! !

!Canvas methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/17/2006 10:42'!
line: pt1 to: pt2 width: width colors: colors dashes: dashes startingOffset: startingOffset 
	"Draw a line using the given width, colors and dash lengths.
	Dash lengths are considered as multiples of width."

	|dist deltaBig segmentOffset phase segmentLength startPoint distDone endPoint segLens lens l ep|
	width = 0 ifTrue: [^startingOffset].
	dist := pt1 dist: pt2.
	dist = 0 ifTrue: [^startingOffset].
	(dashes allSatisfy: [:d | d = 0]) ifTrue: [^startingOffset].
	deltaBig := pt2 - pt1.
	segLens := dashes collect: [:d | d * width].
	
	"Figure out what phase we are in and how far, given startingOffset."
	segmentOffset := startingOffset \\ segLens sum.
	lens := segLens readStream.
	l := 0.
	[lens atEnd or: [segmentOffset <= (l := l + lens next)]] whileFalse: [].
	segmentLength := lens atEnd
		ifTrue: [phase := segLens size.
				segLens sum - segmentOffset]
		ifFalse: [phase := lens position.
				(segLens first: phase) sum - segmentOffset.].
	startPoint := pt1.
	distDone := 0.0.
	segmentLength < (segLens at: phase)
		ifTrue: [startPoint := startPoint + (deltaBig * segmentLength / dist).
				distDone := distDone + segmentLength.
				phase := phase \\ segLens size + 1.
				segmentLength :=  (segLens at: phase)].
	[distDone < dist] whileTrue: 
			[segmentLength := segmentLength min: dist - distDone.
			endPoint := startPoint + (deltaBig * segmentLength / dist).
			ep := startPoint + (deltaBig * (segmentLength - width max: 0) / dist).
			self 
				line: startPoint truncated
				to: ep truncated
				width: width
				color: (colors at: phase).
			distDone := distDone + segmentLength.
			phase := phase \\ segLens size + 1.
			startPoint := endPoint.
			segmentLength := segLens at: phase].
	^startingOffset + distDone! !

LayoutPolicy subclass: #RowLayout
	instanceVariableNames: 'cachedMinExtent cachedMinExtents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!RowLayout commentStamp: 'gvc 5/31/2007 16:12' prior: 0!
A simple row layout.!

!RowLayout methodsFor: 'as yet unclassified' stamp: 'gvc 5/31/2007 17:20'!
flushLayoutCache
	"Flush any cached information associated with the receiver."
	
	cachedMinExtent := nil! !

!RowLayout methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
layout: aMorph in: layoutBounds
	"Compute the layout for the given morph based on the new bounds.
	Supports submorph hResizing, vResizing, cellInset, cellPositioning
	(top, *center, bottom*) and listCentering."

	| props spare extra height inset newBounds minExt fillCount x width|
	aMorph submorphs ifEmpty: [^self].
	props := aMorph assureTableProperties.
	minExt := aMorph minWidth@aMorph minHeight - aMorph extent + aMorph layoutBounds extent.
	newBounds := layoutBounds origin extent: (layoutBounds extent max: minExt).
	width := 0.
	width := (self minExtentOf: aMorph in: newBounds) x.
	spare := newBounds width - width max: 0.
	fillCount := 0.
	spare > 0
		ifTrue: [fillCount := aMorph submorphs inject: 0 into: [:tot :m |
					tot + (m hResizing == #spaceFill ifTrue: [1] ifFalse: [0])].
				extra := fillCount = 0
					ifTrue: [0]
					ifFalse: [spare // fillCount].
				spare := spare - (fillCount - 1 * extra)]
		ifFalse: [extra := 0].
	x := fillCount > 0
		ifTrue: [newBounds left]
		ifFalse: [props listCentering == #center
					ifTrue: [newBounds center x - (width // 2)]
					ifFalse: [props listCentering == #bottomRight
								ifTrue: [newBounds right - width]
								ifFalse: [newBounds left]]].
	height := newBounds height.
	inset := props cellInset isPoint ifTrue: [props cellInset x] ifFalse: [props cellInset]. 
	aMorph submorphs with: cachedMinExtents do: [:m :ext | | pos vr box cell |
		width := m hResizing == #spaceFill
			ifTrue: [fillCount := fillCount - 1.
					ext x + (fillCount > 0
						ifTrue: [spare]
						ifFalse: [extra])]
			ifFalse: [ext x].
		cell := x@newBounds top extent: width@height.
		((vr := m vResizing) == #shrinkWrap or: [m bounds ~= cell])
			ifTrue: [((vr == #shrinkWrap) not and: [m extent = cell extent])
						ifTrue: [m position: cell origin]
						ifFalse: [box := m bounds.
								m hResizing == #spaceFill 
									ifTrue: [box := cell origin extent: cell width @ box height].
								vr  == #spaceFill
									ifTrue: [box := box origin extent: box width @ cell height].
								vr  == #shrinkWrap
									ifTrue:[box := box origin extent: box width @ ext y].
								pos := props cellPositioning.
								box := box align: (box perform: pos) with: (cell perform: pos).
								m bounds: box]].
		x := x + width + inset]! !

!RowLayout methodsFor: 'as yet unclassified' stamp: 'gvc 7/1/2010 12:15'!
minExtentOf: aMorph in: newBounds
	"Return the minimal size aMorph's children would require given the new bounds"
	
	| props extent|
	cachedMinExtent ifNotNil: [^cachedMinExtent].
	aMorph submorphs ifEmpty: [^aMorph minWidth @ aMorph minHeight].
	extent := 0@0.
	cachedMinExtents := aMorph submorphs collect: [:m | | min |
		min := m minExtent.
		extent := extent x + min x @ (extent y max: min y).
		min].
	props := aMorph assureTableProperties.
	^cachedMinExtent := extent + (aMorph submorphs size - 1 * 
		(props cellInset isPoint ifTrue: [props cellInset x] ifFalse: [props cellInset]) @ 0)! !

LayoutPolicy subclass: #StackLayout
	instanceVariableNames: 'cachedMinExtent cachedMinExtents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!StackLayout methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2009 14:23'!
flushLayoutCache
	"Flush any cached information associated with the receiver."
	
	cachedMinExtent := nil! !

!StackLayout methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2009 14:38'!
layout: aMorph in: layoutBounds
	"Compute the layout for the given morph based on the new bounds.
	Supports submorph hResizing, vResizing, cellInset, cellPositioning
	(top, *center, bottom*)."

	|props cell box pos vr newBounds minExt|
	aMorph submorphs ifEmpty: [^self].
	props := aMorph assureTableProperties.
	minExt := self minExtentOf: aMorph in: layoutBounds.
	newBounds := layoutBounds origin extent: (layoutBounds extent max: minExt).
	cell := newBounds.
	aMorph submorphs with: cachedMinExtents do: [:m :ext |
		((vr := m vResizing) == #shrinkWrap or: [m bounds ~= cell])
			ifTrue: [((vr == #shrinkWrap) not and: [m extent = cell extent])
						ifTrue: [m position: cell origin]
						ifFalse: [box := m bounds.
								m hResizing == #spaceFill 
									ifTrue: [box := cell origin extent: cell width @ box height].
								vr  == #spaceFill
									ifTrue: [box := box origin extent: box width @ cell height].
								vr  == #shrinkWrap
									ifTrue:[box := box origin extent: box width @ ext y].
								pos := props cellPositioning.
								box := box align: (box perform: pos) with: (cell perform: pos).
								m bounds: box]]]! !

!StackLayout methodsFor: 'as yet unclassified' stamp: 'gvc 10/21/2009 14:30'!
minExtentOf: aMorph in: newBounds
	"Return the minimal size aMorph's children would require given the new bounds"
	
	|min extent|
	cachedMinExtent ifNotNil: [^cachedMinExtent].
	aMorph submorphs ifEmpty: [^self].
	extent := 0@0.
	cachedMinExtents := aMorph submorphs collect: [:m |
		min := m minExtent.
		extent := extent max: min.
		min].
	^cachedMinExtent := extent! !

!BottomRightGripMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/12/2007 10:52'!
containsPoint: aPoint
	"Answer true only if on edges."
	
	|w|
	^(super containsPoint: aPoint) and: [
		w := SystemWindow borderWidth.
		((self bounds translateBy: (w@w) negated)
			containsPoint: aPoint) not]! !

!BottomRightGripMorph methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/13/2008 10:21'!
drawOn: aCanvas
	"Draw the grip on the given canvas."

	| dotBounds alphaCanvas windowBorderWidth dotBounds2 |
	
	self shouldDraw ifFalse: [^self].

	windowBorderWidth := SystemWindow borderWidth.
	alphaCanvas := aCanvas asAlphaBlendingCanvas: 0.7.	
	"alphaCanvas
		frameRectangle: bounds color: Color blue."

	dotBounds := self bounds.
	dotBounds2 := dotBounds left: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 bottom - windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.
	
	dotBounds2 := dotBounds right: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 top: (dotBounds2 bottom - windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 left: (dotBounds2 left + 7).
	dotBounds2 := dotBounds2 right: (dotBounds2 right - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor.

	dotBounds2 := dotBounds left: (dotBounds right - windowBorderWidth).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - windowBorderWidth).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self handleColor.

	dotBounds2 := dotBounds2 top: (dotBounds2 top + 7).
	dotBounds2 := dotBounds2 bottom: (dotBounds2 bottom - 7).
	alphaCanvas
		fillRectangle: dotBounds2
		color: self dotColor! !

!TableLayout methodsFor: '*Polymorph-Widgets-override' stamp: 'gvc 2/25/2010 19:44'!
layoutLeftToRight: aMorph in: newBounds
	"An optimized left-to-right list layout"
	| inset extent block posX posY centering extraPerCell amount minX minY maxX maxY n width extra last cell size height sum vFill first |
	size := properties minCellSize asPoint. minX := size x. minY := size y.
	size := properties maxCellSize asPoint. maxX := size x. maxY := size y.
	inset := properties cellInset asPoint x.
	extent := newBounds extent.
	n := 0. vFill := false. sum := 0.
	width := height := 0.
	first := last := nil.
	block := [:m| | sizeY sizeX props |
		props := m layoutProperties ifNil:[m].
		props disableTableLayout ifFalse:[
			n := n + 1.
			cell := LayoutCell new target: m.
			(props hResizing == #spaceFill) ifTrue:[
				cell hSpaceFill: true.
				extra := m spaceFillWeight.
				cell extraSpace: extra.
				sum := sum + extra.
			] ifFalse:[cell hSpaceFill: false].
			(props vResizing == #spaceFill) ifTrue:[vFill := true].
			size := m minExtent. sizeX := size x. sizeY := size y.
			sizeX < minX
				ifTrue:[sizeX := minX]
				ifFalse:[sizeX > maxX ifTrue:[sizeX := maxX]].
			sizeY < minY
				ifTrue:[sizeY := minY]
				ifFalse:[sizeY > maxY ifTrue:[sizeY := maxY]].
			cell cellSize: sizeX.
			last ifNil:[first := cell] ifNotNil:[last nextCell: cell].
			last := cell.
			width := width + sizeX.
			sizeY > height ifTrue:[height := sizeY].
		].
	].
	properties reverseTableCells
		ifTrue:[aMorph submorphsReverseDo: block]
		ifFalse:[aMorph submorphsDo: block].

	n > 1 ifTrue:[width := width + (n-1 * inset)].

	(properties hResizing == #shrinkWrap and:[properties rubberBandCells or:[sum isZero]])
		ifTrue:[extent := width @ (extent y max: height)].
	(properties vResizing == #shrinkWrap and:[properties rubberBandCells or:[vFill not]])
		ifTrue:[extent := (extent x max: width) @ height].

	posX := newBounds left.
	posY := newBounds top.

	"Compute extra vertical space"
	extra := extent y - height.
	extra < 0 ifTrue:[extra := 0].
	extra > 0 ifTrue:[
		vFill ifTrue:[
			height := extent y.
		] ifFalse:[
			centering := properties wrapCentering.
			centering == #bottomRight ifTrue:[posY := posY + extra].
			centering == #center ifTrue:[posY := posY + (extra // 2)]
		].
	].


	"Compute extra horizontal space"
	extra := extent x - width.
	extra < 0 ifTrue:[extra := 0].
	extraPerCell := 0.
	extra > 0 ifTrue:[
		sum isZero ifTrue:["extra space but no #spaceFillers"
			centering := properties listCentering.
			centering == #bottomRight ifTrue:[posX := posX + extra].
			centering == #center ifTrue:[posX := posX + (extra // 2)].
		] ifFalse:[extraPerCell := extra asFloat / sum asFloat].
	].

	n := 0.
	extra := last := 0.
	cell := first.
	[cell == nil] whileFalse:[
		n := n + 1.
		width := cell cellSize.
		(extraPerCell > 0 and:[cell hSpaceFill]) ifTrue:[
			extra := (last := extra) + (extraPerCell * cell extraSpace).
			amount := extra truncated - last truncated.
			width := width + amount.
		].
		cell target layoutInBounds: (posX @ posY extent: width @ height).
		posX := posX + width + inset.
		cell := cell nextCell.
	].
! !

SystemWindow subclass: #PluggableSystemWindow
	instanceVariableNames: 'getLabelSelector getChildrenSelector children closeWindowSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!PluggableSystemWindow commentStamp: 'ar 2/11/2005 20:14' prior: 0!
A pluggable system window. Fixes the issues with label retrieval and adds support for changing children.!

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'md 8/31/2005 07:59'!
addPaneMorph: aMorph
	self addMorph: aMorph fullFrame: aMorph layoutFrame! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 9/17/2005 21:05'!
closeWindowSelector
	^closeWindowSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 9/17/2005 21:05'!
closeWindowSelector: aSymbol
	closeWindowSelector := aSymbol! !

!PluggableSystemWindow methodsFor: 'initialization' stamp: 'ar 9/17/2005 21:08'!
delete
	closeWindowSelector ifNotNil:[model perform: closeWindowSelector].
	super delete.
! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getLabelSelector
	^getLabelSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:53'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol.
	self update: aSymbol.! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:52'!
label
	^label contents! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:51'!
label: aString
	self setLabel: aString.! !

!PluggableSystemWindow methodsFor: 'updating' stamp: 'ar 2/11/2005 20:15'!
update: what
	what ifNil:[^self].
	what == getLabelSelector ifTrue:[self setLabel: (model perform: getLabelSelector)].
	what == getChildrenSelector ifTrue:[
		children ifNil:[children := #()].
		self removeAllMorphsIn: children.
		children := model perform: getChildrenSelector.
		self addAllMorphs: children.
		children do:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].
	^super update: what! !

SystemWindow subclass: #StandardWindow
	uses: TEasilyThemed - {#theme}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!StandardWindow commentStamp: 'AlainPlantec 10/17/2009 18:59' prior: 0!
Themed SystemWindow that avoids being picked up except via the title bar. Supports opening in "fullscreen" mode, taking docking bars into account.
Prevents yellow button menu.
Uses TEasilyThemed for easy theme access to subclasses.!

StandardWindow class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

StandardWindow subclass: #DialogWindow
	instanceVariableNames: 'cancelled isResizeable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!DialogWindow commentStamp: 'gvc 5/18/2007 13:26' prior: 0!
Dialog style window with no window controls (expand, collapse etc). Usually opened modally (the morph that is used to modally open determines the modal scope, use of World implies "system modal").
Designed to be subclassed with content.
Supports Escape key for cancel and Enter key for default button.!

DialogWindow subclass: #AboutDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!AboutDialogWindow commentStamp: 'gvc 5/18/2007 13:53' prior: 0!
Default superclass for application about dialogs.!

!AboutDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 16:32'!
newButtons
	"Answer new buttons as appropriate."

	^{self newCloseButton isDefault: true}! !

DialogWindow subclass: #AbstractFontSelectorDialogWindow
	instanceVariableNames: 'fontFamilies selectedFont textPreviewMorph fontFamilyIndex fontSizeIndex isBold isItalic isUnderlined isStruckOut previewText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!AbstractFontSelectorDialogWindow commentStamp: 'gvc 5/18/2007 13:04' prior: 0!
Dialog based font chooser with preview.!

!AbstractFontSelectorDialogWindow class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/19/2010 20:22'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallFontsIcon! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2008 15:49'!
defaultFontFamilies
	"Answer the set of available fonts families that are supported in the font that they represent."
	
	self subclassResponsibility! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2008 15:31'!
defaultPreviewText
	"Answer the default text to use for the preview of the font."

	^(33 to: 127) asByteArray asString! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:47'!
familyName
	"Answer the selected family name or nil if none."

	(self fontFamilyIndex between: 1 and: self fontFamilies size)
		ifFalse: [^nil].
	^(self fontFamilies at: self fontFamilyIndex) asString! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:40'!
fontFamilies
	"Answer the set of available fonts families that are supported as Text objects
	in the font that they represent."
	
	^fontFamilies ifNil: [
		self fontFamilies: self defaultFontFamilies.
		fontFamilies]! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:02'!
fontFamilies: anObject
	"Set the value of fontFamilies"

	fontFamilies := anObject! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 14:30'!
fontFamilyIndex
	"Answer the value of fontFamilyIndex"

	^ fontFamilyIndex! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:19'!
fontFamilyIndex: anObject
	"Set the value of fontFamilyIndex"

	fontFamilyIndex := anObject.
	self updateSelectedFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 16:03'!
fontSize
	"Answer the selected font size or nil if none."

	(self fontSizeIndex between: 1 and: self fontSizes size)
		ifFalse: [^nil].
	^self fontSizes at: self fontSizeIndex! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 14:30'!
fontSizeIndex
	"Answer the value of fontSizeIndex"

	^ fontSizeIndex! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:19'!
fontSizeIndex: anObject
	"Set the value of fontSizeIndex"

	fontSizeIndex := anObject.
	self updateSelectedFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 14:31'!
fontSizes
	"Answer the set of available fonts sizes that are supported."

	^#(6 7 8 9 10 11 12 13 14 15 16 18 20 21 22 24 26 28 32 36 48)! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:22'!
initialize
	"Initialize the receiver."

	self
		isBold: false;
		isItalic: false;
		isUnderlined: false;
		isStruckOut: false;
		previewText: self defaultPreviewText;
		fontFamilyIndex: 0;
		fontSizeIndex: 0.
	super initialize! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isBold
	"Answer the value of isBold"

	^ isBold! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 4/21/2009 17:07'!
isBold: anObject
	"Set the value of isBold"

	isBold := anObject.
	self changed: #isBold! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'lr 3/14/2010 21:13'!
isFreeTypeInstalled
	"Answer whether FreeType appears to be installed."

	^ Smalltalk globals includesKey: #FreeTypeFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isItalic
	"Answer the value of isItalic"

	^ isItalic! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 4/21/2009 17:07'!
isItalic: anObject
	"Set the value of isItalic"

	isItalic := anObject.
	self changed: #isItalic! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isStruckOut
	"Answer the value of isStruckOut"

	^ isStruckOut! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 4/21/2009 17:07'!
isStruckOut: anObject
	"Set the value of isStruckOut"

	isStruckOut := anObject.
	self changed: #isStruckOut! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 15:12'!
isUnderlined
	"Answer the value of isUnderlined"

	^ isUnderlined! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 4/21/2009 17:07'!
isUnderlined: anObject
	"Set the value of isUnderlined"

	isUnderlined := anObject.
	self changed: #isUnderlined! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2008 15:35'!
matchingFont
	"Answer the font that matches the selections."

	self subclassResponsibility! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:02'!
newBoldButtonMorph
	"Answer a button for the boldness of the font."
	
	^self
		newButtonFor: self
		getState: #isBold
		action: #toggleBold
		arguments: nil
		getEnabled: nil
		labelForm: self theme smallBoldIcon
		help: 'Toggle bold font' translated! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:48'!
newContentMorph
	"Answer a new content morph."

	self textPreviewMorph: self newTextPreviewMorph.
	^(self newColumn: {
		(self newRow: {
			self newGroupbox: 'Family' translated for:
				self newFontFamilyMorph.
			(self newColumn: {
				(self newGroupbox: 'Style' translated for: 
					self newFontStyleButtonRowMorph)
					vResizing: #shrinkWrap.
				self newGroupbox: 'Point size' translated for:
					self newFontSizeMorph})
				hResizing: #shrinkWrap})
			vResizing: #spaceFill.
		(self newGroupbox: 'Preview' translated for:
			self textPreviewMorph)
			vResizing: #shrinkWrap})
		minWidth: 350;
		minHeight: 400! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:49'!
newFontFamilyMorph
	"Answer a list for the font family of the font."

	|highestFont|
	highestFont := self fontFamilies first fontAt: 1 withStyle: TextStyle default.
	self fontFamilies do: [:ff | |f|
		f := ff fontAt: 1 withStyle: TextStyle default.
		f height > highestFont height
			ifTrue: [highestFont := f]].
	^(self
		newListFor: self
		list: #fontFamilies
		selected: #fontFamilyIndex
		changeSelected: #fontFamilyIndex:
		help: nil)
		font: highestFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/7/2007 11:49'!
newFontSizeMorph
	"Answer a list for the font size of the font."

	^self
		newListFor: self
		list: #fontSizes
		selected: #fontSizeIndex
		changeSelected: #fontSizeIndex:
		help: nil! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:48'!
newFontStyleButtonRowMorph
	"Answer a new font style button row morph."

	^self newRow: {
		self newBoldButtonMorph.
		self newItalicButtonMorph.
		self newUnderlinedButtonMorph.
		self newStruckOutButtonMorph}! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:02'!
newItalicButtonMorph
	"Answer a button for the italic emphasis of the font."
	
	^self
		newButtonFor: self
		getState: #isItalic
		action: #toggleItalic
		arguments: nil
		getEnabled: nil
		labelForm: self theme smallItalicIcon
		help: 'Toggle italic font' translated! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:02'!
newStruckOutButtonMorph
	"Answer a button for the struck out emphasis of the font."
	
	^self
		newButtonFor: self
		getState: #isStruckOut
		action: #toggleStruckOut
		arguments: nil
		getEnabled: nil
		labelForm: self theme smallStrikeOutIcon
		help: 'Toggle struck-out font' translated! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 16:31'!
newTextPreviewMorph
	"Answer a text entry morph for the preview of the font."

	^(self
		newTextEditorFor: self
		getText: #previewText 
		setText: nil
		getEnabled: nil)
		vResizing: #rigid;
		enabled: false;
		extent: 20@90! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:02'!
newUnderlinedButtonMorph
	"Answer a button for the italic emphasis of the font."
	
	^self
		newButtonFor: self
		getState: #isUnderlined
		action: #toggleUnderlined
		arguments: nil
		getEnabled: nil
		labelForm: self theme smallUnderlineIcon
		help: 'Toggle underlined font' translated! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 4/21/2009 17:30'!
previewText
	"Answer the value of previewText"

	^previewText asText addAttribute: (TextEmphasis new emphasisCode: self textEmphasisCode)! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/18/2007 13:07'!
previewText: anObject
	"Set the value of previewText"

	previewText := anObject.
	self changed: #previewText! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 13:41'!
selectedFont
	"Answer the value of selectedFont"

	^ selectedFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 10/9/2007 14:19'!
selectedFont: anObject
	"Set the value of selectedFont"

	selectedFont := anObject ifNil: [TextStyle defaultFont].
	self updateFromSelectedFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:33'!
textEmphasisCode
	"Answer the current bitmask for the text emphasis."

	^(((self isBold ifTrue: [1] ifFalse: [0]) bitOr:
		(self isItalic ifTrue: [2] ifFalse: [0])) bitOr:
		(self isUnderlined ifTrue: [4] ifFalse: [0])) bitOr:
		(self isStruckOut ifTrue: [16] ifFalse: [0])! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 13:41'!
textPreviewMorph
	"Answer the value of textPreviewMorph"

	^ textPreviewMorph! !

!AbstractFontSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/3/2007 13:41'!
textPreviewMorph: anObject
	"Set the value of textPreviewMorph"

	textPreviewMorph := anObject! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:31'!
toggleBold
	"Toggle the font bold emphasis."

	self isBold: self isBold not.
	self updateSelectedFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:31'!
toggleItalic
	"Toggle the font italic emphasis."

	self isItalic: self isItalic not.
	self updateSelectedFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:31'!
toggleStruckOut
	"Toggle the font struck out emphasis."

	self isStruckOut: self isStruckOut not.
	self updateSelectedFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/3/2007 15:31'!
toggleUnderlined
	"Toggle the font underlined emphasis."

	self isUnderlined: self isUnderlined not.
	self updateSelectedFont! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:21'!
updateFromSelectedFont
	"Update our state based on the selected font."

	self subclassResponsibility! !

!AbstractFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/4/2007 10:25'!
updateSelectedFont
	"Update the selected font to reflect the choices."

	self selectedFont: self matchingFont! !

AbstractFontSelectorDialogWindow subclass: #FreeTypeFontSelectorDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!FreeTypeFontSelectorDialogWindow commentStamp: 'LaurentLaffont 4/15/2011 20:19' prior: 0!
I'm a dialog to select a font. 

Usage example:

|fontSelector|
fontSelector := FreeTypeFontSelectorDialogWindow new.
UITheme builder openModal: fontSelector.
fontSelector selectedFont inspect.!

!FreeTypeFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/25/2011 17:33'!
defaultFontFamilies
	"Answer the set of available fonts families that are supported in the font that they represent."
	
	|fonts defaultFont|
	defaultFont := TextStyle default fontOfPointSize: self theme listFont pointSize.
	fonts := (LogicalFontManager current allFamilies asSortedCollection: [:a :b | 
		a familyName <= b familyName]) collect: [:ff |
			 (ff
				closestMemberWithStretchValue: LogicalFont stretchRegular
				weightValue: LogicalFont weightRegular
				slantValue: LogicalFont slantRegular)
				asLogicalFontOfPointSize: self theme listFont pointSize].
	^fonts collect: [:f | |dispFont|
		dispFont := defaultFont.
		f familyName asText
			addAttribute: (TextFontReference toFont: dispFont)]! !

!FreeTypeFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:14'!
matchingFont
	"Answer the font that matches the selections."

	|lf emp|
	self familyName ifNil: [^TextStyle defaultFont].
	lf := LogicalFont
		familyName: self familyName 
		pointSize: (self fontSize ifNil: [10]).
	emp := self isBold
		ifTrue: [TextEmphasis bold emphasisCode]
		ifFalse: [TextEmphasis normal emphasisCode].
	self isItalic
		ifTrue: [emp := emp + TextEmphasis italic emphasisCode].
	self isUnderlined
		ifTrue: [emp := emp + TextEmphasis underlined emphasisCode].
	self isStruckOut
		ifTrue: [emp := emp + TextEmphasis struckOut emphasisCode].
	lf := lf emphasis: emp.
	lf realFont ifNil: [^TextStyle defaultFont].
	^lf ! !

!FreeTypeFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/21/2009 17:49'!
newFontStyleButtonRowMorph
	"Answer a new font style button row morph."

	^self newRow: {
		self newBoldButtonMorph.
		self newItalicButtonMorph}! !

!FreeTypeFontSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:39'!
updateFromSelectedFont
	"Update our state based on the selected font."

	|font|
	font := self selectedFont ifNil: [TextStyle defaultFont].
	fontFamilyIndex := (self fontFamilies indexOf: font familyName).
	fontSizeIndex := (self fontSizes indexOf: font pointSize).
	isBold := (font emphasis allMask: TextEmphasis bold emphasisCode).
	isItalic := (font emphasis allMask: TextEmphasis italic emphasisCode).
	self
		changed: #fontFamilyIndex;
		changed: #fontSizeIndex;
		changed: #isBold;
		changed: #isItalic.
	self textPreviewMorph ifNotNil: [:tp |
		tp font: self selectedFont.
		self changed: #previewText]! !

DialogWindow subclass: #ColorSelectorDialogWindow
	instanceVariableNames: 'selectedColor hsvaMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!ColorSelectorDialogWindow commentStamp: 'gvc 5/18/2007 13:35' prior: 0!
Standard dialog for selecting a colour by HSVA colour selector, picking from the screen or editing of values.!

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:30'!
alpha
	"Answer the alpha value of the selected color."

	^(self selectedColor alpha * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:21'!
alpha: anInteger
	"Set the alpha value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: (c alpha: anInteger / 255)! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'dik 6/27/2010 16:56'!
basicSelectedColor: anObject
	"Set the value of selectedColor"

	selectedColor := anObject.
	
	self
		changed: #selectedColor;
		changed: #red;
		changed: #green;
		changed: #blue;
		changed: #hue;
		changed: #saturation;
		changed: #brightness;
		changed: #alpha.
		
	self announcer announce: (ColorChanged to: selectedColor).! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:30'!
blue
	"Answer the blue value of the selected color."

	^(self selectedColor blue * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:14'!
blue: anInteger
	"Set the blue value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color r: c red * 255 g: c green * 255 b: anInteger range: 255) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:38'!
brightness
	"Answer the brightness value of the selected color."

	^(self selectedColor brightness * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:37'!
brightness: anInteger
	"Set the brightness value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color h: c hue s: c saturation v: anInteger / 255) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 11:13'!
colorSelected: aColor
	"A color has been selected.."

	self basicSelectedColor: aColor! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'HenrikSperreJohansen 5/21/2010 14:11'!
defaultLabel
	"Answer the default label for the receiver."

	^'Color Selector' translated! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:30'!
green
	"Answer the green value of the selected color."

	^(self selectedColor green * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:14'!
green: anInteger
	"Set the green value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color r: c red * 255 g: anInteger b: c blue * 255 range: 255) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/22/2006 10:04'!
hsvaMorph
	"Answer the value of hsvaMorph"

	^ hsvaMorph! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/22/2006 10:04'!
hsvaMorph: anObject
	"Set the value of hsvaMorph"

	hsvaMorph := anObject! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:38'!
hue
	"Answer the hue value of the selected color."

	^(self selectedColor hue / 359 * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:16'!
hue: anInteger
	"Set the hue value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color h: (anInteger / 255 * 359) rounded s: c saturation v: c brightness) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 10:06'!
initialize
	"Initialize the receiver."

	self
		basicSelectedColor: Color blue.
	super initialize.
	self selectedColor: self selectedColor! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:11'!
newColorComponentFieldMorph: aspect
	"Answer a text entry for the specified aspect of the color."

	^(self
		newTextEntryFor: self
		get: aspect
		set: (aspect, ':') asSymbol
		class: Integer
		getEnabled: nil
		help: nil)
		acceptOnFocusChange: true;
		minWidth: 40! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/19/2010 20:25'!
newColorPickerButtonMorph
	"Answer a button to enable picking of colour."

	^self
		newButtonFor: self
		getState: nil
		action: #pickColor
		arguments: nil
		getEnabled: nil
		labelForm: ((self theme eyedropperIcon)
						scaledIntoFormOfSize: 16)
		help: 'Pick a color from the screen' translated! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'HenrikSperreJohansen 5/21/2010 14:16'!
newColorPresenterMorph
	"Answer a color presenter."

	^self
		newColorPresenterFor: self
		getColor: #selectedColor 
		help: 'Shows the selected color' translated! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'HenrikSperreJohansen 5/21/2010 14:17'!
newContentMorph
	"Answer a new content morph."

	self hsvaMorph: self newHSVAColorSelectorMorph.
	^self newRow: {
		self newGroupbox: 'Color' translated forAll: {
			self hsvaMorph.
			(self newRow: {
				(self newLabelGroup: {
					'Selected color' translated -> self newColorPresenterMorph})
					vResizing: #shrinkWrap.
				self newColorPickerButtonMorph})
				cellPositioning: #leftCenter}.
		(self newGroupbox: 'Values' translated for: 
			(self newLabelGroup: {
				'Red' translated -> (self newColorComponentFieldMorph: #red).
				'Green' translated -> (self newColorComponentFieldMorph: #green).
				'Blue' translated -> (self newColorComponentFieldMorph: #blue).
				'Hue' translated -> (self newColorComponentFieldMorph: #hue).
				'Saturation' translated -> (self newColorComponentFieldMorph: #saturation).
				'Brightness' translated -> (self newColorComponentFieldMorph: #brightness).
				'Alpha' translated -> (self newColorComponentFieldMorph: #alpha)}))
			hResizing: #shrinkWrap}! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/26/2006 13:11'!
newHSVAColorSelectorMorph
	"Answer a hsva color selector."

	^HSVAColorSelectorMorph new
		extent: (40@28) + 152;
		when: #selectedColor send: #colorSelected: to: self! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 2/15/2011 13:07'!
pickColor
	"Pick a colour from the screen."

	|p d c h|
	h := self world activeHand.
	d := Delay forMilliseconds: 20.
	h showTemporaryCursor: self theme eyedropperIcon 
		hotSpotOffset: 6 @ 31.
	[Sensor anyButtonPressed] whileFalse: 
		[[Sensor nextEvent isNil] whileFalse. "Pharo compatability"
		p := Sensor cursorPoint.
			(self hsvaMorph containsPoint: p)
				ifFalse: ["deal with the fact that 32 bit displays may have garbage in the alpha bits"
						c := Display depth = 32 
							ifTrue: [Color
									colorFromPixelValue: ((Display pixelValueAt: p) bitOr: 16rFF000000)
									depth: 32]
							ifFalse: [Display colorAt: p]].
			self world activeHand position: p.
			self selectedColor ~= c ifTrue: [
				self selectedColor: c].
			self world displayWorldSafely.
			d wait].
	h showTemporaryCursor: nil! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:29'!
red
	"Answer the red value of the selected color."

	^(self selectedColor red * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/28/2006 12:14'!
red: anInteger
	"Set the red value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color r: anInteger g: c green * 255 b: c blue * 255 range: 255) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:38'!
saturation
	"Answer the saturation value of the selected color."

	^(self selectedColor saturation * 255) asInteger! !

!ColorSelectorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2006 16:36'!
saturation: anInteger
	"Set the saturation value of the selected color."

	|c|
	c := self selectedColor.
	self selectedColor: ((Color h: c hue s: anInteger / 255 v: c brightness) alpha: c alpha)! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/22/2006 09:49'!
selectedColor
	"Answer the value of selectedColor"

	^ selectedColor! !

!ColorSelectorDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/22/2006 10:03'!
selectedColor: aColor
	"Set the value of selectedColor. Update the color selectors."

	self basicSelectedColor: aColor.
	self hsvaMorph selectedColor: aColor! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/27/2006 11:15'!
acceptTextMorphs
	"Accept any text morphs except for those that have no edits."

	self allMorphs do: [:p |
		((p respondsTo: #accept) and: [
			(p respondsTo: #hasUnacceptedEdits) and: [
				p hasUnacceptedEdits]]) ifTrue: [p accept]]! !

!DialogWindow methodsFor: 'top window' stamp: 'MarcusDenker 12/11/2009 07:38'!
activate
	"Set the default focus for now, will want to
	remember it at some point."
	
	super activate.
	self world ifNil: [^self].
	self rememberedKeyboardFocus
		ifNil: [self defaultFocusMorph ifNotNil: [:m |
				m takeKeyboardFocus]]! !

!DialogWindow methodsFor: 'theme' stamp: 'gvc 5/24/2007 11:35'!
activeFillStyle
	"Return the active fillStyle for the receiver."
	
	^self theme dialogWindowActiveFillStyleFor: self! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/25/2006 10:25'!
addInitialPanel
	"Add the panel."

	self addMainPanel! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/9/2007 16:52'!
addMainPanel
	"Add the main panel."

	self addMorph: self newMainPanel frame: (0@0 corner: 1@1)! !

!DialogWindow methodsFor: 'theme' stamp: 'gvc 4/24/2007 16:19'!
animateClose
	"Animate closing."! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/27/2006 11:11'!
applyChanges
	"Apply the changes."

	self acceptTextMorphs! !

!DialogWindow methodsFor: 'controls' stamp: 'BenjaminVanRyseghem 5/23/2011 22:34'!
beResizeable

	isResizeable := true.
	self addGripsIfWanted! !

!DialogWindow methodsFor: 'controls' stamp: 'BenjaminVanRyseghem 5/23/2011 22:36'!
beUnresizeable

	isResizeable := false.
	self removeGrips! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/12/2009 18:14'!
buttons
	"Answer the buttons in the button row"

	^self paneMorphs last lastSubmorph submorphs! !

!DialogWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/22/2009 11:16'!
canBeMaximized
	"Answer whether we are not we can be maximised."

	^self isResizeable
		ifTrue: [super canBeMaximized]
		ifFalse: [false]! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/25/2006 10:10'!
cancel
	"Cancel and close."

	self close! !

!DialogWindow methodsFor: 'accessing' stamp: 'gvc 8/14/2006 14:12'!
cancelled
	"Answer the value of cancelled"

	^ cancelled! !

!DialogWindow methodsFor: 'accessing' stamp: 'gvc 8/14/2006 14:12'!
cancelled: anObject
	"Set the value of cancelled"

	cancelled := anObject! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/25/2006 10:10'!
close
	"Close the window."

	self delete! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 1/10/2007 13:23'!
defaultButton
	"Answer the default button."

	^self
		findDeepSubmorphThat: [:m |
			(m isKindOf: PluggableButtonMorph) and: [m isDefault]]
		ifAbsent: [] ! !

!DialogWindow methodsFor: 'focus handling' stamp: 'MarcusDenker 12/11/2009 09:34'!
defaultFocusMorph
	"Answer the morph that should have the keyboard
	focus by default when the dialog is opened."
	
	^self defaultButton
		ifNil: [(self respondsTo: #nextMorphWantingFocus)
					ifTrue: [	self nextMorphWantingFocus]]
		ifNotNil: [:b | b enabled ifTrue: [b]]! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/14/2006 12:40'!
defaultLabel
	"Answer the default label for the receiver."

	^'Dialog' translated! !

!DialogWindow methodsFor: 'event handling' stamp: 'gvc 9/22/2009 11:17'!
doubleClick: event
	"Handle a double click. Maximize/restore the window.
	Not for dialogs if not resizeable..."
	
	self isResizeable ifTrue: [super doubleClick: event]! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 1/10/2007 13:42'!
escapePressed
	"Default is to cancel."

	self cancel! !

!DialogWindow methodsFor: 'event handling' stamp: 'gvc 7/30/2009 12:21'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event"
	
	(super handlesKeyboard: evt) ifTrue: [^true].
	^evt keyCharacter = Character escape or: [
		(self defaultButton notNil and: [
			evt keyCharacter = Character cr])]
	! !

!DialogWindow methodsFor: 'theme' stamp: 'gvc 5/24/2007 11:36'!
inactiveFillStyle
	"Return the active fillStyle for the receiver."
	
	^self theme dialogWindowInactiveFillStyleFor: self! !

!DialogWindow methodsFor: 'open/close' stamp: 'MarcusDenker 12/11/2009 09:34'!
initialExtent
	"Answer the default extent for the receiver."

	|rl paneExt ext|
	rl := self getRawLabel.
	paneExt := self mainPanel
		ifNil: [0@0]
		ifNotNil: [:pane | pane minExtent].
	ext := paneExt + (2@ self labelHeight) + (2 * self class borderWidth)
		max: rl extent + 20.
	self isResizeable ifTrue: [
		self title: self title "adjust minimumExtent".
		self minimumExtent: (ext x max: self minimumExtent x)@(ext y max: self minimumExtent y)].
	^ext! !

!DialogWindow methodsFor: 'initialization' stamp: 'gvc 4/3/2008 11:52'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		cancelled: true;
		addInitialPanel! !

!DialogWindow methodsFor: 'initialization' stamp: 'AlainPlantec 12/3/2010 09:00'!
initializeLabelArea
	"Initialize the label area (titlebar) for the window."
	
	super initializeLabelArea.
	self removeBoxes.
	self replaceBoxes! !

!DialogWindow methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 5/23/2011 22:22'!
isResizeable
	"Answer whether we are not we can be resized."

	^ isResizeable ifNil: [ isResizeable := false ]! !

!DialogWindow methodsFor: 'event handling' stamp: 'gvc 7/30/2009 12:32'!
keyStroke: evt
	"Check for return and escape keys."

	super keyStroke: evt.
	(self defaultButton notNil and: [evt keyCharacter = Character cr]) ifTrue: [self returnPressed. ^true].
	evt keyCharacter = Character escape ifTrue: [self escapePressed. ^true].
	^false! !

!DialogWindow methodsFor: 'event handling' stamp: 'MarcusDenker 12/11/2009 07:38'!
keyboardFocusChange: aBoolean
	"Set the focus to the default button."

	aBoolean ifTrue: [
		self defaultFocusMorph ifNotNil: [:b |
			b takeKeyboardFocus]]! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 2/2/2009 13:15'!
mainPanel
	"Anwer the main panel morph or nil if not yet present."

	^self paneMorphs isEmpty
		ifFalse: [self paneMorphs first]! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 12/3/2008 17:35'!
newButtonRow
	"Answer a new ok/cancel button row."

	|answer buttons e|
	buttons := self newButtons.
	e := 0@0.
	buttons do: [:b | e := e max: b minExtent].
	buttons do: [:b | b extent: e].
	answer := Morph new
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #leftToRight;
		listCentering: #bottomRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	buttons do: [:b | answer addMorphBack: b].
	^answer! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 1/10/2007 13:50'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton isDefault: true. self newCancelButton}! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/14/2006 11:58'!
newContentMorph
	"Answer a new content morph."

	^Morph new
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 5/15/2007 17:40'!
newMainPanel
	"Answer a new main panel."

	^self newDialogPanel
		addMorphBack: self newContentMorph;
		addMorphBack: self newButtonRow;
		yourself! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 8/14/2006 14:12'!
ok
	"Apply the changes and close."

	self
		cancelled: false;
		applyChanges;
		delete! !

!DialogWindow methodsFor: 'theme' stamp: 'gvc 6/2/2009 10:26'!
preferredCornerStyle
	"Answer the preferred corner style."

	^self theme dialogWindowPreferredCornerStyleFor: self! !

!DialogWindow methodsFor: 'actions' stamp: 'gvc 1/10/2007 13:48'!
returnPressed
	"Default is to do the default button."

	(self defaultButton ifNil: [^self]) performAction! !

!DialogWindow methodsFor: 'actions' stamp: 'nice 1/5/2010 15:59'!
setButtonFont: aFont
	"Set the font for the buttons."

	| buttons e|
	buttons := self buttons.
	e := 0@0.
	buttons do: [:b | | hRes vRes |
		hRes := b hResizing.
		vRes := b vResizing.
		b
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap.
		b label: b label font: aFont.
		e := e max: b minExtent.
		b
			hResizing: hRes;
			vResizing: vRes].
	buttons do: [:b | b extent: e]! !

!DialogWindow methodsFor: 'initialization' stamp: 'gvc 6/1/2009 12:21'!
setFramesForLabelArea
	"Delegate to theme."
	
	self theme configureDialogWindowLabelAreaFrameFor: self! !

!DialogWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/26/2007 21:31'!
setLabelWidgetAllowance
	"Set the extra space required, in general, apart from the label.
	No extra needed for dialogs."
	
	^labelWidgetAllowance :=  0! !

!DialogWindow methodsFor: 'controls' stamp: 'gvc 1/15/2007 17:14'!
title: aString
	"Set the window title."
	
	super title: aString.
	label fitContents.
	self minimumExtent: ((label width + 20 min: (Display width // 2))@ self minimumExtent y)! !

!DialogWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/22/2009 11:16'!
wantsGrips
	"Answer whether the window wants edge and corner grips."
	
	^self isResizeable! !

!DialogWindow methodsFor: 'theme' stamp: 'gvc 6/2/2009 10:36'!
wantsRoundedCorners
	"Answer whether rounded corners are wanted."
	
	^(self theme dialogWindowPreferredCornerStyleFor: self) == #rounded! !

DialogWindow subclass: #FileDialogWindow
	instanceVariableNames: 'directoryTreeMorph fileListMorph directories selectedDirectory selectedFileIndex fileSelectionBlock showDirectoriesInFileList fileSortBlock fileNameText defaultExtension actionSelector answer entryCache entryCacheDirectory previewType previewMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!FileDialogWindow commentStamp: 'gvc 5/18/2007 13:10' prior: 0!
Dialog based file chooser for selcting or saving files. Supports various types of answer (file stream, file name, directory path etc) with optional extension filters and image or text file preview.!

!FileDialogWindow class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/19/2010 20:48'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallOpenIcon! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/27/2006 10:33'!
actionSelector
	"Answer the value of actionSelector"

	^ actionSelector! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/27/2006 10:33'!
actionSelector: anObject
	"Set the value of actionSelector"

	actionSelector := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 10:49'!
addInitialPanel
	"Add the panel."

	super addInitialPanel.
	self selectDirectory: FileDirectory default! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/31/2006 15:19'!
answer
	"Answer the result of performing the action selector."
	
	self cancelled ifTrue: [^nil].
	^answer! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 14:00'!
answer: anObject
	"Set the answer."
	
	answer := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerDirectory
	"Set the receiver to answer a directory."
	
	self actionSelector: #selectedAnyFileDirectory.
	self  fileSelectionBlock: self directoryFileSelectionBlock.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/4/2007 16:08'!
answerFileEntry
	"Set the receiver to answer the selected file entry."
	
	self actionSelector: #selectedFileEntry.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/4/2007 16:00'!
answerFileName
	"Set the receiver to answer the selected file name."
	
	self actionSelector: #selectedFileName.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerForceSaveFile
	"Set the receiver to answer a forced new file stream."
	
	self actionSelector: #saveForcedSelectedFile.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerOpenFile
	"Set the receiver to answer a new file stream on an existing file."
	
	self actionSelector: #openSelectedFile.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerPathName
	"Set the receiver to answer the selected path name."
	
	self actionSelector: #selectedPathName.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 16:04'!
answerSaveFile
	"Set the receiver to answer a new file stream."
	
	self actionSelector: #saveSelectedFile.
	self changed: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/27/2006 11:38'!
cache: dir
	"Cache the contents of the given directory and answer them."

	self entryCacheDirectory = dir
		ifFalse: [Cursor wait showWhile: [
					self
						entryCache: dir entries;
						entryCacheDirectory: dir]].
	^self entryCache! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 11:23'!
clearEntryCache
	"Clear the entry cache."

	self
		entryCache: nil;
		entryCacheDirectory: nil! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 10/11/2006 13:33'!
defaultExtension
	"Answer the value of defaultExtension"

	^ defaultExtension! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 10/11/2006 13:33'!
defaultExtension: anObject
	"Set the value of defaultExtension"

	defaultExtension := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'stephane.ducasse 4/13/2009 21:06'!
defaultFileSelectionBlock
	"Answer the default file selection block."

	^[:de |
		de isDirectory
			ifTrue: [self showDirectoriesInFileList]
			ifFalse: [self fileNamePattern match: de name]]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'stephane.ducasse 4/13/2009 21:06'!
defaultFileSortBlock
	"Answer the default file stor block"

	^[:de1 :de2 |
		de1 isDirectory = de2 isDirectory
			ifTrue: [de1 name <= de2 name]
			ifFalse: [de1 isDirectory
						ifTrue: [true]
						ifFalse: [de2 isDirectory
									ifTrue: [false]
									ifFalse: [de1 name <= de2 name]]]]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/23/2006 14:19'!
defaultLabel
	"Answer the default label for the receiver."

	^'File' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 11:29'!
deleteFileOrDirectory
	"Delete the selected file or directory."

	|entry|
	self hasSelectedFileOrDirectory ifFalse: [^self].
	entry := self selectedFileEntry.
	entry isDirectory
		ifTrue: [(self 
					proceed: 'Are you sure you wish to delete the\selected directory along with its files?' withCRs translated
					title: 'Delete Directory' translated) ifTrue: [
						self selectedFileDirectory deleteDirectory: entry name.
						self
							clearEntryCache;
							updateDirectories]]
		ifFalse: [(self 
					proceed: 'Are you sure you wish to delete the\file' withCRs translated, ' "', entry name, '"?'
					title: 'Delete Directory' translated) ifTrue: [
						self selectedFileDirectory deleteFileNamed: entry name.
						self
							selectedFileIndex: 0;
							clearEntryCache;
							updateFiles]].! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 14:19'!
directories
	"Answer the value of directories"

	^ directories! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 14:19'!
directories: anObject
	"Set the value of directories"

	directories := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'stephane.ducasse 4/13/2009 21:06'!
directoryFileSelectionBlock
	"Answer the directory file selection block."

	^[:de |
		de isDirectory
			ifTrue: [self showDirectoriesInFileList]
			ifFalse: [false]] ! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/23/2006 14:29'!
directoryNamesFor: item
	"Answer the filtered entries."
	
	^item directoryNames! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 19:51'!
directoryTreeMorph
	"Answer the value of directoryTreeMorph"

	^ directoryTreeMorph! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 19:51'!
directoryTreeMorph: anObject
	"Set the value of directoryTreeMorph"

	directoryTreeMorph := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 12/17/2010 11:44'!
doubleClickFile
	"If the selected entry is a directory then navigate it
	otherwise ok the dialog."
	
	|fe de sm|
	fe := self selectedFileEntry.
	fe ifNil: [^self].
	fe isDirectory
		ifTrue: [de := self selectedFileDirectory.
				sm := self directoryTreeMorph selectedMorph.
				self changed: #(openPath), de pathParts.
				sm := self directoryTreeMorph selectedMorph.
				self selectedDirectory: (sm children detect: [:w |
					w complexContents item localName = fe name]) complexContents]
		ifFalse: [self ok]! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 10:21'!
entryCache
	"Answer the value of entryCache"

	^ entryCache! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 10:21'!
entryCache: anObject
	"Set the value of entryCache"

	entryCache := anObject! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 10:21'!
entryCacheDirectory
	"Answer the value of entryCacheDirectory"

	^ entryCacheDirectory! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 10:21'!
entryCacheDirectory: anObject
	"Set the value of entryCacheDirectory"

	entryCacheDirectory := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/16/2007 11:07'!
fileItems
	"Answer the items for the contents of the selected directory."

	^Cursor wait showWhile: [
		self files collect: [:de |
			(self newRow: {
				ImageMorph new newForm: (self iconFor: de).
				StringMorph contents: de name font: self theme listFont})
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap;
				fullBounds;
				hResizing: #rigid;
				vResizing: #rigid;
				changeNoLayout]]! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 19:51'!
fileListMorph
	"Answer the value of fileListMorph"

	^ fileListMorph! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 19:51'!
fileListMorph: anObject
	"Set the value of fileListMorph"

	fileListMorph := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 16:13'!
fileNamePattern
	"Answer the file name pattern to filter on."
	
	^self fileNameText withBlanksTrimmed, '*'! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 15:54'!
fileNameText
	"Answer the typed file name."

	^fileNameText! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/3/2007 15:19'!
fileNameText: aString
	"The typed file name has changed."

	fileNameText = aString asString ifTrue: [^self].
	fileNameText := aString asString.
	self updateFiles.
	self
		changed: #fileNameText;
		changed: #okEnabled.
	self selectFileFromPattern! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:39'!
fileSelectionBlock
	"Answer the value of fileSelectionBlock"

	^ fileSelectionBlock! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:45'!
fileSelectionBlock: anObject
	"Set the value of fileSelectionBlock"

	fileSelectionBlock := anObject.
	self updateFiles! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:51'!
fileSortBlock
	"Answer the value of fileSortBlock"

	^ fileSortBlock! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:51'!
fileSortBlock: anObject
	"Set the value of fileSortBlock"

	fileSortBlock := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/27/2006 11:39'!
files
	"Answer the contents of the selected directory."

	^(self selectedDirectory ifNil: [^#()]) item isNil
		ifTrue: [#()]
		ifFalse: [Cursor wait showWhile: [
				((self cache: self selectedDirectory item) select: self fileSelectionBlock)
					asSortedCollection: self fileSortBlock]]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:21'!
hasParentDirectory
	"Answer whether the selected directory in the tree part has a parent."

	^(self selectedFileDirectory ifNil: [^false])
		containingDirectory pathName notEmpty! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:17'!
hasSelectedFileOrDirectory
	"Answer whether a file or directopry is selected in the file list."

	^self selectedFileIndex ~= 0! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/19/2010 20:47'!
iconFor: anEntry
	"Answer the icon to use for the directory entry."

	^anEntry isDirectory
		ifTrue: [self theme smallOpenIcon]
		ifFalse: [(self isImageFile: anEntry name)
					ifTrue: [self theme smallPaintIcon]
					ifFalse: [self theme smallLeftFlushIcon]]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/23/2006 14:18'!
initialDirectories
	"Answer the initial directories."
	
	| dirList |
	dirList := (FileDirectory on: '') directoryNames collect: [ :each |
		FileDirectoryWrapper with: (FileDirectory on: each) name: each model: self].
	dirList isEmpty ifTrue:[
		dirList := Array with: (FileDirectoryWrapper 
			with: FileDirectory default 
			name: FileDirectory default localName 
			model: self)].
	^dirList! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/11/2010 22:00'!
initialExtent
	^ 750@550! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 14:01'!
initialize
	"Initialize the receiver."

	selectedFileIndex := 0.
	fileNameText := ''.
	self
		answerPathName;
		directories: self initialDirectories;
		showDirectoriesInFileList: true;
		fileSelectionBlock: self defaultFileSelectionBlock;
		fileSortBlock: self defaultFileSortBlock.
	super initialize! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2006 13:53'!
isImageFile: aString
	"Answer whether the file name indicates an image file."

	aString ifNil: [^false].
	^#('pcx' 'bmp' 'jpeg' 'xbm' 'pnm' 'ppm' 'gif' 'pam' 'jpg' 'png' 'pbm')
		includes: (FileDirectory extensionFor: aString) asLowercase! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2009 11:17'!
isResizeable
	"Answer whether we are not we can be resized."

	^true! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:39'!
newActionButtonRow
	"Answer a new row with the action buttons."
	
	^(self newRow: {
		self newUpButton.
		self newNewDirectoryButton.
		self newDeleteButton})
		listCentering: #bottomRight! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2009 10:55'!
newContentMorph
	"Answer a new content morph."

	self
		directoryTreeMorph: self newDirectoryTree;
		fileListMorph: self newFileList;
		previewMorph: self newPreviewMorph.
	^(self newRow: {
		self newColumn: {
			self newGroupbox: 'Directory' translated for: self directoryTreeMorph.
			(self newLabelGroup: {
				'File name' translated->self newFileNameTextEntry})
				vResizing: #shrinkWrap}.
		self newGroupbox: 'File' translated forAll: {
			self fileListMorph.
			self newActionButtonRow}},
		(self previewMorph notNil
			ifTrue: [{self newGroupbox: 'Preview' translated for: self previewMorph}]
			ifFalse: [#()]))
		vResizing: #spaceFill! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/19/2010 20:48'!
newDeleteButton
	"Answer a new delete button."

	^self 
		newButtonFor: self
		getState: nil
		action: #deleteFileOrDirectory
		arguments: nil
		getEnabled: #hasSelectedFileOrDirectory
		labelForm:  self theme smallDeleteIcon
		help: 'Press to delete the selected file or directory' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 11:19'!
newDirectory
	"Create a new directory within the selected directory."

	|dir dirName title|
	dir := self selectedFileDirectory ifNil: [^self].
	title := 'Create Directory' translated.
	dirName := self
		textEntry: 'Enter directory name' translated
		title: title.
	dirName ifNil: [^self].
	[dir createDirectory: dirName]
		on: Error
		do: [:ex | [((dir fileExists: dirName) or: [(dir directoryNamed: dirName) exists])
					ifTrue: [^self
								alert: 'A file or directory already exists\with the name' withCRs translated, ' "', dirName, '"'
								title: title]] on: Error do: [].
					^self
						alert: 'Invalid directory name' translated, ' "', dirName, '"'
						title: title].
	self updateDirectories! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/22/2009 10:54'!
newDirectoryTree
	"Answer a new directory tree."
	
	^(self newTreeFor: self
		list: #directories
		selected: #selectedDirectory
		changeSelected: #selectedDirectory:)
		minHeight: 200;
		minWidth: 180! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/9/2007 13:29'!
newFileList
	"Answer a new file list."
	
	^(self newMorphListFor: self
			list: #fileItems
			getSelected: #selectedFileIndex
			setSelected: #selectedFileIndex:
			help: nil)
		doubleClickSelector: #doubleClickFile;
		minWidth: 200! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/3/2007 15:20'!
newFileNameTextEntry
	"Answer a new file name text entry morph."

	^self
		newAutoAcceptTextEntryFor: self
		getText: #fileNameText
		setText: #fileNameText:
		getEnabled: nil
		help: 'File name filter pattern' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:33'!
newImagePreviewMorph
	"Answer a new image preview morph."

	^ImagePreviewMorph new
		cornerStyle: self preferredCornerStyle;
		image: nil
		size: self previewSize! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/19/2010 20:48'!
newNewDirectoryButton
	"Answer a new 'new directory' button."

	^self 
		newButtonFor: self
		getState: nil
		action: #newDirectory
		arguments: nil
		getEnabled: nil
		labelForm: self theme smallOpenIcon
		help: 'Press to create a new directory within the current directory' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 15:59'!
newOKButton
	"Answer a new OK button."

	^self
		newOKButtonFor: self
		getEnabled: #okEnabled! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:24'!
newPreviewMorph
	"Answer a new preview morph."

	self previewType == #image ifTrue: [^self newImagePreviewMorph].
	self previewType == #text ifTrue: [^self newTextPreviewMorph].
	^nil! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:39'!
newTextPreviewMorph
	"Answer a new text preview morph."

	^(self newTextEditorFor: self
			getText: nil setText: nil getEnabled: nil)
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: self previewSize;
		minWidth: self previewSize x;
		minHeight: self previewSize y;
		enabled: false! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/19/2010 20:48'!
newUpButton
	"Answer a new up one directory level button."

	^self 
		newButtonFor: self
		getState: nil
		action: #selectParentDirectory
		arguments: nil
		getEnabled: #hasParentDirectory
		labelForm: self theme smallUndoIcon
		help: 'Press to switch to the parent of the current directory' translated! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 10:41'!
ok
	"Apply the changes and close."

	self cancelled: false.
	self applyChanges.
	self answer: (self perform: self actionSelector).
	answer ifNil: [
		self cancelled: true.
		^self delete].
	super ok! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/4/2007 16:34'!
okEnabled
	"Answer wether the ok button should be enabled."

	(#(selectedAnyFileDirectory selectedPathName)
			includes: self actionSelector) ifTrue: [^true].
	((#(saveSelectedFile saveForcedSelectedFile)
			includes: self actionSelector) and: [self fileNameText notEmpty]) ifTrue: [^true].
	(self actionSelector = #selectedFileName and: [
		self selectedFileName notNil]) ifTrue: [^true].
	^self selectedFileName notNil and: [self selectedFileEntry isDirectory not]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 3/23/2007 15:51'!
openSelectedFile
	"Open a stream on the selected file if available and return it."

	|d f|
	d := self selectedFileDirectory ifNil: [^nil].
	f := self selectedFileName ifNil: [^nil].
	self selectedFileEntry isDirectory ifTrue: [^nil].
	^ (d oldFileNamed: f) ifNil: [d readOnlyFileNamed: f]! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 13:55'!
previewMorph
	"Answer the value of previewMorph"

	^ previewMorph! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 13:55'!
previewMorph: anObject
	"Set the value of previewMorph"

	previewMorph := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:38'!
previewSize
	"Answer the size of preview to use."

	self previewType == #text ifTrue: [^256@256].
	^128@128! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 9/27/2006 13:30'!
previewType
	"Answer the value of previewType"

	^ previewType! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/14/2007 16:42'!
previewType: anObject
	"Set the value of previewType.
	See #updatePreview for supported types."

	previewType := anObject! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:13'!
saveForcedSelectedFile
	"Open a stream on the selected file if available and return it."

	|d f|
	d := self selectedFileDirectory ifNil: [^nil].
	f := self selectedFileName ifNil: [self fileNameText withBlanksTrimmed].
	f ifEmpty: [^nil].
	^d forceNewFileNamed: f! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 12:22'!
saveSelectedFile
	"Open a stream on the selected file if available and return it."

	|d f|
	d := self selectedFileDirectory ifNil: [^nil].
	f := self selectedFileName ifNil: [self fileNameText withBlanksTrimmed].
	f ifEmpty: [^nil].
	((FileDirectory extensionFor: f) isEmpty and: [self defaultExtension notNil])
		 ifTrue: [f := FileDirectory fileName: f extension: self defaultExtension].
	^[d newFileNamed: f]
		on: FileExistsException do: [
			(self
				proceed: ('The file {1} already exists.
Overwrite the file?' translated format: {f printString})
				title: 'Save File' translated)
			ifTrue: [d forceNewFileNamed: f]]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 10:49'!
selectDirectory: aFileDirectory
	"Expand and select the given directory."

	self changed: #(openPath), aFileDirectory pathParts! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/2/2007 12:19'!
selectFileFromPattern
	"If there is a single file matching the pattern then select it.
	If none then try for a directory."

	|f matches subMatches|
	f := self files.
	matches := f select: [:de | self fileNamePattern match: de name].
	subMatches := matches select: [:de | de isDirectory not].
	subMatches size = 1 ifTrue: [
		^self selectedFileIndex: (f indexOf: subMatches first)].
	subMatches := matches select: [:de | de isDirectory].
	subMatches size = 1 ifTrue: [^self selectedFileIndex: (f indexOf: subMatches first)].
	self selectedFileIndex: 0! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:43'!
selectParentDirectory
	"Switch to the parent directory."

	self hasParentDirectory ifFalse: [^self].
	self selectDirectory: self selectedFileDirectory containingDirectory! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:04'!
selectPathName: aString
	"Select the directory and set the file name text
	from the given string."

	|dir local|
	(FileDirectory default directoryExists: aString)
		ifTrue: [self selectDirectory: (FileDirectory on: aString)]
		ifFalse: [((FileDirectory on: '') directoryExists: aString)
					ifTrue: [^self selectDirectory: (FileDirectory on: aString)].
				dir := FileDirectory forFileName: aString.
				dir exists
					ifTrue: [(dir directoryExists: aString)
								ifTrue: [self selectDirectory: (dir directoryNamed: aString)]
								ifFalse: [self selectDirectory: dir.
										local := FileDirectory localNameFor: aString.
										(local notEmpty and: [FileDirectory isLegalFileName: local])
											ifTrue: [self fileNameText: local]]]
					ifFalse: [self selectDirectory: FileDirectory default.
							self fileNameText: '']]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:39'!
selectedAnyFileDirectory
	"Answer the file directory for the selected file or, if none
	or not a directory, the selected file directory."

	^self selectedFileEntry
		ifNil: [self selectedFileDirectory]
		ifNotNil: [:fe | self selectedFileDirectory ifNotNil: [:fd |
					fe isDirectory ifTrue: [
						fd directoryNamed: fe name]]]! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 14:33'!
selectedDirectory
	"Answer the value of selectedDirectory"

	^ selectedDirectory! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:49'!
selectedDirectory: anObject
	"Set the value of selectedDirectory"

	selectedDirectory := anObject.
	self
		selectedFileIndex: 0;
		updateSelectedDirectory;
		updateFiles! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:14'!
selectedDirectoryName
	"Answer the name of the selected directory."

	^(self selectedFileDirectory ifNil: [^nil]) name! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:13'!
selectedFileDirectory
	"Answer the selected file directory in the tree part."

	^(self selectedDirectory ifNil: [^nil]) item! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 11/5/2008 12:09'!
selectedFileEntry
	"Answer the selected file."

	self selectedFileIndex = 0 ifTrue: [^nil].
	^self files at: self selectedFileIndex ifAbsent: [nil]! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/23/2006 15:42'!
selectedFileIndex
	"Answer the value of selectedFileIndex"

	^ selectedFileIndex! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:46'!
selectedFileIndex: anObject
	"Set the value of selectedFileIndex"

	selectedFileIndex := anObject.
	self updateSelectedFile! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/23/2006 17:02'!
selectedFileName
	"Answer the name of the selected file."

	^(self selectedFileEntry ifNil: [^nil]) name! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 15:14'!
selectedPathName
	"Answer the name of the selected path."

	^(self selectedFileDirectory ifNil: [^nil])
		fullNameFor: (self selectedFileName ifNil: [^self selectedFileDirectory pathName])! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:42'!
showDirectoriesInFileList
	"Answer the value of showDirectoriesInFileList"

	^ showDirectoriesInFileList! !

!FileDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/24/2006 08:44'!
showDirectoriesInFileList: anObject
	"Set the value of showDirectoriesInFileList"

	showDirectoriesInFileList := anObject.
	self updateFiles! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 14:01'!
updateDirectories
	"Update the directory tree and reselect the current."

	|dir|
	dir := self selectedFileDirectory.
	self changed: #directories.
	self selectDirectory: dir! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/24/2006 08:46'!
updateFiles
	"Notify that the files have changed."

	self
		changed: #files;
		changed: #fileItems! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:33'!
updateImagePreview
	"Update the image preview."

	|str form|
	(self isImageFile: self selectedFileName)
		ifFalse: [^self previewMorph
					image: nil
					size: self previewSize].
	str := self openSelectedFile.
	str ifNil: [^self].
	[[str binary.
	form := ImageReadWriter formFromStream: str]
		on: Error do: []]
		ensure: [str close].
	self previewMorph
		image: form
		size: self previewSize! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:25'!
updatePreview
	"Update the preview."

	self previewType == #image ifTrue: [self updateImagePreview].
	self previewType == #text ifTrue: [self updateTextPreview]! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:41'!
updateSelectedDirectory
	"Notify that the selected directory has changed."

	self
		changed: #selectedDirectory;
		changed: #selectedFileDirectory;
		changed: #selectedPathName;
		changed: #hasParentDirectory! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 10:40'!
updateSelectedFile
	"Notify that the selected file has changed."

	self
		changed: #selectedFileIndex;
		changed: #selectedFileEntry;
		changed: #selectedFileName;
		changed: #selectedPathName;
		changed: #okEnabled;
		changed: #hasSelectedFileOrDirectory.
	self updatePreview! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/14/2007 16:36'!
updateTextPreview
	"Update the text preview."

	|str text|
	str := self openSelectedFile.
	str ifNil: [^self].
	[[text := str next: 5000]
		on: Error do: []]
		ensure: [str close].
	text ifNil: [text := ''].
	self previewMorph
		setText: text! !

!FileDialogWindow methodsFor: 'as yet unclassified' stamp: 'stephane.ducasse 4/13/2009 21:06'!
validExtensions: aList
	"Set the filter for the files to be those with the given extensions."
	
	aList notEmpty
		ifTrue: [self defaultExtension: aList first].
	self fileSelectionBlock: [:de |
		de isDirectory
			ifTrue: [self showDirectoriesInFileList]
			ifFalse: [(self fileNamePattern match: de name) and: [
						aList includes: (FileDirectory extensionFor: de name asLowercase)]]] ! !

DialogWindow subclass: #MessageDialogWindow
	instanceVariableNames: 'textMorph textFont iconMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!MessageDialogWindow commentStamp: 'gvc 5/18/2007 13:27' prior: 0!
Dialog window displaying a message with a single OK button. Escape/return will close. Icon is a themed information icon.!

MessageDialogWindow subclass: #AlertDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!AlertDialogWindow commentStamp: 'gvc 5/18/2007 13:52' prior: 0!
Message dialog with a warning icon.!

!AlertDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:50'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallWarningIcon! !

!AlertDialogWindow methodsFor: 'visual properties' stamp: 'gvc 5/18/2007 10:27'!
icon
	"Answer an icon for the receiver."
	
	^self theme warningIcon! !

MessageDialogWindow subclass: #ChooseDropListDialogWindow
	instanceVariableNames: 'listMorph list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!ChooseDropListDialogWindow commentStamp: 'gvc 5/18/2007 13:46' prior: 0!
Message dialog containing a drop list for selection of an item.!

!ChooseDropListDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:50'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallQuestionIcon! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:27'!
icon
	"Answer an icon for the receiver."
	
	^self theme questionIcon! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:35'!
initialize
	"Initialize the receiver."

	self list: #().
	super initialize! !

!ChooseDropListDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/12/2007 14:15'!
list
	"Answer the value of list"

	^ list! !

!ChooseDropListDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/12/2007 15:21'!
list: anObject
	"Set the value of list"

	list := anObject.
	self
		changed: #list;
		changed: #selectionIndex! !

!ChooseDropListDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/12/2007 14:17'!
listMorph
	"Answer the value of listMorph"

	^ listMorph! !

!ChooseDropListDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/12/2007 14:17'!
listMorph: anObject
	"Set the value of listMorph"

	listMorph := anObject! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2007 13:32'!
newContentMorph
	"Answer a new content morph."

	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	self listMorph: self newListMorph.
	^self newGroupboxForAll: {
		self newRow: {self iconMorph. self textMorph}.
		self listMorph}! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:17'!
newListMorph
	"Answer a new drop-list morph."

	^self
		newDropListFor: self
		list: #list
		getSelected: #selectionIndex
		setSelected: nil
		getEnabled: nil
		help: nil! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:22'!
selectedItem
	"Answer the selected list item or nil if cancelled."

	^self cancelled ifFalse: [self listMorph selectedItem]! !

!ChooseDropListDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 14:15'!
selectionIndex
	"Answer the initial selection index for the list."

	^self list ifEmpty: [0] ifNotEmpty: [1]! !

MessageDialogWindow subclass: #DenyDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!DenyDialogWindow commentStamp: 'gvc 5/18/2007 13:27' prior: 0!
Dialog window displaying a message with a single OK button. Escape/return will close. Icon is a themed lock icon.!

!DenyDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:52'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallLockIcon! !

!DenyDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:27'!
icon
	"Answer an icon for the receiver."
	
	^self theme lockIcon! !

MessageDialogWindow subclass: #ErrorDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!ErrorDialogWindow commentStamp: 'gvc 5/18/2007 14:51' prior: 0!
A message dialog with an error icon.!

!ErrorDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 11:54'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallErrorIcon! !

!ErrorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 14:52'!
icon
	"Answer an icon for the receiver."
	
	^self theme errorIcon! !

MessageDialogWindow subclass: #ListDialogWindow
	instanceVariableNames: 'pattern list searchMorph listMorph listIndex answer listBlock listCreationProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

ListDialogWindow class
	instanceVariableNames: 'searchList'!

ListDialogWindow class
	instanceVariableNames: 'searchList'!

ListDialogWindow subclass: #ClassSearch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!ClassSearch methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/19/2011 16:08'!
initialize
	super initialize.
	self getList: [ :regex| 
		Array streamContents: [ :classes|.
			SystemNavigation default allClassesAndTraits do: [ :cls|
				(regex matchesIn: cls name) isEmpty not
					ifTrue: [ classes nextPut: cls ]]]].! !

!ListDialogWindow class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 08:42'!
choose
	^ (World openModal: self new) answer! !

!ListDialogWindow class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 9/17/2011 06:56'!
chooseFromOwner: aMorph
	^ (aMorph openModal: self new) answer! !

!ListDialogWindow class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 05:34'!
searchList
	^ searchList ifNil: [ searchList := OrderedCollection new ]! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 05:26'!
accept: aClass
	self answer: aClass.
	self ok.! !

!ListDialogWindow methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 08:14'!
answer
	^ answer! !

!ListDialogWindow methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 08:14'!
answer: anObject
	answer := anObject! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 06:33'!
buildListMorph
	^  listMorph := PluggableListMorph new
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			on: self 
			list: #list
			selected: #listIndex
			changeSelected: #listIndex:
			menu: nil
			keystroke: nil;
			keystrokeSelector: #listKeystroke:;
			doubleClickSelector: #ok;
			yourself! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 06:47'!
buildSearchMorph
	^ searchMorph := SearchMorph new
			model: self;
			acceptSelector: #searchAccept:;
			updateSelector: #searchUpdate:;
			searchList: self class searchList;
			keystrokeSelector: #searchKeystroke:
			yourself.	
	! !

!ListDialogWindow methodsFor: 'focus handling' stamp: 'CamilloBruni 8/11/2011 06:13'!
defaultFocusMorph

	^ searchMorph! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 14:48'!
focusList
	list ifEmpty: [ ^ self focusSearch].
	
	self listIndex: (( listIndex max: 1 ) min: list size).
	listMorph takeKeyboardFocus.! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 14:50'!
focusSearch
	searchMorph takeKeyboardFocus.! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/15/2011 23:01'!
getList: aSymbolOrBlock
	aSymbolOrBlock isBlock
		ifTrue: [ listBlock := aSymbolOrBlock. ^ self ].
	aSymbolOrBlock isSymbol 
		ifTrue: [ 
			listBlock := [ :regex| model perform: aSymbolOrBlock with: regex].
			^ self].
	Error signal: 'invalid argument'.! !

!ListDialogWindow methodsFor: 'open/close' stamp: 'CamilloBruni 8/11/2011 03:30'!
initialExtent
	^ 300 @ 400! !

!ListDialogWindow methodsFor: 'initialization' stamp: 'CamilloBruni 9/19/2011 16:21'!
initialize
	list := #().
	listIndex := 0.
	isResizeable := true.
	listBlock := [ :regex| #() ].
	super initialize.
	self title: 'Class Search'.
	self startStepping! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 05:32'!
list
	^ list! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 05:34'!
listChanged
	self changed: #list.! !

!ListDialogWindow methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 08:02'!
listIndex
	^ listIndex ! !

!ListDialogWindow methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 14:50'!
listIndex: aNumber
	listIndex := aNumber.
	self answer: (list at: listIndex ifAbsent: [ nil ]).
	self changed: #listIndex.! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/15/2011 22:47'!
listKeystroke: event
	event keyCharacter = Character arrowUp 
		ifTrue: [ ^ self listKeystrokeUp ].
		
	event keyCharacter = Character arrowDown 
		ifTrue: [ ^ self listKeystrokeDown ].! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/15/2011 22:47'!
listKeystrokeDown
	listIndex = list size
		ifTrue: [ 
			self listIndex: 0.
			self focusSearch.
			^ true].
	^ false.! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/15/2011 22:44'!
listKeystrokeUp
	listIndex = 1 
		ifTrue: [ 
			self listIndex: 0.
			self focusSearch.
			^ true].
	^ false.! !

!ListDialogWindow methodsFor: 'actions' stamp: 'CamilloBruni 8/11/2011 05:05'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton. self newCancelButton isDefault: true}! !

!ListDialogWindow methodsFor: 'actions' stamp: 'CamilloBruni 8/15/2011 22:50'!
newContentMorph
	| panel  |
	panel := PanelMorph new.
	panel layoutPolicy: ProportionalLayout new;
		layoutInset: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
					
	panel addMorph: self buildListMorph
			fullFrame: (LayoutFrame
					fractions: (0@0 corner: 1@1)
					offsets: (0@0 corner: 0@33 negated)).
	
	panel addMorph: self buildSearchMorph
			fullFrame: (LayoutFrame
					fractions: (0@1 corner: 1@1)
					offsets: (0@30 negated  corner: 0@0)).
	^ panel! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 05:55'!
no
	"overwrite de default"! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 06:15'!
searchAccept: aString
	self searchUpdate: aString.
	
	list size = 1
		ifTrue: [ ^ self accept: list first ].
	
	(list detect: [ :class| class name = aString] ifNone: [ nil])
		ifNotNilDo: [ :class| ^ self accept: class ].
		
	list ifNotEmpty: [ ^ self focusList].! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/2/2011 13:13'!
searchKeystroke: event
	|interval|
	
	searchMorph content ifNil: [ ^ false ].
	
	(event keyCharacter = Character arrowDown )
		ifTrue: [ ^ self searchKeystrokeDown ].
		
	(event keyCharacter = Character arrowUp)
		ifTrue: [ ^ self searchKeystrokeUp ].
	! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/15/2011 22:40'!
searchKeystrokeDown
	|interval|
	interval := searchMorph selectionInterval .
	((interval last == searchMorph content size)
	and: [ interval last < interval first ])
		ifFalse: [ ^ false ].
		
	self focusList.
	^ true! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/15/2011 22:42'!
searchKeystrokeUp
	(searchMorph selectionInterval last == 0)
		ifFalse: [ ^ false ].
		
	self listIndex: list size.
	self focusList.
	^ true! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/19/2011 16:34'!
searchUpdate: aString
	pattern := nil.
	
	aString isEmptyOrNil ifFalse: [
		pattern := aString asRegexIgnoringCase].
	
	self updateList.! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/19/2011 16:34'!
updateList
	"update the displayed list in a separate thread to avoid UI blocking"
	
	"if there is already a background thread running for the new list discard it"
	listCreationProcess ifNotNil: [
		listCreationProcess terminate].
	
	"no pattern given => empty list"
	pattern ifNil: [ ^ list :=#() ].
	
	"fork off a possibly costly list calculation"
	listCreationProcess := [
		list := listBlock value: pattern.
		"make sure the ui is updated in a synchronized manner"
		WorldState addDeferredUIMessage: [self listChanged]] fork.! !

!ListDialogWindow methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/11/2011 05:55'!
yes
	"overwrite de default"! !

MessageDialogWindow subclass: #LongMessageDialogWindow
	instanceVariableNames: 'entryText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!LongMessageDialogWindow commentStamp: 'gvc 9/23/2008 11:36' prior: 0!
Dialog window displaying a message with a single OK button. Escape/return will close. Icon is a themed information icon.
Handles long messages through use of a text editor with potential for scrolling.!

!LongMessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 4/15/2008 22:11'!
entryText
	"Answer the value of entryText"

	^ entryText! !

!LongMessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 4/15/2008 22:50'!
entryText: anObject
	"Set the value of entryText"

	entryText := anObject.
	self changed: #entryText! !

!LongMessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/3/2011 08:14'!
isResizeable
	"Answer whether we are not we can be resized."

	^true! !

!LongMessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 4/15/2008 22:52'!
newContentMorph
	"Answer a new content morph."

	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	^self newGroupboxFor: (
		(self newRow: {self iconMorph. self textMorph})
			cellPositioning: #top;
			vResizing: #spaceFill)! !

!LongMessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 8/27/2011 01:13'!
newTextMorph
	"Answer a new text editor morph."

	|tm|
	tm := (self
		newTextEditorFor: self
		getText: #entryText
		setText: #entryText:
		getEnabled: nil)
			styled: false;
			minWidth: Display width // 4;
			minHeight: Display height // 4;
			disable.
	^tm! !

!LongMessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 4/15/2008 22:11'!
text: aStringOrText
	"Set the text."
	
	|t|
	t := aStringOrText isString
		ifTrue: [aStringOrText asText addAttribute: (TextFontReference toFont: self textFont); yourself]
		ifFalse: [aStringOrText].
	self entryText: t! !

!MessageDialogWindow class methodsFor: 'as yet unclassified' stamp: 'gvc 5/22/2007 13:58'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallInfoIcon! !

!MessageDialogWindow methodsFor: 'visual properties' stamp: 'gvc 5/18/2007 10:30'!
icon
	"Answer an icon for the receiver."
	
	^self theme infoIcon! !

!MessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/29/2007 13:29'!
iconMorph
	"Answer the value of iconMorph"

	^ iconMorph! !

!MessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/29/2007 13:28'!
iconMorph: anObject
	"Set the value of iconMorph"

	iconMorph := anObject! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/25/2010 12:34'!
initialExtent
	"Answer the initial extent for the receiver.
	Adjust the text if the text	would be wider than 1/4 the display width."
	
	|ext|
	ext := super initialExtent.
	self textMorph width > (Display width - 50) ifTrue: [
		self textMorph
			wrapFlag: true;
			hResizing: #rigid;
			extent: (Display width - 50) @ 0.
		ext := super initialExtent].
	^ext! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/25/2010 11:43'!
minimumWidth
	| t s |
	t := self textMorph text asString.
	s := 0.
	t linesDo: [:l | s := s max: (self textFont widthOfString: l)].
	^ (s + 100) min: Display width! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/12/2007 15:15'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton isDefault: true}! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2007 13:29'!
newContentMorph
	"Answer a new content morph."

	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	^self newGroupboxFor: (self newRow: {self iconMorph. self textMorph})! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/29/2007 13:29'!
newIconMorph
	"Answer an icon for the receiver."
	
	^ImageMorph new image: self icon! !

!MessageDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/25/2010 11:30'!
newTextMorph
	"Answer a text morph."
	^self newText: ''! !

!MessageDialogWindow methodsFor: 'theme' stamp: 'gvc 9/12/2007 17:47'!
playOpenSound
	"Play the themed sound for opening.
	Do nothing at present, done by the UIManager."! !

!MessageDialogWindow methodsFor: 'accessing' stamp: 'AlainPlantec 10/25/2010 11:07'!
text: aStringOrText
	"Set the text."
	
	|t|
	t := aStringOrText isString
		ifTrue: [aStringOrText asText addAttribute: (TextFontReference toFont: self textFont); yourself]
		ifFalse: [aStringOrText].
	t addAttribute: TextAlignment centered.
	self textMorph newContents: t.
! !

!MessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 10/17/2006 14:19'!
textFont
	"Answer the text font."
	
	^textFont! !

!MessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 7/30/2009 13:58'!
textFont: aFont
	"Set the text font."
	
	textFont :=  aFont! !

!MessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/27/2006 10:26'!
textMorph
	"Answer the value of textMorph"

	^ textMorph! !

!MessageDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/27/2006 10:26'!
textMorph: anObject
	"Set the value of textMorph"

	textMorph := anObject! !

!MessageDialogWindow methodsFor: 'theme' stamp: 'AlainPlantec 10/25/2010 11:15'!
themeChanged
	"Update the icon."

	super themeChanged.
	self iconMorph image: self icon
! !

MessageDialogWindow subclass: #ProceedDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!ProceedDialogWindow commentStamp: 'gvc 5/18/2007 12:22' prior: 0!
Yes/no dialog. Test result as to whether the dialog is cancelled (no) or not (yes).!

!ProceedDialogWindow class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/12/2011 10:13'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallQuestionIcon! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/29/2009 16:37'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event"
	
	(super handlesKeyboard: evt) ifTrue: [^true].
	^evt keyCharacter = $y or: [
		evt keyCharacter = $n]
	! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:30'!
icon
	"Answer an icon for the receiver."
	
	^self theme questionIcon! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/29/2009 16:38'!
keyStroke: evt
	"Additionally check for y and n keys (aliases for ok and cancel)."

	(super keyStroke: evt) ifTrue: [^true].
	evt keyCharacter = $y ifTrue: [self yes. ^true].
	evt keyCharacter = $n ifTrue: [self no. ^true].
	^false! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 13:50'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton. self newCancelButton isDefault: true}! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 17:34'!
no
	"Answer no."

	self cancel! !

!ProceedDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 17:34'!
yes
	"Answer yes."

	self ok! !

ProceedDialogWindow subclass: #QuestionDialogWindow
	instanceVariableNames: 'answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!QuestionDialogWindow commentStamp: 'gvc 5/18/2007 12:20' prior: 0!
A yes/no/cancel message dialog. Cancel (escape & return) is the default.!

QuestionDialogWindow subclass: #CustomQuestionDialogWindow
	instanceVariableNames: 'yesButton noButton cancelButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!CustomQuestionDialogWindow commentStamp: 'gvc 9/23/2008 11:59' prior: 0!
QuestionDialog supporting custom text/buttons for yes/no choices.!

!CustomQuestionDialogWindow methodsFor: 'accessing' stamp: 'GaryChambers 8/23/2010 11:36'!
cancelButton

	^ cancelButton! !

!CustomQuestionDialogWindow methodsFor: 'accessing' stamp: 'GaryChambers 8/23/2010 11:36'!
cancelButton: anObject

	cancelButton := anObject! !

!CustomQuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/23/2010 11:50'!
cancelText: aStringOrText help: helpString
	"Set the cancel button label.
	if the text is nil, remove the button."

	aStringOrText
		ifNil: [self cancelButton delete]
		ifNotNil: [self cancelButton
					hResizing: #shrinkWrap;
					label: aStringOrText;
					setBalloonText: helpString]! !

!CustomQuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/23/2010 12:16'!
default: defaultOption
	"Set the default button."

	defaultOption
		ifNil: [self cancelButton isDefault: true]
		ifNotNil: [defaultOption
					ifTrue: [self yesButton isDefault: true]
					ifFalse: [self noButton isDefault: true]]! !

!CustomQuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/23/2010 12:16'!
defaultCancelButton
	"Answer a default cancel button."

	^self newCancelButton! !

!CustomQuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2008 11:31'!
defaultNoButton
	"Answer a default no button."

	^self newNoButton! !

!CustomQuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/23/2010 12:05'!
defaultYesButton
	"Answer a default yes button."

	^self newYesButton! !

!CustomQuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/23/2010 11:36'!
initialize
	"Initialize the receiver."

	self
		yesButton: self defaultYesButton;
		noButton: self defaultNoButton;
		cancelButton: self defaultCancelButton.
	super initialize! !

!CustomQuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/23/2010 12:05'!
newButtons
	"Answer new buttons as appropriate."

	^{self yesButton. self noButton. self cancelButton}! !

!CustomQuestionDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/10/2008 11:30'!
noButton
	"Answer the value of noButton"

	^ noButton! !

!CustomQuestionDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/10/2008 11:30'!
noButton: anObject
	"Set the value of noButton"

	noButton := anObject! !

!CustomQuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/23/2010 11:50'!
noText: aStringOrText help: helpString
	"Set the no button label.
	if the text is nil, remove the button."

	aStringOrText
		ifNil: [self noButton delete]
		ifNotNil: [self noButton
					hResizing: #shrinkWrap;
					label: aStringOrText;
					setBalloonText: helpString]! !

!CustomQuestionDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/10/2008 11:30'!
yesButton
	"Answer the value of yesButton"

	^ yesButton! !

!CustomQuestionDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/10/2008 11:30'!
yesButton: anObject
	"Set the value of yesButton"

	yesButton := anObject! !

!CustomQuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 8/23/2010 11:50'!
yesText: aStringOrText help: helpString
	"Set the yes button label.
	if the text is nil, remove the button."

	aStringOrText
		ifNil: [self cancelButton delete]
		ifNotNil: [self yesButton
					hResizing: #shrinkWrap;
					label: aStringOrText;
					setBalloonText: helpString]! !

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
answer
	"Answer the value of answer"

	^ answer! !

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
answer: anObject
	"Set the value of answer"

	answer := anObject! !

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
newButtons
	"Answer new buttons as appropriate."

	^{self newYesButton. self newNoButton. self newCancelButton isDefault: true}! !

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/11/2007 17:36'!
no
	"Answer no."

	self
		answer: false;
		ok! !

!QuestionDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
yes
	"Answer yes."

	self
		answer: true;
		ok! !

QuestionDialogWindow subclass: #QuestionWithoutCancelDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!QuestionWithoutCancelDialogWindow commentStamp: 'gvc 5/18/2007 12:20' prior: 0!
A yes/no message dialog. Yes (return) is the default. Escape will answer no.!

!QuestionWithoutCancelDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:44'!
escapePressed
	"Default is to cancel."

	self no! !

!QuestionWithoutCancelDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 14:45'!
newButtons
	"Answer new buttons as appropriate."

	^{self newYesButton isDefault: true. self newNoButton}! !

MessageDialogWindow subclass: #TextEditorDialogWindow
	instanceVariableNames: 'textEditorMorph entryText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!TextEditorDialogWindow commentStamp: 'gvc 5/18/2007 11:16' prior: 0!
Multi-line text entry dialog.!

!TextEditorDialogWindow class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/12/2011 10:46'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme  smallQuestionIcon! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:23'!
cancel
	"Cancel and close."

	self entryText: nil.
	^super cancel! !

!TextEditorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 11:24'!
defaultFocusMorph
	"Answer the morph that should have the keyboard
	focus by default when the dialog is opened."
	
	^self textEditorMorph textMorph! !

!TextEditorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/30/2008 12:09'!
entryHeight: aNumber
	"Set the height of the text editor morph.
	Set the width to be 2 times this also."

	self textEditorMorph
		vResizing: #rigid;
		height: aNumber;
		hResizing: #rigid;
		width: aNumber * 2! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:21'!
entryText
	"Answer the value of entryText"

	^ entryText! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:22'!
entryText: anObject
	"Set the value of entryText"

	entryText := anObject.
	self changed: #entryText.
	self textEditorMorph selectAll! !

!TextEditorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 10:30'!
icon
	"Answer an icon for the receiver."
	
	^self theme questionIcon! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:23'!
initialize
	"Initialize the receiver."

	super initialize.
	self entryText: ''! !

!TextEditorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 11:23'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton. self newCancelButton}! !

!TextEditorDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/25/2010 11:22'!
newContentMorph
	"Answer a new content morph."

	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	self textMorph wrapFlag: false.
	self textEditorMorph: self newTextEditorMorph.
	^self newGroupboxForAll: {
		self newRow: {self iconMorph. self textMorph}.
		self textEditorMorph}! !

!TextEditorDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/1/2007 11:25'!
newTextEditorMorph
	"Answer a new text entry morph."

	^(self
		newTextEditorFor: self
		getText: #entryText
		setText: #entryText:
		getEnabled: nil) selectAll! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:21'!
textEditorMorph
	"Answer the value of textEditorMorph"

	^ textEditorMorph! !

!TextEditorDialogWindow methodsFor: 'accessing' stamp: 'gvc 5/1/2007 11:21'!
textEditorMorph: anObject
	"Set the value of textEditorMorph"

	textEditorMorph := anObject! !

TextEditorDialogWindow subclass: #TextEntryDialogWindow
	instanceVariableNames: ''
	classVariableNames: 'MinimumWidth'
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!TextEntryDialogWindow commentStamp: 'gvc 5/18/2007 11:16' prior: 0!
Single-line text entry dialog.!

TextEntryDialogWindow subclass: #PasswordDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!PasswordDialogWindow commentStamp: 'LaurentLaffont 4/15/2011 20:17' prior: 0!
I'm a Dialog whose TextEditors characters are replaced by *. 

Example:
(UITheme builder openModal: 
        (PasswordDialogWindow new
                title: 'Authentification';
                textFont: StandardFonts defaultFont;
                text: 'Enter your password')) entryText explore!

!PasswordDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 12/3/2008 14:36'!
newTextEditorMorph
	"Answer a new morph for the text entry using a password font."
	
	|textEditor|
	textEditor := super newTextEditorMorph.
	textEditor font: (StrikeFont passwordFontSize: self theme textFont pointSize).
	^textEditor! !

!TextEntryDialogWindow class methodsFor: 'settings' stamp: 'AlainPlantec 4/11/2010 10:10'!
minimumWidth
	^ MinimumWidth ifNil: [MinimumWidth := 450]! !

!TextEntryDialogWindow class methodsFor: 'settings' stamp: 'AlainPlantec 4/11/2010 10:10'!
minimumWidth: anInteger
	MinimumWidth := anInteger! !

!TextEntryDialogWindow methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2010 19:04'!
entryCompletion: anEntryCompletion
	anEntryCompletion chooseBlock: [:t | self ok].
	self textEditorMorph entryCompletion: anEntryCompletion

! !

!TextEntryDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 10/25/2010 11:29'!
initialExtent
	^ self minimumWidth @ (super initialExtent y)
! !

!TextEntryDialogWindow methodsFor: 'accessing' stamp: 'AlainPlantec 10/25/2010 10:36'!
minimumWidth
	^ (super minimumWidth max: self class minimumWidth) min: (Display width)! !

!TextEntryDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/10/2007 13:52'!
newButtons
	"Answer new buttons as appropriate."

	^{self newOKButton isDefault: true. self newCancelButton}! !

!TextEntryDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/25/2010 18:04'!
newTextEditorMorph
	"Answer a new text entry morph."

	^(self
		newTextEntryFor: self
		getText: #entryText
		setText: #entryText:
		getEnabled: nil
		help: nil)
		acceptOnCR: false;
		selectAll! !

!TextEntryDialogWindow methodsFor: 'accessing' stamp: 'AlainPlantec 11/28/2010 09:14'!
withDropListButton
	self textEditorMorph withDropListButton! !

DialogWindow subclass: #ModelDependentDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!ModelDependentDialogWindow commentStamp: 'gvc 5/18/2007 12:44' prior: 0!
DialogWindow that updates content based upon its model.!

!ModelDependentDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 15:27'!
addInitialPanel
	"Don't until the model is set."! !

!ModelDependentDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/15/2006 15:27'!
model: anObject
	"Set the model and add the panel for it."
	
	super model: anObject.
	self paneMorphs copy do: [:p | p delete].
	self addMainPanel! !

ModelDependentDialogWindow subclass: #PluggableDialogWindow
	instanceVariableNames: 'statusValue buttons contentMorph applyChangesSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!PluggableDialogWindow commentStamp: 'gvc 8/8/2007 14:08' prior: 0!
Pluggable form of dialog window supporting custom selector on model for applying changes along with configurable content and buttons.!

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'MarcusDenker 12/11/2009 07:41'!
applyChanges
	"Apply the changes."

	super applyChanges.
	self applyChangesSelector ifNotNil: [:s |
		self model perform: s withEnoughArguments: {self}]! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/12/2007 12:56'!
applyChangesSelector
	"Answer the value of applyChangesSelector"

	^ applyChangesSelector! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/12/2007 12:56'!
applyChangesSelector: anObject
	"Set the value of applyChangesSelector"

	applyChangesSelector := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/8/2007 14:02'!
buttons
	"Answer the value of buttons"

	^ buttons! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 8/8/2007 14:02'!
buttons: anObject
	"Set the value of buttons"

	buttons := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/9/2007 13:34'!
contentMorph
	"Answer the value of contentMorph"

	^ contentMorph! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/9/2007 13:34'!
contentMorph: anObject
	"Set the value of contentMorph"

	contentMorph := anObject! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:03'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		buttons: super newButtons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:02'!
newButtons
	"Answer  the plugged buttons."

	^self buttons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 2/9/2007 13:36'!
newContentMorph
	"Answer the plugged content."
	
	^self contentMorph! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'jrd 12/1/2008 23:56'!
statusValue
	^statusValue! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'jrd 12/1/2008 23:56'!
statusValue: val
	statusValue := val! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:05'!
useDefaultOKButton
	"Set the buttons to be just an OK button.
	Only effective before the model is set."
	
	self buttons: {self newOKButton isDefault: true}! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:06'!
useDefaultOKCancelButton
	"Set the buttons to be a default OK button and a cancel button.
	Only effective before the model is set."
	
	self buttons: super newButtons! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 8/8/2007 14:06'!
useOKDefaultCancelButton
	"Set the buttons to be an OK button and a default cancel button.
	Only effective before the model is set."
	
	self buttons: {self newOKButton. self newCancelButton isDefault: true}! !

ModelDependentDialogWindow subclass: #PopupChoiceDialogWindow
	instanceVariableNames: 'choice labels lines choicesMorph choiceMenus filter filterMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!PopupChoiceDialogWindow commentStamp: 'gvc 5/18/2007 12:26' prior: 0!
Presents a list of options in a popup format. If the list is long it will split into multiple columns. If very long, the columns will be scrollable. Maximum extent of the content area is half the display extent.!

!PopupChoiceDialogWindow class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/12/2011 10:12'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallQuestionIcon! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 13:27'!
activate: evt
	"Backstop."
	! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:45'!
choice
	"Answer the value of choice"

	^ choice! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:45'!
choice: anObject
	"Set the value of choice"

	choice := anObject! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2010 16:52'!
choiceMenus
	"Answer the value of choiceMenus"

	^ choiceMenus ifNil: [#()] ! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/4/2008 15:43'!
choiceMenus: anObject
	"Set the value of choiceMenus"

	choiceMenus := anObject! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/6/2009 13:13'!
choicesMorph
	"Answer the value of choicesMorph"

	^ choicesMorph! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/6/2009 13:13'!
choicesMorph: anObject
	"Set the value of choicesMorph"

	choicesMorph := anObject! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 16:00'!
choose: index
	"Set the given choice and ok."

	self choice: (self model
		ifNil: [index]
		ifNotNil: [self model at: index]).
	self ok! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 12:23'!
deleteIfPopUp: evt
	"For compatibility with MenuMorph."! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 7/30/2009 17:15'!
extent: aPoint
	"Make the choices area at least fill the scroll area."

	|m|
	super extent: aPoint.
	m := self choicesMorph.
	m ifNotNil: [m width: (m width max: self scrollPane width)]! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'GaryChambers 7/5/2010 15:54'!
filter
	"Answer the value of filter"

	^ filter! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2010 16:57'!
filter: aString
	"Set the value of filter, used to match the valid choices."

	filter := aString.
	self changed: #filter.
	self filterMorph ifNil: [^self].
	(self choiceMenus ifNil: [^self]) do: [:embeddedMenu |
		embeddedMenu selectItem: nil event: nil]. "clear selection in other menus"
	self choiceMenus do: [:embeddedMenu | 
		embeddedMenu selectMatch: self filter asLowercase].
	self filterMorph hasKeyboardFocus ifFalse: [
		self activeHand newKeyboardFocus: self filterMorph.
		self filterMorph selectFrom: filter size + 1 to: filter size + 1]! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/27/2008 15:24'!
filterMorph
	"Answer the value of filterMorph"

	^ filterMorph! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 2/27/2008 15:24'!
filterMorph: anObject
	"Set the value of filterMorph"

	filterMorph := anObject! !

!PopupChoiceDialogWindow methodsFor: 'event handling' stamp: 'gvc 7/30/2009 12:44'!
handlesKeyboard: evt
	"True when either the filter morph doesn't have the focus and the key
	is a text key or backspace or no menus have the focus and is up or down arrow."
	
	^(super handlesKeyboard: evt) or: [
		(self choiceMenus anySatisfy: [:m | m hasKeyboardFocus])
			ifTrue: [evt keyCharacter = Character backspace
						or: [evt keyCharacter > Character space
						or: [evt keyCharacter = Character cr
						or: [evt keyCharacter = Character arrowLeft
						or: [evt keyCharacter = Character arrowRight]]]]]
			ifFalse: [evt keyCharacter = Character arrowUp
						or: [evt keyCharacter = Character arrowDown
						or: [self filterMorph hasKeyboardFocus not]]]]! !

!PopupChoiceDialogWindow methodsFor: 'initialization' stamp: 'GaryChambers 7/5/2010 15:57'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		labels: #();
		lines: #();
		filter: ''! !

!PopupChoiceDialogWindow methodsFor: 'event handling' stamp: 'AlainPlantec 11/22/2010 12:37'!
keyStroke: anEvent
	"Look for a matching item?"
	(super keyStroke: anEvent) ifTrue: [^true].
	anEvent keyCharacter = Character backspace
		ifTrue: [self filter ifNotEmpty: [self filter: self filter allButLast]].
	anEvent keyCharacter = Character arrowUp ifTrue: [self selectLastEnabledItem. ^true].
	anEvent keyCharacter = Character arrowDown ifTrue: [self selectFirstEnabledItem. ^true].
	anEvent keyCharacter = Character arrowLeft ifTrue: [self switchToPreviousColumn. ^true].
	anEvent keyCharacter = Character arrowRight ifTrue: [self switchToNextColumn. ^true].
	(anEvent keyCharacter ~= Character cr and: [
		anEvent keyCharacter < Character space]) ifTrue: [^false]. "ignore pageup/down etc."
	(anEvent keyCharacter = Character space or: [ anEvent keyCharacter = Character cr]) 
		ifTrue: [ ^self processEnter: anEvent ].
	anEvent keyCharacter = Character backspace ifFalse: [
		self filter: self filter, anEvent keyCharacter asString].
	^false! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:49'!
labels
	"Answer the value of labels"

	^ labels! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:49'!
labels: anObject
	"Set the value of labels"

	labels := anObject! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:49'!
lines
	"Answer the value of lines"

	^ lines! !

!PopupChoiceDialogWindow methodsFor: 'accessing' stamp: 'gvc 1/15/2007 15:49'!
lines: anObject
	"Set the value of lines"

	lines := anObject! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 12:21'!
newButtons
	"Answer new buttons as appropriate."

	self filterMorph: self newFilterEntry.
	^{self filterMorph. self newCancelButton}! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 16:27'!
newChoiceButtonFor: index
	"Answer a new choice button."

	^(ToggleMenuItemMorph new
		contents: (self labels at: index) asString;
		target: self;
		selector: #choose:;
		arguments: {index};
		getStateSelector: nil;
		enablementSelector: nil)
		cornerStyle: #square;
		hResizing: #spaceFill
		! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2009 13:12'!
newChoicesMorph
	"Answer a row of columns of buttons and separators based on the model."

	|answer morphs str maxLines|
	answer := self newRow
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self labels ifEmpty: [^answer].
	maxLines := Display height - 100 // 2 // (self newChoiceButtonFor: 1) height.
	morphs := OrderedCollection new.
	1 to: self labels size do: [:i |
		morphs add: (self newChoiceButtonFor: i).
		(self lines includes: i) ifTrue: [
			morphs add: self newSeparator]].
	str := morphs readStream.
	[str atEnd] whileFalse: [
		answer
			addMorphBack: (self newMenuWith: (str next: maxLines));
			addMorphBack: self newVerticalSeparator].
	answer removeMorph: answer submorphs last.
	answer submorphs last
		hResizing: #spaceFill.
	self choiceMenus: (answer submorphs select: [:m| m isKindOf: MenuMorph]).
	^answer! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/21/2010 21:55'!
newContentMorph
	"Answer a new content morph."

	|sp choices|
	self choicesMorph: (choices := self newChoicesMorph).
	sp := (self newScrollPaneFor: choices)
		scrollTarget: choices;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	sp
		minWidth: ((choices width min: Display width // 2) + sp scrollBarThickness max: TextEntryDialogWindow minimumWidth);
		minHeight: (choices height min: Display height // 2).
	choices width > sp minWidth
		ifTrue: [sp minHeight: sp minHeight + sp scrollBarThickness].
	sp
		updateScrollbars.
	^self newGroupboxFor: sp! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/25/2010 14:26'!
newFilterEntry
	"Answer a new filter entry field."

	|entry|
	entry := self
		newAutoAcceptTextEntryFor: self
		getText: #filter
		setText: #filter:
		getEnabled: nil
		help: 'Filters the options according to a matching substring' translated.
	entry acceptOnCR: false.
	entry textMorph crAction: (MessageSend receiver: self selector: #ok).
	^entry 
! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 14:24'!
newMenuWith: morphs
	"Answer menu with the given morphs."

	^(self newEmbeddedMenu addAllMorphs: morphs)
		borderWidth: 0;
		removeDropShadow;
		color: Color transparent;
		hResizing: #spaceFill;
		cornerStyle: #square;
		stayUp: true;
		beSticky;
		popUpOwner: (MenuItemMorph new privateOwner: self)! !

!PopupChoiceDialogWindow methodsFor: 'event handling' stamp: 'MarcusDenker 12/11/2009 07:41'!
processEnter: anEvent
	self choiceMenus do: [:embeddedMenu | 
		embeddedMenu selectedItem ifNotNil: [:item |
			item invokeWithEvent: anEvent.
			^true ] ].
	^false! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 13:03'!
rootMenu
	"Answer the root menu. Answer self."

	^self! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 16:07'!
scrollPane
	"Answer the scroll pane."

	^self findDeeplyA: GeneralScrollPane! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/5/2010 15:55'!
selectFirstEnabledItem
	"Select the first enabled item in any of the embedded menus"

	|found|
	found := false.
	(self choiceMenus ifNil: [^self]) do: [:embeddedMenu |
		embeddedMenu selectItem: nil event: nil]. "clear selection in other menus"
	self choiceMenus do: [:embeddedMenu | 
		(embeddedMenu selectMatch: self filter)
			ifNotNil: [:menuItem |
				found ifFalse: [
					embeddedMenu selectItem: menuItem event: nil.
					self activeHand newKeyboardFocus: embeddedMenu.
					found := true]]]! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'GaryChambers 7/5/2010 15:55'!
selectLastEnabledItem
	"Select the last enabled item in any of the embedded menus"

	|found|
	found := false.
	(self choiceMenus ifNil: [^self]) do: [:embeddedMenu |
		embeddedMenu selectItem: nil event: nil]. "clear selection in other menus"
	self choiceMenus reverseDo: [:embeddedMenu | 
		(embeddedMenu selectLastMatch: self filter)
			ifNotNil: [:menuItem |
				found ifFalse: [
					embeddedMenu selectItem: menuItem event: nil.
					self activeHand newKeyboardFocus: embeddedMenu.
					found := true]]]! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 12:59'!
switchToNextColumn
	"Give the next embedded menu keyboard focus."

	|menuWithFocus|
	(self choiceMenus isNil or: [self choiceMenus isEmpty]) ifTrue: [^self].
	menuWithFocus := self choiceMenus
		detect: [:m | m hasKeyboardFocus]
		ifNone: [].
	menuWithFocus isNil 
		ifFalse: [menuWithFocus navigateFocusForward].
	menuWithFocus := self choiceMenus
		detect: [:m | m hasKeyboardFocus]
		ifNone: [].
	menuWithFocus isNil 
		ifTrue: [self choiceMenus first takeKeyboardFocus]! !

!PopupChoiceDialogWindow methodsFor: 'as yet unclassified' stamp: 'gvc 7/30/2009 12:58'!
switchToPreviousColumn
	"Give the previous embedded menu keyboard focus."

	|menuWithFocus|
	(self choiceMenus isNil or: [self choiceMenus isEmpty]) ifTrue: [^self].
	menuWithFocus := self choiceMenus
		detect: [:m | m hasKeyboardFocus]
		ifNone: [].
	menuWithFocus isNil 
		ifFalse: [menuWithFocus navigateFocusBackward].
	menuWithFocus := self choiceMenus
		detect: [:m | m hasKeyboardFocus]
		ifNone: [].
	menuWithFocus isNil 
		ifTrue: [self choiceMenus last takeKeyboardFocus]! !

PopupChoiceDialogWindow subclass: #PopupChoiceDialogWindowWithMessage
	instanceVariableNames: 'textMorph iconMorph textFont message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!PopupChoiceDialogWindowWithMessage commentStamp: 'LaurentLaffont 3/4/2011 22:43' prior: 0!
I'm a dialog which ask the user to select a element in a list. See me in action:

UIManager default inform:
        (UIManager default 
                chooseFrom: #(one two three) 
                values: #('1' '2' '3')  
                message: 'Select one' 
                title: 'PopupChoiceDialogWindowWithMessage example').!

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'gvc 7/21/2010 14:02'!
icon
	"Answer an icon for the receiver."
	
	^self theme questionIcon! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'alain.plantec 2/6/2009 09:35'!
iconMorph
	"Answer the value of iconMorph"

	^ iconMorph! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'alain.plantec 2/6/2009 09:34'!
iconMorph: anObject
	"Set the value of iconMorph"

	iconMorph := anObject! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2009 13:41'!
initialExtent
	"Answer the initial extent for the receiver.
	Adjust the text if the text	would be wider than 1/2 the display width."
	
	|ext|
	ext := super initialExtent.
	self textMorph width > (Display width // 2) ifTrue: [
		self textMorph
			wrapFlag: true;
			hResizing: #rigid;
			extent: Display width // 2 @ 0.
		ext := super initialExtent].
	^ext! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'alain.plantec 2/6/2009 10:08'!
message
	
	^ message! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'alain.plantec 2/6/2009 10:08'!
message: aStringOrText
	
	message := aStringOrText! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'as yet unclassified' stamp: 'alain.plantec 2/6/2009 10:04'!
newContentMorph
	| top bottom |
	self textMorph: self newTextMorph.
	self text: self message.
	self iconMorph: self newIconMorph.
	top := self newRow: {self iconMorph. self textMorph}.
	bottom := super newContentMorph.
	^ self newGroupboxFor: (self newColumn: {top. bottom}).! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'as yet unclassified' stamp: 'alain.plantec 2/6/2009 09:36'!
newIconMorph
	"Answer an icon for the receiver."
	
	^ImageMorph new image: self icon! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'as yet unclassified' stamp: 'alain.plantec 2/6/2009 09:32'!
newTextMorph
	"Answer a text morph."
	
	^self newText: ''! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'gvc 7/30/2009 14:07'!
text: aStringOrText
	"Set the text."
	
	|t|
	t := aStringOrText isString
		ifTrue: [aStringOrText asText addAttribute: (TextFontReference toFont: self textFont); yourself]
		ifFalse: [aStringOrText].
	t addAttribute: TextAlignment centered.
	self textMorph newContents: t! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'alain.plantec 2/6/2009 09:41'!
textFont
	"Answer the text font."
	
	^textFont! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'alain.plantec 2/6/2009 09:41'!
textFont: aFont
	"Set the text font."
	
	textFont :=  aFont! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'alain.plantec 2/6/2009 09:34'!
textMorph
	"Answer the value of textMorph"

	^ textMorph! !

!PopupChoiceDialogWindowWithMessage methodsFor: 'accessing' stamp: 'alain.plantec 2/6/2009 09:34'!
textMorph: anObject
	"Set the value of textMorph"

	textMorph := anObject! !

PopupChoiceDialogWindow subclass: #PopupChoiceOrRequestDialogWindow
	instanceVariableNames: 'okButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!PopupChoiceOrRequestDialogWindow class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 11/21/2009 12:34'!
minWidth
	^250! !

!PopupChoiceOrRequestDialogWindow methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/21/2009 12:34'!
extent: aPoint
	"Make the choices area at least fill the scroll area."
	^super extent: (aPoint x max: self class minWidth)@(aPoint y).! !

!PopupChoiceOrRequestDialogWindow methodsFor: 'accessing' stamp: 'GaryChambers 7/5/2010 15:58'!
filter: aString
	"Set the value of filter used to match the choices.
	Clear any selected items here so that potential requests for
	non-listed items can be handled."
	
	super filter: aString.
	(self choiceMenus ifNil: [^self]) do: [:embeddedMenu |
		embeddedMenu selectItem: nil event: nil]. "clear selection in other menus"
! !

!PopupChoiceOrRequestDialogWindow methodsFor: 'accessing' stamp: 'GaryChambers 7/5/2010 16:01'!
filterValue

	^filter isEmpty
		ifTrue: [ nil ]
		ifFalse: [ filter ]! !

!PopupChoiceOrRequestDialogWindow methodsFor: 'initialization' stamp: 'EstebanLorenzano 11/21/2009 12:18'!
newButtons
	"Answer new buttons as appropriate."
	self filterMorph: self newFilterEntry.
	self okButton: self newOKButton.
	^Array 
		with: self filterMorph
		with: self okButton
		with: self newCancelButton! !

!PopupChoiceOrRequestDialogWindow methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/21/2009 12:19'!
okButton
	^okButton! !

!PopupChoiceOrRequestDialogWindow methodsFor: 'private' stamp: 'EstebanLorenzano 11/21/2009 12:19'!
okButton: aMorph
	okButton := aMorph! !

!PopupChoiceOrRequestDialogWindow methodsFor: 'event handling' stamp: 'AlainPlantec 11/22/2010 12:33'!
processEnter: anEvent
	(super processEnter: anEvent)
		ifFalse: [ self okButton performAction ].
		
	^true! !

DialogWindow subclass: #TickDialogWindow
	instanceVariableNames: 'itemsList itemsHeaderName listMorph wrapBlockOrSelector resultStorage listModel defaultValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Windows'!

!TickDialogWindow commentStamp: '<historical>' prior: 0!
A TickDialogWindow is a dialog window which contains a TickList where user can pick a list of items.


self example!

!TickDialogWindow class methodsFor: 'example' stamp: 'StephaneDucasse 9/17/2011 18:23'!
example
	
	(self itemsList: Morph methodDict values itemsHeaderName: 'Plop' wrapBlockOrSelector: #selector title: 'Example') choose! !

!TickDialogWindow class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 15:06'!
itemsList: itemsList itemsHeaderName: aName title: aTitle

	^ self basicNew
		itemsList: itemsList;
		itemsHeaderName: aName;
		initialize;
		title: aTitle;
		yourself! !

!TickDialogWindow class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 15:43'!
itemsList: itemsList itemsHeaderName: aName title: aTitle defaultValue: aBoolean
	^ self basicNew
		itemsList: itemsList;
		itemsHeaderName: aName;
		defaultValue: aBoolean;
		initialize;
		title: aTitle;
		yourself! !

!TickDialogWindow class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 15:05'!
itemsList: itemsList itemsHeaderName: aName wrapBlockOrSelector: aBlockOrSelector title: aTitle
	^ self basicNew
		itemsList: itemsList;
		itemsHeaderName: aName;
		wrapBlockOrSelector: aBlockOrSelector;
		initialize;
		title: aTitle;
		yourself! !

!TickDialogWindow class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/17/2011 15:42'!
itemsList: itemsList itemsHeaderName: aName wrapBlockOrSelector: aBlockOrSelector title: aTitle defaultValue: aBoolean
	^ self basicNew
		itemsList: itemsList;
		itemsHeaderName: aName;
		wrapBlockOrSelector: aBlockOrSelector;
		defaultValue: aBoolean;
		initialize;
		title: aTitle;
		yourself! !

!TickDialogWindow methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 9/17/2011 14:30'!
accept

	self resultStorage: self listModel selectedItems.! !

!TickDialogWindow methodsFor: 'display' stamp: 'StephaneDucasse 9/17/2011 18:23'!
choose

	^ self chooseFromOwner: World! !

!TickDialogWindow methodsFor: 'display' stamp: 'BenjaminVanRyseghem 9/17/2011 14:34'!
chooseFromOwner: aMorph

	aMorph openModal: self.
	^ resultStorage! !

!TickDialogWindow methodsFor: 'focus handling' stamp: 'BenjaminVanRyseghem 9/17/2011 14:35'!
defaultFocusMorph

	^ self listMorph 
		ifNil: [ super defaultFocusMorph ]
		ifNotNil: [:morph | morph ]! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 15:36'!
defaultValue

	^ defaultValue! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 15:36'!
defaultValue: aBoolean

	defaultValue := aBoolean! !

!TickDialogWindow methodsFor: 'compatibility' stamp: 'BenjaminVanRyseghem 9/17/2011 06:05'!
hasUnacceptedEdits

	^ true! !

!TickDialogWindow methodsFor: 'display' stamp: 'BenjaminVanRyseghem 9/26/2011 16:10'!
initialExtent
	
	| width |
	width := (self listMorph allNodeMorphs detectMax: [:e | e width]) width.
	width := width+ 50.
	
	^width@400! !

!TickDialogWindow methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/17/2011 06:24'!
isResizeable

	^ true! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:35'!
itemsHeaderName

	^ itemsHeaderName! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:35'!
itemsHeaderName: anObject
	
	itemsHeaderName := anObject! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:35'!
itemsList

	^ itemsList! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:35'!
itemsList: anObject
	
	itemsList := anObject! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 14:31'!
listModel

	^ listModel! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 14:32'!
listModel: aModel

	listModel := aModel! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:51'!
listMorph

	^ listMorph! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 05:51'!
listMorph: anObject
	
	listMorph := anObject! !

!TickDialogWindow methodsFor: 'display' stamp: 'BenjaminVanRyseghem 9/28/2011 16:39'!
newContentMorph

	self listModel: (self tickListClass itemsList: self itemsList itemsHeaderName: self itemsHeaderName wrapBlockOrSelector: self wrapBlockOrSelector).
	self defaultValue ifTrue: [ self listModel selectAll ].
	self listMorph: (self listModel buildContents vResizing: #spaceFill; hResizing: #spaceFill).
	^ self listMorph! !

!TickDialogWindow methodsFor: 'display' stamp: 'BenjaminVanRyseghem 9/17/2011 06:39'!
openInWorld

	super openInWorld.
	self width: 300.
	self height: 400.
	self centering
! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:16'!
resultStorage

	^ resultStorage! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:16'!
resultStorage: anObject
	
	resultStorage := anObject! !

!TickDialogWindow methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/17/2011 05:35'!
tickListClass

	^ TickSelectionList! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:18'!
wrapBlockOrSelector

	^ wrapBlockOrSelector! !

!TickDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 06:18'!
wrapBlockOrSelector: anObject
	
	wrapBlockOrSelector := anObject! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/26/2006 10:36'!
defaultColor
	"Answer the default color/fill style for the receiver"
	
	^self theme windowColor! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/26/2006 10:33'!
defaultLabel
	"Answer the default label for the receiver."

	^'Window' translated! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 1/10/2007 11:39'!
delete
	"If fullscreen remove the owner too."
	
	self mustNotClose ifTrue: [^ self].
	self model okToChange ifFalse: [^ self].
	self model okToClose ifFalse: [^self].
	self isFullscreen
		ifTrue: [self owner delete]
		ifFalse: [super delete]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2006 16:26'!
flash
	"Flash the window."
	
	|fs c w d|
	fs := self fillStyle.
	c := self color alphaMixed: 0.5 with: Color white.
	w := self world.
	d := 0.
	2 timesRepeat: [
		(Delay forDuration: d milliSeconds) wait.
		d := 200.
		self color: c.
		w ifNotNil: [w displayWorldSafely].
		(Delay forDuration: d milliSeconds) wait.
		self fillStyle: fs.
		w ifNotNil: [w displayWorldSafely]]
! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/26/2006 10:37'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		setLabel: self defaultLabel;
		setWindowColor: self defaultColor! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 16:47'!
isFullscreen
	"Answer whether the window should be draw as fullscreen, i.e.
	no title bar or borders."

	^self owner isKindOf: FullscreenMorph! !

!StandardWindow methodsFor: 'layout' stamp: 'gvc 9/14/2006 16:49'!
layoutBounds
	"Bounds of pane area only."
	
	^self isFullscreen
		ifTrue: [self perform: #layoutBounds withArguments: #() inSuperclass: Morph]
		ifFalse: [super layoutBounds]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'nice 1/5/2010 15:59'!
makeBorderless
	"Remove the border and border  width offsets.."

	| b|
	b  := self class borderWidth.
	self submorphsDo: [:m | | l |
		l := m layoutFrame.
		l ifNotNil: [
			l rightFraction = 1 ifTrue: [l rightOffset: l rightOffset + b].
			l leftFraction = 0 ifTrue: [l leftOffset: l leftOffset - b].
			l bottomFraction = 1 ifTrue: [l bottomOffset: l bottomOffset + b]]].
	self borderWidth: 0! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/29/2006 12:12'!
model: anObject
	"Reset the minimum extent."

	super model: anObject.
	self title: self title! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 2/26/2010 12:56'!
mouseMove: evt
	"Handle a mouse-move event"

	self isFullscreen ifTrue: [^self]. "do nothing if fullscreen"
	^super mouseMove: evt! !

!StandardWindow methodsFor: 'controls' stamp: 'gvc 8/2/2007 13:47'!
newTextEntryFor: aModel getText: getSel setText: setSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: nil 
		help: helpText! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/7/2008 11:45'!
noteNewOwner: aMorph 
	"Go fullscreen if needed."

	super noteNewOwner: aMorph.
	(self isFullscreen and: [labelArea owner notNil]) ifTrue: [
		self
			beWithoutGrips;
			removeLabelArea;
			makeBorderless.
		(self submorphs size = 1 and: [self submorphs first isKindOf: PanelMorph])
			ifTrue: [self submorphs first roundedCorners: #()]]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/26/2006 12:07'!
open
	"Where else would you want to open it?."

	self openInWorld! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/13/2006 09:55'!
openAsIsIn: aWorld
	"Sad fixup for dodgy layout."

	super openAsIsIn: aWorld.
	self allMorphs do: [:m | m layoutChanged]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 5/18/2007 12:01'!
openFullscreen
	"Open the receiver in a FullscreenMorph."

	^FullscreenMorph new
		setContentMorph: self;
		openInWorld! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/19/2006 13:00'!
openedFullscreen
	"Should activate and update the layout."

	self allMorphs do: [:m | m layoutChanged].
	self activate! !

!StandardWindow methodsFor: 'controls' stamp: 'gvc 9/29/2006 12:11'!
title
	"Answer tht window title."
	
	^self label! !

!StandardWindow methodsFor: 'controls' stamp: 'gvc 8/29/2006 16:53'!
title: aString
	"Set the window title."
	
	self setLabel: aString
	! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 9/14/2006 19:20'!
wantsRoundedCorners
	"Check to see if the property is set first."
	
	^self isFullscreen
		ifTrue: [false]
		ifFalse: [^super wantsRoundedCorners]! !

!StandardWindow methodsFor: 'as yet unclassified' stamp: 'gvc 10/16/2006 14:15'!
yellowButtonActivity: shiftState 
	"Do nothing."! !

!SystemWindow class methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/2/2010 15:16'!
passivateTopWindow
	"Make no window the top window."

	|oldTop|
	oldTop := TopWindow.
	TopWindow := nil.
	oldTop ifNotNil: [
		oldTop
			rememberKeyboardFocus: ActiveHand keyboardFocus;
			passivate]! !

!SystemWindow class methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/15/2007 10:24'!
resetForms
	"Set the box forms to nil so that they will be taken from the current theme.
	Don't touch the expand or menu ones, delegated to theme anyway."

	CloseBoxImage := nil.
	CollapseBoxImage := nil! !

!SystemWindow class methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 10/19/2010 21:18'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^self theme smallWindowIcon! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/15/2008 21:22'!
aboutText
	"Answer the text to use for the About dialog."

	^self model
		ifNil: ['This is a system window without a model' translated]
		ifNotNil: [self model class instanceSide organization classComment
					ifEmpty: ['The model of this window has no class comment']
					ifNotEmptyDo: [:comment | comment]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/24/2008 14:57'!
aboutTitle
	"Answer the title to use for the About dialog."

	|title|
	title := self model
		ifNil: ['SystemWindow']
		ifNotNil: [(self model respondsTo: #aboutTitle)
					ifTrue: [self model aboutTitle]
					ifFalse: [self model class name]].
	^'About {1}' translated format: {title}! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/9/2011 13:27'!
activate
	"Activate the owner too."

	|mo mc|
	mo := self modalOwner.
	mc := self modalChild.
	mc isNil
		ifFalse: [mc owner notNil ifTrue: [
				mc activate.
				^mc modalChild isNil ifTrue: [mc indicateModalChild]]].
	(isCollapsed not 
		and: [ self paneMorphs size > 1 and: [self splitters isEmpty]])
			ifTrue: [self addPaneSplitters].
	TopWindow isNil ifFalse: [
		TopWindow rememberKeyboardFocus: ActiveHand keyboardFocus].
	super activate.
	self isEmbedded ifFalse: [
		self basicActivate].	
	self rememberedKeyboardFocus
		ifNil: [(self respondsTo: #navigateFocusForward)
				ifTrue: [self navigateFocusForward]]
		ifNotNil: [|m|
				m := self rememberedKeyboardFocus.
				m world
						ifNil: [self rememberKeyboardFocus: nil] "deleted"
						ifNotNil: [
							m wantsKeyboardFocus
								ifTrue: [m takeKeyboardFocus]
								ifFalse: [(self respondsTo: #navigateFocusForward)
											ifTrue: [self navigateFocusForward]]]].
	(mo notNil and: [mo isKindOf: SystemWindow])
		ifTrue: [mo bringBehind: self]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:58'!
activeFillStyle
	"Return the active fillStyle for the receiver."
	
	^self theme windowActiveFillStyleFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:58'!
activeLabelFillStyle
	"Return the active label fillStyle for the receiver."
	
	^self theme windowActiveLabelFillStyleFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:58'!
activeTitleFillStyle
	"Return the active title fillStyle for the receiver."
	
	^self theme windowActiveTitleFillStyleFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/15/2007 11:16'!
addCollapseBox
	"If I have a labelArea, add a collapse box to it."
	
	| frame |
	labelArea
		ifNil: [^ self].
	collapseBox := self createCollapseBox.
	frame := LayoutFrame new.
	frame leftFraction: 1;
		 leftOffset: self boxExtent x negated;
		 topFraction: 0;
		 topOffset: 0.
	collapseBox layoutFrame: frame.
	labelArea addMorphBack: collapseBox! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/26/2007 14:16'!
addCornerGrips
	"Should add these to the front!!"
	
	|tl tr lh|
	lh := self labelHeight.
	tl  := TopLeftGripMorph new target: self; position: self position.
	tl layoutFrame topOffset: lh negated.
	tr  := TopRightGripMorph new target: self; position: self position.
	tr layoutFrame topOffset: lh negated.
	self
		addMorph: tl;
		addMorph: tr;
		addMorph: (BottomLeftGripMorph new target: self;position: self position);
		addMorph: (BottomRightGripMorph new target: self;position: self position)! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/1/2007 14:51'!
addEdgeGrips
	"Should add these to the front!!"
	
	|t l r lh|
	lh := self labelHeight.
	t  := WindowEdgeGripMorph new target: self; position: self position; edgeName: #top.
	t layoutFrame
		topOffset: lh negated;
		bottomOffset: lh negated + self class borderWidth.
	l  := WindowEdgeGripMorph new target: self; position: self position; edgeName: #left.
	l layoutFrame topOffset: lh negated + 22.
	r  := WindowEdgeGripMorph new target: self; position: self position; edgeName: #right.
	r layoutFrame topOffset: lh negated + 22.
	self
		addMorph: t;
		addMorph: l;
		addMorph: r;
		addMorph: (WindowEdgeGripMorph new target: self;position: self position; edgeName: #bottom)! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/26/2008 12:12'!
addExpandBox
	"If I have a labelArea, add a close box to it"
	| frame |
	labelArea
		ifNil: [^ self].
	expandBox := self createExpandBox.
	self setExpandBoxBalloonText.
	frame := LayoutFrame new.
	frame leftFraction: 1;
		 leftOffset: (self boxExtent x * 2 + 3) negated;
		 topFraction: 0;
		 topOffset: 0.
	expandBox layoutFrame: frame.
	labelArea addMorphBack: expandBox! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/1/2007 14:43'!
addGrips
	"Add the edge and corner grips."
	
	self
		addCornerGrips;
		addEdgeGrips! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/7/2008 11:35'!
addGripsIfWanted
	"Add the edge and corner grips if the window wants them."
	
	self wantsGrips ifTrue: [self addGrips]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 13:56'!
addMenuControl
	"If I have a label area, add a menu control to it."

	labelArea ifNil: [^ self]. "No menu if no label area"
	menuBox
		ifNotNil: [menuBox delete].
	labelArea addMorphBack: (menuBox := self createMenuBox)! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 11/17/2010 10:12'!
addMorph: aMorph fullFrame: aLayoutFrame
	"Add a morph to the receiver with the given layout frame."
	
	| left right bottom top windowBorderWidth |
	windowBorderWidth := self class borderWidth.

	left := aLayoutFrame leftOffset ifNil: [0].
	right := aLayoutFrame rightOffset ifNil: [0].

	bottom := aLayoutFrame bottomOffset ifNil: [0].
	top := aLayoutFrame topOffset ifNil: [0].
	
	aLayoutFrame rightFraction = 1 ifTrue: [aLayoutFrame rightOffset: right - windowBorderWidth].
	aLayoutFrame leftFraction = 0
		ifTrue: [aLayoutFrame leftOffset: left + windowBorderWidth]
		ifFalse: [aLayoutFrame leftFraction = 1 ifFalse: [
					aLayoutFrame leftOffset: left + ProportionalSplitterMorph splitterWidth]].

	aLayoutFrame bottomFraction = 1 ifTrue: [aLayoutFrame bottomOffset: bottom - windowBorderWidth].
	aLayoutFrame topFraction = 0
		ifTrue: [aLayoutFrame topOffset: top]
		ifFalse: [aLayoutFrame topFraction = 1 ifFalse: [
					aLayoutFrame topOffset: top + ProportionalSplitterMorph splitterWidth]].
	
	super addMorph: aMorph fullFrame: aLayoutFrame.

	paneMorphs := paneMorphs copyReplaceFrom: 1 to: 0 with: (Array with: aMorph).
	aMorph adoptPaneColor: self paneColor.
	aMorph
		borderStyle: (self theme windowPaneBorderStyleFor: aMorph in: self);
		color: (aMorph initialColorInSystemWindow: self).
	self theme settings scrollBarsOnRight	"reorder panes so flop-out right-side scrollbar is visible"
		ifTrue: [self addMorphBack: aMorph].
		
	self owner ifNotNil: [self addPaneSplitters] "do when opened for performance"! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/25/2007 11:10'!
addPaneHSplitterBetween: topMorphs and: bottomMorphs
	"Add a horizontal splitter for the given morphs that share a common bottom fraction.
	If there is a horizontal discontinuity apply the splitter to the first contiguous group.
	Answer the morphs to which the splitter was applied."
	
	|targetY fixed rightFraction leftFrame rightFrame sorted morph topGroup bottomGroup splitter offset|
	topMorphs ifEmpty: [^self].
	targetY := topMorphs first layoutFrame bottomFraction.
	fixed := topMorphs select: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction].
		"fixed morphs appear in both top and bottom"
	sorted := ((topMorphs reject: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction])
		asSortedCollection: [:a :b | a layoutFrame rightFraction = b layoutFrame rightFraction
			ifTrue: [a layoutFrame leftFraction <= b layoutFrame leftFraction]
			ifFalse: [a layoutFrame rightFraction <= b layoutFrame rightFraction]]) readStream.
	sorted contents ifEmpty: [^fixed].
	topGroup := OrderedCollection new.
	rightFraction := sorted contents first layoutFrame leftFraction.
	[sorted atEnd or: [morph := sorted next.
			(morph layoutFrame leftFraction ~= rightFraction and: [
				morph layoutFrame rightFraction ~= rightFraction])]] whileFalse: [
		topGroup add: morph.
		rightFraction := morph layoutFrame rightFraction].
	leftFrame := topGroup first layoutFrame.
	rightFrame := topGroup last layoutFrame.
	bottomGroup := (bottomMorphs 
			reject: [:m | m layoutFrame topFraction = m layoutFrame bottomFraction])
			select: [:m |
		(m layoutFrame leftFraction
			between: leftFrame leftFraction
			and: rightFrame rightFraction) or: [
		m layoutFrame rightFraction
			between: leftFrame leftFraction
			and: rightFrame rightFraction]].
	offset := (topGroup collect: [:m | m layoutFrame bottomOffset ifNil: [0]]) max.
	splitter := ProportionalSplitterMorph new
		beSplitsTopAndBottom.
	splitter layoutFrame: (LayoutFrame
		fractions: (leftFrame leftFraction @ targetY
					corner: rightFrame rightFraction @ targetY)
		offsets: (((leftFrame leftOffset ifNil: [0]) @ 0 corner: ((rightFrame rightOffset ifNil: [0])@ 4))
		 	translateBy: 0 @ offset)).
	topGroup := topGroup, fixed.
	topGroup do: [:m | splitter addLeftOrTop: m].
	bottomGroup do: [:m | splitter addRightOrBottom: m].
	self addMorphBack: splitter.
	^topGroup! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/14/2007 13:44'!
addPaneHSplitters
	"Add the horizontal pane splitters."

	|remaining targetBottom sameBottom sameTop|
	remaining := paneMorphs reject: [:each |
			each layoutFrame bottomFraction = 1 or: [
				each layoutFrame bottomFraction = 0]].
	[remaining notEmpty] whileTrue: [
		targetBottom := remaining first layoutFrame bottomFraction.
		sameBottom := remaining select: [:each |
			each layoutFrame bottomFraction = targetBottom].
		sameTop := paneMorphs select: [:each |
			each layoutFrame topFraction = targetBottom].
		remaining := remaining
			copyWithoutAll: (self addPaneHSplitterBetween: sameBottom and: sameTop)]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/14/2007 14:39'!
addPaneSplitters
	"Add the vertical and horizontal pane splitters."
	
	self removePaneSplitters.
	self addPaneVSplitters.
	self addPaneHSplitters.
	self linkSplittersToSplitters! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/25/2007 11:10'!
addPaneVSplitterBetween: leftMorphs and: rightMorphs
	"Add a vertical splitter for the given morphs that share a common right fraction.
	If there is a vertical discontinuity apply the splitter to the first contiguous group.
	Answer the morphs to which the splitter was applied."
	
	|targetX fixed bottomFraction topFrame bottomFrame sorted morph leftGroup rightGroup splitter offset|
	leftMorphs ifEmpty: [^self].
	targetX := leftMorphs first layoutFrame rightFraction.
	fixed := leftMorphs select: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction].
		"fixed morphs appear in both top and bottom"
	sorted := ((leftMorphs reject: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction])
		asSortedCollection: [:a :b | a layoutFrame bottomFraction = b layoutFrame bottomFraction
			ifTrue: [a layoutFrame topFraction <= b layoutFrame topFraction]
			ifFalse: [a layoutFrame bottomFraction <= b layoutFrame bottomFraction]]) readStream.
	sorted contents ifEmpty: [^fixed].
	leftGroup := OrderedCollection new.
	bottomFraction := sorted contents first layoutFrame topFraction.
	[sorted atEnd or: [morph := sorted next.
			morph layoutFrame topFraction ~= bottomFraction and: [
				morph layoutFrame bottomFraction ~= bottomFraction]]] whileFalse: [
		leftGroup add: morph.
		bottomFraction := morph layoutFrame bottomFraction].
	topFrame := leftGroup first layoutFrame.
	bottomFrame := leftGroup last layoutFrame.
	rightGroup := (rightMorphs
			reject: [:m | m layoutFrame leftFraction = m layoutFrame rightFraction])
			select: [:m |
		m layoutFrame topFraction
			between: topFrame topFraction
			and: bottomFrame bottomFraction].
	offset := (leftGroup collect: [:m | m layoutFrame rightOffset ifNil: [0]]) max.
	splitter := ProportionalSplitterMorph new.
	splitter layoutFrame: (LayoutFrame
		fractions: (targetX @ topFrame topFraction
					corner: targetX @ bottomFrame bottomFraction)
		offsets: ((0 @ (topFrame topOffset ifNil: [0]) corner: (4@ (bottomFrame bottomOffset ifNil: [0])))
		 	translateBy: offset @ 0)).
	leftGroup := leftGroup, fixed.
	leftGroup do: [:m | splitter addLeftOrTop: m].
	rightGroup do: [:m | splitter addRightOrBottom: m].
	self addMorphBack: splitter.
	^leftGroup! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/14/2007 17:05'!
addPaneVSplitters
	"Add the vertical pane splitters."

	|remaining targetRight sameRight sameLeft |
	remaining := paneMorphs reject: [:each |
			each layoutFrame rightFraction = 1 or: [
				each layoutFrame rightFraction = 0]].
	[remaining notEmpty] whileTrue: [
		targetRight := remaining first layoutFrame rightFraction.
		sameRight := remaining select: [:each |
			each layoutFrame rightFraction = targetRight].
		sameLeft := paneMorphs select: [:each |
			each layoutFrame leftFraction = targetRight and: [
				each layoutFrame rightFraction ~= targetRight]].
		remaining := remaining
			copyWithoutAll: (self addPaneVSplitterBetween: sameRight and: sameLeft)]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/21/2009 16:51'!
allowedToClose
	"Answer whether the window is currently allowed to close."

	^self mustNotClose not and: [
		self modalChild isNil]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/15/2009 10:47'!
animateClose
	"Animate closing."
	
	| smallRect restoredRect rects steps|
	self isMinimized ifTrue: [^self].
	restoredRect := self bounds.
	smallRect := restoredRect scaledAndCenteredIn: (0@0 extent: 20@20).
	smallRect := smallRect align: smallRect center with: restoredRect center.
	steps := self theme settings animationSettings numberOfSteps.
	rects := ((steps - 1)/steps to: 0 by: -1/steps) collect: [:x |
		smallRect interpolateTo: restoredRect at: (20 raisedTo: x) - 1 / 19].
	World displayWorldSafely.
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/15/2009 10:47'!
animateMaximize
	"Animate maximizing from restored."
	
	|expandedRect restoredRect rects steps|
	expandedRect := self fullScreenBounds.
	restoredRect := self bounds.
	steps := self theme settings animationSettings numberOfSteps.
	rects := (1/steps to: 1 by: 1/steps) collect: [:x |
		restoredRect interpolateTo: expandedRect at: (20 raisedTo: x) - 1 / 19].
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/15/2009 10:48'!
animateMinimize
	"Animate minimizing."
	
	|tb buttonRect restoredRect rects steps|
	tb := self worldTaskbar ifNil: [^self].
	buttonRect := ((tb taskButtonOf: self) ifNil: [^self]) bounds.
	restoredRect := self isFlexed
		ifTrue: [(owner transform
					globalPointToLocal: fullFrame topLeft)
					extent: fullFrame extent]
		ifFalse: [fullFrame].
	steps := self theme settings animationSettings numberOfSteps.
	rects := ((steps - 1)/steps to: 0 by: -1/steps) collect: [:x |
		buttonRect interpolateTo: restoredRect at: (20 raisedTo: x) - 1 / 19].
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/24/2007 15:05'!
animateRectangles: rects doing: aBlock
	"Animate the given rectangles."
	
	|rectMorph|
	rectMorph := RectangleMorph new
		color: Color transparent;
		setProperty: #morphicLayerNumber toValue: 12;
		openInWorld.
	rects withIndexDo: [:r :i |
		rectMorph bounds: r rounded.
		aBlock value: rectMorph value: i.
		World doOneCycle.
		(Delay forMilliseconds: 1) wait].
	rectMorph delete! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/15/2009 10:48'!
animateRestore
	"Animate restoring from maximised."
	
	|expandedRect restoredRect rects steps|
	expandedRect := self bounds.
	restoredRect := self unexpandedFrame.
	steps := self theme settings animationSettings numberOfSteps.
	rects := ((steps - 1)/steps to: 0 by: -1/steps) collect: [:x |
		restoredRect interpolateTo: expandedRect at: (20 raisedTo: x) - 1 / 19].
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/15/2009 10:48'!
animateRestoreFromMinimized
	"Animate restoring from minimised."
	
	|tb buttonRect restoredRect rects steps|
	tb := self worldTaskbar ifNil: [^self].
	buttonRect := ((tb taskButtonOf: self) ifNil: [^self]) bounds.
	restoredRect := self isFlexed
		ifTrue: [(owner transform
					globalPointToLocal: fullFrame topLeft)
					extent: fullFrame extent]
		ifFalse: [fullFrame].
	steps := self theme settings animationSettings numberOfSteps.
	rects := (1/steps to: 1 by: 1/steps) collect: [:x |
		buttonRect interpolateTo: restoredRect at: (20 raisedTo: x) - 1 / 19].
	self fastAnimateRectangles: rects! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 9/8/2011 10:42'!
basicActivate
	"Bring me to the front and make me able to respond to mouse and keyboard.
	Was #activate (sw 5/18/2001 23:20)"

	| oldTop outerMorph |
	outerMorph := self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	oldTop := TopWindow.
	oldTop = self ifTrue: [^self].
	oldTop
		ifNil: [self world ifNotNil: [:w | w layoutChanged]] "force taskbar update"
		ifNotNil: [oldTop changed]. "invalidate with old drop shadow bounds"
	TopWindow := self.
	oldTop ifNotNil: [oldTop isInWorld ifTrue: [oldTop passivate]].
	outerMorph owner firstSubmorph == outerMorph
		ifFalse: ["Bring me (with any flex) to the top if not already"
				outerMorph owner addMorphFront: outerMorph].
	self submorphsDo: [:m | m unlock].
	labelArea ifNotNil:
		[labelArea submorphsDo: [:m | m unlock].
		self setStripeColorsFrom: self paneColorToUse].
	self isCollapsed ifFalse:
		[model modelWakeUpIn: self.
		self positionSubmorphs.
		labelArea ifNil: [self adjustBorderUponActivationWhenLabeless]].

	self privateFullBounds: nil; changed "ensure fullBounds computed for active drop shadow"
! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/26/2010 12:54'!
basicIsSticky
	"Answer the super isSticky."

	^super isSticky! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/15/2007 11:41'!
basicLabel
	"Answer the actual label morph."

	^label! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/24/2007 13:58'!
basicTaskThumbnailOfSize: thumbExtent
	"Answer a new task thumbnail for the receiver."
	
	^super taskThumbnailOfSize: thumbExtent! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/7/2008 11:42'!
beWithGrips
	"Add the grips and set a property to
	indicate that grips are wanted."

	self removeProperty: #noGrips.
	(self isCollapsed not or: [self isTaskbarPresent]) ifTrue: [
		self addGripsIfWanted]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/7/2008 11:41'!
beWithoutGrips
	"Remove the grips and set a property to
	indicate that grips are not wanted."

	self setProperty: #noGrips toValue: true.
	self removeGrips! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:42'!
bringBehind: aMorph
	"Make the receiver be directly behind the given morph.
	Take into account any modal owner and propagate."

	|outerMorph|
	outerMorph := self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	outerMorph owner addMorph: outerMorph after: aMorph topRendererOrSelf.
	self modalOwner ifNotNil: [:mo | mo bringBehind: self]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 10/19/2010 21:15'!
buildWindowMenu
	"Build and answer the window menu."
	
	| aMenu |
	aMenu := self theme newMenuIn: self for: self.
	aMenu addToggle: 'Close' translated target: self
		selector: #closeBoxHit getStateSelector: nil
		enablementSelector: #allowedToClose.
	aMenu lastItem icon: self theme windowCloseForm.
	aMenu addLine.
	aMenu add: 'About' translated action: #showAbout.
	aMenu lastItem icon: self theme smallHelpIcon.
	aMenu addLine.
	aMenu addLine.
	aMenu add: 'Change title...' translated action: #relabel.
	aMenu addLine.
	aMenu add: 'Send to back' translated action: #sendToBack.
	aMenu add: 'Make next-to-topmost' translated action: #makeSecondTopmost.
	aMenu addLine.
	self mustNotClose
		ifFalse:
			[aMenu add: 'Make unclosable' translated action: #makeUnclosable]
		ifTrue:
			[aMenu add: 'Make closable' translated action: #makeClosable].
	aMenu
		add: (self isSticky ifTrue: ['Make draggable'] ifFalse: ['Make undraggable']) translated 
		action: #toggleStickiness.
	aMenu addLine.
	self isMaximized
		ifTrue: [aMenu add: 'Restore' translated action: #expandBoxHit.
				aMenu lastItem icon: self theme windowMaximizeForm]
		ifFalse: [aMenu add: 'Maximize' translated action: #expandBoxHit.
				aMenu lastItem icon: self theme windowMaximizeForm].
	self isCollapsed ifFalse: [aMenu add: 'Window color...' translated action: #setWindowColor].
	^aMenu! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/20/2009 14:07'!
canBeMaximized
	"Answer whether we are not we can be maximised."

	^self isNotMaximized! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/14/2009 21:22'!
closeBoxHit
	"The user clicked on the close-box control in the window title.
	For Mac users only, the Mac convention of option-click-on-close-box is obeyed if the mac option key is down.
	If we have a modal child then don't delete.
	Play the close sound now since this is the only time we know that the close is user-initiated."

	self allowedToClose ifFalse: [^self].
	self playCloseSound.
	self delete
! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 18:11'!
collapseBoxHit
	"The user has clicked on the collapse box.
	Collapse or expand the receiver as appropriate."
	
	self isCollapsed
		ifTrue: [self playRestoreUpSound]
		ifFalse: [self playMinimizeSound].
	self collapseOrExpand! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/9/2011 13:38'!
configureForEmbedding
	"Set up the window so it can be embedded into another morph."

	labelArea owner notNil ifTrue: [
		self
			hasDropShadow: false;
			beWithoutGrips;
			removeLabelArea;
			makeBorderless.
		self submorphsDo: [:m | m unlock]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/9/2011 13:26'!
configureForUnembedding
	"Set up the window so it can be unembedded and placed in the world."

	labelArea owner isNil ifTrue: [
		self
			removeProperty: #processingMouseDown;
			makeBordered;
			initializeLabelArea;
			themeChanged;
			addGrips;
			hasDropShadow: true]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/22/2008 12:19'!
createCloseBox
	"Answer a button for closing the window."
	
	^self theme createCloseBoxFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/22/2008 12:20'!
createCollapseBox
	"Answer a button for minimising the window."
	
	^self theme createCollapseBoxFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/22/2008 12:20'!
createExpandBox
	"Answer a button for maximising/restoring the window."
	
	^self theme createExpandBoxFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/22/2008 12:20'!
createMenuBox
	"Answer a button for the window menu."
	
	^self theme createMenuBoxFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/16/2009 12:18'!
defaultBackgroundColor
	"Answer the color to be used as the base window color."
	^self theme windowColorFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/19/2007 22:08'!
doubleClick: event
	"Handle a double click. Maximize/restore the window.
	Works in title bar area."
	
	(labelArea containsPoint: event position)
		ifTrue: [self expandBoxHit]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/19/2007 21:48'!
doubleClickTimeout: event
	"Forget the #inactiveDoubleClick property.
	The property is set if an inactive window was double-clicked."
	
 	self removeProperty: #inactiveDoubleClick! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/20/2009 17:44'!
drawDropShadowOn: aCanvas
	"Get the theme to draw the drop shawdow for the receiver."
	
	|dropAreas|
	dropAreas := self areasRemainingToFill: (self bounds expandBy: self shadowOffsetRectangle).
	(dropAreas anySatisfy: [:rect | aCanvas isVisible: rect])
		ifFalse: [^self]. "no need to draw since no intersection"
	self isActive
		ifTrue: [self theme
					drawWindowActiveDropShadowFor: self
					on: aCanvas]
		ifFalse: [self theme
					drawWindowInactiveDropShadowFor: self
					on: aCanvas]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/15/2009 10:32'!
expandBoxHit
	"The full screen expand box has been hit"

	self isCollapsed
		ifTrue: [self playRestoreUpSound.
				self
					hide;
					collapseOrExpand.
				self unexpandedFrame ifNil: [self unexpandedFrame: fullFrame].
				self
					fullScreen;
					setExpandBoxBalloonText.
				^self show].
	self unexpandedFrame
		ifNil: [self playMaximizeSound.
				self theme settings animationSettings useAnimation ifTrue: [self animateMaximize].
				self
					unexpandedFrame: fullFrame;
					fullScreen]
		ifNotNil: [self playRestoreDownSound.
				self theme settings animationSettings useAnimation ifTrue: [self animateRestore].
				self
					bounds: self unexpandedFrame;
					unexpandedFrame: nil].
	self setExpandBoxBalloonText! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/15/2009 10:46'!
fastAnimateRectangles: rects
	"Animate the given rectangles using the fast method."
	
	|delay col merged|
	rects ifEmpty: [^self].
	delay := Delay forMilliseconds: (self theme settings animationSettings delay).
	col := Color gray alpha: 0.5.
	merged := rects first.
	rects withIndexDo: [:r :i |
		Display
			border: r rounded
			width: 1
			rule: Form blend
			fillColor: col.
		merged := merged merge: r.
		delay wait].
	merged := merged expandBy: 1.
	World invalidRect: merged from: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/23/2007 15:43'!
fillStyleToUse
	"Answer the basic fill style for the receiver."

	^self isActive 
		ifTrue: [self activeFillStyle] 
		ifFalse: [self inactiveFillStyle]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/14/2009 18:22'!
fullScreen
	"Zoom Window to Full World size with possible DeskMargins"
		"SystemWindow fullScreen"

	self bounds: self fullScreenBounds! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/14/2009 18:33'!
fullScreenBounds
	"Answer the bounds that the receiver would tak if expanded to full screen."
	
	| left right |
	left := right := 0.
	self paneMorphs
		do: [:pane | ((pane isKindOf: ScrollPane)
					and: [pane retractableScrollBar])
				ifTrue: [pane scrollBarOnLeft
						ifTrue: [left := left max: pane scrollBarThickness]
						ifFalse: [right := right max: pane scrollBarThickness]]].
	^ ( (RealEstateAgent maximumUsableAreaInWorld: self world)
				insetBy: (left @ 0 corner: right @ 0)) insetBy: self fullScreenMargin 
! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 1/7/2010 22:46'!
getRawLabel
	"Answer a shallowCopy of the label with the contents fitted."
	
	|contentsFit|
	contentsFit := label shallowCopy fitContents.
	contentsFit extent: (label extent x min: contentsFit extent x) @ contentsFit extent y.
	^contentsFit! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/23/2009 13:30'!
handlesDropShadowInHand
	"Answer whether the receiver will handle drop shadow drawing when picked up in the hand."

	^self theme handlesWindowDropShadowInHandFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/31/2009 15:47'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event"
	
	(super handlesKeyboard: evt) ifTrue: [^true].
	^evt commandKeyPressed and: [
		evt keyCharacter = Character arrowLeft or: [
		evt keyCharacter = Character arrowRight or: [
		evt keyCharacter = Character delete or: [
		evt keyCharacter = $w]]]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/15/2007 17:16'!
hasCloseBox
	"Answer whether the receiver currently has a close box."

	^closeBox notNil! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/15/2007 17:16'!
hasCollapseBox
	"Answer whether the receiver currently has a collapse box."

	^collapseBox notNil! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/15/2007 17:16'!
hasExpandBox
	"Answer whether the receiver currently has an expand box."

	^expandBox notNil! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/15/2007 17:16'!
hasMenuBox
	"Answer whether the receiver currently has a menu box."

	^menuBox notNil! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:58'!
inactiveFillStyle
	"Return the active fillStyle for the receiver."
	
	^self theme windowInactiveFillStyleFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:59'!
inactiveLabelFillStyle
	"Return the inactive label fillStyle for the receiver."
	
	^self theme windowInactiveLabelFillStyleFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2007 15:59'!
inactiveTitleFillStyle
	"Return the inactive title fillStyle for the receiver."
	
	^self theme windowInactiveTitleFillStyleFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:42'!
indicateModalChild
	"Make the user aware that this is the topmost modal child
	by flashing."

	(self isMinimized and: [self isTaskbarPresent])
		ifTrue: [self worldTaskbar ifNotNil: [:tb |
					tb indicateModalChildForMorph: self]]
		ifFalse: [self flash]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/9/2009 17:09'!
initialize
	"Initialize a system window. Add label, stripes, etc., if desired"
	
	super initialize.
	allowReframeHandles := true.
	labelString ifNil: [labelString := 'Untitled Window'].
	isCollapsed := false.
	activeOnlyOnTop := true.
	paneMorphs := Array new.
	borderColor := Color lightGray.
	borderWidth := 1.
	self color: Color lightGray lighter lighter lighter.
	self layoutPolicy: ProportionalLayout new.
	self clipSubmorphs: true.
	
	self theme
		configureWindowBorderFor: self;
		configureWindowDropShadowFor: self.	
	self initializeLabelArea.

	self cellPositioning: #topLeft. "make the offsets easy to calculate!!"
	self addGripsIfWanted.
	
	self extent: 300 @ 200.
	mustNotClose := false.
	updatablePanes := Array new! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 2/15/2011 15:53'!
initializeLabelArea
	"Initialize the label area (titlebar) for the window."
	
	label := self theme windowLabelFor: self.
	"Add default inital boxes"
	collapseBox := self createCollapseBox. "Add collapse box so #labelHeight will work"
	closeBox := self createCloseBox.
	self wantsExpandBox ifTrue: [
		expandBox := self createExpandBox.
		self setExpandBoxBalloonText].
	menuBox := self createMenuBox.
	stripes := Array
						with: (RectangleMorph newBounds: bounds)
						with: (RectangleMorph newBounds: bounds).
	self addLabelArea.
	labelArea
		goBehind;
		maxCellSize: SmallInteger maxVal @ self boxExtent y.
	self replaceBoxes.
	labelArea fillStyle: self activeTitleFillStyle.! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/10/2011 12:02'!
isActive
	"Answer active if no owner too to avoid color flickering."
	
	self owner ifNil: [^true].
	self activeOnlyOnTop ifTrue: [^self owner isWindowActive: self].
	^ true! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/10/2011 12:11'!
isEmbedded
	"Answer whether the receiver is embedded, i.e.
	has an owner that is not the world or the hand."

	^self owner isNil or: [self owner ~= self world and: [self owner ~= self activeHand]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/16/2007 10:59'!
isMaximized
	"Answer whether we are maximised."

	^self unexpandedFrame notNil! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/16/2007 11:01'!
isMinimized
	"Answer whether we are minimised."

	^self isCollapsed! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/16/2007 11:01'!
isNotMaximized
	"Answer whether we are not maximised."

	^self unexpandedFrame isNil! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/16/2007 11:01'!
isNotMinimized
	"Answer whether we are not minimised."

	^self isCollapsed not! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/16/2007 11:00'!
isNotRestored
	"Answer whether we are maximised or minimised."

	^self isMinimized or: [self isMaximized]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/16/2007 11:03'!
isRestored
	"Answer whether we are neither expanded or collapsed."

	^(self isMinimized or: [self isMaximized]) not! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/26/2010 12:54'!
isSticky
	"Override here to stop the window being grabbed except via title bar."

	^true! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/7/2007 20:01'!
isTaskbarPresent
	"Answer whether there is a taskbar in the world."

	^self worldTaskbar notNil! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/17/2006 10:26'!
justDroppedInto: aMorph event: anEvent
	"Release the mouse focus as well."
	
	isCollapsed
		ifTrue: [self position: ((self position max: 0@0) grid: 8@8).
				collapsedFrame := self bounds]
		ifFalse: [fullFrame := self bounds.
				TopWindow ~~ self ifTrue: [self activate]].
	anEvent hand releaseMouseFocus.
	^super justDroppedInto: aMorph event: anEvent! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 6/18/2011 17:33'!
keyStroke: evt
	"Check for close window."
	super keyStroke: evt.
	(self navigationKey: evt) ifTrue: [^true].
	(evt commandKeyPressed and: [
			evt keyCharacter = Character delete or: [
				evt keyCharacter = $w]])  ifTrue: [
		self delete.
		^true].
	^false! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/14/2007 12:57'!
labelArea
	"Answer the label area."

	^labelArea! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/10/2011 11:31'!
labelHeight
	"Answer the height for the window label.  The standard behavior is at bottom; a hook is provided so that models can stipulate other heights, in support of various less-window-looking demos.
	If no label answer the class border width instead."

	label ifNil: [^self isEmbedded ifTrue: [0] ifFalse: [self class borderWidth]].
		
	(model notNil and: [model respondsTo: #desiredWindowLabelHeightIn:]) ifTrue: [
		(model desiredWindowLabelHeightIn: self) ifNotNil: [:h | ^h]].

	^(label height + (self class borderWidth * 2)) max:
		(collapseBox ifNotNil: [collapseBox height] ifNil: [10])! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/11/2007 15:13'!
labelString
	"Answer the actual label string."

	^label isNil
		ifTrue: [labelString]
		ifFalse: [label contents asString]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:42'!
layoutChanged
	"No need to propagate to the world.
	Fixed to always flush layout cache."

	(self owner isNil or: [self owner isWorldMorph not])
		ifTrue: [^super layoutChanged].
	fullBounds := nil.
	self layoutPolicy ifNotNil: [:layout | layout flushLayoutCache]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/14/2007 14:45'!
linkSplittersToSplitters
	"The pane morphs are already linked. Cross link the splitters as appropriate."
	
	self splitters do: [:each |
		each splitsTopAndBottom
			ifTrue: [self splitters do: [:eachMorph |
					eachMorph splitsTopAndBottom ~= each splitsTopAndBottom ifTrue: [
						eachMorph layoutFrame bottomFraction = each layoutFrame topFraction
							ifTrue: [each addLeftOrTop: eachMorph].
						eachMorph layoutFrame topFraction = each layoutFrame bottomFraction
							ifTrue: [each addRightOrBottom: eachMorph]]]]
			ifFalse: [self splitters do: [:eachMorph |
					eachMorph splitsTopAndBottom ~= each splitsTopAndBottom ifTrue: [
						eachMorph layoutFrame rightFraction = each layoutFrame leftFraction
							ifTrue: [each addLeftOrTop: eachMorph].
						eachMorph layoutFrame leftFraction = each layoutFrame rightFraction
							ifTrue: [each addRightOrBottom: eachMorph]]]]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/9/2011 14:10'!
lockInactivePortions
	"Make me unable to respond to mouse and keyboard.  Control boxes remain active."

	self isEmbedded ifTrue: [^self].
	self submorphsDo: [:m | m == labelArea ifFalse: [m lock]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/9/2011 12:18'!
makeBordered
	"Add the border and border width offsets."

	|b|
	self borderWidth = 0 ifFalse: [^self].
	b  := self class borderWidth.
	self submorphsDo: [:m | | l |
		l := m layoutFrame.
		l ifNotNil: [
			l rightFraction = 1 ifTrue: [l rightOffset: l rightOffset - b].
			l leftFraction = 0 ifTrue: [l leftOffset: l leftOffset + b].
			l bottomFraction = 1 ifTrue: [l bottomOffset: l bottomOffset - b]]].
	self theme configureWindowBorderFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/9/2011 12:13'!
makeBorderless
	"Remove the border and border width offsets.."

	|b|
	b  := self class borderWidth.
	self submorphsDo: [:m | | l |
		l := m layoutFrame.
		l ifNotNil: [
			l rightFraction = 1 ifTrue: [l rightOffset: l rightOffset + b].
			l leftFraction = 0 ifTrue: [l leftOffset: l leftOffset - b].
			l bottomFraction = 1 ifTrue: [l bottomOffset: l bottomOffset + b]]].
	self borderWidth: 0! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/18/2008 10:55'!
makeClosable
	"Reinstate the close box. Go via theme to maintain box order."
	
	mustNotClose := false.
	closeBox
		ifNil: [closeBox := self createCloseBox.
				self replaceBoxes]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/16/2007 11:02'!
maximize
	"Maximise the receiver. If collapsed the uncollapse first."

	self isMinimized ifTrue: [self collapseOrExpand].
	self isMaximized ifFalse: [self expandBoxHit]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/15/2007 12:26'!
menuBox
	"Answer the receiver's menu box."

	^menuBox! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/27/2007 10:38'!
minimize
	"Minimise the receiver."

	self isMinimized ifFalse: [self collapseBoxHit]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'nice 3/5/2010 22:41'!
minimizeAfterGeneratingThumbnail
	"Minimize the window after thumbnail generation."
	
	self isMinimized ifTrue: [^self].
	isCollapsed := true.
	paneMorphs
		do: [:m | m delete; releaseCachedState].
	self setBoundsWithFlex: (-10 @ -10 extent: 2 @ 2).
	self hide.
	self layoutChanged
	! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/16/2007 12:24'!
modalChild
	"Answer the modal child of the receiver, if any."

	^self valueOfProperty: #modalChild! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/21/2009 16:27'!
modalLockTo: aSystemWindow
	"Lock the receiver as a modal owner of the given window."

	aSystemWindow
		setProperty: #modalOwner toValue: self.
	self setProperty: #modalChild toValue: aSystemWindow.
	(closeBox respondsTo: #enabled) ifTrue: [
		self setProperty: #preModalCloseEnabled toValue: closeBox enabled].
	(closeBox respondsTo: #enabled:) ifTrue: [
		closeBox enabled: false]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/16/2007 12:24'!
modalOwner
	"Answer the modal owner of the receiver, if any."

	^self valueOfProperty: #modalOwner! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/21/2009 16:29'!
modalUnlockFrom: aSystemWindow
	"Unlock the receiver as a modal owner of the given window."

	aSystemWindow removeProperty: #modalOwner.
	self removeProperty: #modalChild.
	(closeBox respondsTo: #enabled:) ifTrue: [
		closeBox enabled: (self valueOfProperty: #preModalCloseEnabled ifAbsent: [true])].
	self removeProperty: #preModalCloseEnabled.
	self activate! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 2/15/2011 15:45'!
model: anObject
	"Set the model."
	
	super model: anObject.
	self paneColorTracksModel ifTrue: [
		self
			setProperty: #paneColor toValue: self defaultBackgroundColor;
			fillStyle: self fillStyleToUse;
			setStripeColorsFrom: self paneColorToUse.
		self theme settings fadedBackgroundWindows ifFalse: [ "since not done in stripes"
			self adoptPaneColor: self paneColor]].
	self minimumExtent: (
		(anObject respondsTo: #minimumExtent)
			ifTrue: [anObject minimumExtent]).
	menuBox ifNotNil: [
		menuBox
			labelGraphic: (self theme windowMenuIconFor: self);
			height: self boxExtent y]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 9/8/2011 15:48'!
mouseMove: evt
	"Handle a mouse-move event"

	| cp |
	cp := evt cursorPoint.
	self valueOfProperty: #clickPoint ifPresentDo: 
		[:firstClick |
		((self labelRect containsPoint: firstClick) and: [(cp dist: firstClick) > 3]) ifTrue:
		["If this is a drag that started in the title bar, then pick me up"
		^self basicIsSticky ifFalse:
			[self fastFramingOn 
				ifTrue: [self doFastFrameDrag: firstClick]
				ifFalse: [evt hand grabMorph: self topRendererOrSelf]]]].
	submorphs do: [:m | (m containsPoint: cp) ifTrue: [m mouseMove: evt]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/28/2009 13:51'!
navigateFocusForward
	"Change the keyboard focus to the next morph or the receiver
	in none are interested."

	self nextMorphWantingFocus
		ifNil: [self takeKeyboardFocus]
		ifNotNil: [super navigateFocusForward]
	! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/18/2007 10:57'!
navigationKey: event
	"Check for tab key activity and change focus as appropriate.
	Check for menu key to do popup.
	Check for active window naviagation."
	
	(self world navigationKey: event) ifTrue: [^true].
	(self tabKey: event) ifTrue: [^true].
	(event keyCharacter = Character escape and: [
			event anyModifierKeyPressed]) ifTrue: [
		self yellowButtonActivity: false.
		^true].
	^false! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 12:11'!
nextMorphAcrossInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its next sibling or owner's next sibling etc."

	^self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 12:05'!
nextMorphInWindow
	"Answer the next morph in the window. Traverse
	from the receiver to its first pane."

	^self hasSubmorphs
		ifTrue: [self submorphs first]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/10/2008 16:49'!
openModal: aSystemWindow
	"Open the given window locking the receiver until it is dismissed.
	Set the pane color to match the receiver.
	Answer the system window."
	
	aSystemWindow
		theme: self theme;
		setWindowColor: self paneColor.
	^super openModal: aSystemWindow! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 2/15/2011 12:40'!
paneColor

	"Answer the basic pane color that should be used."
	
	^self theme paneColorFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/29/2006 16:21'!
paneColorOrNil
	"Answer the window's pane color or nil otherwise."

	^self paneColor! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/25/2006 13:44'!
paneColorTracksModel
	"Answer true if the colour of the window should be taken from the model."
	
	^true! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'GaryChambers 6/9/2011 13:54'!
passivate
	"Make me unable to respond to mouse and keyboard"

	super passivate.
	self setStripeColorsFrom: self paneColorToUse.
	self isEmbedded ifTrue: [^self].
	model modelSleep.
	"Control boxes remain active, except in novice mode"
	self lockInactivePortions.
	labelArea ifNil: "i.e. label area is nil, so we're titleless"
		[self adjustBorderUponDeactivationWhenLabeless]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/27/2007 11:01'!
playCloseSound
	"Play the themed sound for closing."
	
	self theme windowCloseSound play! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/27/2007 10:06'!
playMaximizeSound
	"Play the themed sound for maximizing."
	
	self theme windowMaximizeSound play! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/27/2007 10:06'!
playMinimizeSound
	"Play the themed sound for maximizing."
	
	self theme windowMinimizeSound play! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/12/2007 17:48'!
playOpenSound
	"Play the themed sound for opening."
	
	self theme windowOpenSound play! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/27/2007 10:06'!
playRestoreDownSound
	"Play the themed sound for restoring from maximized."
	
	self theme windowRestoreDownSound play! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/27/2007 10:05'!
playRestoreUpSound
	"Play the themed sound for restoring from minimized."
	
	self theme windowRestoreUpSound play! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/2/2009 10:26'!
preferredCornerStyle
	"Answer the preferred corner style."

	^self theme windowPreferredCornerStyleFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/11/2007 12:06'!
previousMorphInWindow
	"Answer the previous morph in the window. This will be the
	last submorph recursively of the first pane morph."

	^self hasSubmorphs
		ifTrue: [self lastSubmorphRecursive]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 3/2/2010 15:01'!
rememberKeyboardFocus: aMorph
	"Record the current keyboard focus for the receiver."
	
	(aMorph isNil or: [(aMorph hasOwner: self) not]) ifFalse: [
		self setProperty: #rememberedFocus toValue: aMorph]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/4/2007 13:42'!
rememberedKeyboardFocus
	"Answer the remembered keyboard focus for the receiver."
	
	^self valueOfProperty: #rememberedFocus! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/25/2007 16:33'!
removeBoxes
	"Remove all label area boxes."

	closeBox ifNotNil: [closeBox delete. closeBox := nil].
	menuBox ifNotNil: [menuBox delete. menuBox := nil].
	expandBox ifNotNil: [expandBox delete. expandBox := nil].
	collapseBox ifNotNil: [collapseBox delete. collapseBox := nil]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/6/2007 12:58'!
removeCloseBox
	"Remove the close box."

	closeBox ifNotNil: [closeBox delete. closeBox := nil]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/6/2007 12:58'!
removeCollapseBox
	"Remove the collapse box."

	collapseBox ifNotNil: [collapseBox delete. collapseBox := nil]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/1/2007 14:41'!
removeEdgeGrips
	"Remove the window edge grips."
	
	|edges|
	edges := self submorphsSatisfying: [:each | each isKindOf: WindowEdgeGripMorph].
	edges do: [:each | each delete]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 9/6/2007 12:59'!
removeExpandBox
	"Remove the expand box."

	expandBox ifNotNil: [expandBox delete. expandBox := nil]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/1/2007 14:42'!
removeGrips
	"Remove the edge and corner grips."
	
	self
		removeCornerGrips;
		removeEdgeGrips! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/7/2008 11:37'!
removeLabelArea
	"Remove the entire label area."

	self removeGrips.
	labelArea delete.
	label := nil.	
	(self isCollapsed not or: [self isTaskbarPresent]) ifTrue: [
		self addGripsIfWanted]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 8/10/2009 11:40'!
replaceBoxes
	"Rebuild the various boxes."
	
	labelArea removeAllMorphs.
	self setLabelWidgetAllowance.
	self theme configureWindowLabelAreaFor: self.
	self setFramesForLabelArea.
	self isActive ifFalse: [labelArea passivate]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 7/30/2009 13:57'!
resetCollapsedFrame
	"Reset the collapsed frame."

	collapsedFrame := nil! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/27/2007 10:36'!
restore
	"Restore the receiver's normal size."

	self isMinimized
		ifTrue: [self collapseBoxHit]
		ifFalse: [self isMaximized ifTrue: [self expandBoxHit]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/23/2007 14:50'!
restoreAndActivate
	"Restore the window if minimised then activate."

	self isMinimized
		ifTrue: [self restore].
	self isActive
		ifFalse: [self activate]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/24/2007 13:43'!
restoreBeforeGeneratingThumbnail
	"Restore the window without activating unlocking or stepping."
	
	self isMinimized ifFalse: [^self].
	isCollapsed := false.
	self show.
	self setBoundsWithFlex: fullFrame.
	paneMorphs reverseDo: [:m | 
		self addMorph: m].
	self layoutChanged! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'tbn 7/29/2010 21:29'!
setExpandBoxBalloonText
	"Set the expand box balloon help text as appropriate."

	expandBox ifNil: [^self].
	self unexpandedFrame
		ifNil: [expandBox setBalloonText: 'Expand to full screen' translated]
		ifNotNil: [expandBox setBalloonText: 'Contract to original size' translated]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/1/2009 12:06'!
setFramesForLabelArea
	"Set the layout for the label area."
	
	self theme configureWindowLabelAreaFrameFor: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/26/2007 21:13'!
setLabelWidgetAllowance
	"Set the extra space required, in general, apart from the label.
	Should make theme based (for centered titles), leave enough room
	for the moment."
	
	^labelWidgetAllowance :=  (self boxExtent x * 7) 
	"allow for three on one side and centering plus a bit"! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/29/2009 11:53'!
setStripeColorsFrom: paneColor 
	"Set the stripe color based on the given paneColor.
	Removed box color update for Pharo compatability."

	stripes ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self isActive 
		ifTrue: [label ifNotNil: [label color: self activeLabelFillStyle].
				labelArea fillStyle: self activeTitleFillStyle] 
		ifFalse: [label ifNotNil: [label color: self inactiveLabelFillStyle].
				labelArea fillStyle: self inactiveTitleFillStyle].
	self adoptPaneColor: self paneColor! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 4/14/2010 15:00'!
setWindowColor: incomingColor
	"Removed existing color check - looked useless!!"
	
	| aColor |
	incomingColor ifNil: [^ self].  "it happens"
	aColor := incomingColor.
	self setProperty: #paneColor toValue: aColor.
	self setStripeColorsFrom: aColor.
	self theme settings fadedBackgroundWindows 
		ifFalse: [self adoptPaneColor: aColor]. "reverse optimisation"
	self changed.! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/15/2009 15:21'!
shadowOffsetRectangle
	"Answer a rectangle describing the offsets to the
	receiver's bounds for a drop shadow."

	^self isActive
		ifTrue: [self theme windowActiveDropShadowOffsetRectangleFor: self]
		ifFalse: [self theme windowInactiveDropShadowOffsetRectangleFor: self]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'FernandoOlivero 4/12/2011 10:32'!
showAbout
	"Show the class comment of the model in a workspace.
	Suggested by Michael Davies."

	self theme  
		longMessageIn: self
		text: self aboutText
		title: self aboutTitle! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/24/2007 13:58'!
taskThumbnailOfSize: thumbExtent
	"Answer a new task thumbnail for the receiver."
	
	|min thumb|
	min := self isMinimized
		ifTrue: [self restoreBeforeGeneratingThumbnail.
				true]
		ifFalse: [false].
	thumb := self basicTaskThumbnailOfSize: thumbExtent.
	min ifTrue: [self minimizeAfterGeneratingThumbnail].
	^thumb! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/16/2007 12:30'!
taskbarButtonClicked
	"The taskbar button for the receiver has been clicked.
	If minimised then restore.
	If active then minimize.
	Otherwise make active."

	self isMinimized
		ifTrue: [self restore]
		ifFalse: [self isActive
					ifTrue: [self minimize]
					ifFalse: [self activate]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/7/2009 09:11'!
taskbarButtonEntered: aButton event: evt in: aMorph
	"The mouse has entered out taskbar button.
	Show a thumbnail."

	aButton owner ifNotNil: [:buttonBar | |thumb|
		buttonBar showWindowPreview ifFalse: [^self].
		thumb := self valueOfProperty: #taskbarThumbnail.
		thumb
			ifNil: [thumb := self theme newTaskbarThumbnailIn: self for: self]
			ifNotNil: [^self].
		self setProperty: #taskbarThumbnail toValue: thumb.
		thumb bottomLeft: ((aButton left min: aButton owner right - thumb width)@ (aButton owner top - 4)).
		thumb openInWorld]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/22/2007 14:01'!
taskbarButtonFor: aTaskbar
	"Answer a new task bar button for the receiver.
	Answer nil if not required."

	^self theme
		newTaskbarButtonIn: aTaskbar
		for: self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'AlainPlantec 12/7/2009 09:13'!
taskbarButtonLeft: aButton event: evt in: aMorph
	"The mouse has left our taskbar button.
	Remove our thumbnail."

	self
		valueOfProperty: #taskbarThumbnail
		ifPresentDo: [:thumb |
			thumb delete.
			self removeProperty: #taskbarThumbnail]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/20/2009 14:08'!
taskbarButtonMenu: aMenu
	"Answer the menu for the task bar button."

	| menu theme |
	theme :=  self theme.
	menu := theme newMenuIn: self for: self.
	menu
		addToggle: 'Restore' translated
		target: self
		selector: #restore
		getStateSelector: nil
		enablementSelector: #isNotRestored.
	menu lastItem
		icon: self theme windowMaximizeForm;
		font: theme menuFont.
	menu
		addToggle: 'Minimize' translated
		target: self
		selector: #minimize
		getStateSelector: nil
		enablementSelector: #isNotMinimized.
	menu lastItem
		icon: self theme windowMinimizeForm;
		font: theme menuFont.
	menu
		addToggle: 'Maximize' translated
		target: self
		selector: #maximize
		getStateSelector: nil
		enablementSelector: #canBeMaximized.
	menu lastItem
		icon: self theme windowMaximizeForm;
		font: theme menuFont.
	menu addLine.
	menu
		addToggle: 'Close' translated
		target: self
		selector: #closeBoxHit
		getStateSelector: nil
		enablementSelector: #allowedToClose.
	menu lastItem
		icon: self theme windowCloseForm;
		font: theme menuFont.
	^menu! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:42'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	self model ifNotNil: [self model taskbarIcon ifNotNil: [:ico | ^ico]].
	^super taskbarIcon! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:42'!
taskbarLabel
	"Answer the label to use for a taskbar button for the receiver."

	self model ifNotNil: [self model taskbarLabel ifNotNil: [:str | ^str]].
	^self labelString! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 4/18/2007 13:08'!
taskbarState
	"Answer one of #minimized, #restored, #maximized or #active."

	^self isMinimized
		ifTrue: [#minimized]
		ifFalse: [self isMaximized
			ifTrue: [#maximized]
			ifFalse: [self isActive
						ifTrue: [#active]
						ifFalse: [#restored]]]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/31/2009 15:54'!
taskbarTask
	"Answer a new taskbar task for the receiver.
	Answer nil if not required."

	(self valueOfProperty: #noTaskbarTask ifAbsent: [false]) ifTrue: [^nil].
	^TaskbarTask
		morph: self
		state: self taskbarState
		icon: self taskbarIcon
		label: self taskbarLabel! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/11/2007 15:06'!
taskbarThumbnailExtent
	"Answer the size of a taskbar thumbnail for the receiver."

	^self isMinimized
		ifTrue: [self fullFrame extent min: self defaultTaskbarThumbnailExtent]
		ifFalse: [super taskbarThumbnailExtent]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'MarcusDenker 12/11/2009 07:42'!
theme
	"Answer the ui theme that provides controls.
	Don't call super since that implementation may delegate here."

	(self valueOfProperty: #theme) ifNotNil: [:t | ^ t].
	^self class theme! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/9/2009 17:09'!
themeChanged
	"Update the window colour and control boxes."

	self labelArea delete.
	self removeGrips.
	self theme
		configureWindowBorderFor: self;
		configureWindowDropShadowFor: self.
	self paneColor: self defaultBackgroundColor.
	label ifNotNil: [ "don't if label area removed"
		self initializeLabelArea].
	self setStripeColorsFrom: self paneColor.
	(self isCollapsed not or: [self isTaskbarPresent]) ifTrue: [
		self addGripsIfWanted].
	super themeChanged! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 2/6/2009 12:26'!
toggleVisibleAndRaise
	"Toggle the visibility of the receiver, bringing to
	the front if becoming visible. Activate or passivate here."

	self isActive ifTrue: [self world navigateVisibleWindowForward].
	super toggleVisibleAndRaise.
	self visible ifTrue: [self activate]! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 5/7/2008 11:43'!
wantsGrips
	"Answer whether the window wants edge and corner grips."
	
	^(self valueOfProperty: #noGrips ifAbsent: [false]) not! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 6/2/2009 10:35'!
wantsRoundedCorners
	"Answer whether rounded corners are wanted."
	
	^(self theme windowPreferredCornerStyleFor: self) == #rounded! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 1/10/2007 10:08'!
window
	"Answer the receiver's window."

	^self! !

!SystemWindow methodsFor: '*Polymorph-Widgets' stamp: 'gvc 10/9/2007 11:47'!
worldTaskbar
	"Answer the world taskbar or nil if none."

	^self world submorphThat: [:m | m isTaskbar] ifNone: [] ! !

UIManager subclass: #MorphicUIManager
	uses: TEasilyThemed
	instanceVariableNames: 'interactiveParser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets-Themes'!

!MorphicUIManager commentStamp: 'StephaneDucasse 6/5/2011 22:19' prior: 0!
The Morphic ui manager. 

I was packaged in toolbuilder and I may change in the future. For the moment, the goal is to unload toolbuilder. !

MorphicUIManager class
	uses: TEasilyThemed classTrait
	instanceVariableNames: ''!

!MorphicUIManager class methodsFor: 'accessing' stamp: 'alain.plantec 5/30/2008 13:55'!
isActiveManager
	"Answer whether I should act as the active ui manager"
	^ true! !

!MorphicUIManager methodsFor: 'debugger' stamp: 'BenjaminVanRyseghem 9/6/2011 11:05'!
buildContextInspectorFor: aDebugger

	^ PluggableTextMorph 
		on: aDebugger contextVariablesInspector
		text: #contents
		accept: #accept:
		readSelection: #contentsSelection
		menu: #codePaneMenu:shifted:! !

!MorphicUIManager methodsFor: 'debugger' stamp: 'BenjaminVanRyseghem 9/6/2011 11:03'!
buildFieldInspectorFor: aDebugger

	^ PluggableTextMorph 
		on: aDebugger receiverInspector
		text: #contents
		accept: #accept:
		readSelection: #contentsSelection
		menu: #codePaneMenu:shifted:! !

!MorphicUIManager methodsFor: 'debugger' stamp: 'BenjaminVanRyseghem 9/6/2011 11:04'!
buildListOfContextFor: aDebugger

	^ PluggableListMorph new
		doubleClickSelector: #inspectSelection;
		on: aDebugger contextVariablesInspector
		list: #fieldList
		selected: #selectionIndex
		changeSelected: #toggleIndex:
		menu: #fieldListMenu:
		keystroke: #inspectorKey:from:! !

!MorphicUIManager methodsFor: 'debugger' stamp: 'BenjaminVanRyseghem 9/8/2011 18:09'!
buildListOfElementsFor: aDebugger

	^ PluggableListMorph 
		on: aDebugger 
		list: #contextStackList
		selected: #contextStackIndex
		changeSelected: #toggleContextStackIndex:
		menu: #contextStackMenu:shifted:
		keystroke: #contextStackKey:from:.! !

!MorphicUIManager methodsFor: 'debugger' stamp: 'BenjaminVanRyseghem 9/6/2011 11:04'!
buildListOfFieldsFor: aDebugger

	^ (PluggableListMorph new
		doubleClickSelector: #inspectSelection;
		on: aDebugger receiverInspector list: #fieldList
		selected: #selectionIndex changeSelected: #toggleIndex:
		menu: #fieldListMenu: keystroke: #inspectorKey:from:)
		autoDeselect: false;
		yourself! !

!MorphicUIManager methodsFor: 'private' stamp: 'AlainPlantec 9/23/2011 10:11'!
buildMorphicNotifierFor: aDebugger labelled: label message: messageString
	| notifyPane window extentToUse row|
	aDebugger expandStack.
	window := (PreDebugWindow labelled: label) model: aDebugger.
	extentToUse := 450 @ 156. "nice and wide to show plenty of the error msg"
	window
		addMorph: (row := aDebugger buttonRowForPreDebugWindow: window)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@row minExtent y)).
	row color: Color transparent.
	messageString notNil
		ifFalse:
			[notifyPane := PluggableListMorph on: aDebugger list: #contextStackList
				selected: #contextStackIndex changeSelected: #debugAt:
				menu: nil keystroke: nil]
		ifTrue:
			[notifyPane := PluggableTextMorph on: aDebugger text: nil accept: nil
				readSelection: nil menu: #debugProceedMenu:.
			notifyPane styled: false.
			notifyPane editString: (aDebugger preDebugNotifierContentsFrom: messageString);
				askBeforeDiscardingEdits: false].
	window
		addMorph: notifyPane
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@24 corner: 0@0)).
	window setBalloonTextForCloseBox.
	window openInWorldExtent: extentToUse.
	window currentWorld displayWorld. "helps with interrupt not working somehow."
	^window! !

!MorphicUIManager methodsFor: 'debugger' stamp: 'BenjaminVanRyseghem 9/8/2011 18:09'!
buildNotifyListPane: aDebugger

	^ PluggableListMorph
		on: aDebugger
		list: #contextStackList
		selected: #contextStackIndex
		changeSelected: #debugAt:
		menu: nil
		keystroke: nil! !

!MorphicUIManager methodsFor: 'debugger' stamp: 'BenjaminVanRyseghem 9/6/2011 13:50'!
buildNotifyTextPane: aDebugger

	^ PluggableTextMorph
		on: aDebugger
		text: nil
		accept: nil
		readSelection: nil
		menu: #debugProceedMenu:! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 15:15'!
checkForNewDisplaySize

	"Check whether the screen size has changed and if so take appropriate actions"

	Display extent = DisplayScreen actualScreenSize ifTrue: [^ Display].
	DisplayScreen startUp.
	World restoreMorphicDisplay.
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:55'!
chooseDirectory: label from: dir
	"Answer the user choice of a directory."
	
	^ self theme  
		chooseDirectoryIn: self modalMorph
		title: (label ifNil: ['Choose Directory' translated])
		path: (dir ifNotNil: [dir pathName])! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:57'!
chooseFileMatching: patterns label: label
	"Let the user choose a file matching the given patterns"
	
	^ self theme
		chooseFileNameIn: self modalMorph
		title: (label ifNil: ['Choose File' translated])
		patterns: patterns
		path: nil
		preview: false! !

!MorphicUIManager methodsFor: 'services' stamp: 'StephaneDucasse 7/17/2010 13:10'!
chooseFrom: aList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^(self
		chooseFrom: aList
		values: nil
		lines: linesArray
		message: messageString
		title: aString) ifNil: [0]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 7/17/2010 13:11'!
chooseFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^(self
		chooseFrom: aList
		values: nil
		lines: linesArray
		title: aString) ifNil: [0]! !

!MorphicUIManager methodsFor: 'services' stamp: 'FernandoOlivero 4/12/2011 09:56'!
chooseFrom: labelList values: valueList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^ self theme
		chooseIn: self modalMorph
		title: aString
		message: messageString
		labels: labelList
		values: valueList
		lines: linesArray! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:55'!
chooseFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^ self theme  
		chooseIn: self modalMorph
		title: aString
		labels: labelList
		values: valueList
		lines: linesArray! !

!MorphicUIManager methodsFor: 'services' stamp: 'CarloTeixeira 5/23/2011 15:59'!
chooseFullFileName: title extensions: exts path: path preview: preview
	"Answer the result of a file name chooser dialog with the given title, extensions
	to show, path and preview type."

	^self theme
		chooseFullFileNameIn: self
		title: title
		extensions: exts
		path: path
		preview: preview! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'CarloTeixeira 5/23/2011 16:01'!
chooseFullFileNameMatching: patterns label: label
	"Let the user choose a file matching the given patterns"
	
	^ self theme
		chooseFullFileNameIn: self modalMorph
		title: (label ifNil: ['Choose File' translated])
		patterns: patterns
		path: nil
		preview: false! !

!MorphicUIManager methodsFor: 'services' stamp: 'StephaneDucasse 7/17/2010 13:12'!
chooseOrRequestFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	
	^self
		chooseOrRequestFrom: aList
		values: aList
		lines: linesArray
		title: aString! !

!MorphicUIManager methodsFor: 'services' stamp: 'FernandoOlivero 4/12/2011 09:56'!
chooseOrRequestFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	
	^ self theme 
		chooseOrRequestIn: self modalMorph
		title: aString
		labels: labelList
		values: valueList
		lines: linesArray! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'SeanDeNigris 7/26/2011 14:27'!
confirm: aStringOrText
	"Put up a question dialog (without cancel).
	Answer true if the response is yes, false if no.
	This is a modal question--the user must respond yes or no."
	
	^ self confirm: aStringOrText label: 'Question' translated.! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'SeanDeNigris 7/26/2011 14:28'!
confirm: questionStringOrText label: labelStringOrText
	"Put up a question dialog (without cancel).
	Answer true if the response is yes, false if no.
	This is a modal question--the user must respond yes or no."
	
	(ProvideAnswerNotification signal: questionStringOrText) ifNotNil: [:answer |
		^answer].
	^ self theme 
		questionWithoutCancelIn: self modalMorph
		text: questionStringOrText
		title: labelStringOrText.! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:56'!
confirm: aStringOrText orCancel: cancelBlock
	"Put up a question dialog (with cancel) with the text queryString.
	Answer true if the response is yes, false if no.
	Answer the value of the cancel block if cancelled.
	This is a modal question--the user must respond yes or no or cancel."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^answer == #cancel ifTrue: [cancelBlock value] ifFalse: [answer]].
	^( self theme 
		questionIn: self modalMorph
		text: aStringOrText
		title: 'Question' translated) ifNil: cancelBlock! !

!MorphicUIManager methodsFor: 'services' stamp: 'GaryChambers 8/23/2010 12:13'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice 
	"Put up a yes/no menu with caption queryString. The actual wording for the two choices will be as provided in the trueChoice and falseChoice parameters. Answer true if the response is the true-choice, false if it's the false-choice.
	This is a modal question -- the user must respond one way or the other."
	
	^self
		confirm: queryString
		trueChoice: trueChoice
		falseChoice: falseChoice
		cancelChoice: nil
		default: nil! !

!MorphicUIManager methodsFor: 'services' stamp: 'FernandoOlivero 4/12/2011 09:57'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice cancelChoice: cancelChoice default: defaultOption
	"Put up a yes/no/cancel menu with caption queryString. The actual wording for the choices will be as provided in the trueChoice, falseChoice and cancelChoice parameters.
	defaultOption should be one of true, false or nil to set the default button.
	Answer true if the response is the true-choice, false if it's the false-choice, nil if the cancelChoice.
	This is a modal question -- the user must respond."
	
	(ProvideAnswerNotification signal: queryString) ifNotNil: [:answer |
		^answer].
	^ self theme  
		customQuestionIn: self modalMorph
		text: queryString
		yesText: trueChoice
		noText: falseChoice
		cancelText: cancelChoice
		default: defaultOption
		title: 'Question' translated! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 11/1/2010 15:17'!
currentWorld
	ActiveWorld ifNotNil: [^ActiveWorld].
	^World! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 2/28/2005 17:13'!
displayProgress: titleString at: aPoint from: minVal to: maxVal during: workBlock
	"Display titleString as a caption over a progress bar while workBlock is evaluated."
	^ProgressInitiationException 
		display: titleString
		at: aPoint 
		from: minVal 
		to: maxVal 
		during: workBlock! !

!MorphicUIManager methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 9/7/2011 22:08'!
displayProgress: titleString from: minVal to: maxVal during: workBlock
	"Display titleString as a caption over a progress bar while workBlock is evaluated."
	^ProgressInitiationException 
		display: titleString
		at: Display center 
		from: minVal 
		to: maxVal 
		during: workBlock! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 4/15/2011 17:26'!
edit: aText label: labelString accept: anAction
	"Open an editor on the given string/text"

	^(Smalltalk tools workspace openLabel: labelString)
		acceptContents:  aText;
		acceptAction: anAction;
		yourself.
	! !

!MorphicUIManager methodsFor: 'services' stamp: 'StephaneDucasse 7/17/2010 13:13'!
enterOrRequestFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	
	^self
		enterOrRequestFrom: aList
		values: aList
		lines: linesArray
		title: aString! !

!MorphicUIManager methodsFor: 'services' stamp: 'FernandoOlivero 4/12/2011 09:56'!
enterOrRequestFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	
	^ self theme 
		enterOrRequestIn: self modalMorph
		title: aString
		labels: labelList
		values: valueList
		lines: linesArray! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 14:51'!
explorer: anObjectExplorer for: anObject withLabel: label 
	| window listMorph |
	anObjectExplorer rootObject: anObject.
	window := (SystemWindow labelled: label) model: anObjectExplorer.
	window addMorph: (listMorph := SimpleHierarchicalListMorph 
			on: anObjectExplorer
			list: #getList
			selected: #getCurrentSelection
			changeSelected: #noteNewSelection:
			menu: #genericMenu:
			keystroke: #explorerKey:from:)
		frame: (0@0 corner: 1@0.8).
	window addMorph: ((PluggableTextMorph on: anObjectExplorer text: #trash accept: #trash:
				readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
					askBeforeDiscardingEdits: false)
		frame: (0@0.8 corner: 1@1).
	listMorph autoDeselect: false.
     ^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 15:12'!
fileDoesNotExistsDefaultAction: anException

	^anException readOnly
		ifTrue: [StandardFileStream readOnlyFileDoesNotExistUserHandling: anException fileName]
		ifFalse: [StandardFileStream fileDoesNotExistUserHandling: anException fileName]
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 20:14'!
fileExistsDefaultAction: anException

	^ anException fileClass fileExistsUserHandling: anException fileName! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'Pavel.Krivanek 10/28/2008 10:46'!
fontFromUser: priorFont	
	
	^ StrikeFont fromUser: priorFont allowKeyboard: true! !

!MorphicUIManager methodsFor: 'bitBlt' stamp: 'Pavel.Krivanek 10/28/2008 11:02'!
grafPort	
	
	^ Display defaultBitBltClass asGrafPort! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:56'!
inform: aStringOrText
	"Display a message for the user to read and then dismiss."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^true].
	^ self theme 
		messageIn: self modalMorph
		text: aStringOrText
		title: 'Information' translated! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 9/7/2011 22:08'!
informUserDuring: aBlock
	"Display a message as progress	during execution of the given block."
	"UIManager default informUserDuring: [:bar|
		#('one' 'two' 'three') do: [:info|
			bar value: info.
			1 to: 100 do: [:v |
				bar value: v.
				(Delay forMilliseconds: 20) wait]]]"
	
	self
		displayProgress: ''
		from: 1 to: 100
		during: [:bar | aBlock value: bar]! !

!MorphicUIManager methodsFor: 'accessing' stamp: 'pavel.krivanek 11/21/2008 17:30'!
interactiveParser
	"Answer the value of interactiveParser"

	^ interactiveParser! !

!MorphicUIManager methodsFor: 'accessing' stamp: 'pavel.krivanek 11/21/2008 17:30'!
interactiveParser: anObject
	"Set the value of interactiveParser"

	interactiveParser := anObject! !

!MorphicUIManager methodsFor: 'settings' stamp: 'stephaneDucasse 5/8/2010 20:00'!
interactiveParserFor: requestor
	"during Morphic loading the interactive parser must be disabled"

	(interactiveParser = false) ifTrue: [ ^ false ].  "can be nil"
	^ requestor notNil! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 20:17'!
lowSpaceWatcherDefaultAction: preemptedProcess

	Project interruptName: 'Space is low' preemptedProcess: preemptedProcess! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 18:17'!
menuClass
	^MenuMorph! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/22/2010 09:10'!
messageNames: aMessageNames inMorphicWindowWithInitialSearchString: initialString
	"Answer a morphic window with the given initial search string, nil if none"

"MessageNames openMessageNames"

	| window selectorListView secondDivider horizDivider searchPane searchButton searchTextMorph searchColumn|
	window := (StandardWindow labelled: 'Message Names' translated) model: aMessageNames.
	secondDivider := 0.5.
	horizDivider := 0.5.

	searchTextMorph := window
		newTextEntryFor: aMessageNames
		getText: #searchString
		setText: #searchString:from:
		help: nil.
	searchTextMorph
		ghostText: 'type here, then click Search' translated;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		askBeforeDiscardingEdits: false.
	searchButton := window
		newButtonFor: aMessageNames
		action: #doSearchFrom:
		label: 'Search' translated
		help: 'Type some letters into the pane at right, and then press this Search button (or hit RETURN) and all method selectors that match what you typed will appear in the list pane below.  Click on any one of them, and all the implementors of that selector will be shown in the right-hand pane, and you can view and edit their code without leaving this tool.' translated.
	searchButton arguments: {searchTextMorph}.
	
	searchPane := window
		newRow: {searchButton. searchTextMorph}.
	initialString isEmptyOrNil ifFalse:
		[searchTextMorph setText: initialString].

	selectorListView := window
		newListFor: aMessageNames
		list: #selectorList
		selected:  #selectorListIndex
		changeSelected: #selectorListIndex:
		help: nil.
	selectorListView
		getMenuSelector: #selectorListMenu:;
		keystrokeActionSelector: #selectorListKey:from:;
		menuTitleSelector: #selectorListMenuTitle;
		useSquareCorners.
	searchColumn := window newColumn: {searchPane. selectorListView}.
	searchColumn cellInset: ProportionalSplitterMorph splitterWidth.
	window
		addMorph: searchColumn
		frame: (0 @ 0 corner: horizDivider @ secondDivider);
		addMorph: aMessageNames buildMorphicMessageList
		frame: (horizDivider @ 0 corner: 1@ secondDivider);
		rememberKeyboardFocus: searchTextMorph.

	aMessageNames 
		addLowerPanesTo: window 
		at: (0 @ secondDivider corner: 1@1) 
		with: nil.

	initialString isEmptyOrNil ifFalse:
		[aMessageNames searchString: initialString].
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/18/2010 09:51'!
messageSet: aMessageSet inMorphicWindowLabeled: labelString
	| window listFraction |
	window := (SystemWindow labelled: labelString) model: aMessageSet.
	listFraction := 0.4.
	window addMorph: aMessageSet buildMorphicMessageList frame: (0@0 extent: 1@listFraction).
	aMessageSet 
		addLowerPanesTo: window 
		at: (0@listFraction corner: 1@1) 
		with: nil.

	window setUpdatablePanesFrom: #(messageList).
	^ window! !

!MorphicUIManager methodsFor: 'accessing' stamp: 'StephaneDucasse 7/17/2010 13:15'!
modalMorph
	"Answer the morph that should be used to handle modality."
	| sender receiver foundWorld |
	sender := thisContext sender.
	foundWorld := false.
	[foundWorld or: [sender isNil]]
		whileFalse: [receiver := sender receiver.
			((sender selector = #invokeWorldMenu:)
					or: [receiver == World
							and: [sender selector == #handleEvent:
									or: [sender selector == #findWindow:]]])
				ifTrue: [foundWorld := true]
				ifFalse: [sender := sender sender]].
	foundWorld
		ifTrue: [^ receiver world
				ifNil: [World]].
	^ SystemWindow topWindow
		ifNil: [World]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 9/7/2011 21:26'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight
	"Create a multi-line instance of me whose question is queryString with
	the given initial answer. Invoke it centered at the given point, and
	answer the string the user accepts.  Answer nil if the user cancels.  An
	empty string returned means that the ussr cleared the editing area and
	then hit 'accept'.  Because multiple lines are invited, we ask that the user
	use the ENTER key, or (in morphic anyway) hit the 'accept' button, to 
	submit; that way, the return key can be typed to move to the next line."
	self deprecated: 'Use multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: ' on: '7 September 2011' in: 'Pharo1.4'.
	(ProvideAnswerNotification signal: queryString) ifNotNil: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	^( self theme 
		textEditorIn: self modalMorph
		text: queryString
		title: 'Information Required' translated
		entryText: defaultAnswer
		entryHeight: answerHeight)
			ifNotNil: [:text | text asString]! !

!MorphicUIManager methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 9/7/2011 21:22'!
multiLineRequest: queryString  initialAnswer: defaultAnswer answerHeight: answerHeight
	"Create a multi-line instance of me whose question is queryString with
	the given initial answer. Answer the string the user accepts.  Answer nil if the user cancels.  An
	empty string returned means that the ussr cleared the editing area and
	then hit 'accept'.  Because multiple lines are invited, we ask that the user
	use the ENTER key, or (in morphic anyway) hit the 'accept' button, to 
	submit; that way, the return key can be typed to move to the next line."
	
	(ProvideAnswerNotification signal: queryString) ifNotNil: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	^( self theme 
		textEditorIn: self modalMorph
		text: queryString
		title: 'Information Required' translated
		entryText: defaultAnswer
		entryHeight: answerHeight)
			ifNotNil: [:text | text asString]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 13:14'!
newDisplayDepthNoRestore: pixelSize

	"Change depths.  Check if there is enough space!!  , di"
	| area need |
	pixelSize = Display depth ifTrue: [^ Display  "no change"].
	pixelSize abs < Display depth ifFalse:
		["Make sure there is enough space"
		area := Display boundingBox area. "pixels"
		need := (area * (pixelSize abs - Display depth) // 8)  "new bytes needed"
				+ Smalltalk lowSpaceThreshold.
		(Smalltalk garbageCollectMost <= need
			and: [Smalltalk garbageCollect <= need])
			ifTrue: [self error: 'Insufficient free space']].
	Display setExtent: Display extent depth: pixelSize.

	DisplayScreen startUp! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 2/25/2011 17:53'!
newMenuIn: aThemedMorph for: aModel
	"Answer a new menu."
	"UIManager default"
	^self theme 
		newMenuIn: aThemedMorph for: aModel! !

!MorphicUIManager methodsFor: 'events' stamp: 'IgorStasenko 4/15/2011 17:26'!
onDebug: process context: context title: title full: bool	
	
	| topCtxt |	
	
	topCtxt := process isActiveProcess ifTrue: [thisContext] ifFalse: [process suspendedContext].
	(topCtxt hasContext: context) ifFalse: [^ self error: 'context not in process'].	
	Smalltalk tools debug: process context: context label: title contents: nil fullView: bool.! !

!MorphicUIManager methodsFor: 'events' stamp: 'Pavel.Krivanek 10/28/2008 11:22'!
onEventSensorStartup: anEventSensor

	anEventSensor flushAllButDandDEvents! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'MarcusDenker 4/29/2011 00:36'!
onFontsChanged

	StringMorph allSubInstancesDo: [ :s | s layoutChanged ].
	TextMorph allSubInstancesDo: [ :s | s layoutChanged ].
	SystemWindow allInstancesDo: [ :w | [ w update: #relabel ] on: Error do: [ :ex | ] ].
	World ifNotNil: [ :w | w changed ].! !

!MorphicUIManager methodsFor: 'events' stamp: 'AlainPlantec 9/12/2011 00:50'!
onPrimitiveError: aString 
	| message |
	message := String
				streamContents: [:s | 
					| context |
					s nextPutAll: '*** System error handling failed ***'.
					s cr; nextPutAll: aString.
					context := thisContext sender sender.
					20
						timesRepeat: [context == nil
								ifFalse: [s cr; print: (context := context sender)]]].
	Transcripter askForEmergencyEvaluatorOrExitWithText: message.
	"init hands and redisplay" 
	World install
! !

!MorphicUIManager methodsFor: 'events' stamp: 'IgorStasenko 1/24/2011 16:37'!
onSnapshot: resuming
	"The resuming argument is true when image boots from disk,
	and false, if user just did an image snapshot."
	
	"if we resuming, check if we're still interactive "
	
	(resuming and: [ Smalltalk isInteractive not ]) ifTrue: [
			^ self nonInteractiveManager onSnapshot: resuming ].

	SystemWindow wakeUpTopWindowUponStartup! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 12:50'!
openBrowser: aBrowser asMorphClassEditing: editString
	"Create a pluggable version a Browser on just a single class."
	| window dragNDropFlag hSepFrac switchHeight mySingletonClassList |

	window := (SystemWindow labelled: 'later') model: aBrowser.
	dragNDropFlag := true.
	hSepFrac := 0.3.
	switchHeight := 25.
	mySingletonClassList := PluggableListMorph on: aBrowser list: #classListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #classListMenu:shifted: keystroke: #classListKey:from:.
	mySingletonClassList enableDragNDrop: dragNDropFlag.

	aBrowser 
		addLowerPanesTo: window 
		at: (0@hSepFrac corner: 1@1) 
		with: editString.
	window 
		addMorph: mySingletonClassList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 0.5@0) 
				offsets: (0@0 corner: 0@switchHeight)
		).
	
	aBrowser 
		addMorphicSwitchesTo: window 
		at: (
			LayoutFrame 
				fractions: (0.5@0 corner: 1.0@0) 
				offsets: (0@0 corner: 0@switchHeight)
		).

	window 
		addMorph: aBrowser buildMorphicMessageCatList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 0.5@hSepFrac) 
				offsets: (0@switchHeight corner: 0@0)
		).

	window 
		addMorph: aBrowser buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0.5@0 corner: 1.0@hSepFrac) 
				offsets: (0@switchHeight corner: 0@0)
		).

	window setUpdatablePanesFrom: #(messageCategoryList messageList).
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'CamilloBruni 8/3/2011 16:30'!
openBrowser: aBrowser asMorphEditing: editString
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	| window hSepFrac |

	hSepFrac := 0.4.
	window := (SystemWindow labelled: 'later') model: aBrowser.

"The method SystemWindow>>addMorph:fullFrame: checks scrollBarsOnRight, then adds the morph at the back if true, otherwise it is added in front. But flopout hScrollbars need the lowerpanes to be behind the upper ones in the draw order. Hence the value of scrollBarsOnRight affects the order in which the lowerpanes are added. "
	window theme settings scrollBarsOnRight ifFalse:
		[aBrowser 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString].
		
	window 
		addMorph: aBrowser buildMorphicSystemCatList
		frame: (0@0 corner: 0.25@hSepFrac).
		
	aBrowser 
		addClassAndSwitchesTo: window 
		at: (0.25@0 corner: 0.5@hSepFrac)
		plus: 0.
		
	window 
		addMorph: aBrowser buildMorphicMessageCatList
		frame: (0.5@0 extent: 0.25@hSepFrac).
		
	window addMorph: aBrowser buildMorphicMessageList
		frame: (0.75@0 extent: 0.25@hSepFrac).

	window theme settings scrollBarsOnRight ifTrue:
		[aBrowser 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString].

	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 12:41'!
openBrowser: aBrowser asMorphMessageEditing: editString
	"Create a pluggable version a Browser that shows just one message"
	| window mySingletonMessageList verticalOffset nominalFractions |
	window := (SystemWindow labelled: 'later') model: aBrowser.

	mySingletonMessageList := PluggableListMorph on: aBrowser list: #messageListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:.
	mySingletonMessageList enableDragNDrop: true.
	verticalOffset := 25.
	nominalFractions := 0@0 corner: 1@0.
	window 
		addMorph: mySingletonMessageList
		fullFrame: (
			LayoutFrame 
				fractions: nominalFractions 
				offsets: (0@0 corner: 0@verticalOffset)
		).

	verticalOffset := aBrowser addOptionalAnnotationsTo: window at: nominalFractions plus: verticalOffset.
	verticalOffset := aBrowser addOptionalButtonsTo: window  at: nominalFractions plus: verticalOffset.

	window 
		addMorph: (aBrowser buildMorphicCodePaneWith: editString)
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@1) 
				offsets: (0@verticalOffset corner: 0@0)
		).

	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 12:45'!
openBrowser: aBrowser asMorphMsgCatEditing: editString
	"Create a pluggable version a Browser on just a message category."

	| window hSepFrac |
	window := (SystemWindow labelled: 'later') model: aBrowser.
	hSepFrac := 0.3.
	window 
		addMorph: ((PluggableListMorph on: aBrowser list: #messageCatListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #messageCategoryMenu:) enableDragNDrop: true)
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@0) 
				offsets: (0@0 corner: 0@25)
		).
	window 
		addMorph: aBrowser buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@hSepFrac) 
				offsets: (0@25 corner: 0@0)
		).

	aBrowser 
		addLowerPanesTo: window 
		at: (0@hSepFrac corner: 1@1) 
		with: editString.
	window setUpdatablePanesFrom: #(messageCatListSingleton messageList).
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 11:51'!
openBrowser: aBrowser asMorphSysCatEditing: editString
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	| window hSepFrac switchHeight mySingletonList nextOffsets |

	window := (SystemWindow labelled: 'later') model: aBrowser.
	hSepFrac := 0.30.
	switchHeight := 25.
	mySingletonList := PluggableListMorph on: aBrowser list: #systemCategorySingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #systemCatSingletonMenu: keystroke: #systemCatSingletonKey:from:.
 	mySingletonList enableDragNDrop: true.
	mySingletonList hideScrollBarsIndefinitely.
	window 
		addMorph: mySingletonList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@0) 
				offsets: (0@0  corner: 0@switchHeight)
		).	

	aBrowser 
		addClassAndSwitchesTo: window 
		at: (0@0 corner: 0.3333@hSepFrac)
		plus: switchHeight.

	nextOffsets := 0@switchHeight corner: 0@0.
	window 
		addMorph: aBrowser buildMorphicMessageCatList
		fullFrame: (
			LayoutFrame 
				fractions: (0.3333@0 corner: 0.6666@hSepFrac) 
				offsets: nextOffsets
		).	

	window 
		addMorph: aBrowser buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0.6666@0 corner: 1@hSepFrac) 
				offsets: nextOffsets
		).	

	aBrowser 
		addLowerPanesTo: window 
		at: (0@hSepFrac corner: 1@1) 
		with: editString.

	window setUpdatablePanesFrom: #( classList messageCategoryList messageList).
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'CamilloBruni 9/16/2011 16:40'!
openChangeList: aChangeList asMorphName: labelString multiSelect: multiSelect
	"Open a morphic view for the messageSet, whose label is labelString. 
	The listView may be either single or multiple selection type"
	| window listHeight listPane |
	listHeight := 0.4.
	window := (SystemWindow labelled: labelString)
				model: aChangeList.
	listPane := multiSelect
				ifTrue: [PluggableListMorph
						on: aChangeList
						list: #list
						primarySelection: #listIndex
						changePrimarySelection: #toggleListIndex:
						listSelection: #listSelectionAt:
						changeListSelection: #listSelectionAt:put:
						menu: (aChangeList showsVersions
								ifTrue: [#versionsMenu:]
								ifFalse: [#changeListMenu:])]
				ifFalse: [PluggableListMorph
						on: aChangeList
						list: #list
						selected: #listIndex
						changeSelected: #toggleListIndex:
						menu: (aChangeList showsVersions
								ifTrue: [#versionsMenu:]
								ifFalse: [#changeListMenu:])].
	listPane keystrokeActionSelector: #changeListKey:from:.
	window
		addMorph: listPane
		frame: (0 @ 0 extent: 1 @ listHeight).
	aChangeList
		addLowerPanesTo: window
		at: (0 @ listHeight corner: 1 @ 1)
		with: nil.
	^ window openInWorld! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 17:07'!
openChangeSorterAsMorph: aChangeSorter
	^aChangeSorter morphicWindow openInWorld! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 4/15/2011 17:28'!
openComparisionFrom: targetMethodSource
					to: originalMethodSource
					belongingTo: aClass
					from: aChange 
					labeled: aLabel 
					inWindowLabeled: aWindowLabel 
	| diffMorph diffBuilder difference win |
	PolymorphSystemSettings usePolymorphDiffMorph 
		ifTrue:[ ^ self openPolymorphComparisonFrom: originalMethodSource 
					to: targetMethodSource
					belongingTo: aClass
					from: aChange
					labeled: aLabel
					inWindowLabeled: aWindowLabel   ].
	diffBuilder :=  TextDiffBuilder
			from: originalMethodSource 
			to: targetMethodSource.
	difference := diffBuilder buildDisplayPatch.
	win := Smalltalk tools workspace openContents: difference.
	win label: aLabel.
					
				! !

!MorphicUIManager methodsFor: 'services' stamp: 'BenjaminVanRyseghem 9/6/2011 11:06'!
openDebugger: aDebugger fullMorphicLabel: aLabelString
	"Open a full morphic debugger with the given label"

	| window aListMorph oldContextStackIndex |
	oldContextStackIndex := aDebugger contextStackIndex.
	aDebugger expandStack. "Sets contextStackIndex to zero."

	window := (SystemWindow labelled: aLabelString) model: aDebugger.
	aListMorph := self buildListOfElementsFor: aDebugger.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	window 
		addMorph: aListMorph
		frame: (0@0 corner: 1@0.25).

	aDebugger addLowerPanesTo: window at: (0@0.25 corner: 1@0.8) with: nil.

	window 
		addMorph: (self buildListOfFieldsFor: aDebugger)
			"For doubleClick to work best disable autoDeselect"	
		frame: (0@0.8 corner: 0.2@1).
		
	window
		addMorph: (self buildFieldInspectorFor: aDebugger)
		frame: (0.2@0.8 corner: 0.5@1).
		
	window
		addMorph: (self buildListOfContextFor: aDebugger)
		frame: (0.5@0.8 corner: 0.7@1).
		
	window
		addMorph: (self buildContextInspectorFor: aDebugger)
		frame: (0.7@0.8 corner: 1@1).
		
	window openInWorld.
	aDebugger toggleContextStackIndex: oldContextStackIndex.
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 4/15/2011 17:27'!
openDebuggerOn: process context: context label: title contents: contentsStringOrNil fullView: bool 
	"Open a notifier in response to an error, halt, or notify. A notifier view
	just shows a short view of the sender stack and provides a menu that
	lets the user open a full debugger."
	| errorWasInUIProcess |
	errorWasInUIProcess := self spawnNewProcessIfThisIsUI: process.
	WorldState
		addDeferredUIMessage: [[| debugger | 
			debugger := Smalltalk tools debugger new
						process: process
						controller: nil
						context: context.
			"schedule debugger in deferred UI message to address
			redraw problems after opening a debugger e.g. from
			the testrunner."
			"WorldState addDeferredUIMessage: ["
			bool
				ifTrue: [debugger openFullNoSuspendLabel: title]
				ifFalse: [debugger openNotifierContents: contentsStringOrNil label: title].
			debugger errorWasInUIProcess: errorWasInUIProcess.
			Smalltalk tools debugger logDebuggerStackToFile
				ifTrue: [Smalltalk
						logError: title
						inContext: context ]]
				on: Error
				do: [:ex | Debugger primitiveError: 'Orginal error: ' , title asString , '.
	Smalltalk tools debugger error: '
							, ([ex description]
									on: Error
									do: ['a ' , ex class printString]) , ':']].
	process suspend! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 17:08'!
openDualChangeSorterAsMorph: aDualChangeSorter
	^aDualChangeSorter morphicWindow openInWorld! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 14:18'!
openInspector: inspectorClass asMorphOn: anObject withLabel: aLabel 
	"(Inspector openAsMorphOn: SystemOrganization withLabel: 'Test') openInWorld"
	| window inspector |
	inspector := inspectorClass inspect: anObject.
	window := (SystemWindow labelled: aLabel)
				model: inspector.
	window
		addMorph: ((PluggableListMorph new doubleClickSelector: #inspectSelection;
				
				on: inspector
				list: #fieldList
				selected: #selectionIndex
				changeSelected: #toggleIndex:
				menu: #fieldListMenu:
				keystroke: #inspectorKey:from:) 
				autoDeselect: false )
				"For doubleClick to work best disable autoDeselect"
		frame: (0 @ 0 corner: inspectorClass horizontalDividerProportion @ inspectorClass verticalDividerProportion).
	window
		addMorph: (PluggableTextMorph
				on: inspector
				text: #contents
				accept: #accept:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:)
		frame: (inspectorClass horizontalDividerProportion @ 0 corner: 1 @ inspectorClass verticalDividerProportion).
	window
		addMorph: ((PluggableTextMorph
				on: inspector
				text: #trash
				accept: #trash:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:)
				askBeforeDiscardingEdits: false)
		frame: (0 @ inspectorClass verticalDividerProportion corner: 1 @ 1).
	window setUpdatablePanesFrom: #(#fieldList ).
	window position: 16 @ 0.
	"Room for scroll bar."
	^ window! !

!MorphicUIManager methodsFor: 'private' stamp: 'MarcusDenker 6/8/2011 15:06'!
openModal: aSystemWindow 
	"Open the given window at an available position with modality.
	Answer the system window."
	
	^World openModal: aSystemWindow! !

!MorphicUIManager methodsFor: 'private' stamp: 'FernandoOlivero 3/30/2011 16:26'!
openPolymorphComparisonFrom: targetMethodSource
					to: originalMethodSource
					belongingTo: aClass
					from: aChange 
					labeled: aLabel 
					inWindowLabeled: aWindowLabel 
	| diffMorph |
	diffMorph := DiffChangeMorph
		from: targetMethodSource
		label: aChange stamp
		to: originalMethodSource
		label: (aClass compiledMethodAt: aChange methodSelector) timeStamp
		contextClass: aClass.
	diffMorph openInWindowLabeled: aWindowLabel.! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 14:08'!
openProcessBrowserAsMorph: aProcessBrowser
	"Create a pluggable version of aProcessBrowser, answer a window"
	| window aTextMorph |
	window := (SystemWindow labelled: 'later')
				model: aProcessBrowser.

	aProcessBrowser deferredMessageRecipient: WorldState.
	window
		addMorph: ((PluggableListMorph
				on: aProcessBrowser
				list: #processNameList
				selected: #processListIndex
				changeSelected: #processListIndex:
				menu: #processListMenu:
				keystroke: #processListKey:from:)
				enableDragNDrop: false)
		frame: (0 @ 0 extent: 0.5 @ 0.5).
	window
		addMorph: ((PluggableListMorph
				on: aProcessBrowser
				list: #stackNameList
				selected: #stackListIndex
				changeSelected: #stackListIndex:
				menu: #stackListMenu:
				keystroke: #stackListKey:from:)
				enableDragNDrop: false)
		frame: (0.5 @ 0.0 extent: 0.5 @ 0.5).
	aTextMorph := PluggableTextMorph
				on: aProcessBrowser
				text: #selectedMethod
				accept: nil
				readSelection: nil
				menu: nil.
	aTextMorph askBeforeDiscardingEdits: false.
	window
		addMorph: aTextMorph
		frame: (0 @ 0.5 corner: 1 @ 1).
	window setUpdatablePanesFrom: #(#processNameList #stackNameList ).
	(window setLabel: 'Process Browser') openInWorld.
	aProcessBrowser mayBeStartCPUWatcher.
	^ window! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 7/7/2011 11:21'!
openTranscript
	
	Smalltalk tools transcript openAsMorphLabel: 'Transcript'
	
! !

!MorphicUIManager methodsFor: 'accessing' stamp: 'FernandoOlivero 5/9/2011 13:14'!
preferredCornerStyle
	^ self theme preferredCornerStyle! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 14:26'!
progressInitiationExceptionDefaultAction: anException

	anException defaultMorphicAction! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 9/7/2011 22:33'!
request: queryString initialAnswer: defaultAnswer
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts. Answer the empty string if the user cancels."


	 ^ self 
		request: queryString 
		initialAnswer: defaultAnswer 
		title: 'Provide the following information'
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 9/7/2011 21:51'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint 	"Create an instance of me whose question is queryString with the given initial answer. Answer the string the user accepts. Answer the empty string if the user cancels."


	 ^ self 
		request: queryString 
		initialAnswer: defaultAnswer 
		
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 11/26/2010 10:19'!
request: aStringOrText initialAnswer: defaultAnswer entryCompletion: anEntryCompletion
	^ self request: aStringOrText initialAnswer: defaultAnswer title: 'Information Required' translated entryCompletion: anEntryCompletion
! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:57'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle
	"Create an instance of me whose question is queryString with the given 
	initial answer. Answer the string the user accepts.
	The title serves for the window that is opened
	Answer the empty string if the user cancels.
	Allow for interception with a ProvideAnswerNotification handler."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	^( self theme 
		textEntryIn: self modalMorph
		text: aStringOrText
		title: aTitle
		entryText: defaultAnswer)! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:57'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle entryCompletion: anEntryCompletion
	"Create an instance of me whose question is queryString with the given 
	initial answer. Answer the string the user accepts.
	The title serves for the window that is opened
	Answer the empty string if the user cancels.
	Allow for interception with a ProvideAnswerNotification handler."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	^( self theme
		textEntryIn: self modalMorph
		text: aStringOrText
		title: aTitle
		entryText: defaultAnswer
		entryCompletion: anEntryCompletion)! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'FernandoOlivero 4/12/2011 09:57'!
requestPassword: aStringOrText 
	"Request for a password.
	Allow for interception with a ProvideAnswerNotification handler.
	Answer nil if the user cancels."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [:answer |
		^answer == #default ifTrue: [''] ifFalse: [answer]].
	^ self theme
		passwordEntryIn: self modalMorph
		text: aStringOrText
		title: 'Password Required' translated
		entryText: ''! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 13:22'!
restoreDisplay

	World fullRepaintNeeded! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 2/24/2007 13:18'!
restoreDisplayAfter: aBlock

	aBlock value.
	Sensor waitButton.
	World fullRepaintNeeded.! !

!MorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 11/1/2010 10:11'!
resumeUIProcess: aProcess
	"Adopt aProcess as the project process -- probably because of proceeding from a debugger"

	Project resumeProcess: aProcess! !

!MorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 11/1/2010 10:07'!
spawnNewProcessIfThisIsUI: suspendedProcess
	^Project spawnNewProcessIfThisIsUI: suspendedProcess.! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 4/15/2011 17:25'!
syntaxErrorNotificationDefaultAction: anException

	^Smalltalk tools debugSyntaxError: anException! !

!MorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 11/1/2010 10:13'!
uiProcess

	^Project uiProcess! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 4/15/2011 17:25'!
unhandledErrorDefaultAction: anException

	"The current computation is terminated. The cause of the error should be logged or reported to the user. If the program is operating in an interactive debugging environment the computation should be suspended and the debugger activated."
	^Smalltalk tools debugError: anException.! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 4/15/2011 17:25'!
warningDefaultAction: anException

"The user should be notified of the occurrence of an exceptional occurrence and given an option of continuing or aborting the computation. The description of the occurrence should include any text specified as the argument of the #signal: message."
	Smalltalk tools
		debugContext: thisContext
		label: 'Warning'
		contents: anException messageText, '\\Select Proceed to continue, or close this window to cancel the operation.' withCRs.
	anException resume.! !

!MorphicUIManager methodsFor: 'global state' stamp: 'FernandoOlivero 5/1/2011 11:40'!
world
	^ ActiveWorld ! !

MorphTreeNodeModel subclass: #CheckListNode
	instanceVariableNames: 'selected labelSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!CheckListNode methodsFor: 'column morphs' stamp: 'AlainPlantec 9/27/2011 12:28'!
checkButton
	^  self theme
			newCheckboxIn: World
			for: self
			getSelected: #selected
			setSelected: #selectedFromButton:
			getEnabled: nil
			label: '' 
			help: nil! !

!CheckListNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/28/2011 16:42'!
label

	^ self model wrapItem: self item! !

!CheckListNode methodsFor: 'column morphs' stamp: 'AlainPlantec 9/26/2011 21:57'!
rowLabel

	^ LabelMorph new contents: self label! !

!CheckListNode methodsFor: 'accessing' stamp: 'AlainPlantec 9/27/2011 11:12'!
selected

	^ selected ifNil: [selected := false]! !

!CheckListNode methodsFor: 'accessing' stamp: 'AlainPlantec 9/26/2011 23:22'!
selected: aBoolean
	selected = aBoolean
		ifFalse: [selected := aBoolean. 
			self changed: #selected]! !

!CheckListNode methodsFor: 'accessing' stamp: 'AlainPlantec 9/27/2011 23:34'!
selectedFromButton: aBoolean
	self selected = aBoolean
		ifFalse: [
			selected := aBoolean.
			self model selectedFromNode: self]! !

!CheckListNode methodsFor: 'accessing' stamp: 'AlainPlantec 9/26/2011 22:00'!
theme  
	^ UITheme current! !

MorphTreeNodeModel subclass: #TickSelectionListNode
	instanceVariableNames: 'selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-Widgets'!

!TickSelectionListNode commentStamp: '<historical>' prior: 0!
A TickSelectionListNode is node for the tree used to render the tick list

selected
	- xxxxx
!

!TickSelectionListNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/17/2011 05:41'!
name

	^ self item itemName asString! !

!TickSelectionListNode methodsFor: 'morph' stamp: 'BenjaminVanRyseghem 9/17/2011 02:15'!
nameMorph

	^ LabelMorph new contents: self name; enabled: false; hResizing: #spaceFill;yourself! !

!TickSelectionListNode methodsFor: 'event' stamp: 'BenjaminVanRyseghem 9/17/2011 05:05'!
pressed: anIndex

	self model pressed: anIndex! !

!TickSelectionListNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 15:58'!
selected

	^ self item selected! !

!TickSelectionListNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2011 15:58'!
selected: aBoolean

	self item selected: aBoolean! !

!TickSelectionListNode methodsFor: 'morph' stamp: 'BenjaminVanRyseghem 9/17/2011 05:16'!
selectedMorph
	^ (TickSelectionCheckboxMorph basicNew index: (self model rootItems indexOf: self item);
		initialize;	
		model: self item;
		getStateSelector: #selected;
		setStateSelector: #selected:;
		updateSelection;
		getEnabledSelector: nil;
		font: StandardFonts defaultFont;
		label: '';
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		setBalloonText: nil) color: Color transparent; yourself! !
UITheme initialize!
TaskbarMorph initialize!
ThemeIcons initialize!
VistaryThemeIcons initialize!
